/*---------------------------------------------------------------------
 *                                                                     
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                       
 *      COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *      THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                       
 *                         INTEL  CORPORATION                            
 *                                                                      
 *                      2200 MISSION COLLEGE BLVD                        
 *                                                                       
 *                SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                       
 *---------------------------------------------------------------------
 *
 *        File Name: dl_system_ingress_b.h
 *
 *        Purpose: This file contains system wide parameters
 *                 that are customized for a given application.
 *        History:
 *
 *        Date            Comment                         By
 *        ---------------------------------------------------------------
 *
 *        11/11/2002      Created                         asv
 *
 *-------------------------------------------------------------------*/
#ifndef	__DL_SYSTEM_INGRESS_B__H__
#define	__DL_SYSTEM_INGRESS_B__H__

/* Define chip. */
#ifndef IXP2800
#define IXP2800
#endif

/* Define project as microcode based. */
#ifndef IXP_MICROCODE
#define IXP_MICROCODE
#endif

/* Split LW0 and LW1-7 of meta-data */
/* Channel 0 contains LW0 of meta-data. */
/* Channel 3 contains LW1-7 of meta-data. */
#define	DL_SPLIT_META_DATA

#ifdef	DL_SPLIT_META_DATA

#define	BUF_SRAM_SPLIT_LW		1
#define	BUF_SRAM_SPLIT_CHANNEL	3

#endif // DL_SPLIT_META_DATA

/* Include default settings. */

/*
 * Default size for PKT HDR to be cached in long words:
 */
#ifndef	PKT_HDR_CACHE_SIZE
#define	PKT_HDR_CACHE_SIZE		6
#endif

/* This file is also used by script files that setup the system when run 
 * in simulation mode. When symbol IXP_SCRIPTS is defined, it indicates
 * that scripts are using this file. Since script files cannot access
 * path definitions, they should not encounter '#include <file>'. Instead
 * they include the <file> using Simulation -> Options -> Startup.
 */
#ifndef	IXP_SCRIPTS
#include <dl_ingress_system_default_2800.h>
#endif

#define_eval DL_SOURCE_NEXT1   BID_QM

#endif	/* __DL_SYSTEM_INGRESS_B__H__ */