/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/

/* FILE  dl_system_config.h
 *
 */

#ifndef	DL_SYSTEM_CONFIG_H
#define	DL_SYSTEM_CONFIG_H

/* These are design specific values - do NOT change it! */
#define MAX_ATM_PORTS_BITS              11
#define MAX_ATM_PORTS					4

#define IXP_CLOCK                       600000000
/* Number of VC supported in the system (VC 0 is reserved) */
#define NUMBER_OF_VC						8192


#define PORTINFO_IN_SRAM 	        1

#define EXCEPTION_RING_OUT_0            0
#define EXCEPTION_RING_OUT_1            1
#define EXCEPTION_RING_IN_0             2
#define EXCEPTION_RING_IN_1             3

#define	CSIX_TO_L2_ENCAP_SCR_RING		4
#define	DIFFSERV_TO_QM_SCR_RING			5
#define	SCHEDULER_TO_QM_SCR_RING		6
#define	QM_TO_AAL5_TX_SCR_RING_0		7
#define	QM_TO_AAL5_TX_SCR_RING_1		8
#define	QM_TO_AAL5_TX_SCR_RING_2		9
#define	QM_TO_AAL5_TX_SCR_RING_3		10

/*
 * following #define determines the mode of PHY operation
 */
#define TX_PHY_MODE 					SPHY_4_8

#define AAL5_TX_PARTITIONS_NUMBER   4

/* Total number of TQs in system for each traffic class */
#define	TQ_TOT							4096

#define	QD_LOG_SRAM_SIZE		5              
#define WRED_DRAM_TABLE
#define WRED_CORE_PROBABILITY_CALCULATION

/*
 *	Size of Meta Data (Buffer Descriptors) in SRAM. 32 entries per buffer.
 * 	Should be a power of 2.
 */
#define			META_DATA_SIZE		32

/*------------------------------------------------------------------------------
 * DRAM BUFEERS definitions
 */
#define			BUFFER_SIZE			2048

#endif /*  DL_SYSTEM_CONFIG_H  */

