/*******************************************************************************
  INTEL CONFIDENTIAL

  Copyright 2003 Intel Corporation All Rights Reserved.

  The source code contained or described herein and all documents related to
  the source code ("Material") are owned by Intel Corporation or its 
  suppliers or licensors.

  Title to the Material remains with Intel Corporation or its suppliers and
  licensors. The Material contains trade secrets and proprietary and
  confidential information of Intel or its suppliers and licensors.
  The Material is protected by worldwide copyright and trade secret laws and
  treaty provisions. No part of the Material may be used, copied, reproduced,
  modified, published, uploaded, posted, transmitted, distributed,
  or disclosed in any way without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure
  or delivery of the Materials, either expressly, by implication, inducement,
  estoppel or otherwise. Any license under such intellectual property rights
  must be express and approved by Intel in writing.

*******************************************************************************/

/**
 * ============================================================================
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2000 Network Processor
 *
 * = FILENAME
 *      media.c
 *
 * = DESCRIPTION
 *     This file has routines to initialize the 6048 media
 *     card to receive and transmit POS packets
 *
 * ============================================================================
 */

#define PUT32(address,val)  (*(volatile unsigned int *)(address) = (val))
#define GET32(address)	    (*(volatile unsigned int *)(address))

media_reset()
{
	/* Setting RESET_0 CAP CSR. */
	PUT32(0xc0004a0c,0x208080);
	PUT32(0xc0004a0c,0x208000);
	

	/* This is a Vxworks delay routine 
        and is OS dependent */
	taskDelay(1) ;
}


Ingress_Set_PLL()
{
	int tries, i;

	/*
	 * set the MCCR to 104/125MHz. The register is at 0xc0004a08
	 * -----------------------------------------------------
	 */
	/* put PLL in PLL disable mode */
	PUT32(0xc0004a08, 0x000000f0);
	/* PLL in bypass mode */
	PUT32(0xc0004a08, 0x0000f0f0);
	/* setup MSF clock to 125MHz (both Tx and Rx) */
	PUT32(0xc0004a08,0x00faf0f0);
	/* disable PLL bypass */
	PUT32(0xc0004a08,0x00fa00f0);
	/* turn on MSF */
	PUT32(0xc0004a08,0x00fa0000);
	printf("media_reset : Waiting for MSF PLL lock ...");
	while (GET32(0xc0004a08) != 0xf0fa0000)
	{
		printf("# ");
		for(i=0;i<20000;i++);
	}
	printf(" Done.\n");

}

