/*---------------------------------------------------------------------
 *
 *                  I N T E L   P R O P R I E T A R Y
 *
 *      COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS
 *      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY
 *      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A
 *      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER
 *      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,
 *      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT
 *      THE PRIOR WRITTEN PERMISSION OF :
 *
 *                         INTEL  CORPORATION
 *
 *                      2200 MISSION COLLEGE BLVD
 *
 *                SANTA  CLARA,  CALIFORNIA  95052-8119
 *
 *---------------------------------------------------------------------
 *
 *        File Name: dl_system.h
 *
 *        Purpose: This file contains system wide parameters
 *                 that are customized for a given application.
 *
 *-------------------------------------------------------------------*/
#ifndef	__DL_SYSTEM__H__
#define	__DL_SYSTEM__H__

/*	Chip is IXP2400 */
#ifndef IXP2400
#define IXP2400
#endif	

/* Define project as microcode based. */
#ifndef IXP_MICROCODE
#define IXP_MICROCODE
#endif

/* Transmit Phy mode */
#define TX_PHY_MODE 						SPHY_4_8

/* Scratch ring definitions */

/* Scratch ring for communicating between CSIX RX and L2 Encap 
   microblocks */
#define	ETHERNET_ARP_SOURCE_SCR_RING		4
#define	ETHERNET_ARP_SOURCE_SCR_RING_BASE	0
#define	ETHERNET_ARP_SOURCE_SCR_RING_SIZE	512

/* Scratch ring for communicating between L2 Encap and Queue Manager 
   microblocks */
#define	ETHERNET_ARP_SINK_SCR_RING			10
#define	ETHERNET_ARP_SINK_SCR_RING_BASE		8192
#define	ETHERNET_ARP_SINK_SCR_RING_SIZE		512

#define CSIX_RX_TO_QM_SCR /* To avoid redefinition in dl_egress_system_default.h */
#define	CSIX_RX_TO_QM_SCR_RING				ETHERNET_ARP_SOURCE_SCR_RING
#define	CSIX_RX_TO_QM_SCR_RING_BASE			ETHERNET_ARP_SOURCE_SCR_RING_BASE
#define	CSIX_RX_TO_QM_SCR_RING_SIZE			ETHERNET_ARP_SOURCE_SCR_RING_SIZE

#define	CSIX_RX_RING_OUT_IND /* To avoid redefinition in dl_egress_system_default.h */
#define CSIX_RX_RING_OUT					ETHERNET_ARP_SOURCE_SCR_RING
#define	CSIX_RX_RING_OUT_BASE				ETHERNET_ARP_SOURCE_SCR_RING_BASE
#define	CSIX_RX_RING_OUT_SIZE				ETHERNET_ARP_SOURCE_SCR_RING_SIZE

#define	QM_RING_IN_0_IND /* To avoid redefinition in dl_egress_system_default.h */	 
#define	QM_RING_IN_0						ETHERNET_ARP_SINK_SCR_RING
#define	QM_RING_IN_0_BASE					ETHERNET_ARP_SINK_SCR_RING_BASE
#define	QM_RING_IN_0_SIZE					ETHERNET_ARP_SINK_SCR_RING_SIZE

/* This file is also used by script files that setup the system when run 
 * in simulation mode. When symbol IXP_SCRIPTS is defined, it indicates
 * that scripts are using this file. Since script files cannot access
 * path definitions, they should not encounter '#include <file>'. Instead
 * they include the <file> using Simulation -> Options -> Startup.
 */
#ifndef IXP_SCRIPTS
#include <dl_egress_system_default.h>
#endif

#endif /* __DL_SYSTEM__H__ */