

#define	TRIE_WRITE(a,b)		set_sram((a),(b))

#define	NH_WRITE(a,b)	set_sram((a),(b))



int l3_create_routes(void) {

void* trie_base = SRAM_LOOKUP_BASE;
void* nh_base = SRAM_NEXTHOP_BASE;

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x0,0x0);

/* blade 0x0 and NH 0xffff, NH id type = 0x0 */

NH_WRITE(nh_base + 0x4,0xffff);

/* MTU is 0, outport is 0x23e8 */ 

NH_WRITE(nh_base + 0x8,0x23e8);


NH_WRITE(nh_base + 0xc,0x0);

/* #=======================================================================
 */ /* # Assumption :-							 
 */ /* #=======================================================================
 */ /* #
 */ /* #	This AI's Ingress Blade_id = 0x3f
 */ /* #	Angel Island(AI) has four ports (port = 0x0, 0x1, 0x2, 0x3)
 */ /* #
 */ /* #=======================================================================
 */ /* # Flags specify the quick-action to be carried on the packet.		
 */ /* # Flags have higher priority to anything in IPv4.				
 */ /* #=======================================================================
 */ /* #
 */ /* #  The bit positions are relative to the starting bit position = 0.
 */ /* #
 */ /* #    Bit pos  	Flag val  Desc		Action
 */ /* #   --------------------------------------------------------------------
 */ /* #	0	0x1	Local		Exception
 */ /* #	1	0x2	I/f Down	Exception
 */ /* #	2	0x4	Drop		Drop
 */ /* #	3	0x8	Broadcast	Exception
 */ /* #	4	0x10	Multicast	Exception
 */ /* #		0x0	Forward		Forward
 */ /* #
 */ /* #=======================================================================
 */ /* #       TEST  CASES 							 
 */ /* #=======================================================================
 */ /* #-----------------------------------------------
 */ /* # 32-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x20000001, mask = 0xffffffff, blade_nh_id=0x1000001,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40504,0x10000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x10,0x0);

/* blade 0x1 and NH 0x1, NH id type = 0x0 */

NH_WRITE(nh_base + 0x14,0x1000001);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x18,0x23fc0001);


NH_WRITE(nh_base + 0x1c,0x0);


	TRIE_WRITE(trie_base + 0x404c0,0x4);


	TRIE_WRITE(trie_base + 0x40480,0x3);


	TRIE_WRITE(trie_base + 0x40440,0x2);


	TRIE_WRITE(trie_base + 0x8000,0x1);


/* @@@ Adding dest=0x20000002, mask = 0xffffffff, blade_nh_id=0x1000002,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40508,0x20000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x20,0x0);

/* blade 0x1 and NH 0x2, NH id type = 0x0 */

NH_WRITE(nh_base + 0x24,0x1000002);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x28,0x23fc0002);


NH_WRITE(nh_base + 0x2c,0x0);


/* @@@ Adding dest=0x20000003, mask = 0xffffffff, blade_nh_id=0x1000003,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4050c,0x30000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x30,0x0);

/* blade 0x1 and NH 0x3, NH id type = 0x0 */

NH_WRITE(nh_base + 0x34,0x1000003);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x38,0x23fc0003);


NH_WRITE(nh_base + 0x3c,0x0);


/* @@@ Adding dest=0x20000004, mask = 0xffffffff, blade_nh_id=0x1000004,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40510,0x40000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x40,0x0);

/* blade 0x1 and NH 0x4, NH id type = 0x0 */

NH_WRITE(nh_base + 0x44,0x1000004);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x48,0x23fc0000);


NH_WRITE(nh_base + 0x4c,0x0);


/* @@@ Adding dest=0x2000000b, mask = 0xffffffff, blade_nh_id=0x1000005,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4052c,0x50000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x50,0x0);

/* blade 0x1 and NH 0x5, NH id type = 0x0 */

NH_WRITE(nh_base + 0x54,0x1000005);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x58,0x23fc0001);


NH_WRITE(nh_base + 0x5c,0x0);


/* @@@ Adding dest=0x2000000c, mask = 0xffffffff, blade_nh_id=0x1000006,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40530,0x60000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x60,0x0);

/* blade 0x1 and NH 0x6, NH id type = 0x0 */

NH_WRITE(nh_base + 0x64,0x1000006);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x68,0x23fc0002);


NH_WRITE(nh_base + 0x6c,0x0);


/* @@@ Adding dest=0x2000000d, mask = 0xffffffff, blade_nh_id=0x1000007,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40534,0x70000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x70,0x0);

/* blade 0x1 and NH 0x7, NH id type = 0x0 */

NH_WRITE(nh_base + 0x74,0x1000007);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x78,0x23fc0003);


NH_WRITE(nh_base + 0x7c,0x0);


/* @@@ Adding dest=0x2000000e, mask = 0xffffffff, blade_nh_id=0x1000008,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40538,0x80000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x80,0x0);

/* blade 0x1 and NH 0x8, NH id type = 0x0 */

NH_WRITE(nh_base + 0x84,0x1000008);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x88,0x23fc0000);


NH_WRITE(nh_base + 0x8c,0x0);


/* @@@ Adding dest=0x20000015, mask = 0xffffffff, blade_nh_id=0x1000009,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40554,0x90000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x90,0x0);

/* blade 0x1 and NH 0x9, NH id type = 0x0 */

NH_WRITE(nh_base + 0x94,0x1000009);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x98,0x23fc0001);


NH_WRITE(nh_base + 0x9c,0x0);


	TRIE_WRITE(trie_base + 0x404c4,0x5);


/* @@@ Adding dest=0x20000016, mask = 0xffffffff, blade_nh_id=0x100000a,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40558,0xa0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xa0,0x0);

/* blade 0x1 and NH 0xa, NH id type = 0x0 */

NH_WRITE(nh_base + 0xa4,0x100000a);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0xa8,0x23fc0002);


NH_WRITE(nh_base + 0xac,0x0);


/* @@@ Adding dest=0x20000017, mask = 0xffffffff, blade_nh_id=0x100000b,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4055c,0xb0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xb0,0x0);

/* blade 0x1 and NH 0xb, NH id type = 0x0 */

NH_WRITE(nh_base + 0xb4,0x100000b);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0xb8,0x23fc0003);


NH_WRITE(nh_base + 0xbc,0x0);


/* @@@ Adding dest=0x20000018, mask = 0xffffffff, blade_nh_id=0x100000c,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40560,0xc0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xc0,0x0);

/* blade 0x1 and NH 0xc, NH id type = 0x0 */

NH_WRITE(nh_base + 0xc4,0x100000c);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0xc8,0x23fc0000);


NH_WRITE(nh_base + 0xcc,0x0);

/* #-----------------------------------------------
 */ /* # 8-bit routes  - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x8000000, mask = 0xff000000, blade_nh_id=0x1000011,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40020,0xd0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xd0,0x0);

/* blade 0x1 and NH 0x11, NH id type = 0x0 */

NH_WRITE(nh_base + 0xd4,0x1000011);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0xd8,0x23fc0001);


NH_WRITE(nh_base + 0xdc,0x0);


/* @@@ Adding dest=0x9000000, mask = 0xff000000, blade_nh_id=0x1000012,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40024,0xe0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xe0,0x0);

/* blade 0x1 and NH 0x12, NH id type = 0x0 */

NH_WRITE(nh_base + 0xe4,0x1000012);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0xe8,0x23fc0002);


NH_WRITE(nh_base + 0xec,0x0);


/* @@@ Adding dest=0xa000000, mask = 0xff000000, blade_nh_id=0x1000013,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40028,0xf0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xf0,0x0);

/* blade 0x1 and NH 0x13, NH id type = 0x0 */

NH_WRITE(nh_base + 0xf4,0x1000013);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0xf8,0x23fc0003);


NH_WRITE(nh_base + 0xfc,0x0);


/* @@@ Adding dest=0xb000000, mask = 0xff000000, blade_nh_id=0x1000014,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4002c,0x100000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x100,0x0);

/* blade 0x1 and NH 0x14, NH id type = 0x0 */

NH_WRITE(nh_base + 0x104,0x1000014);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x108,0x23fc0000);


NH_WRITE(nh_base + 0x10c,0x0);

/* #-----------------------------------------------
 */ /* # 11-bit routes  - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0xb200000, mask = 0xffe00000, blade_nh_id=0x1000021,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40588,0x110000);


	TRIE_WRITE(trie_base + 0x4058c,0x110000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x110,0x0);

/* blade 0x1 and NH 0x21, NH id type = 0x0 */

NH_WRITE(nh_base + 0x114,0x1000021);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x118,0x23fc0001);


NH_WRITE(nh_base + 0x11c,0x0);


	TRIE_WRITE(trie_base + 0x4002c,0x100006);


/* @@@ Adding dest=0xb400000, mask = 0xffe00000, blade_nh_id=0x1000022,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40590,0x120000);


	TRIE_WRITE(trie_base + 0x40594,0x120000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x120,0x0);

/* blade 0x1 and NH 0x22, NH id type = 0x0 */

NH_WRITE(nh_base + 0x124,0x1000022);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x128,0x23fc0002);


NH_WRITE(nh_base + 0x12c,0x0);


/* @@@ Adding dest=0xb800000, mask = 0xffe00000, blade_nh_id=0x1000023,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x405a0,0x130000);


	TRIE_WRITE(trie_base + 0x405a4,0x130000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x130,0x0);

/* blade 0x1 and NH 0x23, NH id type = 0x0 */

NH_WRITE(nh_base + 0x134,0x1000023);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x138,0x23fc0003);


NH_WRITE(nh_base + 0x13c,0x0);


/* @@@ Adding dest=0xbe00000, mask = 0xffe00000, blade_nh_id=0x1000024,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x405b8,0x140000);


	TRIE_WRITE(trie_base + 0x405bc,0x140000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x140,0x0);

/* blade 0x1 and NH 0x24, NH id type = 0x0 */

NH_WRITE(nh_base + 0x144,0x1000024);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x148,0x23fc0000);


NH_WRITE(nh_base + 0x14c,0x0);

/* #-----------------------------------------------
 */ /* # 15-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0xf020000, mask = 0xfffe0000, blade_nh_id=0x1000031,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40608,0x150000);


	TRIE_WRITE(trie_base + 0x4060c,0x150000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x150,0x0);

/* blade 0x1 and NH 0x31, NH id type = 0x0 */

NH_WRITE(nh_base + 0x154,0x1000031);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x158,0x23fc0001);


NH_WRITE(nh_base + 0x15c,0x0);


	TRIE_WRITE(trie_base + 0x405c0,0x8);


	TRIE_WRITE(trie_base + 0x4003c,0x7);


/* @@@ Adding dest=0xf040000, mask = 0xfffe0000, blade_nh_id=0x1000032,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40610,0x160000);


	TRIE_WRITE(trie_base + 0x40614,0x160000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x160,0x0);

/* blade 0x1 and NH 0x32, NH id type = 0x0 */

NH_WRITE(nh_base + 0x164,0x1000032);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x168,0x23fc0002);


NH_WRITE(nh_base + 0x16c,0x0);


/* @@@ Adding dest=0xf080000, mask = 0xfffe0000, blade_nh_id=0x1000033,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40620,0x170000);


	TRIE_WRITE(trie_base + 0x40624,0x170000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x170,0x0);

/* blade 0x1 and NH 0x33, NH id type = 0x0 */

NH_WRITE(nh_base + 0x174,0x1000033);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x178,0x23fc0003);


NH_WRITE(nh_base + 0x17c,0x0);


/* @@@ Adding dest=0xf100000, mask = 0xfffe0000, blade_nh_id=0x1000034,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40640,0x180000);


	TRIE_WRITE(trie_base + 0x40644,0x180000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x180,0x0);

/* blade 0x1 and NH 0x34, NH id type = 0x0 */

NH_WRITE(nh_base + 0x184,0x1000034);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x188,0x23fc0000);


NH_WRITE(nh_base + 0x18c,0x0);


	TRIE_WRITE(trie_base + 0x405c4,0x9);

/* #-----------------------------------------------
 */ /* # 16-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x10010000, mask = 0xffff0000, blade_nh_id=0x1000041,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x406c4,0x190000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x190,0x0);

/* blade 0x1 and NH 0x41, NH id type = 0x0 */

NH_WRITE(nh_base + 0x194,0x1000041);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x198,0x23fc0001);


NH_WRITE(nh_base + 0x19c,0x0);


	TRIE_WRITE(trie_base + 0x40680,0xb);


	TRIE_WRITE(trie_base + 0x40040,0xa);


/* @@@ Adding dest=0x10020000, mask = 0xffff0000, blade_nh_id=0x1000042,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x406c8,0x1a0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x1a0,0x0);

/* blade 0x1 and NH 0x42, NH id type = 0x0 */

NH_WRITE(nh_base + 0x1a4,0x1000042);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x1a8,0x23fc0002);


NH_WRITE(nh_base + 0x1ac,0x0);


/* @@@ Adding dest=0x10030000, mask = 0xffff0000, blade_nh_id=0x1000043,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x406cc,0x1b0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x1b0,0x0);

/* blade 0x1 and NH 0x43, NH id type = 0x0 */

NH_WRITE(nh_base + 0x1b4,0x1000043);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x1b8,0x23fc0003);


NH_WRITE(nh_base + 0x1bc,0x0);


/* @@@ Adding dest=0x10040000, mask = 0xffff0000, blade_nh_id=0x1000044,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x406d0,0x1c0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x1c0,0x0);

/* blade 0x1 and NH 0x44, NH id type = 0x0 */

NH_WRITE(nh_base + 0x1c4,0x1000044);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x1c8,0x23fc0000);


NH_WRITE(nh_base + 0x1cc,0x0);

/* #-----------------------------------------------
 */ /* # 20-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x14011000, mask = 0xfffff000, blade_nh_id=0x1000051,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40704,0x1d0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x1d0,0x0);

/* blade 0x1 and NH 0x51, NH id type = 0x0 */

NH_WRITE(nh_base + 0x1d4,0x1000051);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x1d8,0x23fc0001);


NH_WRITE(nh_base + 0x1dc,0x0);


	TRIE_WRITE(trie_base + 0x5004,0xc);


/* @@@ Adding dest=0x14012000, mask = 0xfffff000, blade_nh_id=0x1000052,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40708,0x1e0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x1e0,0x0);

/* blade 0x1 and NH 0x52, NH id type = 0x0 */

NH_WRITE(nh_base + 0x1e4,0x1000052);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x1e8,0x23fc0002);


NH_WRITE(nh_base + 0x1ec,0x0);


/* @@@ Adding dest=0x14013000, mask = 0xfffff000, blade_nh_id=0x1000053,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4070c,0x1f0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x1f0,0x0);

/* blade 0x1 and NH 0x53, NH id type = 0x0 */

NH_WRITE(nh_base + 0x1f4,0x1000053);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x1f8,0x23fc0003);


NH_WRITE(nh_base + 0x1fc,0x0);


/* @@@ Adding dest=0x14014000, mask = 0xfffff000, blade_nh_id=0x1000054,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40710,0x200000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x200,0x0);

/* blade 0x1 and NH 0x54, NH id type = 0x0 */

NH_WRITE(nh_base + 0x204,0x1000054);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x208,0x23fc0000);


NH_WRITE(nh_base + 0x20c,0x0);

/* #-----------------------------------------------
 */ /* # 24-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x18000100, mask = 0xffffff00, blade_nh_id=0x1000061,mtu_port=0x23fc0001,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40784,0x210000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x210,0x0);

/* blade 0x1 and NH 0x61, NH id type = 0x0 */

NH_WRITE(nh_base + 0x214,0x1000061);

/* MTU is 9212, outport is 0x1 */ 

NH_WRITE(nh_base + 0x218,0x23fc0001);


NH_WRITE(nh_base + 0x21c,0x0);


	TRIE_WRITE(trie_base + 0x40740,0xe);


	TRIE_WRITE(trie_base + 0x6000,0xd);


/* @@@ Adding dest=0x18000200, mask = 0xffffff00, blade_nh_id=0x1000062,mtu_port=0x23fc0002,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40788,0x220000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x220,0x0);

/* blade 0x1 and NH 0x62, NH id type = 0x0 */

NH_WRITE(nh_base + 0x224,0x1000062);

/* MTU is 9212, outport is 0x2 */ 

NH_WRITE(nh_base + 0x228,0x23fc0002);


NH_WRITE(nh_base + 0x22c,0x0);


/* @@@ Adding dest=0x18000300, mask = 0xffffff00, blade_nh_id=0x1000063,mtu_port=0x23fc0003,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4078c,0x230000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x230,0x0);

/* blade 0x1 and NH 0x63, NH id type = 0x0 */

NH_WRITE(nh_base + 0x234,0x1000063);

/* MTU is 9212, outport is 0x3 */ 

NH_WRITE(nh_base + 0x238,0x23fc0003);


NH_WRITE(nh_base + 0x23c,0x0);


/* @@@ Adding dest=0x18000400, mask = 0xffffff00, blade_nh_id=0x1000064,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40790,0x240000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x240,0x0);

/* blade 0x1 and NH 0x64, NH id type = 0x0 */

NH_WRITE(nh_base + 0x244,0x1000064);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x248,0x23fc0000);


NH_WRITE(nh_base + 0x24c,0x0);


/* #-----------------------------------------------
 */ /* # bunch of invalid destination addresses
 */ /* #-----------------------------------------------
 */ /* # drop if dst==0
 */ 
/* @@@ Adding dest=0x0, mask = 0xff000000, blade_nh_id=0x500beef,mtu_port=0x23fc0005,flags=0x4,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40000,0x250000);

/* writing nexthop entry with flags 0x4 */ 

NH_WRITE(nh_base + 0x250,0x4);

/* blade 0x5 and NH 0xbeef, NH id type = 0x0 */

NH_WRITE(nh_base + 0x254,0x500beef);

/* MTU is 9212, outport is 0x5 */ 

NH_WRITE(nh_base + 0x258,0x23fc0005);


NH_WRITE(nh_base + 0x25c,0x0);

/* # drop if dst==127.*
 */ 
/* @@@ Adding dest=0x7f000000, mask = 0xff000000, blade_nh_id=0x500beef,mtu_port=0x23fc0005,flags=0x4,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x401fc,0x260000);

/* writing nexthop entry with flags 0x4 */ 

NH_WRITE(nh_base + 0x260,0x4);

/* blade 0x5 and NH 0xbeef, NH id type = 0x0 */

NH_WRITE(nh_base + 0x264,0x500beef);

/* MTU is 9212, outport is 0x5 */ 

NH_WRITE(nh_base + 0x268,0x23fc0005);


NH_WRITE(nh_base + 0x26c,0x0);

/* # drop if dst==classE
 */ 
/* @@@ Adding dest=0xf0000000, mask = 0xf0000000, blade_nh_id=0x500beef,mtu_port=0x23fc0005,flags=0x4,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x403c0,0x270000);


	TRIE_WRITE(trie_base + 0x403c4,0x270000);


	TRIE_WRITE(trie_base + 0x403c8,0x270000);


	TRIE_WRITE(trie_base + 0x403cc,0x270000);


	TRIE_WRITE(trie_base + 0x403d0,0x270000);


	TRIE_WRITE(trie_base + 0x403d4,0x270000);


	TRIE_WRITE(trie_base + 0x403d8,0x270000);


	TRIE_WRITE(trie_base + 0x403dc,0x270000);


	TRIE_WRITE(trie_base + 0x403e0,0x270000);


	TRIE_WRITE(trie_base + 0x403e4,0x270000);


	TRIE_WRITE(trie_base + 0x403e8,0x270000);


	TRIE_WRITE(trie_base + 0x403ec,0x270000);


	TRIE_WRITE(trie_base + 0x403f0,0x270000);


	TRIE_WRITE(trie_base + 0x403f4,0x270000);


	TRIE_WRITE(trie_base + 0x403f8,0x270000);


	TRIE_WRITE(trie_base + 0x403fc,0x270000);

/* writing nexthop entry with flags 0x4 */ 

NH_WRITE(nh_base + 0x270,0x4);

/* blade 0x5 and NH 0xbeef, NH id type = 0x0 */

NH_WRITE(nh_base + 0x274,0x500beef);

/* MTU is 9212, outport is 0x5 */ 

NH_WRITE(nh_base + 0x278,0x23fc0005);


NH_WRITE(nh_base + 0x27c,0x0);

/* #------------------------------------------------
 */ /* # bunch of local delivery destination addresses
 */ /* #-------------------------------------------------
 */ /* # multicast
 */ 
/* @@@ Adding dest=0xe0000000, mask = 0xf0000000, blade_nh_id=0x2000000,mtu_port=0x23e80001,flags=0x10,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40380,0x280000);


	TRIE_WRITE(trie_base + 0x40384,0x280000);


	TRIE_WRITE(trie_base + 0x40388,0x280000);


	TRIE_WRITE(trie_base + 0x4038c,0x280000);


	TRIE_WRITE(trie_base + 0x40390,0x280000);


	TRIE_WRITE(trie_base + 0x40394,0x280000);


	TRIE_WRITE(trie_base + 0x40398,0x280000);


	TRIE_WRITE(trie_base + 0x4039c,0x280000);


	TRIE_WRITE(trie_base + 0x403a0,0x280000);


	TRIE_WRITE(trie_base + 0x403a4,0x280000);


	TRIE_WRITE(trie_base + 0x403a8,0x280000);


	TRIE_WRITE(trie_base + 0x403ac,0x280000);


	TRIE_WRITE(trie_base + 0x403b0,0x280000);


	TRIE_WRITE(trie_base + 0x403b4,0x280000);


	TRIE_WRITE(trie_base + 0x403b8,0x280000);


	TRIE_WRITE(trie_base + 0x403bc,0x280000);

/* writing nexthop entry with flags 0x10 */ 

NH_WRITE(nh_base + 0x280,0x10);

/* blade 0x2 and NH 0x0, NH id type = 0x0 */

NH_WRITE(nh_base + 0x284,0x2000000);

/* MTU is 9192, outport is 0x1 */ 

NH_WRITE(nh_base + 0x288,0x23e80001);


NH_WRITE(nh_base + 0x28c,0x0);

/* # limited broadcast
 */ 
/* @@@ Adding dest=0xffffffff, mask = 0xffffffff, blade_nh_id=0x2000000,mtu_port=0x23e80001,flags=0x8,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x408bc,0x290000);

/* writing nexthop entry with flags 0x8 */ 

NH_WRITE(nh_base + 0x290,0x8);

/* blade 0x2 and NH 0x0, NH id type = 0x0 */

NH_WRITE(nh_base + 0x294,0x2000000);

/* MTU is 9192, outport is 0x1 */ 

NH_WRITE(nh_base + 0x298,0x23e80001);


NH_WRITE(nh_base + 0x29c,0x0);


	TRIE_WRITE(trie_base + 0x4087c,0x12);


	TRIE_WRITE(trie_base + 0x4083c,0x11);


	TRIE_WRITE(trie_base + 0x407fc,0x10);


	TRIE_WRITE(trie_base + 0x3fffc,0xf);

return 1;


}
