# ============================================================================
#  INTEL CONFIDENTIAL
#
#  Copyright 2003 Intel Corporation All Rights Reserved.
#
#  The source code contained or described herein and all documents related to
#  the source code ("Material") are owned by Intel Corporation or its 
#  suppliers or licensors.
#
#  Title to the Material remains with Intel Corporation or its suppliers and
#  licensors. The Material contains trade secrets and proprietary and
#  confidential information of Intel or its suppliers and licensors.
#  The Material is protected by worldwide copyright and trade secret laws and
#  treaty provisions. No part of the Material may be used, copied, reproduced,
#  modified, published, uploaded, posted, transmitted, distributed,
#  or disclosed in any way without Intel's prior express written permission.
#
#  No license under any patent, copyright, trade secret or other intellectual
#  property right is granted to or conferred upon you by disclosure
#  or delivery of the Materials, either expressly, by implication, inducement,
#  estoppel or otherwise. Any license under such intellectual property rights
#  must be express and approved by Intel in writing.
#
# ============================================================================
# = PRODUCT
#      Intel(r) IXA SDK for the IXP2X00 Network Processor
#
# = FILENAME
#      rtm_config_linux.sh
#
# = DESCRIPTION
#      This file contains script to configure the 4oc12_pos_6gb_ethernet_2801
#      application on an IXPD2801 platform.
#
# = CHANGE HISTORY
#      02/26/2003      Created
# ============================================================================
#

# 16-bit routes - Forward			 
#-----------------------------------------------

./rconfig addRoute "16.0.0.0 255.255.255.255 FFFFFFFD"

# 4 POS routes for 4 OC12 links or for one OC48
#----------------------------------------------
./rconfig addNextHop "1 1 fffe 0 9216 0 16.1.0.10 0"
./rconfig addRoute "16.1.0.0 255.255.0.0 1"
./rconfig addRoute "16.1.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "2 1 fffe 1 9216 0 16.2.0.10 0"
./rconfig addRoute "16.2.0.0 255.255.0.0 2"
./rconfig addRoute "16.2.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "3 1 fffe 2 9216 0 16.3.0.10 0"
./rconfig addRoute "16.3.0.0 255.255.0.0 3"
./rconfig addRoute "16.3.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "4 1 fffe 3 9216 0 16.4.0.10 0"
./rconfig addRoute "16.4.0.0 255.255.0.0 4"
./rconfig addRoute "16.4.0.0 255.255.255.255 FFFFFFFD"

# 8 Ethernet routes POS routes for up to 8 
# Ethernet GB links
#----------------------------------------------

./rconfig addNextHop "5 1 1 4 1500 0 16.5.0.10 0"
./rconfig addRoute "16.5.0.0 255.255.0.0 5"
./l2config addV4EthEntry "1 16.5.0.10 0a:0c:14:37:10:a2 02:01:02:03:00:05 DEFAULT"
./rconfig addRoute "16.5.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "6 1 2 5 1500 0 16.6.0.10 0"
./rconfig addRoute "16.6.0.0 255.255.0.0 6"
./l2config addV4EthEntry "2 16.6.0.10 0a:0c:14:37:20:a2 02:01:02:03:00:06 DEFAULT"
./rconfig addRoute "16.6.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "7 1 3 6 1500 0 16.7.0.10 0"
./rconfig addRoute "16.7.0.0 255.255.0.0 7"
./l2config addV4EthEntry "3 16.7.0.10 0a:0c:14:37:30:a2 02:01:02:03:00:07 DEFAULT"
./rconfig addRoute "16.7.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "8 1 4 7 1500 0 16.8.0.10 0"
./rconfig addRoute "16.8.0.0 255.255.0.0 8"
./l2config addV4EthEntry "4 16.8.0.10 0a:0c:14:37:40:a2 02:01:02:03:00:08 DEFAULT"
./rconfig addRoute "16.8.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "9 1 5 8 1500 0 16.9.0.10 0"
./rconfig addRoute "16.9.0.0 255.255.0.0 9"
./l2config addV4EthEntry "5 16.9.0.10 0a:0c:14:37:10:a2 02:01:02:03:00:09 DEFAULT"
./rconfig addRoute "16.9.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "10 1 6 9 1500 0 16.10.0.10 0"
./rconfig addRoute "16.10.0.0 255.255.0.0 10"
./l2config addV4EthEntry "6 16.10.0.10 0a:0c:14:37:20:a2 02:01:02:03:00:0a DEFAULT"
./rconfig addRoute "16.10.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "11 1 7 10 1500 0 16.11.0.10 0"
./rconfig addRoute "16.11.0.0 255.255.0.0 11"
./l2config addV4EthEntry "7 16.11.0.10 0a:0c:14:37:30:a2 02:01:02:03:00:0b DEFAULT"
./rconfig addRoute "16.11.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "12 1 8 11 1500 0 16.12.0.10 0"
./rconfig addRoute "16.12.0.0 255.255.0.0 12"
./l2config addV4EthEntry "8 16.12.0.10 0a:0c:14:37:40:a2 02:01:02:03:00:0c DEFAULT"
./rconfig addRoute "16.12.0.0 255.255.255.255 FFFFFFFD"


# Directed broadcast - Exception		 
#-----------------------------------------------
./rconfig addNextHop "50 1 50 4 1500 8 16.5.255.255 0"
./rconfig addRoute "16.5.255.255 255.255.255.255 50"
./l2config addV4EthEntry "50 16.5.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:05 DEFAULT"

./rconfig addNextHop "51 1 51 5 1500 8 16.6.255.255 0"
./rconfig addRoute "16.6.255.255 255.255.255.255 51"
./l2config addV4EthEntry "51 16.6.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:06 DEFAULT"

./rconfig addNextHop "52 1 52 6 1500 8 16.7.255.255 0"
./rconfig addRoute "16.7.255.255 255.255.255.255 52"
./l2config addV4EthEntry "52 16.7.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:07 DEFAULT"

./rconfig addNextHop "53 1 53 7 1500 8 16.8.255.255 0"
./rconfig addRoute "16.8.255.255 255.255.255.255 53"
./l2config addV4EthEntry "53 16.8.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:08 DEFAULT"

./rconfig addNextHop "54 1 54 8 1500 8 16.9.255.255 0"
./rconfig addRoute "16.9.255.255 255.255.255.255 54"
./l2config addV4EthEntry "54 16.9.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:09 DEFAULT"

./rconfig addNextHop "55 1 55 9 1500 8 16.10.255.255 0"
./rconfig addRoute "16.10.255.255 255.255.255.255 55"
./l2config addV4EthEntry "55 16.10.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:0a DEFAULT"

./rconfig addNextHop "56 1 56 10 1500 8 16.11.255.255 0"
./rconfig addRoute "16.11.255.255 255.255.255.255 56"
./l2config addV4EthEntry "56 16.11.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:0b DEFAULT"

./rconfig addNextHop "57 1 57 11 1500 8 16.12.255.255 0"
./rconfig addRoute "16.12.255.255 255.255.255.255 57"
./l2config addV4EthEntry "57 16.12.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:0c DEFAULT"

# Configuration successful
#-----------------------------------------------

