/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 2003 By Intel Corporation.  All rights reserved.  
 No part of this program or publication may be reproduced, transmitted,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/
/*
 * xscale_sink.uc
 * This file contains dispatch loop for xscale sink.
 */

#ifndef __XSCALE_SINK_UC__
#define __XSCALE_SINK_UC__

//  Include Files

// include system.h from dispatch loop
#include    "dl_system.h"

#include    "definitions.h"

// include system_init.h from dispatch loop for inter ME signal
#include    "system_init.uc"

// include dispatch_loop.uc from dispatch loop 
#include    "dispatch_loop.uc"


//-----------------------------------------------------------
// Initialize the blocks
//-----------------------------------------------------------

init#:
    ; init buffer meta data cache to Zero.
    init_meta_cache_to_zero[]

    ; Temporary : Initialize EOP handle default.
    _dl_eop_buf_handle_init[]

	; wait for system readiness
	.begin
		// we need to manually allocate a signal on which we wait.
		.sig	sys_init_signal
		.addr	sys_init_signal	ME_INIT_SIGNAL
		.set_sig sys_init_signal


		// we wait for the signal here
		ctx_arb[sys_init_signal]

		// by exiting this block, we free up the signal
	.end

//-----------------------------------------------------------
// dispatch loop
//-----------------------------------------------------------
// Thread 0 will process only exception packets. There 
// is enough headroom available and will not affect
// performance

    br=ctx[0,_handle_exception_pkt#]

	/*
	 * Other threads are killed
	 */
	ctx_arb[kill]


_handle_exception_pkt#:
    
    dl_get_exception_pkt()

    br[_handle_exception_pkt#]  

kill#:
    // Control should never come here.
    nop
    nop

#endif  // __XSCALE_SINK_UC__


