/*******************************************************************************
  INTEL CONFIDENTIAL

  Copyright 2003 Intel Corporation All Rights Reserved.

  The source code contained or described herein and all documents related to
  the source code ("Material") are owned by Intel Corporation or its 
  suppliers or licensors.

  Title to the Material remains with Intel Corporation or its suppliers and
  licensors. The Material contains trade secrets and proprietary and
  confidential information of Intel or its suppliers and licensors.
  The Material is protected by worldwide copyright and trade secret laws and
  treaty provisions. No part of the Material may be used, copied, reproduced,
  modified, published, uploaded, posted, transmitted, distributed,
  or disclosed in any way without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure
  or delivery of the Materials, either expressly, by implication, inducement,
  estoppel or otherwise. Any license under such intellectual property rights
  must be express and approved by Intel in writing.

*******************************************************************************/
/**
 * ============================================================================
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      wred.c
 *
 * = DESCRIPTION
 *      This file contains scripts to initialize the default fwd WRED
 *      microblock on an IXPD2801 platform.
 *
 * = CHANGE HISTORY
 *      08/14/2003      Created
 * ============================================================================
 */

#include "../pos_ethernet_memory.h"
#include "xscale_init.h"

/* -- wred_empty_table -- */

int wred_empty_table()
{

    int i, entry, finish;

    entry = WRED_TABLE_SRAM_BASE;
    finish = entry + WRED_TABLE_SRAM_SIZE;

	printf("wred_empty_table() : Initializing WRED SRAM memory...\n");
    init_sram(0x0, entry, finish);
    
    for (i = 0; i < 256; i++ )
    {
        entry = entry + i*64;
        set_sram(entry+0, 0xffffffff);/* green_min_th & green_max_th */
        set_sram(entry+4, 0xffffffff);/* yellow_min_th & yellow_max_th */
        set_sram(entry+8, 0xffffffff);/* red_min_th & red_max_th */
    }
    
    entry = WRED_64BIT_STAT_SRAM_BASE;
    finish = entry + WRED_64BIT_STAT_SIZE;
    init_sram(0x0, entry, finish);
    
	printf("wred_empty_table() done\n");

    return 1;
}
