# ******************************************************************************
#  INTEL CONFIDENTIAL
#
#  Copyright 2003 Intel Corporation All Rights Reserved.
#
#  The source code contained or described herein and all documents related to
#  the source code ("Material") are owned by Intel Corporation or its
#  suppliers or licensors.
#
#  Title to the Material #ains with Intel Corporation or its suppliers and
#  licensors. The Material contains trade secrets and proprietary and
#  confidential information of Intel or its suppliers and licensors.
#  The Material is protected by worldwide copyright and trade secret laws and
#  treaty provisions. No part of the Material may be used, copied, reproduced,
#  modified, published, uploaded, posted, transmitted, distributed,
#  or disclosed in any way without Intel's prior express written permission.
#
#  No license under any patent, copyright, trade secret or other intellectual
#  property right is granted to or conferred upon you by disclosure
#  or delivery of the Materials, either expressly, by implication, inducement,
#  estoppel or otherwise. Any license under such intellectual property rights
#  must be express and approved by Intel in writing.
#
# ******************************************************************************

# ******************************************************************************
# ============================================================================
#
# = PRODUCT
#      Intel(r) IXA SDK for the IXP2400 Network Processor
#
# = FILENAME
#      init.sh
#
# = DESCRIPTION
#
# ============================================================================
# ******************************************************************************

#!/bin/sh
if [ -z "$1" ]; then
    echo As a first parameter for this script you must provide mezzanine spin. The proper spins are: spin1a and spin2.
    echo Usage:
    echo $0 spin1a
    echo $0 spin2
    exit
fi
SPIN=
if [ "$1" = "spin1a" ] || [ "$1" = "spin2" ]; then
    SPIN=$1
else
    echo Undefined mezzanine spin.
    exit
fi

if [ "$2" = "" ] || [ "$2" = "db0" ]; then
    DB_CONF=0
elif [ "$2" = "db1" ]; then
    DB_CONF=1
else
    echo Specify which mezzanie to initialize - db0 or db1. By default db0 is initialized.
    echo If you want to initialize db1 the code must be recompiled with removed IX_CONFIGURATION_atmdb0 definition in makefile.
   exit
fi

echo Initializing WB Server...
rm -f /dev/MeDrv0
mknod /dev/MeDrv0 c 10 244
insmod ../me_tools/halMeDrv.o
../me_tools/WBSrvr &

echo Initializing configuration application...
./oc12_atm_gbeth_project

echo Intalling drivers ...
#rm -f /dev/pos_atm*
#mknod -m 666 /dev/pos_atm_drv0 c 244 0
#mknod -m 666 /dev/pos_atm_drv1 c 244 1

insmod ../build/bb_linux_drv val_conf="spi2;spi3;sphy;104mhz" db0_conf="spi0;sphy;104mhz" db1_conf="spi1;sphy;104mhz"
#    insmod ../build/ixf1104drv_kernel.o
insmod ../build/pos_atm_drv atmdb0="atm;oc12;$SPIN"

./drv_cfg




