# ******************************************************************************
#  INTEL CONFIDENTIAL
#
#  Copyright 2003 Intel Corporation All Rights Reserved.
#
#  The source code contained or described herein and all documents related to
#  the source code ("Material") are owned by Intel Corporation or its
#  suppliers or licensors.
#
#  Title to the Material #ains with Intel Corporation or its suppliers and
#  licensors. The Material contains trade secrets and proprietary and
#  confidential information of Intel or its suppliers and licensors.
#  The Material is protected by worldwide copyright and trade secret laws and
#  treaty provisions. No part of the Material may be used, copied, reproduced,
#  modified, published, uploaded, posted, transmitted, distributed,
#  or disclosed in any way without Intel's prior express written permission.
#
#  No license under any patent, copyright, trade secret or other intellectual
#  property right is granted to or conferred upon you by disclosure
#  or delivery of the Materials, either expressly, by implication, inducement,
#  estoppel or otherwise. Any license under such intellectual property rights
#  must be express and approved by Intel in writing.
#
# ******************************************************************************

# ******************************************************************************
# ============================================================================
#
# = PRODUCT
#      Intel(r) IXA SDK for the IXP2400 Network Processor
#
# = FILENAME
#      oc12_atm_gbeth_2401_run.sh
#
# = DESCRIPTION
#
# ============================================================================
# ******************************************************************************

#!/bin/sh
if [ -z "$1" ]; then
    echo As a first parameter for this script you must provide mezzanine spin. The proper spins are: spin1a and spin2.
    echo Usage:
    echo $0 spin1a
    echo $0 spin2
    exit
fi
SPIN=
if [ "$1" = "spin1a" ] || [ "$1" = "spin2" ]; then
    SPIN=$1
else
    echo Undefined mezzanine spin.
    exit
fi

./me_tools/WBSrvr &

insmod ./me_tools/halMeDrv.o
insmod ./me_tools/libossl.o
insmod ./me_tools/halMev2_lib.o

insmod ./build/rm_lib.o
insmod ./build/cci_lib.o
insmod ./build/utilities_lib.o
insmod ./build/msg_support_lib.o
insmod ./build/properties_lib.o
insmod ./build/fragmentation_lib.o
insmod ./build/lkup_lib.o
insmod ./build/rtmv4_lib.o
insmod ./build/l2tm_lib.o
insmod ./build/l2_config_util.o
insmod ./build/ether_arp_lib.o
insmod ./build/ipv4_cc.o
insmod ./build/route_config_util.o
insmod ./build/llc_encap_util.o
insmod ./build/llc_snap_config_util.o
#insmod ./build/bb_linux_drv val_conf="spi2;spi3;sphy;104mhz" db0_conf="spi0;sphy;104mhz" db1_conf="spi1;sphy;104mhz"
insmod ./build/bb_linux_drv val_conf="spi2;spi3;sphy;104mhz" db0_conf="spi0;sphy;104mhz" db1_conf="spi1;sphy;104mhz"
insmod ./build/ixf1104drv_kernel.o
insmod ./build/ethernet_tx_cc.o
insmod ./build/ethernet_rx_cc.o
insmod ./build/oc12_atm_gbeth_globals.o
insmod ./build/qm_cc.o
insmod ./build/sched_cc.o
insmod ./build/stkdrv_cc.o
insmod ./build/pos_atm_drv atmdb0="atm;oc12;$SPIN"
insmod ./build/atmsar_main.o
insmod ./build/atmsar_helpers.o
insmod ./build/atmsar_config_util.o
insmod ./build/atm_rx.o
insmod ./build/atm_tm41.o
insmod ./build/atm_tx.o
insmod ./build/oc12_atm_gbeth_2401_config.o
insmod ./build/sysapp_common_egress.o

./build/sa start 1 &




