# ******************************************************************************
#  INTEL CONFIDENTIAL
#
#  Copyright 2003 Intel Corporation All Rights Reserved.
#
#  The source code contained or described herein and all documents related to
#  the source code ("Material") are owned by Intel Corporation or its
#  suppliers or licensors.
#
#  Title to the Material #ains with Intel Corporation or its suppliers and
#  licensors. The Material contains trade secrets and proprietary and
#  confidential information of Intel or its suppliers and licensors.
#  The Material is protected by worldwide copyright and trade secret laws and
#  treaty provisions. No part of the Material may be used, copied, reproduced,
#  modified, published, uploaded, posted, transmitted, distributed,
#  or disclosed in any way without Intel's prior express written permission.
#
#  No license under any patent, copyright, trade secret or other intellectual
#  property right is granted to or conferred upon you by disclosure
#  or delivery of the Materials, either expressly, by implication, inducement,
#  estoppel or otherwise. Any license under such intellectual property rights
#  must be express and approved by Intel in writing.
#
# ******************************************************************************

# ******************************************************************************
# ============================================================================
#
# = PRODUCT
#      Intel(r) IXA SDK for the IXP2400 Network Processor
#
# = FILENAME
#      test_configuration_m3.sh
#
# = DESCRIPTION
#
# ============================================================================
# ******************************************************************************

# VC: vpi=0 vci=100 (VCQ=1) LLC SNAP HBR
./build/atmsar_config addVc "1 1 0 0 100 6"
./build/atmsar_config updateVc "1 1 2 1"

# VC: vpi=0 vci=101 (VCQ=193) VC MUX UBR with priority
./build/atmsar_config addVc "1 2 0 0 101 3"
./build/atmsar_config updateVc "1 2 2 2"

#######################################################
#
#                    ETH -> ATM
#
#######################################################

# ip:16.1.0.10 vcq:1 vpi:0 vci:100 ENCAP:LLC SNAP
./build/rconfig addNextHop "1 1 1 0 1500 0 16.1.0.10 0"
./build/rconfig addRoute "16.1.0.0 255.255.0.0 1"
./build/llc_snap_config addNextHop "1 0 100 1 0 170 170 3 0 2048"

# ip:16.2.0.10 vcq:193 vpi:0 vci:101 ENCAP:VC MUX
./build/rconfig addNextHop "2 1 c1 0 1500 0 16.2.0.10 0"
./build/rconfig addRoute "16.2.0.0 255.255.0.0 2"
./build/llc_snap_config addNextHop "193 0 101 193 1 1 1 1 1 1"


#######################################################
#
#                     ATM -> ETH
#
#######################################################

./build/l2config addV4EthEntry "c1 16.3.0.10 0a:0c:14:37:30:a2 02:01:02:03:00:03 DEFAULT"
./build/rconfig addNextHop "3 1 c1 1 1500 0 16.3.0.10 0"
./build/rconfig addRoute "16.3.0.0 255.255.0.0 3"

./build/l2config addV4EthEntry "c2 16.4.0.10 0a:0c:14:37:40:a2 02:01:02:03:00:04 DEFAULT"
./build/rconfig addNextHop "4 1 c2 1 1500 0 16.4.0.10 0"
./build/rconfig addRoute "16.4.0.0 255.255.0.0 4"


