#ifndef	DL_SYSTEM_CONFIG_H
#define	DL_SYSTEM_CONFIG_H

/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 2003 By Intel Corporation.  All rights reserved.
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/

/* FILE  dl_system_config.h
 *
 * This file contains general system configuration parameters
 *
 */

/* System LineRate */
#define OC12

/* System h/w type */
#define IXP2400
#define IXP_CLOCK                       600000000

/* default test configuration */
#define NQL_CONFIG


/*------------------------------------------------------------------------------
 * Common RX/TX  definitions
 */
/* Number of bits used to address ports in ATM code - design constant - do not change */
#define MAX_ATM_PORTS_BITS              11

/* Number of bits used to address SPI4, between 0..8 */
#define AAL5_PHY_IF_BITS                1

/* Number of bits used to address ports inside the FPGA */
#define AAL5_FPGA_PORT_BITS             (MAX_ATM_PORTS_BITS - AAL5_PHY_IF_BITS)


/*	Number of buffers used in system. */
#define	NUMBER_OF_BUFFERS			8192
/* Port configuration */
#define DOWNSTREAM_RX_MAX_PORTS	    4		/* ETH */
#define DOWNSTREAM_TX_MAX_PORTS		4	/* ATM (DSLAM) */

#define UPSTREAM_RX_MAX_PORTS		4	/* ATM (DSLAM) */
#define UPSTREAM_TX_MAX_PORTS		4		/* ETH */

/* VC configuration */
#define DOWNSTREAM_TX_MAX_VCS		4096	/* ATM (DSLAM) */
#define UPSTREAM_RX_MAX_VCS			4096	/* ATM (DSLAM) */

/* Define number of VCs in upstream direction */
#define AAL5_RX_NUMBER_OF_VC                    UPSTREAM_RX_MAX_VCS

/* reduced from 64k to 32k entries */
#define AAL5_RX_VC_HASH_PRI_BKT_NUMBER			AAL5_RX_NUMBER_OF_VC

/* Take greater value of the two: UPSTREAM_RX_MAX_VCS, DOWNSTREAM_RX_MAX_VCS */
#define AAL5_RX_VC_HASH_PRI_SIZE                AAL5_RX_NUMBER_OF_VC
#define AAL5_RX_VC_HASH_SEC_SIZE                (AAL5_RX_VC_HASH_PRI_SIZE>>2)

/* Additional AAL5 RX defines */
#define NO_PER_PORT_STAT_COUNTERS	    8
#define ATMRX_VC_STAT_COUNTERS_NO       5
#define ATMRX_VC_STAT_COUNTERS_FIRST_LW 10

/* SAR UT define */
#define NUMBER_OF_VC                             AAL5_RX_NUMBER_OF_VC


/* System works with 2K ports */
/*#define SUPPORT_2K_PORTS*/

/* Table containing information about the ports is located in DRAM */
#define PORTINFO_IN_SRAM

/* We use L2Ports, not SUIDs */
/*#define OPTIONAL_L2PORT*/

/*-----------------------------------------------------------------------------
 * L2 Table (ARP)
 */
#define L2_TABLE_ENTRY_SIZE				16
#define MAX_L2_TABLE_ENTRIES			4096

/*
 * The DDR (Double Data Rate DRAM) bank size is used to randomize buffer offset.
 */
#define DDR_BANK_SIZE					128

/*
 * Number of DDR banks
 */
#define NO_OF_DDR_BANKS					2

/* Number of Bridge Forwarding Tables */
#define NO_OF_L2_BRIDGE_FDBS            65

/* Queue Descriptor size */
#define QD_LOG_SRAM_SIZE                5

/* L2PORT/SUID configuration */
#define OPTIONAL_L2PORT

#endif /*  DL_SYSTEM_CONFIG_H  */

/*******************************  FILE HISTORY  *******************************
 * \main\2 Mon Aug 18 09:45:50 2003 adziecia
 * IGK0100025024: ATM-IPV4-ETH: simulation project check-in
 *
 * \main\1 Wed Aug 13 14:03:15 2003 adziecia
 * IGK0100025024: ATM-IPV4-ETH: simulation project check-in
 *
 *****************************************************************************/
