/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 2003 By Intel Corporation.  All rights reserved.
 No part of this program or publication may be reproduced, transmitted,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/

/*
 * test_macros.uc
 */

.reg	@cc


	.if (ctx()==0)
		alu[@cc, --, B, 0]
	.endif


#macro eth_rx_temp_get2()
.begin
.reg tmp1 a1
//	dl_meta_get_header_type(tmp1)
	alu[dl_next_block, --, B, BID_NEXT_BLOCK]

	alu[@cc, @cc, +, 1]
	alu[tmp1, --, B, @cc]
	dl_meta_set_header_type(tmp1)


	alu_shf[a1, --, B, tmp1, <<2]
	local_csr_wr[active_lm_addr_0, a1]
	nop
	nop
	nop
	alu[*l$index0, --, B, tmp1]

.end
#endm

#macro eth_rx_temp_get()
.begin
.reg table_base table_offset tmp1 tmp2 tmp3 tmp4 packet_no
.sig sram_sig

	move(table_base, 0x1000000)
	xbuf_alloc($packet_data, 14, read)

	alu[@packet_no, @packet_no, +, 1]
	.if (@packet_no > 10)
		alu[@packet_no, --, B, 1]
	.endif

	alu[packet_no, --, B, @packet_no]
	alu[table_offset, --, B, packet_no, <<(4+2)]

	alu[--, --, B, (16+14), <<21]
	sram[read, $packet_data0, table_base, table_offset, max_14], indirect_ref, ctx_swap[sram_sig]

	alu[dl_buf_handle, --, B, $packet_data0]
	alu[dl_eop_buf_handle, --, B, $packet_data1]

	dl_meta_init_cache[0, 0, 0, 0, 0, 0, 0, 0]

	alu[tmp1, --, B, $packet_data2]
	dl_meta_set_buffer_size(tmp1)

	alu[tmp1, --, B, $packet_data3]
	dl_meta_set_offset(tmp1)

	alu[tmp1, --, B, $packet_data4]
	dl_meta_set_header_type(tmp1)

	alu[tmp1, --, B, $packet_data5]
	dl_meta_set_input_port(tmp1)
	alu[tmp1, --, B, $packet_data6]
	dl_meta_set_output_port(tmp1)
	alu[tmp1, --, B, $packet_data7]
	dl_meta_set_fabric_port(tmp1)
	alu[tmp1, --, B, $packet_data8]
	dl_meta_set_priority(tmp1)
	alu[tmp1, --, B, $packet_data9]
	dl_meta_set_class_id(tmp1)
	alu[tmp1, --, B, $packet_data10]
	dl_meta_set_vid(tmp1)
	alu[tmp1, --, B, $packet_data11]
	dl_meta_set_tag(tmp1)
	alu[tmp1, --, B, $packet_data12]
	dl_meta_set_fcs(tmp1)
	alu[tmp1, --, B, $packet_data13]
	dl_meta_set_color_id(tmp1)

	xbuf_free($packet_data)

.end
#endm

#macro eth_rx_temp_get0()
.begin
.reg table_base table_offset tmp1 tmp2 tmp3 tmp4 packet_no
.sig sram_sig



	move(dl_buf_handle, 0x10000)
	alu[dl_eop_buf_handle, --, B, IX_NULL]

	dl_meta_init_cache[0, 0, 0, 0, 0, 0, 0, 0]

	alu[tmp1, --, B, 2]
	dl_meta_set_buffer_size(tmp1)

	alu[tmp1, --, B, 6]
	dl_meta_set_offset(tmp1)

	alu[tmp1, --, B, 4]
	dl_meta_set_header_type(tmp1)

	alu[tmp1, --, B, 5]
	dl_meta_set_input_port(tmp1)
	alu[tmp1, --, B, 6]
	dl_meta_set_output_port(tmp1)
	alu[tmp1, --, B, 7]
	dl_meta_set_fabric_port(tmp1)
	alu[tmp1, --, B, 8]
	dl_meta_set_priority(tmp1)
	alu[tmp1, --, B, 9]
	dl_meta_set_class_id(tmp1)
	alu[tmp1, --, B, 10]
	dl_meta_set_vid(tmp1)
	alu[tmp1, --, B, 11]
	dl_meta_set_tag(tmp1)
	alu[tmp1, --, B, 12]
	dl_meta_set_fcs(tmp1)
	alu[tmp1, --, B, 13]
	dl_meta_set_color_id(tmp1)

//	xbuf_free($packet_data)

.end
#endm

#macro fwd_check()
.begin
.reg tmp1 ht
	alu[--, dl_next_block, -, BID_IPV4]
	beq[process#]
	alu[--, dl_next_block, -, BID_L2BR]
	beq[process#]
	alu[--, dl_next_block, -, BID_IPV6]
	bne[end_of_macro#]

process#:
	nop
	dl_meta_get_buffer_size(tmp1)

	nop
	dl_meta_get_offset(tmp1)

	nop
	dl_meta_get_header_type(ht)
	nop


	alu[@cc, @cc, +, 4]
	local_csr_wr[active_lm_addr_0, @cc]
	nop
	nop
	nop
	alu[*l$index0, --, B, ht]





	dl_meta_get_input_port(tmp1)
	nop
	dl_meta_get_output_port(tmp1)
	nop
	dl_meta_get_fabric_port(tmp1)
	nop
	dl_meta_get_priority(tmp1)
	nop
	dl_meta_get_class_id(tmp1)
	nop
	dl_meta_get_vid(tmp1)
	nop
	dl_meta_get_tag(tmp1)
	nop
	dl_meta_get_fcs(tmp1)
	nop
	dl_meta_get_color_id(tmp1)
	nop

	alu[ht, ht, OR, DL_NEXT_ME, <<8]
	dl_meta_set_output_port(ht)




	move(dl_next_block, BID_NEXT_BLOCK)

end_of_macro#:
.end
#endm

#macro ip_test1()

#define IP_VERSION_LENGTH 0, 1          /* version/length fields.  offset 0, 1 byte   */
#define IP_TYPE_OF_SERVICE 1, 1	        /* type of service field.  offset 1, 1 byte   */
#define IP_TOTAL_LENGTH 2, 2            /* type of service field.  offset 2, 2 bytes  */
#define IP_IDENTIFICATION 4, 2          /* identification field.   offset 4, 2 bytes  */
#define IP_FLAGS_FRAGMENT 6, 2          /* flags/fragment fields.  offset 6, 2 bytes  */
#define IP_TIME_TO_LIVE 8, 1            /* time to live field.     offset 8, 1 byte   */
#define IP_PROTOCOL 9, 1                /* protocol field.         offset 9, 1 byte   */
#define IP_CHECKSUM 10, 2               /* checksum field.         offset 10, 2 bytes */
#define IP_SOURCE_ADDRESS 12, 4         /* source ip address.      offset 12, 4 bytes */
#define IP_DESTINATION_ADDRESS 16, 4    /* destination ip address. offset 16, 4 bytes */
#define IP_DEST_ADDRESS IP_DESTINATION_ADDRESS  
#define IP_SOURCE_PORT 20, 2            /* source port.            offset 20, 2 bytes */
#define IP_DESTINATION_PORT 22, 2       /* destination port.       offset 22, 2 bytes */
#define TCP_UDP_PORTS 					20, 4

	#define RD_STARTS	2
	#define RD_START	6
	.reg volatile proto_field TOS_field src_address dst_address tcp_udp_prt

		// extract protocol field
		xbuf_extract(proto_field, iphdr, RD_START, IP_PROTOCOL)
		// extract TOS field
		xbuf_extract(TOS_field,   iphdr, RD_START, IP_TYPE_OF_SERVICE)
		// extract the source address
		xbuf_extract(src_address, iphdr, RD_START, IP_SOURCE_ADDRESS)
		// extract the destination address
		xbuf_extract(dst_address, iphdr, RD_START, IP_DESTINATION_ADDRESS)
		// extract tcp / udp ports	
		xbuf_extract(tcp_udp_prt, iphdr, RD_START, TCP_UDP_PORTS)

#endm


#macro ip_test2()
		// extract protocol field
		xbuf_extract(proto_field, iphdr, RD_START, IP_PROTOCOL)
		// extract TOS field
		xbuf_extract(TOS_field,   iphdr, RD_START, IP_TYPE_OF_SERVICE)
		// extract the source address
		xbuf_extract(src_address, iphdr, RD_START, IP_SOURCE_ADDRESS)
		// extract the destination address
		xbuf_extract(dst_address, iphdr, RD_START, IP_DESTINATION_ADDRESS)
		// extract tcp / udp ports	
		xbuf_extract(tcp_udp_prt, iphdr, RD_START, TCP_UDP_PORTS)

#endm

#macro ip_test3()

		// extract protocol field
		xbuf_extract(proto_field, iphdr, RD_STARTS, IP_PROTOCOL)
		// extract TOS field
		xbuf_extract(TOS_field,   iphdr, RD_STARTS, IP_TYPE_OF_SERVICE)
		// extract the source address
		xbuf_extract(src_address, iphdr, RD_STARTS, IP_SOURCE_ADDRESS)
		// extract the destination address
		xbuf_extract(dst_address, iphdr, RD_STARTS, IP_DESTINATION_ADDRESS)
		// extract tcp / udp ports	
		xbuf_extract(tcp_udp_prt, iphdr, RD_STARTS, TCP_UDP_PORTS)

#endm


#macro wred_check()
.begin
.reg tmp1
	br!=byte[dl_next_block, 0, DL_SOURCE_NEXT1, end_of_macro#]

	dl_meta_get_packet_size(tmp1)
	
	alu[@cc, @cc, +, 4]
	local_csr_wr[active_lm_addr_0, @cc]
	nop
	nop
	nop
	alu[*l$index0, --, B, tmp1]

end_of_macro#:	
.end
#endm


#macro test_base()
.begin
.reg reg
#undef	DOWNSTREAM
	move(reg, BUF_SRAM_BASE);
	move(reg, DOWNSTREAM_SRTCM_TABLE_SRAM_BASE);
	move(reg, SRTCM_64BIT_STAT_SRAM_BASE);
	move(reg, DOWNSTREAM_NEXTHOP_TABLE_SRAM_BASE);
	move(reg, QD_SRAM_BASE);
;
	move(reg, (DOWNSTREAM_TRIE_TABLE_SRAM_BASE - 0x40000000));
	move(reg, (DOWNSTREAM_STATS_TABLE_SRAM_BASE - 0x40000000));
	move(reg, (DOWNSTREAM_DBCAST_TABLE_SRAM_BASE - 0x40000000));
	move(reg, (DOWNSTREAM_CONTROL_BLOCK_SRAM_BASE - 0x40000000));
	move(reg, (PACKET_COUNTERS_SRAM_BASE - 0x40000000));
	move(reg, (SRAM_FLT_TABLE_BASE - 0x40000000));
	move(reg, (SRAM_PORT_BIT_MAP_BASE - 0x40000000));
	move(reg, (VC_HASH_PRI_BASE_SRAM - 0x40000000));
	move(reg, (VC_HASH_SEC_BASE_SRAM - 0x40000000));
;
	move(reg, (UPSTREAM_SRTCM_TABLE_SRAM_BASE - 0x80000000));
	move(reg, (UPSTREAM_SRTCM_64BIT_STAT_SRAM_BASE - 0x80000000));
	move(reg, (UPSTREAM_NEXTHOP_TABLE_SRAM_BASE - 0x80000000));
	move(reg, (UPSTREAM_QD_SRAM_BASE - 0x80000000));
	move(reg, (PACKET_TX_COUNTER_BASE - 0x80000000));
	move(reg, (AAL5_RX_PORT_STAT_SRAM_BASE - 0x80000000));
	move(reg, (AAL5_RX_VC_INFO_SRAM_BASE - 0x80000000));
	move(reg, (AAL5_TX_CTX_SRAM_BASE - 0x80000000));
	move(reg, (AAL5_TX_COUNTER_BASE - 0x80000000));
;
	move(reg, (UPSTREAM_TRIE_TABLE_SRAM_BASE - 0xc0000000));
	move(reg, (UPSTREAM_STATS_TABLE_SRAM_BASE - 0xc0000000));
	move(reg, (UPSTREAM_DBCAST_TABLE_SRAM_BASE - 0xc0000000));
	move(reg, (UPSTREAM_CONTROL_BLOCK_SRAM_BASE - 0xc0000000));
	move(reg, (GCRA_PARAM_SRAM_BASE - 0xc0000000));
	move(reg, (HBR_TQ_SRAM_BASE - 0xc0000000));
	move(reg, (HBR_TQ_SRAM_INDICATOR - 0xc0000000));
	move(reg, (RTQLEN_SRAM_BASE - 0xc0000000));
	move(reg, (NRTQLEN_SRAM_BASE - 0xc0000000));
	move(reg, (RTQ_SRAM_BASE - 0xc0000000));
	move(reg, (NRTQ_SRAM_BASE - 0xc0000000));
	move(reg, (IPQ_RING_SRAM_BASE_MIN - 0xc0000000));
	move(reg, (L2BRIDGE_VLANPORT_SRAM_BASE - 0xc0000000));
	move(reg, (L2BRIDGE_FDBS_SRAM_BASE - 0xc0000000));
	move(reg, (L2BRIDGE_VLAN_SRAM_BASE - 0xc0000000));
	move(reg, (L2BRIDGE_L2PORT_SRAM_BASE - 0xc0000000));

#define	DOWNSTREAM

.end
#endm
/*******************************  FILE HISTORY  *******************************
 * \main\1 Wed Aug 13 14:03:25 2003 adziecia 
 * IGK0100025024: ATM-IPV4-ETH: simulation project check-in 
 *  
 * \main\1 Mon Jan  6 10:53:08 2003 cwierucx 
 * Initial checkin for Lime Point OC12 DSLAM ETH 
 *  
 * \main\3 Thu Oct 17 11:56:50 2002 szawadzx 
 * Modified wred_check and fwd_check macros 
 *  
 * \main\2 Mon Oct 14 16:32:10 2002 szawadzx 
 * Added another macro for tests 
 *  
 * \main\1 Tue Oct  8 16:42:19 2002 szawadzx
 * Initial version 
 *  
 *****************************************************************************/
