/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2003 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor
 *
 * = LIBRARY
 *
 *
 * = MODULE
 *      SAR CTRL configuration file
 *
 * = FILENAME
 *      ix_cc_sarctrl_config.c
 *
 * = DESCRIPTION
 *      The file defines list of SOFT SAR core components serviced by the
 *      SAR Control module. The file can contain definition of variables
 *      ix_cc_sarctrl_cfg_egress or ix_cc_sarctrl_cfg_ingress.
 *      The file contains one of the variables if SOFT SAR works on two IXP.
 *      Or it contains both for SOFT SAR working on single IXP hardware
 *      enviroment. For single IXP, aditional compilation flag
 *      SARCTRL_WITHOUT_AGENT is set.
 *
 * = AUTHOR
 *       Jaroslaw Kogut
 *       jaroslaw.kogut@intel.com
 *
 * = AKNOWLEDGEMENTS
 *
 *
 * = CREATION TIME
 *
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 */
#define IX_ERROR_FILE_IDENT "$Id: ix_cc_sarctrl_config.c,v 1.1.2.1 2004/03/11 17:43:10 ksandowi Exp $";

/**
 * System defined include files
 */
/*#include "ix_types.h"*/
#include "bindings.h"

/**
 * User defined include files
 */
#include "ix_cc_sarctrl_plugin.h"
#include "ix_cc_sarctrl_config.h"

IX_CC_SARCTRL_CFG_PLUGIN_AGENT
IX_CC_SARCTRL_CFG_PLUGIN_END

IX_CC_SARCTRL_CFG_PLUGIN_MAIN
IX_CC_SARCTRL_CFG_PLUGIN_ENTRY(IX_CC_ATMRX),
IX_CC_SARCTRL_CFG_PLUGIN_ENTRY(IX_CC_ATMTX),
IX_CC_SARCTRL_CFG_PLUGIN_ENTRY(IX_CC_ATMTM41),
IX_CC_SARCTRL_CFG_PLUGIN_END


