# ============================================================================
#  INTEL CONFIDENTIAL
#
#  Copyright 2003 Intel Corporation All Rights Reserved.
#
#  The source code contained or described herein and all documents related to
#  the source code ("Material") are owned by Intel Corporation or its 
#  suppliers or licensors.
#
#  Title to the Material remains with Intel Corporation or its suppliers and
#  licensors. The Material contains trade secrets and proprietary and
#  confidential information of Intel or its suppliers and licensors.
#  The Material is protected by worldwide copyright and trade secret laws and
#  treaty provisions. No part of the Material may be used, copied, reproduced,
#  modified, published, uploaded, posted, transmitted, distributed,
#  or disclosed in any way without Intel's prior express written permission.
#
#  No license under any patent, copyright, trade secret or other intellectual
#  property right is granted to or conferred upon you by disclosure
#  or delivery of the Materials, either expressly, by implication, inducement,
#  estoppel or otherwise. Any license under such intellectual property rights
#  must be express and approved by Intel in writing.
#
# ============================================================================
# = PRODUCT
#      Intel(r) IXA SDK for the IXP2X00 Network Processor
#
# = FILENAME
#      pos_eth_rtm_config_linux.sh
#
# = DESCRIPTION
#      This file contains scripts to configure the oc12_pos_gbeth_2401
#      application on an IXPD2401 platform.
#
# = CHANGE HISTORY
#      02/26/2003      Created
# ============================================================================
#


# 16-bit routes - Forward
#-----------------------------------------------

./rconfig addRoute "16.0.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "1 1 FFFE 0 1500 0 16.1.0.10 0"
./rconfig addRoute "16.1.0.0 255.255.0.0 1"
./rconfig addRoute "16.1.0.0 255.255.255.255 FFFFFFFD"

./rconfig addNextHop "2 1 FFFE 1 1500 0 16.2.0.10 0"
./rconfig addRoute "16.2.0.0 255.255.0.0 2"
./rconfig addRoute "16.2.0.0 255.255.255.255 FFFFFFFD"

# Use either addV4L3Info or addV4EthEntry. The former adds only IP address and
# learns MAC address from ARP.
#./l2config addV4L3Info "1 16.3.0.10"
./l2config addV4EthEntry "1 16.3.0.1 00:07:e9:09:03:02 02:01:02:03:00:03 DEFAULT"
./rconfig addNextHop "3 1 1 2 1500 0 16.3.0.10 0"
./rconfig addRoute "16.3.0.0 255.255.0.0 3"
./rconfig addRoute "16.3.0.0 255.255.255.255 FFFFFFFD"

#./l2config addV4L3Info "2 16.4.0.10"
./l2config addV4EthEntry "2 16.4.0.1 00:07:e9:09:03:02 02:01:02:03:00:04 DEFAULT"
./rconfig addNextHop "4 1 2 3 1500 0 16.4.0.10 0"
./rconfig addRoute "16.4.0.0 255.255.0.0 4"
./rconfig addRoute "16.4.0.0 255.255.255.255 FFFFFFFD"

# Directed broadcast - Exception
#-----------------------------------------------
./rconfig addNextHop "5 1 3 2 1500 8 16.3.255.255 0"
./rconfig addRoute "16.3.255.255 255.255.255.255 5"
./l2config addV4EthEntry "3 16.3.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:03 DEFAULT"

./rconfig addNextHop "6 1 4 3 1500 8 16.4.255.255 0"
./rconfig addRoute "16.4.255.255 255.255.255.255 6"
./l2config addV4EthEntry "4 16.4.255.255 ff:ff:ff:ff:ff:ff 02:01:02:03:00:04 DEFAULT"

# Configuration successful
#-----------------------------------------------















