/*******************************************************************************
  INTEL CONFIDENTIAL

  Copyright 2003 Intel Corporation All Rights Reserved.

  The source code contained or described herein and all documents related to
  the source code ("Material") are owned by Intel Corporation or its 
  suppliers or licensors.

  Title to the Material remains with Intel Corporation or its suppliers and
  licensors. The Material contains trade secrets and proprietary and
  confidential information of Intel or its suppliers and licensors.
  The Material is protected by worldwide copyright and trade secret laws and
  treaty provisions. No part of the Material may be used, copied, reproduced,
  modified, published, uploaded, posted, transmitted, distributed,
  or disclosed in any way without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure
  or delivery of the Materials, either expressly, by implication, inducement,
  estoppel or otherwise. Any license under such intellectual property rights
  must be express and approved by Intel in writing.

*******************************************************************************/
/**
 * ============================================================================
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      spi23_to_front.c
 *
 * = DESCRIPTION
 *      This file contains functions to initialize the oc12_pos_gbeth_2401
 *      application on an IXPD2401 platform.
 *
 * = CHANGE HISTORY
 *      06/24/2003      Created
 * ============================================================================
 */
#include <stdio.h>
#include <memory.h>
#include <string.h>

#include "linux_mmap_lib.h"


int main(int argc, char **argv)
{

    unsigned int value;
    
    printf("Changing output of SPI2 and SPI3 to front interfaces.\n");

    printf("Initializing IND library.\n");
    ind_lib_start();

    value = get_slow_port(0xc6024018);

    printf("Register 0xc6024018 value is 0x%08x\n", value);

    value |= 0x100;

    printf("New value: 0x%08x\n",value);

    set_slow_port(0xc6024018,value);
    
    printf("Finishing IND library.\n");
    
    ind_lib_end();

    return 0;
}




