/*
 *
 *                  I N T E L   P R O P R I E T A R Y
 *
 *     COPYRIGHT (c)  2002 BY  INTEL  CORPORATION.  ALL RIGHTS
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT
 *     THE PRIOR WRITTEN PERMISSION OF :
 *
 *                        INTEL  CORPORATION
 *
 *                     2200 MISSION COLLEGE BLVD
 *
 *               SANTA  CLARA,  CALIFORNIA  95052-8119
 *
 */

#ifndef __DL_SOURCE_C__
#define __DL_SOURCE_C__


#include <dl_system.h>
#include <dl_buf.c>					// XXX should become dl_buf.h

#define INLINE static __forceinline

/*
* Funtion to be called by csix_rx. 
*/
INLINE 
dl_sink(
		dl_buf_handle_t sop_buf,
		dl_buf_handle_t	eop_buf,
		unsigned int 	class,
		unsigned int	port,
		unsigned int	ring,
		SIGNAL_MASK		sig_mask )
{
	__declspec(sram_write_reg) int sink_wr[3];
	SIGNAL	sig_scr_wr;


	sink_wr[0] = sop_buf.value;
	sink_wr[1] = eop_buf.value;


	//	XXX Why is ATM_TX here ???

	//	if port and class are zero, we still need make sure what we produce on
	//	scratch sring is never zero. So set MSB to 1 always.
	//	XXX - We can do away with this step. Also find out the width (bits) of port.
	//	

#ifdef	ATM_TX

	sink_wr[2] = (port << 4) | (class & 0xf) | 0x80000000;	// [31:4] port, [3:0] class

#else

	sink_wr[2] = class | 0x80000000;
	(void) port;								// unused. suppress warning.

#endif

	scratch_put_ring(sink_wr, (volatile void __declspec(scratch) *)ring, 3, sig_done, &sig_scr_wr);

	sig_mask |= 1 << __signal_number(&sig_scr_wr);
	wait_for_all(sig_mask);

	__implicit_read(&sig_scr_wr);
	__implicit_read(&sink_wr);
	
	return ;
}

#endif	// __DL_SOURCE_C__

