//------------------------------------------------------------------------------------
//                                                                      
//                   I N T E L   P R O P R I E T A R Y                   
//                                                                       
//      COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
//      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//      THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                       
//                         INTEL  CORPORATION                            
//                                                                      
//                      2200 MISSION COLLEGE BLVD                        
//                                                                       
//                SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                       
//------------------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
//
//
//      File Name: 	dl_source.h
//
//      Purpose: 	This file contains the system wide parameters that can be 
//					customised for a given hardware/application 
//
//
/////////////////////////////////////////////////////////////////////////////
#ifndef	__DL_SOURCE_H__
#define	__DL_SOURCE_H__

#include <dl_system.h>
#include <dl_buf.h>

/*
* Function prototypes.
*/

void
dl_sink(dl_buf_handle_t sop_buf, dl_buf_handle_t eop_buf, unsigned int class,
		unsigned int	port, unsigned int ring, SIGNAL_MASK sig_mask);


#define dl_source(sram_rdx, ring, sig_scr)									\
				scratch_get_ring(											\
								sram_rdx, 									\
								(volatile void __declspec(scratch) *) ring,	\
								3, sig_done, sig_scr)


/*
*	data is write xfer reg. Shoudd be [3].
*	ring is ring number. Can be a variable 
*	ring_full is a constant. This is the inp_state CSR.
*	sig_scr_wr is a signal number. (it can be &sig) 
*/

#define dl_qm_sink(data, ring, ring_full, sig_scr_wr)		\
					do 										\
					{										\
						int ring_state ;					\
															\
							do								\
							{								\
								ring_state = inp_state_test(ring_full); \
															\
							} while (ring_state);			\
															\
							scratch_put_ring(data, (volatile void __declspec(scratch) *)ring, 3, sig_done, sig_scr_wr); \
															\
					} while (0);



#endif	// __DL_SOURCE_H__