#include <dl_system.h>
#include <dl_buf.c>
#include <dl_meta.c>
#include <sig_functions.c>

void system_init()
{
	// Initialise the various scratch rings used in the egress pipeline
	InitScratchRing(L2_ENCAP_SOURCE_SCR_RING_BASE, L2_ENCAP_SOURCE_SCR_RING_SIZE, L2_ENCAP_SOURCE_SCR_RING);	
	InitScratchRing(L2_ENCAP_SINK_SCR_RING_BASE, L2_ENCAP_SINK_SCR_RING_SIZE, L2_ENCAP_SINK_SCR_RING);
	InitScratchRing(SCHEDULER_TO_QM_SCR_RING_BASE, SCHEDULER_TO_QM_SCR_RING_SIZE, SCHEDULER_TO_QM_SCR_RING);
	InitScratchRing(QM_TO_PACKET_TX_SCR_RING_0_BASE, QM_TO_PACKET_TX_SCR_RING_0_SIZE, QM_TO_PACKET_TX_SCR_RING_0);
	InitScratchRing(QM_TO_PACKET_TX_SCR_RING_1_BASE, QM_TO_PACKET_TX_SCR_RING_1_SIZE, QM_TO_PACKET_TX_SCR_RING_1);
	InitScratchRing(QM_TO_PACKET_TX_SCR_RING_2_BASE, QM_TO_PACKET_TX_SCR_RING_2_SIZE, QM_TO_PACKET_TX_SCR_RING_2);
	InitScratchRing(QM_TO_PACKET_TX_SCR_RING_3_BASE, QM_TO_PACKET_TX_SCR_RING_3_SIZE, QM_TO_PACKET_TX_SCR_RING_3);

	// Initialise the free buffer list

	Dl_BufInit();

	//	To ease debugging. Not absoultely essential for proper execution.

	//init_meta_cache_to_zero[]		; all the dl_meta* gprs will be set to 0.

	//	signal all MEs, except ME 0 (ME0 is running CSIX RX & this code)

	signal_me(0x01, ME_INIT_SIGNAL);		// ME 1
	signal_me(0x02, ME_INIT_SIGNAL);		// ME 2
	signal_me(0x03, ME_INIT_SIGNAL);		// ME 3

	// The Next 4 MEs are in Cluster 1. 

	signal_me(0x10, ME_INIT_SIGNAL);		// ME 4
	signal_me(0x11, ME_INIT_SIGNAL);		// ME 5 
	signal_me(0x12, ME_INIT_SIGNAL);		// ME 6 

}