/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      bindings.h
 *
 * = DESCRIPTION
 *      Defines communication ids for core components and maps output id of the component with
 *      input of the receiving component
 *
 * = CHANGE HISTORY
 *      8/15/2002 - Created
 **/

#if !defined(__BINDINGS_H__)
#define __BINDINGS_H__



/* MICROBLOCKS COMID's */

#define			BID_NULL						UC_NULL		// NULL Block ID
#define			BID_EXCEPTION					0x1			// Exception Block ID
#define			BID_DROP						0x2			// Drop Block ID



//	Block IDs for various blocks. Block IDs Start from 0x20. (0 to 0x1f and 0xFF are 
//	reserved for IX_* )

#define			BID_POS							0x21
#define			BID_IPV4						0x22
#define			BID_QM							0x23
#define 		BID_ETHER						0x24
#define			BID_IPV6						0x25
#define			BID_ARP							0x26
#define			BID_ETHER_PPP_DISCOVERY			0x27
#define			BID_ETHER_PPP_SESSION			0x28

/* End of IPv4 OUTPUT ID definitions*/

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__BINDINGS_H__) */

