

#define	TRIE_WRITE(a,b)		set_sram((a),(b))

#define	NH_WRITE(a,b)	set_sram((a),(b))



int l3_create_routes(void) {

void * trie_base = SRAM_LOOKUP_BASE;
void * nh_base = SRAM_NEXTHOP_BASE;

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x0,0x0);

/* blade 0x0 and NH 0xffff, NH id type = 0x0 */

NH_WRITE(nh_base + 0x4,0xffff);



/* #=======================================================================
 */ /* # Assumption :-							 
 */ /* #=======================================================================
 */ /* #	This AI's Ingress Blade_id = 0x3f
 */ /* #	Angel Island has one port (port = 0x0)
 */ /* #
 */ /* #=======================================================================
 */ /* # Flags specify the quick-action to be carried on the packet.		
 */ /* # Flags have higher priority to anything in IPv4.				
 */ /* #=======================================================================
 */ /* #
 */ /* #  The bit positions are relative to the starting bit position = 0.
 */ /* #
 */ /* #    Bit pos  	Flag val  Desc		Action
 */ /* #   --------------------------------------------------------------------
 */ /* #	0	0x1	Local		Exception
 */ /* #	1	0x2	I/f Down	Exception
 */ /* #	2	0x4	Drop		Drop
 */ /* #	3	0x8	Broadcast	Exception
 */ /* #	4	0x10	Multicast	Exception
 */ /* #		0x0	Forward		Forward
 */ /* #
 */ /* #=======================================================================
 */ /* #       TEST  CASES 							 
 */ /* #=======================================================================
 */ /* #-----------------------------------------------
 */ /* # 32-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x20000001, mask = 0xffffffff, blade_nh_id=0x1,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40504,0x10000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x10,0x0);

/* blade 0x0 and NH 0x1, NH id type = 0x0 */

NH_WRITE(nh_base + 0x14,0x1);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x18,0x23fc0000);


NH_WRITE(nh_base + 0x1c,0x0);


	TRIE_WRITE(trie_base + 0x404c0,0x4);


	TRIE_WRITE(trie_base + 0x40480,0x3);


	TRIE_WRITE(trie_base + 0x40440,0x2);


	TRIE_WRITE(trie_base + 0x8000,0x1);


/* @@@ Adding dest=0x20000002, mask = 0xffffffff, blade_nh_id=0x1000002,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40508,0x20000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x20,0x0);

/* blade 0x1 and NH 0x2, NH id type = 0x0 */

NH_WRITE(nh_base + 0x24,0x1000002);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x28,0x23fc0000);


NH_WRITE(nh_base + 0x2c,0x0);


/* @@@ Adding dest=0x20000003, mask = 0xffffffff, blade_nh_id=0x2000003,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4050c,0x30000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x30,0x0);

/* blade 0x2 and NH 0x3, NH id type = 0x0 */

NH_WRITE(nh_base + 0x34,0x2000003);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x38,0x23fc0000);


NH_WRITE(nh_base + 0x3c,0x0);


/* @@@ Adding dest=0x20000004, mask = 0xffffffff, blade_nh_id=0x3000004,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40510,0x40000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x40,0x0);

/* blade 0x3 and NH 0x4, NH id type = 0x0 */

NH_WRITE(nh_base + 0x44,0x3000004);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x48,0x23fc0000);


NH_WRITE(nh_base + 0x4c,0x0);


/* @@@ Adding dest=0x20000005, mask = 0xffffffff, blade_nh_id=0x4000005,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40514,0x50000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x50,0x0);

/* blade 0x4 and NH 0x5, NH id type = 0x0 */

NH_WRITE(nh_base + 0x54,0x4000005);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x58,0x23fc0000);


NH_WRITE(nh_base + 0x5c,0x0);


/* @@@ Adding dest=0x20000006, mask = 0xffffffff, blade_nh_id=0x5000006,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40518,0x60000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x60,0x0);

/* blade 0x5 and NH 0x6, NH id type = 0x0 */

NH_WRITE(nh_base + 0x64,0x5000006);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x68,0x23fc0000);


NH_WRITE(nh_base + 0x6c,0x0);


/* @@@ Adding dest=0x20000007, mask = 0xffffffff, blade_nh_id=0x6000007,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4051c,0x70000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x70,0x0);

/* blade 0x6 and NH 0x7, NH id type = 0x0 */

NH_WRITE(nh_base + 0x74,0x6000007);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x78,0x23fc0000);


NH_WRITE(nh_base + 0x7c,0x0);


/* @@@ Adding dest=0x20000008, mask = 0xffffffff, blade_nh_id=0x7000008,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40520,0x80000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x80,0x0);

/* blade 0x7 and NH 0x8, NH id type = 0x0 */

NH_WRITE(nh_base + 0x84,0x7000008);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x88,0x23fc0000);


NH_WRITE(nh_base + 0x8c,0x0);


/* @@@ Adding dest=0x20000009, mask = 0xffffffff, blade_nh_id=0x8000009,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40524,0x90000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x90,0x0);

/* blade 0x8 and NH 0x9, NH id type = 0x0 */

NH_WRITE(nh_base + 0x94,0x8000009);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x98,0x23fc0000);


NH_WRITE(nh_base + 0x9c,0x0);


/* @@@ Adding dest=0x2000000a, mask = 0xffffffff, blade_nh_id=0x900000a,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40528,0xa0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xa0,0x0);

/* blade 0x9 and NH 0xa, NH id type = 0x0 */

NH_WRITE(nh_base + 0xa4,0x900000a);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0xa8,0x23fc0000);


NH_WRITE(nh_base + 0xac,0x0);


/* @@@ Adding dest=0x2000000b, mask = 0xffffffff, blade_nh_id=0xa00000b,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4052c,0xb0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xb0,0x0);

/* blade 0xa and NH 0xb, NH id type = 0x0 */

NH_WRITE(nh_base + 0xb4,0xa00000b);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0xb8,0x23fc0000);


NH_WRITE(nh_base + 0xbc,0x0);


/* @@@ Adding dest=0x2000000c, mask = 0xffffffff, blade_nh_id=0xb00000c,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40530,0xc0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xc0,0x0);

/* blade 0xb and NH 0xc, NH id type = 0x0 */

NH_WRITE(nh_base + 0xc4,0xb00000c);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0xc8,0x23fc0000);


NH_WRITE(nh_base + 0xcc,0x0);

/* #-----------------------------------------------
 */ /* # 8-bit routes  - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x8000000, mask = 0xff000000, blade_nh_id=0x2000011,mtu_port=0x23e80000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40020,0xd0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xd0,0x0);

/* blade 0x2 and NH 0x11, NH id type = 0x0 */

NH_WRITE(nh_base + 0xd4,0x2000011);

/* MTU is 9192, outport is 0x0 */ 

NH_WRITE(nh_base + 0xd8,0x23e80000);


NH_WRITE(nh_base + 0xdc,0x0);

/* #-----------------------------------------------
 */ /* # 11-bit routes  - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0xb200000, mask = 0xffe00000, blade_nh_id=0x1000012,mtu_port=0x23e80000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40548,0xe0000);


	TRIE_WRITE(trie_base + 0x4054c,0xe0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xe0,0x0);

/* blade 0x1 and NH 0x12, NH id type = 0x0 */

NH_WRITE(nh_base + 0xe4,0x1000012);

/* MTU is 9192, outport is 0x0 */ 

NH_WRITE(nh_base + 0xe8,0x23e80000);


NH_WRITE(nh_base + 0xec,0x0);


	TRIE_WRITE(trie_base + 0x4002c,0x5);

/* #-----------------------------------------------
 */ /* # 15-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0xf020000, mask = 0xfffe0000, blade_nh_id=0x2000013,mtu_port=0x23e80000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x405c8,0xf0000);


	TRIE_WRITE(trie_base + 0x405cc,0xf0000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0xf0,0x0);

/* blade 0x2 and NH 0x13, NH id type = 0x0 */

NH_WRITE(nh_base + 0xf4,0x2000013);

/* MTU is 9192, outport is 0x0 */ 

NH_WRITE(nh_base + 0xf8,0x23e80000);


NH_WRITE(nh_base + 0xfc,0x0);


	TRIE_WRITE(trie_base + 0x40580,0x7);


	TRIE_WRITE(trie_base + 0x4003c,0x6);

/* #-----------------------------------------------
 */ /* # 16-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x10010000, mask = 0xffff0000, blade_nh_id=0x1000014,mtu_port=0x23fc0000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40644,0x100000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x100,0x0);

/* blade 0x1 and NH 0x14, NH id type = 0x0 */

NH_WRITE(nh_base + 0x104,0x1000014);

/* MTU is 9212, outport is 0x0 */ 

NH_WRITE(nh_base + 0x108,0x23fc0000);


NH_WRITE(nh_base + 0x10c,0x0);


	TRIE_WRITE(trie_base + 0x40600,0x9);


	TRIE_WRITE(trie_base + 0x40040,0x8);

/* #-----------------------------------------------
 */ /* # 20-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x14001000, mask = 0xfffff000, blade_nh_id=0x10000015,mtu_port=0x23e80000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40684,0x110000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x110,0x0);

/* blade 0x10 and NH 0x15, NH id type = 0x0 */

NH_WRITE(nh_base + 0x114,0x10000015);

/* MTU is 9192, outport is 0x0 */ 

NH_WRITE(nh_base + 0x118,0x23e80000);


NH_WRITE(nh_base + 0x11c,0x0);


	TRIE_WRITE(trie_base + 0x5000,0xa);

/* #-----------------------------------------------
 */ /* # 24-bit routes - Forward			 
 */ /* #-----------------------------------------------
 */ 
/* @@@ Adding dest=0x18000100, mask = 0xffffff00, blade_nh_id=0x1000016,mtu_port=0x23e80000,flags=0x0,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40704,0x120000);

/* writing nexthop entry with flags 0x0 */ 

NH_WRITE(nh_base + 0x120,0x0);

/* blade 0x1 and NH 0x16, NH id type = 0x0 */

NH_WRITE(nh_base + 0x124,0x1000016);

/* MTU is 9192, outport is 0x0 */ 

NH_WRITE(nh_base + 0x128,0x23e80000);


NH_WRITE(nh_base + 0x12c,0x0);


	TRIE_WRITE(trie_base + 0x406c0,0xc);


	TRIE_WRITE(trie_base + 0x6000,0xb);

/* #-----------------------------------------------
 */ /* # bunch of invalid destination addresses
 */ /* #-----------------------------------------------
 */ /* # drop if dst==0
 */ 
/* @@@ Adding dest=0x0, mask = 0xff000000, blade_nh_id=0x500beef,mtu_port=0x23fc0005,flags=0x4,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40000,0x130000);

/* writing nexthop entry with flags 0x4 */ 

NH_WRITE(nh_base + 0x130,0x4);

/* blade 0x5 and NH 0xbeef, NH id type = 0x0 */

NH_WRITE(nh_base + 0x134,0x500beef);

/* MTU is 9212, outport is 0x5 */ 

NH_WRITE(nh_base + 0x138,0x23fc0005);


NH_WRITE(nh_base + 0x13c,0x0);

/* # drop if dst==127.*
 */ 
/* @@@ Adding dest=0x7f000000, mask = 0xff000000, blade_nh_id=0x500beef,mtu_port=0x23fc0005,flags=0x4,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x401fc,0x140000);

/* writing nexthop entry with flags 0x4 */ 

NH_WRITE(nh_base + 0x140,0x4);

/* blade 0x5 and NH 0xbeef, NH id type = 0x0 */

NH_WRITE(nh_base + 0x144,0x500beef);

/* MTU is 9212, outport is 0x5 */ 

NH_WRITE(nh_base + 0x148,0x23fc0005);


NH_WRITE(nh_base + 0x14c,0x0);

/* # drop if dst==classE
 */ 
/* @@@ Adding dest=0xf0000000, mask = 0xf0000000, blade_nh_id=0x500beef,mtu_port=0x23fc0005,flags=0x4,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x403c0,0x150000);


	TRIE_WRITE(trie_base + 0x403c4,0x150000);


	TRIE_WRITE(trie_base + 0x403c8,0x150000);


	TRIE_WRITE(trie_base + 0x403cc,0x150000);


	TRIE_WRITE(trie_base + 0x403d0,0x150000);


	TRIE_WRITE(trie_base + 0x403d4,0x150000);


	TRIE_WRITE(trie_base + 0x403d8,0x150000);


	TRIE_WRITE(trie_base + 0x403dc,0x150000);


	TRIE_WRITE(trie_base + 0x403e0,0x150000);


	TRIE_WRITE(trie_base + 0x403e4,0x150000);


	TRIE_WRITE(trie_base + 0x403e8,0x150000);


	TRIE_WRITE(trie_base + 0x403ec,0x150000);


	TRIE_WRITE(trie_base + 0x403f0,0x150000);


	TRIE_WRITE(trie_base + 0x403f4,0x150000);


	TRIE_WRITE(trie_base + 0x403f8,0x150000);


	TRIE_WRITE(trie_base + 0x403fc,0x150000);

/* writing nexthop entry with flags 0x4 */ 

NH_WRITE(nh_base + 0x150,0x4);

/* blade 0x5 and NH 0xbeef, NH id type = 0x0 */

NH_WRITE(nh_base + 0x154,0x500beef);

/* MTU is 9212, outport is 0x5 */ 

NH_WRITE(nh_base + 0x158,0x23fc0005);


NH_WRITE(nh_base + 0x15c,0x0);

/* #------------------------------------------------
 */ /* # bunch of local delivery destination addresses
 */ /* #-------------------------------------------------
 */ /* # multicast
 */ 
/* @@@ Adding dest=0xe0000000, mask = 0xf0000000, blade_nh_id=0x2000000,mtu_port=0x23e80001,flags=0x10,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x40380,0x160000);


	TRIE_WRITE(trie_base + 0x40384,0x160000);


	TRIE_WRITE(trie_base + 0x40388,0x160000);


	TRIE_WRITE(trie_base + 0x4038c,0x160000);


	TRIE_WRITE(trie_base + 0x40390,0x160000);


	TRIE_WRITE(trie_base + 0x40394,0x160000);


	TRIE_WRITE(trie_base + 0x40398,0x160000);


	TRIE_WRITE(trie_base + 0x4039c,0x160000);


	TRIE_WRITE(trie_base + 0x403a0,0x160000);


	TRIE_WRITE(trie_base + 0x403a4,0x160000);


	TRIE_WRITE(trie_base + 0x403a8,0x160000);


	TRIE_WRITE(trie_base + 0x403ac,0x160000);


	TRIE_WRITE(trie_base + 0x403b0,0x160000);


	TRIE_WRITE(trie_base + 0x403b4,0x160000);


	TRIE_WRITE(trie_base + 0x403b8,0x160000);


	TRIE_WRITE(trie_base + 0x403bc,0x160000);

/* writing nexthop entry with flags 0x10 */ 

NH_WRITE(nh_base + 0x160,0x10);

/* blade 0x2 and NH 0x0, NH id type = 0x0 */

NH_WRITE(nh_base + 0x164,0x2000000);

/* MTU is 9192, outport is 0x1 */ 

NH_WRITE(nh_base + 0x168,0x23e80001);


NH_WRITE(nh_base + 0x16c,0x0);

/* # limited broadcast
 */ 
/* @@@ Adding dest=0xffffffff, mask = 0xffffffff, blade_nh_id=0x2000000,mtu_port=0x23e80001,flags=0x8,nhid_type=0x0 */

	TRIE_WRITE(trie_base + 0x4083c,0x170000);

/* writing nexthop entry with flags 0x8 */ 

NH_WRITE(nh_base + 0x170,0x8);

/* blade 0x2 and NH 0x0, NH id type = 0x0 */

NH_WRITE(nh_base + 0x174,0x2000000);

/* MTU is 9192, outport is 0x1 */ 

NH_WRITE(nh_base + 0x178,0x23e80001);


NH_WRITE(nh_base + 0x17c,0x0);


	TRIE_WRITE(trie_base + 0x407fc,0x10);


	TRIE_WRITE(trie_base + 0x407bc,0xf);


	TRIE_WRITE(trie_base + 0x4077c,0xe);


	TRIE_WRITE(trie_base + 0x3fffc,0xd);

return 1;


}
