/*---------------------------------------------------------------------
 *                                                                     
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                       
 *      COPYRIGHT (c)  2001 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *      RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *      BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *      RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *      LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *      MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *      THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                       
 *                         INTEL  CORPORATION                            
 *                                                                      
 *                      2200 MISSION COLLEGE BLVD                        
 *                                                                       
 *                SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                       
 *---------------------------------------------------------------------
 *
 *        File Name: dl_system.h
 *
 *        Purpose: This file contains system wide parameters
 *                 that are customized for a given application.
 *
 *        History:
 *
 *        Date            Comment                         By
 *        ---------------------------------------------------------------
 *
 *        11/11/2002      Created                         asv
 *
 *-------------------------------------------------------------------*/
#ifndef	__DL_SYSTEM__H__
#define	__DL_SYSTEM__H__

/* Define chip. */
#ifndef IXP2800
#define IXP2800
#endif

/* Define project as microcode based. */
#ifndef IXP_MICROCODE
#define IXP_MICROCODE
#endif

/* Transmission mode */
/* Use default defined by dl_egress_system_default_2800.h */


/* Split LW0-6 and LW7 of meta-data */
/* Channel 3 contains LW0-6 of meta-data. */
/* Channel 0 contains LW7 of meta-data. */
#define	DL_SPLIT_META_DATA

#ifdef	DL_SPLIT_META_DATA

/* Define the LW of meta-data where the split occurs */
#define	BUF_SRAM_SPLIT_LW			7

/* Define the channel number containing the first half of meta-data */
/* This channel will store LW 0 to (BUF_SRAM_SPLIT_LW - 1) of meta-data */
#define	BUF_SRAM_DEFAULT_CHANNEL	3

/* Define the channel number containing the second half of meta-data */
/* This channel will store LW (BUF_SRAM_SPLIT_LW) to 7 of meta-data */
#define	BUF_SRAM_SPLIT_CHANNEL		0

#endif /* DL_SPLIT_META_DATA */


#define		STATS_RING_IN_IND
#define 	STATS_RING_IN				ETHERNET_ARP_TO_STATS_SCR_RING
#define		STATS_RING_IN_BASE			ETHERNET_ARP_TO_STATS_SCR_RING_BASE
#define		STATS_RING_IN_SIZE			ETHERNET_ARP_TO_STATS_SCR_RING_SIZE

/* Include default settings. */


/* This file is also used by script files that setup the system when run 
 * in simulation mode. When symbol IXP_SCRIPTS is defined, it indicates
 * that scripts are using this file. Since script files cannot access
 * path definitions, they should not encounter '#include <file>'. Instead
 * they include the <file> using Simulation -> Options -> Startup.
 */
#ifndef IXP_SCRIPTS
#include <dl_egress_system_default_2800.h>
#endif

#endif	/* __DL_SYSTEM__H__ */
