/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a licence agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      xscale-common.h
 *
 * = DESCRIPTION
 *      Contain all the common hash defines that are used in the xscale-init code
 *
 * = AUTHOR
 *      Manohar Castelino
 *      manohar.r.castelino@intel.com
 *
 * = CHANGE HISTORY
 *      06/11/2003 - Created
 * ============================================================================
 */
#ifndef _XSCALE_COMMON_H_
#define _XSCALE_COMMON_H_

#define SPLIT_IPV6_TRIE_TABLE

#define IXP_SCRIPTS
#define	IXP_XSCALE
#include "..\ingress\wbench_project\dispatch_loop\dl_system.h"
#include "..\..\..\..\library\microblocks_library\include\dl_ingress_system_default_2800.h"

/* Macros to read and write one longword from memory.
 * The macro assumes that the memory being read or written is mapped.
 */
#define GET32(address)			(*(volatile unsigned int *)(address))
#define PUT32(address,val)		(*(volatile unsigned int *)(address) = (val))

#define set_sram(address,val) 	PUT32(address,val)
#define get_sram(address)		GET32(address)

#define	SRAM_WRITE(a,b)			set_sram((a),(b))
#define	SDRAM_WRITE(a,b)		set_sram((a),(b))

#define get_scratch(address) 	GET32(address)
#define set_scratch(address,val)PUT32(address,val)

#define log2(x)			2

#endif
