/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a licence agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      xscale-common.h
 *
 * = DESCRIPTION
 *      Contain all the common hash defines that are used in the xscale-init code
 *
 * = AUTHOR
 *      Manohar Castelino
 *      manohar.r.castelino@intel.com
 *
 * = CHANGE HISTORY
 *      06/11/2003 - Created
 * ============================================================================
 */
#ifndef _XSCALE_COMMON_H_
#define _XSCALE_COMMON_H_

#ifdef	__linux
#include	<linux/module.h>
#include	<linux/version.h>
#include	<linux/kernel.h>
#include	<linux/init.h>
#include	<linux/types.h>
#include	<linux/slab.h>
#include	<linux/proc_fs.h>
#include	<linux/vmalloc.h>
#include	<linux/delay.h>
#include	<asm/io.h>

#define printf(str, args...)		printk(str, ##args)
#define taskDelay(s)			mdelay(s)

unsigned int get32(unsigned int address);
void put32(unsigned int address, unsigned int val);
#endif

void init_sram(int init_value, int start_addr, int end_addr);
void init_scratch(int init_value, int start_addr, int end_addr);
int ipv6_init(void);
int v6v4TunnelInit(void);
int l3_create_routes(void);
int l3CreateRoutes_TCS_IPv6_0001(void);
int route_add_16_64(void);
int v6v4_tunnel_init(void);
int setup_end_tunnels(void);
int setup_start_tunnels(void);

/* Macros to read and write one longword from memory.
 * The macro assumes that the memory being read or written is mapped.
 */
#ifdef __linux
#define GET32(address)			get32(address)
#define PUT32(address,val)		put32(address, val)
#else
#define GET32(address)			(*(volatile unsigned int *)(address))
#define PUT32(address,val)		(*(volatile unsigned int *)(address) = (val))
#endif

#define set_sram(address,val) 		PUT32(address,val)
#define get_sram(address)		GET32(address)

#define get_scratch(address) 		GET32(address)
#define set_scratch(address,val)	PUT32(address,val)

#define get_msf(address)                GET32(0xC8000000+address)
#define set_msf(address,val)            PUT32((0xC8000000+address),val)

#endif
