/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      ix_cc_atmsar_config_private.h
 *
 * = DESCRIPTION
 *      This file will describe the ioctl commands exported to Linux user 
 *      mode application. 
 *
 * = CHANGE HISTORY
 *      05/06/2003 - Created.
 *
 * ============================================================================
 * $Id: ix_cc_atmsar_config_linux_kernel_module.h,v 1.1 2003/10/03 14:03:49 adziecia Exp $
 */

#if !defined(__IX_CC_ATMSAR_CONFIG_KERNEL_MODULE_H__)
#define __IX_CC_ATMSAR_CONFIG_KERNEL_MODULE_H__



/**
 * System defined include files required.
 */

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

/* maximum number of characters in the string followed after command */
#define MAX_NUM_CHAR_CMD_STRING    1024

/* defines for ioctl commands */
#define ADD_VC               0x0
#define DEL_VC               0x1
#define UPDATE_VC            0x2
#define GETSTATS_VC          0x3
#define GETSTATS_PORT        0x4

int addVc(const char *argv);
int delVc(const char *argv);
int updateVc(const char *argv);
int getstatsVc(const char *argv);
int getstatsPort(const char *argv);

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__IX_CC_ATMSAR_CONFIG_KERNEL_MODULE_H__) */

