/*//////////////////////////////////////////////////////////////////////////////
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  2002-2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
////////////////////////////////////////////////////////////////////////////////
//
//
//      File Name: v6v4_natpt_core_uc.h
//
//      Purpose: This header file contains values that are specific to this 
//               implementation of NATPT, and that are shared between the
//               NATPT core and microblock.
//
//      History:
//
//
//      Date            Comment
//      -----------------------------------------------------------------------
//
//      12/10/2002      Created
//
//
////////////////////////////////////////////////////////////////////////////////
*/

#ifndef V6V4_NATPT_CORE_UC_H
#define V6V4_NATPT_CORE_UC_H

#define NATPT_EXCEPTION_NOENTRY_IPV6         0x80
#define NATPT_EXCEPTION_ICMP_IPV4            0x82
#define NATPT_EXCEPTION_ICMP_IPV6            0x83
#define NATPT_EXCEPTION_DNS                  0x8A
#define NATPT_EXCEPTION_FTP                  0x8B
#define NATPT_EXCEPTION_REASSEMBLE_UDP       0x8C
#define NATPT_EXCEPTION_UDP_V4_CHECKSUM_ZERO 0x8D
#define NATPT_EXCEPTION_IPV6_SECURITY_HEADER 0x8E

#endif /* V6V4_NATPT_CORE_UC_H */

