////////////////////////////////////////////////////////////////////////////////
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  2002-2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
////////////////////////////////////////////////////////////////////////////////
//
//
//      File Name: v6v4_natpt.h
//
//      Purpose: This file contains constants used internally by the
//				 NATPT microblock.
//
//      History:
//
//
//      Date            Comment
//      -----------------------------------------------------------------------
//
//      12/10/2002      Created
//
//
////////////////////////////////////////////////////////////////////////////////

#ifndef V6V4_NATPT_H
#define V6V4_NATPT_H

#include "v6v4_natpt_core_uc.h"

//Contains values specific to the microblock implementation
#define PROTO_UDP 17
#define PROTO_TCP 6
#define PROTO_ICMP_V4 1
#define PROTO_ICMP_V6 58

//Offsets of debug counters

//Packet was received by NATPT
#define NATPT_RECV 0

//Packet was not translated (sent to next microblock)
#define NATPT_PASS_THROUGH 4

//Packet was translated to v6
#define NATPT_TRANSLATED_TO_V6 8

//Packet was translated to v4
#define NATPT_TRANSLATED_TO_V4 12

//An exception was raised & the packet sent to the core
#define NATPT_SENT_TO_CORE 16

#endif //V6V4_NATPT_H
