/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2003 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.x for the IXP2xxx Network Processors
 *
 * = LIBRARY
 *      
 *
 * = MODULE
 *      NAT-PT Core Component - Dynamic Properties Table Management.
 *
 * = FILENAME
 *      ix_cc_natpt_prop.c
 *
 * = DESCRIPTION
 *      The file defines dynamic properties table management interface 
 *      functions.
 *
 * = AKNOWLEDGEMENTS
 *      
 *
 * = CREATION TIME
 *      03/03/03
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 */
#define IX_ERROR_FILE_IDENT "$Id: ix_cc_natpt_prop.c,v 1.3 2003/04/30 01:06:12 sshegde Exp $";

/**
 * System defined include files
 */
#include "ix_cc_error.h"
#include "ix_rm.h"
#include "ix_ossl.h"
#include "ix_netmacros.h"
#include "ix_cc.h"
#include "ix_cc_properties.h"
#include "bindings.h"
#include "cc/ix_cc_natpt.h"

/**
 * User defined include files
 */

#include "cc/natpt/internal/ix_cc_natpt_init.h"
#include "cc/natpt/internal/ix_cc_natpt_prop.h"


/**
 * Preprocessor symbols and Macros used in this file
 */

/**
 * Type definitions whose scope is limited to this file
 */

/**
 * Variable declarations global to this file only. Externs are followed by 
 * static variables.
 */

extern ix_cc_natpt_context* g_pNatPtContext;
extern ix_cc_natpt_registry_data g_NatPtRegistryData;

/** 
 * Extern function prototypes.
 */


/** 
 * Static function prototypes.
 */

/** 
 * Function definitions.
 */
