////////////////////////////////////////////////////////////////////////////////////////
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  2001-2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
////////////////////////////////////////////////////////////////////////////////////////
//
//
//      File Name: ipv6_fwder_util.uc
//
//      Purpose: Contains utility routines related to the IPv6 Forwarder
//
//      History:
//
//
//      Date            Comment                         			By
//      --------------------------------------------------------------------------------	
//
//      03/20/2002      Created                         			
//
//
/////////////////////////////////////////////////////////////////////////////////////////

#ifndef	__IPV6_FWDER_UTIL_UC__
#define	__IPV6_FWDER_UTIL_UC__


/////////////////////////////////////////////////////////////////////////////////////////
//
// _ipv6_fwder_increment_counter[]
//
//	 	Description: 
//
//			Atomically increment a 32bit counter.
//
//			Note the order of parameters. This order, output, output/input,
//			input, input constants MUST be followed.
//
//	 	Outputs:
//			None.
//
//		Inputs:
//
//			addr	-	base address for counters. Should
//				be a GPR.
//			offset	- 	a constant offset (should be 7bits
//				maximum).
//
//		CONSTANTS		
//			None.
//
//		Size: 
//
//			1 instructions. (Worst case cycle count)
////////////////////////////////////////////////////////////////////////////////////////
#macro	_ipv6_fwder_increment_counter(OFFSET)

	sram[incr,--,OFFSET,counter_base]

#endm

#endif	// __IPV6_FWDER_UTIL_UC__