/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor
 *
 *
 * = MODULE
 *      IPv4 Core Component
 *
 * = FILENAME
 *      fragmentation_support.h
 *
 * = DESCRIPTION
 *   This file contains definition of fragmentation 
 *   handling routines   
 *
 *
 *
 * = CREATION TIME
 *      8/14/2002 4:53:42 PM
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 * $Id: fragmentation_support.h,v 1.2 2002/12/30 21:27:17 rmurty Exp $
 */

#if !defined(__FRAGMENTATION_SUPPORT_H__)
#define __FRAGMENTATION_SUPPORT_H__

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


#include "ix_cc_error.h"
#include "ix_ossl.h"
#include "ix_rm.h"
#include "ix_cc.h"
#include "bindings.h"
#include "utils.h"
#include "icmp6.h"



/**
 * Prototypes for interface functions.
 */

/**
 * NAME: _ix_cc_ipv6_pass_packet
 *
 * DESCRIPTION: This function hands the given packet off to
 *              outgoing target. The packet must be completely
 *              formed.
 *       
 *
 * @Param:  - IN arg_hBuffer - The buffer to forward
 *            
 *
 * @Param:  - INOUT  - None
 * @Param:  - OUT - None
 *
 * @Return: IX_SUCCESS if successful or a valid ix_error token
 *          for failure.
 *          
 */

ix_error _ix_cc_ipv6_pass_packet(ix_buffer_handle arg_hBuffer);


/**
 * Exported variables.
 */

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__FRAGMENTATION_SUPPORT_H__) */

