/******************************************************************************
 *                                                                     
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001-2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 ******************************************************************************
 *
 *
 *      File Name: v6v4_tunnel.h
 *
 *      Purpose: This file contains definitions related to IPv6-IPv4 tunneling. 
 *
 *      History:
 *
 *      Date            Comment                         		
 *      -----------------------------------------------------------------------
 *
 *      09/05/2002      Created
 *
 *
 ******************************************************************************/

#ifndef	__V6V4_TUNNEL_H__
#define	__V6V4_TUNNEL_H__

/* IPv4 protocol value assigned to tunneled packets */

#define V6V4_PROTOCOL                     41

/* Minimum IPv6 MTU */

#define V6V4_MIN_IPV6_MTU                 1300

/* Tunneling prefixes */

#define V6V4_COMPATIBLE_PREFIX_0_1        0
#define V6V4_COMPATIBLE_PREFIX_2_3        0
#define V6V4_COMPATIBLE_PREFIX_4_5        0
#define V6V4_COMPATIBLE_PREFIX_LENGTH     96

#define V6V4_6TO4_PREFIX                  0x2002
#define V6V4_6TO4_PREFIX_LENGTH           16
#define V6V4_6TO4_PREFIX_LENGTH_BYTES     2

/* Header sizes */

#define V6V4_IPV4_HDR_SIZE                20
#define V6V4_IPV6_HDR_SIZE                40
#define V6V4_ENCAP_HDR_SIZE               60

#endif	//__V6V4_TUNNEL_H__
