/******************************************************************************
 *                                                                     
 *                  I N T E L   P R O P R I E T A R Y                   
 *                                                                      
 *     COPYRIGHT (c)  2001-2003 BY  INTEL  CORPORATION.  ALL RIGHTS          
 *     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
 *     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
 *     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
 *     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
 *     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
 *     THE PRIOR WRITTEN PERMISSION OF :                                
 *                                                                      
 *                        INTEL  CORPORATION                            
 *                                                                     
 *                     2200 MISSION COLLEGE BLVD                        
 *                                                                      
 *               SANTA  CLARA,  CALIFORNIA  95052-8119                  
 *                                                                      
 ******************************************************************************
 *
 *
 *      File Name: v6v4_tunnel_microc.h
 *
 *      Purpose: This file contains tunneling definitions used by microc.
 *
 *      History:
 *
 *      Date            Comment                         		
 *      -----------------------------------------------------------------------
 *
 *      02/19/2003      Created
 *
 *
 ******************************************************************************/

#ifndef	__V6V4_TUNNEL_MICROC_H__
#define	__V6V4_TUNNEL_MICROC_H__

/* Some tunneling-specific offsets & lengths for fields in the IPv6 header */

#define IPV6_V4ADDR_OFFSET_AUTO         12
#define IPV6_V4ADDR_OFFSET_6TO4         2
#define IPV6_EMBEDDED_IPV4_LENGTH       4

/* Values for verification parameter passed to IPv4 address verification */

#define V6V4_DONT_VERIFY                0
#define V6V4_DO_VERIFY                  1

/* Success/failure return values */

#define V6V4_VALIDATE_SUCCESS           1
#define V6V4_VALIDATE_FAILURE           0

/* Definition of tunnel encap next hop info */

typedef __declspec(packed) union
{
	struct {
        unsigned short	flags;			/* configuration flags */
        unsigned short	pathMtu;        /* tunnel path MTU */

        unsigned int	localAddress;   /* tunnel local address */

        unsigned int	remoteAddress;  /* tunnel remote address */

        unsigned char	ttl;            /* TTL value for encapsulating header */
        unsigned char	tos;            /* TOS value for encapsulating header */
        unsigned short  reserved1;      /* reserved - must be zero */

        unsigned int	snBroadcast;    /* subnet broadcast addr for validation */

        unsigned short	reserved2;

	};	// end of struct

	unsigned int value[8];              /**< aggregate for the above fields */

} tunnel_encap_nh_t;


#endif	/* __V6V4_TUNNEL_MICROC_H__ */