/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2002-2003 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2400 Network Processor, Release 6
 *
 * = LIBRARY
 *      
 *
 * = MODULE
 *      Core Component Infrastructure - Ingress source validation list
 *      support for the default list format.
 *
 * = FILENAME
 *      ix_cc_v6v4_ingress_list_def.h
 *
 * = DESCRIPTION
 *      This file defines all data types, macros and function prototypes
 *      that support management of the default format of the ingress source
 *      validation list for tunneling decapsulation.
 *
 * = CREATION TIME
 *      11/25/2002 2:24 PM
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 * $Id: ix_cc_v6v4_ingress_list_def.h,v 1.3 2003/01/30 18:33:31 cabell Exp $
 */

#if !defined(__IX_CC_V6V4_INGRESS_LIST_DEF_H__)
#define __IX_CC_V6V4_INGRESS_LIST_DEF_H__

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#include "ix_cc_v6v4_ingress_list.h"


/**
 * NAME: _ix_cc_v6v4_ingress_list_init_def_handlers
 *
 * DESCRIPTION: This primitive is used to initialize the ingress list
 * handlers for the default format.
 *           
 * @Param:  - IN None.
 *
 * @Param:  - OUT arg_pHandlers - pointer to handler list to be
 * initialized.
 *
 * @Return: IX_SUCCESS.
 *
 * Error Codes:
 * 
 */

ix_error _ix_cc_v6v4_ingress_list_init_def_handlers(
    ix_cc_v6v4_ingress_list_handlers* arg_pHandlers
    );


#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__IX_CC_V6V4_INGRESS_LIST_DEF_H__) */
