#ifndef MPLS_DEFS_H
#define MPLS_DEFS_H

/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/
/* "$Id: mpls_defs.h,v 1.6.2.1 2004/03/12 10:42:39 wneubaue Exp $" */

/*
 * FILE  mpls_defs.h
 *
 * Definitions relevant to both MPLS microblock and core componenet
 *
 * The following global tokens change the configuration of an MPLS :
 *
 *
 */



/* DEFINE:  IX_CC_MPLS_ILM_TABLE_IDX_SIZE          */
/**
 * ABSTRACT:  size of the index which is used to
 *            address ilm table.
 *
 * DESCRIPTION: size of the index (in bits) which is used to
 *              address ilm table. This constant is
 *              used when system registry is unavailable.
 */
#define IX_CC_MPLS_ILM_TABLE_IDX_SIZE        8



/*
 * MPLS exception codes.
 */
#ifndef ILM_LABELED_PACKET_TOO_BIG
#define ILM_LABELED_PACKET_TOO_BIG           0x1
#endif

#ifndef FTN_LABELED_PACKET_TOO_BIG
#define FTN_LABELED_PACKET_TOO_BIG           0x2
#endif

#ifndef TTL_EXPIRED
#define TTL_EXPIRED                          0x3
#endif

#ifndef TOO_MANY_POPS
#define TOO_MANY_POPS                        0x4
#endif

#ifndef ROUTER_ALERT
#define ROUTER_ALERT                         0x5
#endif


/*
 * The L3 protocol type field defintions
 */

#ifndef MPLS_L3_UNKNOWN
#define MPLS_L3_UNKNOWN     0
#endif

#ifndef MPLS_L3_IP_V4
#define MPLS_L3_IP_V4       1
#endif

#ifndef MPLS_L3_IP_V6
#define MPLS_L3_IP_V6       2
#endif


/*
 * The type of next_hop_id_type field in next hop info 
 */
#ifndef NEXT_HOP_ID_IPV4_TYPE
#define NEXT_HOP_ID_IPV4_TYPE                NHID_TYPE_IPV4
#endif

#ifndef NEXT_HOP_ID_IPV6_TYPE
#define NEXT_HOP_ID_IPV6_TYPE                NHID_TYPE_IPV6
#endif

#ifndef NEXT_HOP_ID_MPLS_TYPE
#define NEXT_HOP_ID_MPLS_TYPE                NHID_TYPE_MPLS
#endif



#ifndef MPLS_IPV4_HEADER_TYPE
#define MPLS_IPV4_HEADER_TYPE                PPP_IPV4_TYPE
#endif

#ifndef MPLS_IPV6_HEADER_TYPE
#define MPLS_IPV6_HEADER_TYPE                PPP_IPV6_TYPE
#endif

#ifndef MPLS_MPLS_HEADER_TYPE
#define MPLS_MPLS_HEADER_TYPE                PPP_MPLS_TYPE
#endif

#ifndef MPLS_UNKNOWN_HEADER_TYPE
#define MPLS_UNKNOWN_HEADER_TYPE             0xFF
#endif

/*
 * Counters support
 */
#ifdef __COUNTERS__
#ifndef MPLS_COUNTERS_FEATURE
#define MPLS_COUNTERS_FEATURE
#endif
#endif


#endif /* MPLS_DEFS_H */
