#if !defined(IX_CC_CLASSIFIER_6T_HASH_COMP_H)
#define      IX_CC_CLASSIFIER_6T_HASH_COMP_H

/*
 * ============================================================================
 * COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a licence agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2003 Intel Corporation. All rights reserved.
 *
 * PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor                
 *                                                                               */
/** \file   ix_cc_classifier_6t_hash_comp.h
 *
 *  \brief  
 * 
 */


/*
 * FUNCTION: _ix_cc_classifier_6t_get_hash_key()  */
/**
 * ABSTRACT: calculates hash index.
 * 
 * DESCRIPTION: depending on IX_CC_CLASSIFIER_6T_SOFTWARE_HASH constant 
 *              this function calculates hash index using either 
 *              software method or hardware hash unit.
 *
 * \param arg_IndexSize - size of hash index (in bits) requested.
 *
 * \return value of hash index which can then be used to address hash table.
 *         operation.
 *         IX_CC_ERROR_NULL - when arg_Data was NULL
 */
ix_uint32
_ix_cc_classifier_6t_get_hash_key(ix_cc_classifier_6t_pattern *arg_Data,
                                  ix_uint32 arg_IndexSize);



#endif


