#ifndef DIFFSERV_H
#define DIFFSERV_H

/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/

/*
 * FILE  diffserv.h
 *
 * This file contains definitions used by diffserv micro-blocks and core
 * components alike.
 */

/*
 * The following values must not be changed because the WRED micro-block
 * will malfunction. Based on this address it calculates the address 
 * to its local memory structures
 */

/* 
 * The value used in meta data by variable named color_id.
 * It indicates that processed packet is green.
 */
#define		GREEN_PACKET    0

/*
 * The value used in meta data by variable named color_id. 
 * It indicates that processed packet is yellow
 */
#define		YELLOW_PACKET   1

/*
 * The value used in meta data by variable named color_id. 
 * It indicates that processed packet is red
 */
#define		RED_PACKET      2


/*
 * Mask to isolate color_id from 32 bit word
 */
#define		COLOR_ID_MASK	0x3


#endif		/*   DIFFSERV_H   */
