/*******************************************************************************
  INTEL CONFIDENTIAL

  Copyright 2003 Intel Corporation All Rights Reserved.

  The source code contained or described herein and all documents related to
  the source code ("Material") are owned by Intel Corporation or its 
  suppliers or licensors.

  Title to the Material remains with Intel Corporation or its suppliers and
  licensors. The Material contains trade secrets and proprietary and
  confidential information of Intel or its suppliers and licensors.
  The Material is protected by worldwide copyright and trade secret laws and
  treaty provisions. No part of the Material may be used, copied, reproduced,
  modified, published, uploaded, posted, transmitted, distributed,
  or disclosed in any way without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure
  or delivery of the Materials, either expressly, by implication, inducement,
  estoppel or otherwise. Any license under such intellectual property rights
  must be express and approved by Intel in writing.

*******************************************************************************/

/**
 * ============================================================================
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2000 Network Processor
 *
 * = FILE
 *     dscp_classifier_debug.h
 *
 * = DESCRIPTION
 *     The DSCP Classifier core component diagnostics support.
 *
 * ============================================================================
 */

#if !defined( _DSCP_CLASSIFIER_DEBUG_H__INCLUDED_ )
#define _DSCP_CLASSIFIER_DEBUG_H__INCLUDED_

#if defined( IX_DEBUG )

#if defined( __cplusplus )
extern "C" {
#endif /* __cplusplus */

/**
 *  @brief  The memory dump function.
 *
 *  The function dumps <code>size</code> bytes long memory block starting at 
 *  <code>ptr</code> address. The
 */

void 
_ix_debug_dump( void * ptr, ix_ossl_size_t size );

/**
 *  NAME: _ix_debug_dump_rslts 
 */

ix_error 
_ix_debug_dump_rslts( ix_cc_classifier_dscp_result * results );

/**
 *  NAME: _ix_debug_dump_entry
 */

ix_error 
_ix_debug_dump_entry( _T( table_entry ) * entry, 
                      void              * cntxt );

#if defined( __cplusplus )
}
#endif /* __cplusplus */

#endif /* IX_DEBUG */

#endif /* _DSCP_CLASSIFIER_DEBUG_H__INCLUDED_ */
