/*******************************************************************************
  INTEL CONFIDENTIAL

  Copyright 2003 Intel Corporation All Rights Reserved.

  The source code contained or described herein and all documents related to
  the source code ("Material") are owned by Intel Corporation or its 
  suppliers or licensors.

  Title to the Material remains with Intel Corporation or its suppliers and
  licensors. The Material contains trade secrets and proprietary and
  confidential information of Intel or its suppliers and licensors.
  The Material is protected by worldwide copyright and trade secret laws and
  treaty provisions. No part of the Material may be used, copied, reproduced,
  modified, published, uploaded, posted, transmitted, distributed,
  or disclosed in any way without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure
  or delivery of the Materials, either expressly, by implication, inducement,
  estoppel or otherwise. Any license under such intellectual property rights
  must be express and approved by Intel in writing.

*******************************************************************************/

/**
 * ============================================================================
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2000 Network Processor
 *
 * = FILE
 *     dscp_classifier_internal.h
 *
 * = DESCRIPTION
 *     The DSCP classifier core component internals. This file includes 
 *     essential header files.
 *
 * ============================================================================
 */

#if !defined( _IX_DSCP_CLASSIFIER_INTERNAL_H__INCLUDED_ )
#define _IX_DSCP_CLASSIFIER_INTERNAL_H__INCLUDED_

/* include ANSI C/C++ header files */
#include <math.h>

#include <ix_types.h>
#include <ix_error.h>

/* include IXA SDK 3.0.1 header files */
#include <ix_ossl.h>
#include <ix_rm.h>

/* _ix_registry */
typedef ix_configuration_property_handle _ix_registry;

/* do not include if "levle 0" configuration */
#if !defined( IX_EXCLUDE_CCI )
  #include <ix_cci.h>
#endif /* IX_EXCLUDE_CCI */

#include <ix_symbols.h>

/* include CC support header files */
#include <ix_cc_error.h>
#include <ix_cc.h>
#include <ix_cc_macros.h>

#include <cc/ix_cc_msup.h>
#include <bindings.h>

/* inlcude local header files */
#include "cc/internal/dscp_classifier_defs.h"

/* do not include if system registry is present */
#if !defined( IX_INCLUDE_REGISTRY )
  #include "cc/internal/dscp_classifier_defaults.h"
#else
  /* only include if system registry is present */
  #include "cc/internal/dscp_classifier_registry.h"
#endif /* IX_INCLUDE_REGISTRY */

#include "cc/ix_cc_dscp_classifier_msghlp.h"
#include "cc/internal/dscp_classifier_types.h"

#include "cc/ix_cc_dscp_classifier.h"

#include "cc/internal/dscp_classifier_api.h"
#include "cc/internal/dscp_classifier_misc.h"

#if defined( IX_DEBUG )
#include "dscp_classifier_debug.h"
#endif /* IX_DEBUG */

#endif /* _IX_DSCP_CLASSIFIER_INTERNAL_H__INCLUDED_ */
