#ifndef DSCP_CLASSIFIER_H
#define DSCP_CLASSIFIER_H	1

/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/

/* FILE  dscp_classifier.h
 *
 *  Contains definitions used by the DSCP Classifier microblock.
 */


/* System dependent definitions.
 * Therefore they should be made either in dl_system.h
 * or as compilation options.
 */

/* Microblock's ID. */
#ifndef	BID_CLASSIFIER_DSCP
    #error "BID_CLASSIFIER_DSCP not defined."
#endif

/* Microblock's outputs. */
#ifndef	CLASSIFIER_DSCP_METER_OUTPUT
    #error "CLASSIFIER_DSCP_METER_OUTPUT not defined."
#endif

#ifndef	CLASSIFIER_DSCP_MARKER_OUTPUT
    #error "CLASSIFIER_DSCP_MARKER_OUTPUT not defined."
#endif

#ifndef	CLASSIFIER_DSCP_IP4_FWD_OUTPUT
    #error "CLASSIFIER_DSCP_IP4_FWD_OUTPUT not defined."
#endif

#ifndef	CLASSIFIER_DSCP_IP6_FWD_OUTPUT
    #error "CLASSIFIER_DSCP_IP6_FWD_OUTPUT not defined."
#endif

#ifndef	CLASSIFIER_DSCP_INV_IP_OUTPUT
    #error "CLASSIFIER_DSCP_INV_IP_OUTPUT not defined."
#endif

#ifndef	CLASSIFIER_DSCP_IP4_DEFAULT_OUTPUT
    #error "CLASSIFIER_DSCP_IP4_DEFAULT_OUTPUT not defined."
#endif

#ifndef	CLASSIFIER_DSCP_IP6_DEFAULT_OUTPUT
    #error "CLASSIFIER_DSCP_IP6_DEFAULT_OUTPUT not defined."
#endif

/* Values of the 'header_type'
 * which indicate the type of the current packet.
 */
#ifndef	CLASSIFIER_DSCP_IPV4_HEADER_TYPE
    #error "CLASSIFIER_DSCP_IPV4_HEADER_TYPE not defined."
#endif

#ifndef	CLASSIFIER_DSCP_IPV6_HEADER_TYPE
    #error "CLASSIFIER_DSCP_IPV6_HEADER_TYPE not defined."
#endif

#ifdef	USE_IMPORT_VAR
/* These values will be patched by core. */

.import_var CLASSIFIER_DSCP_CONFIG_SRAM_BASE

	#ifdef CLASSIFIER_DSCP_PACKET_COUNTER_FEATURE
		.import_var CLASSIFIER_DSCP_STATS_SRAM_BASE
	#endif /* CLASSIFIER_DSCP_PACKET_COUNTER_FEATURE */

#else  /* USE_IMPORT_VAR not defined */

	#ifndef	CLASSIFIER_DSCP_CONFIG_SRAM_BASE
    	#error "CLASSIFIER_DSCP_CONFIG_SRAM_BASE not defined."
	#endif

	#ifdef CLASSIFIER_DSCP_PACKET_COUNTER_FEATURE
		#ifndef	CLASSIFIER_DSCP_STATS_SRAM_BASE
    		#error "CLASSIFIER_DSCP_STATS_SRAM_BASE not defined."
		#endif
	#endif /* CLASSIFIER_DSCP_PACKET_COUNTER_FEATURE */

#endif /* USE_IMPORT_VAR */


/*
 * Microblock's private definitions.
 */
#define CLASSIFIER_DSCP_REMARK_FLAG_BIT				2
#define CLASSIFIER_DSCP_TC_FLAG_BIT					3
#define CLASSIFIER_DSCP_IPC_FLAG_BIT				5

#ifdef CLASSIFIER_DSCP_PACKET_COUNTER_FEATURE

	#define CLASSIFIER_DSCP_STATISTICS_FLAG_BIT		4

	#define CLASSIFIER_DSCP_PACKET_COUNTER_HIGH		0x0
	#define CLASSIFIER_DSCP_PACKET_COUNTER_LOW		0x4
	#define CLASSIFIER_DSCP_BYTE_COUNTER_HIGH		0x8
	#define CLASSIFIER_DSCP_BYTE_COUNTER_LOW		0xC

#endif


#endif // DSCP_CLASSIFIER_H
