#ifndef TC_METER_INIT_UC
#define TC_METER_INIT_UC

/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/
/* "$Id: tc_meter_init.uc,v 1.8.4.1 2004/03/12 10:23:37 wneubaue Exp $" */


// FILE  tc_meter_init.uc
//
// Implements init and term macros of a tc_meter meter block.
//
//
// Exported APIs:
//   tc_meter_init()
//   tc_meter_term()


//------------------------------------------------------------------------------
// Included files:
#include <sig_macros.uc>




//------------------------------------------------------------------------------
// #macro tc_meter_init()

// tc_meter_init
//
// Description:
//   Initiation for tc meter block. Should be called before using tc_metereter
//
#macro	tc_meter_init()
.begin


	br!=ctx[0,init_relative#]

init_absolute#:

	.sig     timestamp_init_signal
	.addr    timestamp_init_signal	TC_METER_TIMESTAMP_SIG
	.set_sig timestamp_init_signal

		// we wait for the signal here
		ctx_arb[timestamp_init_signal]

		.reg init_timestamp

		; init local CSR Timestamp_low
		move(init_timestamp, TC_METER_INIT_TIMESTAMP_LOW);
		local_csr_wr[Timestamp_low, init_timestamp]

		; init local CSR Timestamp_high
		move(init_timestamp, TC_METER_INIT_TIMESTAMP_HIGH);
		local_csr_wr[Timestamp_high, init_timestamp]


		// tc_meter on the last microengine enables time counting
		#if (DL_NEXT_ME == FIRST_TC_METER_ME)

            .sig cap_write
            .reg $enable_timestamp
            immed[$enable_timestamp, 0x300]
            ; read MISC_CONTROL
            cap[read, $enable_timestamp, MISC_CONTROL], ctx_swap[cap_write]  
            ; set 7th bit(Timestamp Enable)
            alu[$enable_timestamp, $enable_timestamp, or, 1, <<7]            
            ; write MISC_CONTROL
            cap[write, $enable_timestamp, MISC_CONTROL], ctx_swap[cap_write] 

		#else
			// tc_meter on every microengine but last pass over the token to 
			// the tc_meter on the next microengine
			signal_me[DL_NEXT_ME, &timestamp_init_signal]
		#endif

init_relative#:

//	immed32(_tc_meter_pir_extract_mask, TC_METER_PIR_EXTRACT_MASK);

.end
#endm


//------------------------------------------------------------------------------
// #macro  tc_meter_term()

// tc_meter_term
//
// Description:
//   Terminates the operation of a tc_metereter block
//
#macro	tc_meter_term()
#endm


#endif // TC_METER_INIT_UC
