/*******************************************************************************
  INTEL CONFIDENTIAL

  Copyright 2000 - 2003 Intel Corporation All Rights Reserved.

  The source code contained or described herein and all documents related to
  the source code ("Material") are owned by Intel Corporation or its 
  suppliers or licensors.

  Title to the Material remains with Intel Corporation or its suppliers and
  licensors. The Material contains trade secrets and proprietary and
  confidential information of Intel or its suppliers and licensors.
  The Material is protected by worldwide copyright and trade secret laws and
  treaty provisions. No part of the Material may be used, copied, reproduced,
  modified, published, uploaded, posted, transmitted, distributed,
  or disclosed in any way without Intel's prior express written permission.

  No license under any patent, copyright, trade secret or other intellectual
  property right is granted to or conferred upon you by disclosure
  or delivery of the Materials, either expressly, by implication, inducement,
  estoppel or otherwise. Any license under such intellectual property rights
  must be express and approved by Intel in writing.

*******************************************************************************/

/**
 * ============================================================================
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2000 Network Processor
 *
 * = FILENAME
 *      ix_cc_wred_pkt_handlers.c
 *
 * ============================================================================
 */

#define IX_ERROR_FILE_IDENT \
  "$Id: ix_cc_wred_pkt_handlers.c,v 1.10.4.1 2004/03/12 10:05:17 wneubaue Exp $"


#include <ix_types.h>
#include <ix_error.h>
#include <ix_ossl.h>
#include <ix_cc.h>
#include <cc/ix_cc_msup.h>

#include "../../include/wred_defs.h"
#include "cc/ix_cc_wred.h"
#include "cc/internal/ix_cc_wred_defs.h"
#include "cc/internal/ix_cc_wred_api.h"
#include "cc/internal/ix_cc_wred_types.h"
#include "cc/internal/ix_cc_wred_misc.h"

IX_CC_WRED_INSTANCE_TABLE_DECLARE()

/* ----------------------------------------------- ix_cc_wred_pkt_handler -- */

ix_error ix_cc_wred_pkt_handler( ix_buffer_handle arg_hBuffer,
                                  ix_uint32       arg_nExCode,
                                  void *          arg_pContext )
  {
    ix_uint32 instanceCC = IX_HANDLE_TO_INSTANCE(((_ix_cc_wred_context *)arg_pContext)->_hCC);

    if ( ix_rm_packet_send(
             IX_CC_WRED_INSTANCE_TABLE_GET(instanceCC,pktOut),
             arg_hBuffer, 0 
           ) != IX_SUCCESS )
      {            
        IX_ERROR_CRT( 
          ix_rm_buffer_free_chain( arg_hBuffer ),
          IX_CCI_ERR_SEND_FAIL, 0 );

        return IX_ERROR_WARNING(
            IX_CC_ERROR_INTERNAL,
            ( "failed to send packet to the WRED microblock" )
          );
      }  

    return IX_SUCCESS;
}
