#ifndef	AAL5_RX_DEFS_H
#define	AAL5_RX_DEFS_H

/*******************************************************************************
                             Intel Proprietary

 Copyright (c) 1998-2002 By Intel Corporation.  All rights reserved.  
 No part of this program or publication may be reproduced, transmited,
 transcribed, stored in a retrieval system, or translated into any language
 or computer language in any form or by any means, electronic, mechanical,
 magnetic, optical, chemical, manual, or otherwise, without the prior
 written permission of:
                         Intel Corporation
                         2200 Mission College Blvd.
                         Santa Clara, CA  95052-8119
*******************************************************************************/


#define AAL5_RX_PORT_STAT_ENTRY_SIZE_LOG2	5
#define AAL5_RX_PORT_STAT_ENTRY_SIZE        (1<<AAL5_RX_PORT_STAT_ENTRY_SIZE_LOG2)

#define AAL5_RX_VC_INFO_ENTRY_SIZE_LOG2	    6
#define AAL5_RX_VC_INFO_ENTRY_SIZE	        (1<<AAL5_RX_VC_INFO_ENTRY_SIZE_LOG2)

/* Primary VC Hash Table */
#define AAL5_RX_VC_HASH_PRI_BKT_ENTRY_SIZE_LOG2	4
#define AAL5_RX_VC_HASH_PRI_BKT_ENTRY_SIZE		(1<<AAL5_RX_VC_HASH_PRI_BKT_ENTRY_SIZE_LOG2) /* Each entry consists of 4LW */

/* Secondary VC Hash Table */
#define AAL5_RX_VC_HASH_SEC_BKT_ENTRY_SIZE_LOG2	5
#define AAL5_RX_VC_HASH_SEC_BKT_ENTRY_SIZE		(1<<AAL5_RX_VC_HASH_SEC_BKT_ENTRY_SIZE_LOG2) /* Each entry consists of 8LW */

/* Offsets for PORT STATISTICS 32 bit counters  */
#define AAL5_RX_PKT_COUNT			    0
#define AAL5_RX_PKT_DROP_COUNT		    4
#define AAL5_RX_HW_ERROR			    8
#define AAL5_RX_VC_ERROR			    12

/* Offsets for VC STATISTICS 32 bit counters  */
#define AAL5_RX_CELL_CNT			    40
#define AAL5_RX_MGT_CELL_COUNT			44
#define	AAL5_RX_AAL5_PDU_COUNT			48
#define AAL5_RX_AAL5_PDU_CRC_BAD		52
#define AAL5_RX_AAL5_PDU_LEN_BAD		56

/* Qdescriptor size in SRAM */
#define QDESC_SIZE  16

#ifdef MICROCODE

#else /* MICROCODE */

#endif /* MICROCODE */

#endif	/* AAL5_RX_DEFS_H */
