///////////////////////////////////////////////////////////////////////////////
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  2001-2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
///////////////////////////////////////////////////////////////////////////////
//
//
//      File Name: csix_rx.h
//
//      Purpose: 
//
//      History:
//
//
//      Date            Comment                         By
//      ---------------------------------------------------------------------
//
//      02/27/2002      Created                         David Meng
//
//
/////////////////////////////////////////////////////////////////////////////

#ifndef _CSIX_RX_H_
#define _CSIX_RX_H_

//	This file is the header file for the CSIX RX micro block.
//	This file includes the pos_rx.h file to use the MSF hardware 
//	register definition.  The constants used in the CSIX RC micro block
//	are also defined in this file.

#include <hardware.h>

#ifdef USE_IMPORT_VAR

	.import_var CSIX_RX_CTX_SRAM_BASE
	.import_var CSIX_RX_COUNTERS_SRAM_BASE
    .import_var FREE_LIST_ID
#else

/* base address defined in dl_system.h */

#endif

/////////////////////////////////////////////////////////////////////////////
#define RBUF_SIZE			128
#define RX_THREAD_FREELIST_TIMEOUT_0	1024

// vertical check may be disabled by assembler option
#ifdef	VERTICAL_PARITY_CHECK
#define ALL_ERROR_CODE		0x3E00
#else
#define ALL_ERROR_CODE		0x1A00
#endif

#define NULL_ERROR_CODE		0x0200
#define	IX_DL_BUF_NULL		IX_NULL
#define DL_NEXT_ME			0	
#define	IX_BUF_MAX			BUFFER_SIZE

/////////////////////////////////////////////////////////////////////////////
// Followin definitions are fro the signal number

#ifdef RX_EVENT_SIG	
#undef RX_EVENT_SIG
#endif
#define RX_EVENT_SIG		3

#define NXT_THRD_SIG_1 		6
#define NXT_THRD_SIG_2 		7
#define NXT_THRD_SIG_3 		8

#ifdef TWO_ME_CSIX_RX

#define _INTER_ME_SIG_1		2
#define _INTER_ME_SIG_2		4

#endif

#define	NORMAL_STATE		1
#define SOP_DATA_OFFSET 	128
#define SOP_PRPEND_HDR 		16
#define NO_SOP_PRPEND_HDR 	8
#define	PKT_DIV				8

/////////////////////////////////////////////////////////////////////////////
// Follow definitions are used for multiple DRAM banks

#define OFFSET_MASK			0x1ff
#define DDR_BANK_SIZE		128
#define NO_OF_DDR_BANKS		4
#define MAX_BUFFER_OFFSET	(DDR_BANK_SIZE * NO_OF_DDR_BANKS)

/////////////////////////////////////////////////////////////////////////////
// Follow definitions are used for global counters
// There are total blage * classs = 64*16=1024 VOQs.  Each VOQ has a counter
// data.  The counter data structure contains 4 long words
//	PKT_RECEIVED_CNT
//	PKT_DROPPED_CNT
//	BYTE_RECEIVED_CNT
//	RESERVED_CNT
//  The index of the counter data is defiend by CSIX_RX_COUNTER_BASE+VOQ_OFFSET
//	VOQ_OFFSET	= blade number << 4 + class number
//	Following are the counter index definitions

#ifdef COUNTERS
#define		PKT_RECEIVED_CNT_IDX	0x00
#define		BYTE_RECEIVED_CNT_IDX	0x04
#define		CFRAMES_CNT_IDX         0x08
#define 	PKT_DROPPED_CNT_IDX 	0x0C
#endif

#ifdef	CELL_MODE
#define CELL_SIZE_CNST				48
#endif

#endif