////////////////////////////////////////////////////////////////////////////////////////
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  2001-2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
////////////////////////////////////////////////////////////////////////////////////////
//
//
//      File Name:ppp.h
//
//      Purpose: This file contains the  constants used in the Ethernet frame
//				 processing micro code 
//
//      History:
//
//
//      Date            Comment                         			By
//      --------------------------------------------------------------------------------	
//
//      06/13/2002      Created                         			David Meng
//
//
/////////////////////////////////////////////////////////////////////////////////////////

#ifndef		__PPP_H__
#define		__PPP_H__

#define		PPP_IP_VER_START			2
#define		PPP_IP_VER_LEN				1
#define		PPP_IP_VER_MSK				0xF

#ifdef PPP_2_BYTE_HEADER
	#define 	PPP_HEADER_LENGTH			2
	#define		PPP_WINDW_START				0
	#define 	PPP_TYPE_START				0
	#define		PPP_TYPE_LEN				2
								
#else	
	#ifdef PPP_4_BYTE_HEADER
		#define 	PPP_HEADER_LENGTH			4
		#define		PPP_WINDW_START				0
		#define 	PPP_TYPE_START				2
		#define		PPP_TYPE_LEN				2
	#endif
#endif

#define PPP_HEADER_OFFSET				0
#define	PPP_IPV4					0x0021
#define PPP_IPV6					0x0057
#define PPP_MPLS_UNICAST			0x0281
#define PPP_MPLS_MULTICAST			0x0283



#endif	//	end __PPP_H__

