/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      ix_cc_llc_snap_config_private.h
 *
 * = DESCRIPTION
 *      This file will describe the ioctl commands exported to Linux user 
 *      mode application. 
 *
 * = CHANGE HISTORY
 *      05/06/2003 - Created.
 *
 * ============================================================================
 * $Id: ix_cc_llc_snap_config_linux_kernel_module.h,v 1.2 2003/12/12 18:42:58 rwielick Exp $
 */

#if !defined(__IX_CC_LLC_SNAP_CONFIG_KERNEL_MODULE_H__)
#define __IX_CC_LLC_SNAP_CONFIG_KERNEL_MODULE_H__



/**
 * System defined include files required.
 */

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

/* maximum number of characters in the string followed after command */
#define MAX_NUM_CHAR_CMD_STRING    1024

/* defines for ioctl commands */
#define ADD_NEXT_HOP               0x0
#define DEL_NEXT_HOP               0x1

int addNextHop(const char *argv);
int delNextHop(const char *argv);

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__IX_CC_LLC_SNAP_CONFIG_KERNEL_MODULE_H__) */

