/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2001 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2X00 Network Processor, Release 6
 *
 * = FILENAME
 *    ix_cc_llc_snap_config_linux_user_mode_util.c
 *
 * = DESCRIPTION
 *    This file contains linux user mode application 'rconfig' that 
 *    can be used to in target shell for configuring the route table.
 *
 * = CHANGE HISTORY
 *      05/06/2003 - Created.
 *
 * ============================================================================
 * $Id: 
 */
#include <fcntl.h>
#include "ix_cc_llc_snap_config_linux_kernel_module.h"

void llc_snapconfig_usage(void);

int main(int argc, char *argv[])
{

    int fd;
    int cmd;
    char *cmdArgStr;

    if (argc == 1)
    {
        llc_snapconfig_usage();
        exit(0);
    }
    else if (strcmp(argv[1],"addNextHop") == 0)
    {
        cmd = ADD_NEXT_HOP;
        cmdArgStr = argv[2];
    }
    else if (strcmp(argv[1],"delNextHop") == 0)
    {
        cmd = DEL_NEXT_HOP;
        cmdArgStr = argv[2];
    }    
    else
    {
        printf("Unrecognized command\n");
        exit(1);
    }

    fd = open("/dev/LlcConfig", O_CREAT | O_RDWR);

    ioctl(fd, cmd, cmdArgStr);

    close(fd);

    return 0;

} /* main */



void llc_snapconfig_usage(void)
{
    printf("\nUSAGE: llc_snap_config <cmd> <\"args\">\n\n");
    printf(" where <cmd> <\"args\"> pair can be one of the followings: \n");
    printf("  addNextHop \"nextHop vpi vci vcq encapBit dSap sSap ctrl oui pid\"\n");
    printf("  delNextHop \"nextHop\"\n");
}







