/******************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2002 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *******************************************************************************/
/*****************************************************************************
 *
 * File:  PacketTxx_init.c
 *
 * Abstract:
 *      This is the SPHY and NPHY4 transmit code init file.  This file 
 *      defines the initialization functions used in the SPHY and MPHY_4
 *		trasmiting microengine C code..
 * Contents:
 *        Definitions of initialization function.
 *****************************************************************************/
#include <packet_txx.h>

/*****************************************************************************
 * Abstract:
 *   Initialize the local memory including queue info and globals for port
 *    
 *
 * Side Effects:
 *    None
 *
 * Assumptions:
 * 	  None
 *****************************************************************************/
INLINE void									/* OUT: No return value			 */
PacketTx_Init()
{
	int i, j, k;

#if (PACKET_TX_PHY_MODE == SPHY_1_32)
	for(i = 0; i < 16; i++ )
		for(j = 0; j < 4; j++)
			qPort[0].q_entry[i].value[j] = 0;  /* clean the queue entries */	
#endif

#if ((PACKET_TX_PHY_MODE == PHY_SPHY_4_8) \
	 || (PACKET_TX_PHY_MODE == PHY_MPHY_4))
	for(i = 0; i < 4; i++)
		for(j = 0; j < 16; j++)
			for(k = 0; k < 4; k++)
		 		qPort[i].q_entry[j].value[k] = 0;
#endif
	myRdRingFlag =0;

} /* PacketTx_Init()*/
