#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

include $(ROOTDIR)/Rules.make

unexport TARGET
unexport COMPONENT
unexport OBJFILES
unexport INCLUDELOCAL
unexport COMPTARGET

# A standard component should define the following variables
# and then include this file
# ARCHIVE - OR -
# COMPONENT - the name of this component
#  depending on if you want to create an archive or .o file
#  ****THERE SHOULD NOT BE ANY TRAILING BLANKS ON THE RHS OF =*****
# 
# beware when defining OBJFILES for Common components - stuff in 
# common/x directories, $(TEAM) has to be prepended to the objs.
# OBJFILES - XXX.o YYY.o etc
# INCLUDELOCAL - -Ixxxx etc. (OPTIONAL)

COMPTARGET = lib/$(ARCH_DIR)_$(OS_DIR)/$(COMPONENT).o

COBJ=$(patsubst %.c,%.o,$(filter %.c, $(SRCFILES)))
CCOBJ=$(patsubst %.cc,%.o,$(filter %.cc, $(SRCFILES)))
CPPOBJ=$(patsubst %.cpp,%.o,$(filter %.cpp, $(SRCFILES)))
OBJFILES=$(COBJ) $(CCOBJ) $(CPPOBJ)

OBJS=$(OBJFILES:%=obj/$(ARCH_DIR)_$(OS_DIR)/%) 
SRCS=$(SRCFILES:%=src/%) 
DOTDS=$(OBJFILES:%.o=lib/$(ARCH_DIR)_$(OS_DIR)/.%.d) 

LOCALDIR    := .

INCLUDEPDK := $(shell sh $(ROOTDIR)/.bpfinc.sh) $(INCLUDELOCAL)
INCLUDEPATH := $(INCLUDEPDK) $(INCLUDESYSTEM)

default: $(COMPTARGET)

$(COMPTARGET): $(OBJS)
	@echo
	@echo "------Collecting the .o's in $(COMPTARGET)...-------"
	$(LD) $(LD_PARTIAL_FLAGS) -o $@ $(OBJS)
	@echo


depend: $(DOTDS)
	@echo "-----Finished checking dependencies for $(COMPONENT)-------"

.PHONY : clean allclean dummy

dummy:
clean: dummy
	$(RM) -f $(OBJS) $(COMPTARGET) $(DOTDS)

allclean: clean

project: $(DOTDS)
	@echo COMPONENT=$(COMPONENT) > .temp.m2p
	@echo SRCFILES=$(SRCFILES) >> .temp.m2p
	@echo IXROOT=$(IXROOT) >> .temp.m2p
	@echo IXAHEADERFILES=$(IXAHEADERFILES) >> .temp.m2p
	@$(ROOTDIR)/Tools/m2p.pl .temp.m2p $(ROOTDIR)/Tools/project.template "$(CFLAGS)" $(LIBDIR) "$(INCLUDEPATH)" $(ROOTDIR)/../workspace/ixa_sdk.wsp
	@rm .temp.m2p

ifneq ($(wildcard $(DOTDS)),)
-include $(DOTDS)
endif
