#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

include $(ROOTDIR)/Rules.make

# A Container should first define the following
# variables, and then include this file
#
# CONTAINER - The container name
#
# COMPONENTS - Subcomponent names
unexport CONTAINER
unexport COMPONENTS
unexport TARGET
unexport COMPONENTSOBJ

COMPONENTSOBJ = $(foreach comp,$(COMPONENTS),$(comp)/$(LIBDIR)/$(comp).o)

TARGET = $(LIBDIR)/$(CONTAINER).o

default: $(TARGET)

$(TARGET): $(COMPONENTSOBJ)
	@echo "------ building container $(basename $(@F)) ------"
	@mkdir -p $(LIBDIR)
	$(LD) $(LD_PARTIAL_FLAGS) -o $@ $(COMPONENTSOBJ)

$(COMPONENTSOBJ): dummy
	@$(MAKE) -C $(basename $(@F))

.PHONY : clean allclean dummy

dummy:

clean: dummy
	rm -f $(TARGET) $(DOTDS)

CLEANDIRS = $(patsubst %, _cleandir_%, $(COMPONENTS))

$(CLEANDIRS): dummy
	$(MAKE) -C $(patsubst _cleandir_%, %, $@) allclean

allclean: $(CLEANDIRS) clean

project:
	@for comp in $(COMPONENTS);\
	do $(MAKE) -C $$comp project; \
	done
	
