/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2002 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/APIImplementations/ATM/inc/if_atm_callback.h,v $
 * $Revision: 1.5 $ 
 * $Date: 2003/11/17 16:57:09 $
 *
 * Description:
 * This file defines the external API which applications use to access
 * ATM functionality.
 *
 ****************************************************************************/
#ifndef __IF_ATM_CALLBACK_H__
#define __IF_ATM_CALLBACK_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Correlator used for IfATM_IfAttrSet function */
typedef struct
{
		IfCorrelator_t *ifCorr;			/* Interface manager corelator */
		NPF_uint64_t	portSpeed;			/* Port Speed */
}IfATM_IfAtmAttrCorrelator_t;

extern NPF_error_t ifAtmOnCB_checkParams(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData,
					FPPI_CONTEXT	 actualContext);

extern NPF_error_t ifAtmOnCB_SendRespToUser(IfATM_RequestCB_t *request);
extern void ifAtmOnCB_VccSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_VccBindFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_VccDelFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_VccEnableFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_VccDisableFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_VccOperStatusGetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_VccStatsGetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_Aal2ChannelSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_Aal2ChannelDelFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_ConnXcSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_ConnXcDelFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamCpSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamCcSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamLbSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamMonitorFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamAlarmSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamAlarmClearFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_OamPmSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_IfAttrSetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_IfDeleteFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_IfEnableFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_IfDisableFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);
extern void ifAtmOnCB_IfGenStatsGetFunc(
					FPPI_FEID       feId,
					FPPI_CORRELATOR correlator,
					FPPI_CONTEXT    context,
					void            *responseData);

 
#ifdef __cplusplus
}
#endif

#endif /* __IF_ATM_CALLBACK_H__ */




