/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/


/*****************************************************************************
* $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/APIImplementations/IPv4/inc/ipv4_modules.h,v $
* $Revision: 1.7 $
* $Date: 2003/11/17 16:57:10 $
*
* Description:
*     Defines the internal APIs used by other Internal IPV4 files.
*****************************************************************************/

#ifndef IPV4_MODULES_H
#define IPV4_MODULES_H

NPF_RET ipv4_InitIPV4Mgr() ;

NPF_RET ipv4_ShutdownIPV4Mgr();

NPF_RET ipv4_InitUserInfo( NPF_userContext_t userContext, NPF_IPv4UC_CallbackFunc_t cbFunc, IPV4UserInfo_t **userInfo);

NPF_RET ipv4_AddInUserListToMgr(IPV4UserInfo_t *userInfo) ;

NPF_RET ipv4_RemoveUserInfo(IPV4UserInfo_t *userInfo);

NPF_RET ipv4_DelInUserListFrmMgr(NPF_callbackHandle_t cbHndl);

NPF_RET ipv4_DeleteTransInfo( IPV4TransInfo_t *transInfo);

NPF_RET ipv4_DeleteUsrReq( IPV4UsrReqInfo_t *reqInfo);


NPF_RET ipv4_InitReqFrmUsr( NPF_correlator_t correlator, NPF_errorReporting_t   appVerb, 
IPV4TableType_t tableType, IPV4TransType_t transType, NPF_IPv4UC_CallbackType_t  reqType,
NPF_callbackHandle_t   cbHandle, NPF_uint32_t   tableHandle, IPV4UsrReqInfo_t   **request) ;


NPF_RET ipv4_CreateFpPfxDataBlock( NPF_IN NPF_uint32_t numEntries, NPF_IN NPF_IPv4UC_Prefix_t *prefixArray,
NPF_IN NPF_uint32_t *nextHopIdArray, NPF_OUT FPPI_UnicastPrefixUpdateInfo_t **pfxBlock) ;

NPF_RET ipv4_DelFpPfxDataBlock(FPPI_UnicastPrefixUpdateInfo_t *pfxBlock);

NPF_RET ipv4_AddNhopCntxtToUsrReq( IPV4UsrReqInfo_t *usrReq, uint32_t nhCount, 
NPF_IPv4UC_NextHopArray_t *nhopArray, uint32_t  *nhIdArray);


NPF_RET ipv4_PrcUserReqToFPForNhopAdd( IPV4UsrReqInfo_t *usrReq, NPF_IN NPF_uint32_t numEntries,
NPF_IN NPF_uint32_t *nextHopIdArray, NPF_IN NPF_IPv4UC_NextHopArray_t *nextHopArrays,
FPPI_UnicastNextHopUpdateInfo_t *fpNhopBlock );

NPF_RET ipv4_PrcUserReqToFPForNhopDel( IPV4UsrReqInfo_t *usrReq, NPF_uint32_t numEntries, 
NPF_uint32_t *nextHopIdArray, FPPI_UnicastNextHopDeleteInfo_t  *fpNhopBlock ) ;
NPF_RET ipv4_PrcUserReqToFPForNhopFlush(FPPI_FEID feId, IPV4UsrReqInfo_t *usrReq, NPF_uint32_t *numEntries,FPPI_UnicastNextHopDeleteInfo_t **fpNHFlushBlock) ;

NPF_RET ipv4_PrcUserReqToFPForArpAdd( NPF_IN IPV4UsrReqInfo_t *usrReq, NPF_IN NPF_uint32_t numEntries,
NPF_IN NPF_IPv4UC_AddResEntry_t *entryArray, FPPI_IPv4UniNHResolEntry_t *fpL2Block  ) ;

NPF_RET ipv4_PrcUserReqToFPForArpDel( IPV4UsrReqInfo_t *usrReq, NPF_IN NPF_uint32_t numEntries, 
NPF_IN NPF_IPv4UC_AddResKey_t *entryArray, FPPI_IPv4UniNHResolEntry_t *fpL2Block );

NPF_RET ipv4_FlushL2Table( IPV4UsrReqInfo_t *usrReq);

/* >>>>>>>>>>>>>>>>>> */

NPF_RET ipv4_ProcessReqFrmUsr( IPV4UsrReqInfo_t *usrReq, IPV4UserInfo_t  **user, 
IPV4TableInfo_t **table);

NPF_RET ipv4_InitTransInfo(IPV4UsrReqInfo_t *usrReq, IPV4UserInfo_t *userInfo,
IPV4TableInfo_t *tableInfo,IPV4TransInfo_t **transInfo) ;

NPF_RET ipv4_AddTableToUsr(IPV4UserInfo_t *userInfo, IPV4TableType_t type) ;

NPF_RET ipv4_RemTableFrmUsr(IPV4UserInfo_t *userInfo, IPV4TableType_t type) ;

NPF_RET ipv4_DelTblCtxtFrmUsr(IPV4UserInfo_t *userInfo, IPV4TableType_t tblType);

NPF_RET ipv4_ProcessReqToFPP(IPV4UsrReqInfo_t *usrReq);

NPF_RET ipv4_FindFEReqByCorrelInFpp( FPPI_FEID feId,
FPPI_CORRELATOR fppi_correlator, IPV4ReqToFEInfo_t **req) ;

NPF_RET ipv4_DelFEReqFrmFpp( FPPI_CORRELATOR fppi_correlator);

NPF_RET ipv4_ExtractFppResponse(
	         NPF_IN npf_IPv4EntryStatusList *fpEntryStatus,
                 NPF_OUT NPF_IPv4UC_CallbackData_t *cbData
		) ;
NPF_RET ipv4_GetTableByHndlFrmUsr(IPV4UserInfo_t *userInfo,IPV4TableType_t tableType, NPF_HANDLE tblHandle, IPV4TableInfo_t  **tableInfo);


NPF_RET ipv4_AllocateFPNhopAddBlock(
           NPF_IN  uint32_t  numEntries,
	        NPF_OUT FPPI_UnicastNextHopUpdateInfo_t **fpNextHopBlock
		       ) ;
NPF_RET ipv4_FreeFPNhopAddBlock(
            uint32_t numEntries,
	         NPF_IN FPPI_UnicastNextHopUpdateInfo_t *fpNextHopBlock
		       ) ;
NPF_RET ipv4_AllocateFPNhopDelBlock( uint32_t  numEntries, FPPI_UnicastNextHopDeleteInfo_t **fpNextHopBlock) ;

NPF_RET ipv4_FreeFPNhopDelBlock(
	         NPF_IN FPPI_UnicastNextHopDeleteInfo_t *fpNextHopBlock
		       ) ;


NPF_RET ipv4_GetUserByHandleFrmMgr(
	NPF_callbackHandle_t cbHndl,
	IPV4UserInfo_t **userInfo
        ) ;

#ifdef IPV4_UNIF_SUPPORT
NPF_RET ipv4_GetNhIdFrmUsr(
		IPV4UserInfo_t *userInfo, 
		NPF_uint32_t *nhId
		) ;
#endif /* IPV4_UNIF_SUPPORT */

NPF_RET ipv4_AddPrefixCntxtToUsrReq(
	IPV4UsrReqInfo_t *usrReq,
	uint32_t         prefixCount,
	NPF_IPv4UC_Prefix_t *prefixArray
   ) ;

NPF_RET ipv4_DupTransInfo(
        IPV4TransInfo_t        *srcTransInfo,
        IPV4TransInfo_t        **dstTransInfo
        ) ;

NPF_RET ipv4_GetHandleFrmMgr(NPF_uint32_t *hndl) ;

NPF_RET ipv4_FreeUsrReq( IPV4UsrReqInfo_t *usrReq);

#endif /* IPV4_MODULES_H */
