/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/****************************************************************
 *  binding_discovery.h                                         *
 *  -------------------                                         *
 * This is the main header file for the Binding and Discovery   *
 * module of the NPF PDK                                        *
 *                                                              *
 ****************************************************************/

#ifndef _BD_H_
#define _BD_H_

#ifdef __cplusplus
extern "C" {
#endif
    
#include "pdk_bd.h"
    
#undef  TRUE
#define TRUE 1
#undef  FALSE
#define FALSE 0
    
 /****************************************************************
 * Callbacks to register with FP Plug in API                    *
 ****************************************************************/

    /* Callback for NPF_FE_BIND event */
extern void on_FEBind_Event( FPPI_FEID fe_id, FPPI_CORRELATOR cb_correlator,
		      FPPI_CONTEXT cb_context, void* response_data );

    /* Callback for NPF_FE_PORT_CAP event */

extern void on_FEPortCap_Event( FPPI_FEID fe_id, FPPI_CORRELATOR cb_correlator,
			 FPPI_CONTEXT cb_context, void* response_data );

 /* Checks if this FE is already present in NS/CM and if its, 
    just activates it
 */
extern int bd_checkFE (FPPI_FEID fe_id, void* response_data, 
		       NPF_HANDLE* fe_hdl);

#ifdef __cplusplus
}
#endif

#endif /* _BD_H_ */
