/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/
 
 
/*****************************************************************************
* $Source: /CODEBASE/ControlPlane/CoreBlocks/NameSpace/inc/ns.h
* $Revision: 1.6 $
* $Date: 2003/11/17 16:57:13 $
*
* Description:
*    The implementation header file of NPF PDK namespace. This is meant to
*	 be included only by namespace.c.
*
* Assumptions:
*     1. PDK Manager initializes and shutdown namespace
*     2. System data like FE and ports are maintained by other PDK modules
*****************************************************************************/
#ifndef _NS_H_
#define _NS_H_

#ifdef __cplusplus
extern "C" {
#endif   

#include <stdio.h>
#include <string.h>
#include "npf_ns_api.h"
#include "pdk_ns.h"
#include "rwlock.h"
#include "list.h"
#include "pdk_cm.h"
#include "log.h"

/* the entry part of a namespace node, which contains the propertis 
   of the current node*/
typedef struct NPF_NS_ENTRY_t
{
	char * name;
	NPF_NSNODETYPE nodeType;
	NPF_DATATYPE   dataType;
	union 
	{
	   NPF_NSHDL  hInstance;
	   NPF_HANDLE hData;
	} entryAttrib;
	int refCount;

} NPF_NS_ENTRY;


/* namespace node has parent, entry part, children, and associates */
typedef struct NPF_NS_NODE_t
{
	struct NPF_NS_NODE_t * 	pParent;
	NPF_NS_ENTRY  			entry;
	DList  					children;
	DList		  			associates;
} NPF_NS_NODE;


#ifdef __cplusplus
}
#endif 

#endif /* _NS_H_ */
