/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/****************************************************************
 *  pkt_hdlr.h                                                  *
 *  ----------                                                  *
 * This is the main header file for the CE Packet Handler module*
 * of the NPF PDK                                               *
 *                                                              *
 ****************************************************************/

#ifndef __PKT_HDLR_H_
#define __PKT_HDLR_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "pdk_cm.h"
#include "list.h"
#include "pil.h"

#include "pdk_vic.h"
#include "pdk_ph.h"
#include "fppapi.h"

#include "npf_ns_types.h"
#include "npf_ns_api.h"
#include "npf_cm_types.h"
#include "pdk_ns_helper.h"

typedef struct {
    char              vi_name[IFNAME_LEN]; /* name of virtual interface */
    IPA               ipaddr;
    IPA               mask;
    char              hwaddr[ETH_ALEN];
    NPF_HANDLE        intf_hdl; /* handle to interface object in C&M*/
    int               isValid; /* indicates if this interface is valid */
    int               vi_fd; /* file descriptor associated with VI device */
    int               num_fes; /* number of FEs this IF belongs to */
    pdk_FEPortList_t* feport_list; /* list of FEs and ports corr. to this VI */
} ph_vif_t;

#ifdef __cplusplus
}
#endif

#endif /* __PKT_HDLR_H__ */


