
#ifndef _VIP_TUNNEL_H_
#define _VIP_TUNNEL_H_

#define SIOCGETTUNNEL   (SIOCDEVPRIVATE + 0)
#define SIOCADDTUNNEL   (SIOCDEVPRIVATE + 1)
#define SIOCDELTUNNEL   (SIOCDEVPRIVATE + 2)
#define SIOCCHGTUNNEL   (SIOCDEVPRIVATE + 3)

#define IPPROTO_VIP 105
#define MAX_MESSAGE_LEN 1500

typedef struct vip_header_t
{
    unsigned int portid;
    unsigned int length;
} vip_header;

struct vip_tunnel_parm
{
	char			name[IFNAMSIZ];
	int			link;
	__u16			i_flags;
	__u16			o_flags;
	__u32			i_key;
	__u32			o_key;
	struct iphdr		iph;
	int			portid;
};

#ifdef __KERNEL__

struct vip_tunnel
{
	struct vip_tunnel	*next;
	struct net_device	*dev;
	struct net_device_stats	stat;

	int			recursion;	/* Depth of hard_start_xmit recursion */
	int			err_count;	/* Number of arrived ICMP errors */
	unsigned long		err_time;	/* Time when the last ICMP error arrived */

	/* These four fields used only by GRE */
	__u32			i_seqno;	/* The last seen seqno	*/
	__u32			o_seqno;	/* The last output seqno */
	int			hlen;		/* Precalculated GRE header length */
	int			mlink;

	struct vip_tunnel_parm	parms;
};

extern int	vipip_init(void);

#endif

#endif /* _VIP_TUNNEL_H_ */
