//////////////////////////////////////////////////////////////////////////////
//           INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//      Copyright (c) 1999-2000 Intel Corporation.  All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////

/*****************************************************************************
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/CoreBlocks/VIDDController/inc/tun_vidd.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:13 $
 *
 * vidd_controller.h
 * --------------------
 * This is the main header file for the VIDD Controller module 
 * of the NPF PDK
 *
 *****************************************************************************/

#ifndef _TUN_VIDD_H_
#define _TUN_VIDD_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "npf_cm_types.h"
#include "pdk_cm.h"
#include "pdk_vic.h"
#include "pdk_callback.h"
#include "fppapi.h"
#include "list.h"
#include "pil.h"
#include "log.h"

extern int tap_open(char *dev, char *hwaddr);
extern int tap_close(int fd, char *dev);
extern int tap_write(int fd, char *buf, int len);
extern int tap_read(int fd, char *buf, int len);
extern int tap_ifup(int fd, char *dev);
extern int tap_ifdown(int fd, char *dev);
extern int tap_ipconfig(int fd, char *dev, uint32_t ipaddr, uint32_t mask);
extern int tap_mtuconfig(int fd, char *dev, uint32_t mtu);
extern int tap_ipconfig6(int fd, char *dev, IPv6A *ipv6addr, int prefix_len);
extern int setlladdr(PDK_VIC_t *vic);

#ifdef __cplusplus
}
#endif

#endif /* _TUN_VIDD_H_ */
