/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#ifndef __VIDD_H
#define __VIDD_H

#ifndef MODVERSIONS
#define MODVERSIONS
#include <linux/modversions.h>
#endif

#ifndef __KERNEL__
#define __KERNEL__
#endif

#include <linux/module.h>
#include <linux/types.h>
#include <linux/sched.h> /* wait_queue, scheduling, sleeping, etc. */
#include <linux/kernel.h> /* printk() */
#include <asm/uaccess.h> /* memcpy, copy_from_user(), etc. */
#include <asm/semaphore.h> /* semaphore functions */
#include <linux/malloc.h> /* kmalloc(), etc. */
/*#include <linux/version.h>*/

#include <linux/if.h>
#include <linux/netdevice.h> /* register_netdev(), etc. */
#include <linux/inetdevice.h>
#include <linux/etherdevice.h> /* ether_setup() */
#include <linux/spinlock.h>
#include <linux/fs.h> /* register_chrdev(), etc. */
#include <linux/errno.h>
#include <linux/ip.h>
#include <linux/in.h>
#include <net/ip.h>
#include <linux/if_ether.h> /* ETH_ALEN, ETH_HLEN, eth_type_trans(), etc. */
#include <linux/poll.h> /* for poll_wait(), select() */

/* Required for using the /proc file system */
#include <linux/proc_fs.h>

#include "viparams.h"

/* More definitions, structures to come later */

struct vif_t
{
    struct vif_params       vi_params;
    struct net_device*      vi_dev;
    struct net_device_stats vi_stats;
    struct proc_dir_entry*  vi_proc_entry;
    struct sk_buff_head     vi_txq;
    wait_queue_head_t       vi_read_wait;
    struct file*            vi_file;
    struct vif_t*           next;
};

struct fe_t
{
    __u32         fe_id;
    struct vif_t* vifs;
    struct fe_t*  next;
};

#endif
