
#ifndef __VIPARAMS_H
#define __VIPARAMS_H

//////////////////////////////////////////////////////////////////////////////
//           INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//      Copyright (c) 1999-2000 Intel Corporation.  All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////

/****************************************************************************
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/CoreBlocks/VIDDController/inc/viparams.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:14 $
 *                                                                          *
 * viparams.h                                                               *
 * ------                                                                   *
 * This contains the virtual interface parameters that need to be accessed  *
 * and/or passed in from user space. Additionally, this also defines the    *
 * ioctls that can be invoked from user space.                              *
 *                                                                          *
 ****************************************************************************/


#ifdef __cplusplus
extern "C" {
#endif

#ifdef __KERNEL__
#include <linux/types.h>
#include <linux/ioctl.h>
#else
#include <sys/types.h>
#include <sys/ioctl.h>
#endif

#define IFNAME_SIZE 16
#define MAC_ADDR_LEN 6

struct vif_params {
    char   name[IFNAME_SIZE]; /* VIF name */
#ifdef __KERNEL__
    __u32  ipaddr;            /* VIF ipaddress*/
    __u32  mask;              /* VIF subnet mask*/
    __u32  fe_id;             /* FE ipaddr this VIF belongs to */
#else
    uint32_t ipaddr;
    uint32_t mask;
    uint32_t fe_id;
#endif
};

    /* this has to be a unique number for each device. Each ioctl
       defined by a driver has to be derived from this number
       Usually, the major number of the device is used by most
       drivers. This is the approach used here also.
    */
#define VID_IOCTL_TYPE              254 

#define VID_ADDVI   _IOW(VID_IOCTL_TYPE, 0, struct vif_params)
#define VID_DELVI   _IOW(VID_IOCTL_TYPE, 1, struct vif_params)
#define VID_CLEANUP _IO(VID_IOCTL_TYPE, 2)
#define VI_IF_DOWN  _IOW(VID_IOCTL_TYPE, 3, struct vif_params)
#define VI_IF_UP    _IOW(VID_IOCTL_TYPE, 4, struct vif_params)

#ifdef __cplusplus
}
#endif

#endif
