/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/DataRelayShim/inc/drspriv.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:14 $
 *
 *
 ****************************************************************************/

#ifndef DRS_PRIV_H
#define DRS_PRIV_H

#ifdef __cplusplus
extern "C" {
#endif

#include "pdk_callback.h"
#include "npf_ds_types.h"
#include "fpp_common.h"

#define POLICY_ID_SIZE    30

/************* Globals *****************/


/************* Internal Methods *****************/

FPPI_RET fppapi_MsgToFP(
    FPPI_FEID        feid,
    FPPI_NHID        nhid,
    FPPI_CORRELATOR  correlator,
    FPPI_CBHANDLE    cbhandle,
    NPF_CBCAT        cbtype,
    void             *policy_list,
    uint32_t         policy_count);

FPPI_RET CopyAndPack(
    NPF_CBCAT             cbtype,
    FPPI_PortID           portid,
    FPPI_NHID             nhid,
    uint32_t  dir,
    uint32_t      tableid,
    uint32_t   instid,
    uint32_t      nexttableid,
    uint32_t   nextinstid,
    uint32_t              policy_count,
    void*                 policy_list,
    void**                outObj);

#ifdef __cplusplus
}
#endif

#endif /* DRS_PRIV_H */

