/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2003 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/TransportPlugin/src/forces.c,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:16 $
 *
 * Description:
 * Contains the utility functions for maintaining ForCESMessages
 *
 ****************************************************************************/

#include "fppapi_types.h"
#include "fppapi.h"
#include "fpp_common.h"
#include "fpppriv.h"

#include "interconnect_api.h"

ForCESMessage newForCESMessage(FEInfo feinfo, uint16_t msg_type,
		uint32_t correlator, size_t size)
{
    ForCESMessage msg;
    void* pbuf;

    if (PL_SUCCESS != pb_getBuffer(feinfo->connectionid,sizeof(forces_header_t)+size,0,&pbuf))
    {
        return 0;
    }
    msg = (ForCESMessage)pbuf;
    msg->header.version = FORCES_VERSION;
    msg->header.flags = 0;
    msg->header.msg_type = htons(msg_type);
    msg->header.cmd_correlator = correlator;

    return msg;
}

void deleteForCESMessage(ForCESMessage msg)
{
    pb_freeBuffer((void*)msg);
}

void ForCESMessageSend(FEInfo feinfo, ForCESMessage msg, size_t size)
{
    if (!feinfo) return;
    if (!msg) return;

    SendDatagram(feinfo->connectionid,(void*)&(msg->header),size+sizeof(forces_header_t),0);
}

int ForCESCheckVersion(uint8_t version)
{
    return (version <= FORCES_VERSION);
}
