/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/inc/fppapi.h,v $
 * $Revision: 1.7 $
 * $Date: 2003/11/17 16:57:17 $
 *
 *
 ****************************************************************************/

#ifndef _FPP_API_H_
#define _FPP_API_H_

#ifdef __cplusplus
extern "C" {
#endif


#include "fpp_common.h"
#include "fppCapabilityTypes.h"
#include "npf_ipv4_types.h"
        
#ifdef _INCLUDE_IPV6
#include "npf_ipv6_types.h"
#endif

#ifdef _INCLUDE_IPV6TM
#include "npf_ipv6tm_types.h"
#endif

#ifdef _INCLUDE_MPLS
#include "fppapi_mpls_types.h"
#endif
#ifdef _INCLUDE_DIFFSERV
#include "npf_ds_types.h"
#endif
#ifdef _INCLUDE_INTSERV
#include "npf_is_types.h"
#endif
#ifdef _INCLUDE_GTP
#include "npf_gtp_types.h"
#endif

#ifdef _INCLUDE_ATM
#include "pdk_cm_types.h"
#include "npf_atm_types.h"
#include "fppapi_atm_types.h"
#endif /* _ATM_ */

    
#define FE_DATA void*

FPPI_RET FPPAPI_register_callback(
    fppapi_callback  callback,
    FPPI_CBHANDLE*   cbhandle,
    NPF_CBCAT        cbtype,
    FPPI_CONTEXT     context);

FPPI_RET FPPAPI_deregister_callback(
    FPPI_CBHANDLE    cbhandle);

FPPI_RET FPPAPI_Initialize (void);
FPPI_RET FPPAPI_Start (void);
FPPI_RET FPPAPI_Shutdown (void);
FPPI_RET FPPAPI_Stop (void);

FPPI_RET FPPAPI_feBind_Reply(
    FPPI_FEID    feid,
    FPPI_Status  status);

FPPI_RET FPPAPI_feCapability_Reply(
    FPPI_FEID    feid);

FPPI_RET FPPAPI_ipv4_unicastAddNextHop(
    FPPI_FEID                        feid,
    FPPI_CORRELATOR                  correlator,
    FPPI_CBHANDLE                    cbhandle,
    NPF_uint32_t                     numEntries,
    FPPI_UnicastNextHopUpdateInfo_t* nhInfo);

/*
FPPI_RET FPPAPI_ipv4_unicastUpdateNextHop(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    FPPI_NHID              nhid,
    NPF_uint32_t           numEntries,
    FPPI_NextHopInfo*      nhInfo);
*/

FPPI_RET FPPAPI_ipv4_unicastDelNextHop(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_uint32_t           numEntries,
    FPPI_UnicastNextHopDeleteInfo_t* nhDelInfo);

/* 
 *  TODO API should change to take a list of
 *  NHop IDs and L2Ids
 *
 */

FPPI_RET FPPAPI_ipv4_unicastFlushNextHop(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_uint32_t           numEntries,
    FPPI_UnicastNextHopDeleteInfo_t* nhFlushInfo);

FPPI_RET FPPAPI_ipv4_unicastQueryNextHop(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_uint32_t           numEntries,
    NPF_uint32_t*          nhid);

FPPI_RET FPPAPI_ipv4_unicastAddPrefix(
    FPPI_FEID                      feid,
    FPPI_CORRELATOR                correlator,
    FPPI_CBHANDLE                  cbhandle,
    NPF_uint32_t                   numEntries,
    FPPI_UnicastPrefixUpdateInfo_t* prfxInfo);

FPPI_RET FPPAPI_ipv4_unicastUpdatePrefix(
    FPPI_FEID                      feid,
    FPPI_CORRELATOR                correlator,
    FPPI_CBHANDLE                  cbhandle,
    NPF_uint32_t                   numEntries,
    NPF_IPv4UC_Prefix_t*           prfxInfo);

FPPI_RET FPPAPI_ipv4_unicastDelPrefix(
    FPPI_FEID                      feid,
    FPPI_CORRELATOR                correlator,
    FPPI_CBHANDLE                  cbhandle,
    NPF_uint32_t                   numEntries,
    NPF_IPv4UC_Prefix_t*           prfxInfo);

FPPI_RET FPPAPI_ipv4_unicastFlushPrefix(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_ipv4_unicastQueryPrefix(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_uint32_t           numEntries,
    NPF_IPv4UC_Prefix_t    *prfxInfo);

FPPI_RET FPPAPI_ipv4_unicastToL2Add(
    FPPI_FEID                    feid,
    FPPI_CORRELATOR              correlator,
    FPPI_CBHANDLE                cbhandle,
    uint32_t                     entry_count,
    FPPI_IPv4UniNHResolEntry_t*  entry_array);

FPPI_RET FPPAPI_ipv4_unicastToL2Del(
    FPPI_FEID                    feid,
    FPPI_CORRELATOR              correlator,
    FPPI_CBHANDLE                cbhandle,
    uint32_t                     entry_count,
    FPPI_IPv4UniNHResolEntry_t*  entry_array);

FPPI_RET FPPAPI_ipv4_unicastToL2Flush(
    FPPI_FEID                                 feid,
    FPPI_CORRELATOR                           correlator,
    FPPI_CBHANDLE                             cbhandle);

FPPI_RET FPPAPI_ipv4_unicastToL2Query(
    FPPI_FEID                                 feid,
    FPPI_CORRELATOR                           correlator,
    FPPI_CBHANDLE                             cbhandle,
    uint32_t                                  numEntries,
    NPF_IPv4UC_AddResKey_t*                   entryArray); 
    
/* Begin: Added for IPv6 API */

#ifdef _INCLUDE_IPV6

FPPI_RET FPPAPI_IPv6PrefixEntryAdd(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_uint32_t           numEntries,
    NPF_IPv6PrefixEntry_t  *entryArray);

FPPI_RET FPPAPI_IPv6PrefixEntryDelete(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_uint32_t           numEntries,
    NPF_IPv6PrefixEntry_t  *entryArray);

FPPI_RET FPPAPI_IPv6PrefixTableFlush(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6PrefixTableAttributeQuery(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6NextHopEntryAdd(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    FPPI_IPv6_UnicastNextHopUpdateInfo_t    *nhInfo);

FPPI_RET FPPAPI_IPv6NextHopEntryDelete(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_IPv6NextHopEntryArray_t    *nhInfo);

FPPI_RET FPPAPI_IPv6NextHopTableFlush(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6NextHopTableAttributeQuery(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6_L2EntryAdd(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_IPv6NbrEntry_t     *entry);

FPPI_RET FPPAPI_IPv6_L2EntryDelete(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    NPF_IPv6NbrEntry_t     *entry);

#endif

/* End: Added for IPv6 API */

FPPI_RET FPPAPI_SendPacket(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    npf_Packet_t           *packet_array,
    uint32_t               packet_count);

FPPI_RET FPPAPI_L2Interface_SetProperties(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    npf_L2IntfAttrs_t      *port_array,
    uint32_t               port_count);

FPPI_RET FPPAPI_L2Interface_GetStatistics(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    FPPI_PortID            *port_array,
    NPF_IfType_t            interface,
    uint32_t               port_count);

FPPI_RET FPPAPI_L3Interface_SetProperties(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    npf_L3IntfAttrs_t      *port_array,
    uint32_t               port_count);

FPPI_RET FPPAPI_L3Interface_DelProperties(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    npf_L3IntfAttrs_t      *port_array,
    uint32_t               port_count);

FPPI_RET FPPAPI_L3Interface_SetPropertiesIPv6(
    FPPI_FEID               feid,
    FPPI_CORRELATOR         correlator,
    FPPI_CBHANDLE           cbhandle,
    npf_L3IntfAttrs_t       *port_array,
    uint32_t                port_count);

FPPI_RET FPPAPI_L3Interface_DelPropertiesIPv6(
    FPPI_FEID               feid,
    FPPI_CORRELATOR         correlator,
    FPPI_CBHANDLE           cbhandle,
    npf_L3IntfAttrs_t       *port_array,
    uint32_t                port_count);

FPPI_RET FPPAPI_L3Interface_GetStatistics(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    FPPI_PortID            *port_array,
    NPF_IfType_t            interface,
    uint32_t               port_count);

FPPI_RET FPPAPI_ICMP_GetStatistics(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    FPPI_PortID            *port_array,
    uint32_t               port_count);

/* MPLS */
#ifdef _INCLUDE_MPLS

FPPI_RET FPPAPI_MPLS_Action(
    FPPI_FEID              feid,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    uint32_t               numEntry,
    FPPI_MPLS_Data_t       *fpData);

#endif

/* DiffServ */

#ifdef _INCLUDE_DIFFSERV

FPPI_RET FPPAPI_QOS_DpeOperation(
    FPPI_FEID             feid,
    FPPI_CORRELATOR       correlator,
    FPPI_CBHANDLE         cbhandle,
    FPPI_DS_Dpe_t         *dpe);

#endif


/* IPV6TM */

#ifdef _INCLUDE_IPV6TM

FPPI_RET FPPAPI_IPv6TM_EnableAuto(
    FPPI_FEID              feid,
    FPPI_PortID            port_id,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6TM_DisableAuto(
    FPPI_FEID              feid,
    FPPI_PortID            port_id,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6TM_EnableConfig(
    FPPI_FEID              feid,
    FPPI_PortID            port_id,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle,
    IPA                    ipv4Addr);

FPPI_RET FPPAPI_IPv6TM_DisableConfig(
    FPPI_FEID              feid,
    FPPI_PortID            port_id,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6TM_Enable6to4(
    FPPI_FEID              feid,
    FPPI_PortID            port_id,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

FPPI_RET FPPAPI_IPv6TM_Disable6to4(
    FPPI_FEID              feid,
    FPPI_PortID            port_id,
    FPPI_CORRELATOR        correlator,
    FPPI_CBHANDLE          cbhandle);

#endif

/* End: Added for IPv6TM */
#ifdef _INCLUDE_GTP

/* Downlink */
FPPI_RET FPPAPI_gtp_rx_setup(
    FPPI_FEID         feid,
    FPPI_CBHANDLE     cbhandle,
    FPPI_CORRELATOR   correlator,
    uint32_t         teid,
    npf_gtp_Config_t *config);

FPPI_RET FPPAPI_gtp_rx_release(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid);

FPPI_RET FPPAPI_gtp_rx_getTunnelInfo(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid);

/* Uplink */
FPPI_RET FPPAPI_gtp_tx_setup(
    FPPI_FEID           feid,
    FPPI_CBHANDLE       cbhandle,
    FPPI_CORRELATOR     correlator,
    uint32_t           teid,
    npf_gtp_Config_t   *config,
    npf_gtp_IuTunnel_t *Iu_Association);

FPPI_RET FPPAPI_gtp_tx_release(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid);

FPPI_RET FPPAPI_gtp_tx_getTunnelInfo(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid);

/* Source RNC */
FPPI_RET FPPAPI_gtp_srnc_relocationCmd(
    FPPI_FEID           feid,
    FPPI_CBHANDLE       cbhandle,
    FPPI_CORRELATOR     correlator,
    uint32_t           teid,
    npf_gtp_IuTunnel_t *Iu_Association);

FPPI_RET FPPAPI_gtp_srnc_suspendRAB(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid);

FPPI_RET FPPAPI_gtp_srnc_relocationComplete(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid);

/* Target RNC */
FPPI_RET FPPAPI_gtp_trnc_relocationCmd(
    FPPI_FEID         feid,
    FPPI_CBHANDLE     cbhandle,
    FPPI_CORRELATOR   correlator,
    uint32_t         teid,
    npf_gtp_Config_t *config);

FPPI_RET FPPAPI_gtp_trnc_relocationComplete(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       teid,
    uint32_t       PDCP_seq_num);

/* intersystem handover */
FPPI_RET FPPAPI_gtp_dataForwardCmd(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t         teid);

FPPI_RET FPPAPI_gtp_suspendRAB(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t         teid);

/* Others */
FPPI_RET FPPAPI_gtp_setBufferSize(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t       buffer_size);

FPPI_RET FPPAPI_gtp_getPDCPSeqNumber(
    FPPI_FEID       feid,
    FPPI_CBHANDLE   cbhandle,
    FPPI_CORRELATOR correlator,
    uint32_t         teid);

#endif

#ifdef _INCLUDE_ATM

FPPI_RET FPPAPI_ATM_IfAttrSetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_IfAtmAttr_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_IfDeleteFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        FPPI_PortID *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_IfEnableFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        FPPI_PortID *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_IfDisableFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        FPPI_PortID *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_IfGenericStatsGetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        FPPI_PortID * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccSetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_IfVcc_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccBindFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_VccBind_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccDeleteFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_VccAddr_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccEnableFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_VccAddr_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccDisableFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_VccAddr_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccOperStatusGetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_VccAddr_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_VccStatsGetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_VccAddr_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_AAL2_ChannelSetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_AAL2_ChannelInfo_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_AAL2_ChannelDeleteFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_AAL2_ConnId_t *info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_ConnectionXcSetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        NPF_ATM_ConnectionXc_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_ConnectionXcDeleteFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        NPF_ATM_ConnectionXc_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_CP_SetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_CP_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_CC_SetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_CC_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_LB_SetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_LB_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_MonitorFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_Mon_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_AlarmSetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_Alarm_t * info,
        uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_AlarmClearFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_Alarm_t * info,
        NPF_uint32_t count);
FPPI_RET FPPAPI_ATM_OAM_PM_SetFunc(
        FPPI_FEID        feid,
        FPPI_CORRELATOR correlator,
        FPPI_CBHANDLE           cbhandle,
        IfATM_OAM_PM_t * info,
        NPF_uint32_t count);
#endif /* _INCLUDE_ATM */

#ifdef __cplusplus
}
#endif
#endif /* _FPP_API_H_ */

