/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/inc/fppapi_types.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:17 $
 *
 *
 ****************************************************************************/

#ifndef _FPP_API_TYPES_H_
#define _FPP_API_TYPES_H_

#include "fpp_common.h"
#include "fppCapabilityTypes.h"
#include "npf_ipv4_types.h"

#ifdef _INCLUDE_MPLS
#include "npf_mpls_types.h"
#endif

#include "npf_ds_types.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef FPPI_TIMING
extern struct timeval report_strt;
#endif

#define POLICY_ID_SIZE    30

typedef struct CB_tag {
        FPPI_CBHANDLE           cbhandle;
        FPPI_CORRELATOR         correlator;
	NPF_CBCAT               cbtype;
        uint32_t                cmdcode;
} CB;

typedef struct PolicyInfo_tag {
        char                    policyId[POLICY_ID_SIZE];
        int                     type;
        void*                   policy;
} PolicyInfo;

typedef struct PolicyKey_tag {
        int                     type;
        void*                   policy;
} PolicyKey;

#ifdef __cplusplus
}
#endif

#endif /* _FPP_API_TYPES_H_ */

