/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2002 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/inc/if_atm.h,v $
 * $Revision: 1.5 $ 
 * $Date: 2003/11/17 16:57:17 $
 *
 * Description:
 * This file defines the external API which applications use to access
 * ATM functionality.
 *
 ****************************************************************************/
#ifndef __IF_ATM_H__
#define __IF_ATM_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _INCLUDE_ATM
extern void IfATM_FreeAtmCbMemory(void *mem);
extern NPF_RET IfATM_IfAttrSet(If_t *ifc, NPF_IfGeneric_t *iface, request_t *req);
extern NPF_RET IfATM_IfDelete(If_t *ifc, request_t *req);
extern NPF_RET IfATM_IfEnable(If_t *ifc, request_t *req);
extern NPF_RET IfATM_IfDisable(If_t *ifc, request_t *req);
extern NPF_RET IfATM_IfGenericStatsGet(If_t *ifc, request_t *req);

extern NPF_error_t ifATM_CreateRequestCB(
				NPF_IfATM_CallbackType_t	cbType,
				NPF_callbackHandle_t			cbHandle,
				NPF_correlator_t				correlator,
				NPF_correlator_t				errorReport,
				NPF_IN NPF_IfHandle_t		ifHandle,
				NPF_uint32_t					numEntries,
				void								*entry,
				IfATM_RequestCB_t				**request);
extern NPF_uint32_t ifATM_GetUserDataSize(
				NPF_IfATM_CallbackType_t	cbType,
				NPF_uint32_t					numEntries);
extern NPF_uint32_t IfATM_CopyUserParam(
				void *destParam,
				void *srcParam,
				NPF_IfATM_CallbackType_t	cbType,
				NPF_uint32_t					numEntries,
				FPPI_PortID		portId);
extern NPF_error_t ifATM_CheckUserParams(
			NPF_IN NPF_callbackHandle_t	if_cbHandle,
			NPF_IN NPF_errorReporting_t if_errorReporting,
			NPF_IN NPF_IfHandle_t ifHandle,
			NPF_IN NPF_uint32_t count,
			NPF_IN void *ptr);


extern NPF_RET IfATM_IfGetFePortFromIfHandle(
				NPF_IfHandle_t ifHandle,
				FPPI_FEID *feId,
				FPPI_PortID	*portId); 

extern NPF_error_t ifATM_ProcessUserRequest(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccBindReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccDelReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccEnableReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccDisableReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccOperStatusGetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessVccStatsGetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessAal2ChanSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessAal2ChanDelReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessConXcSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessConXcDelReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamCpSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamCcSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamLbSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamMonitorReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamAlrmSetReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamAlrmClearReq(IfATM_RequestCB_t	*request);
extern NPF_error_t ifATM_ProcessOamPmSetReq(IfATM_RequestCB_t	*request);

#endif /* _INCLUDE_ATM */

#ifdef __cplusplus
}
#endif

#endif /* __IF_ATM_H__ */
 





