/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/****************************************************************
 *  binding_discovery.h                                         *
 *  -------------------                                         *
 * This is the main header file for the Binding and Discovery   *
 * module of the NPF PDK                                        *
 *                                                              *
 ****************************************************************/
 
#ifndef _PDK_BD_H_
#define _PDK_BD_H_

#ifdef __cplusplus
extern "C" {
#endif
 
#include "npf_cm_types.h"
#include "npf_ns_types.h"
#include "fppapi.h"
#include "pdk_cm.h"
#include "list.h"
#include "pil.h"
#include "fpp_common.h"
 
NPF_RET bd_init();
NPF_RET bd_shutdown();
 
/****************************************************************
 * INTERNAL API. SHOULD NOT BE USED BY EXTERNAL APPLICATIONS    *
 * Callbacks other modules (CM) can register with B&CD          *
 ****************************************************************/
 
typedef void (*BIND_CALLBACK) (
		      /* IN: */ FPPI_FEID fe_id,
                      /* IN: */ NPF_USERCONTEXT context);
 
NPF_RET bd_feBind_register_callback(
                           /* IN: */ NPF_USERCONTEXT context,
                           /* IN: */ BIND_CALLBACK callback,
                           /* OUT:*/ NPF_CBHANDLE* cb_handle );
 
NPF_RET bd_feBind_deregister_callback( NPF_CBHANDLE cb_handle );
 
#ifdef __cplusplus
}
#endif

#endif /* _PDK_BD_H_ */
