/*****************************************************************************
*             INTEL CORPORATION PROPRIETARY INFORMATION
*   This software is supplied under the terms of a license agreement or
*   nondisclosure agreement with Intel Corporation and may not be copied
*   or disclosed except in accordance with the terms of that agreement.
*       Copyright (c) 1999-2000 Intel Corporation.  All Rights Reserved.
*****************************************************************************/

/********************************************************************************
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ControlPlane/inc/pdk_ns_helper.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:18 $
 * 
 * ns_helper.c
 * -----------------                                                        
 * Set of Namespace helper routines
 *********************************************************************************/

#include "npf_ns_types.h"
#include "npf_ns_api.h"
#include "npf_cm_types.h"
#include "pdk_cm.h"

/* Users of the API need to be concerned only with these structures */

typedef struct _pdk_ns_port_ {
    NPF_HANDLE port_hdl;
    FPPI_PortID port_id;
}pdk_port_t;

typedef struct _pdk_ns_fe_portlist_ {
    NPF_HANDLE  fe_hdl;
    FPPI_FEID   fe_id;
    uint32_t    num_ports;
    pdk_port_t* ports;
}pdk_FEPortList_t;


extern NPF_RET pdk_ns_getNSRootHandle (NPF_NSHDL *root_ns_hdl);

extern NPF_RET pdk_ns_getFE_from_If( NPF_HANDLE intf_npf_hdl, 
				     NPF_HANDLE* fe_npf_hdl );

extern NPF_RET pdk_ns_getIntfs_from_FE( NPF_HANDLE fe_npf_hdl,
				 int* num_intfs,
				 NPF_HANDLE* fe_intfs );

extern NPF_RET pdk_ns_getChildItrByType ( NPF_HANDLE root_npf_hdl,
					  NPF_DATATYPE child_type,
					  NODE_ITERATOR* child_itr );

extern NPF_RET pdk_ns_getPort_from_ID ( uint32_t fe_id, FPPI_PortID port_id,
					 NPF_HANDLE* port_npf_hdl );

extern NPF_RET pdk_ns_getFEPorts_from_IF ( NPF_HANDLE if_npf_hdl,
					   int* num_fes,
					   pdk_FEPortList_t** fe_ports );

extern NPF_RET pdk_ns_getFEPorts_from_IF ( NPF_HANDLE if_npf_hdl,
					   int* num_fes,
					   pdk_FEPortList_t** fe_ports );

extern NPF_RET pdk_ns_get_FEs (int        *numFEs,
                               FPPI_FEID  feArray[]);

