#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

# Common makefile variables for NPF PDK
.EXPORT_ALL_VARIABLES:

CONFIG_DEFINES=
ifeq ($(ROOTDIR)/.config,$(wildcard $(ROOTDIR)/.config))
include $(ROOTDIR)/.config
endif

include $(ROOTDIR)/OptionalComponents.make

NPFPDK_PLATFORM  = _PC_
NPFPDK_OS        = _LINUX_
#CWD              = $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

LN=ln
RM=rm
CP=cp
LEX=lex

LATESTKERNEL=2.3.99

TEMPBASE    = $(ROOTDIR)

COMMPATH    = $(TEMPBASE)/common
OEMPATH    = $(TEMPBASE)/oem
COPSPATH    = $(TEMPBASE)/common

ifeq ($(TEAM),CP)
TARG_ARCH=$(TARG_ARCH_CP)
TARG_OS  =$(TARG_OS_CP)
else
TARG_ARCH=$(TARG_ARCH_FP)
TARG_OS  =$(TARG_OS_FP)
endif

ifeq ($(TARG_ARCH),)
TARG_ARCH=IA
endif
ifeq ($(TARG_OS),)
TARG_OS=LINUX
endif

MAGIC_DELIMITER=_

#########################################################################
# Platform specific defines

ifeq ($(TARG_ARCH),IXP)

NPFPDK_PLATFORM  = _IXP_
ARCH_DIR	 = ixp

ifeq ($(TARG_OS),VXWORKS)

NPFPDK_OS        = _VXWORKS_
CPU              = XSCALE
TOOL             = gnu
AR               = ararm
AS               = ccarm
CC               = ccarm
CCC              = ccarm
CFLAGS           = -mcpu=xscale -mapcs-32 -mbig-endian -DRW_MULTI_THREAD -D_REENTRANT -O0 -mno-sched-prolog -fvolatile -fno-for-scope -DCPU=XSCALE -DARMEB -D__vxworks -DOS=VXWORKS
CPP              = ccarm -E -P -xc
CC_DEP		 = ccarm
CCC_DEP		 = ccarm
INCLUDESYSTEM    = -I. -I$(WIND_BASE)/target/h -I$(WIND_BASE)/host/$(WIND_HOST_TYPE)/include/g++-3
DEBUG_FLAGS=
DYN_CFLAGS=
LD               = ldarm
LDFLAGS          = -X -EB -N
LD_PARTIAL_FLAGS = -X -EB -r
NM               = nmarm -g
OS_DIR		 = vxworks
STRP             = striparm

endif

ifeq ($(TARG_OS),MV_LINUX)

NPFPDK_OS        = _LINUX_

CC=xscale_be-gcc
CC_DEP=xscale_be-gcc
CCC=xscale_be-g++
CCC_DEP=xscale_be-g++
AR=xscale_be-ar
LD=xscale_be-ld -X -r
NM=arm_sa_be-nm
CFLAGS = -Wno-cast-align -O0 -g -DCPBIG_ENDIAN -mbig-endian -mapcs-stack-check -mapcs -fstack-check -fno-strict-aliasing
INCLUDESYSTEM    = -I. -Iinc -I/opt/hardhat/devkit/lsp/intel-ixdp2400-arm_xscale_be/linux-2.4.18_mv130/include -I/opt/hardhat/devkit/arm/sa_be/armv4b-hardhat-linux/include/bits -I/opt/hardhat/devkit/arm/sa_be/armv4b-hardhat-linux/include/sys -I/opt/hardhat/devkit/arm/sa_be/armv4b-hardhat-linux/include/g++-3 -I/opt/hardhat/devkit/arm/sa_be/lib/gcc-lib/armv4b-hardhat-linux/2.95.3/include/
CCFLAGS = 
OS_DIR           = linux
STRP             = xscale_be-strip

endif

endif

ifeq ($(TARG_ARCH),IA)

NPFPDK_PLATFORM  = _PC_
ARCH_DIR         = ia

ifeq ($(TARG_OS),MV_LINUX)


NPFPDK_OS        = _LINUX_
TARG=IA
CC=arm_sa_be-gcc 
CC_DEP=arm_sa_be-gcc 
CCC=arm_sa_be-g++ 
CCC_DEP=arm_sa_be-g++ 
AR=arm_sa_be-ar
LD=arm_sa_be-ld
LD_PARTIAL_FLAGS = -X -r
NM=arm_sa_be-nm
CFLAGS =
CCFLAGS =
OS_DIR = linux
STRP = arm_sa_be-strip
INCLUDESYSTEM    = -I. -I/opt/hardhat/devkit/arm/sa_be/target/usr/include/ -I/opt/hardhat/devkit/arm/sa_be/armv4b-hardhat-linux/include/sys -I/opt/hardhat/devkit/arm/sa_be/armv4b-hardhat-linux/include/bits -I/opt/hardhat/devkit/arm/sa_be/armv4b-hardhat-linux/include/g++-3 -I/opt/hardhat/devkit/arm/sa_be/lib/gcc-lib/armv4b-hardhat-linux/2.95.3/include/

endif

ifeq ($(TARG_OS),LINUX)

NPFPDK_OS        = _LINUX_
TARG=IA
CC=gcc
CC_DEP=gcc
CCC=g++
CCC_DEP=g++
AR=ar
LD=ld
LD_PARTIAL_FLAGS = -X -r
NM=nm
CFLAGS =
CCFLAGS =
OS_DIR = linux
STRP = strip

endif

ifeq ($(TARG_OS),VXWORKS)

NPFPDK_OS        = _VXWORKS_
CPU              = PENTIUM
TOOL             = gnu
AR               = arpentium
AS               = ccpentium
CC               = ccpentium
CCC              = ccpentium
CFLAGS           = -g -DRW_MULTI_THREAD -mpentium -O0 -fvolatile -nostdlib -fno-builtin -fno-defer-pop -DCPU=PENTIUM -DOS=VXWORKS
CPP              = ccpentium -E -P -xc
CC_DEP		 = ccpentium
CCC_DEP		 = ccpentium
INCLUDESYSTEM    = -I. -I$(WIND_BASE)/target/h -I$(WIND_BASE)/host/$(WIND_HOST_TYPE)/include/g++-3
DEBUG_FLAGS=
DYN_CFLAGS=
LD               = ldpentium
LDFLAGS          = -X -N
LD_PARTIAL_FLAGS = -X -r
SIZE             = sizepentium
NM               = nmpentium -g
OS_DIR		 = vxworks
STRP             = strippentium

endif

endif

#########################################################################
# Common attributes
CFLAGS+=-Wall -g -D_REENTRANT -Wnested-externs

CONFIG_DEFINES+=-D_TEAM_=$(TEAM) -D_TEAM$(TEAM)_ -D$(NPFPDK_PLATFORM) -D$(NPFPDK_OS)

OBJDIR = obj/$(ARCH_DIR)_$(OS_DIR)
LIBDIR = lib/$(ARCH_DIR)_$(OS_DIR)
BINDIR = bin/$(ARCH_DIR)_$(OS_DIR)

ifeq ($(COLOCATED),YES)
CONFIG_DEFINES+= -DCOLOCATED
endif

ifeq ($(IXASTUBS),YES)
CONFIG_DEFINES+=-DIXASDKSTUBS
endif

ifeq ($(SQESTUBS),YES)
CONFIG_DEFINES+= -DSQESTUBS
endif

ifeq ($(LINUX_MULTI_CLIENT),YES)
CONFIG_DEFINES+= -DLINUX_MULTI_CLIENT
endif

CFLAGS+=$(CONFIG_DEFINES) $(OPTIONAL_COMPONENTS_DEFINES)
