#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

include $(ROOTDIR)/Rules.make

# A Container should first define the following
# variables, and then include this file
#
# FINALCONTAINER - The container name
#
# COMPONENTS - Subcomponent names
# COPSOBJ - Subcomponent names
unexport FINALCONTAINER
unexport COMPONENTS
unexport TARGET
unexport COMPONENTSOBJ
unexport COMMOBJ
unexport SHAREDOBJ
unexport COPSOBJ

COMPONENTSOBJ = $(foreach comp,$(COMPONENTS),$(comp)/$(LIBDIR)/$(comp).o)
COMMOBJ =  $(foreach comp,$(COMMCOMPS),$(COMMPATH)/$(comp)/$(LIBDIR)/$(comp).o)
COPSOBJ =  $(foreach comp,$(COPSCOMPS),$(COPSPATH)/$(comp)/$(LIBDIR)/$(TEAM)$(comp).o)
SHAREDOBJ =  $(foreach comp,$(SHAREDLIBS),$(COMMPATH)/$(comp))

COMMDIRS = $(foreach comp,$(COMMCOMPS),$(COMMPATH)/$(comp))
COPSDIRS = $(foreach comp,$(COPSCOMPS),$(COPSPATH)/$(comp))
SHAREDDIRS = $(SHAREDOBJ)


TARGET = $(LIBDIR)/$(FINALCONTAINER).o

default: $(TARGET)

$(TARGET): $(COMPONENTSOBJ) $(COMMOBJ) $(COPSOBJ) $(SHAREDOBJ)
	@echo "------ building final container $(basename $(@F)) ------"
	@mkdir -p $(LIBDIR)
	$(LD) $(LD_PARTIAL_FLAGS) $(COMPONENTSOBJ) $(COMMOBJ) $(COPSOBJ) -o $@

.PHONY : clean allclean dummy

$(COMPONENTSOBJ): dummy
	@$(MAKE) -C $(basename $(@F))

$(COMMOBJ): dummy
	@$(MAKE) -C $(COMMPATH)/$(basename $(@F))

$(COPSOBJ): dummy
	@$(MAKE) -C $(COPSPATH)/cops

$(SHAREDOBJ): dummy
	@$(MAKE) -C $(COMMPATH)/$(basename $(@F))

dummy:

clean: dummy
	rm -f $(TARGET) $(DOTDS)

CLEANDIRS = $(patsubst %, _cleandir_%, $(COMPONENTS) $(COMMDIRS) $(SHAREDDIRS))

$(CLEANDIRS): dummy
	$(MAKE) -C $(patsubst _cleandir_%, %, $@) allclean

allclean: $(CLEANDIRS) clean

project:
	@for comp in $(COMPONENTS) $(COMMDIRS) $(COPSDIRS) $(SHAREDDIRS);\
	do $(MAKE) -C $$comp project; \
	done
