/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2002 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/DataRelayShim/inc/bepriv.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:18 $
 *
 *
 ****************************************************************************/

#ifndef BE_PRIV_HDR
#define BE_PRIV_HDR

#ifdef __cplusplus
extern "C" {
#endif

#include "fpp_common.h"
#include "msgthreads.h"

/*******************************************************************************
// Structure definitions
*******************************************************************************/

typedef enum {
    drs_FPEvent,
    drs_FPResponse
} drs_FP_Msg_Type;

/******************************************************************************
// Method prototypes
******************************************************************************/

FPPI_RET CopyAndPackFPEvent(
    NPF_CBCAT cbType,
    void*     inObj,
    uint32_t  count,
    void**    outObj);

FPPI_RET CopyAndPackResponse(
    FPPI_Status  status,
    NPF_CBCAT    cbType,
    void*        inObj,
    void**       outObj);

FPPI_RET CopyAndPackFPEvent_atm(
    NPF_CBCAT cbType,
    void*     inObj,
    uint32_t  count,
    void**    outObj);

FPPI_RET CopyAndPackResponse_atm(
    FPPI_Status  status,
    NPF_CBCAT    cbType,
    void*        inObj,
    void**       outObj);


FPPI_RET StuffMsgIntoFPtoCPQueue(
    drs_FP_Msg_Type  msgType,
    NPF_CBCAT        cbType,
    FPPI_FEID        feid,
    FPPI_CORRELATOR  correlator,
    void*            outObj);

FPPI_RET MakeCBIntoFP(
    LPDRS_GENERAL_EVENT_MSG msgPtr);


#ifdef __cplusplus
}
#endif

#endif /* BE_PRIV_HDR */

