/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

/**************************************************************************
*$Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/FPManager/src/fp_mgr-ixasdk30.c,v $
*$Revision: 1.6 $
*$Date: 2003/11/17 16:57:19 $
*****************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <assert.h>
#include <errno.h>

#include "FPManager.h"
#include "pdk_macros.h"
#include "fp_common.h"

/* include file for Resource Manager */
//#include <ix/microace/rm.h>

/* RmSysConfig struct contains the system defined variables like Max Flow ID,
   Max Queue Id, etc. */
//static RmSysConfig      g_rm_sys_config;

/*****************************************************************************
*   Function:   fpmgr_init
*
*   Parameters: None 
*
*   Description: This function creates the ace proxies and sets up the 
*                communication channels to communicate on and also the threads 
*                to communicate with.
*                It also initializes the atubs of the ACE interfaces.
*
*   Return: None 
*****************************************************************************/

int fpmgr_init ()
{
    /* Query Resource Manager for Max Flow ID, Mx Queue ID, etc. */
    PDBG_PRINT ("Initializing communication with Resource Manager!\n");
    //err = RmInit ();

    PDBG_PRINT ("Querying Resource Manager!\n");
    //err = RmGetSysConfig (&g_rm_sys_config);
    /*PDBG_PRINT ("\t Max number of ports = %d \n"
		"\t Max Flow IDs        = %d \n"
		"\t Max Queue IDs       = %d \n",
		g_rm_sys_config.numberOfPorts,
		g_rm_sys_config.maxFlowId,
		g_rm_sys_config.maxQueueId );
	*/
    //g_max_flow_id = g_rm_sys_config.maxFlowId;
    //g_max_queue_id = g_rm_sys_config.maxQueueId;
	/* L2 Manager will set the max number of ports 
	   in the system. RM reports how many hardware
	   ports are there, not the number that is being
	   used by the SDK */
    //g_max_num_ports = g_rm_sys_config.numberOfPorts;

    return 0;
}

/*****************************************************************************
*
*   Function:   fpmgr_shutdown
*
*   Parameters: None 
*
*   Description: This function destroys the ace proxies and deletes the 
*                communication channels to communicate on and also the threads
*                to communicate with.
*                It also destroys the atubs of the ACE interfaces.
*
*   Return: None 
*****************************************************************************/

int fpmgr_shutdown ()
{
    return 0;
}


