/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

/**************************************************************************
*$Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/FPManager/src/fp_mgr-linux.c,v $
*$Revision: 1.6 $
*$Date: 2003/11/17 16:57:19 $
*****************************************************************************/

#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <assert.h>
#include <errno.h>

#include "pdk_macros.h"
#include "fp_common.h"

#ifdef FPM_FPMGR_DEBUG
#define PDBG_PRINT(fmt, args...) printf(fmt,## args)
#define PDBG_TRACE() DBG_TRACE() /* macro */
#define PRETURN(val) RETURN(val)
#else
#define PDBG_PRINT(fmt, args...) /* nothing */
#define PDBG_TRACE() /* nothing */
#define PRETURN(val) { return val; } /* return normally */
#endif

/*****************************************************************************
*   Function:   InitFPEngine()
*
*   Parameters: None 
*
*   Description: This function creates the ace proxies and sets up the 
*                communication channels to communicate on and also the threads 
*                to communicate with.
*                It also initializes the atubs of the ACE interfaces.
*
*   Return: None 
*****************************************************************************/

int fpmgr_init ()
{
    PDBG_TRACE ();

    g_max_flow_id = 255;
    g_max_queue_id = 15;
    g_max_num_ports = 5;

    PRETURN (0);
}

/*****************************************************************************
*
*   Function:   DestroyFPEngine()
*
*   Parameters: None 
*
*   Description: This function destroys the ace proxies and deletes the 
*                communication channels to communicate on and also the threads
*                to communicate with.
*                It also destroys the atubs of the ACE interfaces.
*
*   Return: None 
*****************************************************************************/

int fpmgr_shutdown ()
{
    PDBG_TRACE ();
    PRETURN (0);
}


