/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#include "FPModule.h"
#include "event_mgr_impl.h"

/*************************************************************************
*
*   Function: createEventHandler()
*
*   Parameters:
*        None 
*
*   Description: This function creates the Event Handler thread on which the
*                Event Handler runs 
*
*
*   PRETURN :  NONE
*   PreCondition: The pre-condition is that CE should reply with the 
*                 CEReady Event before this polling thread can be started
*
**************************************************************************/

void fpm_event_mgr_init()
{
    if (event_InitFPEngine() == -1) {
        PDBG_PRINT("Unable to start platform specific event manager\n");
        assert(0);
    }
    return;
}        

void fpm_event_mgr_shutdown()
{
    event_DestroyFPEngine();
    return;
}
