/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2002 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/FPModule/IXASDKStubs/inc/ixasdk_methodmap.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:22 $
 *
 ****************************************************************************/

#ifndef STUBS_METHOD_MAP_HDR
#define STUBS_METHOD_MAP_HDR

#ifdef __cplusplus
extern "C" {
#endif
    
const char * StubsMethodMap(
    uint32_t name);

/* Define IXA SDK API symbols */
#define Method_ix_cc_ipv4_async_add_route                       (0)
#define Method_ix_cc_ipv4_async_delete_route                    (1)
#define Method_ix_cc_ipv4_async_update_route                    (2)
#define Method_ix_cc_ipv4_async_lookup_route                    (3)
#define Method_ix_cc_ipv4_sync_purge_routes                    (4)
#define Method_ix_cc_ipv4_async_dump_routes                     (5)
#define Method_ix_cc_ipv4_async_add_next_hop                    (7)
#define Method_ix_cc_ipv4_async_delete_next_hop                 (8)
#define Method_ix_cc_ipv4_async_update_next_hop                 (9)
#define Method_ix_cc_ipv4_async_get_next_hop                    (10)
#define Method_ix_cc_ipv4_async_purge_rtm                       (11)
#define Method_ix_cc_ipv4_async_dump_next_hops                  (12)
#define Method_ix_cc_ipv4_async_set_mtu                         (13)
#define Method_ix_cc_ipv4_async_set_flags                       (14)
#define Method_ix_cc_ipv4_async_get_sleep_time                  (15)
#define Method_ix_cc_ipv4_async_set_sleep_time                  (16)
#define Method_ix_cc_ipv4_async_get_queue_depth                 (17)
#define Method_ix_cc_ipv4_async_get_packets_to_drain            (18)
#define Method_ix_cc_ipv4_async_set_packets_to_drain            (19)
#define Method_ix_cc_ipv4_async_get_statistics                  (20)
#define Method_ix_cc_ipv4_init                                  (21)
#define Method_ix_cc_ipv4_microblock_high_priority_pkt_handler  (22)
#define Method_ix_cc_ipv4_microblock_low_priority_pkt_handler   (23)
#define Method_ix_cc_ipv4_stkdrv_pkt_handler                    (24)
#define Method_ix_cc_ipv4_common_pkt_handler                    (25)
#define Method_ix_cc_ipv4_delete_route                          (26)
#define Method_ix_cc_ipv4_update_route                          (27)
#define Method_ix_cc_ipv4_lookup_route                          (28)
#define Method_ix_cc_ipv4_purge_routes                          (29)
#define Method_ix_cc_ipv4_dump_routes                           (30)
#define Method_ix_cc_ipv4_add_next_hop                          (31)
#define Method_ix_cc_ipv4_delete_next_hop                       (32)
#define Method_ix_cc_ipv4_update_next_hop                       (33)
#define Method_ix_cc_ipv4_get_next_hop                          (34)
#define Method_ix_cc_ipv4_dump_next_hops                        (35)
#define Method_ix_cc_ipv4_get_sleep_time                        (36)
#define Method_ix_cc_ipv4_set_sleep_time                        (37)
#define Method_ix_cc_ipv4_get_queue_depth                       (38)
#define Method_ix_cc_ipv4_get_packets_to_drain                  (39)
#define Method_ix_cc_ipv4_set_packets_to_drain                  (40)
#define Method_ix_cc_ipv4_get_statistics                        (41)
#define Method_ix_cc_ipv4_set_property                          (42)
#define Method_ix_cc_stkdrv_async_get_num_ports                 (43)
#define Method_ix_cc_stkdrv_async_get_property                  (44)
#define Method_ix_cc_async_set_property                         (45)
#define Method_ix_cc_fpm_sync_del_l2_entry                      (46)
#define Method_ix_cc_fpm_async_add_arp_entry                    (47)
#define Method_ix_cc_fpm_async_purge_arp_table                  (48)
#define Method_ix_cc_fpm_async_get_pos_tx_stats                 (49)
#define Method_ix_cc_pos_rx_async_get_statistics_info           (50)
#define Method_ix_cc_fpm_sync_add_l2_entry                      (51)
#define Method_ix_cc_ipv6_async_add_prefix                      (52)
#define Method_ix_cc_ipv6_async_delete_prefix                   (53)
#define Method_ix_cc_ipv6_async_flush_prefixes                   (54)
#define Method_ix_cc_ipv6_async_add_next_hop                    (55)
#define Method_ix_cc_ipv6_async_update_next_hop                 (56)
#define Method_ix_cc_ipv6_async_delete_next_hop                 (57)
#define Method_ix_cc_ipv6_async_flush_next_hops                 (58)
#define Method_ix_cc_ipv6_async_add_nbr                         (59)
#define Method_ix_cc_ipv6_async_del_nbr                 	    (60)
/*
#define Method_ix_cc_ipv6tm_async_enable_auto                   (61)
#define Method_ix_cc_ipv6tm_async_disable_auto                  (62)
#define Method_ix_cc_ipv6tm_async_enable_config                 (63)
#define Method_ix_cc_ipv6tm_async_disable_config                (64)
#define Method_ix_cc_ipv6tm_async_enable_6to4                   (65)
#define Method_ix_cc_ipv6tm_async_disable_6to4                  (66)
*/
#define Method_ix_cc_v6v4_async_add_end_tunnel                  (61)
#define Method_ix_cc_v6v4_async_delete_end_tunnel               (62)
#define Method_ix_cc_v6v4_async_add_start_tunnel                (63)
#define Method_ix_cc_v6v4_async_delete_start_tunnel             (64)
#define Method_ix_cc_fpm_async_del_arp_entry                    (65)
#define Method_ix_cc_fpm_sync_purge_arp_table                   (66)
#define Method_ix_cc_fpm_async_get_eth_tx_stats                 (67)
#define Method_ix_cc_fpm_async_add_l2_entry                     (68)
#define Method_ix_cc_fpm_async_del_l2_entry                     (69)
#define Method_ix_cc_fpm_register_link_status_cb                (70)

#define Method_ix_cc_fpm_register_link_status_cb                (70)
#define Method_ix_cc_fpm_deregister_link_status_cb	        (71)
#define Method_ix_cc_fpm_register_pkt_hdlr_cb                   (72)
#define Method_ix_cc_fpm_deregister_pkt_hdlr_cb                 (73)
#define Method_ix_cc_fpm_register_ipv4_exception_cb             (74)
#define Method_ix_cc_fpm_deregister_ipv4_exception_cb           (75)
#define Method_ix_cc_eth_rx_async_get_statistics_info           (76)

#ifdef __cplusplus
}
#endif

#endif /* STUBS_METHOD_MAP_HDR */
