/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/
#ifdef _INCLUDE_ATM

#include "npf.h"
#include "cc/ix_cc_atmsar.h"
#include "cc/ix_cc_llc_snap_encap.h"

/* stubs for compilation */
ix_error ix_cc_atmsar_async_vc_create(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_vc_descr_t* arg_pVcDescr,
				ix_cc_atmsar_cb_vc_create_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_vc_create_t)arg_Callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_vc_update(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_vc_handle_t arg_hVc,
				const ix_cc_atmsar_update_data_t* arg_pUpdateData,
				ix_cc_atmsar_cb_vc_update_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_vc_update_t)arg_Callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_vc_remove(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_vc_handle_t arg_hVc,
				ix_cc_atmsar_cb_vc_remove_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_vc_remove_t)arg_Callback(IX_SUCCESS,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_get_vc_stats(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_vc_handle_t arg_hVc,
				ix_cc_atmsar_cb_get_vc_stats_t arg_Callback,
				void *arg_pUserContext)
{
	ix_cc_atmsar_vc_stats_t tempStats;

	/* Call the callback function */
	(ix_cc_atmsar_cb_get_vc_stats_t)arg_Callback(IX_SUCCESS,&tempStats,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_port_create(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_port_descr_t* arg_pPortDescr,
				ix_cc_atmsar_cb_port_create_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_port_create_t)arg_Callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_port_remove(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_port_handle_t arg_port,
				ix_cc_atmsar_cb_port_remove_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_port_remove_t)arg_Callback(IX_SUCCESS,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_get_port_stats(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_port_handle_t arg_port,
				ix_cc_atmsar_cb_get_port_stats_t arg_Callback,
				void *arg_pUserContext)
{
	ix_cc_atmsar_port_stats_t tempStats;

	/* Call the callback function */
	(ix_cc_atmsar_cb_get_port_stats_t)arg_Callback(IX_SUCCESS,&tempStats,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_cid_create(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_cid_descr_t* arg_pCidDescr,
				ix_cc_atmsar_cb_cid_create_t arg_callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_cid_create_t)arg_callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_cid_remove(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_cid_handle_t arg_cid,
				ix_cc_atmsar_cb_cid_remove_t arg_callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_cid_remove_t)arg_callback(IX_SUCCESS,arg_pUserContext);
	return 0;
}

ix_error ix_cc_atmsar_async_get_cid_stats(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_cid_handle_t arg_cid,
				ix_cc_atmsar_cb_get_cid_stats_t arg_callback,
				void *arg_pUserContext)
{
	ix_cc_atmsar_port_stats_t tempStats;

	/* Call the callback function */
	(ix_cc_atmsar_cb_get_cid_stats_t)arg_callback(IX_SUCCESS,&tempStats,arg_pUserContext);
	return 0;
}

/* stubs for compilation */
ix_error ix_cc_fpm_async_vc_create(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_vc_descr_t* arg_pVcDescr,
				ix_cc_atmsar_cb_vc_create_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_vc_create_t)arg_Callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_vc_update(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_vc_handle_t arg_hVc,
				const ix_cc_atmsar_update_data_t* arg_pUpdateData,
				ix_cc_atmsar_cb_vc_update_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_vc_update_t)arg_Callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_vc_remove(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_vc_handle_t arg_hVc,
				ix_cc_atmsar_cb_vc_remove_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_vc_remove_t)arg_Callback(IX_SUCCESS,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_get_vc_stats(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_vc_handle_t arg_hVc,
				ix_cc_atmsar_cb_get_vc_stats_t arg_Callback,
				void *arg_pUserContext)
{
	ix_cc_atmsar_vc_stats_t tempStats;

	/* Call the callback function */
	(ix_cc_atmsar_cb_get_vc_stats_t)arg_Callback(IX_SUCCESS,&tempStats,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_port_create(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_port_descr_t* arg_pPortDescr,
				ix_cc_atmsar_cb_port_create_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_port_create_t)arg_Callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_port_remove(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_port_handle_t arg_port,
				ix_cc_atmsar_cb_port_remove_t arg_Callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_port_remove_t)arg_Callback(IX_SUCCESS,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_get_port_stats(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_port_handle_t arg_port,
				ix_cc_atmsar_cb_get_port_stats_t arg_Callback,
				void *arg_pUserContext)
{
	ix_cc_atmsar_port_stats_t tempStats;

	/* Call the callback function */
	(ix_cc_atmsar_cb_get_port_stats_t)arg_Callback(IX_SUCCESS,&tempStats,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_cid_create(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				const ix_cc_atmsar_cid_descr_t* arg_pCidDescr,
				ix_cc_atmsar_cb_cid_create_t arg_callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_cid_create_t)arg_callback(IX_SUCCESS,1,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_cid_remove(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_cid_handle_t arg_cid,
				ix_cc_atmsar_cb_cid_remove_t arg_callback,
				void *arg_pUserContext)
{
	/* Call the callback function */
	(ix_cc_atmsar_cb_cid_remove_t)arg_callback(IX_SUCCESS,arg_pUserContext);
	return 0;
}

ix_error ix_cc_fpm_async_get_cid_stats(
				const ix_cc_atmsar_instance_t arg_sarInstance,
				ix_cc_atmsar_cid_handle_t arg_cid,
				ix_cc_atmsar_cb_get_cid_stats_t arg_callback,
				void *arg_pUserContext)
{
	ix_cc_atmsar_port_stats_t tempStats;

	/* Call the callback function */
	(ix_cc_atmsar_cb_get_cid_stats_t)arg_callback(IX_SUCCESS,&tempStats,arg_pUserContext);
	return 0;
}


ix_error
ix_cc_llc_snap_encap_async_add_next_hop(
    ix_uint16 nextHop,
    ix_uint8 encapBit,
    ix_uint16 vpi,
    ix_uint16 vci,
    ix_uint16 vcq,
    ix_uint8 dSap,
    ix_uint8 sSap,
    ix_uint8 ctrl,
    ix_uint32 oui,
    ix_uint16 pid,
    ix_cc_llc_snap_encap_cb_add_next_hop pCallback,
    void *pUserContext)
{
	(ix_cc_llc_snap_encap_cb_add_next_hop)pCallback(IX_SUCCESS,pUserContext);

	return 0;
}

ix_error
ix_cc_llc_snap_encap_fpm_add_next_hop(
    ix_uint16 nextHop,
    ix_uint8 encapBit,
    ix_uint16 vpi,
    ix_uint16 vci,
    ix_uint16 vcq,
    ix_uint8 dSap,
    ix_uint8 sSap,
    ix_uint8 ctrl,
    ix_uint32 oui,
    ix_uint16 pid,
    ix_cc_llc_snap_encap_cb_add_next_hop pCallback,
    void *pUserContext)
{
	(ix_cc_llc_snap_encap_cb_add_next_hop)pCallback(IX_SUCCESS,pUserContext);

	return 0;
}

ix_error ix_cc_llc_snap_encap_fpm_del_next_hop(
				ix_uint16 nextHop,
				ix_cc_llc_snap_encap_cb_delete_next_hop pCallback,
				void *pUserContext)
{
	(ix_cc_llc_snap_encap_cb_delete_next_hop)pCallback(IX_SUCCESS,pUserContext);

	return 0;
}



#endif /* _INLCUDE_ATM */
