/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/FPModule/IXASDKStubs/src/ixasdk_methodmap.c,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:23 $
 *
 * Description:
 *      Stringize method names.
 *
 ****************************************************************************/

#include "fpp_common.h"
#include "ixasdk_methodmap.h"

const char * StubsMethodMap(
    uint32_t name)
{

    /* No continuation in macros. GCC gaks when it sees \r\n that
       uses for line termination. */
#define MAPCASE(c)  case c: return(#c)

    switch (name)
    {
        MAPCASE(Method_ix_cc_ipv4_async_add_route);
        MAPCASE(Method_ix_cc_ipv4_async_delete_route);
        MAPCASE(Method_ix_cc_ipv4_async_update_route);
        MAPCASE(Method_ix_cc_ipv4_async_lookup_route);
        MAPCASE(Method_ix_cc_ipv4_sync_purge_routes);
        MAPCASE(Method_ix_cc_ipv4_async_dump_routes);
        MAPCASE(Method_ix_cc_ipv4_async_add_next_hop);
        MAPCASE(Method_ix_cc_ipv4_async_delete_next_hop);
        MAPCASE(Method_ix_cc_ipv4_async_update_next_hop);
        MAPCASE(Method_ix_cc_ipv4_async_get_next_hop);
        MAPCASE(Method_ix_cc_ipv4_async_purge_rtm);
        MAPCASE(Method_ix_cc_ipv4_async_dump_next_hops);
        MAPCASE(Method_ix_cc_ipv4_async_set_mtu);
        MAPCASE(Method_ix_cc_ipv4_async_set_flags);
        MAPCASE(Method_ix_cc_ipv4_async_get_sleep_time);
        MAPCASE(Method_ix_cc_ipv4_async_set_sleep_time);
        MAPCASE(Method_ix_cc_ipv4_async_get_queue_depth);
        MAPCASE(Method_ix_cc_ipv4_async_get_packets_to_drain);
        MAPCASE(Method_ix_cc_ipv4_async_set_packets_to_drain);
        MAPCASE(Method_ix_cc_ipv4_async_get_statistics);
        MAPCASE(Method_ix_cc_ipv4_init);
        MAPCASE(Method_ix_cc_ipv4_microblock_high_priority_pkt_handler);
        MAPCASE(Method_ix_cc_ipv4_microblock_low_priority_pkt_handler);
        MAPCASE(Method_ix_cc_ipv4_stkdrv_pkt_handler);
        MAPCASE(Method_ix_cc_ipv4_common_pkt_handler);
        MAPCASE(Method_ix_cc_ipv4_delete_route);
        MAPCASE(Method_ix_cc_ipv4_update_route);
        MAPCASE(Method_ix_cc_ipv4_lookup_route);
        MAPCASE(Method_ix_cc_ipv4_purge_routes);
        MAPCASE(Method_ix_cc_ipv4_dump_routes);
        MAPCASE(Method_ix_cc_ipv4_add_next_hop);
        MAPCASE(Method_ix_cc_ipv4_delete_next_hop);
        MAPCASE(Method_ix_cc_ipv4_update_next_hop);
        MAPCASE(Method_ix_cc_ipv4_get_next_hop);
        MAPCASE(Method_ix_cc_ipv4_dump_next_hops);
        MAPCASE(Method_ix_cc_ipv4_get_sleep_time);
        MAPCASE(Method_ix_cc_ipv4_set_sleep_time);
        MAPCASE(Method_ix_cc_ipv4_get_queue_depth);
        MAPCASE(Method_ix_cc_ipv4_get_packets_to_drain);
        MAPCASE(Method_ix_cc_ipv4_set_packets_to_drain);
        MAPCASE(Method_ix_cc_ipv4_get_statistics);
        MAPCASE(Method_ix_cc_ipv4_set_property);
        MAPCASE(Method_ix_cc_stkdrv_async_get_num_ports);
        MAPCASE(Method_ix_cc_stkdrv_async_get_property);
        MAPCASE(Method_ix_cc_async_set_property);
        MAPCASE(Method_ix_cc_fpm_sync_del_l2_entry);
        MAPCASE(Method_ix_cc_fpm_async_add_arp_entry);
        MAPCASE(Method_ix_cc_fpm_async_del_arp_entry);
        MAPCASE(Method_ix_cc_fpm_sync_purge_arp_table);
        MAPCASE(Method_ix_cc_fpm_async_get_pos_tx_stats);
        MAPCASE(Method_ix_cc_pos_rx_async_get_statistics_info);
        MAPCASE(Method_ix_cc_fpm_sync_add_l2_entry);
        MAPCASE(Method_ix_cc_ipv6_async_add_prefix);
        MAPCASE(Method_ix_cc_ipv6_async_delete_prefix);
        MAPCASE(Method_ix_cc_ipv6_async_flush_prefixes);
        MAPCASE(Method_ix_cc_ipv6_async_add_next_hop);
        MAPCASE(Method_ix_cc_ipv6_async_delete_next_hop);
        MAPCASE(Method_ix_cc_ipv6_async_flush_next_hops);
        MAPCASE(Method_ix_cc_ipv6_async_add_nbr);
        MAPCASE(Method_ix_cc_ipv6_async_del_nbr);
        /*
        MAPCASE(Method_ix_cc_ipv6tm_async_enable_auto);
        MAPCASE(Method_ix_cc_ipv6tm_async_disable_auto);
        MAPCASE(Method_ix_cc_ipv6tm_async_enable_config);
        MAPCASE(Method_ix_cc_ipv6tm_async_disable_config);
        MAPCASE(Method_ix_cc_ipv6tm_async_enable_6to4);
        MAPCASE(Method_ix_cc_ipv6tm_async_disable_6to4);
        */
        MAPCASE(Method_ix_cc_v6v4_async_add_end_tunnel);
        MAPCASE(Method_ix_cc_v6v4_async_delete_end_tunnel);
        MAPCASE(Method_ix_cc_v6v4_async_add_start_tunnel);
        MAPCASE(Method_ix_cc_v6v4_async_delete_start_tunnel);
	MAPCASE(Method_ix_cc_fpm_async_get_eth_tx_stats);
	MAPCASE(Method_ix_cc_fpm_async_add_l2_entry);
	MAPCASE(Method_ix_cc_fpm_async_del_l2_entry);
	MAPCASE(Method_ix_cc_fpm_register_link_status_cb);
	MAPCASE(Method_ix_cc_fpm_deregister_link_status_cb);	
	MAPCASE(Method_ix_cc_fpm_register_pkt_hdlr_cb);
	MAPCASE(Method_ix_cc_fpm_deregister_pkt_hdlr_cb);
	MAPCASE(Method_ix_cc_fpm_register_ipv4_exception_cb);
	MAPCASE(Method_ix_cc_fpm_deregister_ipv4_exception_cb);
	MAPCASE(Method_ix_cc_eth_rx_async_get_statistics_info);
        default:
            return("Don't know this name!");
    }
}

