/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2002-2003 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor, Release 5
 *
 * = LIBRARY
 *      
 *
 * = MODULE
 *      PH Module Core Component
 *
 * = FILENAME
 *      ix_ph.h
 *
 * = DESCRIPTION
 *      The file declares the global variables and structures used in PH core module 
 *
 * = AUTHOR
 *       Sankaralingam Thirunavukkarasu 
 *       sankaralingam.thirunavukkarasu@intel.com
 *
 * = AKNOWLEDGEMENTS
 *      
 *
 * = CREATION TIME
 *      04/09/2002 (MM/DD/YYYY)
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 **/
#include <linux/config.h>
#include <linux/module.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <asm/uaccess.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/in.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/if_arp.h>
#include <linux/mroute.h>
#include <linux/init.h>
#include <linux/netfilter_ipv4.h>

#include <net/sock.h>
#include <net/ip.h>
#include <net/icmp.h>
#include <net/protocol.h>
#include "net/ipip.h"
#include "net/inet_ecn.h"

#include "ix_ossl.h"

#define  IP_PROTO_VIP 105

/* structure for meta-data */
typedef struct metadata_header_t
{
    unsigned int portid;
    unsigned int length;
} meta_header;

ix_error ix_ph_set_cp_address ( ix_uint32 arg_address );
ix_error ix_ph_receive_packet_fpm(ix_uint32 arg_bladeid, ix_uint32 arg_portid,
		                      ix_uint32 arg_len, char *arg_buffer );
ix_error ix_ph_receive_packet_cp ( struct sk_buff *sk_buff );
ix_error ix_ph_send_packet_fpm ( struct sk_buff *arg_skb_buff );
ix_error ix_ph_send_packet_cp ( ix_uint32 arg_bladeid, ix_uint32 arg_portid, 
		                 ix_uint32 arg_len, char *arg_buffer );


