/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

#ifndef _VXWORKS_
#include <stdint.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <assert.h>
#include <errno.h>

#include "FPModule.h"
#include "pkthndlr_mgr_impl.h"

/* Callback Handles - Callbacks registered with Back end API */
FPPI_CBHANDLE PacketIOCBHdl;

extern NPF_RET ph_init(char* ceaddr);
extern NPF_RET ph_shutdown();

int fpm_pkthndlr_mgr_init(char* host)
{
    ph_init(host);

	return (0);
}

/*****************************************************************************
*
*   Function:   fpm_pkthndlr_mgr_shutdown()
*
*   Parameters: None 
*
*   Description: This function shuts-down the FPModule. It deregisters for 
*                callbacks with the Back-end API, de-initializes the FP Engine
*                Cleans up the threads and sets the FP Manager shutdown flag. It
				 Calls the specific SDK function for respective cleanup.

*				 This function destroys the L3 ace proxy and deletes the 
*                communication channels to communicate on and also the threads
*                to communicate with.
*                It also destroys the stubs of the ACE interfaces.
*
*   Return: None 
*****************************************************************************/

int fpm_pkthndlr_mgr_shutdown ()
{
    ph_shutdown();

    return (FPPI_SUCCESS);
}

