/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#ifndef _VXWORKS_
#include <stdint.h>
#endif

#include "FPModule.h"
#include "qos_mgr_impl.h"

#define _IX_HARDWARE_TYPE_  _IX_HW_2400_
#include "ix_cc_microengines_bindings.h"
#include "bindings.h"
#include "cc/ix_cc_classifier_6t_stats.h"
#include "cc/ix_cc_classifier_6t_api.h"
#include "cc/ix_cc_dscp_classifier_msghlp.h"
#include "cc/ix_cc_tc_meter_msg_helpers.h"
#include "cc/ix_cc_classifier_6t_msg.h"
#include "cc/internal/ix_cc_wred_api.h"
#include "cc/ix_cc_wred_msghlp.h"

ix_error ix_cc_classifier_6t_async_add_entry(ix_cc_classifier_6t_pattern     *arg_pKey,
                                    ix_cc_classifier_6t_result      *arg_pLookupResult,
                                    ix_cc_classifier_6t_cb_add_entry arg_Callback,
                                    void*                            arg_pUserContext)
{
    printf("------------------- ix_cc_classifier_6t_async_add_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_classifier_6t_async_update_entry(ix_cc_classifier_6t_pattern     *arg_pKey,
                                    ix_cc_classifier_6t_result      *arg_pLookupResult,
                                    ix_cc_classifier_6t_cb_add_entry arg_Callback,
                                    void*                            arg_pUserContext)
{
    printf("------------------- ix_cc_classifier_6t_async_update_entry ---------\n");
    arg_pLookupResult->type = IX_CC_CLASSIFIER_6T_QOS;

    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_classifier_6t_async_remove_entry(ix_cc_classifier_6t_pattern     *arg_pKey,
                                    ix_cc_classifier_6t_table_type      arg_Type,
                                    ix_cc_classifier_6t_cb_add_entry arg_Callback,
                                    void*                            arg_pUserContext)
{
    printf("------------------- ix_cc_classifier_6t_async_remove_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_tc_meter_async_add_entry( ix_uint32                arg_nInstance,
                                      ix_cc_tc_meter_parameters * arg_pParams,
                                      ix_cc_tc_meter_callback_op  arg_Callback,
                                      void *                   arg_pContext )
{
    if(arg_pParams->meter_type_id == IX_CC_TC_METER_SRTCM_TYPE)
        printf("------------------- IX_CC_TC_METER_SRTCM_TYPE ---------\n");
    else if(arg_pParams->meter_type_id == IX_CC_TC_METER_TRTCM_TYPE)
        printf("------------------- IX_CC_TC_METER_TRTCM_TYPE ---------\n");
    else 
        printf("------------------- UNKNOWN METER TYPE ---------\n");

    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_tc_meter_async_update_entry(
    ix_uint32 arg_nInstance,
    ix_cc_tc_meter_parameters * arg_pParams,
    ix_cc_tc_meter_callback_op arg_Callback,
    void * arg_pUserContext
  )
{
    printf("------------------- ix_cc_srtcm_async_update_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_tc_meter_async_remove_entry(
    ix_uint32 arg_nInstance,
    ix_cc_tc_meter_callback_op arg_Callback,
    void * arg_pUserContext
  )
{
    printf("------------------- ix_cc_srtcm_async_remove_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_wred_async_add_entry( ix_uint32                arg_nInstance,
                                      ix_cc_wred_parameters * arg_pParams,
                                      ix_cc_wred_callback_default  arg_Callback,
                                      ix_generic_context *     arg_pContext )
{
    printf("------------------- ix_cc_wred_async_add_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_wred_async_update_entry( ix_uint32                arg_nInstance,
                                      ix_cc_wred_parameters * arg_pParams,
                                      ix_cc_wred_callback_default  arg_Callback,
                                      ix_generic_context * arg_pContext )
{
    printf("------------------- ix_cc_wred_async_update_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_wred_async_remove_entry(
    ix_uint32                   arg_nInstance,
    ix_cc_wred_callback_default arg_Callback,
    ix_generic_context * arg_pUserContext
  )
{
    printf("------------------- ix_cc_wred_async_remove_entry ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

#ifdef CLASSIFIER_6T_PACKET_COUNTER_FEATURE
ix_error ix_cc_classifier_6t_async_get_statistics(
    ix_cc_classifier_6t_pattern     *arg_pKey,
    ix_cc_classifier_6t_statistics * arg_pStats,
    ix_cc_classifier_6t_cb_get_statistics arg_Callback,
    void * arg_pUserContext
  )
{
    printf("------------------- ix_cc_classifier_6t_async_get_statistics ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pStats, arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pStats, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}
ix_error ix_cc_classifier_6t_async_get_statistics_def(
    ix_cc_classifier_6t_statistics * arg_pStats,
    ix_cc_classifier_6t_cb_get_statistics arg_Callback,
    void * arg_pUserContext
  )
{
    printf("------------------- ix_cc_classifier_6t_async_get_statistics ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pStats, arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pStats, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}
#endif

ix_error ix_cc_classifier_dscp_async_get_statistics(
            ix_uint16                           arg_inputPort,
            ix_uint8                            arg_dscp,
            ix_cc_classifier_dscp_callback_ex   arg_Callback,
            void                              * arg_pUserContext
          )
{
    static ix_cc_classifier_dscp_statistics stats;
    printf("------------------- ix_cc_classifier_6t_async_get_statistics ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), &stats, arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, &stats, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_tc_meter_async_get_statistics(
    ix_uint32 arg_nInstance,
    ix_cc_tc_meter_statistics * arg_pStats,
    ix_cc_tc_meter_callback_gs arg_Callback,
    void * arg_pUserContext
  )
{
    printf("------------------- ix_cc_tc_meter_async_get_statistics ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pStats, arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pStats, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_wred_async_get_statistics(
    ix_uint32                     arg_nInstance,
    ix_cc_wred_statistics *       arg_pStats,
    ix_cc_wred_callback_get_stats arg_pCallback,
    ix_generic_context *             arg_pUserContext
  )
{
    printf("------------------- ix_cc_wred_async_get_statistics ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_pCallback(getRandom(), arg_pStats, arg_pUserContext);
    #else
    arg_pCallback(IX_SUCCESS, arg_pStats, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_classifier_dscp_async_add_if_config(
            ix_uint16                           arg_inputPort,
            ix_cc_classifier_dscp_result      * arg_pResults,
            ix_cc_classifier_dscp_callback      arg_Callback,
            void                              * arg_pUserContext
          )
{
    printf("------------------- ix_cc_classifier_dscp_async_add_if_config ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_classifier_dscp_async_update_if_config(
            ix_uint16                           arg_inputPort,
            ix_cc_classifier_dscp_result      * arg_pResults,
            ix_cc_classifier_dscp_callback      arg_Callback,
            void                              * arg_pUserContext
          )
{
    printf("------------------- ix_cc_classifier_dscp_async_update_if_config ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

ix_error ix_cc_classifier_dscp_async_remove_if_config(
            ix_uint16                           arg_inputPort,
            ix_cc_classifier_dscp_callback      arg_Callback,
            void                              * arg_pUserContext
          )
{
    printf("------------------- ix_cc_classifier_dscp_async_remove_if_config ---------\n");
    #ifdef GEN_RANDOM_ERROR
    arg_Callback(getRandom(), arg_pUserContext);
    #else
    arg_Callback(IX_SUCCESS, arg_pUserContext);
    #endif
    return(IX_SUCCESS);
}

uint32_t getRandom()
{
    uint32_t x;
    const uint32_t min = 0;
    const uint32_t max = 2;
    srand(time(NULL));
    x = min + rand() % max;
}
