/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c, void **pobj, uint32_t *pcbtype) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/TransportPlugin/inc/funcp.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:49 $
 *
 * Description:
 *
 ****************************************************************************/

#ifndef _FUNCP_H_
#define _FUNCP_H_

#ifdef __cplusplus
extern "C" {
#endif


#define FUNC_SUCCESS 1
#define FUNC_FAILURE 0

typedef uint32_t (*msg_hdlr) (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
typedef uint32_t (*cmd_event_hdlr) (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);

typedef struct __forCES_msg_func_ptr 
{
    uint32_t forces_msg;
    uint32_t cb_type;
    msg_hdlr fp;
} forCES_msg_func_ptr;

typedef struct __forCES_evnt_cmd_ptr 
{
    uint32_t type;
    uint32_t cb_type;
    cmd_event_hdlr fp;
} forCES_evnt_cmd_ptr;

extern forCES_msg_func_ptr msgfp[];

/* Message handlers */
uint32_t FE_Bind_Request_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t FE_Bind_Response_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Capability_Request_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Capability_Response_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Topology_Request_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Topology_Response_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t FE_Start_Operation_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Config_Query_Request_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Config_Query_Response_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t FE_Event_Notification_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Unbind_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);
uint32_t Heartbeat_msgfp (ForCESMessage ,uint32_t , uint32_t, void **, uint32_t *);


/* Command handlers */
uint32_t Forces_NULL_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_Add_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_Update_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_Delete_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_DeleteAll_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_SendPacket_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_QueryStats_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_QueryProps_Cmd_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);

extern forCES_evnt_cmd_ptr cmdfp[];


/* Event handlers */
uint32_t Forces_Port_Event_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_BlockSpecific_Event_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_PacketRedirect_Event_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_Capability_Event_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);

extern forCES_evnt_cmd_ptr evntfp[];


/* Block handlers */
uint32_t Forces_Ingress_Intf_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_Egress_Intf_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
/* uint32_t Forces_IPv4_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *); */
uint32_t Forces_IPv4_Prefix_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv4_NextHop_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_L2_ARP_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_L2_Interface_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_L3_Interface_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_ICMP_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_L3_IPv6_Interface_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6_Prefix_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6_NextHop_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6_L2_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6TM_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6TM_Auto_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6TM_Config_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IPv6TM_6to4_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);

/* MPLS */
#ifdef _INCLUDE_MPLS
uint32_t Forces_MPLS_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
#endif

/* Start of ATM */
#ifdef _INCLUDE_ATM
uint32_t Forces_IfATM_IfAttrSet_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_IfDelete_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_IfEnable_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_IfDisable_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_IfGenStatsGet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccSet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccBind_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccDelete_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccEnable_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccDisable_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccOperStatusGet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_VccStatsGet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_AAL2_ChannelSet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_AAL2_ChannelDel_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_ConnectionXcSet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_ConnectionXcDel_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_CP_Set_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_CC_Set_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_LB_Set_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_Monitor_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_AlarmSet_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_AlarmClear_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
uint32_t Forces_IfATM_OAM_PM_Set_Block_msgfp(ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);

#endif /* _INCLUDE_ATM */
/* start of DS */
uint32_t Forces_DS_Dpe_Block_msgfp (ForCESMessage, uint32_t, uint32_t , uint32_t, void **, uint32_t *);
/* end of DS */
extern forCES_evnt_cmd_ptr blkfp[];

#define MSG_OFFSET 	(FE_Bind_Request - 0)
#define CMD_OFFSET 	(Forces_NULL_Cmd - 0)
#define EVT_OFFSET 	(Forces_Port_Event - 0)
#define BLK_OFFSET 	(Forces_Ingress_Intf_Block - 0)

#define MSG_HANDLER( header, msg, connectid, length, pobject, pcbtype) \
    ( (header->msg_type < FE_Bind_Request) || (header->msg_type > Heartbeat)) ? FUNC_FAILURE \
     : msgfp[(header->msg_type) - MSG_OFFSET].fp(msg,connectid,length, pobject, pcbtype)

#define CMD_HANDLER( cmd, msg, connectid, length, pobject, pcbtype) \
    ( (cmd->cmd_type < Forces_NULL_Cmd) || (cmd->cmd_type >Forces_QueryProps_Cmd )) ? FUNC_FAILURE \
   : cmdfp[(cmd->cmd_type) - CMD_OFFSET].fp(msg,cmd->cmd_type, connectid, length, pobject, pcbtype)

#define EVT_HANDLER( evt, msg, connectid, length, pobject, pcbtype) \
    ( (evt->cmd_type < Forces_Port_Event) || (evt->cmd_type >Forces_Capability_Event )) ? FUNC_FAILURE \
    : evntfp[(evt->cmd_type) - EVT_OFFSET].fp(msg,evt->cmd_type, connectid, length, pobject, pcbtype)

#define BLK_HANDLER( cmd, msg, connectid, length, pobject, pcbtype) \
    ( (cmd->block_type < Forces_Ingress_Intf_Block) || (cmd->block_type >Forces_End_Block )) ? FUNC_FAILURE \
   : blkfp[(cmd->block_type) - BLK_OFFSET].fp(msg,cmd->cmd_type, connectid, length, pobject, pcbtype)

#ifdef __cplusplus
}
#endif

#endif /* _FUNCP_H_ */

