/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/TransportPlugin/src/bereport.c,v $
 * $Revision: 1.7 $
 * $Date: 2003/11/17 16:57:50 $
 *
 * Description:
 * Contains the utility functions for maintaining Back End Reports's
 *
 ****************************************************************************/

#include <assert.h>
#include <string.h>
#include "backendapi.h"
#include "forces_Types.h"
#include "fppencap_forces.h"
#include "fpp_common.h"
#include "bpriv.h"
#include "log.h"

BEReport newBEReport(
        uint32_t connectionid,
        uint32_t cmd_type,
        uint32_t block_type,
        uint32_t status,
		uint32_t corr,
        size_t size)
{
    BEReport rpt;
    forces_command_status_t forcescmd;

    rpt = (BEReport)PIL_AllocateMemory(sizeof(struct BEReport_t),0);

    if (!rpt) return 0;

    rpt->msg = newForCESMessage(connectionid, Config_Query_Response, 
             corr, size+sizeof_forces_command_status_t(&forcescmd));

    if(rpt->msg == NULL)
      return 0;  

    forcescmd.cmd_type = cmd_type;
    forcescmd.block_type = block_type;
    forcescmd.block_handle = 0;
    forcescmd.length = size;
    forcescmd.global_result = status;
    rpt->buf = encapsulate_forces_command_status_t(&forcescmd,(char*)rpt->msg->data);

    rpt->connectionid = connectionid;
    rpt->size = size + sizeof_forces_command_status_t(&forcescmd);

    return rpt;
}

void deleteBEReport(BEReport rpt)
{
    if (!rpt) return;

    deleteForCESMessage(rpt->msg);
    PIL_FreeMemory(rpt);
}

void BEReportSend(BEReport rpt)
{
    if (!rpt) return;

    ForCESMessageSend(rpt->connectionid, rpt->msg, rpt->size);
    PIL_FreeMemory(rpt);
}
