/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/inc/backendapi.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:50 $
 *
 *
 ****************************************************************************/

#ifndef _BACKEND_API_H_
#define _BACKEND_API_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "backendapi_types.h"
#include "pdk_callback.h"
#include "fpp_common.h"


FPPI_RET BENDAPI_register_callback(
    backendapi_callback    callback,
    FPPI_CBHANDLE        *cbhandle,
/*      FPPI_CBTYPE             cbtype, */
        NPF_CBCAT               cbtype,
    FPPI_CONTEXT        context);

FPPI_RET BENDAPI_deregister_callback(
    FPPI_CBHANDLE    cbhandle);

FPPI_RET BENDAPI_Initialize (void);
//FPPI_RET BENDAPI_Start (void);
FPPI_RET BENDAPI_Shutdown (void);
//FPPI_RET BENDAPI_Stop (void);

FPPI_RET BENDAPI_bindRequest(
    char*          ipaddr,
    char*          fename,
    FPPI_FEID      fpFeid,
    FPPI_CBHANDLE  cbhandle);

FPPI_RET BENDAPI_unbindRequest(void);

FPPI_RET BENDAPI_capabilityRequest(
    FPPI_FE_Caps*   fe_caps,
    FPPI_CBHANDLE   cbhandle);

FPPI_RET BENDAPI_sendEvent(
    NPF_CBCAT       event_type,
    void*        event_data);

FPPI_RET BENDAPI_sendPacket(
    npf_Packet_t    *packet_list,
        uint32_t        packet_count);

FPPI_RET BENDAPI_Report_Status(
    FPPI_Status        status,
/*      FPPI_CBTYPE             cbtype, */
        NPF_CBCAT               cbtype,
    FPPI_CBCORRELATOR    cbcorrelator,
    void            *response_data);

FPPI_RET BENDAPI_sendATMEvent(
        NPF_CBCAT       event_type,
        void*           event_data);

FPPI_RET BENDAPI_Report_ATMStatus(
    FPPI_Status       status,
    NPF_CBCAT         cbtype,
    FPPI_CBCORRELATOR cbcorrelator,
    void              *response_data);



#ifdef __cplusplus
}
#endif

#endif /* _BACKEND_API_H_ */

