/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/inc/backendapi_types.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:50 $
 *
 *
 ****************************************************************************/

#ifndef _BACKEND_API_TYPES_H_
#define _BACKEND_API_TYPES_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "pdk_callback.h"
#include "fpp_common.h"
#include "fppCapabilityTypes.h"

typedef struct {
        NPF_CBCAT               cbtype;
        FPPI_CBCORRELATOR       cbcorr;
} ReportKey;

/******************* TPI to FP Data Structs ********************/

#if 0
typedef struct {
    uint32_t route_count;
    npf_ipv4_RouteEntry_t* route_list; /* @!array-length:route_count! */
} npf_ipv4_RouteList_t;

typedef struct {
    uint32_t key_count;
    npf_ipv4_ARPKey_t* key_list; /* @!array-length:key_count! */
} npf_ipv4_ARPKeyList_t;
#endif

/* For adding and deleting IPv4 unicast next hop entries */
typedef struct
{
    FPPI_NHID          nhid;
    uint32_t           numEntries;
    FPPI_NextHopInfo*  nhInfo;/* @!array-length:numEntries! */
} npf_ipv4_UnicastNextHopList_t;

typedef struct 
{
    uint32_t                       numEntries;
    FPPI_UnicastNextHopUpdateInfo_t* nhUpdateInfo; /* @!array-length:numEntries! */
} npf_ipv4_UnicastNextHopUpdateInfoList_t;

typedef struct
{
    uint32_t                       numEntries;
    FPPI_UnicastNextHopDeleteInfo_t* nhDeleteInfo; /* @!array-length:numEntries! */
} npf_ipv4_UnicastNextHopDeleteInfoList_t;

typedef struct 
{
    uint32_t                       numEntries;
    NPF_uint32_t*                  nhIdInfo;
} npf_ipv4_UnicastNextHopQueryList_t;

/* For adding and deleting IPv4 unicast prefix entries */
typedef struct
{
    uint32_t                       numEntries;
    NPF_IPv4UC_Prefix_t*           prfxInfo;/* @!array-length:numEntries! */
} npf_ipv4_UnicastPrefixList_t;

typedef struct
{
    uint32_t                       numEntries;
    FPPI_UnicastPrefixUpdateInfo_t* prefixInfo; /* @!array-length:numEntries! */
} npf_ipv4_UnicastPrefixUpdateInfoList_t;

/* For adding and deleting IPv4 unicast l2 entries */
typedef struct
{
    uint32_t                     numEntries;
    FPPI_IPv4UniNHResolEntry_t*  toL2Info;/* @!array-length:numEntries! */
} npf_ipv4_UnicastToL2List_t;

#ifdef _INCLUDE_IPV6

typedef struct
{
    uint32_t                numEntries;
    NPF_IPv6PrefixEntry_t*  prfxInfo;/* @!array-length:numEntries! */
} npf_ipv6_PrefixList_t;

typedef struct
{
    uint32_t             numEntries;
    FPPI_IPv6NbrEntry_t*  L2Info;/* @!array-length:numEntries! */
} npf_ipv6_L2List_t;


#endif

#ifdef _INCLUDE_IPV6TM

typedef struct {
    FPPI_PortID  portid;
    IPA          destip;
} npf_ipv6tm_Tunnel_t;

#endif

#ifdef __cplusplus
}
#endif

#endif /* _BACKEND_API_TYPES_H_ */
