
/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

/***************************************************************************
*$Source: /cvs/constellations/ixa_3.0/src/cp_pdk/ForwardingPlane/inc/bd_mgr.h,v $
*$Revision: 1.6 $
*$Date: 2003/11/17 16:57:50 $
****************************************************************************/

#ifndef _BD_MANAGER_H
#define _BD_MANAGER_H

#include <stdio.h>
#include <assert.h>
#include <signal.h>
#include "backendapi.h"
#include "pdk_macros.h"

#ifdef TARG_IXP
#include "ix/asl.h"
#include "LinkState.h"
#include "ix/asl/ixbasecc.h"
#include "l3_stub_c.h"
#include "ingress_ace_stub_c.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#endif

/* Initialization and shutdown routines, called by FPManager */
FPPI_RET fpm_bd_mgr_init ();
FPPI_RET fpm_bd_mgr_shutdown ();
FPPI_RET fpm_bd_mgr_start ();

/***  
*   Description: This function is called by Config & Mgmt Manager to 
*                report the FE capabilities it has queried from the
*                underlying platform
***/

void bd_mgr_report_fecaps_cb (uint32_t feid,
			FPPI_FE_Caps* fecaps, uint32_t correlator);

#endif /*_BD_MANAGER_H_ */
