/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

#ifndef _FP_COMMON_H
#define _FP_COMMON_H

uint32_t g_max_flow_id;  /* Max Flow ID supported by the system */
uint32_t g_max_queue_id; /* Max Queue ID supported by the system */
uint32_t g_max_num_ports; /* Max number of ports in the system */
/* Define the Current device configuration. Could be one of:
   IPv4_ROUTER    - simple IPv4 router

   DS_EDGE - QoS in an Edge Router.
             IPv4 Range Classifier, 
	     SRTCM Meter, 
	     Marker,
	     WRED Queue/Buf Mgr, 
	     DRR Scheduler

   DS_CORE - QoS in a Core router. 
             DSCP Classifier,
	     Meter
	     WRED Queue/Buf Mgr
	     DRR Scheduler
	     
   MPLS_LER

   MPLS_LSR

   DS_LER         - MPLS with QoS as an Edge Router

   DS_LSR         - MPLS with QoS as a Core Router
*/

typedef enum {
    IPv4_ROUTER = 1, /* simple IP router */
    IPv6_ROUTER,     /* simple IPv6 router */
    IPv4v6_ROUTER,   /* capable for both v4 and v6 */
    DS_MPLS_LER,     /* MPLS + QoS at the Edge */
    DS_MPLS_LSR,     /* MPLS + QoS in the Core or egress*/
    MPLS,            /* Pure MPLS */
    DS_EDGE,
    DS_CORE
} router_config;

#endif /*_FP_COMMON_H */
