/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

#ifndef _QoS_MANAGER_H
#define _QoS_MANAGER_H

#include <stdio.h>
#include <assert.h>
#include <signal.h>
#include "backendapi.h"
#include "pdk_macros.h"
#include "log.h"

/* Initialization and shutdown routines, called by FPManager */
int fpm_qos_mgr_init();
int fpm_qos_mgr_shutdown();

/* Function for getting QoS capabilitites, called by B&D */
int fpm_qos_getCaps (FPPI_FE_Caps* qos_caps);


/*  #define QOS_DBG_PRINT(lvl, fmt, args...) printf(fmt,## args) */
/*  #define QOS_DBG_TRACE() DBG_TRACE() */
/*  #else */
/*  #define QOS_DBG_PRINT(lvl, fmt, args...) */
/*  #define QOS_DBG_TRACE() */
/*  #endif */

#ifdef FPM_QOSMGR_DEBUG
#define QOS_DBG_TRACE() npf_logger_Write(LOG_FP_QOS, LOG_TRACE, "%s\n", "entering");
#ifdef PRETURN
#undef PRETURN
#endif
#define PRETURN( val ) \
    { \
        npf_logger_Write(LOG_FP_QOS, LOG_TRACE, "%s\n", "leaving"); \
        return val; \
    }

#define QOS_DBG_PRINT( lvl, fmt, args... ) \
        npf_logger_Write(LOG_FP_QOS, lvl, fmt, ## args)
#endif

#define QOS_LOCK() PIL_EnterCriticalSection( &g_qos_global_lock )
#define QOS_UNLOCK() PIL_LeaveCriticalSection( &g_qos_global_lock )

/*****************************************************************************
* Name: CHK_INIT
*
* Description:
*     Utility macro used to check if the
*     component is properly initialized.
*
*/

#define CHK_INIT() \
    if ( !g_initialized ) {\
        return NPF_COMPONENT_UNINITIALIZED;\
    }

#endif /*_QOS_MANAGER_H_ */
