#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

# This makefile defines the variables for which features to include in NPF PDK

# Optional Features Available include:
#IPV6      : IP version 6 Module
#IPV6TM    : IP version 6 in version 4 Module
#INTSERV   : Integrated Services Module
#DIFFSERV  : Differentiated Services Module
#MPLS      : Multi Protocol Label Switching Module
#ATM       : Aysnchronous Transfer Mode Module
#GTP       : GTP Module
#MULTIFE   : Multiple FEs present in system.

# Dependencies:
#	INTSERV depends on DIFFSERV
#	MULTIFE - currently disabled


# Setting optional components to include
OPTIONAL_COMPONENTS_TO_INCLUDE= \
#  DIFFSERV    \
#  IPV6        \
#  IPV6TM      \
#  MPLS        \
#  ATM         \
#  INTSERV     \
#  GTP         \
#  MULTIFE     \

# Checking dependencies
# IPv6 is present
ifneq (,$(findstring IPV6,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += IPV6

# IPv6TM has dependency on IPv6
ifneq (,$(findstring IPV6TM,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += IPV6TM
endif
endif

# MPLS is present
ifneq (,$(findstring MPLS,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += MPLS
endif

# ATM is present
ifneq (,$(findstring ATM,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += ATM
endif

# GTP is present
ifneq (,$(findstring GTP,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += GTP
endif

# DIFFSERV is present
ifneq (,$(findstring DIFFSERV,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += DIFFSERV

#INTSERV has dependency on DIFFSERV
ifneq (,$(findstring INTSERV,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
OPTIONAL_COMPONENTS_TO_INCLUDE += INTSERV
endif

endif

#MULTIFE is in options
#ifneq (,$(findstring MULTIFE,$(OPTIONAL_COMPONENTS_TO_INCLUDE)))
#OPTIONAL_COMPONENTS_TO_INCLUDE += MULTIFE
#endif

#set the flags for including optional components to pdk code
OPTIONAL_COMPONENTS_DEFINES=$(foreach comp,$(OPTIONAL_COMPONENTS_TO_INCLUDE),-D_INCLUDE_$(comp))
OPTIONAL_COMPONENTS_MAKE=$(foreach comp,$(OPTIONAL_COMPONENTS_TO_INCLUDE),MAKE_$(comp))
