/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#include <errno.h>
#include <stdio.h>
#include <ctype.h>
#include "hwaddr.h"
//#include <net/inet.h>
#include <net/if_arp.h>

/*
   Input an Ethernet address and convert to binary.
   input:  bufp = "00:AA:BB:CC:DD:EE" or "00AABBCCDDEE"
   output: sap->sa_family = ARPHRD_ETHER;
           sap->sa_data = unsigned char[6] type
 */
int npf_hwaddr_char2saddr ( char *bufp, struct sockaddr *sap ) 
{
    int a[ETH_ALEN]; 
    int j = 0;
    sap->sa_family = ARPHRD_ETHER;
    if ( sscanf ( bufp, "%02X:%02X:%02X:%02X:%02X:%02X", 
		  &a[0], &a[1], &a[2], &a[3], &a[4], &a[5])  == ETH_ALEN ) 
    {
	/*If the Ethernet Address has the format AA:BB:CC:DD:EE:FF, 
	  then a[0], a[1], a[2] have the values 170, 187, 204 etc., */
    } 
    else if ( sscanf ( bufp, "%02X%02X%02X%02X%02X%02X%02X%02X", 
		       &a[0], &a[1], &a[2], &a[3], &a[4], &a[5]) == ETH_ALEN ) 
    {
	/* If the Ethernet Address has the format AABBCCDDEEFF then 
	   a[0],a[1],a[2] have the values 170,187,204 etc.,*/
    }
    else 
    {
#ifdef DEBUGA
	fprintf (stderr, "\nInvalid format/address \n", orig);
#endif /* DEBUGA */
	errno = EINVAL;
	return (-1);
    }

    for ( j=0 ; j < ETH_ALEN; j++ ) 
    {
	sap->sa_data[j] = a[j] & 0xff;
    }
    return 0;
}

