/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#include "npf.h"
#include "npf_common.h"
#include "fppdecap.h"
#include "fppdecap_npf.h"
#include "npf_ds.h"
#include "fppCapabilityTypes.h"

char* encapsulate_NPF_DS_ErrorType_t (
        NPF_DS_ErrorType_t* a,
        char* buf
        );

char* decapsulate_NPF_DS_Counter_t (
        NPF_DS_Counter_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Counter_t (
        NPF_DS_Counter_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_DpeHandle_t (
        NPF_DS_DpeHandle_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DpeHandle_t (
        NPF_DS_DpeHandle_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_Filter_t (
        NPF_DS_Filter_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Filter_t (
        NPF_DS_Filter_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_MarkerEntry_t (
        NPF_DS_MarkerEntry_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MarkerEntry_t (
        NPF_DS_MarkerEntry_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        uint32_t l,
        char* buf
        );

char* decapsulate_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a,
        uint32_t l,
        char* buf
        );
char* decapsulate_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        char* buf
        );
char* decapsulate_array_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        uint32_t l,
        char* buf
        );
