/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/common/Encap/inc/fppencap.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:51 $
 *
 * Description:
 * This file defines the encapsulate functions
 *
 ****************************************************************************/

#include "ipaddr.h"
#include "hwaddr.h"

char* encapsulate_char ( char* c, char* buf );
#define encapsulate_unsignedchar encapsulate_char 
#define sizeof_unsignedchar(a) sizeof(char)
#define encapsulate_BOOL encapsulate_char 
#define sizeof_BOOL(a) sizeof(char)

char* encapsulate_array_char ( char* a, uint32_t l, char* buf );

#define encapsulate_int8_t encapsulate_char 

char* encapsulate_uint16_t ( uint16_t* i, char* buf );
#define encapsulate_int16_t encapsulate_uint16_t
#define encapsulate_int    encapsulate_uint16_t 

char* encapsulate_array_uint16_t ( uint16_t* a, uint32_t l, char* buf );
#define encapsulate_array_int16_t encapsulate_array_uint16_t

char* encapsulate_uint32_t ( uint32_t* i, char* buf );
#define encapsulate_int32_t encapsulate_uint32_t
#define encapsulate_longint encapsulate_uint32_t
#define sizeof_longint(a) sizeof(long int)

char* encapsulate_array_uint32_t ( uint32_t* a, uint32_t l, char* buf );
#define encapsulate_array_int32_t encapsulate_array_uint32_t

char* encapsulate_uint64_t ( uint64_t* i, char* buf );
#define encapsulate_int64_t encapsulate_uint64_t

char* encapsulate_array_uint64_t ( uint64_t* a, uint32_t l, char* buf );
#define encapsulate_array_int64_t encapsulate_array_uint64_t

char *encapsulate_IPv6A ( IPv6A* a, char* buf );
#define sizeof_IPv6A(a) (sizeof(uint32_t)*4)

char *encapsulate_HWADDR( HWADDR* a, char* buf );
#define sizeof_HWADDR(a) (sizeof(char)*MAX_ADDR_LEN)

char *encapsulate_IPADDR( IPADDR* a, char* buf );
#define sizeof_IPADDR(a) (sizeof(uint32_t))

#define encapsulate_time_t encapsulate_uint32_t
#define sizeof_time_t(a) sizeof(uint32_t)
