/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#include "fppdecap.h"
#include "fppdecap_npf_common.h"
#include "fppdecap_npf_ds.h"
#include "fppCapabilityTypes.h"

char* decapsulate_NPF_DS_Counter_t (
        NPF_DS_Counter_t* i,
        char* buf
        )
{
    uint32_t tmp;
    tmp = ntohl(*(uint32_t*)buf);
    *i = tmp;
    *i = *i << sizeof(uint32_t);
    tmp = ntohl(*(uint32_t*)&buf[4]);
    *i = *i | tmp;
    /**i = ntohl(*(uint64_t*)buf);*/
    return buf + sizeof(uint64_t);
}

char* decapsulate_NPF_DS_DpeDirection_t (
        NPF_DS_DpeDirection_t* a,
        char* buf
        )
{
    buf = (char *)decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_NPF_DS_DpeHandle_t (
        NPF_DS_DpeHandle_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_NPF_DS_ErrorType_t (
        NPF_DS_ErrorType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DpeType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = decapsulate_NPF_IPv4Address_t(&(a->dstAddr),buf);
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->dstNetpLen = tmp;
    buf = decapsulate_NPF_IPv4Address_t(&(a->srcAddr),buf);
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->srcNetpLen = tmp;
    buf = decapsulate_NPF_uint32_t(&(a->dscp),buf);
    buf = decapsulate_NPF_uint32_t(&(a->protocol),buf);
    buf = decapsulate_NPF_uint32_t(&(a->dstL4Port),buf);
    buf = decapsulate_NPF_uint32_t(&(a->srcL4Port),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_IPV4_Filter_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_DSCP_Filter_t (
        NPF_DS_DSCP_Filter_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->dscp = tmp;
    return buf;
}

char* decapsulate_array_NPF_DS_DSCP_Filter_t (
        NPF_DS_DSCP_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DSCP_Filter_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = decapsulate_NPF_IPv6Address_t(&(a->dstAddr),buf);
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->dstNetpLen = tmp;
    buf = decapsulate_NPF_IPv6Address_t(&(a->srcAddr),buf);
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->srcNetpLen = tmp;
    buf = decapsulate_NPF_uint32_t(&(a->fid),buf);
    buf = decapsulate_NPF_uint32_t(&(a->dscp),buf);
    buf = decapsulate_NPF_uint32_t(&(a->protocol),buf);
    buf = decapsulate_NPF_uint32_t(&(a->dstL4Port),buf);
    buf = decapsulate_NPF_uint32_t(&(a->srcL4Port),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_IPV6_Filter_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MPLS_FilterType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_MPLS_FilterType_t(&(a->type),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MPLS_Filter_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_ClassifierType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_ClassifierType_t(&(a->type),buf);
    buf = decapsulate_NPF_uint32_t(&(a->precedence),buf);
    switch(a->type)
    {
	case NPF_DS_IPV4_FILTER:
	    buf = decapsulate_NPF_DS_IPV4_Filter_t(&a->filterEntry.filter_IPV4, buf);
	break;
	case NPF_DS_DSCP_FILTER:
	    buf = decapsulate_NPF_DS_DSCP_Filter_t(&a->filterEntry.filter_DSCP, buf);
	break;
	case NPF_DS_IPV6_FILTER:
	    buf = decapsulate_NPF_DS_IPV6_Filter_t(&a->filterEntry.filter_IPV6, buf);
	break;
	case NPF_DS_MPLS_FILTER:
	    buf = decapsulate_NPF_DS_MPLS_Filter_t(&a->filterEntry.filter_MPLS, buf);
	break;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Classifier_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MeterType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MarkerType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->greenDscp = tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->yellowDscp = tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->redDscp = tmp;
    return buf;
}

char* decapsulate_array_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DSCP_Marker_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_MarkerType_t(&(a->type),buf);
    buf = decapsulate_NPF_boolean_t(&(a->statsRequired),buf);
    switch(a->type)
    {
	case NPF_DS_MARKER_DSCP:
	case NPF_DS_MARKER_MPLS:
    	    buf = (char *)decapsulate_NPF_DS_DSCP_Marker_t(&(a->markerEntry.dscp),buf);
	break;
	default:
	/*
	case NPF_DS_MARKER_MPLS:
    	    buf = (char *)decapsulate_NPF_DS_MPLS_Marker_t(&(a->markerEntry.label),buf);
	break;
	*/
    }
    return buf;
}

char* decapsulate_array_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Marker_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_uint32_t(&(a->cir),buf);
    buf = decapsulate_NPF_uint32_t(&(a->pir),buf);
    buf = decapsulate_NPF_uint32_t(&(a->cbs),buf);
    buf = decapsulate_NPF_uint32_t(&(a->pbs),buf);
    buf = decapsulate_NPF_uint32_t(&(a->ebs),buf);
    buf = decapsulate_NPF_DS_DpeType_t(&(a->nextGreenDpe),buf);
    buf = decapsulate_NPF_DS_DpeType_t(&(a->nextYellowDpe),buf);
    buf = decapsulate_NPF_DS_DpeType_t(&(a->nextRedDpe),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MeterEntry_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_MeterType_t(&(a->type),buf);
    buf = decapsulate_NPF_boolean_t(&(a->statsRequired),buf);
    buf = decapsulate_NPF_DS_MeterEntry_t(&(a->meterEntry),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Meter_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DropperType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->maxThreshold = tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->minThreshold = tmp;
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->maxProbability = tmp;
    return buf;
}

char* decapsulate_array_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_RED_Instance_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_RED_Instance_t(&(a->green),buf);
    buf = decapsulate_NPF_DS_RED_Instance_t(&(a->yellow),buf);
    buf = decapsulate_NPF_DS_RED_Instance_t(&(a->red),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DropperEntry_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = decapsulate_NPF_uint32_t(&(a->serviceRate),buf);
    buf = decapsulate_NPF_uint32_t(&tmp,buf);
    a->weight = tmp;
    buf = decapsulate_NPF_DS_DropperType_t(&(a->type),buf);
    buf = decapsulate_NPF_boolean_t(&(a->statsRequired),buf);
    buf = decapsulate_NPF_DS_DropperEntry_t(&(a->dropperEntry),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Dropper_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_QueueType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_ClassType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_uint32_t(&(a->priority),buf);
    buf = decapsulate_NPF_uint32_t(&(a->abs),buf);
    buf = decapsulate_NPF_uint32_t(&(a->rel),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MinRate_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_uint32_t(&(a->level),buf);
    buf = decapsulate_NPF_uint32_t(&(a->abs),buf);
    buf = decapsulate_NPF_uint32_t(&(a->rel),buf);
    buf = decapsulate_NPF_uint32_t(&(a->threshold),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_SlMaxRate_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_uint32_t(&(a->maxRateCount),buf);
    if (a->maxRateCount)
    {
        a->maxRateList = (NPF_DS_SlMaxRate_t*)malloc(sizeof(NPF_DS_SlMaxRate_t)*a->maxRateCount);
        buf = decapsulate_array_NPF_DS_SlMaxRate_t(a->maxRateList,a->maxRateCount,buf);
    }
    else
    {
        a->maxRateList = NULL;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MlMaxRate_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MaxRateType_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_MaxRateType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_SL_MAXRATE:
            buf = decapsulate_NPF_DS_SlMaxRate_t(&(a->maxRate.slMaxRate),buf);
            break;
        case NPF_DS_ML_MAXRATE:
            buf = decapsulate_NPF_DS_MlMaxRate_t(&(a->maxRate.mlMaxRate),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MaxRate_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_QueueType_t(&(a->type),buf);
    buf = decapsulate_NPF_DS_ClassType_t(&(a->classId),buf);
    buf = decapsulate_NPF_DS_MinRate_t(&(a->minRate),buf);
    buf = decapsulate_NPF_DS_MaxRate_t(&(a->maxRate),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Q_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        char* buf
        )
{
    buf = decapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* decapsulate_array_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_SchedMethod_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_SchedMethod_t(&(a->type),buf);
    buf = decapsulate_NPF_DS_MinRate_t(&(a->minRate),buf);
    buf = decapsulate_NPF_DS_MaxRate_t(&(a->maxRate),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Scheduler_t(a,buf);
    }
    return buf;
}

char* decapsulate2_NPF_DS_Dpe_t (
	NPF_DS_DpeType_t type,
        NPF_DS_Dpe_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_DpeType_t(&(a->type),buf);
    switch(type)
    {
        case NPF_DS_CLASSIFIER:
            buf = decapsulate_NPF_DS_Classifier_t(&(a->u.classifier),buf);
            break;
        case NPF_DS_MARKER:
            buf = decapsulate_NPF_DS_Marker_t(&(a->u.marker),buf);
            break;
        case NPF_DS_METER:
            buf = decapsulate_NPF_DS_Meter_t(&(a->u.meter),buf);
            break;
        case NPF_DS_DROPPER:
            buf = decapsulate_NPF_DS_Dropper_t(&(a->u.dropper),buf);
            break;
        case NPF_DS_QUEUE:
            buf = decapsulate_NPF_DS_Q_t(&(a->u.queue),buf);
            break;
        case NPF_DS_SCHEDULER:
            buf = decapsulate_NPF_DS_Scheduler_t(&(a->u.scheduler),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* decapsulate_FPPI_DS_Dpe_t (
        FPPI_DS_Dpe_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_CallbackType_t(&(a->op),buf);
    buf = decapsulate_NPF_DS_DpeType_t(&(a->type),buf);
    buf = decapsulate_NPF_DS_ErrorType_t(&(a->error),buf);
    buf = decapsulate_NPF_DS_DpeHandle_t(&(a->dpeHandle),buf);
    buf = decapsulate_NPF_DS_DpeHandle_t(&(a->prevDpeHandle),buf);
    buf = decapsulate_FPPI_PortID(&(a->port),buf);
    buf = decapsulate_NPF_DS_DpeDirection_t(&(a->dir),buf);
    if(a->op == NPF_DS_DPE_CREATE || a->op == NPF_DS_DPE_QUERY)
    {
	buf = decapsulate_NPF_DS_Dpe_t(&a->u.dpe, buf);
    }
    else if(a->op == NPF_DS_DPE_MODIFY)
    {
	buf = decapsulate2_NPF_DS_Dpe_t(a->type, &a->u.dpe, buf);
    }
    else if(a->op == NPF_DS_DPE_STATISTICS)
    {
	buf = decapsulate_NPF_DS_StatsResp_t(a, buf);
    }
    return(buf);
}

char* decapsulate_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_DpeType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_CLASSIFIER:
            buf = decapsulate_NPF_DS_Classifier_t(&(a->u.classifier),buf);
            break;
        case NPF_DS_MARKER:
            buf = decapsulate_NPF_DS_Marker_t(&(a->u.marker),buf);
            break;
        case NPF_DS_METER:
            buf = decapsulate_NPF_DS_Meter_t(&(a->u.meter),buf);
            break;
        case NPF_DS_DROPPER:
            buf = decapsulate_NPF_DS_Dropper_t(&(a->u.dropper),buf);
            break;
        case NPF_DS_QUEUE:
            buf = decapsulate_NPF_DS_Q_t(&(a->u.queue),buf);
            break;
        case NPF_DS_SCHEDULER:
            buf = decapsulate_NPF_DS_Scheduler_t(&(a->u.scheduler),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_Dpe_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_DpeHandle_t(&(a->dpeHandle),buf);
    buf = decapsulate_NPF_DS_DpeHandle_t(&(a->prevDpeHandle),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DpeSetHandle_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_Counter_t(&(a->defaultPackects),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->defaultBytes),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->totalBytes),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->totalPackets),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_ClassifierStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_Counter_t(&(a->greenByteCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->greenPacketCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->yellowByteCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->yellowPacketCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->redByteCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->redPacketCount),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_ColorAwareMeterStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_Counter_t(&(a->confByteCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->confPacketCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->nonConfByteCount),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->nonConfPacketCount),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_SimpleMeterStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_MeterType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_TRTCM_AWARE:
        case NPF_DS_SRTCM_AWARE:
            buf = decapsulate_NPF_DS_ColorAwareMeterStats_t(&(a->u.colorAwareStats),buf);
            break;
        case NPF_DS_SIMPLE_TB:
            buf = decapsulate_NPF_DS_SimpleMeterStats_t(&(a->u.simpleStats),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MeterStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_Counter_t(&(a->bytesMarked),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->packetsMarked),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_MarkerStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_Counter_t(&(a->greenByteDropped),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->greenPacketDropped),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->yellowByteDropped),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->yellowPacketDropped),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->redByteDropped),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->redPacketDropped),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_ColorAwareDropperStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_Counter_t(&(a->bytesConsumed),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->packetsConsumed),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->bytesDropped),buf);
    buf = decapsulate_NPF_DS_Counter_t(&(a->packetsDropped),buf);
    return buf;
}

char* decapsulate_array_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_SimpleDropperStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        char* buf
        )
{
    buf = decapsulate_NPF_DS_MeterType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_TRTCM_BLIND:
            buf = decapsulate_NPF_DS_ColorAwareDropperStats_t(&(a->u.colorAwareDropperStats),buf);
            break;
        case NPF_DS_SIMPLE_TB:
            buf = decapsulate_NPF_DS_SimpleDropperStats_t(&(a->u.simpleDropperStats),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_DropperStats_t(a,buf);
    }
    return buf;
}

char* decapsulate_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        char* buf
        )
{
    NPF_DS_StatsResp_t *stats = &a->u.stats;
    switch(a->type)
    {
        case NPF_DS_CLASSIFIER:
            buf = decapsulate_NPF_DS_ClassifierStats_t(&(stats->u.classfierStats),buf);
            break;
        case NPF_DS_METER:
            buf = decapsulate_NPF_DS_MeterStats_t(&(stats->u.meterStats),buf);
            break;
        case NPF_DS_MARKER:
            buf = decapsulate_NPF_DS_MarkerStats_t(&(stats->u.markerStats),buf);
            break;
        case NPF_DS_DROPPER:
            buf = decapsulate_NPF_DS_DropperStats_t(&(stats->u.dropperStats),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* decapsulate_array_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = decapsulate_NPF_DS_StatsResp_t(a,buf);
    }
    return buf;
}
