/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#include "fppencap_common.h"
#include "fppencap_npf_ds.h"
#include "fppCapabilityTypes.h"

char* encapsulate_NPF_DS_DpeHandle_t (
        NPF_DS_DpeHandle_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

uint32_t sizeof_FPPI_DS_Dpe_t (
        FPPI_DS_Dpe_t* a,
        char* buf
        )
{
    return sizeof(FPPI_DS_Dpe_t);
}

uint32_t sizeof_NPF_DS_DpeDirection_t (
        NPF_DS_DpeDirection_t* a,
        char* buf
        )
{
    return sizeof(NPF_DS_DpeDirection_t);
}

char* encapsulate_NPF_DS_DpeDirection_t (
        NPF_DS_DpeDirection_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DpeType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DpeHandle_t (
        NPF_DS_DpeHandle_t* a
        )
{
    return sizeof(NPF_DS_DpeHandle_t);
}

uint32_t sizeof_NPF_DS_Counter_t (
        NPF_DS_Counter_t* a
        )
{
    return sizeof(NPF_DS_Counter_t);
}

char* encapsulate_NPF_DS_Counter_t (
        NPF_DS_Counter_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint64_t((uint64_t *)a,buf);
    return buf;
}

uint32_t sizeof_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a
        )
{
    return sizeof(NPF_DS_DpeType_t);
}

uint32_t sizeof_array_NPF_DS_DpeType_t (
        NPF_DS_DpeType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_DpeType_t)*l;
}

uint32_t sizeof_NPF_DS_Filter_t (
        NPF_DS_Filter_t* a
        )
{
    return sizeof(NPF_DS_Filter_t);
}

char* encapsulate_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = (char *)encapsulate_NPF_IPv4Address_t(&(a->dstAddr),buf);
    tmp = a->dstNetpLen;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    buf = (char *)encapsulate_NPF_IPv4Address_t(&(a->srcAddr),buf);
    tmp = a->srcNetpLen;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->dscp),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->protocol),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->dstL4Port),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->srcL4Port),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_IPV4_Filter_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a
        )
{
    uint32_t s=0;
    NPF_uint32_t tmp;
        s += sizeof_NPF_IPv4Address_t(&(a->dstAddr));
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_IPv4Address_t(&(a->srcAddr));
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_uint32_t(&(a->dscp));
        s += sizeof_NPF_uint32_t(&(a->protocol));
        s += sizeof_NPF_uint32_t(&(a->dstL4Port));
        s += sizeof_NPF_uint32_t(&(a->srcL4Port));
    return s;
}

uint32_t sizeof_array_NPF_DS_IPV4_Filter_t (
        NPF_DS_IPV4_Filter_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_IPV4_Filter_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_DSCP_Filter_t (
        NPF_DS_DSCP_Filter_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    tmp = a->dscp;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_DSCP_Filter_t (
        NPF_DS_DSCP_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DSCP_Filter_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DSCP_Filter_t (
        NPF_DS_DSCP_Filter_t* a
        )
{
    uint32_t s=0;
    NPF_uint32_t tmp;
        s += sizeof_NPF_uint32_t(&tmp);
    return s;
}

uint32_t sizeof_array_NPF_DS_DSCP_Filter_t (
        NPF_DS_DSCP_Filter_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_DSCP_Filter_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = (char *)encapsulate_NPF_IPv6Address_t(&(a->dstAddr),buf);
    tmp = a->dstNetpLen;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    buf = (char *)encapsulate_NPF_IPv6Address_t(&(a->srcAddr),buf);
    tmp = a->srcNetpLen;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->fid),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->dscp),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->protocol),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->dstL4Port),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->srcL4Port),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_IPV6_Filter_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a
        )
{
    uint32_t s=0;
    NPF_uint32_t tmp;
        s += sizeof_NPF_IPv6Address_t(&(a->dstAddr));
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_IPv6Address_t(&(a->srcAddr));
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_uint32_t(&(a->fid));
        s += sizeof_NPF_uint32_t(&(a->dscp));
        s += sizeof_NPF_uint32_t(&(a->protocol));
        s += sizeof_NPF_uint32_t(&(a->dstL4Port));
        s += sizeof_NPF_uint32_t(&(a->srcL4Port));
    return s;
}

uint32_t sizeof_array_NPF_DS_IPV6_Filter_t (
        NPF_DS_IPV6_Filter_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_IPV6_Filter_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MPLS_FilterType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a
        )
{
    return sizeof(NPF_DS_MPLS_FilterType_t);
}

uint32_t sizeof_array_NPF_DS_MPLS_FilterType_t (
        NPF_DS_MPLS_FilterType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_MPLS_FilterType_t)*l;
}

char* encapsulate_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_MPLS_FilterType_t(&(a->type),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MPLS_Filter_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a
        )
{
    return sizeof(NPF_DS_MPLS_Filter_t);
}

uint32_t sizeof_array_NPF_DS_MPLS_Filter_t (
        NPF_DS_MPLS_Filter_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_MPLS_Filter_t)*l;
}

char* encapsulate_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_ClassifierType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a
        )
{
    return sizeof(NPF_DS_ClassifierType_t);
}

uint32_t sizeof_array_NPF_DS_ClassifierType_t (
        NPF_DS_ClassifierType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_ClassifierType_t)*l;
}

char* encapsulate_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_ClassifierType_t(&(a->type),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->precedence),buf);
    switch(a->type)
    {
	case NPF_DS_IPV4_FILTER:
	    buf = encapsulate_NPF_DS_IPV4_Filter_t(&a->filterEntry.filter_IPV4, buf);
	break;
	case NPF_DS_DSCP_FILTER:
	    buf = encapsulate_NPF_DS_DSCP_Filter_t(&a->filterEntry.filter_DSCP, buf);
	break;
	case NPF_DS_IPV6_FILTER:
	    buf = encapsulate_NPF_DS_IPV6_Filter_t(&a->filterEntry.filter_IPV6, buf);
	break;
	case NPF_DS_MPLS_FILTER:
	    buf = encapsulate_NPF_DS_MPLS_Filter_t(&a->filterEntry.filter_MPLS, buf);
	break;
    }
    return buf;
}

char* encapsulate_array_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Classifier_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_ClassifierType_t(&(a->type));
        s += sizeof_NPF_uint32_t(&(a->precedence));
        s += sizeof_NPF_DS_Filter_t(&(a->filterEntry));
    return s;
}

uint32_t sizeof_array_NPF_DS_Classifier_t (
        NPF_DS_Classifier_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Classifier_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MeterType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a
        )
{
    return sizeof(NPF_DS_MeterType_t);
}

uint32_t sizeof_array_NPF_DS_MeterType_t (
        NPF_DS_MeterType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_MeterType_t)*l;
}

char* encapsulate_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MarkerType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MarkerEntry_t (
        NPF_DS_MarkerEntry_t* a
        )
{
    return sizeof(NPF_DS_MarkerEntry_t);
}
uint32_t sizeof_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a
        )
{
    return sizeof(NPF_DS_MarkerType_t);
}

uint32_t sizeof_array_NPF_DS_MarkerType_t (
        NPF_DS_MarkerType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_MarkerType_t)*l;
}

char* encapsulate_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    tmp = a->greenDscp;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    tmp = a->yellowDscp;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    tmp = a->redDscp;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DSCP_Marker_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a
        )
{
    uint32_t s=0;
    NPF_uint32_t tmp;
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_uint32_t(&tmp);
    return s;
}

uint32_t sizeof_array_NPF_DS_DSCP_Marker_t (
        NPF_DS_DSCP_Marker_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_DSCP_Marker_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_MarkerType_t(&(a->type),buf);
    buf = (char *)encapsulate_NPF_boolean_t(&(a->statsRequired),buf);
    switch(a->type)
    {
	case NPF_DS_MARKER_DSCP:
	case NPF_DS_MARKER_MPLS:
    	    buf = (char *)encapsulate_NPF_DS_DSCP_Marker_t(&(a->markerEntry.dscp),buf);
	break;
	default:
	/*
	case NPF_DS_MARKER_MPLS:
    	    buf = (char *)encapsulate_NPF_DS_MPLS_Marker_t(&(a->markerEntry.label),buf);
	break;
	*/
    }
    return buf;
}

char* encapsulate_array_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Marker_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_MarkerType_t(&(a->type));
        s += sizeof_NPF_boolean_t(&(a->statsRequired));
        s += sizeof_NPF_DS_MarkerEntry_t(&(a->markerEntry));
    return s;
}

uint32_t sizeof_array_NPF_DS_Marker_t (
        NPF_DS_Marker_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Marker_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_uint32_t(&(a->cir),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->pir),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->cbs),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->pbs),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->ebs),buf);
    buf = (char *)encapsulate_NPF_DS_DpeType_t(&(a->nextGreenDpe),buf);
    buf = (char *)encapsulate_NPF_DS_DpeType_t(&(a->nextYellowDpe),buf);
    buf = (char *)encapsulate_NPF_DS_DpeType_t(&(a->nextRedDpe),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MeterEntry_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_uint32_t(&(a->cir));
        s += sizeof_NPF_uint32_t(&(a->cbs));
        s += sizeof_NPF_uint32_t(&(a->ebs));
        s += sizeof_NPF_DS_DpeType_t(&(a->nextGreenDpe));
        s += sizeof_NPF_DS_DpeType_t(&(a->nextYellowDpe));
        s += sizeof_NPF_DS_DpeType_t(&(a->nextRedDpe));
    return s;
}

uint32_t sizeof_array_NPF_DS_MeterEntry_t (
        NPF_DS_MeterEntry_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_MeterEntry_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_MeterType_t(&(a->type),buf);
    buf = (char *)encapsulate_NPF_boolean_t(&(a->statsRequired),buf);
    buf = (char *)encapsulate_NPF_DS_MeterEntry_t(&(a->meterEntry),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Meter_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_MeterType_t(&(a->type));
        s += sizeof_NPF_boolean_t(&(a->statsRequired));
        s += sizeof_NPF_DS_MeterEntry_t(&(a->meterEntry));
    return s;
}

uint32_t sizeof_array_NPF_DS_Meter_t (
        NPF_DS_Meter_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Meter_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DropperType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a
        )
{
    return sizeof(NPF_DS_DropperType_t);
}

uint32_t sizeof_array_NPF_DS_DropperType_t (
        NPF_DS_DropperType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_DropperType_t)*l;
}

char* encapsulate_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    tmp = a->minThreshold;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    tmp = a->maxThreshold;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    tmp = a->maxProbability;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_RED_Instance_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a
        )
{
    uint32_t s=0;
    NPF_uint32_t tmp;
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_uint32_t(&tmp);
    return s;
}

uint32_t sizeof_array_NPF_DS_RED_Instance_t (
        NPF_DS_RED_Instance_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_RED_Instance_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_RED_Instance_t(&(a->green),buf);
    buf = (char *)encapsulate_NPF_DS_RED_Instance_t(&(a->yellow),buf);
    buf = (char *)encapsulate_NPF_DS_RED_Instance_t(&(a->red),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DropperEntry_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_RED_Instance_t(&(a->green));
        s += sizeof_NPF_DS_RED_Instance_t(&(a->yellow));
        s += sizeof_NPF_DS_RED_Instance_t(&(a->red));
    return s;
}

uint32_t sizeof_array_NPF_DS_DropperEntry_t (
        NPF_DS_DropperEntry_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_DropperEntry_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        char* buf
        )
{
    NPF_uint32_t tmp;
    buf = (char *)encapsulate_NPF_uint32_t(&(a->serviceRate),buf);
    tmp = a->weight;
    buf = (char *)encapsulate_NPF_uint32_t(&tmp,buf);
    buf = (char *)encapsulate_NPF_DS_DropperType_t(&(a->type),buf);
    buf = (char *)encapsulate_NPF_boolean_t(&(a->statsRequired),buf);
    buf = (char *)encapsulate_NPF_DS_DropperEntry_t(&(a->dropperEntry),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Dropper_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a
        )
{
    uint32_t s=0;
    NPF_uint32_t tmp;
        s += sizeof_NPF_uint32_t(&(a->serviceRate));
        s += sizeof_NPF_uint32_t(&tmp);
        s += sizeof_NPF_DS_DropperType_t(&(a->type));
        s += sizeof_NPF_boolean_t(&(a->statsRequired));
        s += sizeof_NPF_DS_DropperEntry_t(&(a->dropperEntry));
    return s;
}

uint32_t sizeof_array_NPF_DS_Dropper_t (
        NPF_DS_Dropper_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Dropper_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_QueueType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a
        )
{
    return sizeof(NPF_DS_QueueType_t);
}

uint32_t sizeof_array_NPF_DS_QueueType_t (
        NPF_DS_QueueType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_QueueType_t)*l;
}

char* encapsulate_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_ClassType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a
        )
{
    return sizeof(NPF_DS_ClassType_t);
}

uint32_t sizeof_array_NPF_DS_ClassType_t (
        NPF_DS_ClassType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_ClassType_t)*l;
}

char* encapsulate_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_uint32_t(&(a->priority),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->abs),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->rel),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MinRate_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_uint32_t(&(a->priority));
        s += sizeof_NPF_uint32_t(&(a->abs));
        s += sizeof_NPF_uint32_t(&(a->rel));
    return s;
}

uint32_t sizeof_array_NPF_DS_MinRate_t (
        NPF_DS_MinRate_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_MinRate_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_uint32_t(&(a->level),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->abs),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->rel),buf);
    buf = (char *)encapsulate_NPF_uint32_t(&(a->threshold),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_SlMaxRate_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_uint32_t(&(a->level));
        s += sizeof_NPF_uint32_t(&(a->abs));
        s += sizeof_NPF_uint32_t(&(a->rel));
        s += sizeof_NPF_uint32_t(&(a->threshold));
    return s;
}

uint32_t sizeof_array_NPF_DS_SlMaxRate_t (
        NPF_DS_SlMaxRate_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_SlMaxRate_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_uint32_t(&(a->maxRateCount),buf);
    buf = (char *)encapsulate_array_NPF_DS_SlMaxRate_t(a->maxRateList,a->maxRateCount,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MlMaxRate_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_uint32_t(&(a->maxRateCount));
        s += sizeof_array_NPF_DS_SlMaxRate_t(a->maxRateList,a->maxRateCount);
    return s;
}

uint32_t sizeof_array_NPF_DS_MlMaxRate_t (
        NPF_DS_MlMaxRate_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_MlMaxRate_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MaxRateType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a
        )
{
    return sizeof(NPF_DS_MaxRateType_t);
}

uint32_t sizeof_array_NPF_DS_MaxRateType_t (
        NPF_DS_MaxRateType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_MaxRateType_t)*l;
}

char* encapsulate_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_MaxRateType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_SL_MAXRATE:
            buf = (char *)encapsulate_NPF_DS_SlMaxRate_t(&(a->maxRate.slMaxRate),buf);
            break;
        case NPF_DS_ML_MAXRATE:
            buf = (char *)encapsulate_NPF_DS_MlMaxRate_t(&(a->maxRate.mlMaxRate),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* encapsulate_array_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MaxRate_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_MaxRateType_t(&(a->type));
    switch(a->type)
    {
        case NPF_DS_SL_MAXRATE:
            s += sizeof_NPF_DS_SlMaxRate_t(&(a->maxRate.slMaxRate));
            break;
        case NPF_DS_ML_MAXRATE:
            s += sizeof_NPF_DS_MlMaxRate_t(&(a->maxRate.mlMaxRate));
            break;
        default:
            /* unknown type */
            break;
    }
    return s;
}

uint32_t sizeof_array_NPF_DS_MaxRate_t (
        NPF_DS_MaxRate_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_MaxRate_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_QueueType_t(&(a->type),buf);
    buf = (char *)encapsulate_NPF_DS_ClassType_t(&(a->classId),buf);
    buf = (char *)encapsulate_NPF_DS_MinRate_t(&(a->minRate),buf);
    buf = (char *)encapsulate_NPF_DS_MaxRate_t(&(a->maxRate),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Q_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Q_t (
        NPF_DS_Q_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_QueueType_t(&(a->type));
        s += sizeof_NPF_DS_ClassType_t(&(a->classId));
        s += sizeof_NPF_DS_MinRate_t(&(a->minRate));
        s += sizeof_NPF_DS_MaxRate_t(&(a->maxRate));
    return s;
}

uint32_t sizeof_array_NPF_DS_Q_t (
        NPF_DS_Q_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Q_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_SchedMethod_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a
        )
{
    return sizeof(NPF_DS_SchedMethod_t);
}

uint32_t sizeof_array_NPF_DS_SchedMethod_t (
        NPF_DS_SchedMethod_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_SchedMethod_t)*l;
}

char* encapsulate_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_SchedMethod_t(&(a->type),buf);
    buf = (char *)encapsulate_NPF_DS_MinRate_t(&(a->minRate),buf);
    buf = (char *)encapsulate_NPF_DS_MaxRate_t(&(a->maxRate),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Scheduler_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_SchedMethod_t(&(a->type));
        s += sizeof_NPF_DS_MinRate_t(&(a->minRate));
        s += sizeof_NPF_DS_MaxRate_t(&(a->maxRate));
    return s;
}

uint32_t sizeof_array_NPF_DS_Scheduler_t (
        NPF_DS_Scheduler_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Scheduler_t(a);
    }
    return s;
}

char* encapsulate2_NPF_DS_Dpe_t (
	NPF_DS_DpeType_t type,
        NPF_DS_Dpe_t* a,
        char* buf
        )
{
    buf = encapsulate_NPF_DS_DpeType_t(&(a->type),buf);
    switch(type)
    {
        case NPF_DS_CLASSIFIER:
            buf = encapsulate_NPF_DS_Classifier_t(&(a->u.classifier),buf);
            break;
        case NPF_DS_MARKER:
            buf = encapsulate_NPF_DS_Marker_t(&(a->u.marker),buf);
            break;
        case NPF_DS_METER:
            buf = encapsulate_NPF_DS_Meter_t(&(a->u.meter),buf);
            break;
        case NPF_DS_DROPPER:
            buf = encapsulate_NPF_DS_Dropper_t(&(a->u.dropper),buf);
            break;
        case NPF_DS_QUEUE:
            buf = encapsulate_NPF_DS_Q_t(&(a->u.queue),buf);
            break;
        case NPF_DS_SCHEDULER:
            buf = encapsulate_NPF_DS_Scheduler_t(&(a->u.scheduler),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* encapsulate_FPPI_DS_Dpe_t (
        FPPI_DS_Dpe_t* a,
        char* buf
        )
{
    buf = encapsulate_NPF_DS_CallbackType_t(&(a->op),buf);
    buf = encapsulate_NPF_DS_DpeType_t(&(a->type),buf);
    buf = encapsulate_NPF_DS_ErrorType_t(&(a->error),buf);
    buf = encapsulate_NPF_DS_DpeHandle_t(&(a->dpeHandle),buf);
    buf = encapsulate_NPF_DS_DpeHandle_t(&(a->prevDpeHandle),buf);
    buf = encapsulate_FPPI_PortID(&(a->port),buf);
    buf = encapsulate_NPF_DS_DpeDirection_t(&(a->dir),buf);
    if(a->op == NPF_DS_DPE_CREATE || a->op == NPF_DS_DPE_QUERY)
    {
	buf = encapsulate_NPF_DS_Dpe_t(&a->u.dpe, buf);
    }
    else if(a->op == NPF_DS_DPE_MODIFY)
    {
	buf = encapsulate2_NPF_DS_Dpe_t(a->type, &a->u.dpe, buf);
    }
    else if(a->op == NPF_DS_DPE_STATISTICS)
    {
	buf = encapsulate_NPF_DS_StatsResp_t(a, buf);
    }
    return(buf);
}

char* encapsulate_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_DpeType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_CLASSIFIER:
            buf = (char *)encapsulate_NPF_DS_Classifier_t(&(a->u.classifier),buf);
            break;
        case NPF_DS_MARKER:
            buf = (char *)encapsulate_NPF_DS_Marker_t(&(a->u.marker),buf);
            break;
        case NPF_DS_METER:
            buf = (char *)encapsulate_NPF_DS_Meter_t(&(a->u.meter),buf);
            break;
        case NPF_DS_DROPPER:
            buf = (char *)encapsulate_NPF_DS_Dropper_t(&(a->u.dropper),buf);
            break;
        case NPF_DS_QUEUE:
            buf = (char *)encapsulate_NPF_DS_Q_t(&(a->u.queue),buf);
            break;
        case NPF_DS_SCHEDULER:
            buf = (char *)encapsulate_NPF_DS_Scheduler_t(&(a->u.scheduler),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* encapsulate_array_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_Dpe_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_DpeType_t(&(a->type));
    switch(a->type)
    {
        case NPF_DS_CLASSIFIER:
            s += sizeof_NPF_DS_Classifier_t(&(a->u.classifier));
            break;
        case NPF_DS_MARKER:
            s += sizeof_NPF_DS_Marker_t(&(a->u.marker));
            break;
        case NPF_DS_METER:
            s += sizeof_NPF_DS_Meter_t(&(a->u.meter));
            break;
        case NPF_DS_DROPPER:
            s += sizeof_NPF_DS_Dropper_t(&(a->u.dropper));
            break;
        case NPF_DS_QUEUE:
            s += sizeof_NPF_DS_Q_t(&(a->u.queue));
            break;
        case NPF_DS_SCHEDULER:
            s += sizeof_NPF_DS_Scheduler_t(&(a->u.scheduler));
            break;
        default:
            /* unknown type */
            break;
    }
    return s;
}

uint32_t sizeof_array_NPF_DS_Dpe_t (
        NPF_DS_Dpe_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_Dpe_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_DpeHandle_t(&(a->dpeHandle),buf);
    buf = (char *)encapsulate_NPF_DS_DpeHandle_t(&(a->prevDpeHandle),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DpeSetHandle_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_DpeHandle_t(&(a->dpeHandle));
        s += sizeof_NPF_DS_DpeHandle_t(&(a->prevDpeHandle));
    return s;
}

uint32_t sizeof_array_NPF_DS_DpeSetHandle_t (
        NPF_DS_DpeSetHandle_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_DpeSetHandle_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->defaultPackects),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->defaultBytes),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->totalBytes),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->totalPackets),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_ClassifierStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_Counter_t(&(a->defaultPackects));
        s += sizeof_NPF_DS_Counter_t(&(a->defaultBytes));
        s += sizeof_NPF_DS_Counter_t(&(a->totalBytes));
        s += sizeof_NPF_DS_Counter_t(&(a->totalPackets));
    return s;
}

uint32_t sizeof_array_NPF_DS_ClassifierStats_t (
        NPF_DS_ClassifierStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_ClassifierStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->greenByteCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->greenPacketCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->yellowByteCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->yellowPacketCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->redByteCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->redPacketCount),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_ColorAwareMeterStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_Counter_t(&(a->greenByteCount));
        s += sizeof_NPF_DS_Counter_t(&(a->greenPacketCount));
        s += sizeof_NPF_DS_Counter_t(&(a->yellowByteCount));
        s += sizeof_NPF_DS_Counter_t(&(a->yellowPacketCount));
        s += sizeof_NPF_DS_Counter_t(&(a->redByteCount));
        s += sizeof_NPF_DS_Counter_t(&(a->redPacketCount));
    return s;
}

uint32_t sizeof_array_NPF_DS_ColorAwareMeterStats_t (
        NPF_DS_ColorAwareMeterStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_ColorAwareMeterStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->confByteCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->confPacketCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->nonConfByteCount),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->nonConfPacketCount),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_SimpleMeterStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_Counter_t(&(a->confByteCount));
        s += sizeof_NPF_DS_Counter_t(&(a->confPacketCount));
        s += sizeof_NPF_DS_Counter_t(&(a->nonConfByteCount));
        s += sizeof_NPF_DS_Counter_t(&(a->nonConfPacketCount));
    return s;
}

uint32_t sizeof_array_NPF_DS_SimpleMeterStats_t (
        NPF_DS_SimpleMeterStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_SimpleMeterStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_MeterType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_TRTCM_AWARE:
        case NPF_DS_SRTCM_AWARE:
            buf = (char *)encapsulate_NPF_DS_ColorAwareMeterStats_t(&(a->u.colorAwareStats),buf);
            break;
        case NPF_DS_SIMPLE_TB:
            buf = (char *)encapsulate_NPF_DS_SimpleMeterStats_t(&(a->u.simpleStats),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* encapsulate_array_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MeterStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_MeterType_t(&(a->type));
    switch(a->type)
    {
        case NPF_DS_TRTCM_BLIND:
            s += sizeof_NPF_DS_ColorAwareMeterStats_t(&(a->u.colorAwareStats));
            break;
        case NPF_DS_SIMPLE_TB:
            s += sizeof_NPF_DS_SimpleMeterStats_t(&(a->u.simpleStats));
            break;
        default:
            /* unknown type */
            break;
    }
    return s;
}

uint32_t sizeof_array_NPF_DS_MeterStats_t (
        NPF_DS_MeterStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_MeterStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->bytesMarked),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->packetsMarked),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_MarkerStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_Counter_t(&(a->bytesMarked));
        s += sizeof_NPF_DS_Counter_t(&(a->packetsMarked));
    return s;
}

uint32_t sizeof_array_NPF_DS_MarkerStats_t (
        NPF_DS_MarkerStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_MarkerStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->greenByteDropped),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->greenPacketDropped),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->yellowByteDropped),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->yellowPacketDropped),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->redByteDropped),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->redPacketDropped),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_ColorAwareDropperStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_Counter_t(&(a->greenByteDropped));
        s += sizeof_NPF_DS_Counter_t(&(a->greenPacketDropped));
        s += sizeof_NPF_DS_Counter_t(&(a->yellowByteDropped));
        s += sizeof_NPF_DS_Counter_t(&(a->yellowPacketDropped));
        s += sizeof_NPF_DS_Counter_t(&(a->redByteDropped));
        s += sizeof_NPF_DS_Counter_t(&(a->redPacketDropped));
    return s;
}

uint32_t sizeof_array_NPF_DS_ColorAwareDropperStats_t (
        NPF_DS_ColorAwareDropperStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_ColorAwareDropperStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->bytesConsumed),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->packetsConsumed),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->bytesDropped),buf);
    buf = (char *)encapsulate_NPF_DS_Counter_t(&(a->packetsDropped),buf);
    return buf;
}

char* encapsulate_array_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_SimpleDropperStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_Counter_t(&(a->bytesConsumed));
        s += sizeof_NPF_DS_Counter_t(&(a->packetsConsumed));
        s += sizeof_NPF_DS_Counter_t(&(a->bytesDropped));
        s += sizeof_NPF_DS_Counter_t(&(a->packetsDropped));
    return s;
}

uint32_t sizeof_array_NPF_DS_SimpleDropperStats_t (
        NPF_DS_SimpleDropperStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_SimpleDropperStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_NPF_DS_MeterType_t(&(a->type),buf);
    switch(a->type)
    {
        case NPF_DS_TRTCM_BLIND:
            buf = (char *)encapsulate_NPF_DS_ColorAwareDropperStats_t(&(a->u.colorAwareDropperStats),buf);
            break;
        case NPF_DS_SIMPLE_TB:
            buf = (char *)encapsulate_NPF_DS_SimpleDropperStats_t(&(a->u.simpleDropperStats),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* encapsulate_array_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_DropperStats_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a
        )
{
    uint32_t s=0;
        s += sizeof_NPF_DS_MeterType_t(&(a->type));
    switch(a->type)
    {
        case NPF_DS_TRTCM_BLIND:
            s += sizeof_NPF_DS_ColorAwareDropperStats_t(&(a->u.colorAwareDropperStats));
            break;
        case NPF_DS_SIMPLE_TB:
            s += sizeof_NPF_DS_SimpleDropperStats_t(&(a->u.simpleDropperStats));
            break;
        default:
            /* unknown type */
            break;
    }
    return s;
}

uint32_t sizeof_array_NPF_DS_DropperStats_t (
        NPF_DS_DropperStats_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_DropperStats_t(a);
    }
    return s;
}

char* encapsulate_NPF_DS_ErrorType_t (
        NPF_DS_ErrorType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a,
        char* buf
        )
{
    buf = (char *)encapsulate_uint32_t((uint32_t *)a,buf);
    return buf;
}

char* encapsulate_array_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_CallbackType_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a
        )
{
    return sizeof(NPF_DS_CallbackType_t);
}

uint32_t sizeof_array_NPF_DS_CallbackType_t (
        NPF_DS_CallbackType_t* a,
        uint32_t l
        )
{
    return sizeof(NPF_DS_CallbackType_t)*l;
}

char* encapsulate_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        char* buf
        )
{
    NPF_DS_StatsResp_t *stats;
    stats = (NPF_DS_StatsResp_t *)&a->u.stats;
    switch(a->type)
    {
        case NPF_DS_CLASSIFIER:
            buf = (char *)encapsulate_NPF_DS_ClassifierStats_t(&(stats->u.classfierStats),buf);
            break;
        case NPF_DS_METER:
            buf = (char *)encapsulate_NPF_DS_MeterStats_t(&(stats->u.meterStats),buf);
            break;
        case NPF_DS_MARKER:
            buf = (char *)encapsulate_NPF_DS_MarkerStats_t(&(stats->u.markerStats),buf);
            break;
        case NPF_DS_DROPPER:
            buf = (char *)encapsulate_NPF_DS_DropperStats_t(&(stats->u.dropperStats),buf);
            break;
        default:
            /* unknown type */
            break;
    }
    return buf;
}

char* encapsulate_array_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        uint32_t l,
        char* buf
        )
{
    uint32_t i;
    for(i=0;i<l;i++,a++)
    {
        buf = (char *)encapsulate_NPF_DS_StatsResp_t(a,buf);
    }
    return buf;
}

uint32_t sizeof_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a
        )
{
    NPF_DS_StatsResp_t *stats;
    uint32_t s=0;
    stats = (NPF_DS_StatsResp_t *)&a->u.stats;
    switch(a->type)
    {
        case NPF_DS_CLASSIFIER:
            s += sizeof_NPF_DS_ClassifierStats_t(&(stats->u.classfierStats));
            break;
        case NPF_DS_METER:
            s += sizeof_NPF_DS_MeterStats_t(&(stats->u.meterStats));
            break;
        case NPF_DS_MARKER:
            s += sizeof_NPF_DS_MarkerStats_t(&(stats->u.markerStats));
            break;
        case NPF_DS_DROPPER:
            s += sizeof_NPF_DS_DropperStats_t(&(stats->u.dropperStats));
            break;
        default:
            /* unknown type */
            break;
    }
    return s;
}

uint32_t sizeof_array_NPF_DS_StatsResp_t (
        FPPI_DS_Dpe_t* a,
        uint32_t l
        )
{
    uint32_t i,s=0;
    for(i=0;i<l;i++,a++)
    {
        s += sizeof_NPF_DS_StatsResp_t(a);
    }
    return s;
}
