///////////////////////////////////////////////////////////////////////////// 
//             INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or 
//  nondisclosure agreement with Intel Corporation and may not be copied 
//  or disclosed except in accordance with the terms of that agreement. 
//      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
//
//
//      $Workfile:   $
//      $Revision: 1.6 $
//      $Date: 2003/11/17 16:57:52 $
//
//  Purpose:    Redefinitions for OS specific function calls
//
/////////////////////////////////////////////////////////////////////////////

#ifndef OS_REDEFS
#define OS_REDEFS

/*snprintf is defined as _snprintf in windows and works differently from the
* snprintf defined in Linux*/
#ifndef SNPRINTF
#include <stdio.h>

#ifdef _WIN32
#    define SNPRINTF portab_snprintf
#else
#    define SNPRINTF snprintf
#endif/*_WIN32*/

int portab_snprintf(char *buffer, size_t count, const char *format, ...);

#endif/*SNPRINTF*/


#ifndef STRICMP
#include <string.h>

#ifdef _WIN32
#    define STRICMP stricmp
#else
#    define STRICMP strcasecmp
#endif/*_WIN32*/

#endif/*STRICMP*/


#endif /*OS_REDEFS*/
