/**************************************************************************** 
//             INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or 
//  nondisclosure agreement with Intel Corporation and may not be copied 
//  or disclosed except in accordance with the terms of that agreement. 
//      Copyright (c) 2000 Intel Corporation. All Rights Reserved.
****************************************************************************/

/****************************************************************************
//  $Workfile:   csdatatypes.h  $
//  $Revision: 1.6 $
//  $Date: 2003/11/17 16:57:52 $
//
//  Purpose:
//      Required data types are defined here.
//
****************************************************************************/
#ifndef  _CSDATATYPES_HDR
#define _CSDATATYPES_HDR

#include "pil.h"

/* Data type definitions */
typedef unsigned char   BYTE;
typedef unsigned char   *LPBYTE;
typedef unsigned short  WORD;
typedef unsigned long   DWORD;
typedef void            *LPVOID;

#ifndef _VXWORKS_
typedef unsigned char   UCHAR;
typedef unsigned short  USHORT;
typedef unsigned int    UINT;
typedef unsigned long   ULONG;

#ifndef BOOL
typedef int                 BOOL;
#endif

#endif /* _VXWORKS_ */

typedef long                LONG;
typedef short               SHORT;

#ifdef _WIN32
    typedef unsigned __int64 ULONG64;
    typedef __int64 LONG64;
    #define FORMAT_SPEC_L64 "%I64d"
    #define FORMAT_SPEC_U64 "%I64u"
#else
    typedef unsigned long long ULONG64;
    typedef long long LONG64;
    #define FORMAT_SPEC_L64 "%lld"
    #define FORMAT_SPEC_U64 "%llu"
#endif /*WIN32*/

typedef float               FLOAT;

#ifndef FALSE
#define FALSE               0
#endif

#ifndef TRUE
#define TRUE                1
#endif



/* This defnition is for IP addresses and is intended to
   provide IPv6 support later. One IPv4 addresses are supported
   for now. */
typedef struct cs_ipaddr {
    ULONG   addr;
} CS_IPADDR;


#endif /* _CSDATATYPES_HDR */
