/******************************************************************************
//             INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//      Copyright (c) 2000 Intel Corporation. All Rights Reserved.
//
//  $Workfile:   pdatagram.h  $
//  $Revision: 1.6 $
//  $Date: 2003/11/17 16:57:52 $
//
//  Contents: Datagram function header file
//
******************************************************************************/


#if !defined _PDATAGRAM_H
#define _PDATAGRAM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "interconnect_api.h"


/******************************************************************************
//
// uint32_t DatagramCbBufferReceive();
//
// ARGUMENTS: 
//
// DESCRIPTION: Used by the Buffer Management to Supply received buffers
//
// RETURNS:     CS_RET_SUCCESS
//
******************************************************************************/
void DatagramCbBufferReceive(
	ULONG connect_id , 
	const char * buf, 
	int size);
	
/* Internal Data Structures */
typedef struct _plHeader {
    uint32_t		cookie;
    uint32_t		length;	
} plHeader;	

/* Interconnect Messages exchanged */
typedef struct _plmsg {
    struct _plHeader plheader;
    unsigned char pbuf[0];
} plmsg,*pplmsg;

uint32_t AddMappingOnBind (
	uint32_t feid, 
	uint32_t connect_id);

uint32_t DeleteMapping (uint32_t feid);

#define DATAGRAM_SERVER_PORT	PL_DATAGRAM_SERVER_PORT		
/* Exceptions : Used in the CALLBACK */
#define DATAGRAM_EX_CONNECTION_CLOSE PL_DATAGRAM_EX_CONNECTION_CLOSE	
/* Client Connect Flags : Used CBClientDatagramParams */
#define DATAGRAM_IPV4	PL_DATAGRAM_IPV4   
#define DATAGRAM_IPV6	PL_DATAGRAM_IPV6   

#ifdef __cplusplus
}
#endif
#endif // _PDATAGRAM_H
