/******************************************************************************
//             INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or 
//  nondisclosure agreement with Intel Corporation and may not be copied 
//  or disclosed except in accordance with the terms of that agreement. 
//      Copyright (c) 2000 Intel Corporation. All Rights Reserved.
//
//  $Workfile:   ptcpip.h  $
//  $Revision: 1.6 $
//  $Date: 2003/11/17 16:57:53 $
//
//  Contents: TCP/IP function header file 
//
******************************************************************************/


#if !defined _PTCPIP_H 
#define _PTCPIP_H

#ifdef __cplusplus
extern "C" {
#endif

#include "cserror.h"

typedef unsigned int HANDLE;
typedef unsigned int SOCKET;

/* No of bytes to receive at one time. */
#define MAX_RECV_LEN	        4096
#define MAX_LISTEN_SOCKS        5
#define TERMINATE_STR           "Terminate Thread"

#define ULONGToHANDLE(UlongHandle)  (HANDLE) UlongHandle
#define HANDLEToULONG(HandleUlong)  (ULONG) HandleUlong
#define SOCKETToULONG(SocketUlong)  (ULONG) SocketUlong
#define ULONGToSOCKET(UlongSocket)  (SOCKET) UlongSocket  

typedef struct _sockStruct
{
    SOCKET sockHandle;
    PilThread threadHandle;
} sockStruct, *PsockStruct;

BOOL NetworkInit(void);
BOOL NetworkDeinit(void);


#ifdef __cplusplus
}
#endif

#endif // _PTCPIP_H










