/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/*
 * creates and maintains a list of user defined types
 */

/* type types
 * ie, pointer, array, union, whatever
 */

enum {
    TYPE_BUILTIN = 0,
    TYPE_BASIC,
    TYPE_POINTER,
    TYPE_ARRAY,
    TYPE_STRUCT,
    TYPE_UNION,
    TYPE_IGNORE,
};

typedef void* type;

extern void* newdeclaration(
                int     basetype,
                char*   name,
                int     kindoftype,
                char*   size,      /* either a member of the struct or 
                                      a hardcoded value */
                char*   kase
                );
extern void inittypes();
extern void printalltypes();
extern void addtotype(type ee, type tt);
extern void renametype(type tt, char* name);
extern void modifyType(type tt, char* c, char* v);
extern int isintype(type ee, char* name);

extern int changeToArray(type tt, char* s);
