/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#ifndef _HWADDR_H_
#define _HWADDR_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/socket.h>

#define MAX_ADDR_LEN	7

typedef unsigned char HWADDR[MAX_ADDR_LEN];    // it's 7

#ifndef ETH_ALEN
#define ETH_ALEN 6
#endif

/*****************************************************************************
*                                                                            *
*  --------------------------- Public Interface ---------------------------  *
*                                                                            *
*****************************************************************************/

/* Convert an Ethernet address in readable format */
int npf_hwaddr_addr2char(unsigned char *ptr, char *buff);

/* Input an Ethernet address and convert to binary */
int npf_hwaddr_char2saddr(char *bufp, struct sockaddr *sap);

#ifdef __cplusplus
}
#endif

#endif	/* _HWADDR_H_ */
