/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#ifndef _PDK_CALLBACK_TYPES_H_
#define _PDK_CALLBACK_TYPES_H_

/* put all the callback category here, increase MAX if needed */
#define MAXCBCATNUM	200

typedef enum {	/* external starts with NPF_ */
		NPF_CAT_FE = 0,
		NPF_CAT_IF,
		NPF_CAT_IPR,
		NPF_CAT_ICMP,
		NPF_CAT_PORT,
		NPF_CAT_IPv4,
		NPF_CAT_IPV6,
        	NPF_CAT_IPV6TM,
		NPF_CAT_MPLS,
		NPF_CAT_MPLS_EVT,
		NPF_CAT_DS,
                NPF_CAT_INTSERV,
                NPF_CAT_GTP,
                NPF_CAT_ATM,
                NPF_CAT_ATM_LINK,
                NPF_CAT_ATM_CONN,
                NPF_CAT_ATM_OAM,
		NPF_EVT_FE,
		NPF_EVT_IF,
		NPF_EVT_IPR,
		NPF_EVT_PORT,
		NPF_EVT_IPv4,
                NPF_EVT_GTPRX,
                NPF_EVT_GTPTX,
                NPF_EVT_ATM_LINK,
                NPF_EVT_ATM_CONN,
                NPF_EVT_ATM_OAM,

		/* internal starts with PDK_ */
		PDK_EVT_FE,
		PDK_EVT_IF,
		PDK_EVT_IPR,
		PDK_EVT_PORT,
		PDK_EVT_IPv4,
		PDK_EVT_IPv6,
		PDK_VIDD_EVT_VI_EVENT,
                PDK_CAT_MPLS,
                PDK_CAT_DS,
		PDK_BD_EVT_FEBIND, 

		/* FPPAPI CB Types */

/* =====>> Deprecating from here until <<===== */
    FPPI_IPv4_AddRoute,
    FPPI_IPv4_DelRoute,
    FPPI_IPv4_PurgeRoute,
    FPPI_ARP_AddEntry,
    FPPI_ARP_DelEntry,
    FPPI_ARP_QueryEntry,
    FPPI_ARP_PurgeEntry,
/* <<===== Deprecating from =====>> to here */

    FPPI_IPv4_UniAddNextHop,
    FPPI_IPv4_UniDelNextHop,
    FPPI_IPv4_UniFlushNextHop,
    FPPI_IPv4_UniQueryNextHop,
    FPPI_IPv4_UniAddPrefix,
    FPPI_IPv4_UniUpdatePrefix,
    FPPI_IPv4_UniDelPrefix,
    FPPI_IPv4_UniFlushPrefix,
    FPPI_IPv4_UniQueryPrefix,
    FPPI_IPv4_UniAddToL2,
    FPPI_IPv4_UniDelToL2,
    FPPI_IPv4_UniFlushToL2,

    FPPI_IPv6_AddNextHop,
    FPPI_IPv6_DelNextHop,
    FPPI_IPv6_FlushNextHop,
    FPPI_IPv6_QueryNextHop,
    FPPI_IPv6_AddPrefix,
    FPPI_IPv6_DelPrefix,
    FPPI_IPv6_FlushPrefix,
    FPPI_IPv6_QueryPrefix,
    FPPI_IPv6_AddToL2,
    FPPI_IPv6_DelToL2,

    FPPI_IPv6TM_EnableAuto,
    FPPI_IPv6TM_DisableAuto,
    FPPI_IPv6TM_EnableConfig,
    FPPI_IPv6TM_DisableConfig,
    FPPI_IPv6TM_Enable6to4,
    FPPI_IPv6TM_Disable6to4,

                FPPI_FEBind_Event,
                FPPI_FEUnBind_Event,
                FPPI_CEUnBind_Event,
                FPPI_LinkUp_Event,
                FPPI_LinkDown_Event,
                FPPI_ARP_AddEntry_Event,
                FPPI_ARP_DelEntry_Event,
		FPPI_FEPortCap_Event,
                FPPI_FECapability_Event,
                FPPI_CEReady_Event,
                FPPI_Directly_Connected_Host_Event,
                FPPI_PacketIO_Event,
                FPPI_L2_SetProperties,
                FPPI_L2_DelProperties,
                FPPI_L2_GetStatistics,
                FPPI_L3_SetProperties,
                FPPI_L3_SetPropertiesIPv6,
                FPPI_L3_DelProperties,
                FPPI_L3_DelPropertiesIPv6,
                FPPI_L3_GetStatistics,
                FPPI_ICMP_GetStatistics,
                FPPI_CAT_MPLS,                  // MPLS FP Category
		FPPI_DS_DpeOperation,

                FPPI_GTP_RX_Setup,
                FPPI_GTP_RX_Release,
                FPPI_GTP_RX_GetTunnelInfo,
                FPPI_GTP_TX_Setup,
                FPPI_GTP_TX_Release,
                FPPI_GTP_TX_GetTunnelInfo,
                FPPI_GTP_SRNC_RelocationCmd,
                FPPI_GTP_SRNC_SuspendRAB,
                FPPI_GTP_SRNC_RelocationComp,
                FPPI_GTP_TRNC_RelocationCmd,
                FPPI_GTP_TRNC_RelocationComp,
                FPPI_GTP_SetBufferSize,
                FPPI_GTP_GetPDCPSeqNumber,
                FPPI_GTP_DataForwardCmd,
                FPPI_GTP_SuspendRAB, 

#ifdef _INCLUDE_ATM
                FPPI_ATM_IfAttrSet,
                FPPI_ATM_IfDelete,
                FPPI_ATM_IfEnable,
                FPPI_ATM_IfDisable,
                FPPI_ATM_IfGenStatsGet,
                FPPI_ATM_VccSet,        
                FPPI_ATM_VccBind,        
                FPPI_ATM_VccDelete,        
                FPPI_ATM_VccEnable,        
                FPPI_ATM_VccDisable,
                FPPI_ATM_VccOperStatusGet,
                FPPI_ATM_VccStatsGet,
                FPPI_ATM_AAL2_ChannelSet,        
                FPPI_ATM_AAL2_ChannelDel,        
                FPPI_ATM_ConnectionXcSet,        
                FPPI_ATM_ConnectionXcDel,        
                FPPI_ATM_OAM_CP_Set,
                FPPI_ATM_OAM_CC_Set,
                FPPI_ATM_OAM_LB_Set,
                FPPI_ATM_OAM_Monitor,
                FPPI_ATM_OAM_AlarmSet,
                FPPI_ATM_OAM_AlarmClear,
                FPPI_ATM_OAM_PM_Set,
                FPPI_ATM_VccUp_Event,
                FPPI_ATM_VccDown_Event,
                FPPI_ATM_OAM_AisAlarm_Event,
                FPPI_ATM_OAM_RdiAlarm_Event,
                FPPI_ATM_OAM_FpmStats_Event,
                FPPI_ATM_OAM_BrStats_Event,
                FPPI_ATM_OAM_Lb_Event
#endif /* _INCLUDE_ATM */

} NPF_CBCAT;

typedef struct callback_tag
{
    NPF_CBHANDLE	cbid;		/* unique callback id */
    NPF_USERCONTEXT	context;
    NPF_CBCAT		category;
    NPF_GENERAL_CBFUNC	func;		/* user provided callback func */
} CB_t;


#endif
