/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

#ifndef PDKMACROS_H
#define PDKMACROS_H

#include <stdio.h>

extern int DBG_INDENT;

#define INDENT() \
    {\
    int i;\
    for ( i = 0; i < DBG_INDENT; i++, printf( "   " ) );\
    }

#define CHK_PTR( ptr ) \
    if ( !ptr ) {\
        printf( " ** WARNING ** Received a NULL pointer\n" ); \
        return; \
    }

#define DBG_PRINT( fmt, args... ) \
    { \
    INDENT();\
    printf( fmt, ## args ); \
    }

#define DBG_TRACE() \
    { \
    INDENT(); \
    printf( "** entering %s \n", __PRETTY_FUNCTION__ ); \
    DBG_INDENT++; \
    }

#define RETURN( val ) \
    { \
    DBG_INDENT--; \
    INDENT(); \
    printf( "## leaving %s \n", __PRETTY_FUNCTION__ ); \
    return val; \
    }
    
#endif
