/////////////////////////////////////////////////////////////////////////
//                                                                     //
// Filename: PILTYPE.H                                                 //
// Module:   Platform Isolation Layer Type Definitions                 //
// Author:   Daniel Baumberger                                         //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
//      Copyright (C) 1999 Intel Corporation  ALL RIGHTS RESERVED      //
//                                                                     //
//             INTEL CORPORATION PROPRIETARY INFORMATION               //
//                                                                     //
//     This software is supplied under the terms of a license agree-   //
//     ment or non-disclosure agreement with Intel Corporation         //
//     and may not be copied nor disclosed except in accordance        //
//     with the terms of that agreement.                               //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
// PURPOSE:                                                            //
//                                                                     //
// Provides emulation of platform specific types.                      //
//                                                                     //
/////////////////////////////////////////////////////////////////////////

#ifndef __PILTYPE_H_INCLUDED__
#define __PILTYPE_H_INCLUDED__

//
// Standard types
//

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef char CHAR;
typedef int INT;
typedef signed long LONG;

#ifndef VOID
#define VOID void
#endif

//
// Pointer types
//

typedef BYTE *PBYTE;
typedef WORD *PWORD;
typedef DWORD *PDWORD;
typedef CHAR *PCHAR;
typedef INT *PINT;
typedef LONG *PLONG;
typedef VOID *PVOID;

typedef BYTE *LPBYTE;
typedef WORD *LPWORD;
typedef DWORD *LPDWORD;
typedef CHAR *LPCHAR;
typedef INT *LPINT;
typedef LONG *LPLONG;
typedef VOID *LPVOID;

#ifndef __USE_BSD
#ifndef u_long
#define u_long unsigned long
#endif

#ifndef u_char
#define u_char unsigned char
#endif

#ifndef u_short
#define u_short unsigned short
#endif
#endif

#endif // __PILTYPE_H_INCLUDED__
