/////////////////////////////////////////////////////////////////////////
//                                                                     //
// Filename: PIL_INT.H                                                 //
// Module:   Platform Isolation Layer Internal Header                  //
// Author:   JP Sugarbroad                                             //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
//      Copyright (C) 1999 Intel Corporation  ALL RIGHTS RESERVED      //
//                                                                     //
//             INTEL CORPORATION PROPRIETARY INFORMATION               //
//                                                                     //
//     This software is supplied under the terms of a license agree-   //
//     ment or non-disclosure agreement with Intel Corporation         //
//     and may not be copied nor disclosed except in accordance        //
//     with the terms of that agreement.                               //
//                                                                     //
/////////////////////////////////////////////////////////////////////////

#ifndef _PIL_INT_H_
#define _PIL_INT_H_

#include "pil_vx.h"
#include "pillist.h"

#ifdef DEBUG
typedef struct csinfo_s
{
  char *name;
  PilThread_t *owner;
  pillist blocking;
} csinfo_t;
#endif

typedef struct PilCS_t
{
  SEM_ID Sem ;
#ifdef DEBUG
  csinfo_t *info;
#endif
} PilCS ;

#define PILLIST_MUTEX_TYPE SEM_ID

#define PILLIST_LOCK(l) \
	semTake(l,WAIT_FOREVER)

#define PILLIST_UNLOCK(l) \
	semGive(l)

#endif
