/////////////////////////////////////////////////////////////////////////
//                                                                     //
// Filename: PILDEBUG.C                                                //
// Module:   PIL Debug Management Routines.                            //
// Author:   Venky Gokulrangan                                         //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
//      Copyright (C) 1999 Intel Corporation  ALL RIGHTS RESERVED      //
//                                                                     //
//             INTEL CORPORATION PROPRIETARY INFORMATION               //
//                                                                     //
//     This software is supplied under the terms of a license agree-   //
//     ment or non-disclosure agreement with Intel Corporation         //
//     and may not be copied nor disclosed except in accordance        //
//     with the terms of that agreement.                               //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
// PURPOSE:   TO PROVIDE DEBUG ROUTINES                                //
//                                                                     //
// NOTES:                                                              //
//   This code was derived from Dan Baumberger's DEBUG ROUTINES        //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//
// HISTORY:
/////////////////////////////////////////////////////////////////////////

#include <stdarg.h>
#include <stdio.h>

#include "pil_vx.h"



///////////////////////////////////////////////////////////////////////////
//
// Function: PIL_Trace 
//           Borrowed from OLD Debug Code
// Purpose:  Provides a trace provision ; Output is generated only if
//           the DEBUG option was specified during compilation
//           THIS FUNCTION USES THE VARIABLE ARGUMENT LIST TO PARSE OUT
//           INDIVIDUAL FIELDS
// Returns:  Number of characters written to the standard output..
//

DWORD
PIL_Trace (
     PCHAR  Format,
     ... )
{
   CHAR     Buffer [MAX_BUFFER_LEN] ;
   va_list  args ;
   DWORD    dwChars;

   va_start ( args, Format ) ;
   dwChars = vsprintf ( Buffer, Format, args ) ;
   va_end (args) ;

#ifdef DEBUG
   printf ( "%s\n", Buffer ) ;
#endif

   return dwChars ;
}
