/////////////////////////////////////////////////////////////////////////
//                                                                     //
// Filename: PILMISC.C                                                 //
// Module:   PIL miscellaneous functions                               //
// Author:   Mitu Aggarwal                                             //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
//      Copyright (C) 1999 Intel Corporation  ALL RIGHTS RESERVED      //
//                                                                     //
//             INTEL CORPORATION PROPRIETARY INFORMATION               //
//                                                                     //
//     This software is supplied under the terms of a license agree-   //
//     ment or non-disclosure agreement with Intel Corporation         //
//     and may not be copied nor disclosed except in accordance        //
//     with the terms of that agreement.                               //
//                                                                     //
/////////////////////////////////////////////////////////////////////////
//                                                                     //
// PURPOSE: Implement miscellaneous functions that are not supported   //
//          in VxWorks                                                 //
//                                                                     //
/////////////////////////////////////////////////////////////////////////

#include <semLib.h>

#include "pil_vx.h"
#include "resolvLib.h"
#include "timers.h"

char HostBuf[1024];

///////////////////////////////////////////////////////////////////////
//
// PIL_GetHostByName
//
// @func <f PIL_GetHostByName> returns the DNS resolved IP Address 
//  for the given host.  
//
//////////////////////////////////////////////////////////////////////

struct hostent *  
PIL_GetHostByName( char *pHostName)
{
/* GWG - not defined in VxWorks image for Xscale. This method not
   called by PDK so comment out "undefined symbol". */
    return NULL;

/*
     return resolvGetHostByName(pHostName, &HostBuf, sizeof(HostBuf));
*/
}

///////////////////////////////////////////////////////////////////////
//
// PIL_Sleep
//
// @func <f PIL_Sleep> delays the execution of the process for at least
// the time specified.
//
// @rdesc return zero on success.
//
//

int
PIL_Sleep( int sec, long nanosecs)
{
	struct timespec	sleepTime;

	memset(&sleepTime, 0, sizeof(sleepTime));
	sleepTime.tv_sec = sec;
	sleepTime.tv_nsec = nanosecs;

	nanosleep(&sleepTime, NULL);

	return 0;
}

int nanosleep(const struct timespec *ts1, struct timespec *ts2)
{
	return 0;
}
