#!/bin/bash

#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

export LINUX_MULTI_CLIENT="NO"
export SQESTUBS="NO"
export IPV6STUBS="YES"
export IXASDK_VER="ixasdk30"

prompt()
{
local TEMPSTR=
read -p "$1 [${!2}] " TEMPSTR
if [ "$TEMPSTR" == "" ]
then
    TEMPSTR=${!2}
fi

if [ "$TEMPSTR" != "" ]
then
	export $2=$TEMPSTR
else
    echo 
    echo "*** WARINING ***"
    echo "No Value specified for $1"
    echo 
fi
}

saveconfig()
{
echo "ifeq (\$($1),)" >> $3
echo "$1=$2" >> $3
echo "endif" >> $3
}

prompt "What OS is hosting this build?" HOST_OS
prompt "Are the CP and FP to be colocated (YES/NO)?" COLOCATED
if [ $COLOCATED == YES ]
then
	prompt "What is the target OS?" TARG_OS
	prompt "What is the target architecture?" TARG_ARCH
	export TARG_OS_CP=$TARG_OS
	export TARG_ARCH_CP=$TARG_ARCH
	export TARG_OS_FP=$TARG_OS
	export TARG_ARCH_FP=$TARG_ARCH
else
	prompt "What is the target OS of the Control Plane?" TARG_OS_CP
	prompt "What is the target OS of the Forwarding Plane?" TARG_OS_FP
	prompt "What is the target architecture of the Control Plane?" TARG_ARCH_CP
	prompt "What is the target architecture of the Forwarding Plane?" TARG_ARCH_FP
fi

prompt "Should stubs be used for IXASDK?" IXASTUBS

echo "#PDK Build Configuration" > .config

saveconfig HOST_OS $HOST_OS .config
saveconfig COLOCATED $COLOCATED .config
saveconfig LINUX_MULTI_CLIENT $LINUX_MULTI_CLIENT .config
saveconfig TARG_OS_CP $TARG_OS_CP .config
saveconfig TARG_OS_FP $TARG_OS_FP .config
saveconfig TARG_ARCH_CP $TARG_ARCH_CP .config
saveconfig TARG_ARCH_FP $TARG_ARCH_FP .config
saveconfig IXASTUBS $IXASTUBS .config
saveconfig SQESTUBS $SQESTUBS .config
saveconfig IXASDK_VER $IXASDK_VER .config
saveconfig IPV6STUBS $IPV6STUBS .config

