/*****************************************************************************
 *                  INTEL CORPORATION PROPRIETARY IF_INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 *$Source: /cvs/constellations/ixa_3.0/src/cp_pdk/cppui/build/inc/cppui.h,v $
 *$Revision: 1.5 $
 *$Date: 2003/11/17 16:57:56 $
 * Description:
 *     This file contains the datastructures and API of CPPUI module
 *
 *****************************************************************************/

#ifndef __CPPUI_H__
#define __CPPUI_H__

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/types.h>
#include <unistd.h>
#include <math.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include"list.h"
#include"rwlock.h"

#ifdef _VXWORKS_
#include "ioLib.h"
#include "pipeDrv.h"
#include <sockLib.h>
#else
#include <sys/time.h>
#endif

#include"npf.h"
#include"npf_common.h"
#include"log.h"
#include"npf_cm_types.h"
#include"pdk_callback_types.h"
#include"fpp_common.h"
#include"npf_ns_types.h"
#include"npf_ns_api.h"
#include"fppCapabilityTypes.h"
#include"fppapi.h"
#include"pdk_cm.h"


PilThread cppuiThread;
PilThread timerThread;
PilCriticalSection LOCK;
#define CPPUI_LOCK() PIL_EnterCriticalSection(&LOCK);
#define CPPUI_UNLOCK() PIL_LeaveCriticalSection(&LOCK);

DList EventListners;

#define CPPDK_PORT 7890
#define MAX_MSG_SIZE 2048
#define MAX_EVENT_COUNT 10

extern NPF_error_t             registerCppdk;

typedef struct
{
   unsigned long long reqts;
   unsigned long long respts;
   long  seq;
   int  error;
   int  type;
   char msg[MAX_MSG_SIZE];
   char args[100][100];
   int  no;
   int  sd;
   int  pos;
   int  dsize;
   char  resp[MAX_MSG_SIZE];
   struct sockaddr_in to;
   int  toLen;
} CppuiRequest;

int    g_pipefds[2];

#define ASYNC_RESP_WAIT_TIME  5
#define ERROR_REQUEST_TIMEOUT   9999

typedef enum
{
    CPPUI_LAN_INTERFACE_HANDLE,
    CPPUI_POS_INTERFACE_HANDLE,
    CPPUI_IPV4_INTERFACE_HANDLE,
    CPPUI_IPV4_FWD_HANDLE,
    CPPUI_IPV4_PREFIX_HANDLE,
    CPPUI_IPV4_NEXTHOP_HANDLE,
    CPPUI_IPV4_ADDRESS_HANDLE,
    CPPUI_IPV4_FIB_HANDLE,
    CPPUI_MPLS_INTERFACE_HANDLE,
    CPPUI_MPLS_LSP_HANDLE,
    CPPUI_MPLS_NHLFE_HANDLE,
    CPPUI_MPLS_NHLFE_SET_HANDLE,
    CPPUI_ATM_INTERFACE_HANDLE,
    CPPUI_CLASSIFIER_HANDLE,
    CPPUI_METER_HANDLE,
    CPPUI_MARKER_HANDLE,
    CPPUI_DROPPER_HANDLE
}CppuiHandleType_t;

void sendEvent(char *event);
void sendResponse(CppuiRequest *req);
extern NPF_RET pdk_ns_getFE_from_If(NPF_HANDLE intf_npf_hdl, NPF_HANDLE* fe_npf_hdl);
extern void process(CppuiRequest *req);
void addEventListner(CppuiRequest *req);
void deleteEventListner(CppuiRequest *req);
void cppuiCallback( NPF_userContext_t,NPF_correlator_t corr, void *data);
void waitAsyncResponse(CppuiRequest  *req);
int getipv4address(char *input, NPF_uint32_t *addr);
int getmacaddress(char *input, uint8_t *macaddr);
int getatmaddress(char *input, NPF_VccAddr_t *atmaddr);
char* getIPStringFromInt(uint32_t ipAddr);
void getTime(unsigned long long *ms);
char *getTimeString(void);
int storeHandle(CppuiHandleType_t type, uint32_t handle);
int getHandle(char *input);
void cppdkInit(void);
void onCppuiConnect(CppuiRequest *req);
void onCppuiDisconnect(CppuiRequest *req);
void cppdkShutdown(void);
void CppuiEventRegister(void);
void CppuiEventDeregister(void);
int  Reset_DS_Handles(void);
int  Reset_IPV4_Handles(void);

#endif
