/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

        #ifndef __CPPUI_COMMON_H__
        #define __CPPUI_COMMON_H__
         
        #include "cppui.h"
         
         
        #define CPPDK_CONST  1000
        #define CPPDK_CONNECT_REQ  CPPDK_CONST + 1
        #define CPPDK_DISCONNECT_REQ  CPPDK_CONST + 2
        #define CPPDK_EVENT  34567
        #define EVENT_PRIORITY_NORMAL  0
        #define EVENT_PRIORITY_MEDIUM  1
        #define EVENT_PRIORITY_HIGH  2
        #define EVENT_PRIORITY_CRITICAL  3
        #define MAX_PORT_COUNT  4
         
        typedef enum CppuiEvent
        {
            CPPUI_EVENT_FE_BIND,
            CPPUI_EVENT_FE_UNBIND,
            CPPUI_EVENT_FE_PORT,
            CPPUI_EVENT_PORT_LINK_UP,
            CPPUI_EVENT_PORT_LINK_DOWN,
            CPPUI_EVENT_IF_UP,
            CPPUI_EVENT_IF_DOWN,
            CPPUI_EVENT_UNKNOWN
        };
         
        #include "cppui_namespace.h"
        #include "cppui_interface.h"
        #include "cppui_interface.h"
        #include "cppui_ipv4.h"
        #include "cppui_ipv4.h"
        #ifdef DIFFSERV
        #include "cppui_diffserv.h"
        #endif
        #ifdef MPLS
        #include "cppui_mpls.h"
        #endif
        #ifdef ATM
        #include "cppui_atm.h"
        #endif
        #ifdef RCM
        #include "cppui_rcm.h"
        #endif
         
        #ifdef MPLS
        
        
        #endif
         
        void cppui_send_FE_BIND_event(int FEid);
        void cppui_send_FE_UNBIND_event(int FEid);
        void cppui_send_FE_PORT_event(int fid, int pid);
        void cppui_send_PORT_LINK_UP_event(int feid, int portid);
        void cppui_send_PORT_LINK_DOWN_event(int feid, int portid);
        void cppui_send_IF_UP_event(int handle);
        void cppui_send_IF_DOWN_event(int handle);
         
        #endif
         
