/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

        #ifndef __CPPUI_IPV4_H__
        #define __CPPUI_IPV4_H__
         
        #include "cppui.h"
         
         
        
        #include "npf_ipv4_types.h"
        #include "npf_ipv4_api.h"
        NPF_callbackHandle_t	IPV4cbh;
        #define IPV4_COMMON_ARGS IPV4cbh, (NPF_correlator_t)req, NPF_REPORT_ALL
        
         
        extern int NPF_IPv4UC_PrefixEntryAdd_SelfTest(   NPF_IPv4UC_PrefixTableHandle_t *prefixTableHandle, NPF_uint32_t *no, NPF_IPv4UC_Prefix_t *prefixEntry, NPF_uint32_t *nhId, void *corr);
        extern int NPF_IPv4UC_NextHopEntryAdd_SelfTest(             NPF_IPv4UC_NextHopTableHandle_t *nxthopTableHandle, NPF_uint32_t *no, NPF_uint32_t *nhId, NPF_IPv4UC_NextHopArray_t *nextHopEntry, void *corr);
        extern int NPF_IPv4UC_PrefixEntryDelete_SelfTest(             NPF_IPv4UC_PrefixTableHandle_t *prefixTableHandle, NPF_uint32_t *no, NPF_IPv4UC_Prefix_t *prefixEntry, void *corr);
        extern int NPF_IPv4UC_NextHopEntryDelete_SelfTest(                 NPF_IPv4UC_NextHopTableHandle_t *nxthopTableHandle, NPF_uint32_t *no, NPF_uint32_t *nhId, void *corr);
         
        extern void cppuiIPv4Callback(NPF_userContext_t userContext, NPF_correlator_t correlator, NPF_IPv4UC_CallbackData_t cbData);
        extern void getPrefixEntry(char *input, NPF_IPv4UC_Prefix_t *prefixEntry, uint32_t param );
        extern void getNextHopId(char *input, uint32_t *nhId, uint32_t param );
        extern void getNextHopParams(char *input, NPF_IPv4UC_NextHopArray_t *nha, int param);
        extern void getAddResParams(char *input, NPF_IPv4UC_AddResEntry_t *addResEntry, int param);
        extern int formatModeResp(int cmd,uint32_t mode, char *resp);
        extern int formatIPv4Response(int cmd, NPF_IPv4UC_CallbackData_t *data,  char *resp);
         
        extern void cppui_ipv4_message(CppuiRequest *req);
        extern void cppui_ipv4_response(CppuiRequest *req, void *data);
         
        #endif
        #ifndef __CPPUI_IPV4_UNIFIED_H__
        #define __CPPUI_IPV4_UNIFIED_H__
         
        #include "cppui.h"
         
         
        
        #include "npf_ipv4_types.h"
        #include "npf_ipv4_api.h"
        NPF_callbackHandle_t	IPV4cbh;
        #define IPV4_COMMON_ARGS IPV4cbh, (NPF_correlator_t)req, NPF_REPORT_ALL
        
         
         
         
        extern void cppui_ipv4_unified_message(CppuiRequest *req);
        extern void cppui_ipv4_unified_response(CppuiRequest *req, void *data);
         
        #endif
