/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

 
#include "cppui_common.h"
 
 
void cppuiCallback(NPF_userContext_t context, NPF_correlator_t corr, void *data)
{
    #ifdef CPPUI_WAIT_RESP
    uint32_t       len = 0;
    #endif
    CppuiRequest *req = (CppuiRequest *)corr;
    if(req == NULL || req->type == 0) return;
    getTime(&req->respts);
    #ifdef CPPUI_WAIT_RESP
    write(g_pipefds[1], (char *)&len, sizeof(len));
    #endif
    switch(req->type)
    {
        case 1:
        case 2:
        {
            cppui_namespace_response(req, data);
        }
        break;
        case 200:
        case 201:
        case 202:
        case 203:
        case 204:
        case 205:
        case 206:
        case 207:
        case 208:
        case 215:
        case 209:
        case 210:
        case 211:
        case 212:
        case 213:
        case 214:
        {
            cppui_interface_response(req, data);
        }
        break;
        case 250:
        case 251:
        case 252:
        case 253:
        case 254:
        case 255:
        case 256:
        case 257:
        case 258:
        case 259:
        case 260:
        case 261:
        case 262:
        case 263:
        {
            cppui_lan_response(req, data);
        }
        break;
        case 158:
        case 159:
        case 160:
        case 161:
        case 162:
        case 163:
        case 164:
        case 165:
        case 166:
        case 167:
        case 168:
        case 169:
        case 170:
        case 171:
        case 172:
        case 173:
        case 174:
        case 175:
        case 176:
        case 177:
        case 178:
        case 198:
        {
            cppui_ipv4_response(req, data);
        }
        break;
        case 180:
        case 181:
        case 182:
        case 183:
        case 184:
        case 185:
        {
            cppui_ipv4_unified_response(req, data);
        }
        break;
        #ifdef DIFFSERV
        case 100:
        case 101:
        case 102:
        case 103:
        case 113:
        case 104:
        case 105:
        case 106:
        case 107:
        case 108:
        case 109:
        case 110:
        case 111:
        case 112:
        case 114:
        {
            cppui_diffserv_response(req, data);
        }
        break;
        #endif
        #ifdef MPLS
        case 400:
        case 401:
        case 402:
        case 403:
        case 404:
        case 405:
        case 406:
        case 407:
        case 408:
        case 412:
        case 413:
        case 414:
        case 415:
        case 416:
        case 417:
        case 418:
        case 419:
        {
            cppui_mpls_response(req, data);
        }
        break;
        #endif
        #ifdef ATM
        case 503:
        case 510:
        case 511:
        case 512:
        case 513:
        case 514:
        case 515:
        case 516:
        case 517:
        {
            cppui_atm_response(req, data);
        }
        break;
        #endif
        #ifdef RCM
        case 199:
        {
            cppui_rcm_response(req, data);
        }
        break;
        #endif
    }
}

void cppui_send_FE_BIND_event(int FEid)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_FE_BIND);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_NORMAL);
    pos += sprintf(&event[pos], "%s;", "FE BIND EVENT");
    pos += sprintf(&event[pos], "%d;", FEid);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

void cppui_send_FE_UNBIND_event(int FEid)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_FE_UNBIND);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_CRITICAL);
    pos += sprintf(&event[pos], "%s;", "FE UNBIND EVENT");
    pos += sprintf(&event[pos], "%d;", FEid);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

void cppui_send_FE_PORT_event(int fid,int pid)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_FE_PORT);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_NORMAL);
    pos += sprintf(&event[pos], "%s;", "FE CAPABILITY EVENT");
    pos += sprintf(&event[pos], "%d;", fid);
    pos += sprintf(&event[pos], "%d;", pid);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

void cppui_send_PORT_LINK_UP_event(int feid,int portid)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_PORT_LINK_UP);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_NORMAL);
    pos += sprintf(&event[pos], "%s;", "PORT LINKUP EVENT");
    pos += sprintf(&event[pos], "%d;", feid);
    pos += sprintf(&event[pos], "%d;", portid);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

void cppui_send_PORT_LINK_DOWN_event(int feid,int portid)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_PORT_LINK_DOWN);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_CRITICAL);
    pos += sprintf(&event[pos], "%s;", "PORT LINKDOWN EVENT");
    pos += sprintf(&event[pos], "%d;", feid);
    pos += sprintf(&event[pos], "%d;", portid);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

void cppui_send_IF_UP_event(int handle)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_IF_UP);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_NORMAL);
    pos += sprintf(&event[pos], "%s;", "INTERFACE UP EVENT");
    pos += sprintf(&event[pos], "%d;", handle);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

void cppui_send_IF_DOWN_event(int handle)
{
    char	event[MAX_MSG_SIZE];
    int	pos = 0;
    pos += sprintf(&event[pos], "Event Begin#");
    pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);
    pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_IF_DOWN);
    pos += sprintf(&event[pos], "%d;", EVENT_PRIORITY_CRITICAL);
    pos += sprintf(&event[pos], "%s;", "INTERFACE DOWN EVENT");
    pos += sprintf(&event[pos], "%d;", handle);
    pos += sprintf(&event[pos], "#Event End");
    sendEvent(event);
}

