/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

         
        #include "cppui_common.h"
         
        int FormatDpeResponse(int id, NPF_DS_CallbackData_t *data, char *resp)
        {
        
	NPF_DS_DpeType_t type;
        int pos = 0;
        int error = NPF_NO_ERROR;
	if(data == NULL || data->resp == NULL)
	{
            pos += sprintf(&resp[pos], "NULL Response");
	    return(1);
	}
	error = data->resp->error;
	switch(data->resp->error)
	{
	    case NPF_NO_ERROR:
	    break;
	    default: pos += sprintf(&resp[pos], "Unknown Error in DPE Operation(%d)", (int)error);return(error);
	    case NPF_DS_E_INVALID_DPE          :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DPE");return(error);
	    case NPF_DS_E_NO_SUCH_DPE          :  pos += sprintf(&resp[pos], "NPF_DS_E_NO_SUCH_DPE");return(error);           
	    case NPF_DS_E_INVALID_INTERFACE    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_INTERFACE");return(error);
	    case NPF_DS_E_INVALID_DPE_PARAMETER   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DPE_PARAMETER");return(error);
	    case NPF_DS_E_DPE_NOT_SUPPORTED    :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_NOT_SUPPORTED");return(error);
	    case NPF_DS_E_INVALID_DPE_HANDLE   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DPE_HANDLE");return(error);
	    case NPF_DS_E_NO_STATS_AVAILABLE   :  pos += sprintf(&resp[pos], "NPF_DS_E_NO_STATS_AVAILABLE");return(error);
	    case NPF_DS_E_NOT_SUPPORTED        :  pos += sprintf(&resp[pos], "NPF_DS_E_NOT_SUPPORTED");return(error);
	    case NPF_DS_E_UNKNOWN              :  pos += sprintf(&resp[pos], "NPF_DS_E_UNKNOWN ");return(error);
	    case NPF_DS_E_RESOURCE             :  pos += sprintf(&resp[pos], "NPF_DS_E_RESOURCE");return(error);
	    case NPF_DS_E_INVALID_DPE_PATH     :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DPE_PATH");return(error);
	    case NPF_DS_E_INTERNAL             :  pos += sprintf(&resp[pos], "NPF_DS_E_INTERNAL");return(error);
	    case NPF_DS_E_DPE_NOT_CERATED      :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_NOT_CERATED ");return(error);
	    case NPF_DS_E_DPE_NOT_DELETED      :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_NOT_DELETED ");return(error);
	    case NPF_DS_E_DPE_ADD_ASSOC_FAILED :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_ADD_ASSOC_FAILED");return(error);
	    case NPF_DS_E_DPE_DEL_ASSOC_FAILED :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_DEL_ASSOC_FAILED");return(error);
	    case NPF_DS_E_DPE_INVALID_STATE :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_INVALID_STATE");return(error);
	    case NPF_DS_E_DPE_IN_USE :  pos += sprintf(&resp[pos], "NPF_DS_E_DPE_IN_USE");return(error);
	    case NPF_DS_E_INVALID_CLASSIFIER_TYPE :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_CLASSIFIER_TYPE ");return(error);
	    case NPF_DS_E_INVALID_CLASSIFIER_PARAMETER   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_CLASSIFIER_PARAMETER");return(error);
	    case NPF_DS_E_INVALID_PRECEDENCE   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_PRECEDENCE");return(error);
	    //case NPF_DS_E_INVALID_FI<ER       :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_FI<ER");return(error);
	    case NPF_DS_E_INVALID_SOURCE_ADDRESS  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SOURCE_ADDRESS");return(error);
	    case NPF_DS_E_INVALID_DEST_ADDRESS :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DEST_ADDRESS");return(error);
	    case NPF_DS_E_INVALID_SOURCE_PREFIX   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SOURCE_PREFIX");return(error);
	    case NPF_DS_E_INVALID_DEST_PREFIX  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DEST_PREFIX ");return(error);
	    case NPF_DS_E_INVALID_SOURCE_PORT  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SOURCE_PORT ");return(error);
	    case NPF_DS_E_INVALID_DEST_PORT    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DEST_PORT");return(error);
	    case NPF_DS_E_INVALID_DSCP         :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DSCP");return(error);
	    case NPF_DS_E_INVALID_PROTOCOL     :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_PROTOCOL");return(error);
	    case NPF_DS_E_INVALID_FLOW_ID      :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_FLOW_ID ");return(error);
	    case NPF_DS_E_INVALID_CLASS_ID     :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_CLASS_ID");return(error);
	    case NPF_DS_E_INVALID_FEC          :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_FEC ");return(error);
	    case NPF_DS_E_INVALID_LABEL        :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_LABEL");return(error);
	    //case NPF_DS_E_INVALID_FILETR_PARAMETER    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_FILETR_PARAMETER");return(error);
	    case NPF_DS_E_INVALID_METER_TYPE   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_METER_TYPE");return(error);
	    case NPF_DS_E_INVALID_METER_PARAMETER :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_METER_PARAMETER ");return(error);
	    case NPF_DS_E_INVALID_CIR          :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_CIR ");return(error);
	    case NPF_DS_E_INVALID_CBS          :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_CBS ");return(error);
	    case NPF_DS_E_INVALID_EBS          :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_EBS ");return(error);
	    case NPF_DS_E_INVALID_MARKER_TYPE  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_MARKER_TYPE ");return(error);
	    case NPF_DS_E_INVALID_MARKER_PARAMETER    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_MARKER_PARAMETER");return(error);
	    case NPF_DS_E_INVALID_DROPPER_TYPE :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DROPPER_TYPE");return(error);
	    case NPF_DS_E_INVALID_DROPPER_PARAMETER   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_DROPPER_PARAMETER");return(error);
	    case NPF_DS_E_INVALID_MIN_THRESHOLD   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_MIN_THRESHOLD");return(error);
	    case NPF_DS_E_INVALID_MAX_THRESHOLD   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_MAX_THRESHOLD");return(error);
	    case NPF_DS_E_INVALID_PROBABILITY  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_PROBABILITY ");return(error);
	    case NPF_DS_E_INVALID_SERVICE_RATE :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SERVICE_RATE");return(error);
	    case NPF_DS_E_INVALID_WEIGHT       :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_WEIGHT");return(error);
	    case NPF_DS_E_INVALID_Q_TYPE       :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_Q_TYPE");return(error);
	    case NPF_DS_E_INVALID_Q_PARAMETER  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_Q_PARAMETER ");return(error);
	    case NPF_DS_E_INVALID_CLASS_TYPE   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_CLASS_TYPE");return(error);
	    case NPF_DS_E_INVALID_PRIORITY     :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_PRIORITY");return(error);
	    case NPF_DS_E_INVALID_ABSOLUTE_RATE   :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_ABSOLUTE_RATE");return(error);
	    case NPF_DS_E_INVALID_RATE         :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_RATE");return(error);
	    case NPF_DS_E_INVALID_RATE_TYPE    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_RATE_TYPE");return(error);
	    case NPF_DS_E_INVALID_THRESHOLD    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_THRESHOLD");return(error);
	    case NPF_DS_E_INVALID_LEVEL        :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_LEVEL");return(error);
	    case NPF_DS_E_INVALID_SCHEDULER_TYPE  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SCHEDULER_TYPE");return(error);
	    case NPF_DS_E_INVALID_SCHEDULER_PARAMETER :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SCHEDULER_PARAMETER");return(error);
	    case NPF_DS_E_INVALID_MIN_RATE     :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_MIN_RATE");return(error);
	    case NPF_DS_E_INVALID_MAX_RATE     :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_MAX_RATE");return(error);
	    case NPF_DS_E_INVALID_SHAPER_TYPE  :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SHAPER_TYPE ");return(error);
	    case NPF_DS_E_INVALID_SHAPER_PARAMETER    :  pos += sprintf(&resp[pos], "NPF_DS_E_INVALID_SHAPER_PARAMETER");return(error);

	}
	switch(data->type)
	{
	    case NPF_DS_DPE_CREATE:
	    {
		type = getDpeType(data->resp->dpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
		    {
			int i = 0;
			pos += sprintf(&resp[pos], "Classifier Handle: ");
			for(i = 0; i < data->nResp; i++)
			{
			    pos += sprintf(&resp[pos], "%d ", (int)data->resp[i].dpeHandle);
		            storeHandle(CPPUI_CLASSIFIER_HANDLE, data->resp[i].dpeHandle);
			}
		    }
		    break;
		    case NPF_DS_METER:
		    {
			int i = 0;
			pos += sprintf(&resp[pos], "Meter Handle: ");
			for(i = 0; i < data->nResp; i++)
			{
		            storeHandle(CPPUI_METER_HANDLE, data->resp->dpeHandle);
			    pos += sprintf(&resp[pos], "%d ", (int)data->resp[i].dpeHandle);
			}
		    }
		    break;
		    case NPF_DS_MARKER:
		    {
			int i = 0;
			pos += sprintf(&resp[pos], "Marker Handle: ");
			for(i = 0; i < data->nResp; i++)
			{
		            storeHandle(CPPUI_MARKER_HANDLE, data->resp->dpeHandle);
			    pos += sprintf(&resp[pos], "%d ", (int)data->resp[i].dpeHandle);
			}
		    }
		    break;
		    case NPF_DS_DROPPER:
		    {
			int i = 0;
			pos += sprintf(&resp[pos], "Dropper Handle: ");
			for(i = 0; i < data->nResp; i++)
			{
		            storeHandle(CPPUI_DROPPER_HANDLE, data->resp->dpeHandle);
			    pos += sprintf(&resp[pos], "%d ", (int)data->resp[i].dpeHandle);
			}
		    }
		    break;
		    default:

		}
	    }
	    break;
	    case NPF_DS_DPE_MODIFY:
	    {
		type = getDpeType(data->resp->dpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
		        storeHandle(CPPUI_CLASSIFIER_HANDLE, data->resp->dpeHandle);
			pos += sprintf(&resp[pos], "Classifier (%d) Modified", (int)data->resp->dpeHandle);
		    break;
		    case NPF_DS_METER:
		        storeHandle(CPPUI_METER_HANDLE, data->resp->dpeHandle);
			pos += sprintf(&resp[pos], "Meter Handle(%d) Modified", (int)data->resp->dpeHandle);
		    break;
		    case NPF_DS_MARKER:
		        storeHandle(CPPUI_MARKER_HANDLE, data->resp->dpeHandle);
			pos += sprintf(&resp[pos], "Marker Handle(%d) Modified", (int)data->resp->dpeHandle);
		    break;
		    case NPF_DS_DROPPER:
		        storeHandle(CPPUI_DROPPER_HANDLE, data->resp->dpeHandle);
			pos += sprintf(&resp[pos], "Dropper Handle(%d) Modified", (int)data->resp->dpeHandle);
		    break;
		    default:

		}
	    }
	    break;
	    case NPF_DS_DPE_DELETE_ASSOC:
	    {
	 	NPF_DS_DpeType_t type;
	 	NPF_DS_DpeType_t ptype;
		type = getDpeType(data->resp->dpeHandle);
		ptype = getDpeType(data->resp->prevDpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], "\nClaffifier (%d) ", data->resp->dpeHandle);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], "\nMeter (%d) ", data->resp->dpeHandle);
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], "\nMarker (%d) ", data->resp->dpeHandle);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], "\nDropper (%d) ", data->resp->dpeHandle);
		    break;
		    default:
                	pos += sprintf(&resp[pos], " UNKNWON DPE ");
		}
		switch(ptype)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], " and Classifier (%d) Deassociated", data->resp->prevDpeHandle);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], " and Meter (%d) Deassociated", data->resp->prevDpeHandle);
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], " and Marker (%d) Deassociated", data->resp->prevDpeHandle);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], " and Dropper (%d) Deassociated", data->resp->prevDpeHandle);
		    break;
		    default:
                	pos += sprintf(&resp[pos], " UNKNWON DPE Deassociated");
		}
	    }
	    break;
	    case NPF_DS_DPE_ADD_ASSOC:
	    {
	 	NPF_DS_DpeType_t type;
	 	NPF_DS_DpeType_t ptype;
		type = getDpeType(data->resp->dpeHandle);
		ptype = getDpeType(data->resp->prevDpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], "\nClaffifier (%d) Associated with ", data->resp->dpeHandle);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], "\nMeter (%d) Associated with ", data->resp->dpeHandle);
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], "\nMarker (%d) Associated with ", data->resp->dpeHandle);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], "\nDropper (%d) Associated with ", data->resp->dpeHandle);
		    break;
		    default:
                	pos += sprintf(&resp[pos], " UNKNWON DPE ");
		}
		switch(ptype)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], " Classifier (%d)", data->resp->prevDpeHandle);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], " Meter (%d)", data->resp->prevDpeHandle);
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], " Marker (%d)", data->resp->prevDpeHandle);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], " Dropper (%d)", data->resp->prevDpeHandle);
		    break;
		    default:
                	pos += sprintf(&resp[pos], " UNKNOWN DPE");
		}
	    }
	    break;
	    case NPF_DS_DPE_DELETE:
	    {
		type = getDpeType(data->resp->dpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], "\nClaffifier (%d) Deleted", data->resp->dpeHandle);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], "\nMeter (%d) Deleted", data->resp->dpeHandle);
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], "\nMarker (%d) Deleted", data->resp->dpeHandle);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], "\nDropper (%d) Deleted", data->resp->dpeHandle);
		    break;
		    default:
                	pos += sprintf(&resp[pos], "\nDPE (%d) Deleted", data->resp->dpeHandle);
		}
	    }
	    break;
	    case NPF_DS_DPE_QUERY:
	    {
		type = getDpeType(data->resp->dpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], "Classifier Attributes(%d)\n", (int)data->resp->dpeHandle);
                	pos += sprintf(&resp[pos], "\nPrecedance:\t%d", data->resp->u.dpe.u.classifier.precedence);
                	pos += sprintf(&resp[pos], "\nDestAddr:\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.dstAddr);
                	pos += sprintf(&resp[pos], "\nDestNetpLen:\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.dstNetpLen);
                	pos += sprintf(&resp[pos], "\nSrcAddr:\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.srcAddr);
                	pos += sprintf(&resp[pos], "\nnSrcNetpLen:\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.srcNetpLen);
                	pos += sprintf(&resp[pos], "\nDscp:\t\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.dscp);
                	pos += sprintf(&resp[pos], "\nProtocol:\t\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.protocol);
                	pos += sprintf(&resp[pos], "\nDestL4Port:\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.dstL4Port);
                	pos += sprintf(&resp[pos], "\nSrcL4Port:\t%d", data->resp->u.dpe.u.classifier.filterEntry.filter_IPV4.srcL4Port);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], "Meter Attributes(%d)\n", (int)data->resp->dpeHandle);
                	pos += sprintf(&resp[pos], "\nCommitted Information Rate:\t%d", data->resp->u.dpe.u.meter.meterEntry.cir);
                	pos += sprintf(&resp[pos], "\nCommitted Burst Size:\t%d", data->resp->u.dpe.u.meter.meterEntry.cbs);
                	pos += sprintf(&resp[pos], "\nExcess Burst Size:\t\t%d", data->resp->u.dpe.u.meter.meterEntry.ebs);
			switch(data->resp->u.dpe.u.meter.meterEntry.nextGreenDpe)
			{
			    case NPF_DS_MARKER:
				pos += sprintf(&resp[pos],"\nNext Green DPE:\t\t MARKER");
			    break;
			    case NPF_DS_DROPPER:
				pos += sprintf(&resp[pos],"\nNext Green DPE:\t\t DROPPER");
			    break;
			    default: 
			    {
				pos += sprintf(&resp[pos], "\nNext Green DPE:\t\t %d", (int)data->resp->u.dpe.u.meter.meterEntry.nextGreenDpe);
			    }
			}
			switch(data->resp->u.dpe.u.meter.meterEntry.nextYellowDpe)
			{
			    case NPF_DS_MARKER:
				pos += sprintf(&resp[pos],"\nNext Yellow DPE:\t\t MARKER");
			    break;
			    case NPF_DS_DROPPER:
				pos += sprintf(&resp[pos],"\nNext Yellow DPE:\t\t DROPPER");
			    break;
			    default: 
			    {
				pos += sprintf(&resp[pos], "\nNext Yellow DPE:\t\t %d", (int)data->resp->u.dpe.u.meter.meterEntry.nextYellowDpe);
			    }
			}
			switch(data->resp->u.dpe.u.meter.meterEntry.nextRedDpe)
			{
			    case NPF_DS_MARKER:
				pos += sprintf(&resp[pos],"\nNext Red DPE:\t\t MARKER");
			    break;
			    case NPF_DS_DROPPER:
				pos += sprintf(&resp[pos],"\nNext Red DPE:\t\t DROPPER");
			    break;
			    default: 
			    {
				pos += sprintf(&resp[pos], "\nNext Red DPE:\t\t %d", (int)data->resp->u.dpe.u.meter.meterEntry.nextRedDpe);
			    }
			}
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], "Marker Attributes(%d)\n", (int)data->resp->dpeHandle);
                	pos += sprintf(&resp[pos], "\nGreen DSCP:\t%d", (int)data->resp->u.dpe.u.marker.markerEntry.dscp.greenDscp);
                	pos += sprintf(&resp[pos], "\nYellow DSCP:\t%d", (int)data->resp->u.dpe.u.marker.markerEntry.dscp.yellowDscp);
                	pos += sprintf(&resp[pos], "\nRed DSCP:\t%d", (int)data->resp->u.dpe.u.marker.markerEntry.dscp.redDscp);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], "Dropper Attributes(%d)\n", (int)data->resp->dpeHandle);
                	pos += sprintf(&resp[pos], "=> Green Packets\n");
                	pos += sprintf(&resp[pos], "\nMin Threshold:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.green.minThreshold);
                	pos += sprintf(&resp[pos], "\nMax Threshold:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.green.maxThreshold);
                	pos += sprintf(&resp[pos], "\nMax Probability:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.green.maxProbability);
                	pos += sprintf(&resp[pos], "\n=> Yellow Packets");
                	pos += sprintf(&resp[pos], "\nMin Threshold:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.yellow.minThreshold);
                	pos += sprintf(&resp[pos], "\nMax Threshold:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.yellow.maxThreshold);
                	pos += sprintf(&resp[pos], "\nMax Probability:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.yellow.maxProbability);
                	pos += sprintf(&resp[pos], "\n=> Red Packets");
                	pos += sprintf(&resp[pos], "\nMin Threshold:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.red.minThreshold);
                	pos += sprintf(&resp[pos], "\nMax Threshold:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.red.maxThreshold);
                	pos += sprintf(&resp[pos], "\nMax Probability:\t%d", (int)data->resp->u.dpe.u.dropper.dropperEntry.red.maxProbability);
		    break;
		    default:
		    {
		    }
		}
	    }
	    break;
	    case NPF_DS_DPE_STATISTICS:
	    {
	 	NPF_DS_DpeType_t type;
		type = getDpeType(data->resp->dpeHandle);
		switch(type)
		{
		    case NPF_DS_CLASSIFIER:
                	pos += sprintf(&resp[pos], "Classifier Statistics(%d)\n", data->resp->dpeHandle);
                	pos += sprintf(&resp[pos], "\nDefault Packets:\t%.0f", (double)data->resp->u.statsResp.u.classfierStats.defaultPackects);
                	pos += sprintf(&resp[pos], "\nDefault Bytes:\t%.0f", (double)data->resp->u.statsResp.u.classfierStats.defaultBytes);
                	pos += sprintf(&resp[pos], "\nTotal Packets:\t%.0f", (double)data->resp->u.statsResp.u.classfierStats.totalPackets);
                	pos += sprintf(&resp[pos], "\nTotal Bytes:\t%.0f", (double)data->resp->u.statsResp.u.classfierStats.totalBytes);
		    break;
		    case NPF_DS_METER:
                	pos += sprintf(&resp[pos], "Meter Statistics(%d)\n", (int)data->resp->dpeHandle);
			if(data->resp->u.statsResp.u.meterStats.type == NPF_DS_SRTCM_AWARE ||
			   data->resp->u.statsResp.u.meterStats.type == NPF_DS_TRTCM_AWARE)
			{
                	    pos += sprintf(&resp[pos], "\nGreen Byte Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.colorAwareStats.greenByteCount);
                	    pos += sprintf(&resp[pos], "\nGreen Packet Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.colorAwareStats.greenPacketCount);
                	    pos += sprintf(&resp[pos], "\nYellow Byte Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.colorAwareStats.yellowByteCount);
                	    pos += sprintf(&resp[pos], "\nYellow Packet Count:\t%.0f",(double)data->resp->u.statsResp.u.meterStats.u.colorAwareStats.yellowPacketCount);
                	    pos += sprintf(&resp[pos], "\nRed Byte Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.colorAwareStats.redByteCount);
                	    pos += sprintf(&resp[pos], "\nRed Packet Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.colorAwareStats.redPacketCount);
			}
			else
			{
                	    pos += sprintf(&resp[pos], "\nConformance Byte Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.simpleStats.confByteCount);
                	    pos += sprintf(&resp[pos], "\nConformance Packet Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.simpleStats.confPacketCount);
                	    pos += sprintf(&resp[pos], "\nNon Conformance Byte Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.simpleStats.nonConfByteCount);
                	    pos += sprintf(&resp[pos], "\nNon Conformance Packet Count:\t%.0f", (double)data->resp->u.statsResp.u.meterStats.u.simpleStats.nonConfPacketCount);
			}
		    break;
		    case NPF_DS_MARKER:
                	pos += sprintf(&resp[pos], "Marker Statistics(%d)\n", (int)data->resp->dpeHandle);
                	pos += sprintf(&resp[pos], "\nBytes Marked:\t%.0f", (double)data->resp->u.statsResp.u.markerStats.bytesMarked);
                	pos += sprintf(&resp[pos], "\nPackets Marked:\t%.0f", (double)data->resp->u.statsResp.u.markerStats.packetsMarked);
		    break;
		    case NPF_DS_DROPPER:
                	pos += sprintf(&resp[pos], "Dropper Statistics(%d)\n", (int)data->resp->dpeHandle);
			if(data->resp->u.statsResp.u.meterStats.type == NPF_DS_SRTCM_AWARE)
			{
                	    pos += sprintf(&resp[pos], "\nGreen Bytes Dropped:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.colorAwareDropperStats.greenByteDropped);
                	    pos += sprintf(&resp[pos], "\nGreen Packets Dropped:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.colorAwareDropperStats.greenPacketDropped);
                	    pos += sprintf(&resp[pos], "\nYellow Bytes Dropped:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.colorAwareDropperStats.yellowByteDropped);
                	    pos += sprintf(&resp[pos], "\nYellow Packets Dropped:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.colorAwareDropperStats.yellowPacketDropped);
                	    pos += sprintf(&resp[pos], "\nRed Bytes Dropped:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.colorAwareDropperStats.redByteDropped);
                	    pos += sprintf(&resp[pos], "\nRed Packets Dropped:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.colorAwareDropperStats.redPacketDropped);
			}
			else
			{
                	    pos += sprintf(&resp[pos], "Bytes Consumed\n:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.simpleDropperStats.bytesConsumed);
                	    pos += sprintf(&resp[pos], "Bytes Dropped\n:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.simpleDropperStats.packetsConsumed);
                	    pos += sprintf(&resp[pos], "Packets Consumed\n:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.simpleDropperStats.bytesDropped);
                	    pos += sprintf(&resp[pos], "Packets Dropped\n:\t%.0f", (double)data->resp->u.statsResp.u.dropperStats.u.simpleDropperStats.packetsDropped);
			}
		    break;
		    default:
		    {
		    }
		}
	    }
	    break;
	}
	return(0);
    
        }
        int AddDscpFilter(NPF_callbackHandle_t cbhandle, NPF_correlator_t req, NPF_errorReporting_t errorReporting)
        {
        
         NPF_error_t ret;
	 int i;
	 NPF_DS_DpeHandle_t classHandle;
	 NPF_DS_DpeHandle_t meterHandle;
	 NPF_DS_DpeHandle_t markerHandle;
	 NPF_DS_Dpe_t   dpe[DSCP_CLASSIFIER_SIZE];
	 NPF_DS_DpeSetHandle_t   assoc[DSCP_CLASSIFIER_SIZE];

	 for(i = 0; i < DSCP_CLASSIFIER_SIZE; i++)
	 {
	     dpe[i].type = NPF_DS_CLASSIFIER;
	     dpe[i].u.classifier.type = 4;
	     dpe[i].u.classifier.precedence = 0;
	     dpe[i].u.classifier.filterEntry.filter_DSCP.dscp = i;
	 }
	 ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, getHandle("POS:0"), 1, DSCP_CLASSIFIER_SIZE, dpe);
	 for(i = 0; i < DSCP_CLASSIFIER_SIZE; i++)
	 {
	     dpe[i].type = NPF_DS_METER;
	     dpe[i].u.meter.type = NPF_DS_SRTCM_AWARE;
	     dpe[i].u.meter.statsRequired = 1;
	     dpe[i].u.meter.meterEntry.cir = 100;
	     dpe[i].u.meter.meterEntry.pir = 100;
	     dpe[i].u.meter.meterEntry.cbs = 100;
	     dpe[i].u.meter.meterEntry.ebs = 100;
	     dpe[i].u.meter.meterEntry.pbs = 100;
	     dpe[i].u.meter.meterEntry.nextGreenDpe = NPF_DS_MARKER;
	     dpe[i].u.meter.meterEntry.nextYellowDpe = NPF_DS_MARKER;
	     dpe[i].u.meter.meterEntry.nextRedDpe = NPF_DS_MARKER;
	 }
	 ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, getHandle("POS:0"), 1, DSCP_CLASSIFIER_SIZE, dpe);
	 for(i = 0; i < DSCP_CLASSIFIER_SIZE; i++)
	 {
	     dpe[i].type = NPF_DS_MARKER;
	     dpe[i].u.marker.type = NPF_DS_MARKER_DSCP;
	     dpe[i].u.marker.statsRequired = 1;
	     dpe[i].u.marker.markerEntry.dscp.greenDscp = 10;
	     dpe[i].u.marker.markerEntry.dscp.yellowDscp = 12;
	     dpe[i].u.marker.markerEntry.dscp.redDscp = 14;
	 }
	 ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, getHandle("POS:0"), 1, DSCP_CLASSIFIER_SIZE, dpe);

	 for(i=0, classHandle = 1, meterHandle = DSCP_CLASSIFIER_SIZE + 1; i < DSCP_CLASSIFIER_SIZE; i++, classHandle++, meterHandle++)
	 {
	    assoc[i].dpeHandle = meterHandle;
	    assoc[i].prevDpeHandle = classHandle;
	 }
	 ret = NPF_DS_DpeAddAssociation(DS_COMMON_ARGS, DSCP_CLASSIFIER_SIZE, assoc);

	 for(i =0, meterHandle = DSCP_CLASSIFIER_SIZE + 1, markerHandle = 2*DSCP_CLASSIFIER_SIZE + 1; i < DSCP_CLASSIFIER_SIZE; i++, meterHandle++, markerHandle++)
	 {
	    assoc[i].dpeHandle = markerHandle;
	    assoc[i].prevDpeHandle = meterHandle;
	 }
	 ret = NPF_DS_DpeAddAssociation(DS_COMMON_ARGS, DSCP_CLASSIFIER_SIZE, assoc);

	 return(ret);
    
        }
         
         
        int NPF_DS_DpeCreate_SelfTest(NPF_IfHandle_t *ifHandle, NPF_DS_DpeDirection_t *dir, NPF_uint32_t *no, NPF_DS_Dpe_t* dpe, void *corr)
        {
        
			
		printf("----------------------------------------\n");
		printf("--------NPF_DS_DpeCreate_SelfTest ------\n");
		printf("----------------------------------------\n");
		return(0);
		
        }
         
void cppui_diffserv_message(CppuiRequest *req)
{
    switch(req->type)
    {
        case 100: /*DiffServCreate_Classifier */
        {
            NPF_IfHandle_t ifHandle;
            NPF_DS_DpeDirection_t dir;
            NPF_uint32_t no;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            int selftest = 0;
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            ifHandle = (int )getHandle(req->args[3]); /*IfHandle*/
            dir = (int )atol(req->args[4]); /*Direction*/
            dpe.type = (int )atol(req->args[5]); /*DpeType*/
            dpe.u.classifier.type = (int )atol(req->args[6]); /*ClassifierType*/
            dpe.u.classifier.precedence = (int )atol(req->args[7]); /*Precedence*/
            getipv4address(req->args[8], &dpe.u.classifier.filterEntry.filter_IPV4.dstAddr); /*DestAddress*/
            dpe.u.classifier.filterEntry.filter_IPV4.dstNetpLen = (int )atol(req->args[9]); /*DestNetpLen*/
            getipv4address(req->args[10], &dpe.u.classifier.filterEntry.filter_IPV4.srcAddr); /*SrcAddress*/
            dpe.u.classifier.filterEntry.filter_IPV4.srcNetpLen = (int )atol(req->args[11]); /*SrcNetpLen*/
            dpe.u.classifier.filterEntry.filter_IPV4.dscp = (int )atol(req->args[12]); /*Dscp*/
            dpe.u.classifier.filterEntry.filter_IPV4.protocol = (int )atol(req->args[13]); /*Protocol*/
            dpe.u.classifier.filterEntry.filter_IPV4.dstL4Port = (int )atol(req->args[14]); /*DestL4Port*/
            dpe.u.classifier.filterEntry.filter_IPV4.srcL4Port = (int )atol(req->args[15]); /*SrcL4Port*/
            selftest = (int)atol(req->args[16]);
             
            if(selftest)
                ret = NPF_DS_DpeCreate_SelfTest(&ifHandle, &dir, &no, &dpe, req);
            else
                ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, ifHandle, dir, no, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 101: /*DiffServCreate_Meter */
        {
            NPF_IfHandle_t ifHandle;
            NPF_DS_DpeDirection_t dir;
            NPF_uint32_t no;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            ifHandle = (int )getHandle(req->args[3]); /*IfHandle*/
            dir = (int )atol(req->args[4]); /*Direction*/
            dpe.type = (int )atol(req->args[5]); /*DpeType*/
            dpe.u.meter.type = (int )atol(req->args[6]); /*MeterType*/
            dpe.u.meter.meterEntry.cir = (int )atol(req->args[7]); /*CIR*/
            dpe.u.meter.meterEntry.pir = (int )atol(req->args[8]); /*PIR*/
            dpe.u.meter.meterEntry.cbs = (int )atol(req->args[9]); /*CBS*/
            dpe.u.meter.meterEntry.pbs = (int )atol(req->args[10]); /*PBS*/
            dpe.u.meter.meterEntry.ebs = (int )atol(req->args[11]); /*EBS*/
            dpe.u.meter.meterEntry.nextGreenDpe = (int )atol(req->args[12]); /*GreenDpe*/
            dpe.u.meter.meterEntry.nextYellowDpe = (int )atol(req->args[13]); /*YellowDpe*/
            dpe.u.meter.meterEntry.nextRedDpe = (int )atol(req->args[14]); /*RedDpe*/
            dpe.u.meter.statsRequired = (int )atol(req->args[15]); /*Statistics*/
            ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, ifHandle, dir, no, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 102: /*DiffServCreate_Marker */
        {
            NPF_IfHandle_t ifHandle;
            NPF_DS_DpeDirection_t dir;
            NPF_uint32_t no;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            ifHandle = (int )getHandle(req->args[3]); /*IfHandle*/
            dir = (int )atol(req->args[4]); /*Direction*/
            dpe.type = (int )atol(req->args[5]); /*DpeType*/
            dpe.u.marker.type = (int )atol(req->args[6]); /*MarkerType*/
            dpe.u.marker.markerEntry.dscp.greenDscp = (int )atol(req->args[7]); /*GreenDSCP*/
            dpe.u.marker.markerEntry.dscp.yellowDscp = (int )atol(req->args[8]); /*YellowDSCP*/
            dpe.u.marker.markerEntry.dscp.redDscp = (int )atol(req->args[9]); /*RedDSCP*/
            dpe.u.marker.statsRequired = (int )atol(req->args[10]); /*Statistics*/
            ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, ifHandle, dir, no, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 103: /*DiffServCreate_Dropper */
        {
            NPF_IfHandle_t ifHandle;
            NPF_DS_DpeDirection_t dir;
            NPF_uint32_t no;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            ifHandle = (int )getHandle(req->args[3]); /*IfHandle*/
            dir = (int )atol(req->args[4]); /*Direction*/
            dpe.type = (int )atol(req->args[5]); /*DpeType*/
            dpe.u.dropper.type = (int )atol(req->args[6]); /*DropperType*/
            dpe.u.dropper.serviceRate = (int )atol(req->args[7]); /*Service_Rate*/
            dpe.u.dropper.weight = (int )atol(req->args[8]); /*Weight*/
            dpe.u.dropper.dropperEntry.green.minThreshold = (int )atol(req->args[9]); /*GreenMinThreshold*/
            dpe.u.dropper.dropperEntry.green.maxThreshold = (int )atol(req->args[10]); /*GreenMaxThreshold*/
            dpe.u.dropper.dropperEntry.green.maxProbability = (int )atol(req->args[11]); /*GreenMaxProbability*/
            dpe.u.dropper.dropperEntry.yellow.minThreshold = (int )atol(req->args[12]); /*YellowMinThreshold*/
            dpe.u.dropper.dropperEntry.yellow.maxThreshold = (int )atol(req->args[13]); /*YellowMaxThreshold*/
            dpe.u.dropper.dropperEntry.yellow.maxProbability = (int )atol(req->args[14]); /*YellowMaxProbability*/
            dpe.u.dropper.dropperEntry.red.minThreshold = (int )atol(req->args[15]); /*RedMinThreshold*/
            dpe.u.dropper.dropperEntry.red.maxThreshold = (int )atol(req->args[16]); /*RedMaxThreshold*/
            dpe.u.dropper.dropperEntry.red.maxProbability = (int )atol(req->args[17]); /*RedMaxProbability*/
            dpe.u.dropper.statsRequired = (int )atol(req->args[18]); /*Statistics*/
            ret = NPF_DS_DpeCreate(DS_COMMON_ARGS, ifHandle, dir, no, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 113: /*DiffServAdd_DSCP_Filter */
        {
            
            NPF_error_t ret = 1;
            
            
            ret = AddDscpFilter(DS_COMMON_ARGS);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 104: /*DiffServModify_Classifier */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            dpe.u.classifier.type = (int )atol(req->args[4]); /*ClassifierType*/
            dpe.u.classifier.precedence = (int )atol(req->args[5]); /*Precedence*/
            getipv4address(req->args[6], &dpe.u.classifier.filterEntry.filter_IPV4.dstAddr); /*DestAddress*/
            dpe.u.classifier.filterEntry.filter_IPV4.dstNetpLen = (int )atol(req->args[7]); /*DestNetpLen*/
            getipv4address(req->args[8], &dpe.u.classifier.filterEntry.filter_IPV4.srcAddr); /*SrcAddress*/
            dpe.u.classifier.filterEntry.filter_IPV4.srcNetpLen = (int )atol(req->args[9]); /*SrcNetpLen*/
            dpe.u.classifier.filterEntry.filter_IPV4.dscp = (int )atol(req->args[10]); /*Dscp*/
            dpe.u.classifier.filterEntry.filter_IPV4.protocol = (int )atol(req->args[11]); /*Protocol*/
            dpe.u.classifier.filterEntry.filter_IPV4.dstL4Port = (int )atol(req->args[12]); /*DestL4Port*/
            dpe.u.classifier.filterEntry.filter_IPV4.srcL4Port = (int )atol(req->args[13]); /*SrcL4Port*/
            ret = NPF_DS_DpeModify(DS_COMMON_ARGS, no, &dpeHandle, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 105: /*DiffServModify_Meter */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            dpe.u.meter.type = (int )atol(req->args[4]); /*MeterType*/
            dpe.u.meter.meterEntry.cir = (int )atol(req->args[5]); /*CIR*/
            dpe.u.meter.meterEntry.pir = (int )atol(req->args[6]); /*PIR*/
            dpe.u.meter.meterEntry.cbs = (int )atol(req->args[7]); /*CBS*/
            dpe.u.meter.meterEntry.pbs = (int )atol(req->args[8]); /*PBS*/
            dpe.u.meter.meterEntry.ebs = (int )atol(req->args[9]); /*EBS*/
            dpe.u.meter.meterEntry.nextGreenDpe = (int )atol(req->args[10]); /*GreenDpe*/
            dpe.u.meter.meterEntry.nextYellowDpe = (int )atol(req->args[11]); /*YellowDpe*/
            dpe.u.meter.meterEntry.nextRedDpe = (int )atol(req->args[12]); /*RedDpe*/
            dpe.u.meter.statsRequired = (int )atol(req->args[13]); /*Statistics*/
            ret = NPF_DS_DpeModify(DS_COMMON_ARGS, no, &dpeHandle, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 106: /*DiffServModify_Marker */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            dpe.u.marker.type = (int )atol(req->args[4]); /*MarkerType*/
            dpe.u.marker.markerEntry.dscp.greenDscp = (int )atol(req->args[5]); /*GreenDSCP*/
            dpe.u.marker.markerEntry.dscp.yellowDscp = (int )atol(req->args[6]); /*YellowDSCP*/
            dpe.u.marker.markerEntry.dscp.redDscp = (int )atol(req->args[7]); /*RedDSCP*/
            dpe.u.marker.statsRequired = (int )atol(req->args[8]); /*Statistics*/
            ret = NPF_DS_DpeModify(DS_COMMON_ARGS, no, &dpeHandle, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 107: /*DiffServModify_Dropper */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            NPF_DS_Dpe_t dpe;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*NoOfDpe*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            dpe.u.dropper.type = (int )atol(req->args[4]); /*DropperType*/
            dpe.u.dropper.serviceRate = (int )atol(req->args[5]); /*Service_Rate*/
            dpe.u.dropper.weight = (int )atol(req->args[6]); /*Weight*/
            dpe.u.dropper.dropperEntry.green.minThreshold = (int )atol(req->args[7]); /*GreenMinThreshold*/
            dpe.u.dropper.dropperEntry.green.maxThreshold = (int )atol(req->args[8]); /*GreenMaxThreshold*/
            dpe.u.dropper.dropperEntry.green.maxProbability = (int )atol(req->args[9]); /*GreenMaxProbability*/
            dpe.u.dropper.dropperEntry.yellow.minThreshold = (int )atol(req->args[10]); /*YellowMinThreshold*/
            dpe.u.dropper.dropperEntry.yellow.maxThreshold = (int )atol(req->args[11]); /*YellowMaxThreshold*/
            dpe.u.dropper.dropperEntry.yellow.maxProbability = (int )atol(req->args[12]); /*YellowMaxProbability*/
            dpe.u.dropper.dropperEntry.red.minThreshold = (int )atol(req->args[13]); /*RedMinThreshold*/
            dpe.u.dropper.dropperEntry.red.maxThreshold = (int )atol(req->args[14]); /*RedMaxThreshold*/
            dpe.u.dropper.dropperEntry.red.maxProbability = (int )atol(req->args[15]); /*RedMaxProbability*/
            dpe.u.dropper.statsRequired = (int )atol(req->args[16]); /*Statistics*/
            ret = NPF_DS_DpeModify(DS_COMMON_ARGS, no, &dpeHandle, &dpe);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 108: /*DiffServDpe_Add_Associate */
        {
            NPF_uint32_t no;
            NPF_DS_DpeSetHandle_t dpeSetHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*no*/
            dpeSetHandle.dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            dpeSetHandle.prevDpeHandle = (int )getHandle(req->args[4]); /*PrevDpeHandle*/
            ret = NPF_DS_DpeAddAssociation(DS_COMMON_ARGS, no, &dpeSetHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 109: /*DiffServDpe_Query */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*no*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            ret = NPF_DS_DpeQueryAttributes(DS_COMMON_ARGS, no, &dpeHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 110: /*DiffServDpe_Statistics */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*no*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            ret = NPF_DS_DpeQueryStats(DS_COMMON_ARGS, no, &dpeHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 111: /*DiffServDpe_Delete_Associate */
        {
            NPF_uint32_t no;
            NPF_DS_DpeSetHandle_t dpeSetHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*no*/
            dpeSetHandle.dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            dpeSetHandle.prevDpeHandle = (int )getHandle(req->args[4]); /*PrevDpeHandle*/
            ret = NPF_DS_DpeDelAssociation(DS_COMMON_ARGS, no, &dpeSetHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 112: /*DiffServDpe_Delete */
        {
            NPF_uint32_t no;
            NPF_DS_DpeHandle_t dpeHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            dpeHandle = (int )getHandle(req->args[3]); /*DpeHandle*/
            ret = NPF_DS_DpeDelete(DS_COMMON_ARGS, no, &dpeHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 114: /*DiffServReset_Dpe_Handles */
        {
            
            NPF_error_t ret = 1;
            
            
            ret = Reset_DS_Handles();
            
            
            req->error = 0;
            sprintf(req->resp, "DiffServReset_Dpe_Handles");
            getTime(&req->respts);
            sendResponse(req);
            
        }
        break;
    }
}
void cppui_diffserv_response(CppuiRequest *req, void *data)
{
    switch(req->type)
    {
        case 100: /*DiffServCreate_Classifier */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(100, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 101: /*DiffServCreate_Meter */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(101, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 102: /*DiffServCreate_Marker */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(102, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 103: /*DiffServCreate_Dropper */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(103, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 113: /*DiffServAdd_DSCP_Filter */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(113, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 104: /*DiffServModify_Classifier */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(104, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 105: /*DiffServModify_Meter */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(105, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 106: /*DiffServModify_Marker */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(106, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 107: /*DiffServModify_Dropper */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(107, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 108: /*DiffServDpe_Add_Associate */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(108, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 109: /*DiffServDpe_Query */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(109, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 110: /*DiffServDpe_Statistics */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(110, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 111: /*DiffServDpe_Delete_Associate */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(111, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 112: /*DiffServDpe_Delete */
        {
            NPF_DS_CallbackData_t *cbdata = (NPF_DS_CallbackData_t*)data;
            req->error = FormatDpeResponse(112, cbdata, req->resp);
            sendResponse(req);
        }
        break;
    } /*switch(req->type) */
}
