/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

         
        #include "cppui_common.h"
         
        
        void process(CppuiRequest *req)
        {
            
            req->seq = (int)atol(req->args[0]);
            req->type = atol(req->args[1]);
            getTime(&req->reqts);
            switch(req->type)
            {
                case  CPPDK_CONNECT_REQ : /* CPPUI_CONNECT */
                {
                    onCppuiConnect(req);
                }
                break;
                case  CPPDK_DISCONNECT_REQ : /* CPPUI_DISCONNECT */
                {
                    onCppuiDisconnect(req);
                }
                break;
                
                case 1:
                case 2:
                {
                    cppui_namespace_message(req);
                }
                break;
                
                
                case 200:
                case 201:
                case 202:
                case 203:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 215:
                case 209:
                case 210:
                case 211:
                case 212:
                case 213:
                case 214:
                {
                    cppui_interface_message(req);
                }
                break;
                
                
                case 250:
                case 251:
                case 252:
                case 253:
                case 254:
                case 255:
                case 256:
                case 257:
                case 258:
                case 259:
                case 260:
                case 261:
                case 262:
                case 263:
                {
                    cppui_lan_message(req);
                }
                break;
                
                
                case 158:
                case 159:
                case 160:
                case 161:
                case 162:
                case 163:
                case 164:
                case 165:
                case 166:
                case 167:
                case 168:
                case 169:
                case 170:
                case 171:
                case 172:
                case 173:
                case 174:
                case 175:
                case 176:
                case 177:
                case 178:
                case 198:
                {
                    cppui_ipv4_message(req);
                }
                break;
                
                
                case 180:
                case 181:
                case 182:
                case 183:
                case 184:
                case 185:
                {
                    cppui_ipv4_unified_message(req);
                }
                break;
                
                
                #ifdef DIFFSERV
                case 100:
                case 101:
                case 102:
                case 103:
                case 113:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 114:
                {
                    cppui_diffserv_message(req);
                }
                break;
                #endif
                
                
                #ifdef MPLS
                case 400:
                case 401:
                case 402:
                case 403:
                case 404:
                case 405:
                case 406:
                case 407:
                case 408:
                case 412:
                case 413:
                case 414:
                case 415:
                case 416:
                case 417:
                case 418:
                case 419:
                {
                    cppui_mpls_message(req);
                }
                break;
                #endif
                
                
                #ifdef ATM
                case 503:
                case 510:
                case 511:
                case 512:
                case 513:
                case 514:
                case 515:
                case 516:
                case 517:
                {
                    cppui_atm_message(req);
                }
                break;
                #endif
                
                
                #ifdef RCM
                case 199:
                {
                    cppui_rcm_message(req);
                }
                break;
                #endif
                
                default:
                {
                    req->error = 1;
                    sprintf(req->resp, "Unknown Message(%d) \n", req->type);
                    sendResponse(req);
                }
                break;
            }/*switch(type)*/
        }/* process */
