/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

         
        #include "cppui_common.h"
         
        int formatIfResponse(int cmd, NPF_IfCallbackData_t *data, char *resp)
        {
        
        int pos = 0;
 	if(data == NULL || data->resp == NULL) 
	{
	    pos += sprintf(&resp[pos], "NULL RESPONSE .......?");
	    return(1);
	}
	switch(data->resp->error)
	{
	    default: 
		pos += sprintf(&resp[pos], "UNKNOWN ERROR"); break;
	    case NPF_IF_E_INVALID_PARAM: 
		pos += sprintf(&resp[pos], "INVALID PARAMETER"); break;
	    case NPF_IF_E_INVALID_CHILD_HANDLE: 
		pos += sprintf(&resp[pos], "INVALID CHILD HANDLE"); break;
	    case NPF_IF_E_INVALID_PARENT_HANDLE: 
		pos += sprintf(&resp[pos], "INVALID PARENT HANDLE"); break;
	    case NPF_IF_E_INVALID_HANDLE: 
		pos += sprintf(&resp[pos], "INVALID HANDLE"); break;
	    case NPF_IF_E_NO_SUCH_VCC: 
		pos += sprintf(&resp[pos], "NO SUCH VCC"); break;
	    case NPF_IF_E_INVALID_IPADDR: 
		pos += sprintf(&resp[pos], "INVALID IP ADDRESS"); break;
	    case NPF_IF_E_INVALID_NETPLEN: 
		pos += sprintf(&resp[pos], "INVALID NETP LEN>H"); break;
	    case NPF_IF_E_INVALID_MTU: 
		pos += sprintf(&resp[pos], "INVALID MTU"); break;
	    case NPF_IF_E_INVALID_ATTRIBUTE: 
		pos += sprintf(&resp[pos], "INVALID ATTRIBUTE"); break;
	    case NPF_IF_E_NOT_CREATED: 
		pos += sprintf(&resp[pos], "INTERFACE NOT CREATED"); break;
	    case NPF_IF_E_INVALID_MAC_ADDR: 
		pos += sprintf(&resp[pos], "INVALID MAC ADDRESS"); break;
	    case NPF_IF_E_INVALID_FIB_HANDLE: 
		pos += sprintf(&resp[pos], "INVALID FIB HANDLE"); break;
	    case NPF_IF_E_INVALID_ATM_HANDLE: 
		pos += sprintf(&resp[pos], "INVALID ATM HANDLE"); break;
	    case NPF_IF_E_INVALID_L3_HANDLE: 
		pos += sprintf(&resp[pos], "INVALID L3 HANDLE"); break;
	    //case NPF_IF_E_BAD_ARRAY_LEN>H: 
		pos += sprintf(&resp[pos], "BAD ARRAY LEN>H"); break;
	    case NPF_IF_E_NO_SRC_ADDRESS: 
		pos += sprintf(&resp[pos], "NO SOURCE ADDRESS"); break;
	    case NPF_IF_E_INVALID_SPEED: 
		pos += sprintf(&resp[pos], "INVALID SPEED"); break;
	    case NPF_IF_E_INVALID_VCC_ADDRESS: 
		pos += sprintf(&resp[pos], "INVALID VCC ADDRESS"); break;
	    case NPF_IF_E_INVALID_IF_TYPE: 
		pos += sprintf(&resp[pos], "INVALID INTERFACE TYPE"); break;
	    case NPF_IF_E_INVALID_ADMIN_STATUS: 
		pos += sprintf(&resp[pos], "INVALID ADMIN STATUS"); break;
	    case NPF_IF_E_INVALID_PORT_NUMBER: 
		pos += sprintf(&resp[pos], "INVALID PORT NUMBER"); break;
	    case NPF_IF_E_INVALID_PROMISC_MODE: 
		pos += sprintf(&resp[pos], "INVALID PROMISCOUS MODE"); break;
	    case NPF_IF_E_INVALID_LAN_SPEED: 
		pos += sprintf(&resp[pos], "INVALID LAN SPEED"); break;
	    case NPF_IF_E_INVALID_ATM_AAL: 
		pos += sprintf(&resp[pos], "INVALID ATM AAL"); break;
	    case NPF_IF_E_INVALID_ATM_QOS: 
		pos += sprintf(&resp[pos], "INVALID ATM QOS"); break;
	    case NPF_IF_E_INVALID_ICMP_RATELIMITTYPE: 
		pos += sprintf(&resp[pos], "INVALID ICMP RATE LIMIT TYPE"); break;
	    case NPF_IF_E_INVALID_ICMP_RATELIMITVALUE: 
		pos += sprintf(&resp[pos], "INVALID ICMP RATE LIMIT TYPE"); break;
	    case NPF_IF_E_INVALID_SCOPEVALUE: 
		pos += sprintf(&resp[pos], "INVALID SCOPE VALUE"); break;
	    case NPF_IF_E_INVALID_TTL: 
		pos += sprintf(&resp[pos], "INVALID TTL"); break;
	    case NPF_IF_E_INVALID_DSCP: 
		pos += sprintf(&resp[pos], "INVALID DSCP"); break;
	    case NPF_NO_ERROR: 
	    {
		switch(data->type)
		{
    		    case NPF_IF_CREATE:
    		    case NPF_IF_CREATE_AND_SET:
		    {
			switch(cmd)
			{
			    case 200:
	    		        pos += sprintf(&resp[pos], "LAN Interface Handle(%d)", data->resp->ifHandle);
				storeHandle(CPPUI_LAN_INTERFACE_HANDLE, data->resp->ifHandle);
				break;
			    case 201:
	    		        pos += sprintf(&resp[pos], "POS Interface Handle(%d)", data->resp->ifHandle);
				storeHandle(CPPUI_POS_INTERFACE_HANDLE, data->resp->ifHandle);
				break;
			    case 202:
	    		        pos += sprintf(&resp[pos], "ATM Interface Handle(%d)", data->resp->ifHandle);
				storeHandle(CPPUI_ATM_INTERFACE_HANDLE, data->resp->ifHandle);
				break;
			    case 203:
	    		        pos += sprintf(&resp[pos], "IPV4 Interface Handle(%d)", data->resp->ifHandle);
				storeHandle(CPPUI_IPV4_INTERFACE_HANDLE, data->resp->ifHandle);
				break;
			    case 208:
	    		        pos += sprintf(&resp[pos], "MPLS Interface Handle(%d)", data->resp->ifHandle);
				storeHandle(CPPUI_MPLS_INTERFACE_HANDLE, data->resp->ifHandle);
				break;
			    default:
	    		    pos += sprintf(&resp[pos], "\nUNABLE TO STORE ITNERFACE HANDLE(%d)", data->resp->ifHandle);
			    return(1);
			}
			
		    } break;
    		    case NPF_IF_DELETE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_BIND:
		    {
	    		pos += sprintf(&resp[pos], "PARENT IF HANDLE: %d", (int)data->resp->ifHandle);
	    		pos += sprintf(&resp[pos], "\nCHILD IF HANDLE: %d", (int)data->resp->u.child);
		    } break;
    		    case NPF_IF_STATS_GET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_VCC_STATS_GET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATTR_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ENABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_DISABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_OPER_STATUS_GET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_SRC_ADDR_GET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_SRC_ADDR_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_ADDR_LIST_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_ADDR_LIST_ADD:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_PROMISC_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_PROMISC_CLEAR:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_FULL_DUPLEX_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_FULL_DUPLEX_CLEAR:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_SPEED_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_FLOW_CONTROL_TX_ENABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_FLOW_CONTROL_TX_DISABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_FLOW_CONTROL_RX_ENABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_LAN_FLOW_CONTROL_RX_DISABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV4ADDR_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV4MTU_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV4FIB_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_BIND:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_DELETE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_ENABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_DISABLE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_OPER_STATUS_GET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_VCC_STATS_GET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_AAL2_CHANNEL_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_AAL2_CHANNEL_DEL:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_CONNECTION_XC_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_CONNECTION_XC_DEL:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_CP_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_CC_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_LB_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_MONITOR:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_ALARM_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_ALARM_CLEAR:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ATM_OAM_PM_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;

    		    case NPF_IF_IPV6_ADDR_ADD:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6_ADDR_DELETE:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6_UCZONE_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6_MTU_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6_FIB_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6INV4_DSTADDR_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6INV4_SRCADDR_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6INV4_TTL_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_IPV6INV4_DSCP_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
    		    case NPF_IF_ICMPV6_RATE_SET:
		    {
	    		pos += sprintf(&resp[pos], "IF HANDLE: %d", (int)data->resp->ifHandle);
		    } break;
		    default:
		    {
	    		pos += sprintf(&resp[pos], "INVALID INTERFACE OPERATION");
		    }
		}
	    }
	}
        return(data->resp->error);
    
        }
        int getInterfaceAttributes(char *input, int cmd, NPF_IfGeneric_t *interface)
        {
        
    
        }
void cppui_interface_message(CppuiRequest *req)
{
    switch(req->type)
    {
        case 200: /*InterfaceCreate_LAN_And_Set_Attribute */
        {
            NPF_uint32_t no;
            NPF_IfGeneric_t genIf;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            genIf.type = (int )atol(req->args[3]); /*Type*/
            genIf.u.LAN_Attr.port = (int )atol(req->args[4]); /*Port*/
            genIf.u.LAN_Attr.speed = (int )atol(req->args[5]); /*Speed*/
            genIf.u.LAN_Attr.promisc = (int )atol(req->args[6]); /*Promisc*/
            ret = NPF_IfCreateAndSet(IF_COMMON_ARGS, no, &genIf);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 201: /*InterfaceCreate_POS_And_Set_Attribute */
        {
            NPF_uint32_t no;
            NPF_IfGeneric_t genIf;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            genIf.type = (int )atol(req->args[3]); /*Type*/
            genIf.u.POS_Attr.port = (int )atol(req->args[4]); /*Port*/
            ret = NPF_IfCreateAndSet(IF_COMMON_ARGS, no, &genIf);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 202: /*InterfaceCreate_ATM_And_Set_Attribute */
        {
            NPF_uint32_t no;
            NPF_IfGeneric_t genIf;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*Nos*/
            genIf.type = (int )atol(req->args[3]); /*IfType*/
            genIf.speed = (int )atol(req->args[4]); /*PortSpeed*/
            genIf.u.ATM_Attr.port = (int )atol(req->args[5]); /*PortNos*/
            genIf.u.ATM_Attr.atmAddress.addrCh = (int )atol(req->args[6]); /*atmAddressType*/
            genIf.u.ATM_Attr.maxVpiBits = (int )atol(req->args[7]); /*maxVpiBits*/
            genIf.u.ATM_Attr.maxVciBits = (int )atol(req->args[8]); /*maxVciBits*/
            genIf.u.ATM_Attr.atmInf = (int )atol(req->args[9]); /*ATMIfType*/
            genIf.u.ATM_Attr.infType = (int )atol(req->args[10]); /*ATM_IfType*/
            genIf.u.ATM_Attr.devType = (int )atol(req->args[11]); /*DeviceType*/
            ret = NPF_IfCreateAndSet(IF_COMMON_ARGS, no, &genIf);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 203: /*InterfaceCreate_IPV4 */
        {
            NPF_uint32_t no;
            NPF_IfType_t IfType;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            IfType = (int )atol(req->args[3]); /*Type*/
            ret = NPF_IfCreate(IF_COMMON_ARGS, no, IfType);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 204: /*InterfaceIPV4_Set_Attributes */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_IfGeneric_t genIf;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            genIf.type = (int )atol(req->args[3]); /*Type*/
            ifHandle = (int )getHandle(req->args[4]); /*Ifhandle*/
            getipv4address(req->args[5], &genIf.u.IPv4_Attr.addr.IPv4Addr); /*Address*/
            genIf.u.IPv4_Attr.addr.IPv4NetPlen = (int )atol(req->args[6]); /*NetPlen*/
            genIf.u.IPv4_Attr.mtu = (int )atol(req->args[7]); /*MTU*/
            genIf.u.IPv4_Attr.FIB_Handle = (int )atol(req->args[8]); /*FIBhandle*/
            ret = NPF_IfAttrSet(IF_COMMON_ARGS, no, &ifHandle, &genIf);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 205: /*InterfaceIPV4_Interface_Set_Address */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_IPv4NetAddr_t v4Addr;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            getipv4address(req->args[4], &v4Addr.IPv4Addr); /*Address*/
            v4Addr.IPv4NetPlen = (int )atol(req->args[5]); /*NetPlen*/
            ret = NPF_IfIPv4AddrSet(IF_COMMON_ARGS, no, &ifHandle, &v4Addr);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 206: /*InterfaceIPV4_Interface_Set_MTU */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_uint16_t mtu;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            mtu = (int )atol(req->args[4]); /*MTU*/
            ret = NPF_IfIPv4MTUSet(IF_COMMON_ARGS, no, &ifHandle, &mtu);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 207: /*InterfaceIPV4_Interface_Set_FIB */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_IPv4UC_FwdTableHandle_t fwdTableHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            fwdTableHandle = (int )getHandle(req->args[4]); /*FIBhandle*/
            ret = NPF_IfIPv4FIBSet(IF_COMMON_ARGS, no, &ifHandle, fwdTableHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 208: /*InterfaceCreate_MPLS_Interface */
        {
            NPF_uint32_t no;
            NPF_IfType_t IfType;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            IfType = (int )atol(req->args[3]); /*Type*/
            ret = NPF_IfCreate(IF_COMMON_ARGS, no, IfType);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 215: /*InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_IfGeneric_t genIf;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*numEntries*/
            genIf.type = (int )atol(req->args[3]); /*Interface_Type*/
            ifHandle = (int )getHandle(req->args[4]); /*MPLSIfHandle*/
            genIf.u.MPLS_Attr.mtuSize = (int )atol(req->args[5]); /*MPLS_LblPkt_ize*/
            ret = NPF_IfAttrSet(IF_COMMON_ARGS, no, &ifHandle, &genIf);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 209: /*InterfaceBind */
        {
            NPF_uint32_t no;
            NPF_IfBinding_t if_bindArray;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            if_bindArray.parent = (int )getHandle(req->args[3]); /*ParentIfHandle*/
            if_bindArray.child = (int )getHandle(req->args[4]); /*ChildIfHandle*/
            ret = NPF_IfBind(IF_COMMON_ARGS, no, &if_bindArray);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 210: /*InterfaceEnable */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfEnable(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 211: /*InterfaceStatus */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfOperStatusGet(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 212: /*InterfaceStatistics */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*Nos*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfGenericStatsGet(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 213: /*InterfaceDisable */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfDisable(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 214: /*InterfaceDelete */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfDelete(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
    }
}
void cppui_lan_message(CppuiRequest *req)
{
    switch(req->type)
    {
        case 250: /*LANSet_Attributes */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_IfGeneric_t genIf;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            genIf.type = (int )atol(req->args[4]); /*Type*/
            genIf.u.LAN_Attr.port = (int )atol(req->args[5]); /*Port*/
            genIf.u.LAN_Attr.speed = (int )atol(req->args[6]); /*Speed*/
            genIf.u.LAN_Attr.promisc = (int )atol(req->args[7]); /*Promisc*/
            ret = IfAttrSet(IF_COMMON_ARGS, no, &ifHandle, &genIf);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 251: /*LANSet_Speed */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_IfLAN_Speed_t speed;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            speed = (int )atol(req->args[4]); /*Speed*/
            ret = NPF_IfLAN_SpeedSet(IF_COMMON_ARGS, no, &ifHandle, &speed);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 252: /*LANSet_Promisc */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_PromiscSet(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 253: /*LANClear_Promisc */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_PromiscSet(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 254: /*LANGet_Source_Address */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_SrcAddrGet(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 255: /*LANSet_Source_Address */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_MAC_Address_t MACaddr;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            getmacaddress(req->args[4], MACaddr); /*MACAddress*/
            ret = NPF_IfLAN_SrcAddrSet(IF_COMMON_ARGS, no, &ifHandle, &MACaddr);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 256: /*LANSet_Receive_Address_List */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_uint32_t addrNo;
            NPF_MAC_Address_t MACaddr;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            getmacaddress(req->args[4], MACaddr); /*MACAddress*/
            ret = NPF_IfLAN_MAC_RcvAddrListSet(IF_COMMON_ARGS, no, &ifHandle, addrNo, &MACaddr);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 257: /*LANAdd_Receive_Address_List */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            NPF_uint32_t addrNo;
            NPF_MAC_Address_t MACaddr;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            addrNo = (int )atol(req->args[4]); /*AddrNo*/
            getmacaddress(req->args[5], MACaddr); /*MACAddress*/
            ret = NPF_IfLAN_MAC_RcvAddrListAdd(IF_COMMON_ARGS, no, &ifHandle, addrNo, &MACaddr);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 258: /*LANSet_Full_Duplex */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_FullDuplexSet(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 259: /*LANClear_Full_Duplex */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_FullDuplexClear(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 260: /*LANTx_Flow_Control_Enable */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_FlowControlTxEnable(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 261: /*LANTx_Flow_Control_Disable */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_FlowControlTxDisable(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 262: /*LANRx_Flow_Control_Enable */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_FlowControlRxEnable(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
        case 263: /*LANRx_Flow_Control_Disable */
        {
            NPF_uint32_t no;
            NPF_IfHandle_t ifHandle;
            
            NPF_error_t ret = 1;
            
            
            no = (int )atol(req->args[2]); /*No*/
            ifHandle = (int )getHandle(req->args[3]); /*Ifhandle*/
            ret = NPF_IfLAN_FlowControlRxDisable(IF_COMMON_ARGS, no, &ifHandle);
            
            if(ret == NPF_NO_ERROR)
            {
                #ifdef CPPUI_WAIT_RESP
                waitAsyncResponse(req);
                #endif
            }
            else
            {
                req->error = ret;
                sprintf(req->resp, "%s", "Command Rejected");
                sendResponse(req);
            }
        }
        break;
    }
}
void cppui_interface_response(CppuiRequest *req, void *data)
{
    switch(req->type)
    {
        case 200: /*InterfaceCreate_LAN_And_Set_Attribute */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(200, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 201: /*InterfaceCreate_POS_And_Set_Attribute */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(201, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 202: /*InterfaceCreate_ATM_And_Set_Attribute */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(202, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 203: /*InterfaceCreate_IPV4 */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(203, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 204: /*InterfaceIPV4_Set_Attributes */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(204, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 205: /*InterfaceIPV4_Interface_Set_Address */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(205, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 206: /*InterfaceIPV4_Interface_Set_MTU */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(206, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 207: /*InterfaceIPV4_Interface_Set_FIB */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(207, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 208: /*InterfaceCreate_MPLS_Interface */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(208, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 215: /*InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(215, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 209: /*InterfaceBind */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(209, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 210: /*InterfaceEnable */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(210, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 211: /*InterfaceStatus */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(211, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 212: /*InterfaceStatistics */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(212, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 213: /*InterfaceDisable */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(213, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 214: /*InterfaceDelete */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(214, cbdata, req->resp);
            sendResponse(req);
        }
        break;
    } /*switch(req->type) */
}
void cppui_lan_response(CppuiRequest *req, void *data)
{
    switch(req->type)
    {
        case 250: /*LANSet_Attributes */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(250, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 251: /*LANSet_Speed */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(251, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 252: /*LANSet_Promisc */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(252, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 253: /*LANClear_Promisc */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(253, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 254: /*LANGet_Source_Address */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(254, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 255: /*LANSet_Source_Address */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(255, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 256: /*LANSet_Receive_Address_List */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(256, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 257: /*LANAdd_Receive_Address_List */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(257, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 258: /*LANSet_Full_Duplex */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(258, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 259: /*LANClear_Full_Duplex */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(259, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 260: /*LANTx_Flow_Control_Enable */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(260, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 261: /*LANTx_Flow_Control_Disable */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(261, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 262: /*LANRx_Flow_Control_Enable */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(262, cbdata, req->resp);
            sendResponse(req);
        }
        break;
        case 263: /*LANRx_Flow_Control_Disable */
        {
            NPF_IfCallbackData_t *cbdata = (NPF_IfCallbackData_t*)data;
            req->error = formatIfResponse(263, cbdata, req->resp);
            sendResponse(req);
        }
        break;
    } /*switch(req->type) */
}
