/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

         
        #include "cppui_common.h"
         
        int formatNsResponse(int cmd, NPF_error_t error, char *resp)
        {
        
	switch(error)
	{
	    case NPF_SUCCESS:
	    {
	        if(cmd == 1)
		{
	            sprintf(resp, "NAME SPACE CREATED"); 
		    return(0);
		}
	        else if(cmd == 2)
		{
	            sprintf(resp, "NAME SPACE ASSOCIATED"); 
		    return(0);
		}
	        else
		{
	            sprintf(resp, "UNKNOWN OPERATION"); 
		    return(1);
		}
	    }
	    case NPF_FAIL: sprintf(resp, "NAME SPACE CREATAION FAILED"); return 1;
	    case NPF_INVALID_PARAMETERS: sprintf(resp, "INVALID PARAMETERS"); return 1;
	    case NPF_OUT_OF_MEMORY: sprintf(resp, "OUT OF MEMORY"); return 1;
	    case NPF_COMPONENT_UNINITIALIZED: sprintf(resp, "COMPONENT UNINITIALIZED"); return 1;
	    //case NPF_NS_PATH_OVER_LEN>H: sprintf(resp, "PATH OVERLEN>H"); return 1;
	    case NPF_NS_NODE_IN_USE: sprintf(resp, "NODE IN USE"); return 1;
	    case NPF_NS_NODE_EXISTS: sprintf(resp, "NODE ALREADY EXISTS"); return 1;
	    case NPF_NS_NODE_NOTFOUND: sprintf(resp, "NODE NOT FOUND"); return 1;
	    default: sprintf(resp, "UNKNOWN ERROR"); return 1;
	}
    
        }
        NPF_RET npf_ns_associate(char *srcPath, char *tgtPath)
        {
        
       NPF_RET     ret;
       NPF_NSHDL   srcInst;
       NPF_NSHDL   tgtInst;
       if((ret = npf_ns_open(srcPath, &srcInst)) != NPF_SUCCESS) return ret;
       if((ret = npf_ns_open(tgtPath, &tgtInst)) != NPF_SUCCESS) return ret;
       return(npf_ns_addAssociate(srcInst, tgtInst));
    
        }
void cppui_namespace_message(CppuiRequest *req)
{
    switch(req->type)
    {
        case 1: /*NameSpaceCreate */
        {
            char * pathStr;
            NPF_NSNODETYPE nodeType;
            NPF_DATATYPE dataType;
            NPF_NSHDL hInstance;
            NPF_NSHDL hNode;
            
            NPF_error_t ret = 1;
            
            
            pathStr = (char* )(req->args[2]); /*Node_Path*/
            nodeType = (int )atol(req->args[3]); /*Node_Type*/
            dataType = (int )atol(req->args[4]); /*Node_Data_Type*/
            hInstance = (int )atol(req->args[5]); /*Node_Instance*/
            ret = npf_ns_create(pathStr, nodeType, dataType, hInstance, &hNode);
            
            
            req->error = formatNsResponse(1, ret, req->resp);
            getTime(&req->respts);
            sendResponse(req);
            
        }
        break;
        case 2: /*NameSpaceAssociate */
        {
            char * srcPath;
            char * tgtPath;
            
            NPF_error_t ret = 1;
            
            
            srcPath = (char* )(req->args[2]); /*Source_Path*/
            tgtPath = (char* )(req->args[3]); /*Target_Path*/
            ret = npf_ns_associate(srcPath, tgtPath);
            
            
            req->error = formatNsResponse(2, ret, req->resp);
            getTime(&req->respts);
            sendResponse(req);
            
        }
        break;
    }
}
void cppui_namespace_response(CppuiRequest *req, void *data)
{
    switch(req->type)
    {
    } /*switch(req->type) */
}
