#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

import os, time, string, sys
#from xml import *
from xml.dom import *
from xml.dom.ext.reader.Sax import FromXmlFile
from xml.dom import implementation
from xml.dom.ext import PrettyPrint
import os
import sys

class Module:
    #def __init__(self, name, ops, args, values):
    def __init__(self):
	self.file = None
	self.flag = None
	self.name = ''
	self.events = []
	self.ops = []
	self.ids = []
	self.globals = []
	self.header = []
	self.opts = {}
	self.args = {}
	self.values = {}
	self.enums = {}
	self.types = {}
	self.getf = {}
	self.vars = {}
	self.variables = {}
	self.assigns = {}
	self.internals = {}
	self.responses = {}
	self.st = {}

class Event:
    def __init__(self):
	self.id = ''
	self.name = ''
	self.prio = ''
	self.action = ''
	self.params = []

EVENTS = []
VARIABLES = {}
FUNCTIONS = []
INITS = []
INCLUDES = []
GLOBALS = []
DEFINES = []
ENUMS = {}
ID = {}
CID = {}
FLAGS = {}

MODULES = {}
MODES = {}

class Generator:
    def __init__(self, xmls):
        self.maxLineLength = 80
        self.indentLevel = 4
        self.indent = ""
        self.xmls = xmls
	self.file = None
	self.modules = []
	for xml in xmls:
	    xml = string.strip(xml)
	    if(xml[0:1] == '#'):
		continue
	    print '(Parse  :' + xml + ')'
	    self.parse(xml)
	self.start()
	print '\n\nDone !!!!!\n\n'

    def emit(self, line):
	try:
            self.file.write(self.indent + line + "\n" )
	except:
	    print 'ERROR: No output file opened for writing'
	    sys.exit(0)
            
    def emitLines(self, lines, secondLineIndent):
        indent = self.indent
        secondLine = no
        for line in lines:
	    try:
                self.file.write(self.indent + line + "\n" )
	    except:
	        print 'ERROR: No output file opened for writing'
	        sys.exit(0)
            if (secondLine == no):
                secondLine = yes
                indent = indent + secondLineIndent

    def incrIndent(self, levels=1):
        for level in range(levels):
            for space in range(self.indentLevel):
                self.indent = self.indent + " "
    
    def decrIndent(self, levels=1):
        for level in range(levels):
            self.indent = self.indent[:-self.indentLevel]

    def cFile(self, name):
	name = string.split(name, '.')[0]
	name = string.lower(name) + '.c'
	mode = 'w'
	if(MODES.has_key(name)):
	    mode = 'a'
	else:
	    MODES[name] = name
	if(self.file != None):
	    self.file.flush()
	    self.file.flush()
	    self.file.close()
	fl = '..' + os.sep + 'build' + os.sep + 'src' + os.sep + name
	fl = os.path.abspath(fl)
	#print '(File: ' + fl + ')'
	try:
            self.file = open(fl, mode)
	except:
	    fl = '..' + os.sep + 'build' + os.sep + 'src' + os.sep + name + '.new'
	    fl = os.path.abspath(fl)
	    print '\n*** WARNING: Writing to file "' + fl + '"\n'
            self.file = open(fl, mode)
	if(mode == 'w'):
	    self.emit(' ')
	    self.emit('#include "cppui_common.h"')
	    self.emit(' ')

    def hFile(self, name):
	name = string.split(name, '.')[0]
	name = string.lower(name) + '.h'
	mode = 'w'
	if(MODES.has_key(name)):
	    mode = 'a'
	else:
	    MODES[name] = name
	if(self.file != None):
	    self.file.flush()
	    self.file.flush()
	    self.file.close()
	fl = '..' + os.sep + 'build' + os.sep + 'inc' + os.sep + name
	fl = os.path.abspath(fl)
	#print '(File: ' + fl + ')'
	try:
            self.file = open(fl, mode)
	except:
	    fl = '..' + os.sep + 'build' + os.sep + 'inc' + os.sep + name + '.new'
	    fl = os.path.abspath(fl)
	    print '\n*** WARNING: Writing to file "' + fl + '"\n'
            self.file = open(fl, mode)

    def start(self):
	fl = '..' + os.sep  + 'ui' + os.sep + 'cppui.py'
	fl = os.path.abspath(fl)
	try:
            self.file = open(fl, 'w')
	except:
	    print '\nCan\'t open file "' + fl + '" for writing'
	    print 'Writing to file "' + fl + '.new"\n'
	    fl = fl + '.new'
	    fl = os.path.abspath(fl)
            self.file = open(fl, 'w')
	self.genConnectDialog()
	self.genGuiMain()
	self.decrIndent()
	self.decrIndent()
	self.genCommands()
	self.genSend()
	self.genLog()
	self.genEnableLog()
	self.genEnableTestMode()
	self.genDisableTestMode()
	self.genCppuiCommands()
	self.genDisableLog()
	self.genDisplayLog()
	self.genStatus()
	self.genRecv()
	self.genResponse()
	self.genDialogs()
	self.genEventDialogs()
	self.genMain()
	self.genServer()

    def genSend(self):
	self.incrIndent()
	self.emit('')
        #self.emit('def ' + 'Send' +  '(self, msg):')
        self.emit('def ' + 'Send' +  '(self, req):')
	self.incrIndent()
	self.emit('TEST = 0')
	self.emit('req.count(self.seq)')
  	self.emit('if(TEST == 1):')
	self.incrIndent()
	self.emit('self.connect = 1')
	self.emit('print req.name + "=>	" + req.command(self.selftest)')
	self.emit('resp = "TEST PASSED#" + str(req.type()) + ";" + str(req.seq())')
	self.emit('resp = resp + ";" + str(req.geterror()) + "#TIME STAMP"')
	self.emit('self.seq = self.seq + 1')
	self.emit('req.save()')
	self.emit('self.Response(resp)')
	self.emit('if(self.seq%2 == 0):')
	self.incrIndent()
	self.emit('resp = \'-#\'')
	self.emit('resp = resp + str(CPPDK_EVENT) + \';\' + str(CPPUI_EVENT_PORT_LINK_UP) + \';\'')
	self.emit('resp = resp + str(EVENT_PRIORITY_NORMAL) + \';\' + \'PORT_LINK_UP\' + \';\'')
	self.emit('resp = resp + str(0) + \';\' + str(0)')
	self.emit('resp = resp + \'#-\'')
	self.emit('self.Response(resp)')
	self.decrIndent()
	self.emit('return')
	self.decrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('if(self.cc > 3):')
	self.incrIndent()
        self.emit('if(self.gui):')
        self.incrIndent()
        self.emit('abort = tkMessageBox.askyesno("Send Abort", "Stop Sending?")')
        self.decrIndent()
        self.emit('else:')
        self.incrIndent()
        self.emit('abort = askyesno("Stop........... ?")')
        self.decrIndent()
        self.emit('if(abort == 1):')
	self.incrIndent()
        self.emit('self.abort = 1')
        self.emit('return')
	self.decrIndent()
        self.emit('else:')
	self.incrIndent()
        self.emit('self.cc = 0')
	self.decrIndent()
	self.decrIndent()
	self.emit('if(self.waitMode):')
	self.incrIndent()
	self.emit('if(self.gui):')
	self.incrIndent()
        self.emit('send = tkMessageBox.askyesno(req.hdr(), req.getdescr())')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('send = askyesno(\'Send:  \' + req.getdescr())')
	self.decrIndent()
        self.emit('if(not send):')
	self.incrIndent()
        self.emit('self.cc = self.cc + 1')
        self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('req.save()')
        self.emit('if(not self.gui and not self.waitMode):')
        self.incrIndent()
        self.emit('print req.getdescr()')
        self.decrIndent()
	self.emit('if(not self.waitMode and self.waitTime > 0):')
	self.incrIndent()
	self.emit('time.sleep(self.waitTime)')
        self.decrIndent()
	self.emit('self.sock.sendto(req.command(self.selftest), (self.host, self.port))')
	self.emit('self.seq = self.seq + 1')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('sendError = \'Verify Connection to CPPDK server and Try Again\'')
        self.emit('if(self.gui):')
        self.incrIndent()
	self.emit('tkMessageBox.showerror("Send Error ", sendError)')
	self.emit('pass')
	self.decrIndent()
        self.emit('else:')
        self.incrIndent()
	self.emit('showerror("Send Error ", sendError)')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
        self.emit('')
	self.decrIndent()

    def genDisplayLog(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'DisplayLog' +  '(self):')
	self.incrIndent()
	"""
	self.emit('if(not self.log):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Show Log ", "No log file enabled\\n Enable Log file and Try again")')
	self.emit('return')
	self.decrIndent()
	"""
	self.emit('LogDialog(self.root, self)')
	self.decrIndent()
	self.decrIndent()

    def genDisableLog(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'DisableLog' +  '(self, ask = 1):')
	self.incrIndent()
        self.emit('try:')
	self.incrIndent()
        self.emit('if(ask == 1):')
	self.incrIndent()
        self.emit('disable = tkMessageBox.askyesno("Disable Log", "Are you Sure?")')
        self.emit('if(disable != 1):')
	self.incrIndent()
        self.emit('return')
	self.decrIndent()
	self.decrIndent()
        self.emit('if(self.log ==1 and self.logf != None):')
	self.incrIndent()
        self.emit('self.logf.flush()')
        self.emit('self.logf.flush()')
        self.emit('self.logf.close()')
        self.emit('self.log = 0')
        self.emit('self.enableLog.flash()')
        self.emit('self.enableLog.flash()')
	self.emit('self.enableLog.config(bg="lightblue", fg="blue")')
	self.decrIndent()
	self.decrIndent()
        self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Log Error ", "Error Occured while closing log file")')
	self.emit('pass')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

    def genEnableTestMode(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'TestMode' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('if(self.waitMode):')
	self.incrIndent()
	self.emit('self.DisableTestMode()')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('self.EnableTestMode()')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
	self.incrIndent()
	self.emit('')

        self.emit('def ' + 'EnableTestMode' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('ans = tkMessageBox.askyesno("Enable Wait Mode", "Enable Wait Mode, Are you Sure?")')
	self.emit('if(ans == 1):')
	self.incrIndent()
	self.emit('self.waitMode = 1')
	self.emit('self.tm.flash()')
	self.emit('self.tm.flash()')
	self.emit('self.tm.config(bg="cyan", fg="red")')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

    def genDisableTestMode(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'DisableTestMode' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('ans = tkMessageBox.askyesno("Disable Wait Mode", "Disable Wait Mode, Are you Sure?")')
	self.emit('if(ans == 1):')
	self.incrIndent()
	self.emit('self.waitMode = 0')
	self.emit('self.tm.flash()')
	self.emit('self.tm.flash()')
	self.emit('self.tm.config(bg="lightblue", fg="blue")')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

    def genCppuiCommands(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'EnableSelfTest' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
        self.emit('self.selftest = 1')
        self.emit('self.rb.config(bg = "black")')
	self.decrIndent()
	self.emit('')

        self.emit('def ' + 'DisableSelfTest' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
        self.emit('self.selftest = 0')
        self.emit('self.rb.config(bg = "light gray")')
	self.decrIndent()
	self.emit('')

        self.emit('def ' + 'SetWaitTime' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
        self.emit('try:')
	self.incrIndent()
        self.emit('wt = tkSimpleDialog.askstring(title="Delay in seconds", prompt="Time:",'\
					+ ' initialvalue=1)')
        self.emit('if(not wt):')
	self.incrIndent()
        self.emit('return')
	self.decrIndent()
        self.emit('self.waitTime = int(wt)')
	self.decrIndent()
        self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Time", "Invalid Value")')
	self.decrIndent()
        self.emit('if(self.waitTime > 10):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Time", "Too big, use < 10")')
        self.emit('self.waitTime = 0')
	self.decrIndent()
        self.emit('if(self.waitTime > 0):')
	self.incrIndent()
        self.emit('self.loadFile.config(bg="red")')
	self.decrIndent()
        self.emit('else:')
	self.incrIndent()
        self.emit('self.loadFile.config(bg="lightblue")')
	self.decrIndent()
	self.decrIndent()
	self.emit('')

        self.emit('def ' + 'SetRepeatCount' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
        self.emit('try:')
	self.incrIndent()
        self.emit('rc = tkSimpleDialog.askstring(title="Command Repeat Count", prompt="Count:",'\
					+ ' initialvalue=1)')
        self.emit('if(not rc):')
	self.incrIndent()
        self.emit('return')
	self.decrIndent()
        self.emit('self.repeatCount = int(rc)')
	self.decrIndent()
        self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Command Repeat Count", "Invalid Value")')
	self.decrIndent()

	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

    def genEnableLog(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'EnableLog' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('types = []')
	self.emit('types.append((\'log\', \'*.log\'))')
	self.emit('types.append((\'all\', \'*.*\'))')
	self.emit('logf = tkFileDialog.asksaveasfilename(initialdir=self.LOG_DIR, '\
				+ 'defaultextension="log", filetypes=types, initialfile="cppui.log")')
	self.emit('if(not len(logf)):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
        self.emit('self.lf = logf')
        self.emit('self.logf = open(logf, \'w\')')
        self.emit('self.log = 1')
        self.emit('self.enableLog.flash()')
        self.emit('self.enableLog.flash()')
        self.emit('self.enableLog.config(bg="cyan", fg="red")')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

    def genLog(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'LogFile' +  '(self):')
	self.incrIndent()
	self.emit('if(self.log == 1):')
	self.incrIndent()
	self.emit('self.DisableLog()')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('self.EnableLog()')
	self.decrIndent()
	self.decrIndent()

	self.emit('')
        self.emit('def ' + 'Log' +  '(self, text):')
	self.incrIndent()
	self.emit('if(self.log == 0 or self.logf == None):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('self.logf.write(text + \'\\n\\n\')')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('print \'ERROR: Error occured in writing log file\'')
	self.emit('pass')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

    def genStatus(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'Status' +  '(self):')
	self.incrIndent()
	self.emit('while(1):')
	self.incrIndent()
	self.emit('if(self.connect == 0):')
	self.incrIndent()
	self.emit('self.sb.config(text="Connect   ")')
	self.emit('time.sleep(10)')
	self.emit('continue')
	self.decrIndent()
	self.emit('time.sleep(1)')
	self.emit('#self.sb.config(bg="white")')
	self.emit('time.sleep(1)')
	self.emit('#self.sb.config(bg="blue")')
	self.emit('time.sleep(1)')
	self.decrIndent()
	self.decrIndent()
        self.emit('')
	self.decrIndent()

    def genRecv(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'Recv' +  '(self):')
	self.incrIndent()
	self.emit('while(1):')
	self.incrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('data, ADDR = self.sock.recvfrom(1024)')
	self.emit('self.recvs = self.recvs + 1')
	#self.emit('print \'Response = \' +  data')
	self.emit('self.Response(data)')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	#self.emit('print "Receive Exception "')
	self.emit('pass')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
        self.emit('')
	self.decrIndent()

    def genResponse(self):
	self.incrIndent()
	self.emit('')
        self.emit('def ' + 'Response' +  '(self, data):')
	self.incrIndent()
	self.emit('#print data')
	self.emit('resp = string.split(data, \'#\')')
	self.emit('if(len(resp) < 3):')
	self.incrIndent()
	self.emit('self.UpdateResponseButton(\'CPPDK CONNECT\', \'INVALID RESPONSE\', 1)')
	self.emit('return')
	self.decrIndent()
	self.emit('output = resp[0]')
	self.emit('input = resp[1]')
	self.emit('delay = resp[2]')
	self.emit('seq_cmd_error = string.split(resp[1], \';\')')
	self.emit('if(len(seq_cmd_error) < 3):')
	self.incrIndent()
	self.emit('self.UpdateResponseButton(\'CPPDK CONNECT\', \'INVALID RESPONSE\', 1)')
	self.emit('return')
	self.decrIndent()
        self.emit('type = seq_cmd_error[0]')
        self.emit('if(type == str(CPPDK_EVENT)):')
	self.incrIndent()
	self.emit('self.ProcessEvent(resp)')
	self.emit('return')
	self.decrIndent()
        self.emit('seq = seq_cmd_error[1]')
        self.emit('error = seq_cmd_error[2]')


        self.emit('if(not CppuiReqResp.has_key(str(seq))):')
	self.incrIndent()
        self.emit('print \'UNKNOWN RESPONSE(\' + seq + \')\'')
        self.emit('return')
	self.decrIndent()

        self.emit('response = CppuiReqResp[str(seq)]')
        self.emit('response.error(error)')
        self.emit('response.output(output)')
	self.emit('self.UpdateResponseButton(response)')
	self.emit('return')
	self.decrIndent()
	self.decrIndent()

    def genEventDialogs(self):
	print 'Generating Event Dialogs ..................'
	for mod in self.modules:
	    self.emit('')
	    for event in mod.events:
		ek = mod.name + event.name
		self.emit('class ' + mod.name + event.name + 'EventDialog(Dialog):')
		self.incrIndent()
        	self.emit('def __init__(self, parent, cppdk):')
		self.incrIndent()

        	self.emit('self.cppdk = cppdk')
        	self.emit('Dialog.__init__(self, parent, 1, title="(' + str(event.id) + ')' + event.name + ' Event Action")')
	        self.decrIndent()

		self.emit('')
        	self.emit('def body(self, master):')
		self.incrIndent()
        	self.emit('row = 0')

		multClmns = 0
		clmn = 14
		if(len(event.vars) > 25):
		    multClmns = 1
		for var in event.vars:
		    key = mod.name + event.name + var
		    val = mod.values[key]
        	    self.emit('Label(master,text="' + var +':").grid(row=row, column=' + str(clmn) + ')')
        	    self.emit('self.' + var + 'Entry  = Entry(master, width=15, relief=SUNKEN)')
        	    self.emit('self.' + var + 'Entry.grid(row=row, column=' + str(clmn + 8) + ')')
        	    self.emit('self.' + var + 'Entry.insert(0, "' + val + '")')
		    if(not multClmns):
        	        self.emit('row = row + 1')
		    else:
		        if(clmn >= 3*14):
        	            self.emit('row = row + 1')
		            clmn = 14
		        else:
		            clmn = clmn + 14
		actionVar = mod.name + event.name + 'Action'
        	self.emit('Label(master,text="Action:").grid(row=row, column=' + str(clmn) + ')')
        	self.emit('self.' + actionVar + 'Entry  = Entry(master, width=15, relief=SUNKEN)')
        	self.emit('self.' + actionVar + 'Entry.grid(row=row, column=' + str(clmn + 8) + ')')
        	self.emit('self.' + actionVar + 'Entry.insert(0, "' + event.action + '")')
        	self.emit('return ')
		self.decrIndent()
		self.emit('')

        	self.emit('def ok(self):')
		self.incrIndent()
        	self.emit('if not self.validate():')
		self.incrIndent()
        	self.emit('self.initial_focus.focus_set() # put focus back')
        	self.emit('return')
		self.decrIndent()
        	self.emit('self.withdraw()')
        	self.emit('self.update_idletasks()')
        	self.emit('self.apply()')
        	self.emit('self.cancel()')
		self.decrIndent()

        	self.emit('def end(self):')
		self.incrIndent()
        	self.emit('pass')
		self.decrIndent()
		self.emit('')

        	self.emit('def apply(self):')
		self.incrIndent()
		self.emit('try:')
		self.incrIndent()
		cmd = ID[ek] #Command ID
		self.emit('cmd = "' + cmd + '"')
		self.emit('order = []')
		for var in event.vars:
		    key = mod.name + event.name + var
		    input = string.lower(var)
		    self.emit(input + ' = self.' + var + 'Entry.get()') 
		    self.emit('cmd = cmd + ";" + ' + input)
		self.emit(actionVar + ' = self.' + actionVar + 'Entry.get()') 
		self.emit('if(not self.cppdk.printFile):')
		self.incrIndent()
		self.emit('self.cppdk.EventAction(cmd,' + actionVar + ')')
		self.decrIndent()
		self.emit('else:')
		self.incrIndent()
		self.emit('if(not tkMessageBox.askyesno("' + mod.name + event.name +' ", "Write to File:"'\
		 +  ' + self.cppdk.cmdFile)):')
		self.incrIndent()
		self.emit('return')
		self.decrIndent()
		nm =  mod.name + '_' + event.name + '_Event'
		val = cmd
		self.emit('order.append((\'' + nm + '\', \'' + val + '\'))')
		for var in event.vars:
		    key = mod.name + event.name + var
		    nm = ''
		    vl = ''
		    self.emit('nm = "' + var + '"')
		    self.emit('val = self.' + var + 'Entry.get()') 
		    self.emit('val = str(val)')
		    self.emit('order.append((nm, val))')
		self.emit('nm = "action"')
		self.emit('val = self.' + actionVar + 'Entry.get()') 
		self.emit('val = str(val)')
		self.emit('order.append((nm, val))')
		self.emit('self.cppdk.NewCommand(order)')
		self.decrIndent()

		self.decrIndent()
		self.emit('except:')
		self.incrIndent()
		self.emit('tkMessageBox.showerror("' + mod.name + var + '", "Error Occured while processing '\
		+ mod.name + event.name + ' Event Dialog")')
		self.emit('pass')
		self.decrIndent()
		self.emit('')
	        self.decrIndent()

       	   	self.emit('def Select(self, event=None):')
           	self.incrIndent()
	   	self.emit('types = []')
	   	self.emit('types.append((\'cmd\', \'*.ts\'))')
	   	self.emit('types.append((\'all\', \'*.*\'))')
	   	self.emit('inFile = tkFileDialog.askopenfilename(initialdir=self.cppdk.CMDS_DIR, '\
				+ 'defaultextension="ts", filetypes=types, initialfile=self.cppdk.cmdFile)')
	   	self.emit('if(inFile):')
	   	self.incrIndent()
	   	self.emit('self.' + actionVar + 'Entry.delete(0, END)')
	   	self.emit('self.' + actionVar + 'Entry.insert(0, inFile)')
	   	self.emit('return')
	   	self.decrIndent()
           	self.decrIndent()

    def genDialogs(self):
	print 'Generating Dialogs ..................'
	for mod in self.modules:
	    self.emit('')
	    for op in mod.ops:
		if(op == 'ADD_SEPARATOR'):
		    continue
		self.emit('class ' + mod.name + op + 'Dialog(Dialog):')
		self.incrIndent()
        	self.emit('def __init__(self, parent, cppdk):')
		self.incrIndent()

        	self.emit('self.cppdk = cppdk')
        	self.emit('self.helpShown = 0')
        	self.emit('self.listbox = None')
        	self.emit('self.enums = []')
        	self.emit('self.enumCount = 0')
        	self.emit('self.prevSel = None')
        	self.emit('self.curSel = None')
		self.emit('if(not self.cppdk.printFile and self.cppdk.connect == 0):')
		self.incrIndent()
		self.emit('tkMessageBox.showerror("Not Connected",' \
			 + '"Not Connected \\n\\n Connect to CPPDK server and Try again")')
		self.emit('return')
		self.decrIndent()

		if(ENUMS.has_key(mod.name + op)): #Select defined for this operation, put Select button
        	    self.emit('Dialog.__init__(self, parent, 1, title="' + mod.name + op + '")')
		else:
        	    self.emit('Dialog.__init__(self, parent, title="' + mod.name + op + '")')
        	self.emit('self.cppdk = cppdk')
		self.decrIndent()
		self.emit('')

        	self.emit('def body(self, master):')
		self.incrIndent()
        	self.emit('row = 0')

		args = mod.args[op] ##Array of Arguments for this operation
		arg = None
		listType = 0
		enums = []
		multClmns = 0
		clmn = 14
		if(len(args) > 25):
		    multClmns = 1
		for arg in args:
		    listType = 0
		    key = mod.name + op + arg
		    if(mod.enums.has_key(key)):
			self.emit('self.' + arg + 'Enums = ' + str(mod.enums[key]))
		    if(not mod.opts.has_key(key)):
        	        self.emit('Label(master,text="' + string.replace(arg, '_', ' ') +':", fg="blue").grid(row=row, column=' + str(clmn) + ')')
		    else:
        	        self.emit('Label(master,text="' + string.replace(arg, '_', ' ') +'  (Opt)", fg="blue").grid(row=row, column=' + str(clmn) + ')')

		    if(not mod.opts.has_key(key)):
        	        self.emit('self.' + arg + 'Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)')
		    else:
        	        self.emit('self.' + arg + 'Entry  = Entry(master, bg="light lightblue", fg="red", width=15, relief=SUNKEN)')
        	    self.emit('self.' + arg + 'Entry.grid(row=row, column=' + str(clmn + 8) + ')')
        	    self.emit('self.' + arg + 'Entry.insert(0, "' + mod.values[key] + '")')
		    if(mod.internals.has_key(key)):
        	        self.emit('self.' + arg + 'Entry.config(fg="red", state=DISABLED)')
		    if(mod.enums.has_key(key)):
			self.emit('self.enums.append((self.' + arg + 'Entry, self.' + arg + 'Entry, self.' + arg + 'Enums))')
		    if(not multClmns):
        	        self.emit('row = row + 1')
		    else:
			if(clmn >= 3*14):
        	            self.emit('row = row + 1')
			    clmn = 14
			else:
		    	    clmn = clmn + 14
        	self.emit('return ')
		self.decrIndent()
		self.emit('')

        	self.emit('def ok(self):')
		self.incrIndent()
        	self.emit('if not self.validate():')
		self.incrIndent()
        	self.emit('self.initial_focus.focus_set() # put focus back')
        	self.emit('return')
		self.decrIndent()
        	self.emit('self.withdraw()')
        	self.emit('self.update_idletasks()')
        	self.emit('self.apply()')
        	self.emit('self.cancel()')
		self.decrIndent()

        	self.emit('def end(self):')
		self.incrIndent()
        	self.emit('pass')
		self.decrIndent()
		self.emit('')

        	self.emit('def apply(self):')
		self.incrIndent()
		self.emit('try:')
		self.incrIndent()
		cmd = CID['CID_' + mod.name + op]
		self.emit('cmd = "' + cmd + '"')
		self.emit('reqresp = ReqResp(\'' + mod.name + op + '\', cmd)')
		self.emit('order = []')
		self.emit('nm = \'\'')
		self.emit('vl = \'\'')
		for arg in args:
		    self.emit('nm = \'' + arg + '\'')
		    key = mod.name + op + arg
		    if(mod.internals.has_key(key)):
		        if(mod.enums.has_key(key)):
		            self.emit('if(self.' + arg + 'Enums.has_key(\'' + mod.values[key] + '\')):')
		            self.incrIndent()
		            self.emit('internalEnum   = self.' + arg + 'Enums[\'' + mod.values[key] + '\']')
		            self.decrIndent()
		            #self.emit('cmd = cmd + ";"' + ' + internalEnum')
		            self.emit('vl =  internalEnum')
			else:
		            #self.emit('cmd = cmd + ";"' + ' + "'+  mod.values[key] + '" #' + arg)
		            self.emit('vl = \'' + mod.values[key] + '\'')
		    	self.emit('nv = (nm, vl)')
		    	self.emit('reqresp.arg(nv)')
			continue
		    input = string.lower(arg)
		    self.emit(input + ' = self.' + arg + 'Entry.get()') 
		    if(mod.enums.has_key(key)):
		        self.emit('if(self.' + arg + 'Enums.has_key(' + input + ')):')
		        self.incrIndent()
		        self.emit(input + ' = self.' + arg + 'Enums[' + input + ']')
		        self.decrIndent()
		    #self.emit('cmd = cmd + ";" + ' + input)
		    self.emit('vl = ' + input)
		    self.emit('nv = (nm, vl)')
		    self.emit('reqresp.arg(nv)')
		self.emit('if(not self.cppdk.printFile):')
		self.incrIndent()
		#self.emit('self.cppdk.Send(cmd)')
		self.emit('self.cppdk.Send(reqresp)')
		self.decrIndent()
		self.emit('else:')
		self.incrIndent()
		self.emit('if(not tkMessageBox.askyesno("' + mod.name + op +' ", "Write to File:"'\
						 +  ' + self.cppdk.cmdFile)):')
		self.incrIndent()
		self.emit('return')
		self.decrIndent()
		nm =  mod.name + '_' + op
		val = cmd
		self.emit('order.append((\'' + nm + '\', \'' + val + '\'))')
		for arg in args:
		    key = mod.name + op + arg
		    nm = ''
		    vl = ''
		    self.emit('nm = "' + arg + '"')
		    if(mod.internals.has_key(key)):
		        if(mod.enums.has_key(key)):
		            self.emit('if(self.' + arg + 'Enums.has_key(\''+ mod.values[key] + '\')):')
		            self.incrIndent()
		            #self.emit('val  = self.' + arg + 'Enums[\'' + key + '\']')
		            self.emit('val  = self.' + arg + 'Enums[\'' + mod.values[key] + '\']')
		            self.emit('val = str(val)')
		            self.decrIndent()
			else:
		            self.emit('val = "' +  mod.values[key] + '"')
		        self.emit('val = str(val)')
		        self.emit('order.append((nm, val))')
			continue
		    self.emit('val = self.' + arg + 'Entry.get()') 
		    if(mod.enums.has_key(key)):
		        self.emit('if(self.' + arg + 'Enums.has_key(' + 'val' + ')):')
		        self.incrIndent()
		        self.emit('val  = self.' + arg + 'Enums[' + 'val' + ']')
		        self.decrIndent()
		    self.emit('order.append((nm, str(val)))')
		self.emit('self.cppdk.NewCommand(order)')
		self.decrIndent()

		self.decrIndent()
		self.emit('except:')
		self.incrIndent()
		self.emit('tkMessageBox.showerror("' + mod.name + op + '", "Error Occured while processing '\
					 + mod.name + op + ' Dialog")')
		self.emit('pass')
		self.decrIndent()
		self.decrIndent()
		self.emit('')

		if(ENUMS.has_key(mod.name + op)): #Select defined for this operation
        	    self.emit('def Select(self, event=None):')
		    self.incrIndent()
		    self.emit('if(len(self.enums) <= self.enumCount):')
		    self.incrIndent()
		    self.emit('self.listbox.delete(0, END)')
		    #self.emit('self.listbox.config(height=0, bg="black")')
		    self.emit('self.listbox.config(height=0)')
		    #self.emit('self.add.config(state=DISABLED)')
		    #self.emit('self.next.config(state=DISABLED)')
		    self.emit('self.enumCount = 0')
		    #self.emit('self.prevSel.deselect()')
		    self.emit('self.prevSel.config(bg="gray")')
		    self.emit('self.prevSel = None')
		    self.emit('return')
		    self.emit('if(self.curSel):')
		    self.incrIndent()
		    #self.emit('self.curSel.deselect()')
		    self.emit('self.curSel.config(bg="gray")')
		    self.decrIndent()
		    self.decrIndent()
		    self.emit('if(not self.listbox):')
		    self.incrIndent()
		    self.emit('self.listbox = Listbox(self, bg="gray", fg="blue")')
		    self.emit('self.listbox.bind("<Double-Button-1>", self.add)')
        	    #self.emit('self.add = Button(self, text="Add", width=5, command=self.add, default=ACTIVE)')
        	    #self.emit('self.add = Button(self, text="+", width=1, command=self.add, default=ACTIVE)')
        	    self.emit('self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)')
        	    #self.emit('self.add.pack(side=RIGHT, padx=5, pady=5)')
        	    #self.emit('self.add.pack(side=BOTTOM, padx=0, pady=0)')
        	    self.emit('self.next.pack(side=RIGHT, padx=0, pady=0)')
		    self.decrIndent()
		    self.emit('else:')
		    self.incrIndent()
		    self.emit('self.listbox.delete(0, END)')
		    self.decrIndent()
		    self.emit('enum = self.enums[self.enumCount]')
		    self.emit('entry = enum[0]')
		    self.emit('self.curSel = enum[1]')
		    self.emit('if(self.prevSel):')
		    self.incrIndent()
		    #self.emit('self.prevSel.deselect()')
		    self.emit('self.prevSel.config(bg="gray")')
		    self.decrIndent()
		    #self.emit('self.curSel.select()')
		    #self.emit('self.curSel.config(bg="white")')
		    self.emit('if(self.curSel):')
		    self.incrIndent()
		    self.emit('self.curSel.config(bg="black")')
		    self.emit('self.prevSel = self.curSel')
		    self.decrIndent()
		    self.emit('sel = enum[2]')
		    self.emit('for key in sel:')
		    self.incrIndent()
		    self.emit('self.listbox.insert(END, key)')
		    self.decrIndent()
		    self.emit('self.listbox.config(height = len(sel))')
		    self.emit('self.listbox.pack(side=TOP, fill=BOTH)')
		    #self.emit('self.enumCount = self.enumCount + 1')
		    self.emit('')
		    self.decrIndent()
    
        	    self.emit('def add(self, event=None):')
		    self.incrIndent()
        	    self.emit('item=self.listbox.curselection()')
        	    self.emit('try:')
		    self.incrIndent()
        	    self.emit('selected = self.listbox.get(map(int, item)[0])')
        	    self.emit('self.enums[self.enumCount][0].delete(0, END)')
        	    self.emit('self.enums[self.enumCount][0].insert(0, selected)')
		    #self.emit('self.enums[self.enumCount][1].flash()')
		    #self.emit('self.enums[self.enumCount][1].flash()')
		    self.emit('self.enumCount = self.enumCount + 1')
        	    self.emit('self.Select()')
		    self.decrIndent()
        	    self.emit('except:')
		    self.incrIndent()
        	    self.emit('pass')
		    self.decrIndent()
		    self.decrIndent()

        	    self.emit('def next(self, event=None):')
		    self.incrIndent()
        	    self.emit('item=self.listbox.curselection()')
        	    self.emit('try:')
		    self.incrIndent()
		    self.emit('self.enumCount = self.enumCount + 1')
        	    self.emit('self.Select()')
		    self.decrIndent()
        	    self.emit('except:')
		    self.incrIndent()
        	    self.emit('pass')
		    self.decrIndent()
		    self.decrIndent()

        	self.emit('def operation(self, event=None):')
		self.incrIndent()
        	#self.emit('print "Operation Selected:  " + str(item)')
		self.emit('pass')
		self.decrIndent()
		self.decrIndent()
		self.emit('')

    def genCommands(self):
	self.incrIndent()
	for mod in self.modules:
	    self.emit('')
	    for op in mod.ops:
		if(op == 'ADD_SEPARATOR'):
		    continue
	        self.emit('def ' + mod.name + op +  '(self):')
		self.incrIndent()
		self.emit( mod.name + op + 'Dialog(self.root, self)')
		self.decrIndent()
	        self.emit('')
	    for event in mod.events:
		if(event == 'ADD_SEPARATOR'):
		    continue
	        self.emit('def ' + mod.name + event.name +  'Event(self):')
		self.incrIndent()
		self.emit( mod.name + event.name + 'EventDialog(self.root, self)')
		self.decrIndent()
	        self.emit('')

	self.emit('')
        self.emit('def ' + 'LoadActions' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('types = []')
	self.emit('types.append((\'evt\', \'*.evt\'))')
	#self.emit('types.append((\'cmd\', \'*.ts\'))')
	self.emit('types.append((\'all\', \'*.*\'))')
	self.emit('inFile = tkFileDialog.askopenfilename(initialdir=self.CMDS_DIR, '\
				+ 'defaultextension="evt", filetypes=types, initialfile=self.cmdFile)')
	self.emit('if(not inFile):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('fl = open(inFile)')
	self.emit('lines = fl.readlines()')
	self.emit('for line in lines:')
	self.incrIndent()
	self.emit('line = string.strip(line)')
	self.emit('if(not len(line)):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('if(line[0:1] == \'#\'):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('line = string.replace(line, \'[\', \'\')')
	self.emit('line = string.replace(line, \']\', \'\')')
	self.emit('line = string.replace(line, \'(\', \'\')')
	self.emit('elems = string.split(line, \')\')')
	self.emit('cmd = \'\'')
	self.emit('name = string.split(elems[0])[0]')
	self.emit('for elem in elems:')
	self.incrIndent()
	self.emit('elem = string.strip(elem)')
	self.emit('elem = string.replace(elem, \',\', \'\')')
	self.emit('elem = string.replace(elem, \'\\\'\', \'\')')
	self.emit('if(not len(elem)):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('cmd = cmd + string.split(elem)[1] + \';\'')
	self.decrIndent()
	self.emit('tmp = string.split(cmd, \';\')')
	self.emit('actFile = tmp[len(tmp) - 2]')
	self.emit('if(not os.path.exists(actFile)):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror(cmd, "Error in Event: " + cmd + "\\nNo valid action file specified")')
	self.emit('return')
	self.decrIndent()
	self.emit('cmd = string.split(cmd, actFile)[0]') #Remove file name
	self.emit('self.EventAction(cmd, actFile)')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror(inFile, "Error in Command: " + line)')
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('if(fl):')
	self.incrIndent()
	self.emit('fl.close()')
	self.decrIndent()
	self.emit('yes = tkMessageBox.askyesno("Executed " + self.cmdFile, "Want to continue with next Command file?\\n")')
	self.emit('if(yes):')
	self.incrIndent()
	self.emit('self.LoadActions()')
	self.decrIndent()
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror(inFile, "Error in Opening File")')
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('')

	self.emit('def FindCommandFiles(self, dir):')
	self.incrIndent()
    	self.emit('files = os.listdir(dir)')
    	self.emit('for file in files:')
	self.incrIndent()
        self.emit('path = os.path.abspath(dir) + os.sep + file')
        self.emit('if(os.path.isdir(path)):')
	self.incrIndent()
        self.emit('self.FindCommandFiles(path)')
	self.decrIndent()
        self.emit('else:')
	self.incrIndent()
        self.emit('self.CMD_FILES[file] = os.path.abspath(dir) + os.sep + file')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

	self.emit('')
	self.emit('def ReadFile(self, fl, lines):')
	self.incrIndent()
      	self.emit('lns = fl.readlines()')
      	self.emit('for l in lns:')
	self.incrIndent()
       	self.emit('l = string.strip(l)')
       	self.emit('if(not len(l)):')
	self.incrIndent()
       	self.emit('continue')
	self.decrIndent()
       	self.emit('if(l[0:1] == \'#\'):')
	self.incrIndent()
       	self.emit('continue')
	self.decrIndent()
       	self.emit('include = string.strip(string.lower(string.replace(l[0:9], \' \', \'\')))')
       	self.emit('if(include == \'--include\'):')
	self.incrIndent()
       	self.emit('f = open(self.CMD_FILES[string.strip(l[9:])])')
       	self.emit('self.ReadFile(f, lines)')
       	self.emit('f.close()')
	self.decrIndent()
       	self.emit('else:')
	self.incrIndent()
       	self.emit('lines.append(l)')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

	self.emit('')
	self.emit('def ' + 'LoadFile' +  '(self, inFile = None):')
	self.incrIndent()
	self.emit('cmds = []')
	self.emit('if(self.gui == 1):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('#self.SetRepeatCount()')
	self.emit('types = []')
	self.emit('types.append((\'cmd\', \'*.ts\'))')
	self.emit('types.append((\'all\', \'*.*\'))')
	self.emit('inFile = tkFileDialog.askopenfilename(initialdir=self.CMDS_DIR, '\
				+ 'defaultextension="ts", filetypes=types, initialfile=self.cmdFile)')
	self.emit('if(not len(inFile)):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.decrIndent() #gui = 1
	self.emit('try:')
	self.incrIndent()
	self.emit('self.FindCommandFiles(self.CMDS_DIR)')
	self.emit('lines = []')
	self.emit('if(self.CMD_FILES.has_key(inFile)):')
	self.incrIndent()
	self.emit('inFile = self.CMD_FILES[inFile]')
	self.decrIndent()
	self.emit('if(os.path.exists(inFile) and os.path.isfile(inFile)):')
	self.incrIndent()
	self.emit('fl = open(inFile)')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('if(self.gui):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror(inFile, "No such Script File")')
	self.emit('return')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('showerror(\'No such Script File <"\' + inFile + \'">\')')
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('self.ReadFile(fl, lines)')
	self.emit('fl.close()')
	self.emit('for line in lines:')
	self.incrIndent()
	self.emit('line = string.strip(line)')
	self.emit('if(not len(line)):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('if(line[0:1] == \'#\'):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()

       	self.emit('if(string.strip(string.lower(string.replace(line[0:2], \' \', \'\'))) == \'--\'):')
	self.incrIndent()
	self.emit('cmds.append(line)')
	self.emit('continue')
	self.decrIndent()

	self.emit('try:')
	self.incrIndent()
	self.emit('line = string.replace(line, \'[\', \'\')')
	self.emit('line = string.replace(line, \']\', \'\')')
	self.emit('line = string.replace(line, \'(\', \'\')')
	self.emit('elems = string.split(line, \')\')')
	self.emit('cmd = \'\'')
	self.emit('nameid = string.split(elems[0], \',\')')
	self.emit('name = nameid[0]')
	self.emit('name = string.replace(name, "\'", "-")')
	self.emit('name = string.replace(name, "-", "")')
	self.emit('id = nameid[1]')
	self.emit('id = string.replace(id, "\'", "-")')
	self.emit('id = string.replace(id, "-", "")')
	self.emit('reqresp = ReqResp(str(name), str(id))')
	self.emit('for elem in elems[1:]: #command name and id already known')
	self.incrIndent()
	self.emit('elem = string.strip(elem)')
	self.emit('elem = string.replace(elem, \',\', \'\')')
	self.emit('elem = string.replace(elem, \'\\\'\', \'\')')
	self.emit('if(not len(elem)):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('nm = string.split(elem)[0]')
	self.emit('vl = string.split(elem)[1]')
	self.emit('nv = (nm, vl)')
	#self.emit('cmd = cmd + string.split(elem)[1] + \';\'')
	self.emit('reqresp.arg(nv)')
	self.decrIndent()
	#self.emit('cmds.append(cmd)')
	self.emit('cmds.append(reqresp)')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
        self.emit('if(self.gui):')
        self.incrIndent()
	self.emit('tkMessageBox.showerror(inFile, "Error in Command: " + line)')
        self.decrIndent()
        self.emit('else:')
        self.incrIndent()
	self.emit('showerror("Error in Command: " + line)')
        self.decrIndent()
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('if(fl):')
	self.incrIndent()
	self.emit('fl.close()')
	self.decrIndent()
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror(inFile, "Error in Opening File")')
	self.emit('return')
	self.decrIndent()
	self.emit('repeat = self.repeatCount')
	self.emit('self.abort = 0')
	self.emit('while(repeat):')
	self.incrIndent()
	self.emit('if(self.abort == 1):')
	self.incrIndent()
        self.emit('if(not self.gui):')
        self.incrIndent()
        self.emit('print \'\\nShhhhhhhhhhhhhhh .....................\\n\'')
        self.decrIndent()
	self.emit('break')
	self.decrIndent()
	self.emit('self.nc = 0')
	self.emit('for cmd in cmds:')
	self.incrIndent()
	self.emit('if(self.abort == 1):')
	self.incrIndent()
        self.emit('if(not self.gui):')
        self.incrIndent()
        self.emit('print \'\\nShhhhhhhhhhhhhhh .....................\\n\'')
        self.decrIndent()
	self.emit('break')
	self.decrIndent()
	self.emit('self.Send(cmd)')
        self.emit('self.loadFile.flash()')
	self.decrIndent()
        self.emit('if(self.repeatCount != 11111):')
        self.incrIndent()
	self.emit('repeat = repeat - 1')
        self.decrIndent()
	self.decrIndent()
        self.emit('self.repeatCount = 1')
        self.emit('self.loadFile.config(bg="lightblue")')
        self.emit('self.waitTime = 0')
	self.decrIndent()

	self.emit('')
        self.emit('def ' + 'NewCommand' +  '(self, order, write = 1):')
	self.incrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('if(write == 1):')
	self.incrIndent()
	self.emit('self.tsFile.write(str(order) + \'\\n\\n\')')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('self.tsFile = open(self.cmdFile, \'a\')')
	self.emit('if(os.path.getsize(self.cmdFile) == 0):')
	self.incrIndent()
	self.emit('hdr = \'#Do not modify the "Type" parameter value\'')
	self.emit('self.tsFile.write(hdr + \'\\n\\n\')')
	self.decrIndent()
	self.decrIndent()
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.config(fg = "red", bg="cyan")')
	self.emit('self.printFile = 1')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('self.tsFile == None')
	self.emit('self.printFile = 0')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('tkMessageBox.showerror("File Error", "Error in Writing File: " + os.path.basename(self.cmdFile))')
	self.decrIndent()
	self.decrIndent()

	self.emit('')
        self.emit('def ' + 'CommandFile' +  '(self):')
	self.incrIndent()
	self.emit('if(self.printFile == 0):') 
	self.incrIndent()
	self.emit('self.EnableCommandFile()')
	self.emit('return')
	self.decrIndent()
	self.emit('else:') 
	self.incrIndent()
	self.emit('self.DisableCommandFile()')
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('')

        self.emit('def ' + 'DisableCommandFile' +  '(self):')
	self.incrIndent()
	self.emit('if(not self.printFile):') 
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Diasable Command File", "Command File not Enabled")')
	self.emit('return')
	self.decrIndent()
	self.emit('if(not tkMessageBox.askyesno("Diasable Command File", "Disable Command File: "'\
			+ '+ os.path.basename(self.cmdFile) + "\\nAre you sure")):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.emit('if(self.tsFile == None):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.emit('self.tsFile.flush()')
	self.emit('self.tsFile.flush()')
	self.emit('self.tsFile.close()')
	self.emit('self.tsFile == None')
	self.emit('self.printFile = 0')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.config(fg = "blue", bg="lightblue")')
	self.decrIndent()

	self.emit('')
        self.emit('def ' + 'EnableCommandFile' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect):') 
	self.incrIndent()
	self.emit('msg = "Connected to CPPDK Server\\nDisconnect and Try again"')
	self.emit('tkMessageBox.showerror("Enable Command File", msg)')
	self.emit('return')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('types = []')
	self.emit('types.append((\'ts\', \'*.ts\'))')
	self.emit('#types.append((\'evt\', \'*.evt\'))')
	self.emit('cmdFile = tkFileDialog.asksaveasfilename(initialdir=self.CMDS_DIR, defaultextension=".ts",'\
		+ ' filetypes=types, initialfile=self.cmdFile)')
	self.emit('if(len(cmdFile) == 0):')
	self.incrIndent()
	self.emit('self.printFile = 0')
	self.emit('return')
	self.decrIndent()
	self.emit('self.cmdFile = cmdFile')
	self.emit('self.NewCommand(None, 0)')
	"""
	self.emit('self.printFile = 1')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.flash()')
	self.emit('self.tsb.config(bg = "blue")')
	"""
	self.decrIndent()
	self.decrIndent()
	self.emit('')
	self.emit('')

        self.emit('def ' + 'AddResponseList' +  '(self, resp):')
        self.incrIndent()
        self.emit('if(self.responseCount >= self.MAX_RESP_HISTORY):')
        self.incrIndent()
        self.emit('self.responseCount = 0')
        self.decrIndent()
        self.emit('self.responseList[self.responseCount] = resp')
        self.emit('self.navigateCount = self.responseCount')
        self.emit('self.responseCount = self.responseCount + 1')
        self.decrIndent()

        self.emit('def ' + 'ClearHistory' +  '(self):')
        self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not Connected")')
	self.emit('return')
	self.decrIndent()
	self.emit('clear = tkMessageBox.askyesno("Clear History", "\\n Are you sure?")')
       	self.emit('if(clear != 1):')
	self.incrIndent()
       	self.emit('return')
	self.decrIndent()
        self.emit('self.seq = 0')
        self.emit('self.ec = 0')
        self.emit('CppuiReqResp.clear()')
        self.emit('CppuiEvents.clear()')
        self.emit('self.rb.flash()')
        self.emit('self.rb.flash()')
        self.emit('self.rb.flash()')
        self.emit('self.rb.config(text="")')
        self.emit('self.eb.flash()')
        self.emit('self.eb.flash()')
        self.emit('self.eb.flash()')
        self.emit('self.eb.config(text="")')
        self.emit('if(self.log == 1 and self.logf != None):')
        self.incrIndent()
        self.emit('self.enableLog.flash()')
        self.emit('self.enableLog.flash()')
        self.emit('self.enableLog.flash()')
        self.emit('self.logf.flush()')
        self.emit('self.logf.flush()')
        self.decrIndent()
        self.decrIndent()
        self.emit('')

        self.emit('def ' + 'NavigateEventsUp' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not connected\\nConnect to CPPDK and try again !!!")')
	self.emit('return')
	self.decrIndent()
	self.emit('if(CppuiEvents.has_key(self.nec)):')
	self.incrIndent()
	self.emit('self.eb.flash()')
	self.emit('evt = CppuiEvents[self.nec]')
	self.emit('self.ShowEvent(evt, 0)')
	self.emit('self.nec = self.nec + 1')
	self.emit('if(self.nec -1 == self.ec):')
	self.incrIndent()
	self.emit('self.nec = 1')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
        self.emit('')

        self.emit('def ' + 'NavigateEventsDown' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not connected\\nConnect to CPPDK and try again !!!")')
	self.emit('return')
	self.decrIndent()
	self.emit('if(CppuiEvents.has_key(self.nec)):')
	self.incrIndent()
	self.emit('self.eb.flash()')
	self.emit('evt = CppuiEvents[self.nec]')
	self.emit('self.ShowEvent(evt, 0)')
	self.emit('self.nec = self.nec - 1')
	self.emit('if(self.nec == 0):')
	self.incrIndent()
	self.emit('self.nec = self.ec')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
        self.emit('')

        self.emit('def ' + 'NavigateUpResponses' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not connected\\nConnect to CPPDK and try again !!!")')
	self.emit('return')
	self.decrIndent()
	self.emit('if(CppuiReqResp.has_key(str(self.nc))):')
	self.incrIndent()
	self.emit('resp = CppuiReqResp[str(self.nc)]')
	self.emit('self.rb.flash()')
	self.emit('self.UpdateResponseButton(resp, 0)')
	self.emit('self.nc = self.nc + 1')
	self.emit('if(self.nc == self.seq):')
	self.incrIndent()
	self.emit('self.nc = 1')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
        self.emit('')

        self.emit('def ' + 'NavigateDownResponses' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect != 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPUI Status", "Not connected\\nConnect to CPPDK and try again !!!")')
	self.emit('return')
	self.decrIndent()
	self.emit('if(CppuiReqResp.has_key(str(self.nc))):')
	self.incrIndent()
	self.emit('self.rb.flash()')
	self.emit('resp = CppuiReqResp[str(self.nc)]')
	self.emit('self.UpdateResponseButton(resp, 0)')
	self.emit('self.nc = self.nc - 1')
	self.emit('if(self.nc == 0):')
	self.incrIndent()
	self.emit('self.nc = self.seq - 1')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()
        self.emit('')


        self.emit('')
        self.emit('def ' + 'EventAction' +  '(self, evt, actFile):')
	self.incrIndent()
        self.emit('if(string.lower(actFile) == \'default\'):')
	self.incrIndent()
        self.emit('return')
	self.decrIndent()
        self.emit('if(not os.path.exists(actFile)):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Invalid Action File ",' \
			 + '"Can\'t find Event Action file <" + actFile + ">\\n Specify valid action file and Try again")')
        self.emit('return')
	self.decrIndent()
	self.emit('cmd = \'\'')
	self.emit('fl = open(actFile)')
	self.emit('lines = fl.readlines()')
	self.emit('for line in lines:')
	self.incrIndent()
	self.emit('line = string.strip(line)')
	self.emit('if(not len(line)):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('if(line[0:1] == \'#\'):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('try:')
	self.incrIndent()
	self.emit('line = string.replace(line, \'[\', \'\')')
	self.emit('line = string.replace(line, \']\', \'\')')
	self.emit('line = string.replace(line, \'(\', \'\')')
	self.emit('elems = string.split(line, \')\')')
	self.emit('name = string.split(elems[0])[0]')
	self.emit('for elem in elems:')
	self.incrIndent()
	self.emit('elem = string.strip(elem)')
	self.emit('elem = string.replace(elem, \',\', \'\')')
	self.emit('elem = string.replace(elem, \'\\\'\', \'\')')
	self.emit('if(not len(elem)):')
	self.incrIndent()
	self.emit('continue')
	self.decrIndent()
	self.emit('cmd = cmd + string.split(elem)[1] + \';\'')
	self.decrIndent()
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror(inFile, "Error in Command: " + line)')
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('if(fl):')
	self.incrIndent()
	self.emit('fl.close()')
	self.decrIndent()
        self.emit('self.eventActions[evt] = cmd')
        self.emit('print self.eventActions')
	self.decrIndent()
        self.emit('')

        self.emit('def ' + 'ShowEvent' +  '(self, evt, nec = 1):')
	self.incrIndent()
	self.emit('if(nec == 1):')
	self.incrIndent()
	self.emit('self.nec = self.ec')
	self.decrIndent()
	self.emit('text = evt.text()')
        self.emit('if(self.log == 1):')
        self.incrIndent()
        self.emit('self.Log(text)')
        self.decrIndent()
        self.emit('if(self.gui):')
        self.incrIndent()
	self.emit('self.eb.config(text = text)')
        self.decrIndent()
        self.emit('else:')
        self.incrIndent()
        self.emit('print \'\'')
        self.emit('print text')
        self.emit('print \'\'')
        self.decrIndent()
	self.decrIndent()

	#self.decrIndent()
        self.emit('#-----------------------------------------------------')
        self.emit('')

        self.emit('def ' + 'ProcessEvent' +  '(self, resp):')
	self.incrIndent()
	self.emit('evt = resp[1]')
	self.emit('event = string.split(evt, \';\')')
	self.emit('id = event[1]')
	self.emit('prio = event[2]')
	self.emit('descr = event[3]')
	self.emit('self.ec = self.ec + 1')
	for event in EVENTS:
	    ec = 4
	    if(ec == 4):
	        self.emit('if(id == str(CPPUI_EVENT_' + event.id + ')):')
	    else:
	        self.emit('elif(id == str(CPPUI_EVENT_' + event.id + ')):')
	    self.incrIndent()
	    self.emit('name = \'' + event.name + '\'')
	    if(event.name == "FE_PORT"):
	        self.emit('pid = event[5] # Event Parameters: FeId, PortId')
	        self.emit('if(self.ports.has_key(pid)):')
	        self.incrIndent()
	        self.emit('pb = self.ports[pid]')
	        self.emit('pb.flash()')
	        self.emit('pb.flash()')
	        self.emit('pb.config(bg="red", fg="blue")')
	        self.emit('pb.config(text = pid)')
	        self.decrIndent()
	    elif(event.name == "PORT_LINK_UP"):
	        self.emit('pid = event[5] # Event Parameters: FeId, PortId')
	        self.emit('if(self.ports.has_key(pid)):')
	        self.incrIndent()
	        self.emit('pb = self.ports[pid]')
	        self.emit('pb.flash()')
	        self.emit('pb.flash()')
	        self.emit('pb.config(bg="green")')
	        self.decrIndent()
	    elif(event.name == "PORT_LINK_DOWN"):
	        self.emit('pid = event[5] # Event Parameters: FeId, PortId')
	        self.emit('if(self.ports.has_key(pid)):')
	        self.incrIndent()
	        self.emit('pb = self.ports[pid]')
	        self.emit('pb.flash()')
	        self.emit('pb.flash()')
	        self.emit('pb.config(bg="red")')
	        self.decrIndent()
	    self.emit('evt = CppuiEvent(name, id, prio, descr)')
	    self.emit('evt.count(self.ec)')
	    for param in event.params:
		self.emit(param[0] + ' = event[' + str(ec) + ']')
		self.emit('evt.arg((\'' + param[0] + '\',' + param[0] + '))')
	        ec = ec + 1
	    self.emit('evt.save()')
	    self.emit('self.ShowEvent(evt)')
	    self.decrIndent()

	"""
	self.emit('if(id == str(CPPUI_EVENT_FE_PORT)):')
	self.incrIndent()
	self.emit('if(self.ports.has_key(id):')
	self.incrIndent()
	self.emit('pb = self.ports[id]')
	self.emit('pb.config(fg = "red")')
	self.decrIndent()
	self.decrIndent()
	"""
	self.decrIndent()

        self.emit('#-----------------------------------------------------')
        self.emit(' ')
        self.emit('def ' + 'UpdateResponseButton' +  '(self, reqresp, setnc = 1):')
	self.incrIndent()
        self.emit('if(setnc == 1):')
        self.incrIndent()
        self.emit('self.nc = self.seq - 1')
        self.decrIndent()
        self.emit('text = reqresp.text()')
        self.emit('if(self.gui):')
        self.incrIndent()
        self.emit('self.rb.config(text = text)')
        self.decrIndent()
        self.emit('if(self.log == 1):')
        self.incrIndent()
        self.emit('self.Log(text)')
        self.decrIndent()
        self.emit('if(not self.gui):')
        self.incrIndent()
        self.emit('text = \'\\t\\tRESULT(\' + `reqresp.sequence` + \'):\\t\\t\' + reqresp.resp ')
        self.emit('print text')
        self.emit('return')
        self.decrIndent()
        self.emit('if(reqresp.geterror() != CPPUI_NO_ERROR):')
        self.incrIndent()
        self.emit('self.rb.config(fg = "red")')
        self.decrIndent()
        self.emit('else:')
        self.incrIndent()
        self.emit('self.rb.config(fg = "blue")')
        self.decrIndent()
        self.emit('type = reqresp.type()')
        self.emit('error = reqresp.geterror()')
        self.emit('if(setnc == 0): #Call is from Navigate Function')
        self.incrIndent()
        self.emit('return')
        self.decrIndent()
        self.emit('if(type == str(CPPDK_CONNECT_REQ)): #Connect Response')
        self.incrIndent()
        self.emit('if(error == CPPUI_NO_ERROR):')
        self.incrIndent()
        self.emit('self.connect = 1')
        self.emit('self.sb.flash()')
        self.emit('self.sb.flash()')
        self.emit('#self.sb.config(bg="blue")')
        self.emit('self.sb.config(text="Disconnect")')
        self.decrIndent()
        self.decrIndent()
        self.emit('')
        self.emit('elif(type == str(CPPDK_DISCONNECT_REQ)): #Disconnect Response')
        self.incrIndent()
        self.emit('self.DisableLog(0)')
        self.emit('self.connect = 0')
        self.emit('self.sb.flash()')
        self.emit('self.sb.flash()')
        self.emit('self.sb.config(text="Connect   ")')
	self.emit(' ')
	self.emit('self.waitMode = 0')
	self.emit('self.tm.flash()')
	self.emit('self.tm.flash()')
        self.emit('self.tm.config(bg="lightblue", fg="blue")')
        self.emit('self.enableLog.config(bg="lightblue", fg="blue")')
        self.decrIndent()
        self.emit('')
        self.emit('')
	self.decrIndent()
        self.emit('')

        self.emit('')
        self.emit('def ' + 'ConnectDisconnect' +  '(self):')
	self.incrIndent()
        self.emit('if(self.connect == 0):')
	self.incrIndent()
	self.emit('if(self.printFile == 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("CPPDK Connect ",' \
			 + '"Test Script file Enabled, Disable it and Try Again")')
       	self.emit('return')
	self.decrIndent()
	self.emit('self.Connect()')
	self.decrIndent()
        self.emit('else:')
	self.incrIndent()
	self.emit('self.Disconnect()')
	self.decrIndent()
	self.decrIndent()

        self.emit('')
        self.emit('def ' + 'Connect' +  '(self):')
	self.incrIndent()
        self.emit('if(self.RecvThread == 0):')
	self.incrIndent()
	self.emit('thread.start_new_thread(self.Recv, ())')
        self.emit('self.RecvThread == 1')
	self.decrIndent()
	self.emit('if(self.gui):')
	self.incrIndent()
	self.emit('ConnectDialog(self.root, self)')
	self.decrIndent()
	self.decrIndent()
        self.emit('')

	self.emit('')
        self.emit('def ' + 'Disconnect' +  '(self):')
	self.incrIndent()
	self.emit('close = tkMessageBox.askyesno("Disconnect", "Disconnect \\n Are you sure?")')
       	self.emit('if(close != 1):')
	self.incrIndent()
       	self.emit('return')
	self.decrIndent()
	self.emit('reqresp = ReqResp("Disconnect", str(CPPDK_DISCONNECT_REQ))')
        self.emit('self.Send(reqresp)')
       	self.emit('self.connect = 0')
	self.decrIndent()
        self.emit('')

	self.emit('')
        self.emit('def ' + 'End' +  '(self):')
	self.incrIndent()
	self.emit('if(self.connect == 1):')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Quit ",' \
			 + '"connected to CPPDK server \\n Disconnect and Try again")')
       	self.emit('return')
	self.decrIndent()
	self.emit('close = tkMessageBox.askyesno("Quit", "Quit  \\n Are you sure?")')
       	self.emit('if(close != 1):')
	self.incrIndent()
       	self.emit('return')
	self.decrIndent()
       	#self.emit('self.Send(\'1001\') #Disccoonect Message')
	self.emit('self.root.quit()')
	self.decrIndent()
        self.emit('')
	self.decrIndent()

    def genConnectDialog(self):
	self.emit('from Tkinter import *')
	self.emit('from Dialog import *')
	self.emit('import tkMessageBox')
	self.emit('import tkSimpleDialog')
	self.emit('import tkFileDialog')
	self.emit('import os, string, re, time')
	self.emit('import socket, thread')
	self.emit('import os.path')
	self.emit('')
	self.emit('')
	self.emit('')

	for define in DEFINES:
	    self.emit(string.upper(define[0]) + ' = ' + define[1])
     	self.emit(' ')

	ec = 0
	for event in EVENTS:
	    self.emit('CPPUI_EVENT_' + event.id + '=' + str(ec))
	    ec = ec + 1

     	self.emit(' ')
     	self.emit('CPPUI_NO_ERROR = \'0\'')
     	self.emit('CppuiEvents = {}')
     	self.emit('CppuiReqResp = {}')
     	self.emit('CppuiSeperator1 = \'~~~~~~~~~~~~~~~~~~~~~~~~~~\'')
     	self.emit(' ')
     	self.emit('class ReqResp:')
	self.incrIndent()
        self.emit('def __init__(self, name, id):')
	self.incrIndent()
        self.emit('self.sequence = 0')
        self.emit('self.name = name')
        self.emit('self.id = string.strip(id)')
        self.emit('self.args = []')
        self.emit('self.err = 0')
        self.emit('self.ct = "0:0:0"')
        self.emit('self.resp = "RESPONSE NOT RECEIVED"')
     	self.emit(' ')
	self.decrIndent()
        self.emit('def save(self):')
	self.incrIndent()
        self.emit('CppuiReqResp[str(self.sequence)] = self')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def count(self, seq):')
	self.incrIndent()
        self.emit('self.sequence = seq')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def name(self, name):')
	self.incrIndent()
        self.emit('self.name = name')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def type(self):')
	self.incrIndent()
        self.emit('return(self.id)')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def seq(self):')
	self.incrIndent()
        self.emit('return(self.sequence)')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def arg(self, nv):')
	self.incrIndent()
        self.emit('self.args.append(nv)')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def output(self, msg):')
	self.incrIndent()
        self.emit('self.resp = msg')
	self.emit('self.ct = time.asctime(time.localtime())')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def error(self, err):')
	self.incrIndent()
        self.emit('self.err = err')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def geterror(self):')
	self.incrIndent()
        self.emit('return(self.err)')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def command(self, selftest = 0):')
	self.incrIndent()
        self.emit('cmd = str(self.sequence) + \';\'')
        self.emit('cmd = cmd + self.id + \';\'')
        self.emit('for arg in self.args:')
	self.incrIndent()
        self.emit('cmd = cmd + arg[1] + \';\'')
	self.decrIndent()
        self.emit('cmd = cmd + str(selftest)')
        self.emit('return(str(cmd))')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def hdr(self):')
	self.incrIndent()
        self.emit('hdr = self.name + \'(\' + self.id + \')\'')
        self.emit('return(hdr)')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def text(self):')
	self.incrIndent()
        self.emit('txt = \'\'')
        self.emit('hdr = self.name + \'(\' + self.id + \')\'')
        self.emit('txt = \'[\' + str(self.sequence) + \']\\t\' + hdr + \'\\n\\t\\t\\t\\t\' + self.ct')
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1')
        self.emit('txt = txt + \'\\n\\t\' + self.resp')
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1')
        self.emit('for arg in self.args:')
	self.incrIndent()
        self.emit('nm = arg[0]')
        self.emit('val = arg[1]')
        self.emit('txt = txt + \'\\n\' + nm + \' : \' + val')
	self.decrIndent()
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1 + \'\\n\'')
        self.emit('return(txt)')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def getdescr(self):')
	self.incrIndent()
        self.emit('txt = \'\'')
        self.emit('hdr = \'\\n(\' + str(self.sequence) + \')\' + self.name')
        self.emit('txt = hdr')
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1')
        self.emit('for arg in self.args:')
	self.incrIndent()
        self.emit('nm = arg[0]')
        self.emit('val = arg[1]')
        self.emit('txt = txt + \'\\n\' + nm + \' : \' + val')
	self.decrIndent()
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1 + \'\\n\'')
        self.emit('return(txt)')
	self.decrIndent()

	self.decrIndent()
     	self.emit('#---------------------------------------------------------')

     	self.emit(' ')
     	self.emit('class CppuiEvent:')
	self.incrIndent()
        self.emit('def __init__(self, name, id, prio = 0, des = "Not Available"):')
	self.incrIndent()
        self.emit('self.seq = 0')
        self.emit('self.name = name')
        self.emit('self.id = string.strip(id)')
        self.emit('self.prio = prio')
        self.emit('self.descr = des')
	self.emit('self.ct = time.asctime(time.localtime())')
        self.emit('self.args = []')
	self.decrIndent()
     	self.emit(' ')
     	self.emit('def arg(self, nv):')
	self.incrIndent()
     	self.emit('self.args.append(nv)')
	self.decrIndent()
     	self.emit(' ')
     	self.emit('def count(self, c):')
	self.incrIndent()
     	self.emit('self.seq = c')
	self.decrIndent()
     	self.emit(' ')
        self.emit('def save(self):')
	self.incrIndent()
        self.emit('CppuiEvents[self.seq] = self')
	self.decrIndent()
     	self.emit(' ')
     	self.emit('def text(self):')
	self.incrIndent()
        self.emit('txt = \'\\t\\t E V E N T \\n\' + CppuiSeperator1 + CppuiSeperator1 + \'\\n\'')
        self.emit('hdr = self.name + \'(\' + self.id + \')\'')
        self.emit('txt = txt + \'[\' + str(self.seq) + \']\\t\' + hdr + \'\\n\\t\\t\\t\' + self.ct')
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1')
        self.emit('for arg in self.args:')
	self.incrIndent()
        self.emit('nm = arg[0]')
        self.emit('val = arg[1]')
        self.emit('txt = txt + \'\\n\' + nm + \' : \' + val')
	self.decrIndent()
        self.emit('txt = txt + \'\\n\' + CppuiSeperator1 + CppuiSeperator1')
        self.emit('txt = txt + \'\\n\'')
     	self.emit('return(txt)')
	self.decrIndent()
     	self.emit(' ')

	self.decrIndent()
     	self.emit('#---------------------------------------------------------')
     	self.emit(' ')

     	self.emit('class Dialog(Toplevel):')
	self.incrIndent()
        self.emit('def __init__(self, parent, sel = 0, title = None):')
	self.incrIndent()
        self.emit('Toplevel.__init__(self, parent)')
        self.emit('self.transient(parent)')
        self.emit('if title:')
	self.incrIndent()
        self.emit('self.title(title)')
	self.decrIndent()

        self.emit('self.parent = parent')
        self.emit('self.result = None')
        self.emit('self.sel = sel')
        self.emit('body = Frame(self)')
        self.emit('self.initial_focus = self.body(body)')
        self.emit('body.pack(padx=5, pady=5)')
        self.emit('self.buttonbox()')
        self.emit('self.grab_set()')
        self.emit('if not self.initial_focus:')
	self.incrIndent()
        self.emit('self.initial_focus = self')
	self.decrIndent()
	self.emit('')
        self.emit('self.protocol("WM_DELETE_WINDOW", self.cancel)')
        self.emit('self.geometry("+%d+%d" % (parent.winfo_rootx()+50,parent.winfo_rooty()+50))')
        self.emit('self.initial_focus.focus_set()')
        self.emit('self.wait_window(self)')
	self.decrIndent()
        self.emit('def body(self, master):')
	self.incrIndent()
        self.emit('# create dialog body. return widget that should have')
        self.emit('# initial focus. this method should be overridden')
        self.emit('pass')
	self.decrIndent()
	self.emit('')
        self.emit('def buttonbox(self):')
	self.incrIndent()
        self.emit('# add standard button box. override if you don\'t want the')
        self.emit('# standard buttons')
        self.emit('box = Frame(self)')
        self.emit('w = Button(box, text="OK", width=5, command=self.ok, default=ACTIVE)')
        self.emit('w.pack(side=LEFT, padx=5, pady=5)')
        self.emit('if(self.sel):')
	self.incrIndent()
        self.emit('w = Button(box, text="Select", width=5, command=self.Select, default=ACTIVE)')
        self.emit('w.pack(side=LEFT, padx=5, pady=5)')
	self.decrIndent()
        self.emit('w = Button(box, text="Cancel", width=5, command=self.cancel)')
        self.emit('w.pack(side=LEFT, padx=5, pady=5)')
        self.emit('self.bind("&lt;Return>", self.ok)')
        self.emit('self.bind("&lt;Escape>", self.cancel)')
        self.emit('box.pack()')
	self.decrIndent()
        self.emit('def validate(self):')
	self.incrIndent()
        self.emit('return 1 # override')
	self.decrIndent()
	self.emit('')
    	self.emit('# standard button semantics')
        self.emit('def ok(self, event=None):')
	self.incrIndent()
        self.emit('if not self.validate():')
	self.incrIndent()
        self.emit('self.initial_focus.focus_set() # put focus back')
        self.emit('return')
	self.decrIndent()
        self.emit('self.withdraw()')
        self.emit('self.update_idletasks()')
        self.emit('self.apply()')
        self.emit('self.cancel()')
	self.decrIndent()

        self.emit('def cancel(self, event=None):')
	self.incrIndent()
        self.emit('# put focus back to the parent window')
        self.emit('self.parent.focus_set()')
        self.emit('self.destroy()')
	self.decrIndent()

        self.emit('def apply(self):')
	self.incrIndent()
        self.emit('pass # override')
	self.decrIndent()
        self.emit('def Select(self):')
	self.incrIndent()
        self.emit('pass # override')
	self.decrIndent()
        self.emit('def Enums(self, entry, enums, show):')
	self.incrIndent()
	self.emit('if(not show):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.emit('ht = len(enums)')
	self.emit('wd = 25')
	self.emit('if(not self.listbox):')
	self.incrIndent()
	self.emit('self.listbox = Listbox(self, bg="white", fg="blue", height=ht, width=50)')
	self.decrIndent()
	self.emit('for key in enums.keys():')
	self.incrIndent()
	#self.emit('self.listbox.insert(END, enums[key])')
	self.emit('self.listbox.insert(END, key)')
	self.decrIndent()
	self.emit('self.listbox.config(width=wd)')
	self.emit('self.listbox.pack(side=BOTTOM, fill=BOTH)')
	self.decrIndent()
	self.decrIndent()
     	self.emit('#---------------------------------------------------------')
	self.emit('')

     	self.emit('class EventDialog(Toplevel):')
	self.incrIndent()
        self.emit('def __init__(self, parent, title = None):')
	self.incrIndent()
        self.emit('Toplevel.__init__(self, parent)')
        self.emit('self.transient(parent)')
        self.emit('if title:')
	self.incrIndent()
        self.emit('self.title(title)')
	self.decrIndent()

        self.emit('self.parent = parent')
        self.emit('self.result = None')
        self.emit('body = Frame(self)')
        self.emit('self.initial_focus = self.body(body)')
        self.emit('body.pack(padx=5, pady=5)')
        self.emit('self.buttonbox()')
        self.emit('self.grab_set()')
        self.emit('if not self.initial_focus:')
	self.incrIndent()
        self.emit('self.initial_focus = self')
	self.decrIndent()
	self.emit('')
        self.emit('self.protocol("WM_DELETE_WINDOW", self.cancel)')
        self.emit('self.geometry("+%d+%d" % (parent.winfo_rootx()+50,parent.winfo_rooty()+50))')
        self.emit('self.initial_focus.focus_set()')
        self.emit('self.wait_window(self)')
	self.decrIndent()
        self.emit('def body(self, master):')
	self.incrIndent()
        self.emit('# create dialog body. return widget that should have')
        self.emit('# initial focus. this method should be overridden')
        self.emit('pass')
	self.decrIndent()
	self.emit('')
        self.emit('def buttonbox(self):')
	self.incrIndent()
        self.emit('# add standard button box. override if you don\'t want the')
        self.emit('# standard buttons')
        self.emit('box = Frame(self)')
        self.emit('w = Button(box, text="Ok", width=10, command=self.ok, default=ACTIVE)')
        self.emit('w.pack(side=LEFT, padx=5, pady=5)')
	"""
        self.emit('w = Button(box, text="Cancel", width=10, command=self.cancel)')
        self.emit('w.pack(side=LEFT, padx=5, pady=5)')
	"""
        self.emit('self.bind("&lt;Return>", self.ok)')
        self.emit('self.bind("&lt;Escape>", self.cancel)')
        self.emit('box.pack()')
	self.decrIndent()
        self.emit('def validate(self):')
	self.incrIndent()
        self.emit('return 1 # override')
	self.decrIndent()
	self.emit('')
    	self.emit('# standard button semantics')
        self.emit('def ok(self, event=None):')
	self.incrIndent()
        self.emit('if not self.validate():')
	self.incrIndent()
        self.emit('self.initial_focus.focus_set() # put focus back')
        self.emit('return')
	self.decrIndent()
        self.emit('self.withdraw()')
        self.emit('self.update_idletasks()')
        self.emit('self.apply()')
        self.emit('self.cancel()')
	self.decrIndent()

        self.emit('def cancel(self, event=None):')
	self.incrIndent()
        self.emit('# put focus back to the parent window')
        self.emit('self.parent.focus_set()')
        self.emit('self.destroy()')
	self.decrIndent()

        self.emit('def apply(self):')
	self.incrIndent()
        self.emit('pass # override')
	self.decrIndent()
	self.decrIndent()
     	self.emit('#---------------------------------------------------------')
	self.emit('')


	self.emit('class ConnectDialog(Dialog):')
	self.incrIndent()
        self.emit('def __init__(self, parent, cppdk):')
	self.incrIndent()
        self.emit('self.cppdk = cppdk')
        self.emit('Dialog.__init__(self, parent, title="CPPDK Connect")')
	self.decrIndent()
	self.emit('')

        self.emit('def body(self, master):')
	self.incrIndent()
        self.emit('row = 0')
        self.emit('Label(master,text="IP Address:").grid(row=row, column=14)')
        self.emit('self.IpAddressEntry  = Entry(master, width=15, relief=SUNKEN)')
        self.emit('self.IpAddressEntry.grid(row=row, column=22)')
        self.emit('self.IpAddressEntry.insert(0, self.cppdk.host)')
        self.emit('row = row + 1')
        self.emit('Label(master,text="Port:").grid(row=row, column=14)')
        self.emit('self.PortNoEntry = Entry(master, width=15, relief=SUNKEN)')
        self.emit('self.PortNoEntry.grid(row=row, column=22)')
        self.emit('self.PortNoEntry.insert(0, "7890")')
        self.emit('return self.IpAddressEntry')
	self.decrIndent()
	self.emit('')

        self.emit('def ok(self):')
	self.incrIndent()
        self.emit('if not self.validate():')
	self.incrIndent()
        self.emit('self.initial_focus.focus_set() # put focus back')
        self.emit('return')
	self.decrIndent()
        self.emit('self.withdraw()')
        self.emit('self.update_idletasks()')
        self.emit('self.apply()')
        self.emit('self.cancel()')

	self.decrIndent()

	self.emit('')
        self.emit('def apply(self):')
	self.incrIndent()
        self.emit('self.cppdk.host = string.strip(self.IpAddressEntry.get())')
        self.emit('try:')
	self.incrIndent()
        self.emit('self.cppdk.port = int(self.PortNoEntry.get())')
	self.decrIndent()
        self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Port Error", "Invalid Port")')
	self.decrIndent()
        self.emit('if(self.cppdk.sock != None):')
	self.incrIndent()
	self.emit('reqresp = ReqResp("Connect", str(CPPDK_CONNECT_REQ))')
        self.emit('self.cppdk.Send(reqresp)')
	self.decrIndent()

	self.decrIndent()
	self.emit('')
        self.emit('def operation(self, event=None):')
	self.incrIndent()
        #self.emit('print "Operation Selected:  " + str(item)')
        self.emit('pass')
	self.decrIndent()
	self.decrIndent()
     	self.emit('#---------------------------------------------------------')
	self.emit('')

	self.emit('class LogDialog(Dialog):')
	self.incrIndent()
        self.emit('def __init__(self, parent, cppdk):')
	self.incrIndent()
        self.emit('self.cppdk = cppdk')
        self.emit('lf = \'\'')
	self.emit('try:')
	self.incrIndent()
	self.emit('if(self.cppdk.log == 0):')
	self.incrIndent()
	self.emit('types = []')
	self.emit('types.append((\'log\', \'*.log\'))')
	self.emit('types.append((\'all\', \'*.*\'))')
	self.emit('lf = tkFileDialog.askopenfilename(initialdir=self.cppdk.LOG_DIR, defaultextension="log",'\
				+ ' filetypes=types, initialfile=self.cppdk.LOG_FILE)')
	self.emit('if(not len(lf)):')
	self.incrIndent()
	self.emit('return')
	self.decrIndent()
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('lf = self.cppdk.lf')
	self.decrIndent()
	self.emit('log = open(lf)')
	self.emit('self.lines = log.readlines()')
	self.emit('log.close()')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('tkMessageBox.showerror("Log Error", "Error while opening Log file")')
	self.decrIndent()
        self.emit('Dialog.__init__(self, parent, title="CPPUI LOG")')
	self.decrIndent()
	self.emit('')

        self.emit('def body(self, master):')
	self.incrIndent()
	self.emit('scrollbar = Scrollbar(master)')
	self.emit('scrollbar.pack(side=RIGHT, fill=Y)')
	self.emit('listbox = Listbox(master, bg="white", fg="brown", height=35, '\
			+ 'width=100, yscrollcommand=scrollbar.set)')
	self.emit('try:')
	self.incrIndent()
	self.emit('if(len(self.lines) == 0):')
	self.incrIndent()
	self.emit('listbox.insert(END, "Empty Log File")')
	self.decrIndent()
	self.emit('for line in self.lines:')
	self.incrIndent()
	self.emit('line = string.replace(line, \'\\n\', \'\')')
	self.emit('listbox.insert(END, line)')
	self.decrIndent()
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('listbox.insert(END, "LOG ERROR")')
	self.decrIndent()
	self.emit('listbox.pack(side=LEFT, fill=BOTH)')
	self.emit('scrollbar.config(command=listbox.yview)')

	self.decrIndent()
	self.emit('')

        self.emit('def ok(self):')
	self.incrIndent()
        self.emit('if not self.validate():')
	self.incrIndent()
        self.emit('self.initial_focus.focus_set() # put focus back')
        self.emit('return')
	self.decrIndent()
        self.emit('self.withdraw()')
        self.emit('self.update_idletasks()')
        self.emit('self.apply()')
        self.emit('self.cancel()')

	self.decrIndent()

	self.emit('')
        self.emit('def apply(self):')
	self.incrIndent()
        self.emit('pass')
	self.decrIndent()
	self.emit('')
        self.emit('def operation(self, event=None):')
	self.incrIndent()
        self.emit('pass')
	self.decrIndent()
	self.decrIndent()
	self.emit('')

    def genGuiMain(self):
     	self.emit('#---------------------------------------------------------')
	self.emit('class Cppui:')
	self.incrIndent()
    	self.emit('def __init__(self, title, gui = 1):')
	self.incrIndent()
        self.emit('self.MAX_RESP_HISTORY = 10000')
        self.emit('self.MAX_EVENT_HISTORY = 1000')
        self.emit('self.responseList = []')
        self.emit('self.eventsList = []')
        self.emit('self.eventActions = {}')
        self.emit('self.gui = gui')
        self.emit('self.host = \'localhost\'')
        self.emit('self.port = 7890')
        self.emit('self.seq = 0')
        self.emit('self.cc = 0')
        self.emit('self.nc = 0')
        self.emit('self.ec = 0')
        self.emit('self.nec = 0')
        self.emit('self.selftest = 0')
        self.emit('self.respDialogs = 0')
        self.emit('self.log = 0')
        self.emit('self.lf = None')
        self.emit('self.logf = None')
        self.emit('self.sock = None')
	self.emit('self.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)')
        self.emit('self.RecvThread = 0')
        self.emit('self.connect = 0')
        self.emit('self.printFile = 0')
	self.emit('self.ports = {}')
	self.emit('self.GIF_DIR = \'.gif\'')
	self.emit('self.LOG_DIR = \'log\'')
	self.emit('self.LOG_FILE = \'cppui.log\'')
	self.emit('self.CMDS_DIR = \'ts\'')
	self.emit('self.CMD_FILES = {}')
        self.emit('self.cmdFile = \'sample.ts\'')
        self.emit('self.tsFile = None')
        self.emit('self.repeatCount = 1')
        self.emit('self.nc = 0')
        self.emit('self.abort = 0')
        self.emit('self.waitMode = 0')
        self.emit('self.waitTime = 0')
        self.emit('self.recvs = 0')
        self.emit('self.fails = 0')
        self.emit('self.timeout = 0')
        self.emit('self.ct = None')
        self.emit('self.dt = None')
        self.emit('self.title = title')
        self.emit('if(not os.path.exists(self.CMDS_DIR)):')
        self.incrIndent()
        self.emit('os.mkdir(self.CMDS_DIR)')
        self.decrIndent()
        self.emit('if(not os.path.exists(self.LOG_DIR)):')
        self.incrIndent()
        self.emit('os.mkdir(self.LOG_DIR)')
        self.decrIndent()
        self.emit('if(self.gui == 1):')
        self.incrIndent()
        self.emit('self.root = Tk()')
        self.emit('self.root.title(self.title)')
        self.emit('self.root.wm_resizable(0, 0)')
        self.emit('self.root.protocol("WM_DELETE_WINDOW", self.End)')

	self.emit('')
        self.emit('self.bf = Frame(self.root, bg="lightblue", bd=0, width=100 )')
        self.emit('self.bf.grid(row=0, col=0, columnspan=2, sticky="we")')
        self.emit('self.rf = Frame(self.root, bg="white", bd=0, height=100, width=100 )') #Root Frame
        self.emit('self.rf.grid(row=0, col=0, columnspan=2, sticky="we")')
        self.emit('self.cf = Frame(self.root, bg="white", bd=0, width=100 )')
	self.emit('')
        self.emit('self.pf = Frame(self.root, bg="black", bd=0, height=0, width=100 )') #PORTS Frame
	self.emit('')

	self.emit('#Port Buttons')
        self.emit('p = 0')
        self.emit('while(p < MAX_PORT_COUNT):')
        self.incrIndent()
        self.emit('self.ports[str(p)] = Button(self.pf, bg="black", text="", height = 0, width=0, relief=FLAT)')
        self.emit('p = p + 1')
        self.decrIndent()
	"""
        self.emit('self.pb1 = Button(self.pf, bg="black", text="", height = 0, width=0, relief=FLAT)')
        self.emit('self.pb2 = Button(self.pf, bg="black", text="", height = 0, width=0, relief=FLAT)')
        self.emit('self.pb3 = Button(self.pf, bg="black", text="", height = 0, width=0, relief=FLAT)')
        self.emit('self.pb4 = Button(self.pf, bg="black", text="", height = 0, width=0, relief=FLAT)')
	"""
	self.emit('')
        
        self.emit('#self.sb = Button(self.bf, height=0, width=0, bg="brown", text="", command=self.ConnectDisconnect, relief=GROOVE) #Status Button')
	self.emit('self.sb = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.rb = Button(self.rf, bd=1, padx=0, pady=0, relief=SUNKEN, bg="light gray", anchor=NW, justify=LEFT)')
	self.emit('self.rb.config(fg="dark blue", text="", height=20, width=60, wraplength=500)')

	self.emit('self.eb = Button(self.rf, bd=1, padx=0, pady=0, relief=SUNKEN, anchor=NW, justify=LEFT)')
	self.emit('self.eb.config(fg="dark blue", bg="light yellow", text="", height=20, width=50)')
	self.emit('self.loadFile = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.enableLog = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.showLog = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.navig1 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.navig2 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.navig3 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.navig4 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.tsb = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.loadFile.config(bg="lightblue", fg="blue", text="Load", command=self.LoadFile)')
	self.emit('self.showLog.config(bg="lightblue", fg="blue", text="Show", command=self.DisplayLog)')
	self.emit('self.enableLog.config(bg="lightblue", fg="blue", text="Log", command=self.LogFile)')
	self.emit('self.tsb.config(bg="lightblue", fg="blue", text="Script", command = self.CommandFile)')
	self.emit('self.navig1.config(bg="lightblue", fg="blue", text="Prev", command = self.NavigateDownResponses)')
	self.emit('self.navig2.config(bg="lightblue", fg="blue", text="Next", command = self.NavigateUpResponses)')
	self.emit('self.navig3.config(bg="lightblue", fg="blue", text="PrevEvent", command = self.NavigateEventsDown)')
	self.emit('self.navig4.config(bg="lightblue", fg="blue", text="NextEvent", command = self.NavigateEventsUp)')
	self.emit('self.tm = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.tm.config(bg="lightblue", fg="blue", text="Wait", command=self.TestMode)')
	self.emit('self.ch = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)')
	self.emit('self.ch.config(bg="lightblue", fg="blue", text="Clear", command=self.ClearHistory)')

        self.emit('')
        self.emit('Label(self.bf, bg="lightblue", text="").pack(side=LEFT)')
        self.emit('self.sb.config(command=self.ConnectDisconnect, text="Connect   ", fg="blue", bg="lightblue")') #Status Button
        self.emit('self.sb.pack(side="left")') #Status Button
        self.emit('self.rb.pack(side="left")')#Response Button
        self.emit('self.eb.pack(side="top")')#Events Button
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.loadFile.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.enableLog.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.showLog.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.navig1.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.navig2.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.tsb.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.tm.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.ch.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.navig3.pack(side="left")')
        self.emit('Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)')
        self.emit('self.navig4.pack(side="left")')

        self.emit('Label(self.pf, bg="black", fg="white", text="FE Ports    ").pack(side=LEFT)')
        self.emit('p = 0')
        self.emit('while(p < MAX_PORT_COUNT):')
        self.incrIndent()
	self.emit('pb = self.ports[str(p)]')
	self.emit('pb.pack(side=LEFT)')
	self.emit('Label(self.pf, bg="black", text="    ").pack(side=LEFT)')
        self.emit('p = p + 1')
        self.decrIndent()

	self.emit('img1 = PhotoImage(file = self.GIF_DIR + os.sep + \'intel.gif\')')
	self.emit('toplab = Label(self.bf, height=0, width=0, image=img1)')
	self.emit('toplab.pack(side=RIGHT)')

        self.emit('self.bf.pack(side=TOP, fill=BOTH, expand=0)')
        self.emit('self.rf.pack(side=TOP, fill=BOTH, expand=0)')
        self.emit('self.cf.pack(side=BOTTOM, fill=BOTH, expand=0)')
        self.emit('self.pf.pack(side=BOTTOM, fill=BOTH, expand=0)')


	moduleMenu = ''
	moduleName = ''
	self.emit('')
        self.emit('# create a toplevel menu')
        self.emit('menubar = Menu(self.root, bg="cyan", fg="brown")')
        self.emit('cppuiMenu = Menu(menubar, bg="black", fg="red", tearoff=0)')
	self.emit('cppuiMenu.add_command(label="Set Count", command=self.SetRepeatCount)')
	self.emit('cppuiMenu.add_separator()')
	self.emit('cppuiMenu.add_command(label="Set Delay", command=self.SetWaitTime)')
	self.emit('cppuiMenu.add_separator()')
	self.emit('cppuiMenu.add_command(label="Enable Self Test", command=self.EnableSelfTest)')
	self.emit('cppuiMenu.add_separator()')
	self.emit('cppuiMenu.add_command(label="Disable Self Test", command=self.DisableSelfTest)')
	self.emit('cppuiMenu.add_separator()')
	self.emit('menubar.add_cascade(label="Cppui", menu=cppuiMenu)')
	self.emit('')
	for mod in self.modules:
	    if(not len(mod.name)):
		continue
	    moduleMenu = mod.name + 'Menu'
            self.emit(moduleMenu + ' = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)')
	    for op in mod.ops:
		if(op == 'ADD_SEPARATOR'):
		    self.emit(moduleMenu + '.add_separator()')
		    continue
		cmd = mod.name + op
		op = string.replace(op, '_' , ' ')
	        self.emit(moduleMenu + '.add_command(label="' \
			+ op + '", command=self.'+ cmd + ')')
	    if(len(mod.events) > 0):
		self.emit(moduleMenu + '.add_separator()')
		self.emit(moduleMenu + '.add_separator()')
	    for event in mod.events:
		cmd = mod.name + event.name + 'Event'
	        self.emit(moduleMenu + '.add_command(label="' \
			+ 'Add: ' + event.name + 'Event", command=self.'+ cmd + ')')
	    self.emit('menubar.add_cascade(label="' + mod.name + '", menu=' + moduleMenu +')')
	    self.emit('')
	    self.emit('')
	self.emit('self.root.config(menu=menubar)')

	self.emit('thread.start_new_thread(self.Status, ())')

	#self.emit('self.rf.pack()')
	self.emit('self.root.mainloop()')
        self.decrIndent()

        self.decrIndent()

    def parse(self, xml):
        doc = FromXmlFile(xml)
        doc.normalize()
	moduleName = ''
	fl = None
	flag = None
	moduleNodeList = doc.getElementsByTagName('Module')
	#print dir(doc)
	for moduleNode in moduleNodeList:
	    if(moduleNode.hasAttribute('flag')):
                flag = moduleNode.getAttribute('flag')

	    modules = moduleNode.childNodes
	    for module in modules:
	        mod = Module()
		if(module.nodeType != module.ELEMENT_NODE):
		    continue
	        if(not moduleNode.hasAttribute('file')):
	            fl = string.lower(module.nodeName)
	            fl = 'cppui_' + fl
	            print 'WARNING: No "file" attribute found for module "' + module.nodeName \
			    + '", using " ' + fl + '"'
	        else:
	            fl = moduleNode.getAttribute('file')
	            fl = 'cppui_' + string.lower(string.split(fl, '.')[0])
            	mod.file = fl
		if(flag != None):
		    print 'Module "' + module.nodeName + '" will be put under flag "' + flag + '"'
		    FLAGS[module.nodeName] = flag
	        event = None
		moduleName = string.strip(module.nodeName)
		opsNodeList =  module.childNodes
	        operations = []
		opArgs = {}
		opList = []
		values = {}
		opVars = {}

		for hdrNode in opsNodeList:
		    if(hdrNode.nodeName == 'Header' and hdrNode.nodeType == hdrNode.ELEMENT_NODE):
	        	hdr = hdrNode.firstChild
	        	if(hdr.nodeType == hdr.TEXT_NODE):
	            	    mod.header.append(hdr.data)

		#Process Common Node
		for gbNode in opsNodeList:
		    if(gbNode.nodeName == 'Common' and gbNode.nodeType == gbNode.ELEMENT_NODE):
	        	gb = gbNode.firstChild
	        	if(gb.nodeType == gb.TEXT_NODE):
	            	    mod.globals.append(gb.data)

		#Process Events Node
		for opsNode in opsNodeList:
		    if(opsNode.nodeName == 'Events' and opsNode.nodeType == opsNode.ELEMENT_NODE):
		        events = opsNode.childNodes
		        for ev in events:
		            if(ev.nodeType != ev.ELEMENT_NODE):
			        continue
			    event = Event()
		            event.name = ev.nodeName
			    if(not ev.hasAttribute('id')):
			        print 'ERROR: No "id" attribute found for "' + event.name + '"'
			        sys.exit(0)
			    ek = moduleName + event.name
		            event.id = ev.getAttribute('id')
			    if(ID.has_key(event.id)):
			       	print 'ERROR: Duplicate id"' + event.id + '" which is already used for " ' + str(ID[event.id]) + '"'
			       	sys.exit(0)
			    ID[ek] = str(event.id)
			    if(ev.hasAttribute('action')):
		                event.action = ev.getAttribute('action')
			    else:
		                event.action = 'Default'
		            evars = ev.childNodes
		            for evar in evars:
		                if(evar.nodeType != evar.ELEMENT_NODE):
			            continue
		                evrs = evar.childNodes
		                for evr in evrs:
				    vname = evr.nodeName
		                    if(evr.nodeType != evr.ELEMENT_NODE):
			                continue
			    	    if(not evr.hasAttribute('def')):
			        	print 'ERROR: No "def" attribute found for "' + event.name + '->' + vname + '"'
			        	sys.exit(0)
				    event.vars.append(vname)
				    ek = moduleName + event.name + vname
		    		    mod.values[ek] = evr.getAttribute('def')
			if(event != None):
		            mod.events.append(event)
		        continue

		#Process Ops Node
		for opsNode in opsNodeList:
		    if(opsNode.nodeName != 'Ops'):
			continue
		    ops = opsNode.childNodes
		    for op in ops:
		        opName = ''
		        if(op.nodeType != op.ELEMENT_NODE):
			    continue
		        opName = op.nodeName
		        opName = string.strip(opName)
			opName = string.strip(opName)
			#print opName
			operations.append(opName)
			if(opName == 'ADD_SEPARATOR'):
			    continue
			if(op.hasAttribute('id')):
			    id = op.getAttribute('id')
			    try:
			        int(id)
			    except:
			        print 'ERROR: Invalid id "' + id + '" found for "' + opName + '", Specify integer value'
			        sys.exit(0)
			    if(CID.has_key(id)):
				old = CID[id]
			        print 'ERROR: Duplicate id "' + id + '" found for "' + opName + '", which is defined for "' + old + '"\n'
			        sys.exit(0)
			    CID['CID_' + moduleName + opName] = id
			    CID[id] = moduleName + '->' + opName
			    mod.ids.append(id)
			else:
			    print 'ERROR: No "id" attribute found for "' + opName + '"'
			    sys.exit(0)
			if(op.hasAttribute('api')):
			    api = op.getAttribute('api')
			    opArgs['API_' + moduleName + opName] = api
			if(op.hasAttribute('vars')):
			    vars = op.getAttribute('vars')
			    vars = string.strip(vars)
			    vars = string.replace(vars, ',', ' ')
			    for tmp in string.split(vars):
			        mod.variables[tmp] = tmp
			    opVars['API_' + moduleName + opName] = string.split(vars)
			else:
			    print 'ERROR: No "vars" attribute found for "' + opName + '"'
			    sys.exit(0)
			if(op.hasAttribute('selftest')):
			    print 'Operation "' + op.nodeName + '" has Self Test'
			    mod.st['SELFTEST_' + moduleName + opName] = 'SELFTEST_' + moduleName + opName
			argsNodeList = op.childNodes
			opList = []
			for argument in argsNodeList:
		            if(argument.nodeType != op.ELEMENT_NODE):
			         continue
			    argName = argument.nodeName
			    # -- Processing SelfTest node BEGIN --
			    if(string.strip(argName) == 'SelfTest'):
				if(not argument.hasAttribute('proto')):
				    print 'ERROR: No proto attribute Type found for "' \
					+ moduleName + '->' +  opName + '->' + 'SelfTest' + '"'
				    sys.exit(0)
				proto = argument.getAttribute('proto')
				tmp = string.split(proto, ',')
				proto = ''
				cnt = 1
				for t in tmp:
				    if(cnt < len(tmp)):
				        t = string.strip(t) + ', '
				    else:
				        t = string.strip(t)
				    cnt = cnt + 1
				    proto = proto + t
	   			func = argument.firstChild
	   			if(func.nodeType == func.TEXT_NODE):
				    if(mod.st.has_key('SELFTEST_' + moduleName + opName)):
			    	        mod.st['SELFTEST_' + moduleName + opName] = (proto, func.data)
			    # -- Processing Resp node BEGIN --
			    if(string.strip(argName) == 'Resp'):
				if(not argument.hasAttribute('type')):
				    print 'ERROR: No response Type found for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				type = argument.getAttribute('type')
				if(not argument.hasAttribute('name')):
				    print 'ERROR: No response Name found for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				if(type =='async' and not argument.hasAttribute('cbdata')):
				    print 'ERROR: No response Callback data found for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				if(not argument.hasAttribute('var')):
				    print 'ERROR: "var" attribute missing for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				"""
				if(not argument.hasAttribute('format')):
				    print 'ERROR: "format" attribute missing for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				"""

				type = argument.getAttribute('type')
				key = moduleName + opName + 'RespType'
				mod.responses[key] = string.strip(type)

				name = argument.getAttribute('name')
				key = moduleName + opName + 'AyncResponse'
				mod.responses[key] = string.strip(name)

				cbdata = argument.getAttribute('cbdata')
				key = moduleName + opName + 'CallbackData'
				mod.responses[key] = string.strip(cbdata)

				var = argument.getAttribute('var')
				key = moduleName + opName + 'AsyncVar'
				mod.responses[key] = string.strip(var)

				if(argument.hasAttribute('format')):
				    format = argument.getAttribute('format')
				    key = moduleName + opName + 'Format'
				    mod.responses[key] = string.strip(format)

				continue
			    # -- ------ Processing Resp node END ------------ --

			    # -- Processing Args node BEGIN --
			    argsList = argument.childNodes
			    for arg in argsList:
				argName = ''
		                if(arg.nodeType != op.ELEMENT_NODE):
			             continue
				argName = arg.nodeName
				#print argName
				opList.append(arg.nodeName)
				#values = {}
				#assigns = {}
				key = moduleName + opName + argName
				if(arg.hasAttribute('opt')):
				    opt = arg.getAttribute('opt')
			            mod.opts[key] = argName
				if(arg.hasAttribute('def')):
				    default = arg.getAttribute('def')
			            mod.values[key] = default
				    if(arg.hasAttribute('by')):
					by = arg.getAttribute('by')
					if(not ENUMS.has_key(by)):
					    print 'ERROR: No value "' \
								+ by + '" defined in "' + argName +'->' + by + '"'
					    sys.exit(0)
					tmp = ENUMS[by]
					if(not tmp.has_key(default)):
					    print 'ERROR: Please Specify valid default value from "' \
								+ by + '" in "' + argName +'->' + default + '"'
					    print 'Use one of the following as default value:'
					    for k in tmp.keys():
						print k + '(' + tmp[k] + ')'
					    sys.exit(0)
				else:
				    print 'ERROR: No Default value specified for : "' + argName
				    sys.exit(0)
				if(arg.hasAttribute('internal')):
				    internal = arg.getAttribute('internal')
			            mod.internals[key] = internal
				if(not arg.hasAttribute('assign')):
				    print 'ERROR: No assignment found for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				if(not arg.hasAttribute('type')):
				    print 'ERROR: No "type" attribute found for "' \
					+ moduleName + '->' +  opName + '->' + argName + '"'
				    sys.exit(0)
				assign = arg.getAttribute('assign')
			        mod.assigns[key] = assign
				tp = arg.getAttribute('type')
			        mod.types[key] = tp
				if(arg.hasAttribute('getf')):
				    getf = arg.getAttribute('getf')
			            mod.getf[key] = getf
				if(arg.hasAttribute('by')):
				    by = arg.getAttribute('by')
				    if(not ENUMS.has_key(by)):
					print 'ERROR: Can\t find enum definition "' + by + '" defined in"' + arg + '"'
					sys.exit(0)
				    ENUMS[moduleName + opName] = moduleName + opName
			            mod.enums[key] = ENUMS[by]
			    # -- ------ Processing Args node END ------------ --

			opArgs[opName] = opList
	        mod.name = moduleName
	        mod.ops = operations
	        mod.args = opArgs
	        mod.vars = opVars
		self.modules.append(mod)
		MODULES[string.lower(mod.name)] = mod

	varsNodeList = doc.getElementsByTagName('Vars')
	for varNode in varsNodeList:
	    vars = varNode.childNodes
	    for var in vars:
		if(var.nodeType == var.ELEMENT_NODE):
		    if(var.hasAttribute('type')):
	                type = var.getAttribute('type')
			type = string.strip(type)
			if(type == 'enum'):
			    enums = []
			    enumNodes = var.childNodes
			    for enum in enumNodes:
				if(enum.nodeType == enum.ELEMENT_NODE):
				    nm = enum.nodeName
				    if(not enum.hasAttribute('value')):
					print 'ERROR: No Enum value Specified for "' + nm + '"'
					sys.exit(0)
				    val = enum.getAttribute('value')
				    enums.append((nm, val))
			    if(not VARIABLES.has_key(var.nodeName)):
			        VARIABLES[var.nodeName] = enums
				continue
			    else:
			        print 'ERROR: Duplicate Variable "' + var.nodeName + '"'
			        sys.exit(0)
			if(VARIABLES.has_key(var.nodeName)):
			    print 'ERROR: Duplicate Variable "' + var.nodeName + '"'
			    sys.exit(0)
	    		VARIABLES[var.nodeName] = type

	incNodeList = doc.getElementsByTagName('Includes')
	for incNode in incNodeList:
	    inc = incNode.childNodes
	    for i in inc:
		if(i.nodeType == i.ELEMENT_NODE):
	    	        INCLUDES.append(i.nodeName)

	globalNodeList = doc.getElementsByTagName('Globals')
	for globalNode in globalNodeList:
	    glbl = globalNode.childNodes
	    for g in glbl:
		b = ''
		t = ''
		s = ''
		if(g.nodeType == g.ELEMENT_NODE):
		    if(not g.hasAttribute('type')):
			print 'ERROR: No attribute "type(scalar/vector/macro)" specified for "' + g.nodeName + '"'
			sys.exit(0)
		    t = g.getAttribute('type')
		    if(t != 'macro' and not g.hasAttribute('base')):
			print 'ERROR: No attribute "base" specified for "' + g.nodeName + '"'
			sys.exit(0)
		    b = g.getAttribute('base')
		    if(t == 'vector' and not g.hasAttribute('size')):
			print 'ERROR: No attribute "size" specified for Array "' + g.nodeName + '"'
			sys.exit(0)
		    if(t == 'macro' and not g.hasAttribute('value')):
			print 'ERROR: No attribute "value" specified for MACRO "' + g.nodeName + '"'
			sys.exit(0)
		    else:
			if(t == 'vector' and g.hasAttribute('size')):
		            s = g.getAttribute('size')
			if(t == 'macro' and g.hasAttribute('value')):
		            s = g.getAttribute('value')
		    s = string.replace(s, '@', '&')
	    	    GLOBALS.append((g.nodeName, b, t, s))

	funcNodeList = doc.getElementsByTagName('Function')
	for funcNode in funcNodeList:
	   if(not funcNode.hasAttribute("module")):
		print 'ERROR: Missing "module" attribute'
		sys.exit(0)
	   if(not funcNode.hasAttribute("proto")):
		print 'ERROR: Missing "proto" attribute'
		sys.exit(0)
	   md = funcNode.getAttribute('module')
	   proto = funcNode.getAttribute('proto')
	   func = funcNode.firstChild
	   if(func.nodeType == func.TEXT_NODE):
	       FUNCTIONS.append((md, proto, func.data))

	initNodeList = doc.getElementsByTagName('Init')
	for initNode in initNodeList:
	    inits = initNode.firstChild
	    tmp = string.split(inits.data, ';')
	    for func in tmp:
		func = string.strip(func)
		if(not len(func)):
		    continue
	        INITS.append(func)

	enumsNodeList = doc.getElementsByTagName('Enum')
	for enumNode in enumsNodeList:
	    if(not enumNode.hasAttribute("name")):
		print 'ERROR: Missing "name" attribute'
		sys.exit(0)
	    name = enumNode.getAttribute('name')
	    enms = {}
	    enums = enumNode.childNodes
	    for enum in enums:
		if(enum.nodeType == enum.ELEMENT_NODE):
	    	    if(not enum.hasAttribute('value')):
		        print 'ERROR: Missing "value" attribute for name "' + enum.nodeName + '"'
		        sys.exit(0)
		    enms[enum.nodeName] = enum.getAttribute('value')
	    ENUMS[name] = enms
	definesNodeList = doc.getElementsByTagName('Defines')
	for defineNode in definesNodeList:
	    defines = defineNode.childNodes
	    for define in defines:
		if(define.nodeType == define.ELEMENT_NODE):
	    	    if(not define.hasAttribute('value')):
		        print 'ERROR: Missing "value" attribute for name "' + define.nodeName + '"'
		        sys.exit(0)
		    DEFINES.append((define.nodeName, define.getAttribute('value')))

	eventsNodeList = doc.getElementsByTagName('Event')
	for eventNode in eventsNodeList:
	    event = Event()
	    if(eventNode.nodeType == eventNode.ELEMENT_NODE):
    	        if(not eventNode.hasAttribute('name')):
	            print 'ERROR: Missing "name" attribute '
	            sys.exit(0)
		event.name = eventNode.getAttribute('name')
    	        if(not eventNode.hasAttribute('id')):
	            print 'ERROR: Missing "id" attribute '
	            sys.exit(0)
		event.id = eventNode.getAttribute('id')
    	        if(not eventNode.hasAttribute('prio')):
	            print 'ERROR: Missing "prio" attribute '
	            sys.exit(0)
		event.prio = eventNode.getAttribute('prio')
		event.prio = string.strip(event.prio)
		if(event.prio == 'NORMAL' or
		   event.prio == 'MEDIUM' or
		   event.prio == 'HIGH' or
		   event.prio == 'CRITICAL'):
			event.prio = 'EVENT_PRIORITY_' + event.prio
		else:
		    print 'ERROR: Invalid Priority "' + event.prio + '", use (NORMAL, MEDIUM, HIGH, CRITICAL)'
	            sys.exit(0)
	    childs = eventNode.childNodes
	    for child in childs:
		if(not child.nodeType == child.ELEMENT_NODE):
		    continue
		if(child.nodeName == "Params"):
		    params = child.childNodes
		    for param in params:
			if(not param.nodeType == child.ELEMENT_NODE):
			    continue
    	                if(not param.hasAttribute('type')):
	                    print 'ERROR: Missing "type" attribute in "' + param.nodeName + '"'
	                    sys.exit(0)
			nm = param.nodeName
			tp = param.getAttribute('type')
			event.params.append((nm, tp))
		elif(child.nodeName == "Descr"):
	            descr = child.firstChild
	       	    if(descr.nodeType == descr.TEXT_NODE):
		        event.descr = descr.data
		        event.descr = string.strip(descr.data)
	    EVENTS.append(event)

    def genMain(self):
	self.decrIndent()

	self.emit('def usage(txt = \'\'):')
	self.incrIndent()
    	self.emit('args = \'\'')
    	self.emit('args = args + \'-mode [a|g]\'')
    	self.emit('print \'\'')
    	self.emit('print txt')
    	self.emit('print \'ERROR: usage  \' + sys.argv[0] + \' \' + args')
    	self.emit('print \'\'')
    	self.emit('sys.exit(0)')
	self.decrIndent()

    	self.emit(' ')

	self.emit('def text_help():')
	self.incrIndent()
    	self.emit('help = CppuiSeperator1 + CppuiSeperator1 + \'\\n\'')
    	self.emit('help = help + \'ts	- \\t send test script\\n\'')
    	self.emit('help = help + \'delay - \\t Wait "delay" seconds before sending\\n\'')
    	self.emit('help = help + \'ewait - \\t Ask confirmation before sending\\n\'')
    	self.emit('help = help + \'dwait - \\t Don\\\'t confirmation before sending\\n\'')
    	self.emit('help = help + \'elog	- \\t Enable log file\\n\'')
    	self.emit('help = help + \'dlog	- \\t Disable log file\\n\'')
    	self.emit('help = help + \'q    - \\t\\t Quit\\n\'')
    	self.emit('help = help + \'count - \\t set count(test script executed "count" times,'\
						+ ' ("-" execute in loop)\\n\'')
    	self.emit('help = help + CppuiSeperator1 + CppuiSeperator1')
    	self.emit('print help')
	self.decrIndent()
    	self.emit(' ')

	self.emit('def text_mode(host, port):')
	self.incrIndent()
    	self.emit('ui = Cppui(\'ControlPlanePlatformUserInterface(CPPUI)\', 0)')
    	self.emit('ui.host = host')
    	self.emit('ui.port = port')
    	self.emit('print CppuiSeperator1 + CppuiSeperator1')
	self.emit('print \'\\tCPPUI Server (\' + host + \'@\' + `port` + \')\'')
    	self.emit('print CppuiSeperator1 + CppuiSeperator1')
	self.emit('ui.Connect()')
	self.emit('reqresp = ReqResp("Connect", str(CPPDK_CONNECT_REQ))')
        self.emit('ui.Send(reqresp)')
    	self.emit('text_help()')
        self.emit('while(1):')
	self.incrIndent()
	self.emit('sys.stdout.write(\'Test :\')')
	self.emit('ts = sys.stdin.readline()')
	self.emit('ts = string.strip(ts)')
	self.emit('if(ts == \'q\'):')
	self.incrIndent()
    	self.emit('ans = askyesno(\'Quit?\')')
	self.emit('if(ans == 1):')
	self.incrIndent()
	self.emit('reqresp = ReqResp("Disconnect", str(CPPDK_DISCONNECT_REQ))')
        self.emit('ui.Send(reqresp)')
    	self.emit('sys.exit(0)')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
    	self.emit('continue')
	self.decrIndent()
	self.decrIndent()

	self.emit('elif(ts == \'delay\'):')
	self.incrIndent()
	self.emit('sys.stdout.write(\'Seconds:\')')
	self.emit('sec = sys.stdin.readline()')
	self.emit('sec = string.strip(sec)')
	self.emit('try:')
	self.incrIndent()
	self.emit('ui.waitTime = int(sec)')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('showerror(\'Invalid time value "\' + sec + \'"\')')
    	self.emit('continue')
	self.decrIndent()
	self.decrIndent()

	self.emit('elif(ts == \'ewait\'):')
	self.incrIndent()
        self.emit('ui.waitMode = 1')
	self.decrIndent()

	self.emit('elif(ts == \'dwait\'):')
	self.incrIndent()
        self.emit('ui.waitMode = 0')
	self.decrIndent()

	self.emit('elif(ts == \'elog\'):')
	self.incrIndent()
	self.emit('sys.stdout.write(\'Log File:\')')
	self.emit('logf = sys.stdin.readline()')
	self.emit('logf = string.strip(logf)')
	self.emit('try:')
	self.incrIndent()
	self.emit('logf = ui.LOG_DIR + os.sep + logf')
	self.emit('logf = os.path.abspath(logf)')
        self.emit('ui.lf = logf')
        self.emit('ui.logf = open(logf, \'w\')')
        self.emit('ui.log = 1')
    	self.emit('continue')
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('showerror(\'Log Error\')')
    	self.emit('continue')
	self.decrIndent()
	self.decrIndent()

	self.emit('elif(ts == \'dlog\'):')
	self.incrIndent()
	self.emit('ans = askyesno(\'Disable Log\')')
	self.emit('if(ans == 1 and ui.log == 1 and ui.logf != None):')
	self.incrIndent()
        self.emit('ui.lf = ""')
        self.emit('ui.logf.flush()')
        self.emit('ui.logf.flush()')
        self.emit('ui.logf.close()')
        self.emit('ui.logf = None')
        self.emit('ui.log = 0')
	self.decrIndent()
    	self.emit('continue')
	self.decrIndent()

	self.emit('elif(ts == \'count\'):')
	self.incrIndent()
	self.emit('sys.stdout.write(\'Count:\')')
	self.emit('cnt = sys.stdin.readline()')
	self.emit('cnt = string.strip(cnt)')
	self.emit('try:')
	self.incrIndent()
	self.emit('if(cnt != \'-\'):')
	self.incrIndent()
	self.emit('ui.repeatCount = int(cnt)')
    	self.emit('continue')
	self.decrIndent()
	self.emit('else:')
	self.incrIndent()
	self.emit('ui.repeatCount = 11111')
    	self.emit('continue')
	self.decrIndent()
	self.decrIndent()
	self.emit('except:')
	self.incrIndent()
	self.emit('showerror(\'Invalid count value "\' + cnt + \'"\')')
    	self.emit('continue')
	self.decrIndent()
	self.decrIndent()

	self.emit('elif(ts == \'ts\'):')
	self.incrIndent()
	self.emit('sys.stdout.write(\'Test Script:\')')
	self.emit('cf = sys.stdin.readline()')
	self.emit('cf = string.strip(cf)')
    	self.emit('ui.LoadFile(cf)')
    	self.emit('continue')
	self.decrIndent()

	self.emit('else:')
	self.incrIndent()
    	self.emit('text_help()')
	self.decrIndent()
	self.decrIndent() #while

	self.decrIndent()
	self.decrIndent()
    	self.emit(' ')

	self.emit('def showerror(error):')
	self.incrIndent()
	self.emit('print(\'\')')
	self.emit('print(\'ERROR::\\t\\t\' + error)')
	self.emit('print(\'\')')
	self.decrIndent()
    	self.emit(' ')

	self.emit('def askyesno(text, body = \'\'):')
	self.incrIndent()
	self.emit('ans = \'y\'')
	self.emit('sys.stdout.write(text + \'(y/n)[y]:\')')
	self.emit('tmp = sys.stdin.readline()')
	self.emit('tmp = string.strip(tmp)')
	self.emit('if(len(tmp) > 0):')
	self.incrIndent()
	self.emit('ans = tmp')
	self.decrIndent()
	self.emit('if(ans == \'y\'):')
	self.incrIndent()
	self.emit('return(1)')
	self.decrIndent()
	self.emit('return(0)')
	self.decrIndent()
    	self.emit(' ')

        self.emit('if(__name__ == \'__main__\'):')
	self.incrIndent()
    	self.emit('mode = \'\'')
    	self.emit('host = \'localhost\'')
    	self.emit('port = 7890')
    	self.emit('wait = 0')
    	self.emit('count = \'\'')
    	self.emit('argc = 0')
    	self.emit('if(len(sys.argv) < 2):')
	self.incrIndent()
        self.emit('cppui = Cppui(\'ControlPlanePlatformUserInterface(CPPUI)\')')
	self.decrIndent()
    	self.emit('else:')
	self.incrIndent()
    	self.emit('sys.argv.append(\'last\')')
    	self.emit('try:')
	self.incrIndent()
    	self.emit('for arg in sys.argv:')
	self.incrIndent()
        self.emit('argc = argc + 1')
        self.emit('arg = string.strip(arg)')
        self.emit('arg = string.replace(arg, \' \', \'\')')

        self.emit('if(arg == \'-host\'):')
	self.incrIndent()
        self.emit('host = sys.argv[sys.argv.index(arg) + 1]')
	self.decrIndent()

        self.emit('elif(arg == \'-port\'):')
	self.incrIndent()
        self.emit('try:')
	self.incrIndent()
        self.emit('port = int(sys.argv[sys.argv.index(arg) + 1])')
	self.decrIndent()
        self.emit('except:')
	self.incrIndent()
        self.emit('usage(\'Invalid port <\' + sys.argv[sys.argv.index(arg) + 1] + \'>\')')
	self.decrIndent()
	self.decrIndent()

	self.decrIndent()
	self.decrIndent()
        self.emit('except:')
	self.incrIndent()
        self.emit('usage()')
	self.decrIndent()
        self.emit('text_mode(host, port)')
	
    """
    def genServer(self):
	self.genHeader()
	self.genFunctions()
	self.cFile('cppui_input')
	self.emit('')
	self.emit('void process(CppuiRequest *req)')
	self.emit('{')
	self.incrIndent()
	self.emit('NPF_error_t npfRet;')
	self.emit('')
	self.emit('req->type = atol(req->args[0]);')
	self.emit('req->seq = (int)atol(req->args[1]);')

    def genMain(self):
	self.decrIndent()
        self.emit('if(__name__ == \'__main__\'):')
	self.incrIndent()
        self.emit('cppui = Cppui(\'ControlPlanePlatformUserInterface(CPPUI)\')')
	self.decrIndent()
    """
	
    def genServer(self):
	self.genHeader()
	self.genFunctions()
	self.cFile('cppui_input')
	self.emit('')
	self.emit('void process(CppuiRequest *req)')
	self.emit('{')
	self.incrIndent()
	#self.emit('NPF_error_t npfRet;')
	self.emit('')
	self.emit('req->seq = (int)atol(req->args[0]);')
	self.emit('req->type = atol(req->args[1]);')
	self.emit('getTime(&req->reqts);')
	self.emit('switch(req->type)')
	self.emit('{')
	self.incrIndent()

	self.emit('case  CPPDK_CONNECT_REQ : /* CPPUI_CONNECT */')
	self.emit('{')
	self.incrIndent()
	self.emit('onCppuiConnect(req);')
	self.decrIndent()
	self.emit('}')
	self.emit('break;')
	self.emit('case  CPPDK_DISCONNECT_REQ : /* CPPUI_DISCONNECT */')
	self.emit('{')
	self.incrIndent()
	self.emit('onCppuiDisconnect(req);')
	self.decrIndent()
	self.emit('}')
	self.emit('break;')

        self.genProcessRoutine()

	self.cFile('cppui_callback')

	self.emit(' ')
	self.emit('void cppuiCallback(NPF_userContext_t context, '\
			+ 'NPF_correlator_t corr, void *data)')
	self.emit('{')
	self.incrIndent()
        self.emit('#ifdef CPPUI_WAIT_RESP')
        self.emit('uint32_t       len = 0;')
        self.emit('#endif')
	self.emit('CppuiRequest *req = (CppuiRequest *)corr;')
	self.emit('if(req == NULL || req->type == 0) return;')
        self.emit('getTime(&req->respts);')
        self.emit('#ifdef CPPUI_WAIT_RESP')
	self.emit('write(g_pipefds[1], (char *)&len, sizeof(len));')
        self.emit('#endif')

	self.genCppuiCallbackRoutine()
	self.genEventFunctions()

    def genHeader(self):
	print 'Generating HeaderFiles .......'
	for mod in self.modules:
	    self.hFile(mod.file)
	    self.emit('#ifndef __CPPUI_' + string.upper(mod.name) + '_H__') 
	    self.emit('#define __CPPUI_' + string.upper(mod.name) + '_H__') 
	    self.emit(' ')
	    self.emit('#include "cppui.h"')
	    self.emit(' ')
	    #self.emit('NPF_callbackHandle_t ' + string.lower(mod.name) + 'Cbh;')
	    #self.emit('NPF_errorReporting_t ' + string.lower(mod.name) + 'Report;')
	    self.emit(' ')
	    for hdr in mod.header:
		tmp = string.split(hdr, '\n')
		for t in tmp:
		    self.emit(string.strip(t))
	    self.emit(' ')
	    for op in mod.ops:
		if(mod.st.has_key('SELFTEST_' + mod.name + op)):
		    selftest = mod.st['SELFTEST_' + mod.name + op]
		    proto = selftest[0]
		    proto = string.split(proto, ';')[0]
		    self.emit('extern ' + proto + ';')
	    self.emit(' ')
	    for func in FUNCTIONS:
	        module = func[0]
	        name = func[1]
		if(module == mod.name):
		    self.hFile(mod.file)
		    self.emit('extern ' + name + ';')
	    self.emit(' ')
	    self.emit('extern void cppui_' + string.lower(mod.name) + '_message(CppuiRequest *req);')
	    self.emit('extern void cppui_' + string.lower(mod.name) + '_response(CppuiRequest *req, void *data);')
	    self.emit(' ')
	    self.emit('#endif') 

	self.hFile('cppui_common')
	self.emit('#ifndef __CPPUI_COMMON_H__') 
	self.emit('#define __CPPUI_COMMON_H__') 
	self.emit(' ')
	self.emit('#include "cppui.h"')
	self.emit(' ')

     	self.emit(' ')
	for define in DEFINES:
	    self.emit('#define ' + string.upper(define[0]) + '  ' + define[1])
     	self.emit(' ')
	self.emit('typedef enum CppuiEvent')
	self.emit('{')
	self.incrIndent()
	for event in EVENTS:
	    self.emit('CPPUI_EVENT_' + event.id + ',')
	self.emit('CPPUI_EVENT_UNKNOWN')
	self.decrIndent()
	self.emit('};')
     	self.emit(' ')
	for mod in self.modules:
	    if(FLAGS.has_key(mod.name)):
		self.emit('#ifdef ' + FLAGS[mod.name])
	    self.emit('#include "' + mod.file + '.h"')
	    if(FLAGS.has_key(mod.name)):
		self.emit('#endif')
	self.emit(' ')
	for mod in self.modules:
	    if(not len(mod.globals)):
		continue
	    if(FLAGS.has_key(mod.name)):
		self.emit('#ifdef ' + FLAGS[mod.name])
	    for gb in mod.globals:
		tmp = string.split(gb, '\n')
		for t in tmp:
		    self.emit(string.strip(t))
	    if(FLAGS.has_key(mod.name)):
		self.emit('#endif')
	self.emit(' ')
	for event in EVENTS:
	    args = ''
	    for arg in event.params:
		args = args + ' ' + arg[1] + ' ' + arg[0] + ','
		args = string.strip(args)
	    args = args[0:len(args) - 1]
	    self.emit('void cppui_send_' + event.name + '_event(' + args + ');')
	self.emit(' ')
	self.emit('#endif') 

    def genFunctions(self):
	print 'Generating Module defined Function .........'
	self.emit(' ')
	for func in FUNCTIONS:
	    module = func[0]
	    name = func[1]
	    body = func[2]
	    if(not MODULES.has_key(string.lower(module))):
		print ' '
		print 'ERROR: No such module "' + module + '" Reffered in "' + name + '"'
		print ' '
		sys.exit(0)
	    mod = MODULES[string.lower(module)]
	    body = string.replace(body, 'LT', '<')
	    body = string.replace(body, 'GT', '>')
	    body = string.replace(body, '@', '&')
	    self.cFile(mod.file)
	    self.emit(name)
	    self.emit('{')
	    self.emit(body)
	    self.emit('}')
	self.emit(' ')
	for mod in self.modules:
	    if(len(mod.st) > 0):
	        self.cFile(mod.file)
		self.emit(' ')
	    for op in mod.ops:
	        if(mod.st.has_key('SELFTEST_' + mod.name + op)):
		    selftest = mod.st['SELFTEST_' + mod.name + op]
		    func = selftest[0]
		    func = string.strip(func)
		    func = string.split(func, ';')[0]
		    self.emit(' ')
		    body = selftest[1]
	            self.emit(func)
	            self.emit('{')
	    	    body = string.replace(body, 'LT', '<')
	    	    body = string.replace(body, 'GT', '>')
	    	    body = string.replace(body, '@', '&')
		    self.emit(body)
	            self.emit('}')
		    self.emit(' ')

    def genCppuiCallbackRoutine(self):
	print 'Generating Callback Routine ....................'
	self.emit('switch(req->type)')
	self.emit('{')
	self.incrIndent()
	for mod in self.modules:
	    if(not len(mod.ids)):
		continue
	    if(FLAGS.has_key(mod.name)):
		self.emit('#ifdef ' + FLAGS[mod.name])
	    for id in mod.ids:
	        self.emit('case ' + id + ':')
	    self.emit('{')
	    self.incrIndent()
	    self.emit( 'cppui_' + string.lower(mod.name) + '_response(req, data);')
	    self.decrIndent()
	    self.emit('}')
	    self.emit('break;')
	    if(FLAGS.has_key(mod.name)):
		self.emit('#endif')
	self.decrIndent()
	self.emit('}')
	self.decrIndent()
	self.emit('}')

	for mod in self.modules:
	    if(not len(mod.ids)):
		continue
	    self.cFile(mod.file)
	    self.emit('void cppui_' + string.lower(mod.name) + '_response(CppuiRequest *req, void *data)')
	    self.emit('{')
	    self.incrIndent()
	    self.emit('switch(req->type)')
	    self.emit('{')
	    self.incrIndent()
	    for op in mod.ops:
		if(op == 'ADD_SEPARATOR'):
		    continue
		o = mod.name + op
		case = CID['CID_' + o]

		key = o + 'RespType'
	    	type = mod.responses[key]
		if(type != 'async'):
		    continue

		self.emit('case ' + case + ': /*' + o + ' */')
		self.emit('{')
		self.incrIndent()
		key = o + 'CallbackData'
		if(not mod.responses.has_key(key)):
		    print 'ERROR: CallbackData type not specified for "' + o + '"'
		    sys.exit(0)
		cb = mod.responses[key]
		self.emit(cb + ' *cbdata = (' + cb + '*)data;')
		key = o + 'Format'
		if(not mod.responses.has_key(key)):
		    print 'ERROR: No Format function found for "' + o + '"'
		    sys.exit(0)
		self.emit('req->error = ' + mod.responses[key] + '(' + case + ', cbdata, req->resp);')
		self.emit('sendResponse(req);')
		self.decrIndent()
		self.emit('}')
		self.emit('break;')

	    self.decrIndent()
	    self.emit('} /*switch(req->type) */') 

	    self.decrIndent()
	    self.emit('}')

    def genProcessRoutine(self):
	print 'Generating Process Routine ....................'
	for mod in self.modules:
	    if(not len(mod.ids)):
		continue
	    self.emit('')
	    if(FLAGS.has_key(mod.name)):
	        self.emit('#ifdef ' + FLAGS[mod.name])
	    for id in mod.ids:
	        self.emit('case ' + id + ':')
	    self.emit('{')
	    self.incrIndent()
	    self.emit('cppui_' + string.lower(mod.name) + '_message(req);')
	    self.decrIndent()
	    self.emit('}')
	    self.emit('break;')
	    if(FLAGS.has_key(mod.name)):
	        self.emit('#endif')
	    self.emit('')

	self.emit('default:')
	self.emit('{')
	self.incrIndent()
	self.emit('req->error = 1;')
	self.emit('sprintf(req->resp, "Unknown Message(%d) \\n", req->type);')
	self.emit('sendResponse(req);')
	self.decrIndent()
	self.emit('}')
	self.emit('break;')

	self.decrIndent()
	self.emit('}/*switch(type)*/')
	self.decrIndent()
	self.emit('}/* process */')
	self.decrIndent()
	self.decrIndent()
	self.decrIndent()

	for mod in self.modules:
	    if(not len(mod.ids)):
		continue
	    self.cFile(mod.file)
	    self.emit('void cppui_' + string.lower(mod.name) + '_message(CppuiRequest *req)')
	    self.emit('{')
	    self.incrIndent()
	    self.emit('switch(req->type)')
	    self.emit('{')
	    self.incrIndent()
	    for op in mod.ops:
		selftest = None
		if(mod.st.has_key('SELFTEST_' + mod.name + op)):
		    selftest = mod.st['SELFTEST_' + mod.name + op]
		if(op == 'ADD_SEPARATOR'):
		    continue
		o = mod.name + op
		case = CID['CID_' + o]
		npfApi = ''
		if(not mod.args.has_key('API_' + o)):
		   print 'No API found for: '  + o
		   sys.exit(0)
		npfApi = mod.args['API_' + o]
		self.emit('case ' + case + ': /*' + o + ' */')
		self.emit('{')
		self.incrIndent()
		varsDict = {}
		args = mod.args[op]
		if(mod.vars.has_key('API_' + o)):
		    vars = mod.vars['API_' + o]
		    for var in vars:
			var = string.replace(var, '*', '')
			varsDict[var] = var
			if(not VARIABLES.has_key(var)):
			    sys.exit('ERROR: No variable "' + var + '" defined for "' \
						+ mod.name + '->' + op + '"')
			    sys.exit(0)
			type = VARIABLES[var]
			if(type == 'MACRO' or type == 'none'):
			    continue
			if(type != 'MACRO'):
			    self.emit(type + ' ' + var + ';')
		self.emit('')
	        self.emit('NPF_error_t ret = 1;')
		self.emit('')
		if(selftest):
	            self.emit('int selftest = 0;')
		self.emit('')
		argCount = 2
		for arg in args:
		    key = mod.name + op + arg
		    to = mod.assigns[key]
		    if(not mod.internals.has_key(key)): #Check for not internal argument
			tmp = string.replace(to, '[', '.')
			tmp = string.split(tmp, '.')[0]
		        if(not varsDict.has_key(tmp)):
			    print 'ERROR: Extra Argument "' + arg + '" for ' + mod.name + '->' + op
			    sys.exit(0)
		    tp = mod.types[key]
		    tp = string.split(tp, ':')[0]
		    tp = string.replace(tp, 'e', 'd')
		    if(not VARIABLES.has_key(tp)):
			print 'ERROR: No type "' + tp + '" defined in ' + mod.name + '->' + op + '->' + arg
			sys.exit(0)
		    tp = VARIABLES[tp]
		    gb = ''
		    extra = ''
		    if(mod.getf.has_key(key)):
		        gb = mod.getf[key]
			gb = string.replace(gb, ')', '')
			gb = string.replace(gb, ';', '')
			tmp1 = string.split(gb, '(')
			if(len(tmp1) > 1): # User Specified extra args
			    gb = tmp1[0]
			    extra = tmp1[1]
			    extra = string.replace(extra, ')', '')
			    extra = string.replace(extra, '*', '&')
		    elif(tp == 'int' or tp =='char'):
			gb = 'atol'
		    else:
			gb = ''
		    if(len(extra)):
			extra = ', ' + extra
		        self.emit(gb + '(req->args['  + str(argCount) + ']' + extra + '); /*' + arg + '*/')
		    else:
		        self.emit(to + ' = (' + tp + ' )' + gb + '(req->args['  + str(argCount) + ']' + extra + '); /*' + arg + '*/')
		    argCount = argCount + 1
		if(selftest):
		    self.emit('selftest = (int)atol(req->args['  + str(argCount) + ']);')

		arrayInput = npfApi + '_SelfTest('
		pt = npfApi + '_SelfTest('
		pt = 'int ' + npfApi + '_SelfTest('
		count = 1
		for var in vars:
		    tvar = var
		    tvar = string.replace(tvar, ' ', '')
		    type = ''
		    if(VARIABLES.has_key(string.replace(tvar, '*', ''))):
		        type = VARIABLES[string.replace(tvar, '*', '')]
		    else:
			print 'NO Type Found for	: ' + var

		    if(type == 'MACRO'):
			    continue
		    if(len(string.split(var, '*')) < 2):
		        type = type + '*'
		
		    if(len(string.split(var, '*')) >1):
		        var = string.replace(var, "*", "&")
		    else:
			var = '&' + var
		    arrayInput = arrayInput + var + ', '
		    pt = pt + type + ' ' + tvar +', '
		    count = count + 1
		arrayInput = string.strip(arrayInput)
		pt = string.strip(pt)
		arrayInput = arrayInput[:len(arrayInput) -1]
		pt = pt[:len(pt) -1]
		arrayInput = arrayInput + ', req);'
		pt = pt + ', void *corr);'
		if(selftest):
		    try:
		        proto = selftest[0]
		        proto = string.replace(proto, ';', '')
		        #Actuals
		        nma = string.split(proto, '(')[0]
		        nma = string.strip(nma)
		        nma = string.split(nma)[0] + ' ' + string.split(nma)[1]
		        vsa = string.split(proto, '(')[1]
		        vsa = vsa[:len(vsa) -1]
		        vsa = string.split(vsa, ',')

		        #Expected
		        nme = string.replace(pt, ';', '')
		        nme = string.split(nme, '(')[0]
		        nme = string.strip(nme)
		        vse = string.split(pt, '(')[1]
		        vse = string.split(vse, ')')[0]
		        vse = string.split(vse, ',')

			if(nme != nma):
		            print 'ERROR: Invalid SelfTest Function Name for "' + op + '"'
		            print 'Found: "' + nma + "'"
		            print 'Expected: "' + nme + '"'
			    sys.exit(0)
			ok = 1
			tmp1 = [] 
			tmp2 = [] 

			for v in vse:
			    v = string.strip(v)
			    tv = string.split(v, '*')
			    if(len(tv) > 1):
			        v = string.strip(tv[0]) + '* ' + string.strip(tv[1])
			    tmp1.append(v)

			for v in vsa:
			    v = string.strip(v)
			    tv = string.split(v, '*')
			    if(len(tv) > 1):
			        v = string.strip(tv[0]) + '* ' + string.strip(tv[1])
			    tmp2.append(v)
			count = 0
			for t in tmp1:
			    if(string.split(t)[0] != string.split(tmp2[count])[0]): #Check for Types
		                print 'ERROR: Invalid SelfTest Parameter "' + op + '"'
		                print 'Found: ' + tmp2[count]
		                print 'Expected: ' + t
			        sys.exit(0)
			    count = count + 1
		    except:
		        print 'ERROR: Invalid SelfTest prototype for "' + op + '"'
		        print 'Found: ' + proto
		        print 'Expected: ' + pt
			sys.exit(0)

		if(selftest):
		    self.emit(' ')
		    self.emit('if(selftest)')
		    self.incrIndent()
		    self.emit('ret = ' + arrayInput)
		    self.decrIndent()
		    self.emit('else')
		count = 1
		npfApi = 'ret = ' + npfApi + '('
		for var in vars:
		    var = string.strip(var)
		    if(var == 'none'):
			npfApi = npfApi + '('
			continue
		    var = string.replace(var, "*", "&")
		    npfApi = npfApi + var + ', '
		npfApi = string.strip(npfApi)
		npfApi = npfApi[:len(npfApi) -1]
		npfApi = npfApi + ');'
		if(selftest):
		    self.incrIndent()
		    self.emit(npfApi)
		    self.decrIndent()
		else:
		    self.emit(npfApi)
		self.emit('')

		key = o + 'RespType'
	    	type = mod.responses[key]
		fk = o + 'Format'

		if(type == 'sync'):
		    self.emit('')
		    if(mod.responses.has_key(fk)):
	    		fmt = mod.responses[fk]
        	        self.emit('req->error = ' +  fmt+ '(' + case + ', ret, req->resp);')
		    else:
        	        self.emit('req->error = 0;')
        	        self.emit('sprintf(req->resp, "' + o + '");')
		    self.emit('getTime(&req->respts);')
        	    self.emit('sendResponse(req);')
		    self.emit('')
		else:
		    self.emit('if(ret == NPF_NO_ERROR)')
		    self.emit('{')
		    self.incrIndent()
		    self.emit('#ifdef CPPUI_WAIT_RESP')
		    self.emit('waitAsyncResponse(req);')
		    self.emit('#endif')
		    self.decrIndent()
		    self.emit('}')
		    self.emit('else')
		    self.emit('{')
		    self.incrIndent()
        	    self.emit('req->error = ret;')
        	    self.emit('sprintf(req->resp, "%s", "Command Rejected");')
        	    self.emit('sendResponse(req);')
		    self.decrIndent()
		    self.emit('}')

		self.decrIndent()
		self.emit('}')
		self.emit('break;')
	    self.decrIndent()
	    self.emit('}')

	    self.decrIndent()
	    self.emit('}')

    def genEventFunctions(self):
	print 'Generation Events Functions...................'
	self.cFile('cppui_callback')
	self.emit('')
	for event in EVENTS:
	    args = ''
	    for arg in event.params:
		args = args + arg[1] + ' ' + arg[0] + ','
	    args = string.strip(args)
	    args = args[0:len(args) -1]
	    self.emit('void cppui_send_' + event.name + '_event(' + args + ')')
	    self.emit('{')
	    self.incrIndent()
	    self.emit('char	event[MAX_MSG_SIZE];')
	    self.emit('int	pos = 0;')
	    self.emit('pos += sprintf(&event[pos], "Event Begin#");')
	    self.emit('pos += sprintf(&event[pos], "%d;", CPPDK_EVENT);')
	    self.emit('pos += sprintf(&event[pos], "%d;", CPPUI_EVENT_' + event.id + ');')
	    self.emit('pos += sprintf(&event[pos], "%d;", ' + event.prio + ');')
	    self.emit('pos += sprintf(&event[pos], "%s;", ' + event.descr + ');')
	    for arg in event.params:
		type = arg[1]
		type = string.strip(type)
		type = string.replace(type, " ", "")
		par = arg[0]
		if(type == "int"):
	            self.emit('pos += sprintf(&event[pos], "%d;", ' + par + ');')
		elif(type == "char*"):
	            self.emit('pos += sprintf(&event[pos], "%s;", ' + par + ');')
		else:
		    print 'ERROR: In Event "' + event.name + '"Parameter type "' + type + '" Not supported'
		    sys.exit(0)
	    self.emit('pos += sprintf(&event[pos], "#Event End");')
	    self.emit('sendEvent(event);')
	    self.decrIndent()
	    self.emit('}')
	    self.emit('')




if(__name__ == '__main__'):
    if(len(sys.argv) < 2):
	print 'ERROR: please specify XML input file'
	sys.exit(0)
    root = string.strip(sys.argv[1])
    root = string.replace(root, '\\r', '')
    file = open(root)
    xmls = file.readlines()
    file.close()
    generator = Generator(xmls)
