   /**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2002-2003 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2400 Network Processor, Release 5
 *
 * = LIBRARY
 *      
 *
 * = MODULE
 *      FP Module Core Component
 *
 * = FILENAME
 *      ix_cc_fpm_common.h
 *
 * = DESCRIPTION
 *      This file defines common data structures that are shared between
 *      ingress and egress. This is required because the FP Module requires
 *      some of the structures defined by the egress components like Ethernet 
 *      Tx, ARP module, L2 Table Manager, etc. These components are not included
 *      in the egress build. Hence this file simply defines the structures 
 *      required by the FPModule. 
 *
 * = AUTHOR
 *       Rajeev Muralidhar
 *       Rajeev.D.Muralidhar@intel.com
 *
 * = AKNOWLEDGEMENTS
 *      
 *
 * = CREATION TIME
 *      12/28/2002
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 * $Id: ix_cc_fpm_common.h,v 1.6 2003/11/17 16:57:57 mjuneja Exp $
 */

#if !defined(__IX_CC_FPM_COMMON_H__)
#define __IX_CC_FPM_COMMON_H__

#include "ix_cc_error.h"
#include <stdio.h>
#include <string.h>
#include "ix_ossl.h"
#include "ix_rm.h"
#include "ix_cc.h"

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


/*****************************************************************
 *            L2 Table Manager Exports
 *****************************************************************/

#if !defined(__IX_CC_L2TM_H__)

typedef enum ix_e_cc_l2tm_ipaddr_type ix_cc_l2tm_ipaddr_type;
typedef enum ix_e_cc_l2tm_l2addr_type ix_cc_l2tm_l2addr_type;
typedef struct ix_s_cc_l2tm_atm_header ix_cc_l2tm_atm_header;
typedef struct ix_s_cc_l2tm_ether_header ix_cc_l2tm_ether_header;
typedef union ix_u_cc_l2tm_ipaddr ix_cc_l2tm_ipaddr;
typedef struct ix_s_cc_l2tm_entry ix_cc_l2tm_entry;

#endif /* If L2tm file is not included */



#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__IX_CC_FPM_H__) */
