/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/inc/fpp_common.h,v $
 * $Revision: 1.6 $
 * $Date: 2003/11/17 16:57:59 $
 *
 *
 ****************************************************************************/

#ifndef _FPP_COMMON_H_
#define _FPP_COMMON_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _VXWORKS_
#include <unistd.h>
#else
#include <stdint.h>
#endif

#include "list.h"
#include "npf_ipv4_types.h"
#include "pdk_callback.h"

#define FPPI_INVALID_CBTYPE	10000
#define FPPI_INVALID_CBID	10000
#define FEID_INIT_VALUE		0
#define MAX_NO_FES		10
#define FPPI_MAX_NAME_LEN           256

/* Used to separate the fename from the feid when the FP binds
   to the CP - COPS only. */
#define g_pdk_feidNameSeparator  ":feid="

typedef enum {	FPPI_SUCCESS,
		FPPI_FAIL,
		FPPI_INVALID_PARAMETERS,
		FPPI_OUT_OF_MEMORY,
		FPPI_DUPLICATE_CONTEXT,
		FPPI_NOT_INITIALIZED } FPPI_RET;

typedef enum {	FPPI_SUCCESSFUL,
		FPPI_FAILURE } FPPI_Status;

/* Helper for transport plugin encap and decap */
typedef enum {
        ds_Action,
        ds_Property,
        ds_Param,
        ds_Param1
} ds_PropActionParamTYPE;

/* Put here temporarily until perm home for NPF_ types is found */
typedef uint32_t	NPF_MTU;

typedef uint32_t	FPPI_FEID;
typedef uint32_t	FPPI_NHID;
typedef uint32_t	FPPI_L2ID;
typedef uint32_t	FPPI_PortID;
typedef uint32_t	FPPI_CBHANDLE;
typedef void*		FPPI_CONTEXT;
typedef void*		FPPI_CORRELATOR;
typedef uint32_t	FPPI_CBCORRELATOR;

typedef void (*fppapi_callback) (
        FPPI_FEID       feid,
        FPPI_CORRELATOR correlator,
        FPPI_CONTEXT    context,
        void            *response_data);

typedef void (*backendapi_callback) (
        FPPI_CBCORRELATOR       cbcorrelator,
        FPPI_CONTEXT            context,
        void                    *response_data);


/* FPPI Config and Query Commands */

/* fppi private commands */
#define FPPI_QUERY_FECAPS                       101

/* fppi ipv4 commands */
#define FPPI_CONFIG_IPV4_NHOP_ADD               200
#define FPPI_CONFIG_IPV4_UNICAST_ROUTE_ADD      201
#define FPPI_CONFIG_IPV4_UNICAST_ROUTE_DEL      202

/* Event Types */
#define FORCES_EVENT_PORT_DOWN                  500
#define FORCES_EVENT_PORT_UP                    501
#define FORCES_EVENT_PACKET_REDIRECT            502
#define FORCES_EVENT_ARPENTRY_ADD               503
#define FORCES_EVENT_ARPENTRY_DEL               504
#define FORCES_EVENT_CE_READY                   505

/* for ATM EVENTS */
#define FORCES_EVENT_ATM_OAM_AIS_ALARM          506
#define FORCES_EVENT_ATM_OAM_RDI_ALARM          507
#define FORCES_EVENT_ATM_OAM_LB                 508 
#define FORCES_EVENT_ATM_OAM_FPM_STATS          509 
#define FORCES_EVENT_ATM_OAM_BR_STATS           510 
#define FORCES_EVENT_ATM_VCC_UP_EVENT           511 
#define FORCES_EVENT_ATM_VCC_DOWN_EVENT         512

#define FORCES_EVENT_DIRECT_CONNECTED_HOST      514 

/* Reserved Next Hop Id limits. Reserved values are used between FPModule
   and SDK
*/
#define MAX_NHID                                0xF0
#define MAX_RESERVED_NHID                       0xE0

#ifdef __cplusplus
}
#endif

#endif /* _FPP_COMMON_H_ */

