/*****************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *****************************************************************************/

/* This header file defines typedefs, constants, and functions*/
/* that apply to all NPF Software Working group APIs. */

#ifndef __NPF_H__
#define __NPF_H__

#ifdef __cplusplus
extern "C" {
#endif

#define   NPF_IN
#define   NPF_OUT
#define   NPF_IN_OUT

/* This section defines base NPF types and will differ from */
/* platform to platform. The type shown here are based on */
/* Linux 6.2 on an x86. */

typedef    char                        NPF_char8_t;
typedef    unsigned char               NPF_uchar8_t;
typedef    char                        NPF_int8_t;
typedef    short                       NPF_int16_t;
typedef    int                         NPF_int32_t;
typedef    long long int               NPF_int64_t;
typedef    unsigned char               NPF_uint8_t;
typedef    unsigned short              NPF_uint16_t;
typedef    unsigned int                NPF_uint32_t;
typedef    unsigned long long int      NPF_uint64_t;
typedef    float                       NPF_float32_t;
typedef    long double                 NPF_float64_t;

/* This section defines constructed NPF types and is */
/* identical for all implementations of the NPF APIs. */
typedef    NPF_uint32_t      NPF_error_t;
typedef    NPF_uint32_t      NPF_callbackHandle_t;
typedef    NPF_uint32_t      NPF_correlator_t;
typedef    NPF_uint32_t      NPF_userContext_t;
typedef    enum NPF_boolean {NPF_FALSE = 0, NPF_TRUE = 1} NPF_boolean_t;
typedef    NPF_uint32_t      NPF_IPv4Address_t;
typedef    NPF_uint32_t      NPF_IPv6Address_t[4];
typedef    NPF_uchar8_t      NPF_MAC_Address_t[6];
typedef    enum NPF_errorReporting {
        NPF_REPORT_ALL = 1,
        NPF_REPORT_NONE = 2,
        NPF_REPORT_ERRORS = 3
} NPF_errorReporting_t;

#define NPF_NO_ERROR 0
#define NPF_FOUNDATIONS_BASE_ERR 1
#define NPF_FOUNDATIONS_MAX_ERR (NPF_FOUNDATIONS_BASE_ERR + 98)

#define NPF_E_UNKNOWN                      NPF_FOUNDATIONS_BASE_ERR
#define NPF_E_BAD_CALLBACK_HANDLE          (NPF_FOUNDATIONS_BASE_ERR + 1)
#define NPF_E_BAD_CALLBACK_FUNCTION        (NPF_FOUNDATIONS_BASE_ERR + 2)
#define NPF_E_CALLBACK_ALREADY_REGISTERED  (NPF_FOUNDATIONS_BASE_ERR + 3)

#ifdef __cplusplus
}
#endif

#endif  /* __NPF_H__ */
