/*****************************************************************************
*                  INTEL CORPORATION PROPRIETARY INFORMATION
*  This software is supplied under the terms of a license agreement or
*  nondisclosure agreement with Intel Corporation and may not be copied
*  or disclosed except in accordance with the terms of that agreement.
*  Copyright (c) 2001 Intel Corporation. All Rights Reserved.
*****************************************************************************/

/*****************************************************************************
* $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/npf_api/npf_cm_api.h,v $
* $Revision: 1.6 $
* $Date: 2003/11/17 16:58:00 $
*
* Description:
*    These are external C&M  APIs
*
*****************************************************************************/

#ifndef _NPF_CM_API_H_
#define _NPF_CM_API_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "npf_common.h"
#include "npf_cm_types.h"
#include "pdk_callback.h"

/* ------------------------- Category Callback ---------------------------- */
extern NPF_RET npf_category_register(	NPF_CBCAT,
					NPF_USERCONTEXT,
					NPF_GENERAL_CBFUNC,
					NPF_CBHANDLE*	);
					
extern NPF_RET npf_category_deregister(	NPF_CBHANDLE	);


/* ------------------------ FE Event Callback ---------------------------- */
#define npf_fe_event_register(context, func, cbhandle) \
 npf_category_register(NPF_EVT_FE, context,(NPF_GENERAL_CBFUNC)func,cbhandle)
    
#define npf_fe_event_deregister(cbhandle) npf_category_deregister(cbhandle)

/* ------------------------ PORT Event Callback ---------------------------- */
#define npf_port_event_register(context, func, cbhandle) \
 npf_category_register(NPF_EVT_PORT,context,(NPF_GENERAL_CBFUNC)func,cbhandle)

#define npf_port_event_deregister(cbhandle) npf_category_deregister(cbhandle)

/* ------------------------ If Event Callback ---------------------------- */
#define npf_if_event_register(context, func, cbhandle) \
 npf_category_register(NPF_EVT_IF, context,(NPF_GENERAL_CBFUNC)func,cbhandle)

#define npf_if_event_deregister(cbhandle) npf_category_deregister(cbhandle)


/*-------------- Function to query FE Capabilities-------------------------- */
extern NPF_RET npf_fe_get_capabilities(uint32_t           feId,
                                       NPF_FeCapability_t **feCaps);

#ifdef __cplusplus
}
#endif

#endif /* _NPF_CM_API_H_ */
