/****************************************************************************
 *             INTEL CORPORATION PROPRIETARY INFORMATION
 *  This software is supplied under the terms of a license agreement or
 *  nondisclosure agreement with Intel Corporation and may not be copied
 *  or disclosed except in accordance with the terms of that agreement.
 *      Copyright (c) 2001 Intel Corporation. All Rights Reserved.
 *
 * $Source: /cvs/constellations/ixa_3.0/src/cp_pdk/npf_api/npf_ds_api.h,v $
 * $Revision: 1.5 $
 * $Date: 2003/11/17 16:58:00 $
 *
 * Description:
 * This file defines the external API which applications use to access 
 * DiffServ functionality.
 *
 ****************************************************************************/

#ifndef _NPF_DS_API_H_
#define _NPF_DS_API_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "npf_ds_types.h"

NPF_error_t NPF_DS_Register (
            NPF_IN    NPF_userContext_t      context,
            NPF_IN    NPF_DS_CallbackFunc_t  callback,
            NPF_OUT   NPF_callbackHandle_t   *cbhandle);

NPF_error_t NPF_DS_Deregister (
            NPF_IN    NPF_callbackHandle_t cbhandle);


NPF_error_t NPF_DS_ClassifierEntryAdd(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_Direction_t	dir,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_BaseFilter_t	*clfr,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_ClassifierEntryModify(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_BaseFilter_t	*clfr,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_ClassifierEntryDel(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_MarkerEntryAdd(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_Direction_t	dir,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Action_t		*marker,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_MarkerEntryModify(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Action_t		*marker,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_MarkerEntryDel(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_MeterEntryAdd(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_Direction_t	dir,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Meter_t		*meter,
	    NPF_IN    NPF_DS_TableId_t		succeednexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	succeednextinstid);

NPF_error_t NPF_DS_MeterEntryModify(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Meter_t		*meter,
	    NPF_IN    NPF_DS_TableId_t		succeednexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	succeednextinstid);

NPF_error_t NPF_DS_MeterEntryDel(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_AlgoDropperEntryAdd(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_Direction_t	dir,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_AlgDrop_t		*dropper,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_AlgoDropperEntryModify(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_AlgDrop_t		*dropper,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_AlgoDropperEntryDel(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_QueueEntryAdd(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_Direction_t	dir,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Q_t		*queue,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_QueueEntryModify(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Q_t		*queue,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_QueueEntryDel(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_SchedulerEntryAdd(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_Direction_t	dir,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Scheduler_t	*scheduler,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_SchedulerEntryModify(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid,
	    NPF_IN    NPF_DS_Scheduler_t	*scheduler,
	    NPF_IN    NPF_DS_TableId_t		nexttableid,
	    NPF_IN    NPF_DS_InstanceId_t	nextinstid);

NPF_error_t NPF_DS_SchedulerEntryDel(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_CapabilityQuery(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface);

NPF_error_t NPF_DS_ClassifierStatisticsGet(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_MeterStatisticsGet(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_MarkerStatisticsGet(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_DropperStatisticsGet(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_QueueStatisticsGet(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

NPF_error_t NPF_DS_SchedulerStatisticsGet(
	    NPF_IN    NPF_callbackHandle_t	cbhandle,
	    NPF_IN    NPF_correlator_t		correlator,
	    NPF_IN    NPF_errorReporting_t 	errorReporting,
	    NPF_IN    NPF_IfHandle_t		interface,
	    NPF_IN    NPF_DS_TableId_t	        tableid,
	    NPF_IN    NPF_DS_InstanceId_t	instid);

#ifdef __cplusplus
}
#endif

#endif /* _NPF_DS_API_H_ */

