/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation.All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor, Release 5
 *
 * = FILENAME
 *      cci_main.h
 *
 * = DESCRIPTION
 *      Contains the public APIs for initializing and terminating the core
 *      component infrastructure.
 *
 * = AUTHOR
 *       Roland Arajs
 *       roland.arajs@intel.com
 *
 * = CHANGE HISTORY
 *      4/8/2002 11:28:15 AM - creation time
 *
 * ============================================================================
 * $Id: cci_main.h,v 1.3 2002/09/27 17:44:11 rlarajs Exp $
 */

#if !defined(__CCI_MAIN_H__)
#define __CCI_MAIN_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

/**
 * NAME: ix_cci_init
 *
 * DESCRIPTION: Initializes the resource manager and core component 
 *				infrastructure   
 * 
 *
 * @Return: IX_SUCCESS if successful or an ix_error token encapsulating one of 
 *          the following error codes:
 *              IX_CCI_ERR_INIT_ERR_LOG unable to initialize error-message log
 *              IX_CCI_ERR_SHARED_MEM_ALLOC unable to allocate shared memory 
 *                  needed by the CCI
 *              IX_CCI_ERR_GLOB_SEMA_INIT unable to initialize the global CCI 
 *                  semaphore
 *              IX_CCI_ERR_PROPERTY_CREATE error creating Resource Manager 
 *                  properties
 *              IX_CCI_ERR_PROPERTY_SET error setting a property
 */
IX_EXPORT_FUNCTION
ix_error ix_cci_init( void );


/**
 * NAME: ix_cci_fini
 *
 * DESCRIPTION: Terminates the resource manager and core component 
 *				infrastructure   
 * 
 *
 * @Return: IX_SUCCESS if successful or an ix_error token from Resource Manager 
 *          or OSSL when trying to free a resource.
 */
IX_EXPORT_FUNCTION 
ix_error ix_cci_fini( void );




#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__CCI_MAIN_H__) */
