/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation.All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor, Release 5
 *
 * = FILENAME
 *      cci_types.h
 *
 * = DESCRIPTION
 *      Typedefs used by core component infrastructure
 *      
 * = AUTHOR
 *       Roland Arajs
 *       roland.arajs@intel.com
 *
 * = CHANGE HISTORY
 *      4/8/2002 10:55:17 AM - Creation time
 *
 * ============================================================================
 * $Id: cci_types.h,v 1.5 2003/09/08 21:58:09 ageorges Exp $
 */
#if !defined(__CCI_TYPES_H__)
#define __CCI_TYPES_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


#include "ix_types.h"

typedef ix_handle           ix_tk_handle;
typedef ix_tk_handle        ix_exe_handle;
typedef ix_exe_handle       ix_policy_handle;
typedef ix_exe_handle       ix_cc_handle;
typedef ix_policy_handle    ix_msg_handle;
typedef ix_policy_handle    ix_pkt_handle;
typedef ix_tk_handle        ix_event_handle;

/* Extensions for multi-instanced core components */
typedef struct ix_s_generic_context
{
    /* The handle holds info on the CC instance */
    ix_cc_handle hCC;
} ix_generic_context;


#define IX_CC_INSTANCE_LSB      27
#define IX_CC_INSTANCE_MSB      28

#define IX_CC_INSTANCE_MAX      ((1 << (IX_CC_INSTANCE_MSB + 1 - IX_CC_INSTANCE_LSB)) - 1)

#define IX_CC_INSTANCE_MASK     ((1 << (IX_CC_INSTANCE_MSB + 1 - IX_CC_INSTANCE_LSB)) - 1)

#define IX_CC_ID_MASK           ((1 << IX_CC_INSTANCE_LSB) - 1)

#define IX_INSTANCE_TO_EXTENDED_ID( ix_cc_id, ix_cc_instance )        \
        ( (unsigned) ( (ix_cc_id) | ( (ix_cc_instance) << IX_CC_INSTANCE_LSB ) ) )

#define IX_EXTENDED_ID_TO_INSTANCE( ix_cc_extended_id ) \
        ( ( ix_cc_extended_id >> IX_CC_INSTANCE_LSB ) & IX_CC_INSTANCE_MASK )

#define IX_EXTENDED_ID_TO_ID( ix_cc_extended_id ) \
        ( ix_cc_extended_id & IX_CC_ID_MASK )

#define IX_INSTANCE_TO_HANDLE( ix_cc_handle, ix_cc_instance )        \
        ( ix_cc_handle | ( ix_cc_instance << IX_CC_INSTANCE_LSB ) )

#define IX_HANDLE_TO_INSTANCE( ix_cc_handle )        \
        ( ( ix_cc_handle >> IX_CC_INSTANCE_LSB ) & IX_CC_INSTANCE_MASK )


#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__CCI_TYPES_H__) */
