/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation.All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor, Release 5
 *
 * = FILENAME
 *      internal_cc.h
 *
 * = DESCRIPTION
 *      Defines the core component structure used internally by the CCI. This
 *      structure is not public because the CCI portion of a core component
 *      is accessed via handles.
 *
 * = AUTHOR
 *       Roland Arajs
 *       roland.arajs@intel.com
 *
 * = CHANGE HISTORY
 *      4/26/2002 9:23:03 AM -creation time
 *
 * ============================================================================
 * $Id: internal_cc.h,v 1.3 2002/09/18 17:15:37 lbmiller Exp $
 */

#if !defined(__INTERNAL_CC_H__)
#define __INTERNAL_CC_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


#include "cci/cc.h"


/**
 * TYPENAME: ix_cc_node
 * 
 * DESCRIPTION: Stores core component information. 
 *
 */
typedef struct ix_s_cc_node
{
    ix_cc_fini              pFiniFunc;
    void*                   pUserContext;
    struct ix_s_cc_node*    pNext;
    ix_uint32               vIsUserInitComplete;
} ix_cc_node;



#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__INTERNAL_CC_H__) */
