/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      ix_rm.h
 *
 * = DESCRIPTION
 *      This file will include all the header files required for using Resource Manager 
 *      library.
 *
 * = AUTHOR
 *      Adrian Georgescu
 *      adrian.georgescu@intel.com
 *
 * = CHANGE HISTORY
 *      4/22/2002 4:11:34 PM - creation time 
 * ============================================================================
 * $Id: ix_rm.h,v 1.16 2003/10/30 23:51:21 ageorges Exp $
 */

#if !defined(__IX_RM_H__)
#define __IX_RM_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#include "ix_os_type.h"
#include "ix_symbols.h"
#include "ix_hardware_configuration.h"

#include "ix_types.h"
#include "ix_macros.h"
#include "ix_error.h"

#include "rm/symbols.h"
#include "rm/system.h"
#include "rm/sync_mechanism.h"
#include "rm/memory.h"

#if (_IX_HARDWARE_TYPE_ != _IX_HW_WESTPORT_)

#include "rm/buffer.h"
#include "rm/hardware.h"
#include "rm/communication.h"
#include "rm/remote_communication.h"
#include "rm/microengine.h"
#include "rm/configuration_property.h"
#include "rm/counter_64bit.h"
#include "rm/atomic_operations.h"
#include "rm/fast_memory_operations.h"
#include "rm/hash.h"
#include "rm/me_notification.h"
#include "rm/me_xscale_locks.h"

#else /* Westport hardware */

#include "rm/IxNpeMh.h"
#include "rm/IxNpeDl.h"

#endif /* (_IX_HARDWARE_TYPE_ != _IX_HW_WESTPORT_) */

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__IX_RM_H__) */
