/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2001 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor, Release 4
 *
 * = LIBRARY
 *      Resource Manager Library
 *
 * = MODULE
 *      Internal Library
 *
 * = FILENAME
 *      internal_support.h
 *
 * = DESCRIPTION
 *      This file defines macros, types and function prototypes required internaly
 *
 * = AUTHOR
 *       Adrian Georgescu
 *       adrian.georgescu@intel.com
 *
 * = AKNOWLEDGEMENTS
 *      
 *
 * = CREATION TIME
 *      11/5/2001 2:33:14 PM
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 * $Id: internal_support.h,v 1.2 2002/09/18 17:27:15 lbmiller Exp $
 */

#if !defined(__INTERNAL_SUPPORT_H__)
#define __INTERNAL_SUPPORT_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */


/**
 * MACRO NAME: IX_RM_UNUSED_ARG
 *
 * DESCRIPTION: This macro is used to remove the warnings generated for unused arguments.
 *
 */
#define IX_RM_UNUSED_ARG( \
                          arg_Argument \
                        ) \
                        (void)arg_Argument


/**
 * MACRO NAME: IX_RM_UNUSED_VARIABLE
 *
 * DESCRIPTION: This macro is used to remove the warnings generated for unused automatic
 *          variables.
 *
 */
#define IX_RM_UNUSED_VARIABLE( \
                          arg_Variable \
                        ) \
                        (void)arg_Variable
                        

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__INTERNAL_SUPPORT_H__) */
