/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      symbols.h
 *
 * = DESCRIPTION
 *      This file declares all the global preprocessor symbols required by 
 *      the Resource Manager API.
 *
 * = AUTHOR
 *      Adrian Georgescu
 *      adrian.georgescu@intel.com
 *
 * = CHANGE HISTORY
 *      4/23/2002 12:42:26 PM - creation time 
 * ============================================================================
 * $Id: symbols.h,v 1.12 2003/08/27 23:23:09 ageorges Exp $
 */

#if !defined(__SYMBOLS_H__)
#define __SYMBOLS_H__


#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

#if defined( _IX_RM_MULTI_THREADED_ ) && !defined( _IX_RM_EXPLICIT_SINGLE_THREADED_ )
#   define _IX_RM_COMPONENT_MULTI_THREADED_
#endif

#define _IX_RM_MULTI_THREADED_ 
#define _IX_RM_COMPONENT_MULTI_THREADED_

#if defined(IX_TARGET_SIMNTgnu) || defined(IX_TARGET_SIMNTgnu_Debug) || \
    defined(IX_TARGET_SIMNTgnu_2800) || defined(IX_TARGET_SIMNTgnu_Debug_2800)

    #define _IX_RM_LIB_DEVELOPMENT_ 
    #define IOSTYLE     NOIOOP

#endif

#if defined(IX_TARGET_XSCALEgnube) || defined(IX_TARGET_XSCALEgnube_Debug) || \
    defined(IX_TARGET_XSCALEgnube_2800) || defined(IX_TARGET_XSCALEgnube_Debug_2800)

    #define _IX_RM_IMPL_HARDWARE_ 
    #define IOSTYLE     HARDWARE

#endif 


#if defined(IX_DEBUG)

#define _IX_RM_DEBUG_

#endif /* end defined(IX_DEBUG) */

#if defined(_IX_RM_DEBUG_)

#define _IX_RM_BUFFER_DEBUG_

#endif /* defined(_IX_RM_DEBUG_) */


/* #define _IX_RM_SPLIT_META_DATA_  */
/* #define _IX_RM_MULTIPLE_CHANNEL_HW_FREE_LIST_ */

#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__SYMBOLS_H__) */
