/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2001 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2000 Network Processor, Release 4
 *
 * = LIBRARY
 *      Resource Manager Library
 *
 * = MODULE
 *      Linux Development Support
 *
 * = FILENAME
 *      internal_linux_support.c
 *
 * = DESCRIPTION
 *      This file will define external functions and variables defined by the hal and
 *      uclo libraries that are not available at this time.
 *
 * = AUTHOR
 *       Adrian Georgescu
 *       adrian.georgescu@intel.com
 *
 * = AKNOWLEDGEMENTS
 *      
 *
 * = CREATION TIME
 *      10/23/2001 3:48:58 PM
 *
 * = CHANGE HISTORY
 *
 * ============================================================================
 */

static const char s_aFileIdentifier[] = "$Id: internal_linux_support.c,v 1.4 2003/01/03 23:45:39 ageorges Exp $";

#include "ix_ossl.h"

#include "ix_os_type.h"
#include "ix_symbols.h"
#include "ix_hardware_configuration.h"

#include "ix_types.h"
#include "ix_macros.h"
#include "ix_error.h"

#include "rm/symbols.h"

#if defined(_IX_RM_IMPL_HARDWARE_)

#include <uclo.h>
#include <halMev2Api.h>

#include <asm/arch/ixp2000.h>


void	*SRAM_MEM_BEG = (void*)0x80000000;
void	*SRAM_MEM_END = (void*)0xbfffffff;

void	*SRAM_CSR_CHANNEL0_BASE_ADDR = (void*)0xcc000000;
void	*SRAM_CSR_CHANNEL1_BASE_ADDR = (void*)0xcc400000;
void	*SRAM_CSR_CHANNEL2_BASE_ADDR = (void*)0xcc800000;
void	*SRAM_CSR_CHANNEL3_BASE_ADDR = (void*)0xccc00000;

void	*SRAM_CHANNEL0_RING_OP_BASE_ADDR = (void*)0xce000000;
void	*SRAM_CHANNEL1_RING_OP_BASE_ADDR = (void*)0xce400000;
void	*SRAM_CHANNEL2_RING_OP_BASE_ADDR = (void*)0xce800000;
void	*SRAM_CHANNEL3_RING_OP_BASE_ADDR = (void*)0xcec00000;

void	*SRAM_CHANNEL0_QUEUE_OP_BASE_ADDR = (void*)0xcc000100;
void	*SRAM_CHANNEL1_QUEUE_OP_BASE_ADDR = (void*)0xcc400100;
void	*SRAM_CHANNEL2_QUEUE_OP_BASE_ADDR = (void*)0xcc800100;
void	*SRAM_CHANNEL3_QUEUE_OP_BASE_ADDR = (void*)0xccc00100;

unsigned char	*SCRATCH_MEM_BEG = (unsigned char*)0xca000000;
unsigned char	*SCRATCH_MEM_END = (unsigned char*)0xcbffffff;
unsigned char	*SCRATCH_BASE_ADDR = (unsigned char*)(VIRT_CAP_CSR + 0x00004800);
unsigned char	*SCRATCH_RING_OP_BASE_ADDR = (unsigned char*)0xcb400000;
unsigned char	*GASKET_CRS_BASE_ADDR = (unsigned char*)VIRT_GASKET_CSR;


void UcLo_InitLib(void)
{
}

int UcLo_WriteUimageAll(void *handle)
{
    return UCLO_SUCCESS;
}
int UcLo_GetVarMemSegs(void *handle, UcLo_VarMemSeg_T *varMemSeg)
{
    varMemSeg->sram0BaseAddr = 0;
    varMemSeg->sram0Size = 0;
    varMemSeg->sram1BaseAddr = 0;
    varMemSeg->sram1Size = 0;
    varMemSeg->sram2BaseAddr = 0;
    varMemSeg->sram2Size = 0;
    varMemSeg->sram3BaseAddr = 0;
    varMemSeg->sram3Size = 0;
    varMemSeg->sdramBaseAddr = 0;
    varMemSeg->sdramSize = 0;
    varMemSeg->scratchBaseAddr = 0;
    varMemSeg->scratchSize = 0;
    return UCLO_SUCCESS;
}

int UcLo_DeleObj(void *handle)
{
    return UCLO_SUCCESS;
}

int UcLo_MapObjAddr(void **handle, void *addrPtr, int memSize, int readOnly)
{
    return UCLO_SUCCESS;
}
int UcLo_CopyObjFile(char *fileName, char **objBuf, unsigned int *chunkSize)
{
    return UCLO_SUCCESS;
}

int UcLo_LoadObjFile(void **handle, char *fileName)
{
    return UCLO_SUCCESS;
}

int UcLo_BindSymbol(void *handle, char *ucodeImageName, char *ucodeSymName, int value)
{
    return UCLO_SUCCESS;
}

int UcLo_MeBindSymbol(void *handle, unsigned char me, char *ucodeSymName, int value)
{
    return UCLO_SUCCESS;
}

int UcLo_VerifyUengine(void *handle, unsigned char me)
{
    return UCLO_SUCCESS;
}


int halMe_IsMeEnabled(unsigned char me)
{
    return HALME_ENABLED;
}

int halMe_Start(unsigned char me, unsigned int ctxEnMask)
{
    return HALME_SUCCESS;
}

int halMe_Stop(unsigned char me, unsigned int ctxMask)
{
    return HALME_SUCCESS;
}

void halMe_Reset(unsigned int meMask, int clrReg)
{
}

void halMe_ClrReset(unsigned int meMask)
{
}

#endif /* end defined(_IX_RM_IMPL_HARDWARE_) */
