/******************************************************************************
//////////////////////////////////////////////////////////////////////////////
//                                                                     
//                  I N T E L   P R O P R I E T A R Y                   
//                                                                      
//     COPYRIGHT (c)  2001-2002 BY  INTEL  CORPORATION.  ALL RIGHTS          
//     RESERVED.   NO  PART  OF THIS PROGRAM  OR  PUBLICATION  MAY      
//     BE  REPRODUCED,   TRANSMITTED,   TRANSCRIBED,   STORED  IN  A    
//     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR COMPUTER    
//     LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRONIC, MECHANICAL,    
//     MAGNETIC,  OPTICAL,  CHEMICAL, MANUAL, OR OTHERWISE,  WITHOUT    
//     THE PRIOR WRITTEN PERMISSION OF :                                
//                                                                      
//                        INTEL  CORPORATION                            
//                                                                     
//                     2200 MISSION COLLEGE BLVD                        
//                                                                      
//               SANTA  CLARA,  CALIFORNIA  95052-8119                  
//                                                                      
///////////////////////////////////////////////////////////////////////////////
//
//
//      File Name: definitions.h
//
//      Purpose: Contains some global definitions.
//
/////////////////////////////////////////////////////////////////////////////
*****************************************************************************/

#ifndef __DEFINITIONS_H__
#define __DEFINITIONS_H__


#define SPHY_1_32		0x01
#define SPHY_1_16_2_8	0x02
#define SPHY_2_16		0x03
#define SPHY_4_8		0x04
#define SPHY_4_8_SHARED	0x09	/* Similiar to SPHY_4_8, All threads of one *
                       	    	 * ME can utilize single MSF channel and    *
                       	    	 * other MEs can utilize other MSF channels *
                       	    	 * (channels can be shared between MEs)     */

#define MPHY_4			0x05
#define MPHY_16			0x06
#define MPHY_ETH_ATM	0x07	/* 8 Ethernet ports and 8 ATM ports */

#define SPI_4			0x08	/* Required by sphy_mphy4 tx code */

#define SPI_4_16PORTS	0x09	/* 2ME, each handles 8 ports */
#define SPI_4_10PORTS	0x0a	/* 2ME, each handles 5 ports */	

/*	
 * PPP header is 2 bytes
 */

#ifndef PPP_4_BYTE_HEADER
#define PPP_2_BYTE_HEADER
#endif

/* 
 * Following define the port type 
 */

#define	ETHER_TYPE		0x01
#define PPP_TYPE		0x02

#define IP_V4			0x04
#define IP_V6			0x06

/*
 * Enable/Disable compilation switches
 */

#define	SWITCH_ENABLE	0x1
#define	SWITCH_DISABLE	0x0

/* 
 * L3 header type definitions
 */

#define PPP_IPV4_TYPE	0x21  /* 0x06 */
#define	PPP_IPV6_TYPE	0x57  /* 0x07 */
#define	PPP_MPLS_TYPE	0x08	
#define UNKNOWN_TYPE	0x00

#define IPV4_TYPE		PPP_IPV4_TYPE
#define IPV6_TYPE		PPP_IPV6_TYPE

#define MPLS_TYPE		PPP_MPLS_TYPE
#define MPLS_RA_TYPE	PPP_MPLS_TYPE + 1
#define MPLSCP_TYPE		MPLS_RA_TYPE  + 1

/*
 * NHID Type definitions. Maximum number
 * allowed is 0xf
 */

#define	NHID_TYPE_IPV4		0x0
#define	NHID_TYPE_IPV6		0x1
#define	NHID_TYPE_MPLS		0x2
#define	NHID_TYPE_TUNNELING	0x3



#endif /* __DEFINITIONS_H__ done=======*/
