/* Copyright 1998 Wind River Systems, Inc.; Copyright 1999 Intel Corp. */

/*
modification history
--------------------
01a,25mar02,lagarwal  created from ixp1200eb_be
*/

#ifndef INCixp2400pcih
#define INCixp2400pcih

enum PciBarId{CSR_BAR=0, SRAM_BAR, SD_BAR, NO_BAR};

typedef struct {
    UINT32 size;
    UINT32 address;
} PciBar;

typedef struct {
    int bus;
    int device;
    int func;
    int irq;
    UINT16 vendor_id;
    UINT16 device_id;
    PciBar bar[6];
} PciDevice;

/* defines for strap pins */
/*#define CFG_PCI_BOOT_HOST	(1 << 2)
#define CFG_PROM_BOOT		(1 << 1)*/

#if defined(__cplusplus)
extern "C"
{
#endif				/* __cplusplus */
extern PciDevice *pciInfoGet(unsigned short device);
extern PciDevice *pciInfoSearch ( int bus, int device, int func, int count);
extern PciDevice *pciDeviceGet ( int vendor_id, int device_id, int count);
#if defined(__cplusplus)
}
#endif				/* __cplusplus */

#endif				/* ifndef INCixp2400pcih */
