/* Copyright 2001 Wind River Systems, Inc. */

/*
modification history
--------------------
01b,28may02,eme changed value of SYS_FLASH_TYPE to FLASH_28F128J3A
01a,18apr02,eme created from 01a ibrh80200
01b,13mar03,tep removed define for INCLUDE_EXTRA_PCI_MAPPING, modified boot
lines for convenience (default,master, and slave)
01c,18mar03,tep added def for STANDALONE_NET, bspVal testing defs, INCLUDE_PCI,
undefed SERIAL_DEBUG
01d,23mar03,tep Added define for DRAM_OTHER as a temp fix for not being
able to run vxworks from the top 32Mb of memory due to parity errors encountered,
added define for STAND_ALONE_NEt, ping, NET_SYM_TABLE, RLOGIN,AND  NET_SHOW,
INCLUDE_PCI, changed default boot lines for convenience, removed define for 
serial_debug
01e,25mar03,tep Added INCLUDE_FLASH define and adjusted default boot parms
01f,26mar03,tep Changed A0_2800 to REV_A0_2800 and added REV_AX_2800.  
REV_AX_2800 leave some sili workarounds in the RDRAM init code, see rominit.s.
01g,27mar03,tep Added "#define 2800"
01h,03apr03,tep Added the following defines:
#define INCLUDE_BOOTP 
#define INCLUDE_DHCPC
#define INCLUDE_NFS
#define INCLUDE_NFS_MOUNT_ALL
#define INCLUDE_TELNET
#define INCLUDE_DOSFS          
#define INCLUDE_DOSFS_MAIN
#define INCLUDE_DOSFS_FAT
#define INCLUDE_CBIO
#define INCLUDE_DOSFS_DIR_VFAT
#define INCLUDE_DOSFS_FMT
#define INCLUDE_DISK_UTIL
#define TELNETD_MAX_CLIENTS 4
#undef STANDALONE_NET
in pursuit of RPC error still in debug.
01i,4apr03,tep Removed bootp, dosfs, dhcp defines.
01j,13apr03,tep removed NFS_MOUNT_ALL and TELNET for simplicity,  also
changed vxWork phys location to top of 768M of RDRAM.
01k,22apr03,tep revised options selection and sram boot parameters
01m.27apr03,tep added STANDALONE_BOOT wrappers for ROM_SIZE and ROM_BASE_ADRS,
changed location of bootline in flash to c4fffe00
01n,21may03,tep changed location of the bootline from c4fffe00 to c49ffe00
due to linux requirement for use of top of flash.


This module contains the configuration parameters for ixdp2000
*/

#ifndef INCconfigh
#define INCconfigh

#ifdef __cplusplus
IMPORT "C" {
#endif

/** BSP version/revision identification, before configAll.h **/
#define BSP_VER_1_1          1      /* BSP Version */
#define BSP_VERSION          "0.1"  /* Version string */
#define BSP_REV              "/0"   /* 0 for first revision */

#undef INCLUDE_BOOTP 
#undef INCLUDE_DHCPC
#define INCLUDE_NFS
#undef INCLUDE_NFS_MOUNT_ALL

#define INCLUDE_TELNET

#undef INCLUDE_DOSFS           /* dosFs file system */
#undef INCLUDE_DOSFS_MAIN
#undef INCLUDE_DOSFS_FAT
#undef INCLUDE_CBIO
#undef INCLUDE_DOSFS_DIR_VFAT
#undef INCLUDE_DOSFS_FMT
#undef INCLUDE_DISK_UTIL


#include "configAll.h"	/* Include the default configurations */

#define	IXP2800

/* The REV_A0_2800 define covers A0 SW workarounds for the silicon*/
#undef REV_A0_2800
/* The REV_AX_2800 define covers AX SW workarounds for the silicon*/
#define REV_AX_2800

/* Add the following define to make system simpler for debugging (?)*/
#undef DRAM_ONE2ONE
#undef DRAM_OTHER /*vxWorks at 480Mb for 32Mb*/

#define TELNETD_MAX_CLIENTS 4

/*
 * STANDALONE_NET must be defined for network debug with
 * standalone vxWorks
 */
#undef STANDALONE_NET

/*
 * bspVal testing ...
 */
 #define INCLUDE_SHELL
 #define INCLUDE_SHOW_ROUTINES
 #define INCLUDE_LOADER
 #define INCLUDE_NET_SYM_TBL
 #define INCLUDE_PING
 #define INCLUDE_RLOGIN
 #define INCLUDE_NET_SHOW

/** Selection Macros, which might have affect later **/

#define INCLUDE_SYS_HW_INIT_0
#ifdef INCLUDE_SYS_HW_INIT_0
#ifndef _ASMLANGUAGE
IMPORT void sysHwInit0 (void);
#endif
#define SYS_HW_INIT_0() sysHwInit0 ()
#endif

/** TFFS & DOSFS support **/
#undef INCLUDE_TFFS
#undef INCLUDE_DOSFS

#define INCLUDE_AUX_CLK

#ifdef INCLUDE_AUX_CLK 
#define AUX_CLK_AVAIL        TRUE 
#endif

#ifdef REV_A0_2800
#undef INCLUDE_TIMESTAMP
#else
#define INCLUDE_TIMESTAMP
#endif	/*REV_A0_2800*/

#ifdef INCLUDE_TIMESTAMP
#define INCLUDE_USER_TIMESTAMP

#ifdef INCLUDE_USER_TIMESTAMP
#define USER_TIMESTAMP      sysTimestamp
#define USER_TIMESTAMPLOCK  sysTimestampLock
#define USER_TIMEENABLE     sysTimestampEnable
#define USER_TIMEDISABLE    sysTimestampDisable
#define USER_TIMECONNECT    sysTimestampConnect
#define USER_TIMEPERIOD     sysTimestampPeriod
#define USER_TIMEFREQ       sysTimestampFreq
#endif  /* INCLUDE_USER_TIMESTAMP */
#endif

#define INCLUDE_EXC_HANDLING

#define INCLUDE_EXC_TASK

#define INCLUDE_RAM_PAGE_TABLE

/*
 * defined to work with standalone image and visionClick/Probe
 * if defined, then define STANDALONE_NET, and undefine INCLUDE_FLASH...
 * also flush out DEFAULT_BOOT_LINE for IPs and target name...
 *
 * under visionClick/Probe you must convert your vxWorks.st into a "bdx" image...
 *
 * convert.exe "Z:\wpwr\target\config\ixdp2000_be\vxWorks.st" -c -m gnu -b -z
 *
 * under visionClick/Probe select from menu bar: " TOOLS/CONVERT OBJECT MODULES",
 * and :
 *   (1) add path to vxWorks.st image,
 *   (2) check "create symbol file for visionClick"
 *   (3) check "create bdx file for RAM download"
 *
 */
#undef INCLUDE_HSI_PROBE    /* work with standalone image and probe */

/* PCI configuration */

#ifndef INCLUDE_PCI
#define INCLUDE_PCI
#endif

#ifdef  INCLUDE_PCI
#define INCLUDE_PING
#define AUTO_PCI_CONFIG   /* automatically scan PCI bus and assign addresses */
#define INCLUDE_AUTO_PCI_CONFIG_SHOW_ROUTINE

#define INCLUDE_END
#ifdef	INLCUDE_END
#define INCLUDE_FEI82557END     /* include FEI END Ethernet driver */

#undef WDB_COMM_TYPE
#define WDB_COMM_TYPE       WDB_COMM_END
#endif /* INCLUDE_END */

#endif  /* INCLUDE_PCI */

/* First line below indicates host (hdice013) and path of image
   (c:\vxWorks). The parameters that follow are:
   h = Internet address of host (hdice013)
   e = Internet address of target
   tn = Name of target machine
   u = user name used to access host
   pw = password for user
*/
 #define DEFAULT_BOOT_LINE \
          "fei(0,0)hdw2wlab1029:c:/tornado2.2/target/config/ixdp2800_be/vxWorks.st " \
          "h=17.17.17.81 e=17.17.17.85:FFFFFF00 u=target pw=target tn=ixdp2000"

#define MASTER_BOOT_LINE \
          "fei(0,0)hdw2wlab1029:c:/tornado2.2/target/config/ixdp2800_be/vxWorks.st " \
          "h=17.17.17.81 e=17.17.17.85:FFFFFF00 u=egress pw=egress tn=egress"

#define SLAVE_BOOT_LINE \
          "fei(0,0)hdw2wlab1029:c:/tornado2.2/target/config/ixdp2800_be/vxWorks.st " \
          "h=17.17.17.81 e=17.17.17.86:FFFFFF00 u=ingress pw=ingress tn=ingress"

/*** UART ***/
/* Serial port configuration */

#define INCLUDE_SERIAL
#ifdef INCLUDE_SERIAL

/*
 * If there are two UARTs. The default UART defs like NUM_TTY, CONSOLE_TTY
 * and CONSOLE_BAUD_RATE in configAll.h should work fine. If you change any
 * defaults, it might affect the WDB defs also, so cross check with WDB defs.
 *
 */
#define N_UARTS              1
#undef  NUM_TTY
#define NUM_TTY              N_UARTS
#define IXP2000_BAUD_RATE	 9600
#define DEFAULT_BAUD         IXP2000_BAUD_RATE 
#define UART_DEFAULT_BAUD    IXP2000_BAUD_RATE 

#undef  CONSOLE_TTY
#define CONSOLE_TTY         0

#undef  CONSOLE_BAUD_RATE
#define CONSOLE_BAUD_RATE DEFAULT_BAUD

/*** WDB ***/
/*
 * Define SERIAL_DEBUG to enable debugging
 * via the serial ports
 */

#undef SERIAL_DEBUG

#ifdef SERIAL_DEBUG
#define WDB_NO_BAUD_AUTO_CONFIG

#undef WDB_COMM_TYPE
#undef WDB_TTY_BAUD
#undef WDB_TTY_CHANNEL
#undef WDB_TTY_DEV_NAME

#define WDB_COMM_TYPE     WDB_COMM_SERIAL /* WDB in Serial mode */
#define WDB_TTY_BAUD      IXP2000_BAUD_RATE  /* Baud rate for WDB Connection */
#define WDB_TTY_CHANNEL   0               /* COM PORT #0 */
#define WDB_TTY_DEV_NAME  "/tyCo/0"       /* default TYCODRV_5_2 device name */
#endif /* SERIAL_DEBUG */
#endif /* INCLUDE_SERIAL */

/*
 * Cache/MMU configuration
 *
 * Note that when MMU is enabled, cache modes are controlled by
 * the MMU table entries in sysPhysMemDesc[], not the cache mode
 * macros defined here.
 *
 * INCLUDE_CACHE_SUPPORT will be defined by default in configAll.h, and
 * as a consequence, INCLUDE_MMU_BASIC will also be defined (via
 * usrDepend.c) when compiling usrConfig.c. However, we need it defined
 * in here so that it will be seen in sysLib.c. If VxVMI is required,
 * replace this with INCLUDE_MMU_FULL.
 */

/* cache support */
#define INCLUDE_CACHE_SUPPORT
#define USER_I_CACHE_ENABLE
#define USER_D_CACHE_ENABLE

/* XScale I-cache mode is a bit of an inappropriate concept, but use this */

#undef  USER_I_CACHE_MODE
#define USER_I_CACHE_MODE    CACHE_WRITETHROUGH

/* XScale has to be this, as it does not support writethrough */

#undef  USER_D_CACHE_MODE
#define USER_D_CACHE_MODE    CACHE_COPYBACK

/*** MMU ***/

/*
 * Initial MMU translation table location. Make sure it is 16K aligned.
 * ROM_TEXT_ADRS should also be recalculted, if this MMU_TRANSLATION_BASE is
 * changed.
 */

#if 1
#undef  INCLUDE_MMU_FULL
#define INCLUDE_MMU_BASIC
#else
#undef INCLUDE_MMU_BASIC
#define INCLUDE_MMU_FULL
#endif


#define MMU_TABLE_SIZE			0x00004000
#define MMU_TRANSLATION_BASE	0x00004000 /* translation table location */
#define MMU_TABLE_END			(MMU_TRANSLATION_BASE + MMU_TABLE_SIZE)

#if defined(INCLUDE_MMU_BASIC) || defined(INCLUDE_MMU_FULL)
#define INCLUDE_MMU
#endif

#undef VM_PAGE_SIZE
#define VM_PAGE_SIZE         4096

/* Memory configuration */
#undef  LOCAL_MEM_AUTOSIZE                 /* run-time memory sizing */

/*
 * LOCAL_MEM_RESERVED is the number of MBytes reserved from low RDRAM.
 * This memory will not be mapped to virtual address 0 and will be used
 * to communicate with the microgengines.
 */
#ifdef DRAM_OTHER
#define LOCAL_MEM_RESERVED    (480 * SZ_1M)
#else
#define LOCAL_MEM_RESERVED    (736 * SZ_1M)
#endif	 /*	DRAM_OTHER  */

/*
 * LOCAL_MEM_SIZE_ACTUAL is the amount of physical memory present on the board.
 * LOCAL_MEM_SIZE is the amount that VxWorks thinks is on the board, which is
 *   less by the amount LOCAL_MEM_RESERVED.
 */

#ifndef SRAM_BOOT
#define LOCAL_MEM_LOCAL_ADRS       0x00000000      /* fixed */
#define LOCAL_MEM_SIZE (LOCAL_MEM_SIZE_ACTUAL - LOCAL_MEM_RESERVED)
#else
#define LOCAL_MEM_LOCAL_ADRS       SRAM_CHAN1_BASE      /* fixed */
#define LOCAL_MEM_SIZE			   (SRAM_CHAN_SIZE*2)
#endif /* SRAM_BOOT */
/*
 * The configuration macro, USER_RESERVED_MEM, allows the user to reserve 
 * memory for special purposes. The reserved memory will not be used or 
 * cleared by VxWorks during startup or operation.
 *
 * If the user wants the reserved area to be cleared like all other memory, 
 * then the value of USER_RESERVED_MEM should be set to 0 for building any 
 * boot ROM image.
 */
#define USER_RESERVED_MEM   0x000000        /* see sysMemTop() */

/* RAM Information */
#ifndef SRAM_BOOT
#define RAM_LOW_ADRS    0x00010000 /* RAM starting address, RAM Size */
#define RAM_HIGH_ADRS	0x01000000 /* where the image will be decompressed */
#else
#define RAM_LOW_ADRS    0x90010000 /* RAM starting address, RAM Size */
#define RAM_HIGH_ADRS	0x90800000 /* where the image will be decompressed */
#endif

/* ROM Information */
/*
 * Boot ROM is an image written into Flash ROM and started
 * by the ixdp2000 Primary Boot Loader.
 *
 * The following parameters are defined here and in the Makefile.
 * They must be kept synchronized; effectively config.h depends on
 * Makefile. Any changes made here must be made in the Makefile and vice
 * versa.
 *
 * ROM_BASE_ADRS is the base of the Flash ROM
 * ROM_TEXT_ADRS is the entry point of the VxWorks image
 * ROM_SIZE is the size of the part of the Flash ROM allocated to the VxWorks
 *          image (block size - size of headers)
 *
 * Two other constants are used:
 * ROM_COPY_SIZE is the size of the part of the ROM to be copied into RAM
 *               (uncompressed bootrom)
 * ROM_SIZE_TOTAL is the size of the entire Flash ROM (used in sysPhysMemDesc)
 *
 * The address of the Flash block being used is:
 *    ROM_BASE_ADRS + (block << 18)   (blocks are ROM_SIZE)
 * The boot ROM image is at an offset of 0xC0 into this block - 0x40
 * bytes for a Flash header, 0x80 bytes for an AIF header
 *
 * The values are given as literals here to make it easier to ensure
 * that they are the same as those in the Makefile.
 */
#ifdef STANDALONE_BOOT
#define ROM_BASE_ADRS	      0xC4000000
#else
#define ROM_BASE_ADRS	      (0xC4000000+SZ_8M)	
#endif	/*STANDALONE_BOOT*/

/*
 * Where the text starts in ROM, (address of _romInit)...
 */
#define ROM_TEXT_ADRS	      (MMU_TABLE_END + ROM_BASE_ADRS)

/*
 * The size must be big enough so that
 *    (ROM_BASE_ADRS + ROM_SIZE - ROM_TEXT_ADRS) >= size of boot image
 * We allow up to an arbitrary 128K for the image.
 */
#ifdef STANDALONE_BOOT
#define ROM_SIZE            0x01000000      /* 16MB size of flash ROM */
#else
#define ROM_SIZE            0x00800000      /* 8MB size of flash ROM */
#endif	/*STANDALONE_BOOT*/

#define ROM_COPY_SIZE       0x00200000
#define ROM_SIZE_TOTAL      ROM_SIZE		    /* total size of Flash ROM */

#if (ROM_BASE_ADRS + ROM_SIZE - ROM_TEXT_ADRS) < 0x20000
#error  "ROM_ values need checking in config.h/Makefile"
#endif

/*
 * ISR_STACK_SIZE is defined here rather than in ../all/configAll.h (as is
 * more usual) because the stack size depends on the interrupt structure of the
 * BSP.
 */
#define ISR_STACK_SIZE	      0x1000   /* ISR Stack Size 4K */

#undef STACK_SAVE
#define STACK_SAVE           512      /* maximum stack used to preserve */

/*
 * make use of data cache for fast DRAM
 */
#undef INCLUDE_FAST_DRAM
#ifdef INCLUDE_FAST_DRAM
#define FD_CACHELINE        8      /* 8 UINT32's in a cache line (32-bytes) */
#define FD_LINESPERSET      28     /* 28 available cache lines per set */
#define FD_SETS             32     /* 32 sets in data cache */

/* Max number of lines one can allocate (28 x 32) */
#define FD_MAX_LINES (FD_LINESPERSET * FD_SETS) 

#define FD_ORIGIN           0xf9000000 /* location of virtual address */
#define FD_MAX_SIZE         0x7000     /* Max size for MMU table descr, 28KB */

/* modify based on the number of cache lines you want to use as data ram... */
#define FD_NUMLINES         FD_MAX_LINES  /* set for max 28Kbytes */
#endif

#include "ixdp2000.h" /* board settings */

/*
 * Enable Flash as NvRam. Use the last 512 bytes of flash bank 1
 */
#define INCLUDE_FLASH
 #ifdef INCLUDE_FLASH
  #define SYS_FLASH_TYPE      FLASH_28F128J3A                                 /* Specify 8 bit 28F part */
  #undef FLASH_NO_OVERLAY
  #define SYS_FLASH_WRITE

  #define FLASH_WIDTH         1
  #define FLASH_SEGMENT_SIZE  (128 * 1024)                                    /* sector size of 28F128j3a */

/*
 * FLASH_ADRS is the virtual address of the block to hold the NV Ram
 * parameters. FLASH_SIZE is the size of that block.
 */

  /* due to Boot Monitor dependencies we are not at standard offset... */
  #define FLASH_ADRS          0xc49ffe00 /* typically, (ROM_BASE_ADRS + ROM_SIZE - FLASH_SEGMENT_SIZE) => 0xc4fe0000 */
  #define FLASH_SIZE          FLASH_SEGMENT_SIZE
  #define NV_RAM_SIZE         0x200
  #undef NV_BOOT_OFFSET
  #define NV_BOOT_OFFSET      0

 #else
  #define NV_RAM_SIZE         NONE
 #endif /* INCLUDE_FLASH */

/*These are INCLUDES required by Application that runs on IXDP2000 development 
 * platform. These is need not be defined for a generic BSP.
 */
#define INCLUDE_RPC
#define INCLUDE_BSD
#define IP_MAX_UNITS 20
#define INCLUDE_POSIX_SCHED

/*These  defines are added to fix the problem od unresolved symbols 
 "__builtin_delete" and "__builtin_new" when Workbench backend is 
 downloaded
 */
#define INCLUDE_CPLUS 			/*include C++ support*/
#define INCLUDE_CPLUS_IOSTREAMS 	/* include basic iostream classes*/

/*For the start up script to be executed only when shell is included*/
#define INCLUDE_STARTUP_SCRIPT
/*End of application specific defines*/


#undef INCLUDE_USER_APPL
 
#ifdef INCLUDE_USER_APPL
#define USER_APPL_INIT		\
	{			\
	IMPORT int demoApp(void);	\
				\
	demoApp();	\
	}
#endif

#ifdef __cplusplus
}
#endif

#endif  /* INCconfigh */

#if defined(PRJ_BUILD)
#include "prjParams.h"
#endif
