/* ixdp2000Pci.h - PCI header file */

/* Copyright 2001 Wind River Systems, Inc.; Copyright 2001 Intel Corp. */

/*
modification history
--------------------
01a,18may02,eme	created from ixdp1200eb_be
*/

#ifndef INCixdp2000pcih
#define INCixdp2000pcih

enum PciBarId{CSR_BAR=0, SRAM_BAR, RDRAM_BAR, NO_BAR};

typedef struct {
    UINT32 size;
    UINT32 address;
} PciBar;

typedef struct {
    int bus;
    int device;
    int func;
    int irq;
    UINT16 vendor_id;
    UINT16 device_id;
    PciBar bar[6];
} PciDevice;

#ifdef __cplusplus
IMPORT "C" {
#endif

IMPORT PciDevice *pciInfoGet(unsigned short device);
IMPORT PciDevice *pciInfoSearch ( int bus, int device, int func, int count);
IMPORT PciDevice *pciDeviceGet ( int vendor_id, int device_id, int count);

#ifdef __cplusplus
}
#endif

#endif				/* ifndef INCixdp2000pcih */
