/* ixdp2000misc.h - Miscellaneous header files */

/* Copyright 2000 Intel Corp. */

/*
modification history
--------------------
01a,16apr02,eme created from ixdp2400
*/

#ifndef INCixdp2000misch
#define INCixdp2000misch

#ifdef __cplusplus
IMPORT "C" {
#endif

struct SpCfg
	{
	UINT32 spCCR;
	UINT32 spWTC2;
	UINT32 spRTC2;
	UINT32 spPCR;
	UINT32 spADC; 
	};

BOOL isNpuMaster (void); 
BOOL isNpuFlashEnabled(void);
STATUS sysMmuMapAdd(void *addr, UINT len, UINT mask, UINT state);
UINT32 swap32(UINT32 data);
UINT16 sysRead16(volatile UINT16 *address);
UINT16 swap16(UINT16 data);
void sysWrite16(volatile UINT16 *address, UINT16 data);
STATUS ixp2000SramInit(int channel, int skipCsr, int frmPci, int offset);
void getXtalFreq(void);

void ixdp2000SpCfgSave(struct SpCfg * slowPortCfg);
void ixdp2000SpCfgRestore(struct SpCfg *slowPortCfg);

void delayUSec(UINT32 delay);
void dcacheOn();
void dcacheOff();
void dcacheSync();
unsigned int getCP15(void);

#ifdef __cplusplus
}
#endif

#endif /* #ifndef INCixdp2000misch */

