/*******************************************************************************
 *                            Intel Proprietary
 *
 * Copyright (c) 1998-2002 By Intel Corporation.  All rights reserved.  
 * No part of this program or publication may be reproduced, transmitted,
 * transcribed, stored in a retrieval system, or translated into any language
 * or computer language in any form or by any means, electronic, mechanical,
 * magnetic, optical, chemical, manual, or otherwise, without the prior
 * written permission of:
 *                        Intel Corporation
 *                        2200 Mission College Blvd.
 *                        Santa Clara, CA  95052-8119
 *******************************************************************************/
/*****************************************************************************
 *
 * File:  ether_encap.h
 *
 * Abstract:
 *      This file contains the constants used in the Ethernet frame processing
 *
 *****************************************************************************/



#ifndef		__ETHER_ENCAP_C_H__
#define		__ETHER_ENCAP_C_H__


#ifdef USE_IMPORT_VAR

#define MPLS_OUTPORT_STATS_BASE		LoadTimeConstant ("MPLS_OUTPORT_STATS_BASE")
#define IPV4_OUTPORT_STATS_BASE		LoadTimeConstant ("IPV4_OUTPORT_STATS_BASE")
#define IPV6_OUTPORT_STATS_BASE		LoadTimeConstant ("IPV6_OUTPORT_STATS_BASE")

#endif

// Ethernet statistics table Base. Need to change the values later.
//#define MPLS_OUTPORT_STATS_BASE		0x40900010
#define IPV4_OUTPORT_STATS_BASE 	0x40900200
#define IPV6_OUTPORT_STATS_BASE 	0x40900400


// Out port statistics
typedef struct
{
	unsigned int 	outPortTxPkts;	     // Number of Packets Transmitted on output port

	unsigned int 	outPortTxOctets;    // Number of octets that are transmitted on output port									

} ix_ether_outport_stats;


__declspec(packed) typedef union
{

	struct {
		
		unsigned char	destAddr[6] ;      // Destination ethernet MAC address

		unsigned char	srcAddr[6];		   // Source Ethernet MAC address

		unsigned int 	packetType  :16,   // Type of upper layer packet
						valid       :1,    // Valid entry bit
					    reserved    :15;   // Reserved for future use.
	};

	unsigned int value[4];

} ether_encap_t;

#if 1
__declspec(packed) typedef union
{
	struct {
	unsigned int	upper28	:28,
					bit3	: 1,
					bit2	: 1,
					bit1	: 1,
					bit0	: 1;
	};
	unsigned int value;

}offsetType;
#endif

#define		ETHER_ENCAP_ENTRY_SIZE		(sizeof(ether_encap_t)/sizeof(unsigned int))
unsigned int 
ether_encap(__declspec(dram_write_reg) unsigned int *, unsigned int);



#endif
