/*
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *     Copyright (C) 2002-2003 Intel Corporation. All rights reserved.
 *
 * $Id: internal_named.h,v 1.3 2003/01/24 23:58:48 lbmiller Exp $
 */

/**
 * @file internal_named.h
 * Private header file for the L2TM containing information related to 
 * using the registry to manage named table managers.
 */

#if !defined(__INTERNAL_NAMED_H__)
#define __INTERNAL_NAMED_H__

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/**
 * Location in the registry where all named L2 Table Managers are found.
 */
#define _IX_CC_L2TM_REG_ROOT "L2_TABLE_MANAGER"

/**
 * Name of the registry key containing the number of entries the L2TM
 * should manage.
 */
#define _IX_CC_L2TM_REG_NUM_ENTRIES     "NUM_ENTRIES"

/**
 * Name of the registry key containing the type of memory the L2TM should
 * be created in.
 */
#define _IX_CC_L2TM_REG_MEMORY_TYPE     "MEMORY_TYPE"

/**
 * Name of the registry key containing the memory channel the L2TM should be
 * created in.
 */
#define _IX_CC_L2TM_REG_MEMORY_CHANNEL  "MEMORY_CHANNEL"

/**
 * Name of the registry entry that contains the L2 Table Manager's handle,
 * once it has been created.
 */
#define _IX_CC_L2TM_REG_HANDLE "HANDLE"

/**
 * Name of the registry entry that contains the L2 Table Manager's reference
 * count, once it has been created.
 */
#define _IX_CC_L2TM_REG_REFCOUNT "REFCOUNT"

#if defined(__cplusplus)
} /* extern "C" */
#endif /* __cplusplus */

/*vim:tabstop=8:expandtab:shiftwidth=4:tw=78*/
#endif /*__INTERNAL_NAMED_H__*/
