#ifndef	__IX_ASL_INTERNAL_ERROR_H__
#define	__IX_ASL_INTERNAL_ERROR_H__

/*
**			INTEL CORPORATION PROPRIETARY INFORMATION
**	This software is supplied under the terms of a license agreement or
**	nondisclosure agreement with Intel Corporation and may not be copied
**	or disclosed except in accordance with the terms of that agreement.
**	    Copyright (C) 2000,2001 Intel Corporation. All rights Reserved.
**
**	$Id: internal_error.h,v 1.2 2002/08/24 02:58:18 lbmiller Exp $
*/

/*
#include <ix/asl/error.h>
*/

#ifdef	__cplusplus
extern "C" {
#endif

/** @file ix/asl/internal/internal-error.h
    @brief Error Reporting Internal Interfaces

*/

#define	IX_ERROR_BASE		(1<<15)
#define	IX_ERROR_INCR		(IX_ERROR_BASE << 1)
#define	IX_ERROR_MASK		(IX_ERROR_BASE - 1)

#define	IX_ERROR_COUNT_MIN	16
#define	IX_ERROR_COUNT_MAX	1024
#define	IX_ERROR_LENGTH_MIN	64
#define	IX_ERROR_LENGTH_MAX	4096

typedef struct ix_s_error_hunk ix_error_hunk;

typedef struct ix_s_error_pti ix_error_pti;

struct ix_s_error_hunk {
    ix_error                ref;
    ix_error                self;
    ix_error_level          level;
    ix_error_number         code;
    char                    buf[1];
};

struct ix_s_error_pti {
    int                     data_size;
    int                     pool_size;
    int                     pool_next;
    ix_error_hunk         **pool_ptrs;
    char                   *tmp_buf;
};

/** Find Thread-Specific Data.
   @returns pointer to thread-specific error area
 */
ix_error_pti           *ix_error_get_pti(void);

/** set up new error hunk.

    this function locates the error hunk storage, and sets up
    its contents appropriately, up to but not including filling
    in the text string area, which it initializes to a zero
    length string. The length of the longest string that can be
    stored in the hunk's buffer (not including the zero at the
    end of the string) is returned through the size return value.

    this function always returns a nonzero error code that represents
    the error described in its parameters.

    @param	retp	where to return address of error hunk
    @param	sizep	where to return maximum string length
    @param	level	error severity
    @param	code	error number
    @param	ref	subsidiary error
    @returns an error token.
*/
ix_error
ix_error_build(ix_error_hunk **retp,
	       size_t *sizep,
	       ix_error_number code, 
	       ix_error_level level,
	       ix_error ref);

/** locate error information.

    this function translates an error handle into a pointer to the
    appropriate matching error hunk. a null pointer is returned if
    the provided handle is zero, or if it refers to a stale hunk.

    @param	err	error token to decode
    @param	retp	where to return hunk pointer
*/
void
ix_error_find(ix_error err,
	      ix_error_hunk **retp,
	      size_t *sizep);

#ifdef	__cplusplus
};
#endif

#endif/*__IX_ASL_INTERNAL_ERROR_H__*/
