/**
 * ============================================================================
 * = COPYRIGHT INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      ix_cc_reg_util.h
 *
 * = DESCRIPTION
 *
 * = AUTHOR
 *      Rob Petri
 * ============================================================================
 * $Id:
**/

#if !defined(__IX_CC_REG_UTIL_H__)
#define __IX_CC_REG_UTIL_H__

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/*
 * ix_cc_reg_get_parent_from_path
 * This function takes a registry path in the form:
 *  '/prop1/prop2/prop3/prop4'
 * and retrieves the handle to the property pointed to by the path.
 * In the above example, the ix_configuration_property_handle would
 * be provided for 'prop4'.
 *
 * ARGS
 * Input:
 *      arg_path: A string representing the path.
 * Output:
 *      arg_prop: A pointer to an ix_configuration_property_handle to store handle
 */
ix_error 
ix_cc_reg_get_prop_from_path(char *arg_path, 
                             ix_configuration_property_handle *arg_prop);


#if defined(__cplusplus)
} /* extern "C" */
#endif /* __cplusplus */

#endif /*__IX_SA_INTERNAL_REGISTRY_H__*/
