/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      l2_config_linux_kernel_module.h
 *
 * = DESCRIPTION
 *      This file will describe the ioctl commands exported to Linux user 
 *      mode application. 
 *
 * = CHANGE HISTORY
 *      05/06/2003 - Created.
 *
 * ============================================================================
 * $Id: l2_config_linux_kernel_module.h,v 1.3 2003/07/22 21:48:16 ktseng Exp $
 */

#if !defined(__L2_CONFIG_LINUX_KERNEL_MODULE_H__)
#define __L2_CONFIG_LINUX_KERNEL_MODULE_H__



/**
 * System defined include files required.
 */

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

/* maximum number of characters in the string followed after command */
#define MAX_NUM_CHAR_CMD_STRING    1024

/* defines for ioctl commands */

#define ADD_V4_ETH_ENTRY           0x0
#define ADD_V6_ETH_ENTRY           0x1
#define ADD_V4_L3_INFO             0x2
#define ADD_V4_ATM_ENTRY           0x3
#define DELETE_L2_ENTRY            0x4
#define CLEAR_L2_INFO              0x5
#define DUMP_L2TM                  0x6


int addV4EthEntry(const char *argv);
int addV6EthEntry(const char *argv);
int addV4L3Info(const char *argv);
int addV4AtmEntry(const char *argv);
int deleteL2Entry(const char *argv);
int clearL2Info(const char *argv);
int dumpL2tm(char *argv);



#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__L2_CONFIG_LINUX_KERNEL_MODULE_H__) */

