/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2002 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK for the IXP2X00 Network Processor
 *
 * = FILENAME
 *      mac_config_linux_kernel_module.h
 *
 * = DESCRIPTION
 *      This file will describe the ioctl commands exported to Linux user 
 *      mode application. 
 *
 * = CHANGE HISTORY
 *      05/08/2003 - Created.
 *
 * ============================================================================
 * $Id: mac_config_linux_kernel_module.h,v 1.3 2003/05/08 21:41:31 rranjeet Exp $
 */

#if !defined(__MAC_CONFIG_LINUX_KERNEL_MODULE_H__)
#define __MAC_CONFIG_LINUX_KERNEL_MODULE_H__



/**
 * System defined include files required.
 */

#if defined(__cplusplus)
extern "C"
{
#endif /* end defined(__cplusplus) */

/* maximum number of characters in the string followed after command */
#define MAX_NUM_CHAR_CMD_STRING    1024

/* defines for ioctl commands */
#define ADD_MAC                   0x0
#define DEL_MAC                   0x1
#define LOOKUP_PORT               0x4
#define MAC_CONFIG                0x5

int addMac(const char *argv);
int delMac(const char *argv);
int lookupPort(const char *argv);
int mac_config(void);


#if defined(__cplusplus)
}
#endif /* end defined(__cplusplus) */

#endif /* end !defined(__MAC_CONFIG_LINUX_KERNEL_MODULE_H__) */

