#! /usr/bin/perl
#use strict "vars";
#/*--------------------------------------------------------------------
#*                   I N T E L   P R O P I E T A R Y
#*     COPYRIGHT (c) 2001 BY INTEL CORPORATION. ALL RIGHTS
#*     RESERVED. NO PART OF THIS PROGRAM OR PUBLICATION MAY
#*     BE REPRODUCED, TRANSMITTED, TRANSCRIBED, STORED IN A
#*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR
#*     COMPUTER LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRIC,
#*     MECHANICAL, MAGNETIC, OPTICAL, CHEMICAL, MANUAL OR OTHERWISE
#*     WITHOUT THE PRIOR WRITTEN PERMISSION OF :
#*                        INTEL   CORPORATION
#*
#*                       2200 MISSION COLLEGE BLVD
#*
#*                   SANTA CLARA,  CALIFORNIA  95052-8119
#*
#*--------------------------------------------------------------------
#*********************************************************************
#*
#*
#*      File Name:
#*
#*      Purpose:
#*
#*      History:
#*
#*      Date           Comment                By
#*      --------------------------------------------------------------
#*      11/11/2003       Initial Creation      Kalpana Roge
#*
#********************************************************************/

use Cwd;
#use Win32;
#***************************
# Global Variables
#***************************
@ValidNames = ("hw_next", "offset", "buffer_size", "buffer_next", "header_type", "free_list", "rx_stat", "packet_size",
              "output_port_egress", "output_port", "input_port", "nexthop_id", "output_port_fabric", "fabric_port",
              "flow_id", "class_id", "sw_next", "packet_next", "packet_size", "color", "nexthop_id_type", "destination_port",
              "format_id", "crc_32", "npf_table", "npe_register", "npe_record", "npe_operation", "sap_id", "context_id",
              "channel_id", "egress_point", "ingress_point", "flow_qos", "flow_state", "cksum_16", "ack_seq",
              "timestamp", "send_sequence", "user_attribute", "sequence_num", "flow_qos", "flow_state", "ingress_channel",
              "egress_channel", "Reserved");
@Name;  #Holds metadata field name mentioned in the ublock config file
@Size;  #Holds size of the metadata field
@Access;  # Holds access attribute of the field
@SRAM; #Holds index of @Name array of all fields that will be stored in SRAM
@DRAM; #Holds index of @Name array of all fields that will be stored in DRAM
@SCRATCH; #Holds index of @Name array of all fields that will be stored in SCRATCH
@Memory; #Hold memory type for the each field in @Name
@SRAMOffset; #Holds offset (in bytes) in LW for the field in @Name
@SRAMOffset_bits; #Holds offset in bites in LW for the field in @Name
@SRAMByteIndex; #Holds LW index for the field in @Name
@SRAMByteMask; #Holds Mask for each LW to check is all the bits are used
@SRAMBitsRemain; #Holds bits remainining in the LW
@Mask; #Holds mask value for the field in @Name
@MaskInNum; #Holds mask value in Numeric for the field in @Name
@Rotate; #Holds rotate info for the field in @Name. This is used to generate code
@ByteField; #Holds byte location within the LW for the field in @Name. This is used to generate code
$TotalSize_SRAM = 0;
$TotalSize_DRAM = 0;
$TotalSize_SCRATCH = 0;
$TotalSize_GPR = 0;
@Grouped; #Flag to set all the fields that are grouped in the metadata block
@Config[10]; #Holds index of the field in @Name for the field mentioned in the config file
@SizeOfConfig;  #Hold the total number of ublock config files

@OrderConfigFile;  #Holds the order of ublock config to be grouped based on field usage
$OrderConfigFileIndex; #Holds size of the OrderConfigfile

@InFile[10];  #Holds index of field in @Name for the field in the ublock CF
@InFileSize;

@GroupedSRAM[20]; #Holds index of field in @Name grouped in each LW
@ReservedSize[20];  #location of waste bits in LW
@SizeOfGroup;

@DLFilename;  #Holds name of all dispatch loop config files
@uBlockFilename; #Holds name of all uBlock config files
$DLFilenameindex = 0;

$MainConfigFile;  #Holds name of main config file
$MaxConfigFile;  #Holds num of DL config file
$MaxSRAMSize;

$MacroFilename="dl_meta.uc";
$BufferFilename="buffer.h";



$listfilename;
$junkfile;

@DLStartSRAMLW;   #Holds LW index in metadata block for the 1st field in that DL
@DLEndSRAMLW;     #Holds LW index in metadata block for the last field in that DL
@DLuBlockIndex[20];  #Holds index of ublock config file in DL config file
@DLuBlockSize;
@DLFlag;
@DL_fieldindex[20]; #Holds index of field in @Name for each DL config
@DL_SizeOfFieldIndex;
@uBlockStartSRAMLW; #Holds LW index in metadata block for the 1st field in that ublock
@uBlockEndSRAMLW;  #Holds LW index in metadata block for the last field in that ublock
$MAXSRAMSIZELW = 16;

($s,$m,$h,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$mon++;
$year += 1900;
#*********************************************************
MainControl();


#*********************************************************************
#** SUBROUTINE  :ProcessArg()
#** DESCRIPTION :
#       This subroutine processes the main config file mentioned as
#       argument and interates through all the config files and
#       generate the intermediate list file.
#** INPUT      : None
#** OUTPUT     : A list file.
#*********************************************************************
sub ProcessArg()
{
  my $outfile;
  my $index = -1;
  my $filename, $fileindex = 0, $filefound = 0, $pipelinefound = 0; $DLindex=0;
  my $dothisflag = 0;
  my @tmpfile;
  if (-e $MacroFilename)
  {
    system ("rm $MacroFilename");
  }
  if (-e  $BufferFilename)
  {
    system ("rm $BufferFilename");
  }


  $MacroFilename = $ARGV[2];
  $outfile = $ARGV[2];
  @tmpfile = split('/', $MainConfigFile);

  @tmpfile = split('\.', $tmpfile[$#tmpfile]);
  $listfilename = "$tmpfile[0]_list.lst";
  $junkfile = "../../junkfile.jnk";
  open (JUNKFILE, ">$junkfile")|| die "Cannot open $junkfile\n";
  open (LISTFILE, ">$listfilename") || die "cannot open $listfilename\n";
  print LISTFILE "#***********************************************************************************\n";
  print LISTFILE "#This file is automatically generated by the metadata tool.\n";
  print LISTFILE "#PLEASE DO NOT CHANGE THE ORDER OF FIELDS OR ADD/DELETE FIELDS\n";
  print LISTFILE "#\n";
  print LISTFILE "#Following are the supported attributes you can add to each field\n";
  print LISTFILE "# Longwd_Offset: <longword number[0-16]> <offset in bits within the longword[0-31]>\n";
  print LISTFILE "#  \n";
  print LISTFILE "#**********************************************************************************\n\n\n";
  
  open (MAINFILE, $MainConfigFile) || die "Cannot open $MainConfigFile\n";
  foreach (<MAINFILE>)
  {
      if( /\S/ )
      {
        s/^\s*(.*?)\s*$/$1/;
        s/\\/ /g;
       }
       $len = length;
    if ($len <=5 )
    {
      goto endmainloop;
    }
    $filename = $_;
    $DLuBlockSize[$DLindex] = 0;
    push(@DLFilename, $_);
    print JUNKFILE "dFILE $_\n";
    print LISTFILE "#In dispatch loop $_ config file:\n";
    open (DLFILENAME, $filename) || die "Cannot open dispatch loop config file $filename\n";
    foreach(<DLFILENAME>)
	  {
      if( /\S/ )
      {
        s/^\s*(.*?)\s*$/$1/;
        s/\\/ /g;
       }
       $len = length;
       if ($len <=5 )
       {
          goto enddlloop;
       }
      $DLuBlockIndex[$DLindex][$DLuBlockSize[$DLindex]] = $fileindex;
      print JUNKFILE "DLu $DLindex $DLuBlockSize[$DLindex] $fileindex\n";
      $DLuBlockSize[$DLindex] = $DLuBlockSize[$DLindex]+1;
      $ufilename = $_;
  		$SizeOfConfig[$fileindex] = 0;
      push (@uBlockFilename, $_);
      print LISTFILE "#In microblock $_ config file:\n";
      print JUNKFILE "uFILE $ufilename\n";
		  open (INFILE, $ufilename) || die "Cannot open uBlock Config File $ufilename\n";
      foreach (<INFILE>)
		  {

		    # Remove white space
  		  if( /\S/ )
		    {
  			s/^\s*(.*?)\s*$/$1/;
		  	s/\\/ /g;
  		  }
         $len = length;
         if ($len <= 5)
         {
          goto endinloop;
         }
         @t = split(' ', $_);
         $t[0] = lc $t[0];
         $s="name:";
         if (($dothisflag eq 0) && ($_ ne "") && (($t[0] cmp $s) ne 0))
         {
           	print "ERROR: fieldname 'Name:' missing in $ufilename\n";
            Cleanup(1);
			     	exit;
         }

		    # Parse the file

  		  if ($dothisflag eq 0)
		    {
  		  	if ( /Name/i)
  		  	{
    			  @Namefields = split(' ', $_);
			    # Check for valid name;
  			  $foundflag = 0;
          $Namefields[1] = lc $Namefields[1];
		  	  for ($j = 0; $j <= $#ValidNames && ($foundflag == 0); $j++)
			    {
  		  		if (($Namefields[1] cmp $ValidNames[$j]) eq 0)
		  		  {
    				  $foundflag = 1;
				    }
  			  }
		  	  if ($foundflag == 0)
			    {
    				print "ERROR: Invalid metadata name in $ufilename\n";
				    Print_names();
            Cleanup(1);
    				exit;
			    }
  			  $sizeflag = 0;
		  	  $Memflag = 0;
			    $Accessflag = 0;
  			  $dothisflag = 1;
          goto endinloop;
		  	}#if(/name/i)
   	  } #if ($dothisflag eq 0)
      else
      {
			  if (/Size/i)
			  {
	   			if (/\./)
  				{
		  		  print "ERROR: Size should be an Integer Constant\n";
				    print "       Please check $ufilename\n";
            Cleanup(1);
				    exit;
  				}
		  	  @Sizefields = split(' ', $_);
          if ($Sizefields[1] >= 64)
          {
             print "ERROR: Size of 64 or greater is not supported\n";
				     print "       Please check $ufilename\n";
             Cleanup(1);
				     exit;
          }
          if ($Sizefields[1] >= 33)
          {
             print "ERROR: Size of 32 or greater is not supported in this phase\n";
				     print "       Please check $ufilename\n";
             Cleanup(1);
				     exit;
          }
			   $sizeflag = 1;
  		  }# if (/Size/i)
			  elsif (/FieldAccess/i)
			  {
				  @Accessfields = split(' ', $_);
				  $Accessflag = 1;

			  }

			  elsif (/Priority/i)
			  {
			   	@Memfields = split(' ', $_);
			    $Memflag = 1;

			  }
			  else
			  {
			   	print "ERROR: Invalid attribute or attribute missing in $ufilename\n";
          Cleanup(1);
			   	exit;
			  }
       }

		if (/Name/i && $dothisflag && ($sizeflag ne 0 || $Memflag ne 0 || $Accessflag ne 0) )
		{
		  print "ERROR: Missing field attribute. Please check $ufilename\n";
      Cleanup(1);
		  exit;
		}
        
		if ( $sizeflag && $Memflag && $Accessflag  && $dothisflag )
		{
		  $dothisflag = 0;
		  #Check for duplicate Name
		  $found = 0;  $Needtopush = 0;
		  for ($i = $#Name; $i >= 0; $i--)
		  {
			if ($Name[$i] eq $Namefields[1])
			{
				$found = 1;
				$InFile[$i][$InFileSize[$i]] = $fileindex;
				$InFileSize[$i]++;
	#			if ($Memory[$i] eq $Memfields[1])
				{
				  if ($Size[$i] > $Sizefields[1])
				  {
             print "Size of $Namefields[1] will be changed from $Size[$i] to $Sizefields[1]\n";
					   $Size[$i] = $Sizefields[1];
             print JUNKFILE "SC $i  $Size[$i]\n";
				  }
          print LISTFILE "# $Namefields[1] is also accessed by this ublock, but only once is mentioned in the list file\n";
				}
#				else
#				{
#				  $Needtopush = 1;
#				}
        print JUNKFILE "IF $i $InFileSize[$i] $InFile[$i][$InFileSize[$i]-1]\n";
			} #if ($Name[$i] == $Namefields[1]);
		  }  #for ($i = $#Name - 1; $i > 0; $i--);
      
		  if ($found == 0 || $Needtopush)
		  {
			my $ind;
			$index++;
			$sizeflag = 0;
			$Memflag = 0;
			$Accessflag = 0;
      print LISTFILE "Name:$Namefields[1]\n";
      print LISTFILE "Access:$Accessfields[1]\n";
      print LISTFILE "Size:$Sizefields[1]\n";
      print LISTFILE "Priority:$Memfields[1]\n\n";
			push (@Name, $Namefields[1]);
			push (@Access, $Accessfields[1]);
			push (@Size, $Sizefields[1]);
			push (@Memory, $Memfields[1]);

   		$Config[$fileindex][$SizeOfConfig[$fileindex]] = $index;
   		$ind = $#Name;
      if ($InFileSize[$ind] < 0)
      {
         $InFileSize[$ind] = 0;
      }
			$InFile[$ind][$InFileSize[$ind]] = $fileindex;

			$InFileSize[$ind] = $InFileSize[$ind] + 1;
      print JUNKFILE "$fileindex $SizeOfConfig[$fileindex] $Config[$fileindex][$SizeOfConfig[$fileindex]] $ind $InFileSize[$ind] $InFile[$ind][$InFileSize[$ind]-1]  $Namefields[1] $Accessfields[1] $Sizefields[1] $Memfields[1]\n";
 			$SizeOfConfig[$fileindex] = $SizeOfConfig[$fileindex]+ 1;
			if ($Memfields[1] eq "SRAM")    #**check for case
			{
			  push (@SRAM, $index);
			}

			if ($Memfields[1] eq "DRAM")
			{
			  push (@DRAM, $index);
			}

			if ($Memfields[1] eq "SCRATCH")
			{
			  push (@SCRATCH, $index);
			}

		  } #  if ($found == 0 || $Needtopush);
		}  #if ( $sizeflag = 0 || $Memflag = 0 || $Accessflag = 0);
      endinloop:
	    }  # foreach (<INFILE>);
	    close(INFILE);
	    $fileindex++;
      enddlloop:
	  }  # foreach ($DLFILE>);
     $DLindex++;
    print LISTFILE "\n\n";
  endmainloop:
    $MaxConfigFile = $fileindex;
  } #foreach (<MAINFILE>)
  endloop:

  close(MAINFILE);
  close(LISTFILE);
  close(JUNKFILE);

} #sub ProcessArg




#*********************************************************************
#** SUBROUTINE  :GroupFields()
#** DESCRIPTION :
#       This subroutine check if any field is accessed by 2 ublock and
#       re-arrange the order of ublock file and their fields for grouping.
#       It will then interate through all the fields read from the
#       list file and gruop them in longwords. This routine will also
#       calculate the START LW and NUM LW for each ublock and each
#       dispatch loop
#** INPUT      : None
#** OUTPUT     : A list file.
#*********************************************************************
sub GroupFields()
{
  my $calcoffset = 0, $totsize = 0, $SRAMtotSize = 0, $grpIndex = 0, $byteGroupIndex = 0, $tmpoffset = 0;
  my $SRAMTotBitsWaste=0;
  my @grouped, @byteGroup, @StoreOffset;
  $SRAMIndex = 0;
  $f = 0;
  for ($i=0; $i <= $#SizeOfGroup && $f == 0; $i++)
  {
    if ($SRAMBitsRemain[$i] >= 4)
    {
      $SRAMIndex = $i;
      $f=1;
    }
  }



  #Generate Mask for each DL file
  for($i=0; $i<=$#DLuBlockSize; $i++)
  {
    $DLFlag[$i] = 0;
    $DLEndSRAMLW[$i] = 0;
    $DLStartSRAMLW[$i] = 0;
  }
  

  for ($g=0; $g<=$#DLuBlockSize; $g++)
  {
    $DL_SizeOfFieldIndex[$g] = 0;
    for ($w=0; $w<=$DLuBlockSize[$g]; $w++)
    {
      $ind = $DLuBlockIndex[$g][$w];
      for ($v=0; $v<=$SizeOfConfig[$ind]; $v++)
      {
          $DL_fieldindex[$g][$DL_SizeOfFieldIndex[$g]] = $Config[$ind][$v];
          $DL_SizeOfFieldIndex[$g] += 1;
      }
    }
  } # for ($g=0; $g<=$#DLuBlockSize; $g++)
  #Order the Config Files based on the fields used frequently
  for ($i=0; $i<=$#Name; $i++)
  {
    if ($InFileSize[$i] > 1)
    {
      $found = 0;
      for ($k=0; $k<$InFileSize[$i] && $found == 0; $k++)
      {
        for ($j=0; $j<$OrderConfigFileIndex && $found == 0; $j++)
        {
          if ($InFile[$i][$k] == $OrderConfigFile[$j])
          {
            $found = 1;
          }
        }
        if ($found == 0)
        {
          $OrderConfigFile[$OrderConfigFileIndex++] = $InFile[$i][$k];
        }
      } # for ($k=0; $k<$InFileSize[$i] && $found == 0; $k++)
    } # if ($InFileSize[$i] > 1)
  }# for ($i=0; $i<=$#Name; $i++)
  
  for ($i=0; $i<=$MaxConfigFile; $i++)
  {
    $found = 0;
    for ($j=0; $j<$OrderConfigFileIndex && $found == 0; $j++)
    {
      if ($i ==  $OrderConfigFile[$j])
      {
        $found = 1;
      }
    }
    if ($found == 0)
    {
      $OrderConfigFile[$OrderConfigFileIndex++] = $i;
    }
  } #for ($i=0; $i<=$MaxConfigFile; $i++)

  #--------------------------------------------------------
  #Try to group the fields in 32bits chuck
  
  for ($in=0; $in<=$MaxConfigFile; $in++)
  {

    $Cind = $OrderConfigFile[$in];

    for ($m=0; $m<=$SizeOfConfig[$Cind]; $m++)
    {

       my $ind;

       for ($j=0; $j<=$SizeOfConfig[$Cind]; $j++)
       {
         my $found, $foundIndex;
         $ind = $Config[$Cind][$j];

         if (($Grouped[$ind] == 0) && ($Size[$ind] <= $SRAMBitsRemain[$SRAMIndex]))
         {


              if (($tmpoffset = CanBeGrouped($SRAMIndex, $ind)) >= 0)
              {
                $byteGroup[$ByteGroupIndex] = $ind;
                $StoreOffset[$ByteGroupIndex++] = $tmpoffset;
                $totsize += $Size[$ind];
              }

         } #if ($grouped[$ind] == 0 && ($totsize + $Size[$ind]) <= 32)
       } #$for ($j=0; $j<$SizeOfConfig[$i] && ($grouped[$Config[$i][$j]] == 0); $j++)

       
       #If the totsize is still less than 32, look into next file group and group
       if ($totsize < 28 && $totsize > 0)
       {
         if ($in eq $MaxConfigFile)
         {
            goto skipnextgroup;
         }
         $Cind1 = $OrderConfigFile[$in+1];
         for ($j=0; $j<$SizeOfConfig[$Cind1]; $j++)
         {
           $ind1 = $Config[$Cind1][$j];
           if (($Grouped[$ind1] == 0) && ($Size[$ind1] <= $SRAMBitsRemain[$SRAMIndex]))
           {
              if (($tmpoffset = CanBeGrouped($SRAMIndex, $ind1)) >= 0)
              {
                $byteGroup[$ByteGroupIndex] = $ind1;
                $StoreOffset[$ByteGroupIndex++] = $tmpoffset;
                $totsize += $Size[$ind1];
                for ($g=0; $g<=$#DLuBlockSize && $j==0; $g++)
                {
                  for ($w=0; $w<=$DLuBlockSize[$g]; $w++)
                  {
                   if ($DLuBlockIndex[$g][$w] == $Cind1)
                   {
                      if ($DLFlag[$g] eq 0)
                      {
                       $DLStartSRAMLW[$g] = $SRAMIndex;
                      }
                       $DLFlag[$g] = ($DLFlag[$g] << 1) | 1;
                    }
                  }
               } # for ($g=0; $g<=$#DLuBlockSize; $g++)
              }
           }
         }# for ($j=0; $j<$SizeOfConfig[$Cind1]; $j++)
skipnextgroup:
       }#if ($totsize < 28 && $totsize > 0)

       if ($totsize > 0)
       {

         $SRAMTotBitsWaste += (32 - $totsize);
         for ($n=0; $n<$ByteGroupIndex; $n++)
         {
            if ($m eq 0)
            {
              $StartSRAMLW[$Cind] = $SRAMIndex;
            }
            $ind =  $byteGroup[$n];
            $GroupedSRAM[$SRAMIndex][$SizeOfGroup[$SRAMIndex]] = $ind;
            $SizeOfGroup[$SRAMIndex] = $SizeOfGroup[$SRAMIndex] + 1;
            $Grouped[$ind] = 1;
            $ConfigGrouped[$iind] =  $ConfigGrouped[$iind] | (1 << $jind);

            $SRAMOffset[$ind] = int($StoreOffset[$n]/8);
            $SRAMOffset_bits[$ind] = $StoreOffset[$n];
            $SRAMByteIndex[$ind] = $SRAMIndex;
            $SRAMtotSize += $Size[$ind];
            if ((($StoreOffset[$n] + $Size[$ind]) ne $StoreOffset[$n+1]) && $n < $ByteGroupIndex && $totsize ne 32 &&($StoreOffset[$n] + $Size[$ind]) < 32 && $SRAMBitsRemain[$SRAMIndex] > 1)
            {
              $GroupedSRAM[$SRAMIndex][$SizeOfGroup[$SRAMIndex]] = $#ValidNames;
              if ($n == ($ByteGroupIndex - 1) )
              {
                $StoreOffset[$n+1] = 32;
              }
              $ReservedSize[$SRAMIndex][$SizeOfGroup[$SRAMIndex]] = $StoreOffset[$n+1] - ($StoreOffset[$n] + $Size[$ind]);
	      $SRAMBitsRemain[$SRAMIndex] -= $ReservedSize[$SRAMIndex][$SizeOfGroup[$SRAMIndex]];
              $SizeOfGroup[$SRAMIndex] = $SizeOfGroup[$SRAMIndex] + 1;
            }
              #$Mask[$tmpgroup[$n]] $Size[$tmpgroup[$n]];
              $test = GenerateMask($Size[$ind]);
              $Mask[$ind] = sprintf "%X", $test;
              $MaskInNum[$ind] = $test;
              if ( $SRAMOffset[$ind])
              {
                $Rotate[$ind] = $SRAMOffset_bits[$ind];
              }
               #Generate mask for bytefield insert
                $ByteField[$ind] = GenerateMask($Size[$ind]/8);
                $ByteField[$ind] = $ByteField[$ind] << ($SRAMOffset[$ind]);

              if  ( $ByteField[$ind] & 8)
              {
                $ByteField[$ind] =  sprintf "%b", $ByteField[$ind];
              }
              elsif ( $ByteField[$ind] & 4)
              {
                $ByteField[$ind] =  sprintf "0%b", $ByteField[$ind];
              }
              elsif ( $ByteField[$ind] & 2)
              {
                $ByteField[$ind] =  sprintf "00%b", $ByteField[$ind];
              }
              elsif ( $ByteField[$ind] & 1)
              {
                $ByteField[$ind] =  sprintf "000%b", $ByteField[$ind];
              }
          }#for ($n=0; $n<$ByteGroupIndex; $n++)

          $grpIndex++;
          $totsize = 0;
          $calcoffset = 0;
          $tmpoffset = 0;
          $SRAMIndex++;
          $ByteGroupIndex = 0;


      }  #  $totsize > 0)

      if ($m eq $SizeOfConfig[$Cind])
      {
         $uBlockEndSRAMLW[$Cind] = $SRAMIndex;
      }
      for ($g=0; $g<=$#DLuBlockSize; $g++)
      {
      for ($w=0; $w<=$DLuBlockSize[$g]; $w++)
      {
        if ($DLuBlockIndex[$g][$w] == $Cind)
        {
          if ($DLFlag[$g] eq 0)
          {
            $r = $Config[$Cind][0];
            $DLStartSRAMLW[$g] = $SRAMByteIndex[$r];
          }
          $DLFlag[$g] = ($DLFlag[$g] << 1) | 1;
        }
      }
    } # for ($g=0; $g<=$#DLuBlockSize; $g++)
      for ($g=0; $g<=$#DLuBlockSize; $g++)
      {
        $fnd =0 ;
        for ($v=0; $v<$DL_SizeOfFieldIndex[$g]; $v++)
        {
          $gh = $DL_fieldindex[$g][$v];
          if ($Grouped[$gh] == 0)
          {
            $fnd = 1;
          }
        }
        if ($fnd == 0 && $DLEndSRAMLW[$g] eq 0)
        {
          $rind = $DLuBlockIndex[$g][$DLuBlockSize[$g]];
          $rind = $Config[$rind][$SizeOfConfig[$rind]];
          $DLEndSRAMLW[$g] = $SRAMByteIndex[$rind];
        }
      }

    } #for ($m=0; $m<=$SizeOfConfig[$Cind]; $m++)
  } # for ($i=0; $i<=$MaxConfigFile; $i++)


  #$TotalSize_SRAM = int(($SRAMtotSize/32));


  $total = $#SizeOfGroup + 1;
  $totf = $#Name + 1;
  if ($total >= 15)
  {
    print "ERROR: Total metadata Block Size exceeds 64 bytes\n";
    Cleanup(0);
    exit;
  }
  print "***************************************************\n";
  print "SUMMARY:\n";
  print "Total metadata fields      :  $totf\n";
  print "Total SRAM memory usage    :  $total Longwords\n";
  print "Metadata Block Size        :  $total Longwords\n";
  print "Bits wasted                :  $SRAMTotBitsWaste Bits \n";
  print "***************************************************\n";
  

  
}

#*********************************************************************
#** FUNCTION    : CanBeGrouped()
#** DESCRIPTION :
#       This function checks if the field can be grouped within the
#       specified LW.
#** INPUT      : SRAM_LongwordIndex, Index of @Name
#** OUTPUT     : Return Offset or -1.
#*********************************************************************
sub CanBeGrouped()
{
  @myparams = @_;
  $tsize = $Size[$myparams[1]];
  $tindex = $myparams[0];
  if ($tsize <= 4)
  {
    $mult = 4;
  }
  else
  {
    $mult = 8;
  }
  $tmask = GenerateMask($tsize);
  $limit = 32 - $tsize;
  for($i=0; ($i*$mult) <= $limit; $i++)
  {
    if((($SRAMByteMask[$tindex] >> ($i*$mult)) & $tmask) eq 0)
    {
      $nwmask = $tmask << ($i*$mult);
      $myparams[2] = ($i*$mult);
      $SRAMByteMask[$tindex] |= $nwmask;
      $SRAMBitsRemain[$tindex] -= $tsize;
      return $myparams[2];
    }
  }
  return -1;
}




#*********************************************************************
#** SUBROUTINE    : WriteToFile()
#** DESCRIPTION   :
#       This function creates buffer.h and dl_meta.uc
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub WriteToFile()
{

  my $bufferfilename = "buffer.h";
  open (OUTFILE, ">$MacroFilename");
  open (BUFFER, ">$bufferfilename");
  print "Creating buffer.h.......\n";
  PrintHeader(OUTFILE, $MacroFilename);
  print OUTFILE "#ifndef __DL_META_UC__\n";
  print OUTFILE "#define __DL_META_UC__\n\n\n";
  print OUTFILE "#include <stdmac.uc>\n";
  print OUTFILE "#include <xbuf.uc>\n";
  print OUTFILE "#include <buf.uc>\n";
  print OUTFILE "#include <bytefield.uc>\n";
  
  print OUTFILE "/* Define the number of LW of the metadata to be cached*/\n";
  print OUTFILE "#ifndef   META_CACHE_SIZE\n";
  print OUTFILE "#define   META_CACHE_SIZE    $total\n";
  print OUTFILE "#endif\n\n";
  
  print OUTFILE "#ifdef DL_META_DATA_IN_SXFER\n";
  print OUTFILE "/* Use SRAM xfer registers for metadata*/\n";
  print OUTFILE "#define dl_meta \$dl_meta\n\n";
  print OUTFILE "#else\n";
  print OUTFILE "#ifdef DL_META_DATA_IN_DXFER\n";
  print OUTFILE "/* Use DRAM xfer registers for metadata*/\n";
  print OUTFILE "#define dl_meta \$\$dl_meta\n\n";
  print OUTFILE "#else\n";
  print OUTFILE "/* Use GPR for metadata*/\n";
  print OUTFILE ".reg dl_meta[META_CACHE_SIZE]\n\n";
  print OUTFILE "#endif\n";
  print OUTFILE "#endif\n";
  
  print OUTFILE "#ifdef USE_DL_THREAD_ID\n";
  print OUTFILE ".reg dl_exception\n";
  print OUTFILE "#endif\n\n";
  
  print OUTFILE "//\n";
  print OUTFILE "//Metadata Structure:\n";
  PrintStructure (OUTFILE, "// ");
  print OUTFILE "///\n";
  # Print #define OFFSETs and SIZE
  for ($i=0; $i<=$#SRAM; $i++)
  {
    $UName[$SRAM[$i]] = uc($Name[$SRAM[$i]]);

    print OUTFILE "#define SRAM_$UName[$SRAM[$i]]_LW_INDEX $SRAMByteIndex[$SRAM[$i]]\n";
    print OUTFILE "#define SRAM_$UName[$SRAM[$i]]_OFFSET $SRAMOffset[$SRAM[$i]]  /* Byte position within LW*/\n";
    print OUTFILE "#define SRAM_$UName[$SRAM[$i]]_OFFSET_BITS $SRAMOffset_bits[$SRAM[$i]]  /* Bit position within LW*/\n";
    print OUTFILE "#define SRAM_$UName[$SRAM[$i]]_SIZE $Size[$SRAM[$i]]\n\n";

  }
  
  print OUTFILE "\n\n";
  # Print DispatchLoop Start LW and NUM LW
  print OUTFILE "/* Constants for Dispatch Loop*/\n";
  for ($i=0; $i<=$#DLuBlockSize; $i++)
  {
    $UDL[$i] = uc($DLFilename[$i]);
    print  OUTFILE "#define  $UDL[$i]_STARTLW $DLStartSRAMLW[$i]\n";
    $end = ($DLEndSRAMLW[$i] - $DLStartSRAMLW[$i]) + 1;

    print  OUTFILE "#define  $UDL[$i]_NUMLW $end\n";
  }
  print OUTFILE "\n\n";
  
  PrintBuffer(BUFFER);
  print "Creating dl_meta.uc.....\n";
  # Print GET and SET macros for each metadata
  for ($i=0; $i<=$#SRAM; $i++)
  {

    
    print OUTFILE "/*********************************************************\n";
    print OUTFILE "*  dl_meta_get_$Name[$SRAM[$i]]:\n";
    print OUTFILE "*     Description: Get $Name[$SRAM[$i]]\n";
    print OUTFILE "*     Outputs:  Value of $Name[$SRAM[$i]]\n";
    print OUTFILE "*     Inputs:   None\n";
    print OUTFILE "*\n";
    print OUTFILE "*     Size:\n";
    print OUTFILE "*       1-3 instruction\n";
    print OUTFILE "**********************************************************/\n";
    print OUTFILE "#macro dl_meta_get_$Name[$SRAM[$i]]\[$Name[$SRAM[$i]]] \n";
    print OUTFILE ".begin\n";
    if ($Size[$SRAM[$i]] == 32)
    {
      $name = $Name[$SRAM[$i]];
      print OUTFILE "    alu[$name, --, B, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX]]\n";
    }

    elsif ( $Size[$SRAM[$i]] % 8 == 0)
    {
        if ($Rotate[$SRAM[$i]] eq <undef>)
      {

        print OUTFILE "    ld_field_w_clr[$Name[$SRAM[$i]], $ByteField[$SRAM[$i]], dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX]]\n";
      }
      else
      {
        $revbytefield = GetReverseByte($ByteField[$SRAM[$i]]);
        print OUTFILE "    ld_field_w_clr[$Name[$SRAM[$i]], $revbytefield, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], >>$Rotate[$SRAM[$i]]]\n";
      }
    }

    elsif($Size[$SRAM[$i]] <= 8)
    {
      if ($Rotate[$SRAM[$i]] ne <undef>)
      {
        print OUTFILE "    alu_shf[$Name[$SRAM[$i]], 0x$Mask[$SRAM[$i]], AND, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], >>$Rotate[$SRAM[$i]]]\n";
      }
      else
      {
          print OUTFILE "    alu[$Name[$SRAM[$i]], 0x$Mask[$SRAM[$i]], AND, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX]]\n";
      }
    }
    #elsif($SRAMOffset_bits[$SRAM[$i]] eq 0)  #arbitrary size with 0 offset
    #{
    #  print OUTFILE "    alu_shf[$Name[$SRAM[$i]], --, B, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], >>$Size[$SRAM[$i]]]\n";
    #}
    else  #arbitrary field size
    {
         $a = $Size[$SRAM[$i]] + $SRAMOffset_bits[$SRAM[$i]];
         print OUTFILE "    #define_eval _SHF_LEFT (32 - $a)\n";
         print OUTFILE "     #define_eval _SHF_RIGHT (_SHF_LEFT + $SRAMOffset_bits[$SRAM[$i]])\n";
         #print OUTFILE "    bitfield_extract[$Name[$SRAM[$i]], dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $a, SRAM_$UName[$SRAM[$i]]_OFFSET_BITS] \n";
         print OUTFILE "     alu[$Name[$SRAM[$i]], --, B, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], <<_SHF_LEFT ]\n";
         print OUTFILE "     alu[$Name[$SRAM[$i]], --, B, $Name[$SRAM[$i]], >>_SHF_RIGHT]\n";
         
    }
    print OUTFILE ".end\n";
    print OUTFILE "#endm\n\n\n";
    
    
    
    print OUTFILE "/*********************************************************\n";
    print OUTFILE "*  dl_meta_set_$Name[$SRAM[$i]]:\n";
    print OUTFILE "*     Description: Sets $Name[$SRAM[$i]]\n";
    print OUTFILE "*     Outputs:  Value of $Name[$SRAM[$i]]\n";
    print OUTFILE "*     Inputs:   None\n";
    print OUTFILE "*\n";
    print OUTFILE "*     Size:\n";
    print OUTFILE "*       1-3 instruction\n";
    print OUTFILE "**********************************************************/\n";
    print OUTFILE "#macro dl_meta_set_$Name[$SRAM[$i]]\[$Name[$SRAM[$i]]] \n";
    print OUTFILE ".begin\n";
    if ($Size[$SRAM[$i]] == 32)
    {
      $name = $Name[$SRAM[$i]];
      if ($Name[$SRAM[$i]] eq "nexthop_id")
      {
          print OUTFILE "   #if (isnum($Name[$SRAM[$i]]))\n";
          print OUTFILE "     immed_w1[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], ($Name[$SRAM[$i]] & 0xffff)]\n";
          print OUTFILE "   #else    \n";
          print OUTFILE "     alu[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], --, B, $name]\n";
          print OUTFILE "   #endif  \n";
      }
      else
      {
        #print OUTFILE "    xbuf_insert[dl_meta_sram, $Name[$SRAM[$i]], $window, SRAM_$Name[$SRAM[$i]]_SRAM_OFFSET, $tmpsize]\n";
        print OUTFILE "    alu[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], --, B, $name]\n";
      }
    }
    elsif ( $Size[$SRAM[$i]] % 8 == 0)
    {
      if ($Name[$SRAM[$i]] eq "nexthop_id")
      {
          print OUTFILE "   #if (isnum($Name[$SRAM[$i]]))\n";
          print OUTFILE "     immed_w1[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], ($Name[$SRAM[$i]] & 0xffff)]\n";
          print OUTFILE "   #else    \n";

          if ($Rotate[$SRAM[$i]] ne <undef>)
          {

            print OUTFILE "    ld_field[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $ByteField[$SRAM[$i]], $Name[$SRAM[$i]], <<$Rotate[$SRAM[$i]]]\n";
          }
          else
          {
           print OUTFILE "    ld_field[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $ByteField[$SRAM[$i]], $Name[$SRAM[$i]]]\n";
          }
          print OUTFILE "   #endif  \n";
      }
      else
      {
        if ($Rotate[$SRAM[$i]] ne <undef>)
        {

          print OUTFILE "    ld_field[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $ByteField[$SRAM[$i]], $Name[$SRAM[$i]], <<$Rotate[$SRAM[$i]]]\n";
        }
        else
        {
         print OUTFILE "    ld_field[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $ByteField[$SRAM[$i]], $Name[$SRAM[$i]]]\n";
        }
      }
    }
    
    elsif($Size[$SRAM[$i]] <= 8)
    {
      print OUTFILE "     bits_clr[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $SRAMOffset_bits[$SRAM[$i]], 0x$Mask[$SRAM[$i]]]\n";
      print OUTFILE "     #if (isnum($Name[$SRAM[$i]]) && ($Name[$SRAM[$i]] == 0))\n";
      print OUTFILE "             // Do Nothing\n";
      print OUTFILE "     #else\n";
      if ($Rotate[$SRAM[$i]] ne <undef>)
      {
        print OUTFILE "        alu_shf[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], OR, $Name[$SRAM[$i]], <<$Rotate[$SRAM[$i]]]\n";

      }
      else
      {
        print OUTFILE "        alu[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], OR, $Name[$SRAM[$i]]]\n";
      }
      print OUTFILE "     #endif\n";
    }
    elsif($SRAMOffset_bits[$SRAM[$i]] eq 0)
    {
        print OUTFILE "        alu_shf[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], --, B, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], >>$Size[$SRAM[$i]]]\n";
        print OUTFILE "        alu_shf[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], --, B, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], <<$Size[$SRAM[$i]]]\n";
        print OUTFILE "        alu[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $Name[$SRAM[$i]], OR, dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX]]\n";
    }
    else  #arbitrary field size
    {
         $a =  $Size[$SRAM[$i]] + $SRAMOffset_bits[$SRAM[$i]];
         print OUTFILE "    bitfield_insert[dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], dl_meta[SRAM_$UName[$SRAM[$i]]_LW_INDEX], $Name[$SRAM[$i]], $a, SRAM_$UName[$SRAM[$i]]_OFFSET_BITS] \n";
    }
    #else
    #{

     # if ($Rotate[$SRAM[$i]] ne <undef>)
     # {
     #   print OUTFILE "    ld_field[dl_meta_sram[SRAM_$Name[$SRAM[$i]]_LW_INDEX], $Mask[$SRAM[$i]], $Name[$SRAM[$i]]], <<$Rotate[$SRAM[$i]]\n";
     # }
     # else
     # {
     #   print OUTFILE "    ld_field[dl_meta_sram[SRAM_$Name[$SRAM[$i]]_LW_INDEX], $Mask[$SRAM[$i]], $Name[$SRAM[$i]] ]\n";
     # }
   # }
    print OUTFILE ".end\n";
    print OUTFILE "#endm\n\n\n";

  } #for ($i=0; $i<=$#SRAM; $i++)
  


  print OUTFILE "/**********************************************************************\n";
  print OUTFILE "*  dl_meta_init_cache:\n";
  print OUTFILE "*     Description:    Initialize the metadata cache with given values.\n";
  print OUTFILE "*     Outputs:        None\n";
  print OUTFILE "*     Inputs:         8 words of data to be written in xbuf registers\n";
  print OUTFILE "*\n";
  print OUTFILE "*     Size:\n";
  print OUTFILE "*                     1 - 7 instruction\n";
  print OUTFILE "**********************************************************************/\n";
  print OUTFILE "#macro dl_meta_init_cache[";
  for($i=0; $i<$total-1; $i++)
  {
	print OUTFILE "d$i, ";
  }
  print OUTFILE "d$total]\n";
  print OUTFILE ".begin\n";
  print OUTFILE "    #if (!isnum(d0))\n";
  print OUTFILE "        alu[dl_meta[0], --, B, d0]\n";
  print OUTFILE "    #endif\n";

  for ($i=1; $i<$total;$i++)
  {
  print OUTFILE "    #if ((!isnum(d$i)) && (META_CACHE_SIZE >$i))\n";
  print OUTFILE "        alu[dl_meta[$i], --, B, d$i]\n";
  print OUTFILE "    #endif\n";
  }
  
  print OUTFILE ".end\n";
  print OUTFILE "#endm\n\n\n";

  print OUTFILE "/**********************************************************************************\n";
  print OUTFILE "*  dl_meta_flush_cache:\n";
  print OUTFILE "*     Description:       Flushes the cache of meta data in GPR to SRAM.\n";
  print OUTFILE "*                        How the data comes to cache is TBD\n";
  print OUTFILE "*     Outputs:           None\n";
  print OUTFILE "*     Inputs:   \n";
  print OUTFILE "*         wxfer_prefix:   Write transfer register prefix\n";
  print OUTFILE "*                         using xbuf_alloc. At least NUM_LW\n";
  print OUTFILE "*                         wxfer registers should have been allocated\n";
  print OUTFILE "*         buf_handle      Handle to SRAM buffer\n";
  print OUTFILE "*         req_sig:        Signal to be used in I?O operation\n";
  print OUTFILE "*         sig_action:     What to do with I/O operation -\n";
  print OUTFILE "*                         - wait for signal(s) as specified by signal action\n";
  print OUTFILE "*                         - do not wait for signal, just return (SIG_NONE)\n";
  print OUTFILE "*                         If 'DL_SPLIT_META_DATA' is defined and the meta data to\n";
  print OUTFILE "*                         flush spans 2 SRAM channels, signal 'sig_action1' will be \n";
  print OUTFILE "*                         used by this macro. It needs to be defined by the code that\n";
  print OUTFILE "*                         calls this macro\n";
  print OUTFILE "*     Size:\n";
  print OUTFILE "*       1 - 7 instruction\n";
  print OUTFILE "**********************************************************************************/\n";
  print OUTFILE "#macro dl_meta_flush_cache[wxfer_prefix, buf_handle, req_sig, sig_action, START_LW, NUM_LW] \n";
  print OUTFILE ".begin\n";
  print OUTFILE "    .reg INDEX, sram_offset\n";
  print OUTFILE "    #define_eval INDEX 0\n";
  print OUTFILE "    #define_eval END_LW  (START_LW + NUM_LW)\n\n";
  print OUTFILE "    #while  INDEX < META_CACHE_SIZE\n";
  print OUTFILE "        #if ((START_LW <= INDEX) && (END_LW > INDEX))\n";
  print OUTFILE "           alu[wxfer_prefix[INDEX], --, B, dl_meta[INDEX]]\n";
  print OUTFILE "        #endif\n";
  print OUTFILE "        #define_eval INDEX (INDEX+1)\n";
  print OUTFILE "    #endloop\n\n";
  print OUTFILE "    #undef INDEX \n";
  print OUTFILE "    #undef END_LW \n\n";

  print OUTFILE "    /* Get the SRAM offset for the metadata*/\n";
  print OUTFILE "    dl_buf_get_desc[sram_offset, buf_handle]\n";
  print OUTFILE "    /* Write the metadata to SRAM*/\n\n";
  print OUTFILE "    #define_eval START_INDEX START_LW\n";
  print OUTFILE "    #define_eval START_BYTE (START_LW*4)\n";
  print OUTFILE "    sram[write, wxfer_prefix[START_INDEX], sram_offset, START_BYTE, NUM_LW], sig_done[req_sig]\n";
  print OUTFILE "    #undef START_INDEX \n\n";
  print OUTFILE "    #if (!streq('sig_action', 'SIG_NONE'))\n";
  print OUTFILE "       ctx_arb[sig_action]\n";
  print OUTFILE "    #endif\n";
  print OUTFILE ".end\n";
  print OUTFILE "#endm\n\n\n";


  print OUTFILE "/**********************************************************************************\n";
  print OUTFILE "*  dl_meta_load_cache:\n";
  print OUTFILE "*     Description:       Flushes the cache of meta data to SRAM.\n";
  print OUTFILE "*                        How the data comes to cache is TBD\n";
  print OUTFILE "*     Outputs:           None\n";
  print OUTFILE "*     Inputs:   \n";
  print OUTFILE "*         buf_handle      Handle to SRAM buffer\n";
  print OUTFILE "*         dl_meta         GPR allocated using xbuf_alloc\n";
  print OUTFILE "*         req_sig:        Signal to be used in I?O operation\n";
  print OUTFILE "*                         If 'DL_SPLIT_META_DATA' is defined and the meta data to\n";
  print OUTFILE "*                         flush spans 2 SRAM channels, signal 'sig_action1' will be \n";
  print OUTFILE "*                         used by this macro. It needs to be defined by the code that\n";
  print OUTFILE "*                         calls this macro\n";
  print OUTFILE "*     Size:\n";
  print OUTFILE "*       1 - 7 instruction\n";
  print OUTFILE "**********************************************************************************/\n";
  print OUTFILE "#macro dl_meta_load_cache[buf_handle, dl_meta, req_sig, START_LW, NUM_LW] \n";
  print OUTFILE ".begin\n";
  print OUTFILE "   .reg sram_offset\n";
  print OUTFILE "   /* Get the SRAM offset for the metadata*/\n";
  print OUTFILE "    dl_buf_get_desc[sram_offset, buf_handle]\n\n";
  print OUTFILE "    /* Read the metadata to SRAM*/\n\n";
  print OUTFILE "    #define_eval TEMP_SRAM_OFFSET     (START_LW*4)\n";
  print OUTFILE "    #define_eval START_INDEX           START_LW\n";
  print OUTFILE "    sram[read, dl_meta[START_INDEX], sram_offset, TEMP_SRAM_OFFSET, NUM_LW], sig_done[req_sig]\n";
  print OUTFILE "    #undef TEMP_SRAM_OFFSET \n\n";
  print OUTFILE "    #undef START_INDEX \n\n";
  print OUTFILE ".end\n";
  print OUTFILE "#endm\n\n\n";
  
  print OUTFILE "#endif\n";
  close(OUTFILE);
  close(BUFFER);
}


#*********************************************************************
#** SUBROUTINE    : GetReverseByte()
#** DESCRIPTION   :
#       Reverse of byte
#** INPUT        : Byte in binary
#** OUTPUT       : None.
#*********************************************************************

sub GetReverseByte()
{

  my $b1 = @_[0], $res = 0, $inde = @_[1];

  if ($b1 & 0x1)
  {
    return ($b1);
  }
  if ($b1 eq "1100")
  {
    $res = "0011";
  }
  elsif ($b1 eq "1110")
  {
    $res = "0111";
  }
  elsif (($b1 eq "0100") || ($b1 eq "0010") || ($b1 eq "1000"))
  {
    $res = "0001";
  }

  elsif ($b1 eq "0110")
  {
    $res = "0011";
  }
  
  

  return ($res);
}

#*********************************************************************
#** SUBROUTINE    : PrintBuffer()
#** DESCRIPTION   :
#       This xscale structure to buffer.h
#** INPUT        : HANDLE to the file
#** OUTPUT       : None.
#*********************************************************************

sub PrintBuffer()
{

  my $HANDLE = @_[0];
  PrintHeader($HANDLE, $bufferfilename);
  print $HANDLE "#if !defined(__BUFFER_H__)\n";
  print $HANDLE "#define __BUFFER_H__\n";
  print $HANDLE "#if defined(__cplusplus)\n";
  print $HANDLE "extern \"C\"\n";
  print $HANDLE "{\n";
  print $HANDLE "#endif /* end defined(__cplusplus) */  \n";
  print $HANDLE "/**\n";
  print $HANDLE "* DESCRIPTION: This symbol will declare all the fields and the layout of the common\n";
  print $HANDLE "*          part of the buffer meta data. Applications that need extra fields can do\n";
  print $HANDLE "*          so in the following manner without the expense of an extra indirection.\n";
  print $HANDLE "*          typedef struct ix_s_atm_buffer_meta\n";
  print $HANDLE "*          {\n";
  print $HANDLE "*              IX_DECLARE_HW_BUFFER_META_DATA\n";
  print $HANDLE "*              ix_uint32       m_CellHeader;\n";
  print $HANDLE "*          } ix_atm_buffer_meta;\n";
  print $HANDLE "*\n";
  print $HANDLE "*/\n";

  print $HANDLE "#define IX_DECLARE_HW_BUFFER_META_DATA \\\n";
  print $HANDLE "{\n";

  PrintStructure(@_[0], "");

  
   print $HANDLE "}\n\n\n";
   print $HANDLE "/** \n";
   print $HANDLE "* TYPENAME: ix_hw_buffer_meta\n";
   print $HANDLE "*\n";
   print $HANDLE "* DESCRIPTION: This structure defines the information and the layout of the common\n";
   print $HANDLE "*          buffer meta data. If applications will need to add extra fields then they\n";
   print $HANDLE "*          can do so.\n";
   print $HANDLE "*\n";
   print $HANDLE "*/\n";
   print $HANDLE "typedef struct ix_s_hw_buffer_meta\n";
   print $HANDLE "{                                     \n";
   print $HANDLE "    IX_DECLARE_HW_BUFFER_META_DATA\n";
   print $HANDLE "} ix_hw_buffer_meta;\n";

  print $HANDLE "#if defined(__cplusplus)\n";
  print $HANDLE "}\n";
  print $HANDLE "#endif /* end defined(__cplusplus) */\n";

  print $HANDLE "#endif /* end !defined(__BUFFER_H__) */\n";

}
 
#*********************************************************************
#** SUBROUTINE    : PrintStructure()
#** DESCRIPTION   :
#       This xscale structure to buffer.h
#** INPUT        : HANDLE to the file
#** OUTPUT       : None.
#*********************************************************************

sub PrintStructure()
{
my $HANDLE=@_[0], $t=@_[1], $rescount=0;
for ($i=0; $i<=$#GroupedSRAM; $i++)
  {
    print $HANDLE "$t    /* Longword $i */\n";
    for($j=0; $j<=$SizeOfGroup[$i]-1; $j++)
    {
      $index = $GroupedSRAM[$i][$j];
      if ($index == $#ValidNames)
      {
        $tsize = $ReservedSize[$i][$j];
        $tname = "$ValidNames[$index]$rescount";
        $rescount++;
      }
      else
      {
        $tsize = $Size[$index];
        $tname = $Name[$index];
      }
      if ($tsize >= 17 &&  $tsize <= 32)
      {
        print $HANDLE "$t   ix_uint32    m_$tname  /* $tsize bits*/\n";
      }
      elsif ($tsize >= 1 &&  $tsize <= 8)
      {
        print $HANDLE "$t   ix_uint8    m_$tname    /* $tsize bits*/\n";
      }
      elsif ($tsize >= 9 &&  $tsize <= 16)
      {
        print $HANDLE "$t   ix_uint16    m_$tname    /* $tsize bits*/\n";
      }
    }
  }
}

 
#*********************************************************************
#** SUBROUTINE    : Print_names()
#** DESCRIPTION   :
#       Print all the valid metadata names to the console
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub Print_names()
{
  print "Valid Metadata Names are:\n";

  for($i=0; $i<=$#ValidNames; $i++)
  {
    print "$ValidNames[$i]  ";
  }
}





#*********************************************************************
#** SUBROUTINE    : ReadListFile()
#** DESCRIPTION   :
#       Open and parse the list file.
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub ReadListFile()
{
  my $fieldindex = 0, $index, $fileindex, $ind, $i=0;
  my $found = 0, $Sflag = 0, $Aflag = 0, $Pflag = 0, $nfound = 0, $cfind = 0;
  my @t;
  @t = split('\.', $listfilename);
  $junkfile = "../../junkfile.jnk";
  open (JUNKFILE, "$junkfile") || die "Please re-run the tool with -a option";
  foreach(<JUNKFILE>)
  {
    $len = length;
    if ($len <= 1)
    {
      goto endloop;
    }
    if( /\S/ )
      {
        s/^\s*(.*?)\s*$/$1/;
        s/\\/ /g;
       }
    my @a = split(' ', $_);
    if (($a[0] cmp "dFILE") eq 0)
    {
        @a = split('/', $a[1]);
        @a = split('\.', $a[$#a]);
        push(@DLFilename, $a[0]);
    }
    elsif (($a[0] cmp "uFILE") eq 0)
    {
        push(@uBlockFilename, $a[1]);
        $OrderConfigFile[$cfind] = $cfind;
        $cfind++;
    }
    elsif (($a[0] cmp "DLu") eq 0)
    {
      $DLuBlockIndex[$a[1]][$a[2]] = $a[3];
      $DLuBlockSize[$a[1]] = $a[2];
    }
    elsif (($a[0] cmp "SC") eq 0)
    {
      $Size[$a[1]] = $a[2];
    }
    elsif (($a[0] cmp "IF") eq 0)
    {
      $ind = $a[1];
      $InFileSize[$ind]= $a[2];
      $InFile[$ind][$InFileSize[$ind]-1] = $a[3];
    }
    else
    {
      $fileindex = $a[0];
      $MaxConfigFile = $a[0];
      $SizeOfConfig[$fileindex] = $a[1];
      $Config[$fileindex][$SizeOfConfig[$fileindex]] = $a[2];

      $ind = $a[3];
      $InFileSize[$ind] = $a[4]-1;
      $InFile[$ind][$InFileSize[$ind]] = $a[5];

      $Name[$i] = $a[6];
      $Access[$i] = $a[7];
      $Size[$i] = $a[8];
      $Memory[$i] = $a[9];

      $SRAM[$i] = $i;
      $i++;
    }
    endloop:
   }
  open (LISTFILE, "$listfilename") || die "Cannot open $listfilename";

  
  foreach(<LISTFILE>)
  {

    if (/^#/)
    {
      goto forend;
    }
    $len = length;
    if ($len <=5 )
    {
      goto forend;
    }

    @t = split(':', $_);
    $t[0] = lc $t[0];
    $s="name";
         
    $tplace = $_;
    $_ = $t[1];
    if( /\S/ )
    {
        s/^\s*(.*?)\s*$/$1/;
        s/\\/ /g;
    }
       $t[1] = $_;
        $_ = $tplace;
    if (($found eq 0) && ($_ ne "") && (($t[0] cmp $s) ne 0))
    {
      	print "ERROR: fieldname 'Name:' missing in $listfilename\n";
        Cleanup(0);
		  	exit;
    }

    if (/Name:/i)
    {
      if (($Sflag == 0 || $Aflag == 0 || $Pflag == 0) && ($found == 1))
      {
        print "ERROR: Missing field attribute. Please check $listfilename\n";
        Cleanup(0);
		    exit;
      }
      my @namefield = split(':', $_);
      $tplace = $_;
      $_ = $namefield[1];
      if( /\S/ )
      {
        s/^\s*(.*?)\s*$/$1/;
        s/\\/ /g;
       }
       $namefield[1] = $_;
       $_ = $tplace;
      $found = 0;
      $Sflag = 0;
      $Aflag = 0;
      $Pflag = 0;
       $namefield[1] = lc $namefield[1];
      for ($i=0; $i<=$#Name && $found == 0; $i++)
      {
        $tmpname = lc $Name[$i];
        if ( ($namefield[1] cmp $tmpname) eq 0)
        {
          $found = 1;
          $fieldindex = $i;
          $nfound = 1;
        }
      }#for ($i=0; $i<=$#Name && $found == 0; $i++)
        if ($found == 0)
        {
          print "ERROR: Invalid metadata fieldname found in the $listfilename list file\n";
          Cleanup(0);
          exit;
        }
        goto forend;
      }#if (/Name:/i)
    if ($found)
    {
        if (/Size:/i)
			  {
	   			if (/\./)
  				{
		  		  print "ERROR: Size should be an Integer Constant\n";
				    print "       Please check $listfilename\n";
            Cleanup(0);
				    exit;
  				}
		  	  @Sizef = split(':', $_);
          if ($Sizef[1] >= 64)
          {
             print "ERROR: Size of 64 or greater is not supported\n";
				     print "       Please check $listfilename\n";
             Cleanup(0);
				     exit;
          }
          if ($Sizefields[1] >= 33)
          {
             print "ERROR: Size of 32 or greater is not supported in this phase\n";
				     print "       Please check $listfilename\n";
             Cleanup(0);
				     exit;
          }
			   $Sflag = 1;
         if ($Size[$fieldindex] > int($Sizef[1]))
         {
           $Size[$fieldindex] = int($Sizef[1]);
         }
  		  }# if (/Size/i)
			  elsif (/Access:/i)
			  {
				  @Accessf = split(':', $_);
				  $Aflag = 1;
          $Access[$fieldindex] = $Accessf[1];
			  }

			  elsif (/Priority:/i)
			  {
			   	@Memf = split(':', $_);
			    $Pflag = 1;
          $Memory[$fieldindex] = int($Memf[1]);
			  }
        elsif (/Longwd_Offset/i)
        {
          my $tmpmask = 0, $newmask = 0, @newByte;
          @newByte = split (":", $_);
          @newByte = split (" ", $newByte[1]);

          if ($newByte[0] > 16 || $newByte[1] > 32)
          {
             print "ERROR: Invalid Longword and Offset number\n";
             print "       Please check the $listfilename file\n";
             Cleanup(0);
             exit;
          }
          if ($newByte[1]%4)
          {
             print "ERROR: Invalid Offset number field $Name[$fieldindex].\n";
             print "       Should be multiple of 4\n";
             print "       Please check the $listfilename file\n";
             Cleanup(0);
             exit;
          }
        #Check for available bits in that byte
          if ($SRAMBitsRemain[$newByte[0]]  < $Size[$fieldindex])
          {
             print "ERROR: Few number of bits are available at $newByte[0] from Offset $newByte[1]\n";
             print "       for field $Name[$fieldindex]\n";
             print "       $newByte[0] cannot be reserved for $Name[$fieldindex]\n";
             goto forend;
          }



          $newmask = GenerateMask($Size[$fieldindex]);
          for($i=0; $i<$newByte[1]; $i++)
          {
           $newmask = ($newmask << 1);
          }

          if ($SRAMByteMask[$newByte[0]] & $newmask )
          {
             print "ERROR: Byte $newByte[0] Offset $newByte[1] for field $Name[$fieldindex]\n";
             print "       cannot be reserved\n";
             goto forend;
          }
          $GroupedSRAM[$newByte[0]][$SizeOfGroup[$newByte[0]]] = $fieldindex;
          $SizeOfGroup[$newByte[0]] = $SizeOfGroup[$newByte[0]] + 1;
          $SRAMByteIndex[$fieldindex] = $newByte[0];
          $SRAMOffset[$fieldindex] = $newByte[1]/8;
          $SRAMOffset_bits[$ind] = $newByte[1];
          $Grouped[$fieldindex] = 1;
          $SRAMByteMask[$newByte[0]] |= $newmask;
          $SRAMBitsRemain[$newByte[0]] =($SRAMBitsRemain[$newByte[0]] - $Size[$fieldindex]);
          $SRAMtotSize += $Size[$fieldindex];
          

        }
			  elsif ($len >5)
			  {
			   	print "ERROR: Invalid attribute or attribute missing in $filename\n";
          Cleanup(0);
			   	exit;
			  }
    } #if($found)


    forend:
  }# foreach(<LISTFILE>)
  if ($nfound  == 0)
  {
    print "ERROR: Invalid list file\n";
    Cleanup(0);
    exit;
  }
  close(LISTFILE);
}

#*********************************************************************
#** FUNCTION    : GenerateMask()
#** DESCRIPTION :
#       This function generate mask for the specified value
#** INPUT      : Value
#** OUTPUT     : Mask.
#*********************************************************************
sub GenerateMask()
{
  my $i, $result=1;
  my @myparms = @_;
  for ($i = 1; $i < $myparms[0]; $i++)
  {
    $result = ($result << 1) | 1;
  }
  return $result;
}

#*********************************************************************
#** SUBROUTINE    : PrintUsage()
#** DESCRIPTION   :
#       Print usage to the console.
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub PrintUsage()
{
    print "usage: metadataTool.pl -a <Application config file>.cfg\n";
    print "OR   : metadataTool.pl -l <list file>.lst\n";
    print "       The <Application config file>.cfg contains list of <dispatch loop>.cfg filesb\n";
    print "       <dispatch loop>.cfg contains list of <ublock>.cfg files\n";
    print "       <list file>.lst is the file generated by the metadata tool in the 1st round\n";
}




#*********************************************************************
#** SUBROUTINE    : PrintHeader()
#** DESCRIPTION   :
#       Print Intel Propietary header to the file.
#** INPUT        : File Handle
#** OUTPUT       : None.
#*********************************************************************
sub PrintHeader()
{
  my $HANDLE = $_[0];
  my $fn = $_[1];
  print $HANDLE "/*--------------------------------------------------------------------\n";
  print $HANDLE "*                   I N T E L   P R O P I E T A R Y\n";
  print $HANDLE "*     COPYRIGHT (c) 2001 BY INTEL CORPORATION. ALL RIGHTS\n";
  print $HANDLE "*     RESERVED. NO PART OF THIS PROGRAM OR PUBLICATION MAY\n";
  print $HANDLE "*     BE REPRODUCED, TRANSMITTED, TRANSCRIBED, STORED IN A\n";
  print $HANDLE "*     RETRIEVAL SYSTEM, OR TRANSLATED INTO ANY LANGUAGE OR \n";
  print $HANDLE "*     COMPUTER LANGUAGE IN ANY FORM OR BY ANY MEANS, ELECTRIC,\n";
  print $HANDLE "*     MECHANICAL, MAGNETIC, OPTICAL, CHEMICAL, MANUAL OR OTHERWISE\n";
  print $HANDLE "*     WITHOUT THE PRIOR WRITTEN PERMISSION OF :\n";
  print $HANDLE "*                        INTEL   CORPORATION\n";
  print $HANDLE "*                 \n";
  print $HANDLE "*                       2200 MISSION COLLEGE BLVD\n";
  print $HANDLE "* \n";
  print $HANDLE "*                   SANTA CLARA,  CALIFORNIA  95052-8119\n";
  print $HANDLE "* \n";
  print $HANDLE "*--------------------------------------------------------------------\n";
  print $HANDLE "*********************************************************************\n";
  print $HANDLE "* \n";
  print $HANDLE "* \n";
  print $HANDLE "*      File Name:  $fn \n";
  print $HANDLE "*      \n";
  print $HANDLE "*      Purpose:\n";
  print $HANDLE "* \n";
  print $HANDLE "*      History:\n";
  print $HANDLE "* \n";
  print $HANDLE "*      Date           Comment                By\n";
  print $HANDLE "*      --------------------------------------------------------------\n";
  print $HANDLE "*      $mon/$mday/$year       Initial Creation      Kalpana Roge\n";
  print $HANDLE "* \n";
  print $HANDLE "********************************************************************/\n";



}

#*********************************************************************
#** SUBROUTINE    : Initialize()
#** DESCRIPTION   :
#       Initialize all global variables.
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub Initialize()
{
  $MAXSRAMSIZELW = 16;
  for($i=0; $i<$MAXSRAMSIZELW; $i++)
  {
    $SRAMBitsRemain[$i] = 32;
    $SRAMByteIndex[$i] = 0;
    $SRAMByteMask[$i] = 0;
  }
  $SRAMtotSize = 0;
  for($i=0; $i<20;$i++)
  {
    $InFileSize[$i] = 0;

  }
  
  for ($i=0; $i<=$#ValidNames; $i++)
  {
    if ($Grouped[$i] ne 1)
    {
      $Grouped[$i] = 0;
    }
  }
}

#*********************************************************************
#** SUBROUTINE    : Cleanup()
#** DESCRIPTION   :
#       Clean up all the files created.
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub Cleanup()
{
  my $s = @_[0];
  
  close($BufferFilename);
  close($MacroFilename);
  close($listfilename);
  close($junkfile);
  if (-e  $BufferFilename)
  {
    system ("rm $BufferFilename");
  }
  if (-e  $MacroFilename)
  {
    system ("rm $MacroFilename");
  }
  if ($s eq 1)
  {
    if (-e  $listfilename)
    {
     system ("rm $listfilename");
    }

    if (-e  $junkfile)
    {
      system ("rm $junkfile");
    }
  }
   print "\n\n\n";
}

#*********************************************************************
#** SUBROUTINE    : MainControl()
#** DESCRIPTION   :
#       Main routine.
#** INPUT        : None
#** OUTPUT       : None.
#*********************************************************************
sub MainControl()
{

  if ($#ARGV < 0)
  {
    PrintUsage();
    exit;
  }


  if ($ARGV[0] eq "-a")
  {
    $MainConfigFile = $ARGV[1];
    print "Parsing $MainConfigFile ...\n";
    ProcessArg();
    print "DONE...........\nPlease check $listfilename and re-run the tool with -l option\n";
    goto done;
  }
  elsif ($ARGV[0] eq "-l")
  {
    $listfilename = $ARGV[1];
    print "Parsing $listfilename ...\n";
    Initialize();
    ReadListFile();
    GroupFields();
    WriteToFile();
    print "DONE........\n";
    #CreatePipelineFile();
  }
  else
  {

    PrintUsage();
    exit;
  }
  

  done:


}

