/**
 * ============================================================================
 * = COPYRIGHT
 *              INTEL CORPORATION PROPRIETARY INFORMATION
 *   This software is supplied under the terms of a license agreement or
 *   nondisclosure agreement with Intel Corporation and may not be copied 
 *   or disclosed except in accordance with the terms in that agreement.
 *      Copyright (C) 2000-2001 Intel Corporation. All rights reserved.
 *
 * = PRODUCT
 *      Intel(r) IXA SDK 3.0 for the IXP2X00 Network Processor
 *
 * = FILENAME
 *    print_freelist_linux_user_app.c
 *
 * = DESCRIPTION
 *    This file contains linux user mode application that 
 *    can be used to in target shell for printing available buffers in freelist 
 *    
 *
 * = CHANGE HISTORY
 *      05/08/2003 - Created.
 *
 * ============================================================================
 * $Id: print_freelist_linux_user_app.c,v 1.2 2003/07/12 01:50:51 rranjeet Exp $
 */
#include <fcntl.h>
#include "print_freelist_linux_kernel_module.h"

void print_freelist_usage(void);

int main(int argc, char *argv[])
{

    int fd;
    int cmd;

    if (argc == 1)
    {
        print_freelist_usage();
        exit(0);
    }


    cmd = atoi(argv[2]);

    fd = open("/dev/PConfig", O_CREAT | O_RDWR);

    ioctl(fd, cmd, 0);

    close(fd);

    return 0;

} /* main */



void print_freelist_usage(void)
{
    printf("\nUSAGE: print_freelist <cmd> <\"args\">\n\n");
    printf(" where <cmd> <\"args\"> pair can be one of the followings: \n");
    printf("  print_available_buffers freelist_id\"\n");
}
