#*****************************************************************************
#                            Intel Proprietary
#
# Copyright (c) 1998-2003 By Intel Corporation.  All rights reserved.  
# No part of this program or publication may be reproduced, transmitted,
# transcribed, stored in a retrieval system, or translated into any language
# or computer language in any form or by any means, electronic, mechanical,
# magnetic, optical, chemical, manual, or otherwise, without the prior
# written permission of:
#                        Intel Corporation
#                        2200 Mission College Blvd.
#                        Santa Clara, CA  95052-8119
#****************************************************************************

from Tkinter import *
from Dialog import *
import tkMessageBox
import tkSimpleDialog
import tkFileDialog
import os, string, re, time
import socket, thread
import os.path



CPPDK_CONST = 1000
CPPDK_CONNECT_REQ = CPPDK_CONST + 1
CPPDK_DISCONNECT_REQ = CPPDK_CONST + 2
CPPDK_EVENT = 34567
EVENT_PRIORITY_NORMAL = 0
EVENT_PRIORITY_MEDIUM = 1
EVENT_PRIORITY_HIGH = 2
EVENT_PRIORITY_CRITICAL = 3
MAX_PORT_COUNT = 4
 
CPPUI_EVENT_FE_BIND=0
CPPUI_EVENT_FE_UNBIND=1
CPPUI_EVENT_FE_PORT=2
CPPUI_EVENT_PORT_LINK_UP=3
CPPUI_EVENT_PORT_LINK_DOWN=4
CPPUI_EVENT_IF_UP=5
CPPUI_EVENT_IF_DOWN=6
 
CPPUI_NO_ERROR = '0'
CppuiEvents = {}
CppuiReqResp = {}
CppuiSeperator1 = '~~~~~~~~~~~~~~~~~~~~~~~~~~'
 
class ReqResp:
    def __init__(self, name, id):
        self.sequence = 0
        self.name = name
        self.id = string.strip(id)
        self.args = []
        self.err = 0
        self.ct = "0:0:0"
        self.resp = "RESPONSE NOT RECEIVED"
         
    def save(self):
        CppuiReqResp[str(self.sequence)] = self
     
    def count(self, seq):
        self.sequence = seq
     
    def name(self, name):
        self.name = name
     
    def type(self):
        return(self.id)
     
    def seq(self):
        return(self.sequence)
     
    def arg(self, nv):
        self.args.append(nv)
     
    def output(self, msg):
        self.resp = msg
        self.ct = time.asctime(time.localtime())
     
    def error(self, err):
        self.err = err
     
    def geterror(self):
        return(self.err)
     
    def command(self, selftest = 0):
        cmd = str(self.sequence) + ';'
        cmd = cmd + self.id + ';'
        for arg in self.args:
            cmd = cmd + arg[1] + ';'
        cmd = cmd + str(selftest)
        return(str(cmd))
     
    def hdr(self):
        hdr = self.name + '(' + self.id + ')'
        return(hdr)
     
    def text(self):
        txt = ''
        hdr = self.name + '(' + self.id + ')'
        txt = '[' + str(self.sequence) + ']\t' + hdr + '\n\t\t\t\t' + self.ct
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1
        txt = txt + '\n\t' + self.resp
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1
        for arg in self.args:
            nm = arg[0]
            val = arg[1]
            txt = txt + '\n' + nm + ' : ' + val
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1 + '\n'
        return(txt)
     
    def getdescr(self):
        txt = ''
        hdr = '\n(' + str(self.sequence) + ')' + self.name
        txt = hdr
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1
        for arg in self.args:
            nm = arg[0]
            val = arg[1]
            txt = txt + '\n' + nm + ' : ' + val
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1 + '\n'
        return(txt)
#---------------------------------------------------------
 
class CppuiEvent:
    def __init__(self, name, id, prio = 0, des = "Not Available"):
        self.seq = 0
        self.name = name
        self.id = string.strip(id)
        self.prio = prio
        self.descr = des
        self.ct = time.asctime(time.localtime())
        self.args = []
     
    def arg(self, nv):
        self.args.append(nv)
     
    def count(self, c):
        self.seq = c
     
    def save(self):
        CppuiEvents[self.seq] = self
     
    def text(self):
        txt = '\t\t E V E N T \n' + CppuiSeperator1 + CppuiSeperator1 + '\n'
        hdr = self.name + '(' + self.id + ')'
        txt = txt + '[' + str(self.seq) + ']\t' + hdr + '\n\t\t\t' + self.ct
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1
        for arg in self.args:
            nm = arg[0]
            val = arg[1]
            txt = txt + '\n' + nm + ' : ' + val
        txt = txt + '\n' + CppuiSeperator1 + CppuiSeperator1
        txt = txt + '\n'
        return(txt)
     
#---------------------------------------------------------
 
class Dialog(Toplevel):
    def __init__(self, parent, sel = 0, title = None):
        Toplevel.__init__(self, parent)
        self.transient(parent)
        if title:
            self.title(title)
        self.parent = parent
        self.result = None
        self.sel = sel
        body = Frame(self)
        self.initial_focus = self.body(body)
        body.pack(padx=5, pady=5)
        self.buttonbox()
        self.grab_set()
        if not self.initial_focus:
            self.initial_focus = self
        
        self.protocol("WM_DELETE_WINDOW", self.cancel)
        self.geometry("+%d+%d" % (parent.winfo_rootx()+50,parent.winfo_rooty()+50))
        self.initial_focus.focus_set()
        self.wait_window(self)
    def body(self, master):
        # create dialog body. return widget that should have
        # initial focus. this method should be overridden
        pass
    
    def buttonbox(self):
        # add standard button box. override if you don't want the
        # standard buttons
        box = Frame(self)
        w = Button(box, text="OK", width=5, command=self.ok, default=ACTIVE)
        w.pack(side=LEFT, padx=5, pady=5)
        if(self.sel):
            w = Button(box, text="Select", width=5, command=self.Select, default=ACTIVE)
            w.pack(side=LEFT, padx=5, pady=5)
        w = Button(box, text="Cancel", width=5, command=self.cancel)
        w.pack(side=LEFT, padx=5, pady=5)
        self.bind("&lt;Return>", self.ok)
        self.bind("&lt;Escape>", self.cancel)
        box.pack()
    def validate(self):
        return 1 # override
    
    # standard button semantics
    def ok(self, event=None):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def cancel(self, event=None):
        # put focus back to the parent window
        self.parent.focus_set()
        self.destroy()
    def apply(self):
        pass # override
    def Select(self):
        pass # override
    def Enums(self, entry, enums, show):
        if(not show):
            return
        ht = len(enums)
        wd = 25
        if(not self.listbox):
            self.listbox = Listbox(self, bg="white", fg="blue", height=ht, width=50)
        for key in enums.keys():
            self.listbox.insert(END, key)
        self.listbox.config(width=wd)
        self.listbox.pack(side=BOTTOM, fill=BOTH)
#---------------------------------------------------------

class EventDialog(Toplevel):
    def __init__(self, parent, title = None):
        Toplevel.__init__(self, parent)
        self.transient(parent)
        if title:
            self.title(title)
        self.parent = parent
        self.result = None
        body = Frame(self)
        self.initial_focus = self.body(body)
        body.pack(padx=5, pady=5)
        self.buttonbox()
        self.grab_set()
        if not self.initial_focus:
            self.initial_focus = self
        
        self.protocol("WM_DELETE_WINDOW", self.cancel)
        self.geometry("+%d+%d" % (parent.winfo_rootx()+50,parent.winfo_rooty()+50))
        self.initial_focus.focus_set()
        self.wait_window(self)
    def body(self, master):
        # create dialog body. return widget that should have
        # initial focus. this method should be overridden
        pass
    
    def buttonbox(self):
        # add standard button box. override if you don't want the
        # standard buttons
        box = Frame(self)
        w = Button(box, text="Ok", width=10, command=self.ok, default=ACTIVE)
        w.pack(side=LEFT, padx=5, pady=5)
        self.bind("&lt;Return>", self.ok)
        self.bind("&lt;Escape>", self.cancel)
        box.pack()
    def validate(self):
        return 1 # override
    
    # standard button semantics
    def ok(self, event=None):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def cancel(self, event=None):
        # put focus back to the parent window
        self.parent.focus_set()
        self.destroy()
    def apply(self):
        pass # override
#---------------------------------------------------------

class ConnectDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        Dialog.__init__(self, parent, title="CPPDK Connect")
    
    def body(self, master):
        row = 0
        Label(master,text="IP Address:").grid(row=row, column=14)
        self.IpAddressEntry  = Entry(master, width=15, relief=SUNKEN)
        self.IpAddressEntry.grid(row=row, column=22)
        self.IpAddressEntry.insert(0, self.cppdk.host)
        row = row + 1
        Label(master,text="Port:").grid(row=row, column=14)
        self.PortNoEntry = Entry(master, width=15, relief=SUNKEN)
        self.PortNoEntry.grid(row=row, column=22)
        self.PortNoEntry.insert(0, "7890")
        return self.IpAddressEntry
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    
    def apply(self):
        self.cppdk.host = string.strip(self.IpAddressEntry.get())
        try:
            self.cppdk.port = int(self.PortNoEntry.get())
        except:
            tkMessageBox.showerror("Port Error", "Invalid Port")
        if(self.cppdk.sock != None):
            reqresp = ReqResp("Connect", str(CPPDK_CONNECT_REQ))
            self.cppdk.Send(reqresp)
    
    def operation(self, event=None):
        pass
#---------------------------------------------------------

class LogDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        lf = ''
        try:
            if(self.cppdk.log == 0):
                types = []
                types.append(('log', '*.log'))
                types.append(('all', '*.*'))
                lf = tkFileDialog.askopenfilename(initialdir=self.cppdk.LOG_DIR, defaultextension="log", filetypes=types, initialfile=self.cppdk.LOG_FILE)
                if(not len(lf)):
                    return
            else:
                lf = self.cppdk.lf
            log = open(lf)
            self.lines = log.readlines()
            log.close()
        except:
            tkMessageBox.showerror("Log Error", "Error while opening Log file")
        Dialog.__init__(self, parent, title="CPPUI LOG")
    
    def body(self, master):
        scrollbar = Scrollbar(master)
        scrollbar.pack(side=RIGHT, fill=Y)
        listbox = Listbox(master, bg="white", fg="brown", height=35, width=100, yscrollcommand=scrollbar.set)
        try:
            if(len(self.lines) == 0):
                listbox.insert(END, "Empty Log File")
            for line in self.lines:
                line = string.replace(line, '\n', '')
                listbox.insert(END, line)
        except:
            listbox.insert(END, "LOG ERROR")
        listbox.pack(side=LEFT, fill=BOTH)
        scrollbar.config(command=listbox.yview)
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    
    def apply(self):
        pass
    
    def operation(self, event=None):
        pass

#---------------------------------------------------------
class Cppui:
    def __init__(self, title, gui = 1):
        self.MAX_RESP_HISTORY = 10000
        self.MAX_EVENT_HISTORY = 1000
        self.responseList = []
        self.eventsList = []
        self.eventActions = {}
        self.gui = gui
        self.host = 'localhost'
        self.port = 7890
        self.seq = 0
        self.cc = 0
        self.nc = 0
        self.ec = 0
        self.nec = 0
        self.selftest = 0
        self.respDialogs = 0
        self.log = 0
        self.lf = None
        self.logf = None
        self.sock = None
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        self.RecvThread = 0
        self.connect = 0
        self.printFile = 0
        self.ports = {}
        self.GIF_DIR = '.gif'
        self.LOG_DIR = 'log'
        self.LOG_FILE = 'cppui.log'
        self.CMDS_DIR = 'ts'
        self.CMD_FILES = {}
        self.cmdFile = 'sample.ts'
        self.tsFile = None
        self.repeatCount = 1
        self.nc = 0
        self.abort = 0
        self.waitMode = 0
        self.waitTime = 0
        self.recvs = 0
        self.fails = 0
        self.timeout = 0
        self.ct = None
        self.dt = None
        self.title = title
        if(not os.path.exists(self.CMDS_DIR)):
            os.mkdir(self.CMDS_DIR)
        if(not os.path.exists(self.LOG_DIR)):
            os.mkdir(self.LOG_DIR)
        if(self.gui == 1):
            self.root = Tk()
            self.root.title(self.title)
            self.root.wm_resizable(0, 0)
            self.root.protocol("WM_DELETE_WINDOW", self.End)
            
            self.bf = Frame(self.root, bg="lightblue", bd=0, width=100 )
            self.bf.grid(row=0, col=0, columnspan=2, sticky="we")
            self.rf = Frame(self.root, bg="white", bd=0, height=100, width=100 )
            self.rf.grid(row=0, col=0, columnspan=2, sticky="we")
            self.cf = Frame(self.root, bg="white", bd=0, width=100 )
            
            self.pf = Frame(self.root, bg="black", bd=0, height=0, width=100 )
            
            #Port Buttons
            p = 0
            while(p < MAX_PORT_COUNT):
                self.ports[str(p)] = Button(self.pf, bg="black", text="", height = 0, width=0, relief=FLAT)
                p = p + 1
            
            #self.sb = Button(self.bf, height=0, width=0, bg="brown", text="", command=self.ConnectDisconnect, relief=GROOVE) #Status Button
            self.sb = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.rb = Button(self.rf, bd=1, padx=0, pady=0, relief=SUNKEN, bg="light gray", anchor=NW, justify=LEFT)
            self.rb.config(fg="dark blue", text="", height=20, width=60, wraplength=500)
            self.eb = Button(self.rf, bd=1, padx=0, pady=0, relief=SUNKEN, anchor=NW, justify=LEFT)
            self.eb.config(fg="dark blue", bg="light yellow", text="", height=20, width=50)
            self.loadFile = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.enableLog = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.showLog = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.navig1 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.navig2 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.navig3 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.navig4 = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.tsb = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.loadFile.config(bg="lightblue", fg="blue", text="Load", command=self.LoadFile)
            self.showLog.config(bg="lightblue", fg="blue", text="Show", command=self.DisplayLog)
            self.enableLog.config(bg="lightblue", fg="blue", text="Log", command=self.LogFile)
            self.tsb.config(bg="lightblue", fg="blue", text="Script", command = self.CommandFile)
            self.navig1.config(bg="lightblue", fg="blue", text="Prev", command = self.NavigateDownResponses)
            self.navig2.config(bg="lightblue", fg="blue", text="Next", command = self.NavigateUpResponses)
            self.navig3.config(bg="lightblue", fg="blue", text="PrevEvent", command = self.NavigateEventsDown)
            self.navig4.config(bg="lightblue", fg="blue", text="NextEvent", command = self.NavigateEventsUp)
            self.tm = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.tm.config(bg="lightblue", fg="blue", text="Wait", command=self.TestMode)
            self.ch = Button(self.bf, bd=0, padx=0, pady=0, relief=FLAT, anchor=NW, justify=LEFT)
            self.ch.config(bg="lightblue", fg="blue", text="Clear", command=self.ClearHistory)
            
            Label(self.bf, bg="lightblue", text="").pack(side=LEFT)
            self.sb.config(command=self.ConnectDisconnect, text="Connect   ", fg="blue", bg="lightblue")
            self.sb.pack(side="left")
            self.rb.pack(side="left")
            self.eb.pack(side="top")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.loadFile.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.enableLog.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.showLog.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.navig1.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.navig2.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.tsb.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.tm.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.ch.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.navig3.pack(side="left")
            Label(self.bf, bg = "lightblue", fg="pink", text="  ").pack(side=LEFT)
            self.navig4.pack(side="left")
            Label(self.pf, bg="black", fg="white", text="FE Ports    ").pack(side=LEFT)
            p = 0
            while(p < MAX_PORT_COUNT):
                pb = self.ports[str(p)]
                pb.pack(side=LEFT)
                Label(self.pf, bg="black", text="    ").pack(side=LEFT)
                p = p + 1
            img1 = PhotoImage(file = self.GIF_DIR + os.sep + 'intel.gif')
            toplab = Label(self.bf, height=0, width=0, image=img1)
            toplab.pack(side=RIGHT)
            self.bf.pack(side=TOP, fill=BOTH, expand=0)
            self.rf.pack(side=TOP, fill=BOTH, expand=0)
            self.cf.pack(side=BOTTOM, fill=BOTH, expand=0)
            self.pf.pack(side=BOTTOM, fill=BOTH, expand=0)
            
            # create a toplevel menu
            menubar = Menu(self.root, bg="cyan", fg="brown")
            cppuiMenu = Menu(menubar, bg="black", fg="red", tearoff=0)
            cppuiMenu.add_command(label="Set Count", command=self.SetRepeatCount)
            cppuiMenu.add_separator()
            cppuiMenu.add_command(label="Set Delay", command=self.SetWaitTime)
            cppuiMenu.add_separator()
            cppuiMenu.add_command(label="Enable Self Test", command=self.EnableSelfTest)
            cppuiMenu.add_separator()
            cppuiMenu.add_command(label="Disable Self Test", command=self.DisableSelfTest)
            cppuiMenu.add_separator()
            menubar.add_cascade(label="Cppui", menu=cppuiMenu)
            
            NameSpaceMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            NameSpaceMenu.add_command(label="Create", command=self.NameSpaceCreate)
            NameSpaceMenu.add_separator()
            NameSpaceMenu.add_command(label="Associate", command=self.NameSpaceAssociate)
            menubar.add_cascade(label="NameSpace", menu=NameSpaceMenu)
            
            
            InterfaceMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            InterfaceMenu.add_command(label="Create LAN And Set Attribute", command=self.InterfaceCreate_LAN_And_Set_Attribute)
            InterfaceMenu.add_command(label="Create POS And Set Attribute", command=self.InterfaceCreate_POS_And_Set_Attribute)
            InterfaceMenu.add_command(label="Create ATM And Set Attribute", command=self.InterfaceCreate_ATM_And_Set_Attribute)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Create IPV4", command=self.InterfaceCreate_IPV4)
            InterfaceMenu.add_command(label="IPV4 Set Attributes", command=self.InterfaceIPV4_Set_Attributes)
            InterfaceMenu.add_command(label="IPV4 Interface Set Address", command=self.InterfaceIPV4_Interface_Set_Address)
            InterfaceMenu.add_command(label="IPV4 Interface Set MTU", command=self.InterfaceIPV4_Interface_Set_MTU)
            InterfaceMenu.add_command(label="IPV4 Interface Set FIB", command=self.InterfaceIPV4_Interface_Set_FIB)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Create MPLS Interface", command=self.InterfaceCreate_MPLS_Interface)
            InterfaceMenu.add_command(label="Set MPLS Attribute DoAfterMPLS2Layer2Binding", command=self.InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Bind", command=self.InterfaceBind)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Enable", command=self.InterfaceEnable)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Status", command=self.InterfaceStatus)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Statistics", command=self.InterfaceStatistics)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Disable", command=self.InterfaceDisable)
            InterfaceMenu.add_separator()
            InterfaceMenu.add_command(label="Delete", command=self.InterfaceDelete)
            menubar.add_cascade(label="Interface", menu=InterfaceMenu)
            
            
            LANMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            LANMenu.add_command(label="Set Attributes", command=self.LANSet_Attributes)
            LANMenu.add_command(label="Set Speed", command=self.LANSet_Speed)
            LANMenu.add_command(label="Set Promisc", command=self.LANSet_Promisc)
            LANMenu.add_command(label="Clear Promisc", command=self.LANClear_Promisc)
            LANMenu.add_separator()
            LANMenu.add_command(label="Get Source Address", command=self.LANGet_Source_Address)
            LANMenu.add_command(label="Set Source Address", command=self.LANSet_Source_Address)
            LANMenu.add_separator()
            LANMenu.add_command(label="Set Receive Address List", command=self.LANSet_Receive_Address_List)
            LANMenu.add_command(label="Add Receive Address List", command=self.LANAdd_Receive_Address_List)
            LANMenu.add_separator()
            LANMenu.add_command(label="Set Full Duplex", command=self.LANSet_Full_Duplex)
            LANMenu.add_command(label="Clear Full Duplex", command=self.LANClear_Full_Duplex)
            LANMenu.add_separator()
            LANMenu.add_command(label="Tx Flow Control Enable", command=self.LANTx_Flow_Control_Enable)
            LANMenu.add_command(label="Tx Flow Control Disable", command=self.LANTx_Flow_Control_Disable)
            LANMenu.add_command(label="Rx Flow Control Enable", command=self.LANRx_Flow_Control_Enable)
            LANMenu.add_command(label="Rx Flow Control Disable", command=self.LANRx_Flow_Control_Disable)
            menubar.add_cascade(label="LAN", menu=LANMenu)
            
            
            IPV4Menu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            IPV4Menu.add_command(label="Get Supported Mode", command=self.IPV4Get_Supported_Mode)
            IPV4Menu.add_command(label="Get Preferred Mode", command=self.IPV4Get_Preferred_Mode)
            IPV4Menu.add_separator()
            IPV4Menu.add_command(label="Create Prefix Table Handle", command=self.IPV4Create_Prefix_Table_Handle)
            IPV4Menu.add_command(label="Create NextHop Table Handle", command=self.IPV4Create_NextHop_Table_Handle)
            IPV4Menu.add_command(label="Create AddRes Table Handle", command=self.IPV4Create_AddRes_Table_Handle)
            IPV4Menu.add_separator()
            IPV4Menu.add_command(label="Delete Prefix Table Handle", command=self.IPV4Delete_Prefix_Table_Handle)
            IPV4Menu.add_command(label="Delete NextHop Table Handle", command=self.IPV4Delete_NextHop_Table_Handle)
            IPV4Menu.add_command(label="Delete Address Table Handle", command=self.IPV4Delete_Address_Table_Handle)
            IPV4Menu.add_command(label="Bind Prefix NextHop Table", command=self.IPV4Bind_Prefix_NextHop_Table)
            IPV4Menu.add_separator()
            IPV4Menu.add_command(label="Add Prefix Table Entry", command=self.IPV4Add_Prefix_Table_Entry)
            IPV4Menu.add_command(label="Add NextHop Table Entry", command=self.IPV4Add_NextHop_Table_Entry)
            IPV4Menu.add_command(label="Add AddRes Table Entry", command=self.IPV4Add_AddRes_Table_Entry)
            IPV4Menu.add_command(label="Delete Prefix Table Entry", command=self.IPV4Delete_Prefix_Table_Entry)
            IPV4Menu.add_command(label="Delete NextHop Table Entry", command=self.IPV4Delete_NextHop_Table_Entry)
            IPV4Menu.add_command(label="Delete AddRes Entry", command=self.IPV4Delete_AddRes_Entry)
            IPV4Menu.add_separator()
            IPV4Menu.add_command(label="Flush Prefix Table", command=self.IPV4Flush_Prefix_Table)
            IPV4Menu.add_command(label="Flush NextHop Table", command=self.IPV4Flush_NextHop_Table)
            IPV4Menu.add_command(label="Flush AddRes Table", command=self.IPV4Flush_AddRes_Table)
            IPV4Menu.add_separator()
            IPV4Menu.add_command(label="Query Prefix Table Entry", command=self.IPV4Query_Prefix_Table_Entry)
            IPV4Menu.add_command(label="Query NextHop Table Entry", command=self.IPV4Query_NextHop_Table_Entry)
            IPV4Menu.add_command(label="Query AddRes Table Entry", command=self.IPV4Query_AddRes_Table_Entry)
            IPV4Menu.add_separator()
            IPV4Menu.add_command(label="Reset IPV4 Handles For Test Repeat", command=self.IPV4Reset_IPV4_Handles_For_Test_Repeat)
            menubar.add_cascade(label="IPV4", menu=IPV4Menu)
            
            
            IPV4_UNIFIEDMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            IPV4_UNIFIEDMenu.add_command(label="Create Fib Table Handle", command=self.IPV4_UNIFIEDCreate_Fib_Table_Handle)
            IPV4_UNIFIEDMenu.add_command(label="Delete Fib Table Handle", command=self.IPV4_UNIFIEDDelete_Fib_Table_Handle)
            IPV4_UNIFIEDMenu.add_separator()
            IPV4_UNIFIEDMenu.add_command(label="Add Fib Table Entry", command=self.IPV4_UNIFIEDAdd_Fib_Table_Entry)
            IPV4_UNIFIEDMenu.add_command(label="Delete Fib Table Entry", command=self.IPV4_UNIFIEDDelete_Fib_Table_Entry)
            IPV4_UNIFIEDMenu.add_separator()
            IPV4_UNIFIEDMenu.add_command(label="Flush Fib Table", command=self.IPV4_UNIFIEDFlush_Fib_Table)
            IPV4_UNIFIEDMenu.add_separator()
            IPV4_UNIFIEDMenu.add_command(label="Query Fib Table Entry", command=self.IPV4_UNIFIEDQuery_Fib_Table_Entry)
            menubar.add_cascade(label="IPV4_UNIFIED", menu=IPV4_UNIFIEDMenu)
            
            
            DiffServMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            DiffServMenu.add_command(label="Create Classifier", command=self.DiffServCreate_Classifier)
            DiffServMenu.add_command(label="Create Meter", command=self.DiffServCreate_Meter)
            DiffServMenu.add_command(label="Create Marker", command=self.DiffServCreate_Marker)
            DiffServMenu.add_command(label="Create Dropper", command=self.DiffServCreate_Dropper)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Add DSCP Filter", command=self.DiffServAdd_DSCP_Filter)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Modify Classifier", command=self.DiffServModify_Classifier)
            DiffServMenu.add_command(label="Modify Meter", command=self.DiffServModify_Meter)
            DiffServMenu.add_command(label="Modify Marker", command=self.DiffServModify_Marker)
            DiffServMenu.add_command(label="Modify Dropper", command=self.DiffServModify_Dropper)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Dpe Add Associate", command=self.DiffServDpe_Add_Associate)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Dpe Query", command=self.DiffServDpe_Query)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Dpe Statistics", command=self.DiffServDpe_Statistics)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Dpe Delete Associate", command=self.DiffServDpe_Delete_Associate)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Dpe Delete", command=self.DiffServDpe_Delete)
            DiffServMenu.add_separator()
            DiffServMenu.add_command(label="Reset Dpe Handles", command=self.DiffServReset_Dpe_Handles)
            menubar.add_cascade(label="DiffServ", menu=DiffServMenu)
            
            
            MPLSMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            MPLSMenu.add_separator()
            MPLSMenu.add_command(label="Create NHLFE", command=self.MPLSCreate_NHLFE)
            MPLSMenu.add_command(label="Create NHLFESET", command=self.MPLSCreate_NHLFESET)
            MPLSMenu.add_command(label="Create NHLFESET n NHLFE", command=self.MPLSCreate_NHLFESET_n_NHLFE)
            MPLSMenu.add_separator()
            MPLSMenu.add_command(label="Create FTN IPv4HostAddr NHLFESET Handle LSP", command=self.MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP)
            MPLSMenu.add_command(label="Create FTN IPv4HostAddr NHLFESET Params NHLFE Handle LSP", command=self.MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP)
            MPLSMenu.add_command(label="Create FTN IPv4HostAddr NHLFESET Params NHLFE Params LSP", command=self.MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP)
            MPLSMenu.add_separator()
            MPLSMenu.add_command(label="Create ILM ShimLbl NHLFESET Handle LSP", command=self.MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP)
            MPLSMenu.add_command(label="Create ILM ShimLbl NHLFESET Params NHLFE Handle LSP", command=self.MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP)
            MPLSMenu.add_command(label="Create ILM ShimLbl NHLFESET Params NHLFE Params LSP", command=self.MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP)
            MPLSMenu.add_separator()
            MPLSMenu.add_command(label="Delete LSP", command=self.MPLSDelete_LSP)
            MPLSMenu.add_command(label="Delete NHLFESET", command=self.MPLSDelete_NHLFESET)
            MPLSMenu.add_command(label="Delete NHLFE", command=self.MPLSDelete_NHLFE)
            MPLSMenu.add_separator()
            MPLSMenu.add_command(label="Query NHLFE based on Handle", command=self.MPLSQuery_NHLFE_based_on_Handle)
            MPLSMenu.add_command(label="Query NHLFESET based on Handle", command=self.MPLSQuery_NHLFESET_based_on_Handle)
            MPLSMenu.add_command(label="Query NHLFESET based on SetId", command=self.MPLSQuery_NHLFESET_based_on_SetId)
            MPLSMenu.add_command(label="Query LSP based on Handle", command=self.MPLSQuery_LSP_based_on_Handle)
            MPLSMenu.add_separator()
            MPLSMenu.add_separator()
            MPLSMenu.add_command(label="Reset MPLS Handles For Test Repeat", command=self.MPLSReset_MPLS_Handles_For_Test_Repeat)
            menubar.add_cascade(label="MPLS", menu=MPLSMenu)
            
            
            ATMMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            ATMMenu.add_command(label="AAL5 Vcc Set", command=self.ATMAAL5_Vcc_Set)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM Vcc Bind", command=self.ATMATM_Vcc_Bind)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM Vcc Delete", command=self.ATMATM_Vcc_Delete)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM Vcc Enable", command=self.ATMATM_Vcc_Enable)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM Vcc Disable", command=self.ATMATM_Vcc_Disable)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM Vcc Oper Status Get", command=self.ATMATM_Vcc_Oper_Status_Get)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM Vcc Stats Get", command=self.ATMATM_Vcc_Stats_Get)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM AAL2 Chan Set", command=self.ATMATM_AAL2_Chan_Set)
            ATMMenu.add_separator()
            ATMMenu.add_command(label="ATM AAL2 Chan Del", command=self.ATMATM_AAL2_Chan_Del)
            menubar.add_cascade(label="ATM", menu=ATMMenu)
            
            
            RCMMenu = Menu(menubar, bg="lightblue", fg="blue", tearoff=0)
            RCMMenu.add_command(label="Start RCM", command=self.RCMStart_RCM)
            menubar.add_cascade(label="RCM", menu=RCMMenu)
            
            
            self.root.config(menu=menubar)
            thread.start_new_thread(self.Status, ())
            self.root.mainloop()
    
    def NameSpaceCreate(self):
        NameSpaceCreateDialog(self.root, self)
    
    def NameSpaceAssociate(self):
        NameSpaceAssociateDialog(self.root, self)
    
    
    def InterfaceCreate_LAN_And_Set_Attribute(self):
        InterfaceCreate_LAN_And_Set_AttributeDialog(self.root, self)
    
    def InterfaceCreate_POS_And_Set_Attribute(self):
        InterfaceCreate_POS_And_Set_AttributeDialog(self.root, self)
    
    def InterfaceCreate_ATM_And_Set_Attribute(self):
        InterfaceCreate_ATM_And_Set_AttributeDialog(self.root, self)
    
    def InterfaceCreate_IPV4(self):
        InterfaceCreate_IPV4Dialog(self.root, self)
    
    def InterfaceIPV4_Set_Attributes(self):
        InterfaceIPV4_Set_AttributesDialog(self.root, self)
    
    def InterfaceIPV4_Interface_Set_Address(self):
        InterfaceIPV4_Interface_Set_AddressDialog(self.root, self)
    
    def InterfaceIPV4_Interface_Set_MTU(self):
        InterfaceIPV4_Interface_Set_MTUDialog(self.root, self)
    
    def InterfaceIPV4_Interface_Set_FIB(self):
        InterfaceIPV4_Interface_Set_FIBDialog(self.root, self)
    
    def InterfaceCreate_MPLS_Interface(self):
        InterfaceCreate_MPLS_InterfaceDialog(self.root, self)
    
    def InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding(self):
        InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2BindingDialog(self.root, self)
    
    def InterfaceBind(self):
        InterfaceBindDialog(self.root, self)
    
    def InterfaceEnable(self):
        InterfaceEnableDialog(self.root, self)
    
    def InterfaceStatus(self):
        InterfaceStatusDialog(self.root, self)
    
    def InterfaceStatistics(self):
        InterfaceStatisticsDialog(self.root, self)
    
    def InterfaceDisable(self):
        InterfaceDisableDialog(self.root, self)
    
    def InterfaceDelete(self):
        InterfaceDeleteDialog(self.root, self)
    
    
    def LANSet_Attributes(self):
        LANSet_AttributesDialog(self.root, self)
    
    def LANSet_Speed(self):
        LANSet_SpeedDialog(self.root, self)
    
    def LANSet_Promisc(self):
        LANSet_PromiscDialog(self.root, self)
    
    def LANClear_Promisc(self):
        LANClear_PromiscDialog(self.root, self)
    
    def LANGet_Source_Address(self):
        LANGet_Source_AddressDialog(self.root, self)
    
    def LANSet_Source_Address(self):
        LANSet_Source_AddressDialog(self.root, self)
    
    def LANSet_Receive_Address_List(self):
        LANSet_Receive_Address_ListDialog(self.root, self)
    
    def LANAdd_Receive_Address_List(self):
        LANAdd_Receive_Address_ListDialog(self.root, self)
    
    def LANSet_Full_Duplex(self):
        LANSet_Full_DuplexDialog(self.root, self)
    
    def LANClear_Full_Duplex(self):
        LANClear_Full_DuplexDialog(self.root, self)
    
    def LANTx_Flow_Control_Enable(self):
        LANTx_Flow_Control_EnableDialog(self.root, self)
    
    def LANTx_Flow_Control_Disable(self):
        LANTx_Flow_Control_DisableDialog(self.root, self)
    
    def LANRx_Flow_Control_Enable(self):
        LANRx_Flow_Control_EnableDialog(self.root, self)
    
    def LANRx_Flow_Control_Disable(self):
        LANRx_Flow_Control_DisableDialog(self.root, self)
    
    
    def IPV4Get_Supported_Mode(self):
        IPV4Get_Supported_ModeDialog(self.root, self)
    
    def IPV4Get_Preferred_Mode(self):
        IPV4Get_Preferred_ModeDialog(self.root, self)
    
    def IPV4Create_Prefix_Table_Handle(self):
        IPV4Create_Prefix_Table_HandleDialog(self.root, self)
    
    def IPV4Create_NextHop_Table_Handle(self):
        IPV4Create_NextHop_Table_HandleDialog(self.root, self)
    
    def IPV4Create_AddRes_Table_Handle(self):
        IPV4Create_AddRes_Table_HandleDialog(self.root, self)
    
    def IPV4Delete_Prefix_Table_Handle(self):
        IPV4Delete_Prefix_Table_HandleDialog(self.root, self)
    
    def IPV4Delete_NextHop_Table_Handle(self):
        IPV4Delete_NextHop_Table_HandleDialog(self.root, self)
    
    def IPV4Delete_Address_Table_Handle(self):
        IPV4Delete_Address_Table_HandleDialog(self.root, self)
    
    def IPV4Bind_Prefix_NextHop_Table(self):
        IPV4Bind_Prefix_NextHop_TableDialog(self.root, self)
    
    def IPV4Add_Prefix_Table_Entry(self):
        IPV4Add_Prefix_Table_EntryDialog(self.root, self)
    
    def IPV4Add_NextHop_Table_Entry(self):
        IPV4Add_NextHop_Table_EntryDialog(self.root, self)
    
    def IPV4Add_AddRes_Table_Entry(self):
        IPV4Add_AddRes_Table_EntryDialog(self.root, self)
    
    def IPV4Delete_Prefix_Table_Entry(self):
        IPV4Delete_Prefix_Table_EntryDialog(self.root, self)
    
    def IPV4Delete_NextHop_Table_Entry(self):
        IPV4Delete_NextHop_Table_EntryDialog(self.root, self)
    
    def IPV4Delete_AddRes_Entry(self):
        IPV4Delete_AddRes_EntryDialog(self.root, self)
    
    def IPV4Flush_Prefix_Table(self):
        IPV4Flush_Prefix_TableDialog(self.root, self)
    
    def IPV4Flush_NextHop_Table(self):
        IPV4Flush_NextHop_TableDialog(self.root, self)
    
    def IPV4Flush_AddRes_Table(self):
        IPV4Flush_AddRes_TableDialog(self.root, self)
    
    def IPV4Query_Prefix_Table_Entry(self):
        IPV4Query_Prefix_Table_EntryDialog(self.root, self)
    
    def IPV4Query_NextHop_Table_Entry(self):
        IPV4Query_NextHop_Table_EntryDialog(self.root, self)
    
    def IPV4Query_AddRes_Table_Entry(self):
        IPV4Query_AddRes_Table_EntryDialog(self.root, self)
    
    def IPV4Reset_IPV4_Handles_For_Test_Repeat(self):
        IPV4Reset_IPV4_Handles_For_Test_RepeatDialog(self.root, self)
    
    
    def IPV4_UNIFIEDCreate_Fib_Table_Handle(self):
        IPV4_UNIFIEDCreate_Fib_Table_HandleDialog(self.root, self)
    
    def IPV4_UNIFIEDDelete_Fib_Table_Handle(self):
        IPV4_UNIFIEDDelete_Fib_Table_HandleDialog(self.root, self)
    
    def IPV4_UNIFIEDAdd_Fib_Table_Entry(self):
        IPV4_UNIFIEDAdd_Fib_Table_EntryDialog(self.root, self)
    
    def IPV4_UNIFIEDDelete_Fib_Table_Entry(self):
        IPV4_UNIFIEDDelete_Fib_Table_EntryDialog(self.root, self)
    
    def IPV4_UNIFIEDFlush_Fib_Table(self):
        IPV4_UNIFIEDFlush_Fib_TableDialog(self.root, self)
    
    def IPV4_UNIFIEDQuery_Fib_Table_Entry(self):
        IPV4_UNIFIEDQuery_Fib_Table_EntryDialog(self.root, self)
    
    
    def DiffServCreate_Classifier(self):
        DiffServCreate_ClassifierDialog(self.root, self)
    
    def DiffServCreate_Meter(self):
        DiffServCreate_MeterDialog(self.root, self)
    
    def DiffServCreate_Marker(self):
        DiffServCreate_MarkerDialog(self.root, self)
    
    def DiffServCreate_Dropper(self):
        DiffServCreate_DropperDialog(self.root, self)
    
    def DiffServAdd_DSCP_Filter(self):
        DiffServAdd_DSCP_FilterDialog(self.root, self)
    
    def DiffServModify_Classifier(self):
        DiffServModify_ClassifierDialog(self.root, self)
    
    def DiffServModify_Meter(self):
        DiffServModify_MeterDialog(self.root, self)
    
    def DiffServModify_Marker(self):
        DiffServModify_MarkerDialog(self.root, self)
    
    def DiffServModify_Dropper(self):
        DiffServModify_DropperDialog(self.root, self)
    
    def DiffServDpe_Add_Associate(self):
        DiffServDpe_Add_AssociateDialog(self.root, self)
    
    def DiffServDpe_Query(self):
        DiffServDpe_QueryDialog(self.root, self)
    
    def DiffServDpe_Statistics(self):
        DiffServDpe_StatisticsDialog(self.root, self)
    
    def DiffServDpe_Delete_Associate(self):
        DiffServDpe_Delete_AssociateDialog(self.root, self)
    
    def DiffServDpe_Delete(self):
        DiffServDpe_DeleteDialog(self.root, self)
    
    def DiffServReset_Dpe_Handles(self):
        DiffServReset_Dpe_HandlesDialog(self.root, self)
    
    
    def MPLSCreate_NHLFE(self):
        MPLSCreate_NHLFEDialog(self.root, self)
    
    def MPLSCreate_NHLFESET(self):
        MPLSCreate_NHLFESETDialog(self.root, self)
    
    def MPLSCreate_NHLFESET_n_NHLFE(self):
        MPLSCreate_NHLFESET_n_NHLFEDialog(self.root, self)
    
    def MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP(self):
        MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSPDialog(self.root, self)
    
    def MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP(self):
        MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSPDialog(self.root, self)
    
    def MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP(self):
        MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSPDialog(self.root, self)
    
    def MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP(self):
        MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSPDialog(self.root, self)
    
    def MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP(self):
        MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSPDialog(self.root, self)
    
    def MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP(self):
        MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSPDialog(self.root, self)
    
    def MPLSDelete_LSP(self):
        MPLSDelete_LSPDialog(self.root, self)
    
    def MPLSDelete_NHLFESET(self):
        MPLSDelete_NHLFESETDialog(self.root, self)
    
    def MPLSDelete_NHLFE(self):
        MPLSDelete_NHLFEDialog(self.root, self)
    
    def MPLSQuery_NHLFE_based_on_Handle(self):
        MPLSQuery_NHLFE_based_on_HandleDialog(self.root, self)
    
    def MPLSQuery_NHLFESET_based_on_Handle(self):
        MPLSQuery_NHLFESET_based_on_HandleDialog(self.root, self)
    
    def MPLSQuery_NHLFESET_based_on_SetId(self):
        MPLSQuery_NHLFESET_based_on_SetIdDialog(self.root, self)
    
    def MPLSQuery_LSP_based_on_Handle(self):
        MPLSQuery_LSP_based_on_HandleDialog(self.root, self)
    
    def MPLSReset_MPLS_Handles_For_Test_Repeat(self):
        MPLSReset_MPLS_Handles_For_Test_RepeatDialog(self.root, self)
    
    
    def ATMAAL5_Vcc_Set(self):
        ATMAAL5_Vcc_SetDialog(self.root, self)
    
    def ATMATM_Vcc_Bind(self):
        ATMATM_Vcc_BindDialog(self.root, self)
    
    def ATMATM_Vcc_Delete(self):
        ATMATM_Vcc_DeleteDialog(self.root, self)
    
    def ATMATM_Vcc_Enable(self):
        ATMATM_Vcc_EnableDialog(self.root, self)
    
    def ATMATM_Vcc_Disable(self):
        ATMATM_Vcc_DisableDialog(self.root, self)
    
    def ATMATM_Vcc_Oper_Status_Get(self):
        ATMATM_Vcc_Oper_Status_GetDialog(self.root, self)
    
    def ATMATM_Vcc_Stats_Get(self):
        ATMATM_Vcc_Stats_GetDialog(self.root, self)
    
    def ATMATM_AAL2_Chan_Set(self):
        ATMATM_AAL2_Chan_SetDialog(self.root, self)
    
    def ATMATM_AAL2_Chan_Del(self):
        ATMATM_AAL2_Chan_DelDialog(self.root, self)
    
    
    def RCMStart_RCM(self):
        RCMStart_RCMDialog(self.root, self)
    
    
    def LoadActions(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        types = []
        types.append(('evt', '*.evt'))
        types.append(('all', '*.*'))
        inFile = tkFileDialog.askopenfilename(initialdir=self.CMDS_DIR, defaultextension="evt", filetypes=types, initialfile=self.cmdFile)
        if(not inFile):
            return
        try:
            fl = open(inFile)
            lines = fl.readlines()
            for line in lines:
                line = string.strip(line)
                if(not len(line)):
                    continue
                if(line[0:1] == '#'):
                    continue
                try:
                    line = string.replace(line, '[', '')
                    line = string.replace(line, ']', '')
                    line = string.replace(line, '(', '')
                    elems = string.split(line, ')')
                    cmd = ''
                    name = string.split(elems[0])[0]
                    for elem in elems:
                        elem = string.strip(elem)
                        elem = string.replace(elem, ',', '')
                        elem = string.replace(elem, '\'', '')
                        if(not len(elem)):
                            continue
                        cmd = cmd + string.split(elem)[1] + ';'
                    tmp = string.split(cmd, ';')
                    actFile = tmp[len(tmp) - 2]
                    if(not os.path.exists(actFile)):
                        tkMessageBox.showerror(cmd, "Error in Event: " + cmd + "\nNo valid action file specified")
                        return
                    cmd = string.split(cmd, actFile)[0]
                    self.EventAction(cmd, actFile)
                except:
                    tkMessageBox.showerror(inFile, "Error in Command: " + line)
                    return
            if(fl):
                fl.close()
            yes = tkMessageBox.askyesno("Executed " + self.cmdFile, "Want to continue with next Command file?\n")
            if(yes):
                self.LoadActions()
        except:
            tkMessageBox.showerror(inFile, "Error in Opening File")
            return
    
    def FindCommandFiles(self, dir):
        files = os.listdir(dir)
        for file in files:
            path = os.path.abspath(dir) + os.sep + file
            if(os.path.isdir(path)):
                self.FindCommandFiles(path)
            else:
                self.CMD_FILES[file] = os.path.abspath(dir) + os.sep + file
    
    def ReadFile(self, fl, lines):
        lns = fl.readlines()
        for l in lns:
            l = string.strip(l)
            if(not len(l)):
                continue
            if(l[0:1] == '#'):
                continue
            include = string.strip(string.lower(string.replace(l[0:9], ' ', '')))
            if(include == '--include'):
                f = open(self.CMD_FILES[string.strip(l[9:])])
                self.ReadFile(f, lines)
                f.close()
            else:
                lines.append(l)
    
    def LoadFile(self, inFile = None):
        cmds = []
        if(self.gui == 1):
            if(self.connect != 1):
                tkMessageBox.showerror("CPPUI Status", "Not Connected")
                return
            #self.SetRepeatCount()
            types = []
            types.append(('cmd', '*.ts'))
            types.append(('all', '*.*'))
            inFile = tkFileDialog.askopenfilename(initialdir=self.CMDS_DIR, defaultextension="ts", filetypes=types, initialfile=self.cmdFile)
            if(not len(inFile)):
                return
        try:
            self.FindCommandFiles(self.CMDS_DIR)
            lines = []
            if(self.CMD_FILES.has_key(inFile)):
                inFile = self.CMD_FILES[inFile]
            if(os.path.exists(inFile) and os.path.isfile(inFile)):
                fl = open(inFile)
            else:
                if(self.gui):
                    tkMessageBox.showerror(inFile, "No such Script File")
                    return
                else:
                    showerror('No such Script File <"' + inFile + '">')
                    return
            self.ReadFile(fl, lines)
            fl.close()
            for line in lines:
                line = string.strip(line)
                if(not len(line)):
                    continue
                if(line[0:1] == '#'):
                    continue
                if(string.strip(string.lower(string.replace(line[0:2], ' ', ''))) == '--'):
                    cmds.append(line)
                    continue
                try:
                    line = string.replace(line, '[', '')
                    line = string.replace(line, ']', '')
                    line = string.replace(line, '(', '')
                    elems = string.split(line, ')')
                    cmd = ''
                    nameid = string.split(elems[0], ',')
                    name = nameid[0]
                    name = string.replace(name, "'", "-")
                    name = string.replace(name, "-", "")
                    id = nameid[1]
                    id = string.replace(id, "'", "-")
                    id = string.replace(id, "-", "")
                    reqresp = ReqResp(str(name), str(id))
                    for elem in elems[1:]: #command name and id already known
                        elem = string.strip(elem)
                        elem = string.replace(elem, ',', '')
                        elem = string.replace(elem, '\'', '')
                        if(not len(elem)):
                            continue
                        nm = string.split(elem)[0]
                        vl = string.split(elem)[1]
                        nv = (nm, vl)
                        reqresp.arg(nv)
                    cmds.append(reqresp)
                except:
                    if(self.gui):
                        tkMessageBox.showerror(inFile, "Error in Command: " + line)
                    else:
                        showerror("Error in Command: " + line)
                    return
            if(fl):
                fl.close()
        except:
            tkMessageBox.showerror(inFile, "Error in Opening File")
            return
        repeat = self.repeatCount
        self.abort = 0
        while(repeat):
            if(self.abort == 1):
                if(not self.gui):
                    print '\nShhhhhhhhhhhhhhh .....................\n'
                break
            self.nc = 0
            for cmd in cmds:
                if(self.abort == 1):
                    if(not self.gui):
                        print '\nShhhhhhhhhhhhhhh .....................\n'
                    break
                self.Send(cmd)
                self.loadFile.flash()
            if(self.repeatCount != 11111):
                repeat = repeat - 1
        self.repeatCount = 1
        self.loadFile.config(bg="lightblue")
        self.waitTime = 0
    
    def NewCommand(self, order, write = 1):
        try:
            if(write == 1):
                self.tsFile.write(str(order) + '\n\n')
            else:
                self.tsFile = open(self.cmdFile, 'a')
                if(os.path.getsize(self.cmdFile) == 0):
                    hdr = '#Do not modify the "Type" parameter value'
                    self.tsFile.write(hdr + '\n\n')
            self.tsb.flash()
            self.tsb.flash()
            self.tsb.flash()
            self.tsb.config(fg = "red", bg="cyan")
            self.printFile = 1
        except:
            self.tsFile == None
            self.printFile = 0
            self.tsb.flash()
            self.tsb.flash()
            self.tsb.flash()
            tkMessageBox.showerror("File Error", "Error in Writing File: " + os.path.basename(self.cmdFile))
    
    def CommandFile(self):
        if(self.printFile == 0):
            self.EnableCommandFile()
            return
        else:
            self.DisableCommandFile()
            return
    
    def DisableCommandFile(self):
        if(not self.printFile):
            tkMessageBox.showerror("Diasable Command File", "Command File not Enabled")
            return
        if(not tkMessageBox.askyesno("Diasable Command File", "Disable Command File: "+ os.path.basename(self.cmdFile) + "\nAre you sure")):
            return
        if(self.tsFile == None):
            return
        self.tsFile.flush()
        self.tsFile.flush()
        self.tsFile.close()
        self.tsFile == None
        self.printFile = 0
        self.tsb.flash()
        self.tsb.flash()
        self.tsb.flash()
        self.tsb.config(fg = "blue", bg="lightblue")
    
    def EnableCommandFile(self):
        if(self.connect):
            msg = "Connected to CPPDK Server\nDisconnect and Try again"
            tkMessageBox.showerror("Enable Command File", msg)
            return
        else:
            types = []
            types.append(('ts', '*.ts'))
            #types.append(('evt', '*.evt'))
            cmdFile = tkFileDialog.asksaveasfilename(initialdir=self.CMDS_DIR, defaultextension=".ts", filetypes=types, initialfile=self.cmdFile)
            if(len(cmdFile) == 0):
                self.printFile = 0
                return
            self.cmdFile = cmdFile
            self.NewCommand(None, 0)
    
    
    def AddResponseList(self, resp):
        if(self.responseCount >= self.MAX_RESP_HISTORY):
            self.responseCount = 0
        self.responseList[self.responseCount] = resp
        self.navigateCount = self.responseCount
        self.responseCount = self.responseCount + 1
    def ClearHistory(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        clear = tkMessageBox.askyesno("Clear History", "\n Are you sure?")
        if(clear != 1):
            return
        self.seq = 0
        self.ec = 0
        CppuiReqResp.clear()
        CppuiEvents.clear()
        self.rb.flash()
        self.rb.flash()
        self.rb.flash()
        self.rb.config(text="")
        self.eb.flash()
        self.eb.flash()
        self.eb.flash()
        self.eb.config(text="")
        if(self.log == 1 and self.logf != None):
            self.enableLog.flash()
            self.enableLog.flash()
            self.enableLog.flash()
            self.logf.flush()
            self.logf.flush()
    
    def NavigateEventsUp(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not connected\nConnect to CPPDK and try again !!!")
            return
        if(CppuiEvents.has_key(self.nec)):
            self.eb.flash()
            evt = CppuiEvents[self.nec]
            self.ShowEvent(evt, 0)
            self.nec = self.nec + 1
            if(self.nec -1 == self.ec):
                self.nec = 1
    
    def NavigateEventsDown(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not connected\nConnect to CPPDK and try again !!!")
            return
        if(CppuiEvents.has_key(self.nec)):
            self.eb.flash()
            evt = CppuiEvents[self.nec]
            self.ShowEvent(evt, 0)
            self.nec = self.nec - 1
            if(self.nec == 0):
                self.nec = self.ec
    
    def NavigateUpResponses(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not connected\nConnect to CPPDK and try again !!!")
            return
        if(CppuiReqResp.has_key(str(self.nc))):
            resp = CppuiReqResp[str(self.nc)]
            self.rb.flash()
            self.UpdateResponseButton(resp, 0)
            self.nc = self.nc + 1
            if(self.nc == self.seq):
                self.nc = 1
    
    def NavigateDownResponses(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not connected\nConnect to CPPDK and try again !!!")
            return
        if(CppuiReqResp.has_key(str(self.nc))):
            self.rb.flash()
            resp = CppuiReqResp[str(self.nc)]
            self.UpdateResponseButton(resp, 0)
            self.nc = self.nc - 1
            if(self.nc == 0):
                self.nc = self.seq - 1
    
    
    def EventAction(self, evt, actFile):
        if(string.lower(actFile) == 'default'):
            return
        if(not os.path.exists(actFile)):
            tkMessageBox.showerror("Invalid Action File ","Can't find Event Action file <" + actFile + ">\n Specify valid action file and Try again")
            return
        cmd = ''
        fl = open(actFile)
        lines = fl.readlines()
        for line in lines:
            line = string.strip(line)
            if(not len(line)):
                continue
            if(line[0:1] == '#'):
                continue
            try:
                line = string.replace(line, '[', '')
                line = string.replace(line, ']', '')
                line = string.replace(line, '(', '')
                elems = string.split(line, ')')
                name = string.split(elems[0])[0]
                for elem in elems:
                    elem = string.strip(elem)
                    elem = string.replace(elem, ',', '')
                    elem = string.replace(elem, '\'', '')
                    if(not len(elem)):
                        continue
                    cmd = cmd + string.split(elem)[1] + ';'
            except:
                tkMessageBox.showerror(inFile, "Error in Command: " + line)
                return
        if(fl):
            fl.close()
        self.eventActions[evt] = cmd
        print self.eventActions
    
    def ShowEvent(self, evt, nec = 1):
        if(nec == 1):
            self.nec = self.ec
        text = evt.text()
        if(self.log == 1):
            self.Log(text)
        if(self.gui):
            self.eb.config(text = text)
        else:
            print ''
            print text
            print ''
    #-----------------------------------------------------
    
    def ProcessEvent(self, resp):
        evt = resp[1]
        event = string.split(evt, ';')
        id = event[1]
        prio = event[2]
        descr = event[3]
        self.ec = self.ec + 1
        if(id == str(CPPUI_EVENT_FE_BIND)):
            name = 'FE_BIND'
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            FEid = event[4]
            evt.arg(('FEid',FEid))
            evt.save()
            self.ShowEvent(evt)
        if(id == str(CPPUI_EVENT_FE_UNBIND)):
            name = 'FE_UNBIND'
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            FEid = event[4]
            evt.arg(('FEid',FEid))
            evt.save()
            self.ShowEvent(evt)
        if(id == str(CPPUI_EVENT_FE_PORT)):
            name = 'FE_PORT'
            pid = event[5] # Event Parameters: FeId, PortId
            if(self.ports.has_key(pid)):
                pb = self.ports[pid]
                pb.flash()
                pb.flash()
                pb.config(bg="red", fg="blue")
                pb.config(text = pid)
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            fid = event[4]
            evt.arg(('fid',fid))
            pid = event[5]
            evt.arg(('pid',pid))
            evt.save()
            self.ShowEvent(evt)
        if(id == str(CPPUI_EVENT_PORT_LINK_UP)):
            name = 'PORT_LINK_UP'
            pid = event[5] # Event Parameters: FeId, PortId
            if(self.ports.has_key(pid)):
                pb = self.ports[pid]
                pb.flash()
                pb.flash()
                pb.config(bg="green")
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            feid = event[4]
            evt.arg(('feid',feid))
            portid = event[5]
            evt.arg(('portid',portid))
            evt.save()
            self.ShowEvent(evt)
        if(id == str(CPPUI_EVENT_PORT_LINK_DOWN)):
            name = 'PORT_LINK_DOWN'
            pid = event[5] # Event Parameters: FeId, PortId
            if(self.ports.has_key(pid)):
                pb = self.ports[pid]
                pb.flash()
                pb.flash()
                pb.config(bg="red")
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            feid = event[4]
            evt.arg(('feid',feid))
            portid = event[5]
            evt.arg(('portid',portid))
            evt.save()
            self.ShowEvent(evt)
        if(id == str(CPPUI_EVENT_IF_UP)):
            name = 'IF_UP'
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            handle = event[4]
            evt.arg(('handle',handle))
            evt.save()
            self.ShowEvent(evt)
        if(id == str(CPPUI_EVENT_IF_DOWN)):
            name = 'IF_DOWN'
            evt = CppuiEvent(name, id, prio, descr)
            evt.count(self.ec)
            handle = event[4]
            evt.arg(('handle',handle))
            evt.save()
            self.ShowEvent(evt)
    #-----------------------------------------------------
     
    def UpdateResponseButton(self, reqresp, setnc = 1):
        if(setnc == 1):
            self.nc = self.seq - 1
        text = reqresp.text()
        if(self.gui):
            self.rb.config(text = text)
        if(self.log == 1):
            self.Log(text)
        if(not self.gui):
            text = '\t\tRESULT(' + `reqresp.sequence` + '):\t\t' + reqresp.resp 
            print text
            return
        if(reqresp.geterror() != CPPUI_NO_ERROR):
            self.rb.config(fg = "red")
        else:
            self.rb.config(fg = "blue")
        type = reqresp.type()
        error = reqresp.geterror()
        if(setnc == 0): #Call is from Navigate Function
            return
        if(type == str(CPPDK_CONNECT_REQ)): #Connect Response
            if(error == CPPUI_NO_ERROR):
                self.connect = 1
                self.sb.flash()
                self.sb.flash()
                #self.sb.config(bg="blue")
                self.sb.config(text="Disconnect")
        
        elif(type == str(CPPDK_DISCONNECT_REQ)): #Disconnect Response
            self.DisableLog(0)
            self.connect = 0
            self.sb.flash()
            self.sb.flash()
            self.sb.config(text="Connect   ")
             
            self.waitMode = 0
            self.tm.flash()
            self.tm.flash()
            self.tm.config(bg="lightblue", fg="blue")
            self.enableLog.config(bg="lightblue", fg="blue")
        
        
    
    
    def ConnectDisconnect(self):
        if(self.connect == 0):
            if(self.printFile == 1):
                tkMessageBox.showerror("CPPDK Connect ","Test Script file Enabled, Disable it and Try Again")
                return
            self.Connect()
        else:
            self.Disconnect()
    
    def Connect(self):
        if(self.RecvThread == 0):
            thread.start_new_thread(self.Recv, ())
            self.RecvThread == 1
        if(self.gui):
            ConnectDialog(self.root, self)
    
    
    def Disconnect(self):
        close = tkMessageBox.askyesno("Disconnect", "Disconnect \n Are you sure?")
        if(close != 1):
            return
        reqresp = ReqResp("Disconnect", str(CPPDK_DISCONNECT_REQ))
        self.Send(reqresp)
        self.connect = 0
    
    
    def End(self):
        if(self.connect == 1):
            tkMessageBox.showerror("Quit ","connected to CPPDK server \n Disconnect and Try again")
            return
        close = tkMessageBox.askyesno("Quit", "Quit  \n Are you sure?")
        if(close != 1):
            return
        self.root.quit()
    
    
    def Send(self, req):
        TEST = 0
        req.count(self.seq)
        if(TEST == 1):
            self.connect = 1
            print req.name + "=>	" + req.command(self.selftest)
            resp = "TEST PASSED#" + str(req.type()) + ";" + str(req.seq())
            resp = resp + ";" + str(req.geterror()) + "#TIME STAMP"
            self.seq = self.seq + 1
            req.save()
            self.Response(resp)
            if(self.seq%2 == 0):
                resp = '-#'
                resp = resp + str(CPPDK_EVENT) + ';' + str(CPPUI_EVENT_PORT_LINK_UP) + ';'
                resp = resp + str(EVENT_PRIORITY_NORMAL) + ';' + 'PORT_LINK_UP' + ';'
                resp = resp + str(0) + ';' + str(0)
                resp = resp + '#-'
                self.Response(resp)
            return
        try:
            if(self.cc > 3):
                if(self.gui):
                    abort = tkMessageBox.askyesno("Send Abort", "Stop Sending?")
                else:
                    abort = askyesno("Stop........... ?")
                if(abort == 1):
                    self.abort = 1
                    return
                else:
                    self.cc = 0
            if(self.waitMode):
                if(self.gui):
                    send = tkMessageBox.askyesno(req.hdr(), req.getdescr())
                else:
                    send = askyesno('Send:  ' + req.getdescr())
                if(not send):
                    self.cc = self.cc + 1
                    return
            req.save()
            if(not self.gui and not self.waitMode):
                print req.getdescr()
            if(not self.waitMode and self.waitTime > 0):
                time.sleep(self.waitTime)
            self.sock.sendto(req.command(self.selftest), (self.host, self.port))
            self.seq = self.seq + 1
        except:
            sendError = 'Verify Connection to CPPDK server and Try Again'
            if(self.gui):
                tkMessageBox.showerror("Send Error ", sendError)
                pass
            else:
                showerror("Send Error ", sendError)
    
    
    def LogFile(self):
        if(self.log == 1):
            self.DisableLog()
        else:
            self.EnableLog()
    
    def Log(self, text):
        if(self.log == 0 or self.logf == None):
            return
        try:
            self.logf.write(text + '\n\n')
        except:
            print 'ERROR: Error occured in writing log file'
            pass
    
    def EnableLog(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        types = []
        types.append(('log', '*.log'))
        types.append(('all', '*.*'))
        logf = tkFileDialog.asksaveasfilename(initialdir=self.LOG_DIR, defaultextension="log", filetypes=types, initialfile="cppui.log")
        if(not len(logf)):
            return
        self.lf = logf
        self.logf = open(logf, 'w')
        self.log = 1
        self.enableLog.flash()
        self.enableLog.flash()
        self.enableLog.config(bg="cyan", fg="red")
    
    def TestMode(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        if(self.waitMode):
            self.DisableTestMode()
        else:
            self.EnableTestMode()
    
    def EnableTestMode(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        ans = tkMessageBox.askyesno("Enable Wait Mode", "Enable Wait Mode, Are you Sure?")
        if(ans == 1):
            self.waitMode = 1
            self.tm.flash()
            self.tm.flash()
            self.tm.config(bg="cyan", fg="red")
    
    def DisableTestMode(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        ans = tkMessageBox.askyesno("Disable Wait Mode", "Disable Wait Mode, Are you Sure?")
        if(ans == 1):
            self.waitMode = 0
            self.tm.flash()
            self.tm.flash()
            self.tm.config(bg="lightblue", fg="blue")
    
    def EnableSelfTest(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        self.selftest = 1
        self.rb.config(bg = "black")
    
    def DisableSelfTest(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        self.selftest = 0
        self.rb.config(bg = "light gray")
    
    def SetWaitTime(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        try:
            wt = tkSimpleDialog.askstring(title="Delay in seconds", prompt="Time:", initialvalue=1)
            if(not wt):
                return
            self.waitTime = int(wt)
        except:
            tkMessageBox.showerror("Time", "Invalid Value")
        if(self.waitTime > 10):
            tkMessageBox.showerror("Time", "Too big, use < 10")
            self.waitTime = 0
        if(self.waitTime > 0):
            self.loadFile.config(bg="red")
        else:
            self.loadFile.config(bg="lightblue")
    
    def SetRepeatCount(self):
        if(self.connect != 1):
            tkMessageBox.showerror("CPPUI Status", "Not Connected")
            return
        try:
            rc = tkSimpleDialog.askstring(title="Command Repeat Count", prompt="Count:", initialvalue=1)
            if(not rc):
                return
            self.repeatCount = int(rc)
        except:
            tkMessageBox.showerror("Command Repeat Count", "Invalid Value")
    
    def DisableLog(self, ask = 1):
        try:
            if(ask == 1):
                disable = tkMessageBox.askyesno("Disable Log", "Are you Sure?")
                if(disable != 1):
                    return
            if(self.log ==1 and self.logf != None):
                self.logf.flush()
                self.logf.flush()
                self.logf.close()
                self.log = 0
                self.enableLog.flash()
                self.enableLog.flash()
                self.enableLog.config(bg="lightblue", fg="blue")
        except:
            tkMessageBox.showerror("Log Error ", "Error Occured while closing log file")
            pass
    
    def DisplayLog(self):
        LogDialog(self.root, self)
    
    def Status(self):
        while(1):
            if(self.connect == 0):
                self.sb.config(text="Connect   ")
                time.sleep(10)
                continue
            time.sleep(1)
            #self.sb.config(bg="white")
            time.sleep(1)
            #self.sb.config(bg="blue")
            time.sleep(1)
    
    
    def Recv(self):
        while(1):
            try:
                data, ADDR = self.sock.recvfrom(1024)
                self.recvs = self.recvs + 1
                self.Response(data)
            except:
                pass
    
    
    def Response(self, data):
        #print data
        resp = string.split(data, '#')
        if(len(resp) < 3):
            self.UpdateResponseButton('CPPDK CONNECT', 'INVALID RESPONSE', 1)
            return
        output = resp[0]
        input = resp[1]
        delay = resp[2]
        seq_cmd_error = string.split(resp[1], ';')
        if(len(seq_cmd_error) < 3):
            self.UpdateResponseButton('CPPDK CONNECT', 'INVALID RESPONSE', 1)
            return
        type = seq_cmd_error[0]
        if(type == str(CPPDK_EVENT)):
            self.ProcessEvent(resp)
            return
        seq = seq_cmd_error[1]
        error = seq_cmd_error[2]
        if(not CppuiReqResp.has_key(str(seq))):
            print 'UNKNOWN RESPONSE(' + seq + ')'
            return
        response = CppuiReqResp[str(seq)]
        response.error(error)
        response.output(output)
        self.UpdateResponseButton(response)
        return

class NameSpaceCreateDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="NameSpaceCreate")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="Node Path:", fg="blue").grid(row=row, column=14)
        self.Node_PathEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Node_PathEntry.grid(row=row, column=22)
        self.Node_PathEntry.insert(0, "/NPFSys/0")
        row = row + 1
        self.Node_TypeEnums = {u'NPF_NS_INSTNODE': u'1', u'NPF_NS_TYPENODE': u'0', u'NPF_NS_ALIASNODE': u'2'}
        Label(master,text="Node Type:", fg="blue").grid(row=row, column=14)
        self.Node_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Node_TypeEntry.grid(row=row, column=22)
        self.Node_TypeEntry.insert(0, "NPF_NS_TYPENODE")
        self.enums.append((self.Node_TypeEntry, self.Node_TypeEntry, self.Node_TypeEnums))
        row = row + 1
        self.Node_Data_TypeEnums = {u'NPF_FTNTABLE': u'6', u'NPF_ATM_VIRTUAL_DEVICE': u'14', u'NPF_INTCONFIG': u'11', u'NPF_ILMTABLE': u'7', u'NPF_PORT': u'9', u'NPF_INTERFACE': u'10', u'NPF_SYSTEM': u'0', u'NPF_IPROUTER': u'1', u'NPF_ATM_CONNECTION': u'13', u'NPF_NEXTHOPTABLE': u'4', u'NPF_ROUTETABLE': u'2', u'NPF_FE': u'8', u'NPF_ATM_LINK': u'12', u'NPF_ARPTABLE': u'5', u'NPF_PREFIXTABLE': u'3'}
        Label(master,text="Node Data Type:", fg="blue").grid(row=row, column=14)
        self.Node_Data_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Node_Data_TypeEntry.grid(row=row, column=22)
        self.Node_Data_TypeEntry.insert(0, "NPF_SYSTEM")
        self.enums.append((self.Node_Data_TypeEntry, self.Node_Data_TypeEntry, self.Node_Data_TypeEnums))
        row = row + 1
        Label(master,text="Node Instance:", fg="blue").grid(row=row, column=14)
        self.Node_InstanceEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Node_InstanceEntry.grid(row=row, column=22)
        self.Node_InstanceEntry.insert(0, "0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "1"
            reqresp = ReqResp('NameSpaceCreate', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'Node_Path'
            node_path = self.Node_PathEntry.get()
            vl = node_path
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Node_Type'
            node_type = self.Node_TypeEntry.get()
            if(self.Node_TypeEnums.has_key(node_type)):
                node_type = self.Node_TypeEnums[node_type]
            vl = node_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Node_Data_Type'
            node_data_type = self.Node_Data_TypeEntry.get()
            if(self.Node_Data_TypeEnums.has_key(node_data_type)):
                node_data_type = self.Node_Data_TypeEnums[node_data_type]
            vl = node_data_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Node_Instance'
            node_instance = self.Node_InstanceEntry.get()
            vl = node_instance
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("NameSpaceCreate ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('NameSpace_Create', '1'))
                nm = "Node_Path"
                val = self.Node_PathEntry.get()
                order.append((nm, str(val)))
                nm = "Node_Type"
                val = self.Node_TypeEntry.get()
                if(self.Node_TypeEnums.has_key(val)):
                    val  = self.Node_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "Node_Data_Type"
                val = self.Node_Data_TypeEntry.get()
                if(self.Node_Data_TypeEnums.has_key(val)):
                    val  = self.Node_Data_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "Node_Instance"
                val = self.Node_InstanceEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("NameSpaceCreate", "Error Occured while processing NameSpaceCreate Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class NameSpaceAssociateDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="NameSpaceAssociate")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="Source Path:", fg="blue").grid(row=row, column=14)
        self.Source_PathEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Source_PathEntry.grid(row=row, column=22)
        self.Source_PathEntry.insert(0, "/NPFSys/0")
        row = row + 1
        Label(master,text="Target Path:", fg="blue").grid(row=row, column=14)
        self.Target_PathEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Target_PathEntry.grid(row=row, column=22)
        self.Target_PathEntry.insert(0, "/NPFSys/0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "2"
            reqresp = ReqResp('NameSpaceAssociate', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'Source_Path'
            source_path = self.Source_PathEntry.get()
            vl = source_path
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Target_Path'
            target_path = self.Target_PathEntry.get()
            vl = target_path
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("NameSpaceAssociate ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('NameSpace_Associate', '2'))
                nm = "Source_Path"
                val = self.Source_PathEntry.get()
                order.append((nm, str(val)))
                nm = "Target_Path"
                val = self.Target_PathEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("NameSpaceAssociate", "Error Occured while processing NameSpaceAssociate Dialog")
            pass
    
    def operation(self, event=None):
        pass


class InterfaceCreate_LAN_And_Set_AttributeDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="InterfaceCreate_LAN_And_Set_Attribute")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.TypeEnums = {u'NPF_IF_TYPE_IPV6INV4': u'7', u'NPF_IF_TYPE_UNK': u'1', u'NPF_IF_TYPE_ATM': u'3', u'NPF_IF_TYPE_POS': u'4', u'NPF_IF_TYPE_MPLS': u'8', u'NPF_IF_TYPE_LAN': u'2', u'NPF_IF_TYPE_IPV4': u'5', u'NPF_IF_TYPE_IPV6': u'6'}
        Label(master,text="Type:", fg="blue").grid(row=row, column=14)
        self.TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.TypeEntry.grid(row=row, column=22)
        self.TypeEntry.insert(0, "NPF_IF_TYPE_LAN")
        self.TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.TypeEntry, self.TypeEntry, self.TypeEnums))
        row = row + 1
        Label(master,text="Port:", fg="blue").grid(row=row, column=14)
        self.PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PortEntry.grid(row=row, column=22)
        self.PortEntry.insert(0, "0")
        row = row + 1
        self.SpeedEnums = {u'NPF_IF_LAN_SPEED_10G': u'4', u'NPF_IF_LAN_SPEED_1G': u'3', u'NPF_IF_LAN_SPEED_10M': u'1', u'NPF_IF_LAN_SPEED_AUTO': u'5', u'NPF_IF_LAN_SPEED_100M': u'2'}
        Label(master,text="Speed:", fg="blue").grid(row=row, column=14)
        self.SpeedEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SpeedEntry.grid(row=row, column=22)
        self.SpeedEntry.insert(0, "NPF_IF_LAN_SPEED_10M")
        self.enums.append((self.SpeedEntry, self.SpeedEntry, self.SpeedEnums))
        row = row + 1
        Label(master,text="Promisc:", fg="blue").grid(row=row, column=14)
        self.PromiscEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PromiscEntry.grid(row=row, column=22)
        self.PromiscEntry.insert(0, "0")
        self.PromiscEntry.config(fg="red", state=DISABLED)
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "200"
            reqresp = ReqResp('InterfaceCreate_LAN_And_Set_Attribute', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Type'
            if(self.TypeEnums.has_key('NPF_IF_TYPE_LAN')):
                internalEnum   = self.TypeEnums['NPF_IF_TYPE_LAN']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Port'
            port = self.PortEntry.get()
            vl = port
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Speed'
            speed = self.SpeedEntry.get()
            if(self.SpeedEnums.has_key(speed)):
                speed = self.SpeedEnums[speed]
            vl = speed
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Promisc'
            vl = '0'
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceCreate_LAN_And_Set_Attribute ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Create_LAN_And_Set_Attribute', '200'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Type"
                if(self.TypeEnums.has_key('NPF_IF_TYPE_LAN')):
                    val  = self.TypeEnums['NPF_IF_TYPE_LAN']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "Port"
                val = self.PortEntry.get()
                order.append((nm, str(val)))
                nm = "Speed"
                val = self.SpeedEntry.get()
                if(self.SpeedEnums.has_key(val)):
                    val  = self.SpeedEnums[val]
                order.append((nm, str(val)))
                nm = "Promisc"
                val = "0"
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceCreate_LAN_And_Set_Attribute", "Error Occured while processing InterfaceCreate_LAN_And_Set_Attribute Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class InterfaceCreate_POS_And_Set_AttributeDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="InterfaceCreate_POS_And_Set_Attribute")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.TypeEnums = {u'NPF_IF_TYPE_IPV6INV4': u'7', u'NPF_IF_TYPE_UNK': u'1', u'NPF_IF_TYPE_ATM': u'3', u'NPF_IF_TYPE_POS': u'4', u'NPF_IF_TYPE_MPLS': u'8', u'NPF_IF_TYPE_LAN': u'2', u'NPF_IF_TYPE_IPV4': u'5', u'NPF_IF_TYPE_IPV6': u'6'}
        Label(master,text="Type:", fg="blue").grid(row=row, column=14)
        self.TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.TypeEntry.grid(row=row, column=22)
        self.TypeEntry.insert(0, "NPF_IF_TYPE_POS")
        self.TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.TypeEntry, self.TypeEntry, self.TypeEnums))
        row = row + 1
        Label(master,text="Port:", fg="blue").grid(row=row, column=14)
        self.PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PortEntry.grid(row=row, column=22)
        self.PortEntry.insert(0, "0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "201"
            reqresp = ReqResp('InterfaceCreate_POS_And_Set_Attribute', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Type'
            if(self.TypeEnums.has_key('NPF_IF_TYPE_POS')):
                internalEnum   = self.TypeEnums['NPF_IF_TYPE_POS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Port'
            port = self.PortEntry.get()
            vl = port
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceCreate_POS_And_Set_Attribute ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Create_POS_And_Set_Attribute', '201'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Type"
                if(self.TypeEnums.has_key('NPF_IF_TYPE_POS')):
                    val  = self.TypeEnums['NPF_IF_TYPE_POS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "Port"
                val = self.PortEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceCreate_POS_And_Set_Attribute", "Error Occured while processing InterfaceCreate_POS_And_Set_Attribute Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class InterfaceCreate_ATM_And_Set_AttributeDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="InterfaceCreate_ATM_And_Set_Attribute")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="Nos:", fg="blue").grid(row=row, column=14)
        self.NosEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NosEntry.grid(row=row, column=22)
        self.NosEntry.insert(0, "1")
        self.NosEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.IfTypeEnums = {u'NPF_IF_TYPE_IPV6INV4': u'7', u'NPF_IF_TYPE_UNK': u'1', u'NPF_IF_TYPE_ATM': u'3', u'NPF_IF_TYPE_POS': u'4', u'NPF_IF_TYPE_MPLS': u'8', u'NPF_IF_TYPE_LAN': u'2', u'NPF_IF_TYPE_IPV4': u'5', u'NPF_IF_TYPE_IPV6': u'6'}
        Label(master,text="IfType:", fg="blue").grid(row=row, column=14)
        self.IfTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfTypeEntry.grid(row=row, column=22)
        self.IfTypeEntry.insert(0, "NPF_IF_TYPE_ATM")
        self.IfTypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.IfTypeEntry, self.IfTypeEntry, self.IfTypeEnums))
        row = row + 1
        Label(master,text="PortSpeed:", fg="blue").grid(row=row, column=14)
        self.PortSpeedEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PortSpeedEntry.grid(row=row, column=22)
        self.PortSpeedEntry.insert(0, "644000")
        row = row + 1
        Label(master,text="PortNos:", fg="blue").grid(row=row, column=14)
        self.PortNosEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PortNosEntry.grid(row=row, column=22)
        self.PortNosEntry.insert(0, "0")
        row = row + 1
        self.atmAddressTypeEnums = {u'NPF_IF_ATM_E164_ADDR': u'0', u'NPF_IF_ATM_NSAP_ADDR': u'1'}
        Label(master,text="atmAddressType:", fg="blue").grid(row=row, column=14)
        self.atmAddressTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.atmAddressTypeEntry.grid(row=row, column=22)
        self.atmAddressTypeEntry.insert(0, "NPF_IF_ATM_E164_ADDR")
        self.enums.append((self.atmAddressTypeEntry, self.atmAddressTypeEntry, self.atmAddressTypeEnums))
        row = row + 1
        Label(master,text="maxVpiBits:", fg="blue").grid(row=row, column=14)
        self.maxVpiBitsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.maxVpiBitsEntry.grid(row=row, column=22)
        self.maxVpiBitsEntry.insert(0, "12")
        row = row + 1
        Label(master,text="maxVciBits:", fg="blue").grid(row=row, column=14)
        self.maxVciBitsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.maxVciBitsEntry.grid(row=row, column=22)
        self.maxVciBitsEntry.insert(0, "12")
        row = row + 1
        self.ATMIfTypeEnums = {u'NPF_NNI': u'0', u'NPF_UNI': u'1'}
        Label(master,text="ATMIfType:", fg="blue").grid(row=row, column=14)
        self.ATMIfTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ATMIfTypeEntry.grid(row=row, column=22)
        self.ATMIfTypeEntry.insert(0, "NPF_NNI")
        self.enums.append((self.ATMIfTypeEntry, self.ATMIfTypeEntry, self.ATMIfTypeEnums))
        row = row + 1
        self.ATM_IfTypeEnums = {u'NPF_PUBLIC': u'0', u'NPF_PRIVATE': u'1'}
        Label(master,text="ATM IfType:", fg="blue").grid(row=row, column=14)
        self.ATM_IfTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ATM_IfTypeEntry.grid(row=row, column=22)
        self.ATM_IfTypeEntry.insert(0, "NPF_PUBLIC")
        self.enums.append((self.ATM_IfTypeEntry, self.ATM_IfTypeEntry, self.ATM_IfTypeEnums))
        row = row + 1
        self.DeviceTypeEnums = {u'NPF_NETWORK': u'1', u'NPF_USER': u'0'}
        Label(master,text="DeviceType:", fg="blue").grid(row=row, column=14)
        self.DeviceTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DeviceTypeEntry.grid(row=row, column=22)
        self.DeviceTypeEntry.insert(0, "NPF_USER")
        self.enums.append((self.DeviceTypeEntry, self.DeviceTypeEntry, self.DeviceTypeEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "202"
            reqresp = ReqResp('InterfaceCreate_ATM_And_Set_Attribute', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'Nos'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfType'
            if(self.IfTypeEnums.has_key('NPF_IF_TYPE_ATM')):
                internalEnum   = self.IfTypeEnums['NPF_IF_TYPE_ATM']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PortSpeed'
            portspeed = self.PortSpeedEntry.get()
            vl = portspeed
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PortNos'
            portnos = self.PortNosEntry.get()
            vl = portnos
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'atmAddressType'
            atmaddresstype = self.atmAddressTypeEntry.get()
            if(self.atmAddressTypeEnums.has_key(atmaddresstype)):
                atmaddresstype = self.atmAddressTypeEnums[atmaddresstype]
            vl = atmaddresstype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'maxVpiBits'
            maxvpibits = self.maxVpiBitsEntry.get()
            vl = maxvpibits
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'maxVciBits'
            maxvcibits = self.maxVciBitsEntry.get()
            vl = maxvcibits
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ATMIfType'
            atmiftype = self.ATMIfTypeEntry.get()
            if(self.ATMIfTypeEnums.has_key(atmiftype)):
                atmiftype = self.ATMIfTypeEnums[atmiftype]
            vl = atmiftype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ATM_IfType'
            atm_iftype = self.ATM_IfTypeEntry.get()
            if(self.ATM_IfTypeEnums.has_key(atm_iftype)):
                atm_iftype = self.ATM_IfTypeEnums[atm_iftype]
            vl = atm_iftype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DeviceType'
            devicetype = self.DeviceTypeEntry.get()
            if(self.DeviceTypeEnums.has_key(devicetype)):
                devicetype = self.DeviceTypeEnums[devicetype]
            vl = devicetype
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceCreate_ATM_And_Set_Attribute ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Create_ATM_And_Set_Attribute', '202'))
                nm = "Nos"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfType"
                if(self.IfTypeEnums.has_key('NPF_IF_TYPE_ATM')):
                    val  = self.IfTypeEnums['NPF_IF_TYPE_ATM']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "PortSpeed"
                val = self.PortSpeedEntry.get()
                order.append((nm, str(val)))
                nm = "PortNos"
                val = self.PortNosEntry.get()
                order.append((nm, str(val)))
                nm = "atmAddressType"
                val = self.atmAddressTypeEntry.get()
                if(self.atmAddressTypeEnums.has_key(val)):
                    val  = self.atmAddressTypeEnums[val]
                order.append((nm, str(val)))
                nm = "maxVpiBits"
                val = self.maxVpiBitsEntry.get()
                order.append((nm, str(val)))
                nm = "maxVciBits"
                val = self.maxVciBitsEntry.get()
                order.append((nm, str(val)))
                nm = "ATMIfType"
                val = self.ATMIfTypeEntry.get()
                if(self.ATMIfTypeEnums.has_key(val)):
                    val  = self.ATMIfTypeEnums[val]
                order.append((nm, str(val)))
                nm = "ATM_IfType"
                val = self.ATM_IfTypeEntry.get()
                if(self.ATM_IfTypeEnums.has_key(val)):
                    val  = self.ATM_IfTypeEnums[val]
                order.append((nm, str(val)))
                nm = "DeviceType"
                val = self.DeviceTypeEntry.get()
                if(self.DeviceTypeEnums.has_key(val)):
                    val  = self.DeviceTypeEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceCreate_ATM_And_Set_Attribute", "Error Occured while processing InterfaceCreate_ATM_And_Set_Attribute Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class InterfaceCreate_IPV4Dialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="InterfaceCreate_IPV4")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.TypeEnums = {u'NPF_IF_TYPE_IPV6INV4': u'7', u'NPF_IF_TYPE_UNK': u'1', u'NPF_IF_TYPE_ATM': u'3', u'NPF_IF_TYPE_POS': u'4', u'NPF_IF_TYPE_MPLS': u'8', u'NPF_IF_TYPE_LAN': u'2', u'NPF_IF_TYPE_IPV4': u'5', u'NPF_IF_TYPE_IPV6': u'6'}
        Label(master,text="Type:", fg="blue").grid(row=row, column=14)
        self.TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.TypeEntry.grid(row=row, column=22)
        self.TypeEntry.insert(0, "NPF_IF_TYPE_IPV4")
        self.TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.TypeEntry, self.TypeEntry, self.TypeEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "203"
            reqresp = ReqResp('InterfaceCreate_IPV4', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Type'
            if(self.TypeEnums.has_key('NPF_IF_TYPE_IPV4')):
                internalEnum   = self.TypeEnums['NPF_IF_TYPE_IPV4']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceCreate_IPV4 ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Create_IPV4', '203'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Type"
                if(self.TypeEnums.has_key('NPF_IF_TYPE_IPV4')):
                    val  = self.TypeEnums['NPF_IF_TYPE_IPV4']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceCreate_IPV4", "Error Occured while processing InterfaceCreate_IPV4 Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class InterfaceIPV4_Set_AttributesDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceIPV4_Set_Attributes")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Type:", fg="blue").grid(row=row, column=14)
        self.TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.TypeEntry.grid(row=row, column=22)
        self.TypeEntry.insert(0, "NPF_IF_TYPE_IPV4")
        self.TypeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "IPV4:0")
        row = row + 1
        Label(master,text="Address:", fg="blue").grid(row=row, column=14)
        self.AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddressEntry.grid(row=row, column=22)
        self.AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        Label(master,text="NetPlen:", fg="blue").grid(row=row, column=14)
        self.NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NetPlenEntry.grid(row=row, column=22)
        self.NetPlenEntry.insert(0, "2")
        row = row + 1
        Label(master,text="MTU:", fg="blue").grid(row=row, column=14)
        self.MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MTUEntry.grid(row=row, column=22)
        self.MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="FIBhandle:", fg="blue").grid(row=row, column=14)
        self.FIBhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FIBhandleEntry.grid(row=row, column=22)
        self.FIBhandleEntry.insert(0, "0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "204"
            reqresp = ReqResp('InterfaceIPV4_Set_Attributes', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Type'
            vl = 'NPF_IF_TYPE_IPV4'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Address'
            address = self.AddressEntry.get()
            vl = address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NetPlen'
            netplen = self.NetPlenEntry.get()
            vl = netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MTU'
            mtu = self.MTUEntry.get()
            vl = mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'FIBhandle'
            fibhandle = self.FIBhandleEntry.get()
            vl = fibhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceIPV4_Set_Attributes ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_IPV4_Set_Attributes', '204'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Type"
                val = "NPF_IF_TYPE_IPV4"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "Address"
                val = self.AddressEntry.get()
                order.append((nm, str(val)))
                nm = "NetPlen"
                val = self.NetPlenEntry.get()
                order.append((nm, str(val)))
                nm = "MTU"
                val = self.MTUEntry.get()
                order.append((nm, str(val)))
                nm = "FIBhandle"
                val = self.FIBhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceIPV4_Set_Attributes", "Error Occured while processing InterfaceIPV4_Set_Attributes Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceIPV4_Interface_Set_AddressDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceIPV4_Interface_Set_Address")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "IPV4:0")
        row = row + 1
        Label(master,text="Address:", fg="blue").grid(row=row, column=14)
        self.AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddressEntry.grid(row=row, column=22)
        self.AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        Label(master,text="NetPlen:", fg="blue").grid(row=row, column=14)
        self.NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NetPlenEntry.grid(row=row, column=22)
        self.NetPlenEntry.insert(0, "2")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "205"
            reqresp = ReqResp('InterfaceIPV4_Interface_Set_Address', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Address'
            address = self.AddressEntry.get()
            vl = address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NetPlen'
            netplen = self.NetPlenEntry.get()
            vl = netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceIPV4_Interface_Set_Address ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_IPV4_Interface_Set_Address', '205'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "Address"
                val = self.AddressEntry.get()
                order.append((nm, str(val)))
                nm = "NetPlen"
                val = self.NetPlenEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceIPV4_Interface_Set_Address", "Error Occured while processing InterfaceIPV4_Interface_Set_Address Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceIPV4_Interface_Set_MTUDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceIPV4_Interface_Set_MTU")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "IPV4:0")
        row = row + 1
        Label(master,text="MTU:", fg="blue").grid(row=row, column=14)
        self.MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MTUEntry.grid(row=row, column=22)
        self.MTUEntry.insert(0, "1500")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "206"
            reqresp = ReqResp('InterfaceIPV4_Interface_Set_MTU', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MTU'
            mtu = self.MTUEntry.get()
            vl = mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceIPV4_Interface_Set_MTU ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_IPV4_Interface_Set_MTU', '206'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "MTU"
                val = self.MTUEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceIPV4_Interface_Set_MTU", "Error Occured while processing InterfaceIPV4_Interface_Set_MTU Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceIPV4_Interface_Set_FIBDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceIPV4_Interface_Set_FIB")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "IPV4:0")
        row = row + 1
        Label(master,text="FIBhandle:", fg="blue").grid(row=row, column=14)
        self.FIBhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FIBhandleEntry.grid(row=row, column=22)
        self.FIBhandleEntry.insert(0, "FWD:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "207"
            reqresp = ReqResp('InterfaceIPV4_Interface_Set_FIB', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'FIBhandle'
            fibhandle = self.FIBhandleEntry.get()
            vl = fibhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceIPV4_Interface_Set_FIB ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_IPV4_Interface_Set_FIB', '207'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "FIBhandle"
                val = self.FIBhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceIPV4_Interface_Set_FIB", "Error Occured while processing InterfaceIPV4_Interface_Set_FIB Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceCreate_MPLS_InterfaceDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="InterfaceCreate_MPLS_Interface")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.TypeEnums = {u'NPF_IF_TYPE_IPV6INV4': u'7', u'NPF_IF_TYPE_UNK': u'1', u'NPF_IF_TYPE_ATM': u'3', u'NPF_IF_TYPE_POS': u'4', u'NPF_IF_TYPE_MPLS': u'8', u'NPF_IF_TYPE_LAN': u'2', u'NPF_IF_TYPE_IPV4': u'5', u'NPF_IF_TYPE_IPV6': u'6'}
        Label(master,text="Type:", fg="blue").grid(row=row, column=14)
        self.TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.TypeEntry.grid(row=row, column=22)
        self.TypeEntry.insert(0, "NPF_IF_TYPE_MPLS")
        self.TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.TypeEntry, self.TypeEntry, self.TypeEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "208"
            reqresp = ReqResp('InterfaceCreate_MPLS_Interface', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Type'
            if(self.TypeEnums.has_key('NPF_IF_TYPE_MPLS')):
                internalEnum   = self.TypeEnums['NPF_IF_TYPE_MPLS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceCreate_MPLS_Interface ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Create_MPLS_Interface', '208'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Type"
                if(self.TypeEnums.has_key('NPF_IF_TYPE_MPLS')):
                    val  = self.TypeEnums['NPF_IF_TYPE_MPLS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceCreate_MPLS_Interface", "Error Occured while processing InterfaceCreate_MPLS_Interface Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2BindingDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Interface Type:", fg="blue").grid(row=row, column=14)
        self.Interface_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Interface_TypeEntry.grid(row=row, column=22)
        self.Interface_TypeEntry.insert(0, "NPF_IF_TYPE_MPLS")
        self.Interface_TypeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="MPLSIfHandle:", fg="blue").grid(row=row, column=14)
        self.MPLSIfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MPLSIfHandleEntry.grid(row=row, column=22)
        self.MPLSIfHandleEntry.insert(0, "MPLS:0")
        row = row + 1
        Label(master,text="MPLS LblPkt ize:", fg="blue").grid(row=row, column=14)
        self.MPLS_LblPkt_izeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MPLS_LblPkt_izeEntry.grid(row=row, column=22)
        self.MPLS_LblPkt_izeEntry.insert(0, "1500")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "215"
            reqresp = ReqResp('InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Interface_Type'
            vl = 'NPF_IF_TYPE_MPLS'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MPLSIfHandle'
            mplsifhandle = self.MPLSIfHandleEntry.get()
            vl = mplsifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MPLS_LblPkt_ize'
            mpls_lblpkt_ize = self.MPLS_LblPkt_izeEntry.get()
            vl = mpls_lblpkt_ize
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Set_MPLS_Attribute_DoAfterMPLS2Layer2Binding', '215'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Interface_Type"
                val = "NPF_IF_TYPE_MPLS"
                val = str(val)
                order.append((nm, val))
                nm = "MPLSIfHandle"
                val = self.MPLSIfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "MPLS_LblPkt_ize"
                val = self.MPLS_LblPkt_izeEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding", "Error Occured while processing InterfaceSet_MPLS_Attribute_DoAfterMPLS2Layer2Binding Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceBindDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceBind")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="ParentIfHandle:", fg="blue").grid(row=row, column=14)
        self.ParentIfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ParentIfHandleEntry.grid(row=row, column=22)
        self.ParentIfHandleEntry.insert(0, "IPV4:0")
        row = row + 1
        Label(master,text="ChildIfHandle:", fg="blue").grid(row=row, column=14)
        self.ChildIfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ChildIfHandleEntry.grid(row=row, column=22)
        self.ChildIfHandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "209"
            reqresp = ReqResp('InterfaceBind', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ParentIfHandle'
            parentifhandle = self.ParentIfHandleEntry.get()
            vl = parentifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ChildIfHandle'
            childifhandle = self.ChildIfHandleEntry.get()
            vl = childifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceBind ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Bind', '209'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "ParentIfHandle"
                val = self.ParentIfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "ChildIfHandle"
                val = self.ChildIfHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceBind", "Error Occured while processing InterfaceBind Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceEnableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceEnable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "210"
            reqresp = ReqResp('InterfaceEnable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceEnable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Enable', '210'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceEnable", "Error Occured while processing InterfaceEnable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceStatusDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceStatus")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "211"
            reqresp = ReqResp('InterfaceStatus', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceStatus ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Status', '211'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceStatus", "Error Occured while processing InterfaceStatus Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceStatisticsDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceStatistics")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="Nos:", fg="blue").grid(row=row, column=14)
        self.NosEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NosEntry.grid(row=row, column=22)
        self.NosEntry.insert(0, "1")
        self.NosEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "ATM:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "212"
            reqresp = ReqResp('InterfaceStatistics', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'Nos'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceStatistics ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Statistics', '212'))
                nm = "Nos"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceStatistics", "Error Occured while processing InterfaceStatistics Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceDisableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceDisable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "213"
            reqresp = ReqResp('InterfaceDisable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceDisable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Disable', '213'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceDisable", "Error Occured while processing InterfaceDisable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class InterfaceDeleteDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="InterfaceDelete")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "214"
            reqresp = ReqResp('InterfaceDelete', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("InterfaceDelete ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('Interface_Delete', '214'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("InterfaceDelete", "Error Occured while processing InterfaceDelete Dialog")
            pass
    
    def operation(self, event=None):
        pass


class LANSet_AttributesDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="LANSet_Attributes")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        Label(master,text="Type:", fg="blue").grid(row=row, column=14)
        self.TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.TypeEntry.grid(row=row, column=22)
        self.TypeEntry.insert(0, "NPF_IF_TYPE_LAN")
        self.TypeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Port:", fg="blue").grid(row=row, column=14)
        self.PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PortEntry.grid(row=row, column=22)
        self.PortEntry.insert(0, "0")
        row = row + 1
        self.SpeedEnums = {u'NPF_IF_LAN_SPEED_10G': u'4', u'NPF_IF_LAN_SPEED_1G': u'3', u'NPF_IF_LAN_SPEED_10M': u'1', u'NPF_IF_LAN_SPEED_AUTO': u'5', u'NPF_IF_LAN_SPEED_100M': u'2'}
        Label(master,text="Speed:", fg="blue").grid(row=row, column=14)
        self.SpeedEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SpeedEntry.grid(row=row, column=22)
        self.SpeedEntry.insert(0, "NPF_IF_LAN_SPEED_10M")
        self.enums.append((self.SpeedEntry, self.SpeedEntry, self.SpeedEnums))
        row = row + 1
        Label(master,text="Promisc:", fg="blue").grid(row=row, column=14)
        self.PromiscEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PromiscEntry.grid(row=row, column=22)
        self.PromiscEntry.insert(0, "0")
        self.PromiscEntry.config(fg="red", state=DISABLED)
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "250"
            reqresp = ReqResp('LANSet_Attributes', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Type'
            vl = 'NPF_IF_TYPE_LAN'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Port'
            port = self.PortEntry.get()
            vl = port
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Speed'
            speed = self.SpeedEntry.get()
            if(self.SpeedEnums.has_key(speed)):
                speed = self.SpeedEnums[speed]
            vl = speed
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Promisc'
            vl = '0'
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANSet_Attributes ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Set_Attributes', '250'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "Type"
                val = "NPF_IF_TYPE_LAN"
                val = str(val)
                order.append((nm, val))
                nm = "Port"
                val = self.PortEntry.get()
                order.append((nm, str(val)))
                nm = "Speed"
                val = self.SpeedEntry.get()
                if(self.SpeedEnums.has_key(val)):
                    val  = self.SpeedEnums[val]
                order.append((nm, str(val)))
                nm = "Promisc"
                val = "0"
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANSet_Attributes", "Error Occured while processing LANSet_Attributes Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class LANSet_SpeedDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="LANSet_Speed")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        self.SpeedEnums = {u'NPF_IF_LAN_SPEED_10G': u'4', u'NPF_IF_LAN_SPEED_1G': u'3', u'NPF_IF_LAN_SPEED_10M': u'1', u'NPF_IF_LAN_SPEED_AUTO': u'5', u'NPF_IF_LAN_SPEED_100M': u'2'}
        Label(master,text="Speed:", fg="blue").grid(row=row, column=14)
        self.SpeedEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SpeedEntry.grid(row=row, column=22)
        self.SpeedEntry.insert(0, "NPF_IF_LAN_SPEED_10M")
        self.enums.append((self.SpeedEntry, self.SpeedEntry, self.SpeedEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "251"
            reqresp = ReqResp('LANSet_Speed', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Speed'
            speed = self.SpeedEntry.get()
            if(self.SpeedEnums.has_key(speed)):
                speed = self.SpeedEnums[speed]
            vl = speed
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANSet_Speed ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Set_Speed', '251'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "Speed"
                val = self.SpeedEntry.get()
                if(self.SpeedEnums.has_key(val)):
                    val  = self.SpeedEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANSet_Speed", "Error Occured while processing LANSet_Speed Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class LANSet_PromiscDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANSet_Promisc")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "252"
            reqresp = ReqResp('LANSet_Promisc', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANSet_Promisc ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Set_Promisc', '252'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANSet_Promisc", "Error Occured while processing LANSet_Promisc Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANClear_PromiscDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANClear_Promisc")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "253"
            reqresp = ReqResp('LANClear_Promisc', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANClear_Promisc ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Clear_Promisc', '253'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANClear_Promisc", "Error Occured while processing LANClear_Promisc Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANGet_Source_AddressDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANGet_Source_Address")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "254"
            reqresp = ReqResp('LANGet_Source_Address', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANGet_Source_Address ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Get_Source_Address', '254'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANGet_Source_Address", "Error Occured while processing LANGet_Source_Address Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANSet_Source_AddressDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANSet_Source_Address")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        Label(master,text="MACAddress:", fg="blue").grid(row=row, column=14)
        self.MACAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MACAddressEntry.grid(row=row, column=22)
        self.MACAddressEntry.insert(0, "128.113.7.14")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "255"
            reqresp = ReqResp('LANSet_Source_Address', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MACAddress'
            macaddress = self.MACAddressEntry.get()
            vl = macaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANSet_Source_Address ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Set_Source_Address', '255'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "MACAddress"
                val = self.MACAddressEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANSet_Source_Address", "Error Occured while processing LANSet_Source_Address Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANSet_Receive_Address_ListDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANSet_Receive_Address_List")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        Label(master,text="MACAddress:", fg="blue").grid(row=row, column=14)
        self.MACAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MACAddressEntry.grid(row=row, column=22)
        self.MACAddressEntry.insert(0, "128.113.7.14")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "256"
            reqresp = ReqResp('LANSet_Receive_Address_List', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MACAddress'
            macaddress = self.MACAddressEntry.get()
            vl = macaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANSet_Receive_Address_List ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Set_Receive_Address_List', '256'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "MACAddress"
                val = self.MACAddressEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANSet_Receive_Address_List", "Error Occured while processing LANSet_Receive_Address_List Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANAdd_Receive_Address_ListDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANAdd_Receive_Address_List")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        Label(master,text="AddrNo:", fg="blue").grid(row=row, column=14)
        self.AddrNoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddrNoEntry.grid(row=row, column=22)
        self.AddrNoEntry.insert(0, "1")
        self.AddrNoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="MACAddress:", fg="blue").grid(row=row, column=14)
        self.MACAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MACAddressEntry.grid(row=row, column=22)
        self.MACAddressEntry.insert(0, "128.113.7.14")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "257"
            reqresp = ReqResp('LANAdd_Receive_Address_List', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'AddrNo'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MACAddress'
            macaddress = self.MACAddressEntry.get()
            vl = macaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANAdd_Receive_Address_List ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Add_Receive_Address_List', '257'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                nm = "AddrNo"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "MACAddress"
                val = self.MACAddressEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANAdd_Receive_Address_List", "Error Occured while processing LANAdd_Receive_Address_List Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANSet_Full_DuplexDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANSet_Full_Duplex")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "258"
            reqresp = ReqResp('LANSet_Full_Duplex', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANSet_Full_Duplex ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Set_Full_Duplex', '258'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANSet_Full_Duplex", "Error Occured while processing LANSet_Full_Duplex Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANClear_Full_DuplexDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANClear_Full_Duplex")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "259"
            reqresp = ReqResp('LANClear_Full_Duplex', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANClear_Full_Duplex ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Clear_Full_Duplex', '259'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANClear_Full_Duplex", "Error Occured while processing LANClear_Full_Duplex Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANTx_Flow_Control_EnableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANTx_Flow_Control_Enable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "260"
            reqresp = ReqResp('LANTx_Flow_Control_Enable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANTx_Flow_Control_Enable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Tx_Flow_Control_Enable', '260'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANTx_Flow_Control_Enable", "Error Occured while processing LANTx_Flow_Control_Enable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANTx_Flow_Control_DisableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANTx_Flow_Control_Disable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "261"
            reqresp = ReqResp('LANTx_Flow_Control_Disable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANTx_Flow_Control_Disable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Tx_Flow_Control_Disable', '261'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANTx_Flow_Control_Disable", "Error Occured while processing LANTx_Flow_Control_Disable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANRx_Flow_Control_EnableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANRx_Flow_Control_Enable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "262"
            reqresp = ReqResp('LANRx_Flow_Control_Enable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANRx_Flow_Control_Enable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Rx_Flow_Control_Enable', '262'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANRx_Flow_Control_Enable", "Error Occured while processing LANRx_Flow_Control_Enable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class LANRx_Flow_Control_DisableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="LANRx_Flow_Control_Disable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="Ifhandle:", fg="blue").grid(row=row, column=14)
        self.IfhandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfhandleEntry.grid(row=row, column=22)
        self.IfhandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "263"
            reqresp = ReqResp('LANRx_Flow_Control_Disable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Ifhandle'
            ifhandle = self.IfhandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("LANRx_Flow_Control_Disable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('LAN_Rx_Flow_Control_Disable', '263'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Ifhandle"
                val = self.IfhandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("LANRx_Flow_Control_Disable", "Error Occured while processing LANRx_Flow_Control_Disable Dialog")
            pass
    
    def operation(self, event=None):
        pass


class IPV4Get_Supported_ModeDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Get_Supported_Mode")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "158"
            reqresp = ReqResp('IPV4Get_Supported_Mode', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Get_Supported_Mode ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Get_Supported_Mode', '158'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Get_Supported_Mode", "Error Occured while processing IPV4Get_Supported_Mode Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Get_Preferred_ModeDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Get_Preferred_Mode")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "159"
            reqresp = ReqResp('IPV4Get_Preferred_Mode', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Get_Preferred_Mode ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Get_Preferred_Mode', '159'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Get_Preferred_Mode", "Error Occured while processing IPV4Get_Preferred_Mode Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Create_Prefix_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Create_Prefix_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "160"
            reqresp = ReqResp('IPV4Create_Prefix_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Create_Prefix_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Create_Prefix_Table_Handle', '160'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Create_Prefix_Table_Handle", "Error Occured while processing IPV4Create_Prefix_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Create_NextHop_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Create_NextHop_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "161"
            reqresp = ReqResp('IPV4Create_NextHop_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Create_NextHop_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Create_NextHop_Table_Handle', '161'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Create_NextHop_Table_Handle", "Error Occured while processing IPV4Create_NextHop_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Create_AddRes_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Create_AddRes_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "162"
            reqresp = ReqResp('IPV4Create_AddRes_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Create_AddRes_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Create_AddRes_Table_Handle', '162'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Create_AddRes_Table_Handle", "Error Occured while processing IPV4Create_AddRes_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Delete_Prefix_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Delete_Prefix_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "PREFIX:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "163"
            reqresp = ReqResp('IPV4Delete_Prefix_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Delete_Prefix_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Delete_Prefix_Table_Handle', '163'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Delete_Prefix_Table_Handle", "Error Occured while processing IPV4Delete_Prefix_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Delete_NextHop_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Delete_NextHop_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "NEXTHOP:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "164"
            reqresp = ReqResp('IPV4Delete_NextHop_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Delete_NextHop_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Delete_NextHop_Table_Handle', '164'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Delete_NextHop_Table_Handle", "Error Occured while processing IPV4Delete_NextHop_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Delete_Address_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Delete_Address_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="AddResTableHandle:", fg="blue").grid(row=row, column=14)
        self.AddResTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddResTableHandleEntry.grid(row=row, column=22)
        self.AddResTableHandleEntry.insert(0, "ADDRESS:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "165"
            reqresp = ReqResp('IPV4Delete_Address_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'AddResTableHandle'
            addrestablehandle = self.AddResTableHandleEntry.get()
            vl = addrestablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Delete_Address_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Delete_Address_Table_Handle', '165'))
                nm = "AddResTableHandle"
                val = self.AddResTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Delete_Address_Table_Handle", "Error Occured while processing IPV4Delete_Address_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Bind_Prefix_NextHop_TableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Bind_Prefix_NextHop_Table")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "PREFIX:0")
        row = row + 1
        Label(master,text="NextHopTableHandle:", fg="blue").grid(row=row, column=14)
        self.NextHopTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTableHandleEntry.grid(row=row, column=22)
        self.NextHopTableHandleEntry.insert(0, "NEXTHOP:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "166"
            reqresp = ReqResp('IPV4Bind_Prefix_NextHop_Table', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopTableHandle'
            nexthoptablehandle = self.NextHopTableHandleEntry.get()
            vl = nexthoptablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Bind_Prefix_NextHop_Table ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Bind_Prefix_NextHop_Table', '166'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopTableHandle"
                val = self.NextHopTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Bind_Prefix_NextHop_Table", "Error Occured while processing IPV4Bind_Prefix_NextHop_Table Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Add_Prefix_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Add_Prefix_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "PREFIX:0")
        row = row + 1
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        row = row + 1
        Label(master,text="IPv4Addr:", fg="blue").grid(row=row, column=14)
        self.IPv4AddrEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4AddrEntry.grid(row=row, column=22)
        self.IPv4AddrEntry.insert(0, "10.1.0.9")
        row = row + 1
        Label(master,text="IPv4NetPlen:", fg="blue").grid(row=row, column=14)
        self.IPv4NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4NetPlenEntry.grid(row=row, column=22)
        self.IPv4NetPlenEntry.insert(0, "32")
        row = row + 1
        Label(master,text="NextHopId:", fg="blue").grid(row=row, column=14)
        self.NextHopIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopIdEntry.grid(row=row, column=22)
        self.NextHopIdEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "167"
            reqresp = ReqResp('IPV4Add_Prefix_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NoOfEntries'
            noofentries = self.NoOfEntriesEntry.get()
            vl = noofentries
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4Addr'
            ipv4addr = self.IPv4AddrEntry.get()
            vl = ipv4addr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4NetPlen'
            ipv4netplen = self.IPv4NetPlenEntry.get()
            vl = ipv4netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopId'
            nexthopid = self.NextHopIdEntry.get()
            vl = nexthopid
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Add_Prefix_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Add_Prefix_Table_Entry', '167'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NoOfEntries"
                val = self.NoOfEntriesEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4Addr"
                val = self.IPv4AddrEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4NetPlen"
                val = self.IPv4NetPlenEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopId"
                val = self.NextHopIdEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Add_Prefix_Table_Entry", "Error Occured while processing IPV4Add_Prefix_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Add_NextHop_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="IPV4Add_NextHop_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        row = row + 1
        Label(master,text="NextHopTableHandle:", fg="blue").grid(row=row, column=14)
        self.NextHopTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTableHandleEntry.grid(row=row, column=22)
        self.NextHopTableHandleEntry.insert(0, "NEXTHOP:0")
        row = row + 1
        Label(master,text="NextHopId:", fg="blue").grid(row=row, column=14)
        self.NextHopIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopIdEntry.grid(row=row, column=22)
        self.NextHopIdEntry.insert(0, "1")
        row = row + 1
        self.NextHopTypeEnums = {u'NPF_IPV4_REMOTE_ENTRY': u'5', u'NPF_IPV4_BASIC_ENTRY': u'1', u'NPF_IPV4_DIRECT_ATTACH_ENTRY': u'2'}
        Label(master,text="NextHopType:", fg="blue").grid(row=row, column=14)
        self.NextHopTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTypeEntry.grid(row=row, column=22)
        self.NextHopTypeEntry.insert(0, "NPF_IPV4_BASIC_ENTRY")
        self.enums.append((self.NextHopTypeEntry, self.NextHopTypeEntry, self.NextHopTypeEnums))
        row = row + 1
        Label(master,text="NextHopWeight:", fg="blue").grid(row=row, column=14)
        self.NextHopWeightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopWeightEntry.grid(row=row, column=22)
        self.NextHopWeightEntry.insert(0, "3")
        row = row + 1
        Label(master,text="EgressIfaceHandle:", fg="blue").grid(row=row, column=14)
        self.EgressIfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.EgressIfaceHandleEntry.grid(row=row, column=22)
        self.EgressIfaceHandleEntry.insert(0, "LAN:0")
        row = row + 1
        Label(master,text="NextHop IP Address:", fg="blue").grid(row=row, column=14)
        self.NextHop_IP_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHop_IP_AddressEntry.grid(row=row, column=22)
        self.NextHop_IP_AddressEntry.insert(0, "10.1.0.7")
        row = row + 1
        self.Media_Address_TypeEnums = {u'NPF_ATM_VC': u'3', u'NPF_MAC_ADDRESS': u'2', u'NPF_NO_MEDIA_TYPE': u'1'}
        Label(master,text="Media Address Type:", fg="blue").grid(row=row, column=14)
        self.Media_Address_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Media_Address_TypeEntry.grid(row=row, column=22)
        self.Media_Address_TypeEntry.insert(0, "NPF_MAC_ADDRESS")
        self.enums.append((self.Media_Address_TypeEntry, self.Media_Address_TypeEntry, self.Media_Address_TypeEnums))
        row = row + 1
        Label(master,text="Media Address:", fg="blue").grid(row=row, column=14)
        self.Media_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Media_AddressEntry.grid(row=row, column=22)
        self.Media_AddressEntry.insert(0, "0x12893473a1e3")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "168"
            reqresp = ReqResp('IPV4Add_NextHop_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            no = self.NoEntry.get()
            vl = no
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopTableHandle'
            nexthoptablehandle = self.NextHopTableHandleEntry.get()
            vl = nexthoptablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopId'
            nexthopid = self.NextHopIdEntry.get()
            vl = nexthopid
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopType'
            nexthoptype = self.NextHopTypeEntry.get()
            if(self.NextHopTypeEnums.has_key(nexthoptype)):
                nexthoptype = self.NextHopTypeEnums[nexthoptype]
            vl = nexthoptype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopWeight'
            nexthopweight = self.NextHopWeightEntry.get()
            vl = nexthopweight
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'EgressIfaceHandle'
            egressifacehandle = self.EgressIfaceHandleEntry.get()
            vl = egressifacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHop_IP_Address'
            nexthop_ip_address = self.NextHop_IP_AddressEntry.get()
            vl = nexthop_ip_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Media_Address_Type'
            media_address_type = self.Media_Address_TypeEntry.get()
            if(self.Media_Address_TypeEnums.has_key(media_address_type)):
                media_address_type = self.Media_Address_TypeEnums[media_address_type]
            vl = media_address_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Media_Address'
            media_address = self.Media_AddressEntry.get()
            vl = media_address
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Add_NextHop_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Add_NextHop_Table_Entry', '168'))
                nm = "No"
                val = self.NoEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopTableHandle"
                val = self.NextHopTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopId"
                val = self.NextHopIdEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopType"
                val = self.NextHopTypeEntry.get()
                if(self.NextHopTypeEnums.has_key(val)):
                    val  = self.NextHopTypeEnums[val]
                order.append((nm, str(val)))
                nm = "NextHopWeight"
                val = self.NextHopWeightEntry.get()
                order.append((nm, str(val)))
                nm = "EgressIfaceHandle"
                val = self.EgressIfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NextHop_IP_Address"
                val = self.NextHop_IP_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "Media_Address_Type"
                val = self.Media_Address_TypeEntry.get()
                if(self.Media_Address_TypeEnums.has_key(val)):
                    val  = self.Media_Address_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "Media_Address"
                val = self.Media_AddressEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Add_NextHop_Table_Entry", "Error Occured while processing IPV4Add_NextHop_Table_Entry Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class IPV4Add_AddRes_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="IPV4Add_AddRes_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="AddResTableHandle:", fg="blue").grid(row=row, column=14)
        self.AddResTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddResTableHandleEntry.grid(row=row, column=22)
        self.AddResTableHandleEntry.insert(0, "ADDRESS:0")
        row = row + 1
        Label(master,text="IP Address:", fg="blue").grid(row=row, column=14)
        self.IP_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IP_AddressEntry.grid(row=row, column=22)
        self.IP_AddressEntry.insert(0, "10.1.0.7")
        row = row + 1
        Label(master,text="Interface Handle:", fg="blue").grid(row=row, column=14)
        self.Interface_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Interface_HandleEntry.grid(row=row, column=22)
        self.Interface_HandleEntry.insert(0, "LAN:0")
        row = row + 1
        self.Media_Address_TypeEnums = {u'NPF_ATM_VC': u'3', u'NPF_MAC_ADDRESS': u'2', u'NPF_NO_MEDIA_TYPE': u'1'}
        Label(master,text="Media Address Type:", fg="blue").grid(row=row, column=14)
        self.Media_Address_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Media_Address_TypeEntry.grid(row=row, column=22)
        self.Media_Address_TypeEntry.insert(0, "NPF_MAC_ADDRESS")
        self.enums.append((self.Media_Address_TypeEntry, self.Media_Address_TypeEntry, self.Media_Address_TypeEnums))
        row = row + 1
        Label(master,text="Media Address:", fg="blue").grid(row=row, column=14)
        self.Media_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Media_AddressEntry.grid(row=row, column=22)
        self.Media_AddressEntry.insert(0, "0x12893473a1e3")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "169"
            reqresp = ReqResp('IPV4Add_AddRes_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'AddResTableHandle'
            addrestablehandle = self.AddResTableHandleEntry.get()
            vl = addrestablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IP_Address'
            ip_address = self.IP_AddressEntry.get()
            vl = ip_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Interface_Handle'
            interface_handle = self.Interface_HandleEntry.get()
            vl = interface_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Media_Address_Type'
            media_address_type = self.Media_Address_TypeEntry.get()
            if(self.Media_Address_TypeEnums.has_key(media_address_type)):
                media_address_type = self.Media_Address_TypeEnums[media_address_type]
            vl = media_address_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Media_Address'
            media_address = self.Media_AddressEntry.get()
            vl = media_address
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Add_AddRes_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Add_AddRes_Table_Entry', '169'))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "AddResTableHandle"
                val = self.AddResTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "IP_Address"
                val = self.IP_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "Interface_Handle"
                val = self.Interface_HandleEntry.get()
                order.append((nm, str(val)))
                nm = "Media_Address_Type"
                val = self.Media_Address_TypeEntry.get()
                if(self.Media_Address_TypeEnums.has_key(val)):
                    val  = self.Media_Address_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "Media_Address"
                val = self.Media_AddressEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Add_AddRes_Table_Entry", "Error Occured while processing IPV4Add_AddRes_Table_Entry Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class IPV4Delete_Prefix_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Delete_Prefix_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "PREFIX:0")
        row = row + 1
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        row = row + 1
        Label(master,text="IPv4Addr:", fg="blue").grid(row=row, column=14)
        self.IPv4AddrEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4AddrEntry.grid(row=row, column=22)
        self.IPv4AddrEntry.insert(0, "10.1.0.9")
        row = row + 1
        Label(master,text="IPv4NetPlen:", fg="blue").grid(row=row, column=14)
        self.IPv4NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4NetPlenEntry.grid(row=row, column=22)
        self.IPv4NetPlenEntry.insert(0, "32")
        row = row + 1
        Label(master,text="NextHopIndex:", fg="blue").grid(row=row, column=14)
        self.NextHopIndexEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopIndexEntry.grid(row=row, column=22)
        self.NextHopIndexEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "170"
            reqresp = ReqResp('IPV4Delete_Prefix_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NoOfEntries'
            noofentries = self.NoOfEntriesEntry.get()
            vl = noofentries
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4Addr'
            ipv4addr = self.IPv4AddrEntry.get()
            vl = ipv4addr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4NetPlen'
            ipv4netplen = self.IPv4NetPlenEntry.get()
            vl = ipv4netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopIndex'
            nexthopindex = self.NextHopIndexEntry.get()
            vl = nexthopindex
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Delete_Prefix_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Delete_Prefix_Table_Entry', '170'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NoOfEntries"
                val = self.NoOfEntriesEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4Addr"
                val = self.IPv4AddrEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4NetPlen"
                val = self.IPv4NetPlenEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopIndex"
                val = self.NextHopIndexEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Delete_Prefix_Table_Entry", "Error Occured while processing IPV4Delete_Prefix_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Delete_NextHop_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Delete_NextHop_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        row = row + 1
        Label(master,text="NextHopTableHandle:", fg="blue").grid(row=row, column=14)
        self.NextHopTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTableHandleEntry.grid(row=row, column=22)
        self.NextHopTableHandleEntry.insert(0, "NEXTHOP:0")
        row = row + 1
        Label(master,text="NextHopId:", fg="blue").grid(row=row, column=14)
        self.NextHopIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopIdEntry.grid(row=row, column=22)
        self.NextHopIdEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "171"
            reqresp = ReqResp('IPV4Delete_NextHop_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfEntries'
            noofentries = self.NoOfEntriesEntry.get()
            vl = noofentries
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopTableHandle'
            nexthoptablehandle = self.NextHopTableHandleEntry.get()
            vl = nexthoptablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopId'
            nexthopid = self.NextHopIdEntry.get()
            vl = nexthopid
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Delete_NextHop_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Delete_NextHop_Table_Entry', '171'))
                nm = "NoOfEntries"
                val = self.NoOfEntriesEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopTableHandle"
                val = self.NextHopTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopId"
                val = self.NextHopIdEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Delete_NextHop_Table_Entry", "Error Occured while processing IPV4Delete_NextHop_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Delete_AddRes_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Delete_AddRes_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="AddResTableHandle:", fg="blue").grid(row=row, column=14)
        self.AddResTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddResTableHandleEntry.grid(row=row, column=22)
        self.AddResTableHandleEntry.insert(0, "ADDRESS:0")
        row = row + 1
        Label(master,text="IP Address:", fg="blue").grid(row=row, column=14)
        self.IP_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IP_AddressEntry.grid(row=row, column=22)
        self.IP_AddressEntry.insert(0, "10.1.0.7")
        row = row + 1
        Label(master,text="Interface Handle:", fg="blue").grid(row=row, column=14)
        self.Interface_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Interface_HandleEntry.grid(row=row, column=22)
        self.Interface_HandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "172"
            reqresp = ReqResp('IPV4Delete_AddRes_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'AddResTableHandle'
            addrestablehandle = self.AddResTableHandleEntry.get()
            vl = addrestablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IP_Address'
            ip_address = self.IP_AddressEntry.get()
            vl = ip_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Interface_Handle'
            interface_handle = self.Interface_HandleEntry.get()
            vl = interface_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Delete_AddRes_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Delete_AddRes_Entry', '172'))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "AddResTableHandle"
                val = self.AddResTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "IP_Address"
                val = self.IP_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "Interface_Handle"
                val = self.Interface_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Delete_AddRes_Entry", "Error Occured while processing IPV4Delete_AddRes_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Flush_Prefix_TableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Flush_Prefix_Table")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "PREFIX:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "173"
            reqresp = ReqResp('IPV4Flush_Prefix_Table', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Flush_Prefix_Table ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Flush_Prefix_Table', '173'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Flush_Prefix_Table", "Error Occured while processing IPV4Flush_Prefix_Table Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Flush_NextHop_TableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Flush_NextHop_Table")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NextHopTableHandle:", fg="blue").grid(row=row, column=14)
        self.NextHopTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTableHandleEntry.grid(row=row, column=22)
        self.NextHopTableHandleEntry.insert(0, "NEXTHOP:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "174"
            reqresp = ReqResp('IPV4Flush_NextHop_Table', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NextHopTableHandle'
            nexthoptablehandle = self.NextHopTableHandleEntry.get()
            vl = nexthoptablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Flush_NextHop_Table ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Flush_NextHop_Table', '174'))
                nm = "NextHopTableHandle"
                val = self.NextHopTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Flush_NextHop_Table", "Error Occured while processing IPV4Flush_NextHop_Table Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Flush_AddRes_TableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Flush_AddRes_Table")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="AddResTableHandle:", fg="blue").grid(row=row, column=14)
        self.AddResTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddResTableHandleEntry.grid(row=row, column=22)
        self.AddResTableHandleEntry.insert(0, "ADDRESS:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "175"
            reqresp = ReqResp('IPV4Flush_AddRes_Table', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'AddResTableHandle'
            addrestablehandle = self.AddResTableHandleEntry.get()
            vl = addrestablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Flush_AddRes_Table ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Flush_AddRes_Table', '175'))
                nm = "AddResTableHandle"
                val = self.AddResTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Flush_AddRes_Table", "Error Occured while processing IPV4Flush_AddRes_Table Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Query_Prefix_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Query_Prefix_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="PrefixTableHandle:", fg="blue").grid(row=row, column=14)
        self.PrefixTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrefixTableHandleEntry.grid(row=row, column=22)
        self.PrefixTableHandleEntry.insert(0, "PREFIX:0")
        row = row + 1
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IPv4Addr:", fg="blue").grid(row=row, column=14)
        self.IPv4AddrEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4AddrEntry.grid(row=row, column=22)
        self.IPv4AddrEntry.insert(0, "10.1.0.9")
        row = row + 1
        Label(master,text="IPv4NetPlen:", fg="blue").grid(row=row, column=14)
        self.IPv4NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4NetPlenEntry.grid(row=row, column=22)
        self.IPv4NetPlenEntry.insert(0, "32")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "176"
            reqresp = ReqResp('IPV4Query_Prefix_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'PrefixTableHandle'
            prefixtablehandle = self.PrefixTableHandleEntry.get()
            vl = prefixtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4Addr'
            ipv4addr = self.IPv4AddrEntry.get()
            vl = ipv4addr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4NetPlen'
            ipv4netplen = self.IPv4NetPlenEntry.get()
            vl = ipv4netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Query_Prefix_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Query_Prefix_Table_Entry', '176'))
                nm = "PrefixTableHandle"
                val = self.PrefixTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IPv4Addr"
                val = self.IPv4AddrEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4NetPlen"
                val = self.IPv4NetPlenEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Query_Prefix_Table_Entry", "Error Occured while processing IPV4Query_Prefix_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Query_NextHop_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Query_NextHop_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="NextHopTableHandle:", fg="blue").grid(row=row, column=14)
        self.NextHopTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTableHandleEntry.grid(row=row, column=22)
        self.NextHopTableHandleEntry.insert(0, "NEXTHOP:0")
        row = row + 1
        Label(master,text="NextHopId:", fg="blue").grid(row=row, column=14)
        self.NextHopIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopIdEntry.grid(row=row, column=22)
        self.NextHopIdEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "177"
            reqresp = ReqResp('IPV4Query_NextHop_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopTableHandle'
            nexthoptablehandle = self.NextHopTableHandleEntry.get()
            vl = nexthoptablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopId'
            nexthopid = self.NextHopIdEntry.get()
            vl = nexthopid
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Query_NextHop_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Query_NextHop_Table_Entry', '177'))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NextHopTableHandle"
                val = self.NextHopTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopId"
                val = self.NextHopIdEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Query_NextHop_Table_Entry", "Error Occured while processing IPV4Query_NextHop_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Query_AddRes_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Query_AddRes_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="AddResTableHandle:", fg="blue").grid(row=row, column=14)
        self.AddResTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AddResTableHandleEntry.grid(row=row, column=22)
        self.AddResTableHandleEntry.insert(0, "ADDRESS:0")
        row = row + 1
        Label(master,text="IP Address:", fg="blue").grid(row=row, column=14)
        self.IP_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IP_AddressEntry.grid(row=row, column=22)
        self.IP_AddressEntry.insert(0, "10.1.0.7")
        row = row + 1
        Label(master,text="Interface Handle:", fg="blue").grid(row=row, column=14)
        self.Interface_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Interface_HandleEntry.grid(row=row, column=22)
        self.Interface_HandleEntry.insert(0, "LAN:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "178"
            reqresp = ReqResp('IPV4Query_AddRes_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'AddResTableHandle'
            addrestablehandle = self.AddResTableHandleEntry.get()
            vl = addrestablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IP_Address'
            ip_address = self.IP_AddressEntry.get()
            vl = ip_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Interface_Handle'
            interface_handle = self.Interface_HandleEntry.get()
            vl = interface_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Query_AddRes_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Query_AddRes_Table_Entry', '178'))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "AddResTableHandle"
                val = self.AddResTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "IP_Address"
                val = self.IP_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "Interface_Handle"
                val = self.Interface_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Query_AddRes_Table_Entry", "Error Occured while processing IPV4Query_AddRes_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4Reset_IPV4_Handles_For_Test_RepeatDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4Reset_IPV4_Handles_For_Test_Repeat")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "198"
            reqresp = ReqResp('IPV4Reset_IPV4_Handles_For_Test_Repeat', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4Reset_IPV4_Handles_For_Test_Repeat ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_Reset_IPV4_Handles_For_Test_Repeat', '198'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4Reset_IPV4_Handles_For_Test_Repeat", "Error Occured while processing IPV4Reset_IPV4_Handles_For_Test_Repeat Dialog")
            pass
    
    def operation(self, event=None):
        pass


class IPV4_UNIFIEDCreate_Fib_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4_UNIFIEDCreate_Fib_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "180"
            reqresp = ReqResp('IPV4_UNIFIEDCreate_Fib_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4_UNIFIEDCreate_Fib_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_UNIFIED_Create_Fib_Table_Handle', '180'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4_UNIFIEDCreate_Fib_Table_Handle", "Error Occured while processing IPV4_UNIFIEDCreate_Fib_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4_UNIFIEDDelete_Fib_Table_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4_UNIFIEDDelete_Fib_Table_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="FibTableHandle:", fg="blue").grid(row=row, column=14)
        self.FibTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FibTableHandleEntry.grid(row=row, column=22)
        self.FibTableHandleEntry.insert(0, "FIB:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "181"
            reqresp = ReqResp('IPV4_UNIFIEDDelete_Fib_Table_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'FibTableHandle'
            fibtablehandle = self.FibTableHandleEntry.get()
            vl = fibtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4_UNIFIEDDelete_Fib_Table_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_UNIFIED_Delete_Fib_Table_Handle', '181'))
                nm = "FibTableHandle"
                val = self.FibTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4_UNIFIEDDelete_Fib_Table_Handle", "Error Occured while processing IPV4_UNIFIEDDelete_Fib_Table_Handle Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4_UNIFIEDAdd_Fib_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="IPV4_UNIFIEDAdd_Fib_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="FibTableHandle:", fg="blue").grid(row=row, column=14)
        self.FibTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FibTableHandleEntry.grid(row=row, column=22)
        self.FibTableHandleEntry.insert(0, "FIB:0")
        row = row + 1
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IPv4Addr:", fg="blue").grid(row=row, column=14)
        self.IPv4AddrEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4AddrEntry.grid(row=row, column=22)
        self.IPv4AddrEntry.insert(0, "10.1.0.9")
        row = row + 1
        Label(master,text="IPv4NetPlen:", fg="blue").grid(row=row, column=14)
        self.IPv4NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4NetPlenEntry.grid(row=row, column=22)
        self.IPv4NetPlenEntry.insert(0, "32")
        row = row + 1
        Label(master,text="NextHop IP Address:", fg="blue").grid(row=row, column=14)
        self.NextHop_IP_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHop_IP_AddressEntry.grid(row=row, column=22)
        self.NextHop_IP_AddressEntry.insert(0, "10.1.0.7")
        row = row + 1
        self.NextHopTypeEnums = {u'NPF_IPV4_REMOTE_ENTRY': u'5', u'NPF_IPV4_BASIC_ENTRY': u'1', u'NPF_IPV4_DIRECT_ATTACH_ENTRY': u'2'}
        Label(master,text="NextHopType:", fg="blue").grid(row=row, column=14)
        self.NextHopTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopTypeEntry.grid(row=row, column=22)
        self.NextHopTypeEntry.insert(0, "NPF_IPV4_BASIC_ENTRY")
        self.enums.append((self.NextHopTypeEntry, self.NextHopTypeEntry, self.NextHopTypeEnums))
        row = row + 1
        Label(master,text="NextHopWeight:", fg="blue").grid(row=row, column=14)
        self.NextHopWeightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NextHopWeightEntry.grid(row=row, column=22)
        self.NextHopWeightEntry.insert(0, "3")
        row = row + 1
        Label(master,text="EgressIfaceHandle:", fg="blue").grid(row=row, column=14)
        self.EgressIfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.EgressIfaceHandleEntry.grid(row=row, column=22)
        self.EgressIfaceHandleEntry.insert(0, "LAN:0")
        row = row + 1
        self.Media_Address_TypeEnums = {u'NPF_ATM_VC': u'3', u'NPF_MAC_ADDRESS': u'2', u'NPF_NO_MEDIA_TYPE': u'1'}
        Label(master,text="Media Address Type:", fg="blue").grid(row=row, column=14)
        self.Media_Address_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Media_Address_TypeEntry.grid(row=row, column=22)
        self.Media_Address_TypeEntry.insert(0, "NPF_MAC_ADDRESS")
        self.enums.append((self.Media_Address_TypeEntry, self.Media_Address_TypeEntry, self.Media_Address_TypeEnums))
        row = row + 1
        Label(master,text="Media Address:", fg="blue").grid(row=row, column=14)
        self.Media_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Media_AddressEntry.grid(row=row, column=22)
        self.Media_AddressEntry.insert(0, "0x12893473a1e3")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "182"
            reqresp = ReqResp('IPV4_UNIFIEDAdd_Fib_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'FibTableHandle'
            fibtablehandle = self.FibTableHandleEntry.get()
            vl = fibtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4Addr'
            ipv4addr = self.IPv4AddrEntry.get()
            vl = ipv4addr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4NetPlen'
            ipv4netplen = self.IPv4NetPlenEntry.get()
            vl = ipv4netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHop_IP_Address'
            nexthop_ip_address = self.NextHop_IP_AddressEntry.get()
            vl = nexthop_ip_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopType'
            nexthoptype = self.NextHopTypeEntry.get()
            if(self.NextHopTypeEnums.has_key(nexthoptype)):
                nexthoptype = self.NextHopTypeEnums[nexthoptype]
            vl = nexthoptype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NextHopWeight'
            nexthopweight = self.NextHopWeightEntry.get()
            vl = nexthopweight
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'EgressIfaceHandle'
            egressifacehandle = self.EgressIfaceHandleEntry.get()
            vl = egressifacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Media_Address_Type'
            media_address_type = self.Media_Address_TypeEntry.get()
            if(self.Media_Address_TypeEnums.has_key(media_address_type)):
                media_address_type = self.Media_Address_TypeEnums[media_address_type]
            vl = media_address_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Media_Address'
            media_address = self.Media_AddressEntry.get()
            vl = media_address
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4_UNIFIEDAdd_Fib_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_UNIFIED_Add_Fib_Table_Entry', '182'))
                nm = "FibTableHandle"
                val = self.FibTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IPv4Addr"
                val = self.IPv4AddrEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4NetPlen"
                val = self.IPv4NetPlenEntry.get()
                order.append((nm, str(val)))
                nm = "NextHop_IP_Address"
                val = self.NextHop_IP_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "NextHopType"
                val = self.NextHopTypeEntry.get()
                if(self.NextHopTypeEnums.has_key(val)):
                    val  = self.NextHopTypeEnums[val]
                order.append((nm, str(val)))
                nm = "NextHopWeight"
                val = self.NextHopWeightEntry.get()
                order.append((nm, str(val)))
                nm = "EgressIfaceHandle"
                val = self.EgressIfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "Media_Address_Type"
                val = self.Media_Address_TypeEntry.get()
                if(self.Media_Address_TypeEnums.has_key(val)):
                    val  = self.Media_Address_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "Media_Address"
                val = self.Media_AddressEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4_UNIFIEDAdd_Fib_Table_Entry", "Error Occured while processing IPV4_UNIFIEDAdd_Fib_Table_Entry Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class IPV4_UNIFIEDDelete_Fib_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4_UNIFIEDDelete_Fib_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="FibTableHandle:", fg="blue").grid(row=row, column=14)
        self.FibTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FibTableHandleEntry.grid(row=row, column=22)
        self.FibTableHandleEntry.insert(0, "FIB:0")
        row = row + 1
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IPv4Addr:", fg="blue").grid(row=row, column=14)
        self.IPv4AddrEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4AddrEntry.grid(row=row, column=22)
        self.IPv4AddrEntry.insert(0, "10.1.0.9")
        row = row + 1
        Label(master,text="IPv4NetPlen:", fg="blue").grid(row=row, column=14)
        self.IPv4NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4NetPlenEntry.grid(row=row, column=22)
        self.IPv4NetPlenEntry.insert(0, "32")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "183"
            reqresp = ReqResp('IPV4_UNIFIEDDelete_Fib_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'FibTableHandle'
            fibtablehandle = self.FibTableHandleEntry.get()
            vl = fibtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4Addr'
            ipv4addr = self.IPv4AddrEntry.get()
            vl = ipv4addr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4NetPlen'
            ipv4netplen = self.IPv4NetPlenEntry.get()
            vl = ipv4netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4_UNIFIEDDelete_Fib_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_UNIFIED_Delete_Fib_Table_Entry', '183'))
                nm = "FibTableHandle"
                val = self.FibTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IPv4Addr"
                val = self.IPv4AddrEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4NetPlen"
                val = self.IPv4NetPlenEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4_UNIFIEDDelete_Fib_Table_Entry", "Error Occured while processing IPV4_UNIFIEDDelete_Fib_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4_UNIFIEDFlush_Fib_TableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4_UNIFIEDFlush_Fib_Table")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="FibTableHandle:", fg="blue").grid(row=row, column=14)
        self.FibTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FibTableHandleEntry.grid(row=row, column=22)
        self.FibTableHandleEntry.insert(0, "FIB:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "184"
            reqresp = ReqResp('IPV4_UNIFIEDFlush_Fib_Table', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'FibTableHandle'
            fibtablehandle = self.FibTableHandleEntry.get()
            vl = fibtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4_UNIFIEDFlush_Fib_Table ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_UNIFIED_Flush_Fib_Table', '184'))
                nm = "FibTableHandle"
                val = self.FibTableHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4_UNIFIEDFlush_Fib_Table", "Error Occured while processing IPV4_UNIFIEDFlush_Fib_Table Dialog")
            pass
    
    def operation(self, event=None):
        pass

class IPV4_UNIFIEDQuery_Fib_Table_EntryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="IPV4_UNIFIEDQuery_Fib_Table_Entry")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="FibTableHandle:", fg="blue").grid(row=row, column=14)
        self.FibTableHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FibTableHandleEntry.grid(row=row, column=22)
        self.FibTableHandleEntry.insert(0, "FIB:0")
        row = row + 1
        Label(master,text="NoOfEntries:", fg="blue").grid(row=row, column=14)
        self.NoOfEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfEntriesEntry.grid(row=row, column=22)
        self.NoOfEntriesEntry.insert(0, "1")
        self.NoOfEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IPv4Addr:", fg="blue").grid(row=row, column=14)
        self.IPv4AddrEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4AddrEntry.grid(row=row, column=22)
        self.IPv4AddrEntry.insert(0, "10.1.0.9")
        row = row + 1
        Label(master,text="IPv4NetPlen:", fg="blue").grid(row=row, column=14)
        self.IPv4NetPlenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4NetPlenEntry.grid(row=row, column=22)
        self.IPv4NetPlenEntry.insert(0, "32")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "185"
            reqresp = ReqResp('IPV4_UNIFIEDQuery_Fib_Table_Entry', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'FibTableHandle'
            fibtablehandle = self.FibTableHandleEntry.get()
            vl = fibtablehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NoOfEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4Addr'
            ipv4addr = self.IPv4AddrEntry.get()
            vl = ipv4addr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4NetPlen'
            ipv4netplen = self.IPv4NetPlenEntry.get()
            vl = ipv4netplen
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("IPV4_UNIFIEDQuery_Fib_Table_Entry ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('IPV4_UNIFIED_Query_Fib_Table_Entry', '185'))
                nm = "FibTableHandle"
                val = self.FibTableHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NoOfEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IPv4Addr"
                val = self.IPv4AddrEntry.get()
                order.append((nm, str(val)))
                nm = "IPv4NetPlen"
                val = self.IPv4NetPlenEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("IPV4_UNIFIEDQuery_Fib_Table_Entry", "Error Occured while processing IPV4_UNIFIEDQuery_Fib_Table_Entry Dialog")
            pass
    
    def operation(self, event=None):
        pass


class DiffServCreate_ClassifierDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServCreate_Classifier")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "POS:0")
        row = row + 1
        self.DirectionEnums = {u'NPF_DS_INGRESS': u'1', u'NPF_DS_EGRESS': u'2'}
        Label(master,text="Direction:", fg="blue").grid(row=row, column=14)
        self.DirectionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DirectionEntry.grid(row=row, column=22)
        self.DirectionEntry.insert(0, "NPF_DS_INGRESS")
        self.enums.append((self.DirectionEntry, self.DirectionEntry, self.DirectionEnums))
        row = row + 1
        self.DpeTypeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="DpeType:", fg="blue").grid(row=row, column=14)
        self.DpeTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeTypeEntry.grid(row=row, column=22)
        self.DpeTypeEntry.insert(0, "NPF_DS_CLASSIFIER")
        self.DpeTypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.DpeTypeEntry, self.DpeTypeEntry, self.DpeTypeEnums))
        row = row + 1
        self.ClassifierTypeEnums = {u'NPF_DS_DSCP_FILTER': u'4', u'NPF_DS_MPLS_FILTER': u'3', u'NPF_DS_IPV4_FILTER': u'1', u'NPF_DS_IPV6_FILTER': u'2'}
        Label(master,text="ClassifierType:", fg="blue").grid(row=row, column=14)
        self.ClassifierTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ClassifierTypeEntry.grid(row=row, column=22)
        self.ClassifierTypeEntry.insert(0, "NPF_DS_IPV4_FILTER")
        self.enums.append((self.ClassifierTypeEntry, self.ClassifierTypeEntry, self.ClassifierTypeEnums))
        row = row + 1
        Label(master,text="Precedence:", fg="blue").grid(row=row, column=14)
        self.PrecedenceEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrecedenceEntry.grid(row=row, column=22)
        self.PrecedenceEntry.insert(0, "0")
        row = row + 1
        Label(master,text="DestAddress:", fg="blue").grid(row=row, column=14)
        self.DestAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DestAddressEntry.grid(row=row, column=22)
        self.DestAddressEntry.insert(0, "20.0.0.2")
        row = row + 1
        Label(master,text="DestNetpLen:", fg="blue").grid(row=row, column=14)
        self.DestNetpLenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DestNetpLenEntry.grid(row=row, column=22)
        self.DestNetpLenEntry.insert(0, "32")
        row = row + 1
        Label(master,text="SrcAddress:", fg="blue").grid(row=row, column=14)
        self.SrcAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SrcAddressEntry.grid(row=row, column=22)
        self.SrcAddressEntry.insert(0, "10.0.0.2")
        row = row + 1
        Label(master,text="SrcNetpLen:", fg="blue").grid(row=row, column=14)
        self.SrcNetpLenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SrcNetpLenEntry.grid(row=row, column=22)
        self.SrcNetpLenEntry.insert(0, "32")
        row = row + 1
        self.DscpEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="Dscp:", fg="blue").grid(row=row, column=14)
        self.DscpEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DscpEntry.grid(row=row, column=22)
        self.DscpEntry.insert(0, "DEFAULT_PHB")
        self.enums.append((self.DscpEntry, self.DscpEntry, self.DscpEnums))
        row = row + 1
        self.ProtocolEnums = {u'ICPM': u'1', u'UDP': u'17', u'OSPF': u'89', u'IGPM': u'2', u'TCP': u'6'}
        Label(master,text="Protocol:", fg="blue").grid(row=row, column=14)
        self.ProtocolEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ProtocolEntry.grid(row=row, column=22)
        self.ProtocolEntry.insert(0, "TCP")
        self.enums.append((self.ProtocolEntry, self.ProtocolEntry, self.ProtocolEnums))
        row = row + 1
        Label(master,text="DestL4Port:", fg="blue").grid(row=row, column=14)
        self.DestL4PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DestL4PortEntry.grid(row=row, column=22)
        self.DestL4PortEntry.insert(0, "20")
        row = row + 1
        Label(master,text="SrcL4Port:", fg="blue").grid(row=row, column=14)
        self.SrcL4PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SrcL4PortEntry.grid(row=row, column=22)
        self.SrcL4PortEntry.insert(0, "20")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "100"
            reqresp = ReqResp('DiffServCreate_Classifier', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Direction'
            direction = self.DirectionEntry.get()
            if(self.DirectionEnums.has_key(direction)):
                direction = self.DirectionEnums[direction]
            vl = direction
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeType'
            if(self.DpeTypeEnums.has_key('NPF_DS_CLASSIFIER')):
                internalEnum   = self.DpeTypeEnums['NPF_DS_CLASSIFIER']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ClassifierType'
            classifiertype = self.ClassifierTypeEntry.get()
            if(self.ClassifierTypeEnums.has_key(classifiertype)):
                classifiertype = self.ClassifierTypeEnums[classifiertype]
            vl = classifiertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Precedence'
            precedence = self.PrecedenceEntry.get()
            vl = precedence
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DestAddress'
            destaddress = self.DestAddressEntry.get()
            vl = destaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DestNetpLen'
            destnetplen = self.DestNetpLenEntry.get()
            vl = destnetplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'SrcAddress'
            srcaddress = self.SrcAddressEntry.get()
            vl = srcaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'SrcNetpLen'
            srcnetplen = self.SrcNetpLenEntry.get()
            vl = srcnetplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Dscp'
            dscp = self.DscpEntry.get()
            if(self.DscpEnums.has_key(dscp)):
                dscp = self.DscpEnums[dscp]
            vl = dscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Protocol'
            protocol = self.ProtocolEntry.get()
            if(self.ProtocolEnums.has_key(protocol)):
                protocol = self.ProtocolEnums[protocol]
            vl = protocol
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DestL4Port'
            destl4port = self.DestL4PortEntry.get()
            vl = destl4port
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'SrcL4Port'
            srcl4port = self.SrcL4PortEntry.get()
            vl = srcl4port
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServCreate_Classifier ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Create_Classifier', '100'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "Direction"
                val = self.DirectionEntry.get()
                if(self.DirectionEnums.has_key(val)):
                    val  = self.DirectionEnums[val]
                order.append((nm, str(val)))
                nm = "DpeType"
                if(self.DpeTypeEnums.has_key('NPF_DS_CLASSIFIER')):
                    val  = self.DpeTypeEnums['NPF_DS_CLASSIFIER']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "ClassifierType"
                val = self.ClassifierTypeEntry.get()
                if(self.ClassifierTypeEnums.has_key(val)):
                    val  = self.ClassifierTypeEnums[val]
                order.append((nm, str(val)))
                nm = "Precedence"
                val = self.PrecedenceEntry.get()
                order.append((nm, str(val)))
                nm = "DestAddress"
                val = self.DestAddressEntry.get()
                order.append((nm, str(val)))
                nm = "DestNetpLen"
                val = self.DestNetpLenEntry.get()
                order.append((nm, str(val)))
                nm = "SrcAddress"
                val = self.SrcAddressEntry.get()
                order.append((nm, str(val)))
                nm = "SrcNetpLen"
                val = self.SrcNetpLenEntry.get()
                order.append((nm, str(val)))
                nm = "Dscp"
                val = self.DscpEntry.get()
                if(self.DscpEnums.has_key(val)):
                    val  = self.DscpEnums[val]
                order.append((nm, str(val)))
                nm = "Protocol"
                val = self.ProtocolEntry.get()
                if(self.ProtocolEnums.has_key(val)):
                    val  = self.ProtocolEnums[val]
                order.append((nm, str(val)))
                nm = "DestL4Port"
                val = self.DestL4PortEntry.get()
                order.append((nm, str(val)))
                nm = "SrcL4Port"
                val = self.SrcL4PortEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServCreate_Classifier", "Error Occured while processing DiffServCreate_Classifier Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServCreate_MeterDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServCreate_Meter")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "POS:0")
        row = row + 1
        self.DirectionEnums = {u'NPF_DS_INGRESS': u'1', u'NPF_DS_EGRESS': u'2'}
        Label(master,text="Direction:", fg="blue").grid(row=row, column=14)
        self.DirectionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DirectionEntry.grid(row=row, column=22)
        self.DirectionEntry.insert(0, "NPF_DS_INGRESS")
        self.enums.append((self.DirectionEntry, self.DirectionEntry, self.DirectionEnums))
        row = row + 1
        self.DpeTypeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="DpeType:", fg="blue").grid(row=row, column=14)
        self.DpeTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeTypeEntry.grid(row=row, column=22)
        self.DpeTypeEntry.insert(0, "NPF_DS_METER")
        self.DpeTypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.DpeTypeEntry, self.DpeTypeEntry, self.DpeTypeEnums))
        row = row + 1
        self.MeterTypeEnums = {u'NPF_DS_SRTCM_AWARE': u'4', u'NPF_DS_SIMPLE_TB': u'1', u'NPF_DS_TRTCM_BLIND': u'5', u'NPF_DS_TRTCM_AWARE': u'6', u'NPF_DS_TSW_TCM': u'7', u'NPF_DS_AVG_RATE': u'2', u'NPF_DS_SRTCM_BLIND': u'3'}
        Label(master,text="MeterType:", fg="blue").grid(row=row, column=14)
        self.MeterTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MeterTypeEntry.grid(row=row, column=22)
        self.MeterTypeEntry.insert(0, "NPF_DS_SRTCM_AWARE")
        self.enums.append((self.MeterTypeEntry, self.MeterTypeEntry, self.MeterTypeEnums))
        row = row + 1
        Label(master,text="CIR:", fg="blue").grid(row=row, column=14)
        self.CIREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.CIREntry.grid(row=row, column=22)
        self.CIREntry.insert(0, "100")
        row = row + 1
        Label(master,text="PIR:", fg="blue").grid(row=row, column=14)
        self.PIREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PIREntry.grid(row=row, column=22)
        self.PIREntry.insert(0, "100")
        row = row + 1
        Label(master,text="CBS:", fg="blue").grid(row=row, column=14)
        self.CBSEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.CBSEntry.grid(row=row, column=22)
        self.CBSEntry.insert(0, "10000")
        row = row + 1
        Label(master,text="PBS:", fg="blue").grid(row=row, column=14)
        self.PBSEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PBSEntry.grid(row=row, column=22)
        self.PBSEntry.insert(0, "10000")
        row = row + 1
        Label(master,text="EBS:", fg="blue").grid(row=row, column=14)
        self.EBSEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.EBSEntry.grid(row=row, column=22)
        self.EBSEntry.insert(0, "10000")
        row = row + 1
        self.GreenDpeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="GreenDpe:", fg="blue").grid(row=row, column=14)
        self.GreenDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenDpeEntry.grid(row=row, column=22)
        self.GreenDpeEntry.insert(0, "NPF_DS_MARKER")
        self.enums.append((self.GreenDpeEntry, self.GreenDpeEntry, self.GreenDpeEnums))
        row = row + 1
        self.YellowDpeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="YellowDpe:", fg="blue").grid(row=row, column=14)
        self.YellowDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowDpeEntry.grid(row=row, column=22)
        self.YellowDpeEntry.insert(0, "NPF_DS_MARKER")
        self.enums.append((self.YellowDpeEntry, self.YellowDpeEntry, self.YellowDpeEnums))
        row = row + 1
        self.RedDpeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="RedDpe:", fg="blue").grid(row=row, column=14)
        self.RedDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedDpeEntry.grid(row=row, column=22)
        self.RedDpeEntry.insert(0, "NPF_DS_DROPPER")
        self.enums.append((self.RedDpeEntry, self.RedDpeEntry, self.RedDpeEnums))
        row = row + 1
        self.StatisticsEnums = {u'YES': u'1', u'NO': u'0'}
        Label(master,text="Statistics:", fg="blue").grid(row=row, column=14)
        self.StatisticsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.StatisticsEntry.grid(row=row, column=22)
        self.StatisticsEntry.insert(0, "YES")
        self.enums.append((self.StatisticsEntry, self.StatisticsEntry, self.StatisticsEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "101"
            reqresp = ReqResp('DiffServCreate_Meter', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Direction'
            direction = self.DirectionEntry.get()
            if(self.DirectionEnums.has_key(direction)):
                direction = self.DirectionEnums[direction]
            vl = direction
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeType'
            if(self.DpeTypeEnums.has_key('NPF_DS_METER')):
                internalEnum   = self.DpeTypeEnums['NPF_DS_METER']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MeterType'
            metertype = self.MeterTypeEntry.get()
            if(self.MeterTypeEnums.has_key(metertype)):
                metertype = self.MeterTypeEnums[metertype]
            vl = metertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'CIR'
            cir = self.CIREntry.get()
            vl = cir
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PIR'
            pir = self.PIREntry.get()
            vl = pir
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'CBS'
            cbs = self.CBSEntry.get()
            vl = cbs
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PBS'
            pbs = self.PBSEntry.get()
            vl = pbs
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'EBS'
            ebs = self.EBSEntry.get()
            vl = ebs
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenDpe'
            greendpe = self.GreenDpeEntry.get()
            if(self.GreenDpeEnums.has_key(greendpe)):
                greendpe = self.GreenDpeEnums[greendpe]
            vl = greendpe
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowDpe'
            yellowdpe = self.YellowDpeEntry.get()
            if(self.YellowDpeEnums.has_key(yellowdpe)):
                yellowdpe = self.YellowDpeEnums[yellowdpe]
            vl = yellowdpe
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedDpe'
            reddpe = self.RedDpeEntry.get()
            if(self.RedDpeEnums.has_key(reddpe)):
                reddpe = self.RedDpeEnums[reddpe]
            vl = reddpe
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Statistics'
            statistics = self.StatisticsEntry.get()
            if(self.StatisticsEnums.has_key(statistics)):
                statistics = self.StatisticsEnums[statistics]
            vl = statistics
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServCreate_Meter ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Create_Meter', '101'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "Direction"
                val = self.DirectionEntry.get()
                if(self.DirectionEnums.has_key(val)):
                    val  = self.DirectionEnums[val]
                order.append((nm, str(val)))
                nm = "DpeType"
                if(self.DpeTypeEnums.has_key('NPF_DS_METER')):
                    val  = self.DpeTypeEnums['NPF_DS_METER']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "MeterType"
                val = self.MeterTypeEntry.get()
                if(self.MeterTypeEnums.has_key(val)):
                    val  = self.MeterTypeEnums[val]
                order.append((nm, str(val)))
                nm = "CIR"
                val = self.CIREntry.get()
                order.append((nm, str(val)))
                nm = "PIR"
                val = self.PIREntry.get()
                order.append((nm, str(val)))
                nm = "CBS"
                val = self.CBSEntry.get()
                order.append((nm, str(val)))
                nm = "PBS"
                val = self.PBSEntry.get()
                order.append((nm, str(val)))
                nm = "EBS"
                val = self.EBSEntry.get()
                order.append((nm, str(val)))
                nm = "GreenDpe"
                val = self.GreenDpeEntry.get()
                if(self.GreenDpeEnums.has_key(val)):
                    val  = self.GreenDpeEnums[val]
                order.append((nm, str(val)))
                nm = "YellowDpe"
                val = self.YellowDpeEntry.get()
                if(self.YellowDpeEnums.has_key(val)):
                    val  = self.YellowDpeEnums[val]
                order.append((nm, str(val)))
                nm = "RedDpe"
                val = self.RedDpeEntry.get()
                if(self.RedDpeEnums.has_key(val)):
                    val  = self.RedDpeEnums[val]
                order.append((nm, str(val)))
                nm = "Statistics"
                val = self.StatisticsEntry.get()
                if(self.StatisticsEnums.has_key(val)):
                    val  = self.StatisticsEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServCreate_Meter", "Error Occured while processing DiffServCreate_Meter Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServCreate_MarkerDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServCreate_Marker")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "POS:0")
        row = row + 1
        self.DirectionEnums = {u'NPF_DS_INGRESS': u'1', u'NPF_DS_EGRESS': u'2'}
        Label(master,text="Direction:", fg="blue").grid(row=row, column=14)
        self.DirectionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DirectionEntry.grid(row=row, column=22)
        self.DirectionEntry.insert(0, "NPF_DS_INGRESS")
        self.enums.append((self.DirectionEntry, self.DirectionEntry, self.DirectionEnums))
        row = row + 1
        self.DpeTypeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="DpeType:", fg="blue").grid(row=row, column=14)
        self.DpeTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeTypeEntry.grid(row=row, column=22)
        self.DpeTypeEntry.insert(0, "NPF_DS_MARKER")
        self.DpeTypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.DpeTypeEntry, self.DpeTypeEntry, self.DpeTypeEnums))
        row = row + 1
        self.MarkerTypeEnums = {u'NPF_DS_MARKER_DSCP': u'1', u'NPF_DS_MARKER_MPLS': u'2'}
        Label(master,text="MarkerType:", fg="blue").grid(row=row, column=14)
        self.MarkerTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MarkerTypeEntry.grid(row=row, column=22)
        self.MarkerTypeEntry.insert(0, "NPF_DS_MARKER_DSCP")
        self.enums.append((self.MarkerTypeEntry, self.MarkerTypeEntry, self.MarkerTypeEnums))
        row = row + 1
        self.GreenDSCPEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="GreenDSCP:", fg="blue").grid(row=row, column=14)
        self.GreenDSCPEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenDSCPEntry.grid(row=row, column=22)
        self.GreenDSCPEntry.insert(0, "AF11_PHB")
        self.enums.append((self.GreenDSCPEntry, self.GreenDSCPEntry, self.GreenDSCPEnums))
        row = row + 1
        self.YellowDSCPEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="YellowDSCP:", fg="blue").grid(row=row, column=14)
        self.YellowDSCPEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowDSCPEntry.grid(row=row, column=22)
        self.YellowDSCPEntry.insert(0, "AF11_PHB")
        self.enums.append((self.YellowDSCPEntry, self.YellowDSCPEntry, self.YellowDSCPEnums))
        row = row + 1
        self.RedDSCPEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="RedDSCP:", fg="blue").grid(row=row, column=14)
        self.RedDSCPEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedDSCPEntry.grid(row=row, column=22)
        self.RedDSCPEntry.insert(0, "AF11_PHB")
        self.enums.append((self.RedDSCPEntry, self.RedDSCPEntry, self.RedDSCPEnums))
        row = row + 1
        self.StatisticsEnums = {u'YES': u'1', u'NO': u'0'}
        Label(master,text="Statistics:", fg="blue").grid(row=row, column=14)
        self.StatisticsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.StatisticsEntry.grid(row=row, column=22)
        self.StatisticsEntry.insert(0, "YES")
        self.enums.append((self.StatisticsEntry, self.StatisticsEntry, self.StatisticsEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "102"
            reqresp = ReqResp('DiffServCreate_Marker', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Direction'
            direction = self.DirectionEntry.get()
            if(self.DirectionEnums.has_key(direction)):
                direction = self.DirectionEnums[direction]
            vl = direction
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeType'
            if(self.DpeTypeEnums.has_key('NPF_DS_MARKER')):
                internalEnum   = self.DpeTypeEnums['NPF_DS_MARKER']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MarkerType'
            markertype = self.MarkerTypeEntry.get()
            if(self.MarkerTypeEnums.has_key(markertype)):
                markertype = self.MarkerTypeEnums[markertype]
            vl = markertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenDSCP'
            greendscp = self.GreenDSCPEntry.get()
            if(self.GreenDSCPEnums.has_key(greendscp)):
                greendscp = self.GreenDSCPEnums[greendscp]
            vl = greendscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowDSCP'
            yellowdscp = self.YellowDSCPEntry.get()
            if(self.YellowDSCPEnums.has_key(yellowdscp)):
                yellowdscp = self.YellowDSCPEnums[yellowdscp]
            vl = yellowdscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedDSCP'
            reddscp = self.RedDSCPEntry.get()
            if(self.RedDSCPEnums.has_key(reddscp)):
                reddscp = self.RedDSCPEnums[reddscp]
            vl = reddscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Statistics'
            statistics = self.StatisticsEntry.get()
            if(self.StatisticsEnums.has_key(statistics)):
                statistics = self.StatisticsEnums[statistics]
            vl = statistics
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServCreate_Marker ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Create_Marker', '102'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "Direction"
                val = self.DirectionEntry.get()
                if(self.DirectionEnums.has_key(val)):
                    val  = self.DirectionEnums[val]
                order.append((nm, str(val)))
                nm = "DpeType"
                if(self.DpeTypeEnums.has_key('NPF_DS_MARKER')):
                    val  = self.DpeTypeEnums['NPF_DS_MARKER']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "MarkerType"
                val = self.MarkerTypeEntry.get()
                if(self.MarkerTypeEnums.has_key(val)):
                    val  = self.MarkerTypeEnums[val]
                order.append((nm, str(val)))
                nm = "GreenDSCP"
                val = self.GreenDSCPEntry.get()
                if(self.GreenDSCPEnums.has_key(val)):
                    val  = self.GreenDSCPEnums[val]
                order.append((nm, str(val)))
                nm = "YellowDSCP"
                val = self.YellowDSCPEntry.get()
                if(self.YellowDSCPEnums.has_key(val)):
                    val  = self.YellowDSCPEnums[val]
                order.append((nm, str(val)))
                nm = "RedDSCP"
                val = self.RedDSCPEntry.get()
                if(self.RedDSCPEnums.has_key(val)):
                    val  = self.RedDSCPEnums[val]
                order.append((nm, str(val)))
                nm = "Statistics"
                val = self.StatisticsEntry.get()
                if(self.StatisticsEnums.has_key(val)):
                    val  = self.StatisticsEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServCreate_Marker", "Error Occured while processing DiffServCreate_Marker Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServCreate_DropperDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServCreate_Dropper")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "POS:0")
        row = row + 1
        self.DirectionEnums = {u'NPF_DS_INGRESS': u'1', u'NPF_DS_EGRESS': u'2'}
        Label(master,text="Direction:", fg="blue").grid(row=row, column=14)
        self.DirectionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DirectionEntry.grid(row=row, column=22)
        self.DirectionEntry.insert(0, "NPF_DS_EGRESS")
        self.enums.append((self.DirectionEntry, self.DirectionEntry, self.DirectionEnums))
        row = row + 1
        self.DpeTypeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="DpeType:", fg="blue").grid(row=row, column=14)
        self.DpeTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeTypeEntry.grid(row=row, column=22)
        self.DpeTypeEntry.insert(0, "NPF_DS_DROPPER")
        self.DpeTypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.DpeTypeEntry, self.DpeTypeEntry, self.DpeTypeEnums))
        row = row + 1
        self.DropperTypeEnums = {u'NPF_DS_WRED': u'2', u'NPF_DS_RED': u'1'}
        Label(master,text="DropperType:", fg="blue").grid(row=row, column=14)
        self.DropperTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DropperTypeEntry.grid(row=row, column=22)
        self.DropperTypeEntry.insert(0, "NPF_DS_WRED")
        self.enums.append((self.DropperTypeEntry, self.DropperTypeEntry, self.DropperTypeEnums))
        row = row + 1
        Label(master,text="Service Rate:", fg="blue").grid(row=row, column=14)
        self.Service_RateEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Service_RateEntry.grid(row=row, column=22)
        self.Service_RateEntry.insert(0, "1000")
        row = row + 1
        Label(master,text="Weight:", fg="blue").grid(row=row, column=14)
        self.WeightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.WeightEntry.grid(row=row, column=22)
        self.WeightEntry.insert(0, "0")
        row = row + 1
        Label(master,text="GreenMinThreshold:", fg="blue").grid(row=row, column=14)
        self.GreenMinThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenMinThresholdEntry.grid(row=row, column=22)
        self.GreenMinThresholdEntry.insert(0, "0")
        row = row + 1
        Label(master,text="GreenMaxThreshold:", fg="blue").grid(row=row, column=14)
        self.GreenMaxThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenMaxThresholdEntry.grid(row=row, column=22)
        self.GreenMaxThresholdEntry.insert(0, "250")
        row = row + 1
        Label(master,text="GreenMaxProbability:", fg="blue").grid(row=row, column=14)
        self.GreenMaxProbabilityEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenMaxProbabilityEntry.grid(row=row, column=22)
        self.GreenMaxProbabilityEntry.insert(0, "1")
        row = row + 1
        Label(master,text="YellowMinThreshold:", fg="blue").grid(row=row, column=14)
        self.YellowMinThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowMinThresholdEntry.grid(row=row, column=22)
        self.YellowMinThresholdEntry.insert(0, "0")
        row = row + 1
        Label(master,text="YellowMaxThreshold:", fg="blue").grid(row=row, column=14)
        self.YellowMaxThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowMaxThresholdEntry.grid(row=row, column=22)
        self.YellowMaxThresholdEntry.insert(0, "250")
        row = row + 1
        Label(master,text="YellowMaxProbability:", fg="blue").grid(row=row, column=14)
        self.YellowMaxProbabilityEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowMaxProbabilityEntry.grid(row=row, column=22)
        self.YellowMaxProbabilityEntry.insert(0, "1")
        row = row + 1
        Label(master,text="RedMinThreshold:", fg="blue").grid(row=row, column=14)
        self.RedMinThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedMinThresholdEntry.grid(row=row, column=22)
        self.RedMinThresholdEntry.insert(0, "0")
        row = row + 1
        Label(master,text="RedMaxThreshold:", fg="blue").grid(row=row, column=14)
        self.RedMaxThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedMaxThresholdEntry.grid(row=row, column=22)
        self.RedMaxThresholdEntry.insert(0, "250")
        row = row + 1
        Label(master,text="RedMaxProbability:", fg="blue").grid(row=row, column=14)
        self.RedMaxProbabilityEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedMaxProbabilityEntry.grid(row=row, column=22)
        self.RedMaxProbabilityEntry.insert(0, "1")
        row = row + 1
        self.StatisticsEnums = {u'YES': u'1', u'NO': u'0'}
        Label(master,text="Statistics:", fg="blue").grid(row=row, column=14)
        self.StatisticsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.StatisticsEntry.grid(row=row, column=22)
        self.StatisticsEntry.insert(0, "YES")
        self.enums.append((self.StatisticsEntry, self.StatisticsEntry, self.StatisticsEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "103"
            reqresp = ReqResp('DiffServCreate_Dropper', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Direction'
            direction = self.DirectionEntry.get()
            if(self.DirectionEnums.has_key(direction)):
                direction = self.DirectionEnums[direction]
            vl = direction
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeType'
            if(self.DpeTypeEnums.has_key('NPF_DS_DROPPER')):
                internalEnum   = self.DpeTypeEnums['NPF_DS_DROPPER']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DropperType'
            droppertype = self.DropperTypeEntry.get()
            if(self.DropperTypeEnums.has_key(droppertype)):
                droppertype = self.DropperTypeEnums[droppertype]
            vl = droppertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Service_Rate'
            service_rate = self.Service_RateEntry.get()
            vl = service_rate
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Weight'
            weight = self.WeightEntry.get()
            vl = weight
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenMinThreshold'
            greenminthreshold = self.GreenMinThresholdEntry.get()
            vl = greenminthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenMaxThreshold'
            greenmaxthreshold = self.GreenMaxThresholdEntry.get()
            vl = greenmaxthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenMaxProbability'
            greenmaxprobability = self.GreenMaxProbabilityEntry.get()
            vl = greenmaxprobability
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowMinThreshold'
            yellowminthreshold = self.YellowMinThresholdEntry.get()
            vl = yellowminthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowMaxThreshold'
            yellowmaxthreshold = self.YellowMaxThresholdEntry.get()
            vl = yellowmaxthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowMaxProbability'
            yellowmaxprobability = self.YellowMaxProbabilityEntry.get()
            vl = yellowmaxprobability
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedMinThreshold'
            redminthreshold = self.RedMinThresholdEntry.get()
            vl = redminthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedMaxThreshold'
            redmaxthreshold = self.RedMaxThresholdEntry.get()
            vl = redmaxthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedMaxProbability'
            redmaxprobability = self.RedMaxProbabilityEntry.get()
            vl = redmaxprobability
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Statistics'
            statistics = self.StatisticsEntry.get()
            if(self.StatisticsEnums.has_key(statistics)):
                statistics = self.StatisticsEnums[statistics]
            vl = statistics
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServCreate_Dropper ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Create_Dropper', '103'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "Direction"
                val = self.DirectionEntry.get()
                if(self.DirectionEnums.has_key(val)):
                    val  = self.DirectionEnums[val]
                order.append((nm, str(val)))
                nm = "DpeType"
                if(self.DpeTypeEnums.has_key('NPF_DS_DROPPER')):
                    val  = self.DpeTypeEnums['NPF_DS_DROPPER']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "DropperType"
                val = self.DropperTypeEntry.get()
                if(self.DropperTypeEnums.has_key(val)):
                    val  = self.DropperTypeEnums[val]
                order.append((nm, str(val)))
                nm = "Service_Rate"
                val = self.Service_RateEntry.get()
                order.append((nm, str(val)))
                nm = "Weight"
                val = self.WeightEntry.get()
                order.append((nm, str(val)))
                nm = "GreenMinThreshold"
                val = self.GreenMinThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "GreenMaxThreshold"
                val = self.GreenMaxThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "GreenMaxProbability"
                val = self.GreenMaxProbabilityEntry.get()
                order.append((nm, str(val)))
                nm = "YellowMinThreshold"
                val = self.YellowMinThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "YellowMaxThreshold"
                val = self.YellowMaxThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "YellowMaxProbability"
                val = self.YellowMaxProbabilityEntry.get()
                order.append((nm, str(val)))
                nm = "RedMinThreshold"
                val = self.RedMinThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "RedMaxThreshold"
                val = self.RedMaxThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "RedMaxProbability"
                val = self.RedMaxProbabilityEntry.get()
                order.append((nm, str(val)))
                nm = "Statistics"
                val = self.StatisticsEntry.get()
                if(self.StatisticsEnums.has_key(val)):
                    val  = self.StatisticsEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServCreate_Dropper", "Error Occured while processing DiffServCreate_Dropper Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServAdd_DSCP_FilterDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="DiffServAdd_DSCP_Filter")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "113"
            reqresp = ReqResp('DiffServAdd_DSCP_Filter', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServAdd_DSCP_Filter ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Add_DSCP_Filter', '113'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServAdd_DSCP_Filter", "Error Occured while processing DiffServAdd_DSCP_Filter Dialog")
            pass
    
    def operation(self, event=None):
        pass

class DiffServModify_ClassifierDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServModify_Classifier")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        self.ClassifierTypeEnums = {u'NPF_DS_DSCP_FILTER': u'4', u'NPF_DS_MPLS_FILTER': u'3', u'NPF_DS_IPV4_FILTER': u'1', u'NPF_DS_IPV6_FILTER': u'2'}
        Label(master,text="ClassifierType:", fg="blue").grid(row=row, column=14)
        self.ClassifierTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ClassifierTypeEntry.grid(row=row, column=22)
        self.ClassifierTypeEntry.insert(0, "NPF_DS_IPV4_FILTER")
        self.enums.append((self.ClassifierTypeEntry, self.ClassifierTypeEntry, self.ClassifierTypeEnums))
        row = row + 1
        Label(master,text="Precedence:", fg="blue").grid(row=row, column=14)
        self.PrecedenceEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrecedenceEntry.grid(row=row, column=22)
        self.PrecedenceEntry.insert(0, "0")
        row = row + 1
        Label(master,text="DestAddress:", fg="blue").grid(row=row, column=14)
        self.DestAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DestAddressEntry.grid(row=row, column=22)
        self.DestAddressEntry.insert(0, "20.0.0.2")
        row = row + 1
        Label(master,text="DestNetpLen:", fg="blue").grid(row=row, column=14)
        self.DestNetpLenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DestNetpLenEntry.grid(row=row, column=22)
        self.DestNetpLenEntry.insert(0, "32")
        row = row + 1
        Label(master,text="SrcAddress:", fg="blue").grid(row=row, column=14)
        self.SrcAddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SrcAddressEntry.grid(row=row, column=22)
        self.SrcAddressEntry.insert(0, "10.0.0.2")
        row = row + 1
        Label(master,text="SrcNetpLen:", fg="blue").grid(row=row, column=14)
        self.SrcNetpLenEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SrcNetpLenEntry.grid(row=row, column=22)
        self.SrcNetpLenEntry.insert(0, "32")
        row = row + 1
        self.DscpEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="Dscp:", fg="blue").grid(row=row, column=14)
        self.DscpEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DscpEntry.grid(row=row, column=22)
        self.DscpEntry.insert(0, "DEFAULT_PHB")
        self.enums.append((self.DscpEntry, self.DscpEntry, self.DscpEnums))
        row = row + 1
        self.ProtocolEnums = {u'ICPM': u'1', u'UDP': u'17', u'OSPF': u'89', u'IGPM': u'2', u'TCP': u'6'}
        Label(master,text="Protocol:", fg="blue").grid(row=row, column=14)
        self.ProtocolEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ProtocolEntry.grid(row=row, column=22)
        self.ProtocolEntry.insert(0, "TCP")
        self.enums.append((self.ProtocolEntry, self.ProtocolEntry, self.ProtocolEnums))
        row = row + 1
        Label(master,text="DestL4Port:", fg="blue").grid(row=row, column=14)
        self.DestL4PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DestL4PortEntry.grid(row=row, column=22)
        self.DestL4PortEntry.insert(0, "20")
        row = row + 1
        Label(master,text="SrcL4Port:", fg="blue").grid(row=row, column=14)
        self.SrcL4PortEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.SrcL4PortEntry.grid(row=row, column=22)
        self.SrcL4PortEntry.insert(0, "20")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "104"
            reqresp = ReqResp('DiffServModify_Classifier', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ClassifierType'
            classifiertype = self.ClassifierTypeEntry.get()
            if(self.ClassifierTypeEnums.has_key(classifiertype)):
                classifiertype = self.ClassifierTypeEnums[classifiertype]
            vl = classifiertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Precedence'
            precedence = self.PrecedenceEntry.get()
            vl = precedence
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DestAddress'
            destaddress = self.DestAddressEntry.get()
            vl = destaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DestNetpLen'
            destnetplen = self.DestNetpLenEntry.get()
            vl = destnetplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'SrcAddress'
            srcaddress = self.SrcAddressEntry.get()
            vl = srcaddress
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'SrcNetpLen'
            srcnetplen = self.SrcNetpLenEntry.get()
            vl = srcnetplen
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Dscp'
            dscp = self.DscpEntry.get()
            if(self.DscpEnums.has_key(dscp)):
                dscp = self.DscpEnums[dscp]
            vl = dscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Protocol'
            protocol = self.ProtocolEntry.get()
            if(self.ProtocolEnums.has_key(protocol)):
                protocol = self.ProtocolEnums[protocol]
            vl = protocol
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DestL4Port'
            destl4port = self.DestL4PortEntry.get()
            vl = destl4port
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'SrcL4Port'
            srcl4port = self.SrcL4PortEntry.get()
            vl = srcl4port
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServModify_Classifier ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Modify_Classifier', '104'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                nm = "ClassifierType"
                val = self.ClassifierTypeEntry.get()
                if(self.ClassifierTypeEnums.has_key(val)):
                    val  = self.ClassifierTypeEnums[val]
                order.append((nm, str(val)))
                nm = "Precedence"
                val = self.PrecedenceEntry.get()
                order.append((nm, str(val)))
                nm = "DestAddress"
                val = self.DestAddressEntry.get()
                order.append((nm, str(val)))
                nm = "DestNetpLen"
                val = self.DestNetpLenEntry.get()
                order.append((nm, str(val)))
                nm = "SrcAddress"
                val = self.SrcAddressEntry.get()
                order.append((nm, str(val)))
                nm = "SrcNetpLen"
                val = self.SrcNetpLenEntry.get()
                order.append((nm, str(val)))
                nm = "Dscp"
                val = self.DscpEntry.get()
                if(self.DscpEnums.has_key(val)):
                    val  = self.DscpEnums[val]
                order.append((nm, str(val)))
                nm = "Protocol"
                val = self.ProtocolEntry.get()
                if(self.ProtocolEnums.has_key(val)):
                    val  = self.ProtocolEnums[val]
                order.append((nm, str(val)))
                nm = "DestL4Port"
                val = self.DestL4PortEntry.get()
                order.append((nm, str(val)))
                nm = "SrcL4Port"
                val = self.SrcL4PortEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServModify_Classifier", "Error Occured while processing DiffServModify_Classifier Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServModify_MeterDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServModify_Meter")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "METER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        self.MeterTypeEnums = {u'NPF_DS_SRTCM_AWARE': u'4', u'NPF_DS_SIMPLE_TB': u'1', u'NPF_DS_TRTCM_BLIND': u'5', u'NPF_DS_TRTCM_AWARE': u'6', u'NPF_DS_TSW_TCM': u'7', u'NPF_DS_AVG_RATE': u'2', u'NPF_DS_SRTCM_BLIND': u'3'}
        Label(master,text="MeterType:", fg="blue").grid(row=row, column=14)
        self.MeterTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MeterTypeEntry.grid(row=row, column=22)
        self.MeterTypeEntry.insert(0, "NPF_DS_SRTCM_AWARE")
        self.enums.append((self.MeterTypeEntry, self.MeterTypeEntry, self.MeterTypeEnums))
        row = row + 1
        Label(master,text="CIR:", fg="blue").grid(row=row, column=14)
        self.CIREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.CIREntry.grid(row=row, column=22)
        self.CIREntry.insert(0, "100")
        row = row + 1
        Label(master,text="PIR:", fg="blue").grid(row=row, column=14)
        self.PIREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PIREntry.grid(row=row, column=22)
        self.PIREntry.insert(0, "100")
        row = row + 1
        Label(master,text="CBS:", fg="blue").grid(row=row, column=14)
        self.CBSEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.CBSEntry.grid(row=row, column=22)
        self.CBSEntry.insert(0, "10000")
        row = row + 1
        Label(master,text="PBS:", fg="blue").grid(row=row, column=14)
        self.PBSEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PBSEntry.grid(row=row, column=22)
        self.PBSEntry.insert(0, "10000")
        row = row + 1
        Label(master,text="EBS:", fg="blue").grid(row=row, column=14)
        self.EBSEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.EBSEntry.grid(row=row, column=22)
        self.EBSEntry.insert(0, "10000")
        row = row + 1
        self.GreenDpeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="GreenDpe:", fg="blue").grid(row=row, column=14)
        self.GreenDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenDpeEntry.grid(row=row, column=22)
        self.GreenDpeEntry.insert(0, "NPF_DS_MARKER")
        self.enums.append((self.GreenDpeEntry, self.GreenDpeEntry, self.GreenDpeEnums))
        row = row + 1
        self.YellowDpeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="YellowDpe:", fg="blue").grid(row=row, column=14)
        self.YellowDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowDpeEntry.grid(row=row, column=22)
        self.YellowDpeEntry.insert(0, "NPF_DS_MARKER")
        self.enums.append((self.YellowDpeEntry, self.YellowDpeEntry, self.YellowDpeEnums))
        row = row + 1
        self.RedDpeEnums = {u'NPF_DS_SHAPER': u'7', u'NPF_DS_METER': u'2', u'NPF_DS_CLASSIFIER': u'1', u'NPF_DS_SCHEDULER': u'6', u'NPF_DS_DROPPER': u'4', u'NPF_DS_MARKER': u'3', u'NPF_DS_QUEUE': u'5'}
        Label(master,text="RedDpe:", fg="blue").grid(row=row, column=14)
        self.RedDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedDpeEntry.grid(row=row, column=22)
        self.RedDpeEntry.insert(0, "NPF_DS_DROPPER")
        self.enums.append((self.RedDpeEntry, self.RedDpeEntry, self.RedDpeEnums))
        row = row + 1
        self.StatisticsEnums = {u'YES': u'1', u'NO': u'0'}
        Label(master,text="Statistics:", fg="blue").grid(row=row, column=14)
        self.StatisticsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.StatisticsEntry.grid(row=row, column=22)
        self.StatisticsEntry.insert(0, "YES")
        self.enums.append((self.StatisticsEntry, self.StatisticsEntry, self.StatisticsEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "105"
            reqresp = ReqResp('DiffServModify_Meter', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MeterType'
            metertype = self.MeterTypeEntry.get()
            if(self.MeterTypeEnums.has_key(metertype)):
                metertype = self.MeterTypeEnums[metertype]
            vl = metertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'CIR'
            cir = self.CIREntry.get()
            vl = cir
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PIR'
            pir = self.PIREntry.get()
            vl = pir
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'CBS'
            cbs = self.CBSEntry.get()
            vl = cbs
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PBS'
            pbs = self.PBSEntry.get()
            vl = pbs
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'EBS'
            ebs = self.EBSEntry.get()
            vl = ebs
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenDpe'
            greendpe = self.GreenDpeEntry.get()
            if(self.GreenDpeEnums.has_key(greendpe)):
                greendpe = self.GreenDpeEnums[greendpe]
            vl = greendpe
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowDpe'
            yellowdpe = self.YellowDpeEntry.get()
            if(self.YellowDpeEnums.has_key(yellowdpe)):
                yellowdpe = self.YellowDpeEnums[yellowdpe]
            vl = yellowdpe
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedDpe'
            reddpe = self.RedDpeEntry.get()
            if(self.RedDpeEnums.has_key(reddpe)):
                reddpe = self.RedDpeEnums[reddpe]
            vl = reddpe
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Statistics'
            statistics = self.StatisticsEntry.get()
            if(self.StatisticsEnums.has_key(statistics)):
                statistics = self.StatisticsEnums[statistics]
            vl = statistics
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServModify_Meter ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Modify_Meter', '105'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                nm = "MeterType"
                val = self.MeterTypeEntry.get()
                if(self.MeterTypeEnums.has_key(val)):
                    val  = self.MeterTypeEnums[val]
                order.append((nm, str(val)))
                nm = "CIR"
                val = self.CIREntry.get()
                order.append((nm, str(val)))
                nm = "PIR"
                val = self.PIREntry.get()
                order.append((nm, str(val)))
                nm = "CBS"
                val = self.CBSEntry.get()
                order.append((nm, str(val)))
                nm = "PBS"
                val = self.PBSEntry.get()
                order.append((nm, str(val)))
                nm = "EBS"
                val = self.EBSEntry.get()
                order.append((nm, str(val)))
                nm = "GreenDpe"
                val = self.GreenDpeEntry.get()
                if(self.GreenDpeEnums.has_key(val)):
                    val  = self.GreenDpeEnums[val]
                order.append((nm, str(val)))
                nm = "YellowDpe"
                val = self.YellowDpeEntry.get()
                if(self.YellowDpeEnums.has_key(val)):
                    val  = self.YellowDpeEnums[val]
                order.append((nm, str(val)))
                nm = "RedDpe"
                val = self.RedDpeEntry.get()
                if(self.RedDpeEnums.has_key(val)):
                    val  = self.RedDpeEnums[val]
                order.append((nm, str(val)))
                nm = "Statistics"
                val = self.StatisticsEntry.get()
                if(self.StatisticsEnums.has_key(val)):
                    val  = self.StatisticsEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServModify_Meter", "Error Occured while processing DiffServModify_Meter Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServModify_MarkerDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServModify_Marker")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "MARKER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        self.MarkerTypeEnums = {u'NPF_DS_WRED': u'2', u'NPF_DS_RED': u'1'}
        Label(master,text="MarkerType:", fg="blue").grid(row=row, column=14)
        self.MarkerTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.MarkerTypeEntry.grid(row=row, column=22)
        self.MarkerTypeEntry.insert(0, "NPF_DS_WRED")
        self.enums.append((self.MarkerTypeEntry, self.MarkerTypeEntry, self.MarkerTypeEnums))
        row = row + 1
        self.GreenDSCPEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="GreenDSCP:", fg="blue").grid(row=row, column=14)
        self.GreenDSCPEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenDSCPEntry.grid(row=row, column=22)
        self.GreenDSCPEntry.insert(0, "AF11_PHB")
        self.enums.append((self.GreenDSCPEntry, self.GreenDSCPEntry, self.GreenDSCPEnums))
        row = row + 1
        self.YellowDSCPEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="YellowDSCP:", fg="blue").grid(row=row, column=14)
        self.YellowDSCPEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowDSCPEntry.grid(row=row, column=22)
        self.YellowDSCPEntry.insert(0, "AF11_PHB")
        self.enums.append((self.YellowDSCPEntry, self.YellowDSCPEntry, self.YellowDSCPEnums))
        row = row + 1
        self.RedDSCPEnums = {u'AF43_PHB': u'38', u'AF41_PHB': u'34', u'AF11_PHB': u'10', u'DEFAULT_PHB': u'0', u'AF33_PHB': u'30', u'AF31_PHB': u'26', u'EF_PHB': u'46', u'AF32_PHB': u'28', u'AF42_PHB': u'36', u'AF22_PHB': u'20', u'AF23_PHB': u'22', u'AF21_PHB': u'18', u'AF13_PHB': u'14', u'AF12_PHB': u'12'}
        Label(master,text="RedDSCP:", fg="blue").grid(row=row, column=14)
        self.RedDSCPEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedDSCPEntry.grid(row=row, column=22)
        self.RedDSCPEntry.insert(0, "AF11_PHB")
        self.enums.append((self.RedDSCPEntry, self.RedDSCPEntry, self.RedDSCPEnums))
        row = row + 1
        self.StatisticsEnums = {u'YES': u'1', u'NO': u'0'}
        Label(master,text="Statistics:", fg="blue").grid(row=row, column=14)
        self.StatisticsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.StatisticsEntry.grid(row=row, column=22)
        self.StatisticsEntry.insert(0, "YES")
        self.enums.append((self.StatisticsEntry, self.StatisticsEntry, self.StatisticsEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "106"
            reqresp = ReqResp('DiffServModify_Marker', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'MarkerType'
            markertype = self.MarkerTypeEntry.get()
            if(self.MarkerTypeEnums.has_key(markertype)):
                markertype = self.MarkerTypeEnums[markertype]
            vl = markertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenDSCP'
            greendscp = self.GreenDSCPEntry.get()
            if(self.GreenDSCPEnums.has_key(greendscp)):
                greendscp = self.GreenDSCPEnums[greendscp]
            vl = greendscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowDSCP'
            yellowdscp = self.YellowDSCPEntry.get()
            if(self.YellowDSCPEnums.has_key(yellowdscp)):
                yellowdscp = self.YellowDSCPEnums[yellowdscp]
            vl = yellowdscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedDSCP'
            reddscp = self.RedDSCPEntry.get()
            if(self.RedDSCPEnums.has_key(reddscp)):
                reddscp = self.RedDSCPEnums[reddscp]
            vl = reddscp
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Statistics'
            statistics = self.StatisticsEntry.get()
            if(self.StatisticsEnums.has_key(statistics)):
                statistics = self.StatisticsEnums[statistics]
            vl = statistics
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServModify_Marker ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Modify_Marker', '106'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                nm = "MarkerType"
                val = self.MarkerTypeEntry.get()
                if(self.MarkerTypeEnums.has_key(val)):
                    val  = self.MarkerTypeEnums[val]
                order.append((nm, str(val)))
                nm = "GreenDSCP"
                val = self.GreenDSCPEntry.get()
                if(self.GreenDSCPEnums.has_key(val)):
                    val  = self.GreenDSCPEnums[val]
                order.append((nm, str(val)))
                nm = "YellowDSCP"
                val = self.YellowDSCPEntry.get()
                if(self.YellowDSCPEnums.has_key(val)):
                    val  = self.YellowDSCPEnums[val]
                order.append((nm, str(val)))
                nm = "RedDSCP"
                val = self.RedDSCPEntry.get()
                if(self.RedDSCPEnums.has_key(val)):
                    val  = self.RedDSCPEnums[val]
                order.append((nm, str(val)))
                nm = "Statistics"
                val = self.StatisticsEntry.get()
                if(self.StatisticsEnums.has_key(val)):
                    val  = self.StatisticsEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServModify_Marker", "Error Occured while processing DiffServModify_Marker Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServModify_DropperDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServModify_Dropper")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="NoOfDpe:", fg="blue").grid(row=row, column=14)
        self.NoOfDpeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoOfDpeEntry.grid(row=row, column=22)
        self.NoOfDpeEntry.insert(0, "1")
        self.NoOfDpeEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "DROPPER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        self.DropperTypeEnums = {u'NPF_DS_WRED': u'2', u'NPF_DS_RED': u'1'}
        Label(master,text="DropperType:", fg="blue").grid(row=row, column=14)
        self.DropperTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DropperTypeEntry.grid(row=row, column=22)
        self.DropperTypeEntry.insert(0, "NPF_DS_WRED")
        self.enums.append((self.DropperTypeEntry, self.DropperTypeEntry, self.DropperTypeEnums))
        row = row + 1
        Label(master,text="Service Rate:", fg="blue").grid(row=row, column=14)
        self.Service_RateEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Service_RateEntry.grid(row=row, column=22)
        self.Service_RateEntry.insert(0, "1000")
        row = row + 1
        Label(master,text="Weight:", fg="blue").grid(row=row, column=14)
        self.WeightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.WeightEntry.grid(row=row, column=22)
        self.WeightEntry.insert(0, "0")
        row = row + 1
        Label(master,text="GreenMinThreshold:", fg="blue").grid(row=row, column=14)
        self.GreenMinThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenMinThresholdEntry.grid(row=row, column=22)
        self.GreenMinThresholdEntry.insert(0, "0")
        row = row + 1
        Label(master,text="GreenMaxThreshold:", fg="blue").grid(row=row, column=14)
        self.GreenMaxThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenMaxThresholdEntry.grid(row=row, column=22)
        self.GreenMaxThresholdEntry.insert(0, "250")
        row = row + 1
        Label(master,text="GreenMaxProbability:", fg="blue").grid(row=row, column=14)
        self.GreenMaxProbabilityEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.GreenMaxProbabilityEntry.grid(row=row, column=22)
        self.GreenMaxProbabilityEntry.insert(0, "1")
        row = row + 1
        Label(master,text="YellowMinThreshold:", fg="blue").grid(row=row, column=14)
        self.YellowMinThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowMinThresholdEntry.grid(row=row, column=22)
        self.YellowMinThresholdEntry.insert(0, "0")
        row = row + 1
        Label(master,text="YellowMaxThreshold:", fg="blue").grid(row=row, column=14)
        self.YellowMaxThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowMaxThresholdEntry.grid(row=row, column=22)
        self.YellowMaxThresholdEntry.insert(0, "250")
        row = row + 1
        Label(master,text="YellowMaxProbability:", fg="blue").grid(row=row, column=14)
        self.YellowMaxProbabilityEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.YellowMaxProbabilityEntry.grid(row=row, column=22)
        self.YellowMaxProbabilityEntry.insert(0, "1")
        row = row + 1
        Label(master,text="RedMinThreshold:", fg="blue").grid(row=row, column=14)
        self.RedMinThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedMinThresholdEntry.grid(row=row, column=22)
        self.RedMinThresholdEntry.insert(0, "0")
        row = row + 1
        Label(master,text="RedMaxThreshold:", fg="blue").grid(row=row, column=14)
        self.RedMaxThresholdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedMaxThresholdEntry.grid(row=row, column=22)
        self.RedMaxThresholdEntry.insert(0, "250")
        row = row + 1
        Label(master,text="RedMaxProbability:", fg="blue").grid(row=row, column=14)
        self.RedMaxProbabilityEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RedMaxProbabilityEntry.grid(row=row, column=22)
        self.RedMaxProbabilityEntry.insert(0, "1")
        row = row + 1
        self.StatisticsEnums = {u'YES': u'1', u'NO': u'0'}
        Label(master,text="Statistics:", fg="blue").grid(row=row, column=14)
        self.StatisticsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.StatisticsEntry.grid(row=row, column=22)
        self.StatisticsEntry.insert(0, "YES")
        self.enums.append((self.StatisticsEntry, self.StatisticsEntry, self.StatisticsEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "107"
            reqresp = ReqResp('DiffServModify_Dropper', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'NoOfDpe'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DropperType'
            droppertype = self.DropperTypeEntry.get()
            if(self.DropperTypeEnums.has_key(droppertype)):
                droppertype = self.DropperTypeEnums[droppertype]
            vl = droppertype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Service_Rate'
            service_rate = self.Service_RateEntry.get()
            vl = service_rate
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Weight'
            weight = self.WeightEntry.get()
            vl = weight
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenMinThreshold'
            greenminthreshold = self.GreenMinThresholdEntry.get()
            vl = greenminthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenMaxThreshold'
            greenmaxthreshold = self.GreenMaxThresholdEntry.get()
            vl = greenmaxthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'GreenMaxProbability'
            greenmaxprobability = self.GreenMaxProbabilityEntry.get()
            vl = greenmaxprobability
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowMinThreshold'
            yellowminthreshold = self.YellowMinThresholdEntry.get()
            vl = yellowminthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowMaxThreshold'
            yellowmaxthreshold = self.YellowMaxThresholdEntry.get()
            vl = yellowmaxthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'YellowMaxProbability'
            yellowmaxprobability = self.YellowMaxProbabilityEntry.get()
            vl = yellowmaxprobability
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedMinThreshold'
            redminthreshold = self.RedMinThresholdEntry.get()
            vl = redminthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedMaxThreshold'
            redmaxthreshold = self.RedMaxThresholdEntry.get()
            vl = redmaxthreshold
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'RedMaxProbability'
            redmaxprobability = self.RedMaxProbabilityEntry.get()
            vl = redmaxprobability
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Statistics'
            statistics = self.StatisticsEntry.get()
            if(self.StatisticsEnums.has_key(statistics)):
                statistics = self.StatisticsEnums[statistics]
            vl = statistics
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServModify_Dropper ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Modify_Dropper', '107'))
                nm = "NoOfDpe"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                nm = "DropperType"
                val = self.DropperTypeEntry.get()
                if(self.DropperTypeEnums.has_key(val)):
                    val  = self.DropperTypeEnums[val]
                order.append((nm, str(val)))
                nm = "Service_Rate"
                val = self.Service_RateEntry.get()
                order.append((nm, str(val)))
                nm = "Weight"
                val = self.WeightEntry.get()
                order.append((nm, str(val)))
                nm = "GreenMinThreshold"
                val = self.GreenMinThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "GreenMaxThreshold"
                val = self.GreenMaxThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "GreenMaxProbability"
                val = self.GreenMaxProbabilityEntry.get()
                order.append((nm, str(val)))
                nm = "YellowMinThreshold"
                val = self.YellowMinThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "YellowMaxThreshold"
                val = self.YellowMaxThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "YellowMaxProbability"
                val = self.YellowMaxProbabilityEntry.get()
                order.append((nm, str(val)))
                nm = "RedMinThreshold"
                val = self.RedMinThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "RedMaxThreshold"
                val = self.RedMaxThresholdEntry.get()
                order.append((nm, str(val)))
                nm = "RedMaxProbability"
                val = self.RedMaxProbabilityEntry.get()
                order.append((nm, str(val)))
                nm = "Statistics"
                val = self.StatisticsEntry.get()
                if(self.StatisticsEnums.has_key(val)):
                    val  = self.StatisticsEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServModify_Dropper", "Error Occured while processing DiffServModify_Dropper Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServDpe_Add_AssociateDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServDpe_Add_Associate")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="no:", fg="blue").grid(row=row, column=14)
        self.noEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.noEntry.grid(row=row, column=22)
        self.noEntry.insert(0, "1")
        self.noEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        self.PrevDpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="PrevDpeHandle:", fg="blue").grid(row=row, column=14)
        self.PrevDpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrevDpeHandleEntry.grid(row=row, column=22)
        self.PrevDpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.PrevDpeHandleEntry, self.PrevDpeHandleEntry, self.PrevDpeHandleEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "108"
            reqresp = ReqResp('DiffServDpe_Add_Associate', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'no'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PrevDpeHandle'
            prevdpehandle = self.PrevDpeHandleEntry.get()
            if(self.PrevDpeHandleEnums.has_key(prevdpehandle)):
                prevdpehandle = self.PrevDpeHandleEnums[prevdpehandle]
            vl = prevdpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServDpe_Add_Associate ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Dpe_Add_Associate', '108'))
                nm = "no"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                nm = "PrevDpeHandle"
                val = self.PrevDpeHandleEntry.get()
                if(self.PrevDpeHandleEnums.has_key(val)):
                    val  = self.PrevDpeHandleEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServDpe_Add_Associate", "Error Occured while processing DiffServDpe_Add_Associate Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServDpe_QueryDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServDpe_Query")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="no:", fg="blue").grid(row=row, column=14)
        self.noEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.noEntry.grid(row=row, column=22)
        self.noEntry.insert(0, "1")
        self.noEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "109"
            reqresp = ReqResp('DiffServDpe_Query', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'no'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServDpe_Query ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Dpe_Query', '109'))
                nm = "no"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServDpe_Query", "Error Occured while processing DiffServDpe_Query Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServDpe_StatisticsDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServDpe_Statistics")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="no:", fg="blue").grid(row=row, column=14)
        self.noEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.noEntry.grid(row=row, column=22)
        self.noEntry.insert(0, "1")
        self.noEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "110"
            reqresp = ReqResp('DiffServDpe_Statistics', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'no'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServDpe_Statistics ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Dpe_Statistics', '110'))
                nm = "no"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServDpe_Statistics", "Error Occured while processing DiffServDpe_Statistics Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServDpe_Delete_AssociateDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServDpe_Delete_Associate")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="no:", fg="blue").grid(row=row, column=14)
        self.noEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.noEntry.grid(row=row, column=22)
        self.noEntry.insert(0, "1")
        self.noEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        self.PrevDpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="PrevDpeHandle:", fg="blue").grid(row=row, column=14)
        self.PrevDpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.PrevDpeHandleEntry.grid(row=row, column=22)
        self.PrevDpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.PrevDpeHandleEntry, self.PrevDpeHandleEntry, self.PrevDpeHandleEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "111"
            reqresp = ReqResp('DiffServDpe_Delete_Associate', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'no'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'PrevDpeHandle'
            prevdpehandle = self.PrevDpeHandleEntry.get()
            if(self.PrevDpeHandleEnums.has_key(prevdpehandle)):
                prevdpehandle = self.PrevDpeHandleEnums[prevdpehandle]
            vl = prevdpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServDpe_Delete_Associate ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Dpe_Delete_Associate', '111'))
                nm = "no"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                nm = "PrevDpeHandle"
                val = self.PrevDpeHandleEntry.get()
                if(self.PrevDpeHandleEnums.has_key(val)):
                    val  = self.PrevDpeHandleEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServDpe_Delete_Associate", "Error Occured while processing DiffServDpe_Delete_Associate Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServDpe_DeleteDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="DiffServDpe_Delete")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="No:", fg="blue").grid(row=row, column=14)
        self.NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NoEntry.grid(row=row, column=22)
        self.NoEntry.insert(0, "1")
        self.NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.DpeHandleEnums = {u'CLASSIFIER:0': u'CLASSIFIER:0', u'METER:0': u'METER:0', u'QUEUE:0': u'QUEUE:0', u'MARKER:0': u'MARKER:0', u'DROPPER:0': u'DROPPER:0', u'SCHEDULER:0': u'SCHEDULER:0'}
        Label(master,text="DpeHandle:", fg="blue").grid(row=row, column=14)
        self.DpeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.DpeHandleEntry.grid(row=row, column=22)
        self.DpeHandleEntry.insert(0, "CLASSIFIER:0")
        self.enums.append((self.DpeHandleEntry, self.DpeHandleEntry, self.DpeHandleEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "112"
            reqresp = ReqResp('DiffServDpe_Delete', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'DpeHandle'
            dpehandle = self.DpeHandleEntry.get()
            if(self.DpeHandleEnums.has_key(dpehandle)):
                dpehandle = self.DpeHandleEnums[dpehandle]
            vl = dpehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServDpe_Delete ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Dpe_Delete', '112'))
                nm = "No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "DpeHandle"
                val = self.DpeHandleEntry.get()
                if(self.DpeHandleEnums.has_key(val)):
                    val  = self.DpeHandleEnums[val]
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServDpe_Delete", "Error Occured while processing DiffServDpe_Delete Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class DiffServReset_Dpe_HandlesDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="DiffServReset_Dpe_Handles")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "114"
            reqresp = ReqResp('DiffServReset_Dpe_Handles', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("DiffServReset_Dpe_Handles ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('DiffServ_Reset_Dpe_Handles', '114'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("DiffServReset_Dpe_Handles", "Error Occured while processing DiffServReset_Dpe_Handles Dialog")
            pass
    
    def operation(self, event=None):
        pass


class MPLSCreate_NHLFEDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_NHLFE")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFE_Param_TypeEnums = {u'NPF_MPLS_NHLFE_HANDLE': u'1', u'NPF_MPLS_NHLFE_PARAMS': u'2'}
        Label(master,text="NHLFE Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFE_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFE_PARAMS")
        self.NHLFE_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_Param_TypeEntry, self.NHLFE_Param_TypeEntry, self.NHLFE_Param_TypeEnums))
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.NHLFE_IP_Addr_TypeEnums = {u'NPF_MPLS_IPV6': u'2', u'NPF_MPLS_IPV4': u'1'}
        Label(master,text="NHLFE IP Addr Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_IP_Addr_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_IP_Addr_TypeEntry.grid(row=row, column=22)
        self.NHLFE_IP_Addr_TypeEntry.insert(0, "NPF_MPLS_IPV4")
        self.NHLFE_IP_Addr_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEnums))
        row = row + 1
        Label(master,text="IPV4 Address:", fg="blue").grid(row=row, column=14)
        self.IPV4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPV4_AddressEntry.grid(row=row, column=22)
        self.IPV4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        Label(master,text="No Of Labels:", fg="blue").grid(row=row, column=14)
        self.No_Of_LabelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.No_Of_LabelsEntry.grid(row=row, column=22)
        self.No_Of_LabelsEntry.insert(0, "1")
        self.No_Of_LabelsEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="labels:", fg="blue").grid(row=row, column=14)
        self.labelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.labelsEntry.grid(row=row, column=22)
        self.labelsEntry.insert(0, "1")
        row = row + 1
        self.Label_TypeEnums = {u'NPF_MPLS_LABEL_TYPE_FR': u'3', u'NPF_MPLS_LABEL_TYPE_GENERIC': u'1', u'NPF_MPLS_LABEL_TYPE_ATM': u'2'}
        Label(master,text="Label Type:", fg="blue").grid(row=row, column=14)
        self.Label_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Label_TypeEntry.grid(row=row, column=22)
        self.Label_TypeEntry.insert(0, "NPF_MPLS_LABEL_TYPE_GENERIC")
        self.Label_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.Label_TypeEntry, self.Label_TypeEntry, self.Label_TypeEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "400"
            reqresp = ReqResp('MPLSCreate_NHLFE', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Param_Type'
            if(self.NHLFE_Param_TypeEnums.has_key('NPF_MPLS_NHLFE_PARAMS')):
                internalEnum   = self.NHLFE_Param_TypeEnums['NPF_MPLS_NHLFE_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_IP_Addr_Type'
            if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                internalEnum   = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPV4_Address'
            ipv4_address = self.IPV4_AddressEntry.get()
            vl = ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'No_Of_Labels'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'labels'
            labels = self.labelsEntry.get()
            vl = labels
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Label_Type'
            if(self.Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                internalEnum   = self.Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_NHLFE ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_NHLFE', '400'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Param_Type"
                if(self.NHLFE_Param_TypeEnums.has_key('NPF_MPLS_NHLFE_PARAMS')):
                    val  = self.NHLFE_Param_TypeEnums['NPF_MPLS_NHLFE_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFE_IP_Addr_Type"
                if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                    val  = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IPV4_Address"
                val = self.IPV4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "No_Of_Labels"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "labels"
                val = self.labelsEntry.get()
                order.append((nm, str(val)))
                nm = "Label_Type"
                if(self.Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                    val  = self.Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_NHLFE", "Error Occured while processing MPLSCreate_NHLFE Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_NHLFESETDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_NHLFESET")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="setId:", fg="blue").grid(row=row, column=14)
        self.setIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.setIdEntry.grid(row=row, column=22)
        self.setIdEntry.insert(0, "1")
        row = row + 1
        self.weightEnums = {u'NPF_MPLS_POLICYTYPE_DSCP': u'3', u'NPF_MPLS_POLICYTYPE_WEIGHT': u'1', u'NPF_MPLS_POLICYTYPE_EXP': u'2'}
        Label(master,text="weight:", fg="blue").grid(row=row, column=14)
        self.weightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.weightEntry.grid(row=row, column=22)
        self.weightEntry.insert(0, "NPF_MPLS_POLICYTYPE_WEIGHT")
        self.weightEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.weightEntry, self.weightEntry, self.weightEnums))
        row = row + 1
        Label(master,text="numPolicy:", fg="blue").grid(row=row, column=14)
        self.numPolicyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numPolicyEntry.grid(row=row, column=22)
        self.numPolicyEntry.insert(0, "1")
        self.numPolicyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="policy:", fg="blue").grid(row=row, column=14)
        self.policyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.policyEntry.grid(row=row, column=22)
        self.policyEntry.insert(0, "1")
        self.policyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="NhlfeHandle:", fg="blue").grid(row=row, column=14)
        self.NhlfeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NhlfeHandleEntry.grid(row=row, column=22)
        self.NhlfeHandleEntry.insert(0, "NHLFE:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "401"
            reqresp = ReqResp('MPLSCreate_NHLFESET', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'setId'
            setid = self.setIdEntry.get()
            vl = setid
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'weight'
            if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                internalEnum   = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'numPolicy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'policy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NhlfeHandle'
            nhlfehandle = self.NhlfeHandleEntry.get()
            vl = nhlfehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_NHLFESET ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_NHLFESET', '401'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "setId"
                val = self.setIdEntry.get()
                order.append((nm, str(val)))
                nm = "weight"
                if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                    val  = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "numPolicy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "policy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NhlfeHandle"
                val = self.NhlfeHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_NHLFESET", "Error Occured while processing MPLSCreate_NHLFESET Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_NHLFESET_n_NHLFEDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_NHLFESET_n_NHLFE")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="setId:", fg="blue").grid(row=row, column=14)
        self.setIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.setIdEntry.grid(row=row, column=22)
        self.setIdEntry.insert(0, "1")
        row = row + 1
        self.weightEnums = {u'NPF_MPLS_POLICYTYPE_DSCP': u'3', u'NPF_MPLS_POLICYTYPE_WEIGHT': u'1', u'NPF_MPLS_POLICYTYPE_EXP': u'2'}
        Label(master,text="weight:", fg="blue").grid(row=row, column=14)
        self.weightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.weightEntry.grid(row=row, column=22)
        self.weightEntry.insert(0, "NPF_MPLS_POLICYTYPE_WEIGHT")
        self.weightEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.weightEntry, self.weightEntry, self.weightEnums))
        row = row + 1
        Label(master,text="numPolicy:", fg="blue").grid(row=row, column=14)
        self.numPolicyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numPolicyEntry.grid(row=row, column=22)
        self.numPolicyEntry.insert(0, "1")
        self.numPolicyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="policy:", fg="blue").grid(row=row, column=14)
        self.policyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.policyEntry.grid(row=row, column=22)
        self.policyEntry.insert(0, "1")
        self.policyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.NHLFE_IP_Addr_TypeEnums = {u'NPF_MPLS_IPV6': u'2', u'NPF_MPLS_IPV4': u'1'}
        Label(master,text="NHLFE IP Addr Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_IP_Addr_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_IP_Addr_TypeEntry.grid(row=row, column=22)
        self.NHLFE_IP_Addr_TypeEntry.insert(0, "NPF_MPLS_IPV4")
        self.NHLFE_IP_Addr_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEnums))
        row = row + 1
        Label(master,text="IPv4 Address:", fg="blue").grid(row=row, column=14)
        self.IPv4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4_AddressEntry.grid(row=row, column=22)
        self.IPv4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        Label(master,text="No Of Labels:", fg="blue").grid(row=row, column=14)
        self.No_Of_LabelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.No_Of_LabelsEntry.grid(row=row, column=22)
        self.No_Of_LabelsEntry.insert(0, "1")
        self.No_Of_LabelsEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="labels:", fg="blue").grid(row=row, column=14)
        self.labelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.labelsEntry.grid(row=row, column=22)
        self.labelsEntry.insert(0, "1")
        row = row + 1
        self.Label_TypeEnums = {u'NPF_MPLS_LABEL_TYPE_FR': u'3', u'NPF_MPLS_LABEL_TYPE_GENERIC': u'1', u'NPF_MPLS_LABEL_TYPE_ATM': u'2'}
        Label(master,text="Label Type:", fg="blue").grid(row=row, column=14)
        self.Label_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Label_TypeEntry.grid(row=row, column=22)
        self.Label_TypeEntry.insert(0, "NPF_MPLS_LABEL_TYPE_GENERIC")
        self.Label_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.Label_TypeEntry, self.Label_TypeEntry, self.Label_TypeEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "402"
            reqresp = ReqResp('MPLSCreate_NHLFESET_n_NHLFE', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'setId'
            setid = self.setIdEntry.get()
            vl = setid
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'weight'
            if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                internalEnum   = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'numPolicy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'policy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_IP_Addr_Type'
            if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                internalEnum   = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4_Address'
            ipv4_address = self.IPv4_AddressEntry.get()
            vl = ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'No_Of_Labels'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'labels'
            labels = self.labelsEntry.get()
            vl = labels
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Label_Type'
            if(self.Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                internalEnum   = self.Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_NHLFESET_n_NHLFE ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_NHLFESET_n_NHLFE', '402'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "setId"
                val = self.setIdEntry.get()
                order.append((nm, str(val)))
                nm = "weight"
                if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                    val  = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "numPolicy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "policy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFE_IP_Addr_Type"
                if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                    val  = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IPv4_Address"
                val = self.IPv4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "No_Of_Labels"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "labels"
                val = self.labelsEntry.get()
                order.append((nm, str(val)))
                nm = "Label_Type"
                if(self.Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                    val  = self.Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_NHLFESET_n_NHLFE", "Error Occured while processing MPLSCreate_NHLFESET_n_NHLFE Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.LSP_TypeEnums = {u'NPF_MPLS_LSP_FEC': u'1', u'NPF_MPLS_LSP_ILM': u'2', u'NPF_MPLS_LSP_TUN': u'3'}
        Label(master,text="LSP Type:", fg="blue").grid(row=row, column=14)
        self.LSP_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TypeEntry.grid(row=row, column=22)
        self.LSP_TypeEntry.insert(0, "NPF_MPLS_LSP_FEC")
        self.LSP_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_TypeEntry, self.LSP_TypeEntry, self.LSP_TypeEnums))
        row = row + 1
        Label(master,text="LSP MTU:", fg="blue").grid(row=row, column=14)
        self.LSP_MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_MTUEntry.grid(row=row, column=22)
        self.LSP_MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="LSP Model:", fg="blue").grid(row=row, column=14)
        self.LSP_ModelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_ModelEntry.grid(row=row, column=22)
        self.LSP_ModelEntry.insert(0, "1")
        row = row + 1
        Label(master,text="LSP TTL Decrement:", fg="blue").grid(row=row, column=14)
        self.LSP_TTL_DecrementEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TTL_DecrementEntry.grid(row=row, column=22)
        self.LSP_TTL_DecrementEntry.insert(0, "1")
        row = row + 1
        self.LSP_FEC_TypeEnums = {u'NPF_MPLS_FEC_IPV4_HOSTADDR': u'2', u'NPF_MPLS_FEC_IPV4_DEST_PREFIX': u'1', u'NPF_MPLS_FEC_IPV6_HOSTADDR': u'4', u'NPF_MPLS_FEC_IPV6_DEST_PREFIX': u'3'}
        Label(master,text="LSP FEC Type:", fg="blue").grid(row=row, column=14)
        self.LSP_FEC_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_FEC_TypeEntry.grid(row=row, column=22)
        self.LSP_FEC_TypeEntry.insert(0, "NPF_MPLS_FEC_IPV4_HOSTADDR")
        self.LSP_FEC_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_FEC_TypeEntry, self.LSP_FEC_TypeEntry, self.LSP_FEC_TypeEnums))
        row = row + 1
        Label(master,text="IPv4 Address:", fg="blue").grid(row=row, column=14)
        self.IPv4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4_AddressEntry.grid(row=row, column=22)
        self.IPv4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_HANDLE")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="NhlfeSetHandle:", fg="blue").grid(row=row, column=14)
        self.NhlfeSetHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NhlfeSetHandleEntry.grid(row=row, column=22)
        self.NhlfeSetHandleEntry.insert(0, "NHLFESET:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "403"
            reqresp = ReqResp('MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Type'
            if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_FEC')):
                internalEnum   = self.LSP_TypeEnums['NPF_MPLS_LSP_FEC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_MTU'
            lsp_mtu = self.LSP_MTUEntry.get()
            vl = lsp_mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Model'
            lsp_model = self.LSP_ModelEntry.get()
            vl = lsp_model
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_TTL_Decrement'
            lsp_ttl_decrement = self.LSP_TTL_DecrementEntry.get()
            vl = lsp_ttl_decrement
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_FEC_Type'
            if(self.LSP_FEC_TypeEnums.has_key('NPF_MPLS_FEC_IPV4_HOSTADDR')):
                internalEnum   = self.LSP_FEC_TypeEnums['NPF_MPLS_FEC_IPV4_HOSTADDR']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4_Address'
            ipv4_address = self.IPv4_AddressEntry.get()
            vl = ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_HANDLE')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_HANDLE']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NhlfeSetHandle'
            nhlfesethandle = self.NhlfeSetHandleEntry.get()
            vl = nhlfesethandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_FTN_IPv4HostAddr_NHLFESET_Handle_LSP', '403'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Type"
                if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_FEC')):
                    val  = self.LSP_TypeEnums['NPF_MPLS_LSP_FEC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_MTU"
                val = self.LSP_MTUEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Model"
                val = self.LSP_ModelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_TTL_Decrement"
                val = self.LSP_TTL_DecrementEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_FEC_Type"
                if(self.LSP_FEC_TypeEnums.has_key('NPF_MPLS_FEC_IPV4_HOSTADDR')):
                    val  = self.LSP_FEC_TypeEnums['NPF_MPLS_FEC_IPV4_HOSTADDR']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IPv4_Address"
                val = self.IPv4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_HANDLE')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_HANDLE']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "NhlfeSetHandle"
                val = self.NhlfeSetHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP", "Error Occured while processing MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Handle_LSP Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.LSP_TypeEnums = {u'NPF_MPLS_LSP_FEC': u'1', u'NPF_MPLS_LSP_ILM': u'2', u'NPF_MPLS_LSP_TUN': u'3'}
        Label(master,text="LSP Type:", fg="blue").grid(row=row, column=14)
        self.LSP_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TypeEntry.grid(row=row, column=22)
        self.LSP_TypeEntry.insert(0, "NPF_MPLS_LSP_FEC")
        self.LSP_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_TypeEntry, self.LSP_TypeEntry, self.LSP_TypeEnums))
        row = row + 1
        Label(master,text="LSP MTU:", fg="blue").grid(row=row, column=14)
        self.LSP_MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_MTUEntry.grid(row=row, column=22)
        self.LSP_MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="LSP Model:", fg="blue").grid(row=row, column=14)
        self.LSP_ModelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_ModelEntry.grid(row=row, column=22)
        self.LSP_ModelEntry.insert(0, "1")
        row = row + 1
        Label(master,text="LSP TTL Decrement:", fg="blue").grid(row=row, column=14)
        self.LSP_TTL_DecrementEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TTL_DecrementEntry.grid(row=row, column=22)
        self.LSP_TTL_DecrementEntry.insert(0, "1")
        row = row + 1
        self.LSP_FEC_TypeEnums = {u'NPF_MPLS_FEC_IPV4_HOSTADDR': u'2', u'NPF_MPLS_FEC_IPV4_DEST_PREFIX': u'1', u'NPF_MPLS_FEC_IPV6_HOSTADDR': u'4', u'NPF_MPLS_FEC_IPV6_DEST_PREFIX': u'3'}
        Label(master,text="LSP FEC Type:", fg="blue").grid(row=row, column=14)
        self.LSP_FEC_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_FEC_TypeEntry.grid(row=row, column=22)
        self.LSP_FEC_TypeEntry.insert(0, "NPF_MPLS_FEC_IPV4_HOSTADDR")
        self.LSP_FEC_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_FEC_TypeEntry, self.LSP_FEC_TypeEntry, self.LSP_FEC_TypeEnums))
        row = row + 1
        Label(master,text="IPv4 Address:", fg="blue").grid(row=row, column=14)
        self.IPv4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4_AddressEntry.grid(row=row, column=22)
        self.IPv4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="setId:", fg="blue").grid(row=row, column=14)
        self.setIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.setIdEntry.grid(row=row, column=22)
        self.setIdEntry.insert(0, "1")
        row = row + 1
        self.weightEnums = {u'NPF_MPLS_POLICYTYPE_DSCP': u'3', u'NPF_MPLS_POLICYTYPE_WEIGHT': u'1', u'NPF_MPLS_POLICYTYPE_EXP': u'2'}
        Label(master,text="weight:", fg="blue").grid(row=row, column=14)
        self.weightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.weightEntry.grid(row=row, column=22)
        self.weightEntry.insert(0, "NPF_MPLS_POLICYTYPE_WEIGHT")
        self.weightEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.weightEntry, self.weightEntry, self.weightEnums))
        row = row + 1
        Label(master,text="numPolicy:", fg="blue").grid(row=row, column=14)
        self.numPolicyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numPolicyEntry.grid(row=row, column=22)
        self.numPolicyEntry.insert(0, "1")
        self.numPolicyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="policy:", fg="blue").grid(row=row, column=14)
        self.policyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.policyEntry.grid(row=row, column=22)
        self.policyEntry.insert(0, "1")
        self.policyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="NhlfeHandle:", fg="blue").grid(row=row, column=14)
        self.NhlfeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NhlfeHandleEntry.grid(row=row, column=22)
        self.NhlfeHandleEntry.insert(0, "NHLFE:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "404"
            reqresp = ReqResp('MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Type'
            if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_FEC')):
                internalEnum   = self.LSP_TypeEnums['NPF_MPLS_LSP_FEC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_MTU'
            lsp_mtu = self.LSP_MTUEntry.get()
            vl = lsp_mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Model'
            lsp_model = self.LSP_ModelEntry.get()
            vl = lsp_model
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_TTL_Decrement'
            lsp_ttl_decrement = self.LSP_TTL_DecrementEntry.get()
            vl = lsp_ttl_decrement
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_FEC_Type'
            if(self.LSP_FEC_TypeEnums.has_key('NPF_MPLS_FEC_IPV4_HOSTADDR')):
                internalEnum   = self.LSP_FEC_TypeEnums['NPF_MPLS_FEC_IPV4_HOSTADDR']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4_Address'
            ipv4_address = self.IPv4_AddressEntry.get()
            vl = ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'setId'
            setid = self.setIdEntry.get()
            vl = setid
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'weight'
            if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                internalEnum   = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'numPolicy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'policy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NhlfeHandle'
            nhlfehandle = self.NhlfeHandleEntry.get()
            vl = nhlfehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP', '404'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Type"
                if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_FEC')):
                    val  = self.LSP_TypeEnums['NPF_MPLS_LSP_FEC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_MTU"
                val = self.LSP_MTUEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Model"
                val = self.LSP_ModelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_TTL_Decrement"
                val = self.LSP_TTL_DecrementEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_FEC_Type"
                if(self.LSP_FEC_TypeEnums.has_key('NPF_MPLS_FEC_IPV4_HOSTADDR')):
                    val  = self.LSP_FEC_TypeEnums['NPF_MPLS_FEC_IPV4_HOSTADDR']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IPv4_Address"
                val = self.IPv4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "setId"
                val = self.setIdEntry.get()
                order.append((nm, str(val)))
                nm = "weight"
                if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                    val  = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "numPolicy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "policy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NhlfeHandle"
                val = self.NhlfeHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP", "Error Occured while processing MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Handle_LSP Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.LSP_TypeEnums = {u'NPF_MPLS_LSP_FEC': u'1', u'NPF_MPLS_LSP_ILM': u'2', u'NPF_MPLS_LSP_TUN': u'3'}
        Label(master,text="LSP Type:", fg="blue").grid(row=row, column=14)
        self.LSP_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TypeEntry.grid(row=row, column=22)
        self.LSP_TypeEntry.insert(0, "NPF_MPLS_LSP_FEC")
        self.LSP_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_TypeEntry, self.LSP_TypeEntry, self.LSP_TypeEnums))
        row = row + 1
        Label(master,text="LSP MTU:", fg="blue").grid(row=row, column=14)
        self.LSP_MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_MTUEntry.grid(row=row, column=22)
        self.LSP_MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="LSP Model:", fg="blue").grid(row=row, column=14)
        self.LSP_ModelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_ModelEntry.grid(row=row, column=22)
        self.LSP_ModelEntry.insert(0, "1")
        row = row + 1
        Label(master,text="LSP TTL Decrement:", fg="blue").grid(row=row, column=14)
        self.LSP_TTL_DecrementEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TTL_DecrementEntry.grid(row=row, column=22)
        self.LSP_TTL_DecrementEntry.insert(0, "1")
        row = row + 1
        self.LSP_FEC_TypeEnums = {u'NPF_MPLS_FEC_IPV4_HOSTADDR': u'2', u'NPF_MPLS_FEC_IPV4_DEST_PREFIX': u'1', u'NPF_MPLS_FEC_IPV6_HOSTADDR': u'4', u'NPF_MPLS_FEC_IPV6_DEST_PREFIX': u'3'}
        Label(master,text="LSP FEC Type:", fg="blue").grid(row=row, column=14)
        self.LSP_FEC_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_FEC_TypeEntry.grid(row=row, column=22)
        self.LSP_FEC_TypeEntry.insert(0, "NPF_MPLS_FEC_IPV4_HOSTADDR")
        self.LSP_FEC_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_FEC_TypeEntry, self.LSP_FEC_TypeEntry, self.LSP_FEC_TypeEnums))
        row = row + 1
        Label(master,text="FEC IPv4 Address:", fg="blue").grid(row=row, column=14)
        self.FEC_IPv4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.FEC_IPv4_AddressEntry.grid(row=row, column=22)
        self.FEC_IPv4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="setId:", fg="blue").grid(row=row, column=14)
        self.setIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.setIdEntry.grid(row=row, column=22)
        self.setIdEntry.insert(0, "1")
        row = row + 1
        self.weightEnums = {u'NPF_MPLS_POLICYTYPE_DSCP': u'3', u'NPF_MPLS_POLICYTYPE_WEIGHT': u'1', u'NPF_MPLS_POLICYTYPE_EXP': u'2'}
        Label(master,text="weight:", fg="blue").grid(row=row, column=14)
        self.weightEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.weightEntry.grid(row=row, column=22)
        self.weightEntry.insert(0, "NPF_MPLS_POLICYTYPE_WEIGHT")
        self.weightEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.weightEntry, self.weightEntry, self.weightEnums))
        row = row + 1
        Label(master,text="numPolicy:", fg="blue").grid(row=row, column=14)
        self.numPolicyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numPolicyEntry.grid(row=row, column=22)
        self.numPolicyEntry.insert(0, "1")
        self.numPolicyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="policy:", fg="blue").grid(row=row, column=14)
        self.policyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.policyEntry.grid(row=row, column=22)
        self.policyEntry.insert(0, "1")
        self.policyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.NHLFE_IP_Addr_TypeEnums = {u'NPF_MPLS_IPV6': u'2', u'NPF_MPLS_IPV4': u'1'}
        Label(master,text="NHLFE IP Addr Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_IP_Addr_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_IP_Addr_TypeEntry.grid(row=row, column=22)
        self.NHLFE_IP_Addr_TypeEntry.insert(0, "NPF_MPLS_IPV4")
        self.NHLFE_IP_Addr_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEnums))
        row = row + 1
        Label(master,text="IPv4 Address:", fg="blue").grid(row=row, column=14)
        self.IPv4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPv4_AddressEntry.grid(row=row, column=22)
        self.IPv4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        Label(master,text="No Of Labels:", fg="blue").grid(row=row, column=14)
        self.No_Of_LabelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.No_Of_LabelsEntry.grid(row=row, column=22)
        self.No_Of_LabelsEntry.insert(0, "1")
        self.No_Of_LabelsEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="labels:", fg="blue").grid(row=row, column=14)
        self.labelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.labelsEntry.grid(row=row, column=22)
        self.labelsEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "405"
            reqresp = ReqResp('MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Type'
            if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_FEC')):
                internalEnum   = self.LSP_TypeEnums['NPF_MPLS_LSP_FEC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_MTU'
            lsp_mtu = self.LSP_MTUEntry.get()
            vl = lsp_mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Model'
            lsp_model = self.LSP_ModelEntry.get()
            vl = lsp_model
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_TTL_Decrement'
            lsp_ttl_decrement = self.LSP_TTL_DecrementEntry.get()
            vl = lsp_ttl_decrement
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_FEC_Type'
            if(self.LSP_FEC_TypeEnums.has_key('NPF_MPLS_FEC_IPV4_HOSTADDR')):
                internalEnum   = self.LSP_FEC_TypeEnums['NPF_MPLS_FEC_IPV4_HOSTADDR']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'FEC_IPv4_Address'
            fec_ipv4_address = self.FEC_IPv4_AddressEntry.get()
            vl = fec_ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'setId'
            setid = self.setIdEntry.get()
            vl = setid
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'weight'
            if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                internalEnum   = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'numPolicy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'policy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_IP_Addr_Type'
            if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                internalEnum   = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPv4_Address'
            ipv4_address = self.IPv4_AddressEntry.get()
            vl = ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'No_Of_Labels'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'labels'
            labels = self.labelsEntry.get()
            vl = labels
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP', '405'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Type"
                if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_FEC')):
                    val  = self.LSP_TypeEnums['NPF_MPLS_LSP_FEC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_MTU"
                val = self.LSP_MTUEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Model"
                val = self.LSP_ModelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_TTL_Decrement"
                val = self.LSP_TTL_DecrementEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_FEC_Type"
                if(self.LSP_FEC_TypeEnums.has_key('NPF_MPLS_FEC_IPV4_HOSTADDR')):
                    val  = self.LSP_FEC_TypeEnums['NPF_MPLS_FEC_IPV4_HOSTADDR']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "FEC_IPv4_Address"
                val = self.FEC_IPv4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "setId"
                val = self.setIdEntry.get()
                order.append((nm, str(val)))
                nm = "weight"
                if(self.weightEnums.has_key('NPF_MPLS_POLICYTYPE_WEIGHT')):
                    val  = self.weightEnums['NPF_MPLS_POLICYTYPE_WEIGHT']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "numPolicy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "policy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFE_IP_Addr_Type"
                if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                    val  = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IPv4_Address"
                val = self.IPv4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "No_Of_Labels"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "labels"
                val = self.labelsEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP", "Error Occured while processing MPLSCreate_FTN_IPv4HostAddr_NHLFESET_Params_NHLFE_Params_LSP Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.LSP_TypeEnums = {u'NPF_MPLS_LSP_FEC': u'1', u'NPF_MPLS_LSP_ILM': u'2', u'NPF_MPLS_LSP_TUN': u'3'}
        Label(master,text="LSP Type:", fg="blue").grid(row=row, column=14)
        self.LSP_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TypeEntry.grid(row=row, column=22)
        self.LSP_TypeEntry.insert(0, "NPF_MPLS_LSP_ILM")
        self.LSP_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_TypeEntry, self.LSP_TypeEntry, self.LSP_TypeEnums))
        row = row + 1
        Label(master,text="LSP MTU:", fg="blue").grid(row=row, column=14)
        self.LSP_MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_MTUEntry.grid(row=row, column=22)
        self.LSP_MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="LSP Model:", fg="blue").grid(row=row, column=14)
        self.LSP_ModelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_ModelEntry.grid(row=row, column=22)
        self.LSP_ModelEntry.insert(0, "1")
        row = row + 1
        Label(master,text="LSP TTL Decrement:", fg="blue").grid(row=row, column=14)
        self.LSP_TTL_DecrementEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TTL_DecrementEntry.grid(row=row, column=22)
        self.LSP_TTL_DecrementEntry.insert(0, "1")
        row = row + 1
        self.LSP_Incoming_Label_TypeEnums = {u'NPF_MPLS_LABEL_TYPE_FR': u'3', u'NPF_MPLS_LABEL_TYPE_GENERIC': u'1', u'NPF_MPLS_LABEL_TYPE_ATM': u'2'}
        Label(master,text="LSP Incoming Label Type:", fg="blue").grid(row=row, column=14)
        self.LSP_Incoming_Label_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Incoming_Label_TypeEntry.grid(row=row, column=22)
        self.LSP_Incoming_Label_TypeEntry.insert(0, "NPF_MPLS_LABEL_TYPE_GENERIC")
        self.LSP_Incoming_Label_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_Incoming_Label_TypeEntry, self.LSP_Incoming_Label_TypeEntry, self.LSP_Incoming_Label_TypeEnums))
        row = row + 1
        Label(master,text="LSP Incoming Label:", fg="blue").grid(row=row, column=14)
        self.LSP_Incoming_LabelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Incoming_LabelEntry.grid(row=row, column=22)
        self.LSP_Incoming_LabelEntry.insert(0, "100")
        row = row + 1
        Label(master,text="LSP Ingress Interface handle:", fg="blue").grid(row=row, column=14)
        self.LSP_Ingress_Interface_handleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Ingress_Interface_handleEntry.grid(row=row, column=22)
        self.LSP_Ingress_Interface_handleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.LSP_Lable_ActionEnums = {u'NPF_MPLS_DISCARD': u'4', u'NPF_MPLS_NO_POP_AND_FORWARD': u'3', u'NPF_MPLS_POP_AND_LOOKUP': u'1', u'NPF_MPLS_POP_AND_FORWARD': u'2'}
        Label(master,text="LSP Lable Action:", fg="blue").grid(row=row, column=14)
        self.LSP_Lable_ActionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Lable_ActionEntry.grid(row=row, column=22)
        self.LSP_Lable_ActionEntry.insert(0, "NPF_MPLS_POP_AND_FORWARD")
        self.enums.append((self.LSP_Lable_ActionEntry, self.LSP_Lable_ActionEntry, self.LSP_Lable_ActionEnums))
        row = row + 1
        self.LSP_Modify_TypeEnums = {u'NPF_MPLS_COPY_PROCESS_OPCODE': u'2', u'NPF_MPLS_REDIRECT': u'1'}
        Label(master,text="LSP Modify Type:", fg="blue").grid(row=row, column=14)
        self.LSP_Modify_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Modify_TypeEntry.grid(row=row, column=22)
        self.LSP_Modify_TypeEntry.insert(0, "NPF_MPLS_REDIRECT")
        self.enums.append((self.LSP_Modify_TypeEntry, self.LSP_Modify_TypeEntry, self.LSP_Modify_TypeEnums))
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_HANDLE")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="NhlfeSetHandle:", fg="blue").grid(row=row, column=14)
        self.NhlfeSetHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NhlfeSetHandleEntry.grid(row=row, column=22)
        self.NhlfeSetHandleEntry.insert(0, "NHLFESET:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "406"
            reqresp = ReqResp('MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Type'
            if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_ILM')):
                internalEnum   = self.LSP_TypeEnums['NPF_MPLS_LSP_ILM']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_MTU'
            lsp_mtu = self.LSP_MTUEntry.get()
            vl = lsp_mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Model'
            lsp_model = self.LSP_ModelEntry.get()
            vl = lsp_model
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_TTL_Decrement'
            lsp_ttl_decrement = self.LSP_TTL_DecrementEntry.get()
            vl = lsp_ttl_decrement
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Incoming_Label_Type'
            if(self.LSP_Incoming_Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                internalEnum   = self.LSP_Incoming_Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Incoming_Label'
            lsp_incoming_label = self.LSP_Incoming_LabelEntry.get()
            vl = lsp_incoming_label
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Ingress_Interface_handle'
            lsp_ingress_interface_handle = self.LSP_Ingress_Interface_handleEntry.get()
            vl = lsp_ingress_interface_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Lable_Action'
            lsp_lable_action = self.LSP_Lable_ActionEntry.get()
            if(self.LSP_Lable_ActionEnums.has_key(lsp_lable_action)):
                lsp_lable_action = self.LSP_Lable_ActionEnums[lsp_lable_action]
            vl = lsp_lable_action
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Modify_Type'
            lsp_modify_type = self.LSP_Modify_TypeEntry.get()
            if(self.LSP_Modify_TypeEnums.has_key(lsp_modify_type)):
                lsp_modify_type = self.LSP_Modify_TypeEnums[lsp_modify_type]
            vl = lsp_modify_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_HANDLE')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_HANDLE']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NhlfeSetHandle'
            nhlfesethandle = self.NhlfeSetHandleEntry.get()
            vl = nhlfesethandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_ILM_ShimLbl_NHLFESET_Handle_LSP', '406'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Type"
                if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_ILM')):
                    val  = self.LSP_TypeEnums['NPF_MPLS_LSP_ILM']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_MTU"
                val = self.LSP_MTUEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Model"
                val = self.LSP_ModelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_TTL_Decrement"
                val = self.LSP_TTL_DecrementEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Incoming_Label_Type"
                if(self.LSP_Incoming_Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                    val  = self.LSP_Incoming_Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Incoming_Label"
                val = self.LSP_Incoming_LabelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Ingress_Interface_handle"
                val = self.LSP_Ingress_Interface_handleEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Lable_Action"
                val = self.LSP_Lable_ActionEntry.get()
                if(self.LSP_Lable_ActionEnums.has_key(val)):
                    val  = self.LSP_Lable_ActionEnums[val]
                order.append((nm, str(val)))
                nm = "LSP_Modify_Type"
                val = self.LSP_Modify_TypeEntry.get()
                if(self.LSP_Modify_TypeEnums.has_key(val)):
                    val  = self.LSP_Modify_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_HANDLE')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_HANDLE']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "NhlfeSetHandle"
                val = self.NhlfeSetHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP", "Error Occured while processing MPLSCreate_ILM_ShimLbl_NHLFESET_Handle_LSP Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.LSP_TypeEnums = {u'NPF_MPLS_LSP_FEC': u'1', u'NPF_MPLS_LSP_ILM': u'2', u'NPF_MPLS_LSP_TUN': u'3'}
        Label(master,text="LSP Type:", fg="blue").grid(row=row, column=14)
        self.LSP_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TypeEntry.grid(row=row, column=22)
        self.LSP_TypeEntry.insert(0, "NPF_MPLS_LSP_ILM")
        self.LSP_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_TypeEntry, self.LSP_TypeEntry, self.LSP_TypeEnums))
        row = row + 1
        Label(master,text="LSP MTU:", fg="blue").grid(row=row, column=14)
        self.LSP_MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_MTUEntry.grid(row=row, column=22)
        self.LSP_MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="LSP Model:", fg="blue").grid(row=row, column=14)
        self.LSP_ModelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_ModelEntry.grid(row=row, column=22)
        self.LSP_ModelEntry.insert(0, "1")
        row = row + 1
        Label(master,text="LSP TTL Decrement:", fg="blue").grid(row=row, column=14)
        self.LSP_TTL_DecrementEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TTL_DecrementEntry.grid(row=row, column=22)
        self.LSP_TTL_DecrementEntry.insert(0, "1")
        row = row + 1
        self.LSP_Incoming_Label_TypeEnums = {u'NPF_MPLS_LABEL_TYPE_FR': u'3', u'NPF_MPLS_LABEL_TYPE_GENERIC': u'1', u'NPF_MPLS_LABEL_TYPE_ATM': u'2'}
        Label(master,text="LSP Incoming Label Type:", fg="blue").grid(row=row, column=14)
        self.LSP_Incoming_Label_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Incoming_Label_TypeEntry.grid(row=row, column=22)
        self.LSP_Incoming_Label_TypeEntry.insert(0, "NPF_MPLS_LABEL_TYPE_GENERIC")
        self.LSP_Incoming_Label_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_Incoming_Label_TypeEntry, self.LSP_Incoming_Label_TypeEntry, self.LSP_Incoming_Label_TypeEnums))
        row = row + 1
        Label(master,text="LSP Incoming Label:", fg="blue").grid(row=row, column=14)
        self.LSP_Incoming_LabelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Incoming_LabelEntry.grid(row=row, column=22)
        self.LSP_Incoming_LabelEntry.insert(0, "100")
        row = row + 1
        Label(master,text="LSP Ingress Interface handle:", fg="blue").grid(row=row, column=14)
        self.LSP_Ingress_Interface_handleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Ingress_Interface_handleEntry.grid(row=row, column=22)
        self.LSP_Ingress_Interface_handleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.LSP_Lable_ActionEnums = {u'NPF_MPLS_DISCARD': u'4', u'NPF_MPLS_NO_POP_AND_FORWARD': u'3', u'NPF_MPLS_POP_AND_LOOKUP': u'1', u'NPF_MPLS_POP_AND_FORWARD': u'2'}
        Label(master,text="LSP Lable Action:", fg="blue").grid(row=row, column=14)
        self.LSP_Lable_ActionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Lable_ActionEntry.grid(row=row, column=22)
        self.LSP_Lable_ActionEntry.insert(0, "NPF_MPLS_POP_AND_FORWARD")
        self.enums.append((self.LSP_Lable_ActionEntry, self.LSP_Lable_ActionEntry, self.LSP_Lable_ActionEnums))
        row = row + 1
        self.LSP_Modify_TypeEnums = {u'NPF_MPLS_COPY_PROCESS_OPCODE': u'2', u'NPF_MPLS_REDIRECT': u'1'}
        Label(master,text="LSP Modify Type:", fg="blue").grid(row=row, column=14)
        self.LSP_Modify_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Modify_TypeEntry.grid(row=row, column=22)
        self.LSP_Modify_TypeEntry.insert(0, "NPF_MPLS_REDIRECT")
        self.enums.append((self.LSP_Modify_TypeEntry, self.LSP_Modify_TypeEntry, self.LSP_Modify_TypeEnums))
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="NHLFE Set Id:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Set_IdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Set_IdEntry.grid(row=row, column=22)
        self.NHLFE_Set_IdEntry.insert(0, "0")
        row = row + 1
        self.NHLFE_Set_Policy_TypeEnums = {u'NPF_MPLS_POLICYTYPE_DSCP': u'3', u'NPF_MPLS_POLICYTYPE_WEIGHT': u'1', u'NPF_MPLS_POLICYTYPE_EXP': u'2'}
        Label(master,text="NHLFE Set Policy Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Set_Policy_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Set_Policy_TypeEntry.grid(row=row, column=22)
        self.NHLFE_Set_Policy_TypeEntry.insert(0, "NPF_MPLS_POLICYTYPE_WEIGHT")
        self.enums.append((self.NHLFE_Set_Policy_TypeEntry, self.NHLFE_Set_Policy_TypeEntry, self.NHLFE_Set_Policy_TypeEnums))
        row = row + 1
        Label(master,text="NHLFE Set numPolicy:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Set_numPolicyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Set_numPolicyEntry.grid(row=row, column=22)
        self.NHLFE_Set_numPolicyEntry.insert(0, "1")
        self.NHLFE_Set_numPolicyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="policy:", fg="blue").grid(row=row, column=14)
        self.policyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.policyEntry.grid(row=row, column=22)
        self.policyEntry.insert(0, "1")
        self.policyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="NhlfeHandle:", fg="blue").grid(row=row, column=14)
        self.NhlfeHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NhlfeHandleEntry.grid(row=row, column=22)
        self.NhlfeHandleEntry.insert(0, "NHLFE:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "407"
            reqresp = ReqResp('MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Type'
            if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_ILM')):
                internalEnum   = self.LSP_TypeEnums['NPF_MPLS_LSP_ILM']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_MTU'
            lsp_mtu = self.LSP_MTUEntry.get()
            vl = lsp_mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Model'
            lsp_model = self.LSP_ModelEntry.get()
            vl = lsp_model
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_TTL_Decrement'
            lsp_ttl_decrement = self.LSP_TTL_DecrementEntry.get()
            vl = lsp_ttl_decrement
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Incoming_Label_Type'
            if(self.LSP_Incoming_Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                internalEnum   = self.LSP_Incoming_Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Incoming_Label'
            lsp_incoming_label = self.LSP_Incoming_LabelEntry.get()
            vl = lsp_incoming_label
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Ingress_Interface_handle'
            lsp_ingress_interface_handle = self.LSP_Ingress_Interface_handleEntry.get()
            vl = lsp_ingress_interface_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Lable_Action'
            lsp_lable_action = self.LSP_Lable_ActionEntry.get()
            if(self.LSP_Lable_ActionEnums.has_key(lsp_lable_action)):
                lsp_lable_action = self.LSP_Lable_ActionEnums[lsp_lable_action]
            vl = lsp_lable_action
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Modify_Type'
            lsp_modify_type = self.LSP_Modify_TypeEntry.get()
            if(self.LSP_Modify_TypeEnums.has_key(lsp_modify_type)):
                lsp_modify_type = self.LSP_Modify_TypeEnums[lsp_modify_type]
            vl = lsp_modify_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Set_Id'
            nhlfe_set_id = self.NHLFE_Set_IdEntry.get()
            vl = nhlfe_set_id
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Set_Policy_Type'
            nhlfe_set_policy_type = self.NHLFE_Set_Policy_TypeEntry.get()
            if(self.NHLFE_Set_Policy_TypeEnums.has_key(nhlfe_set_policy_type)):
                nhlfe_set_policy_type = self.NHLFE_Set_Policy_TypeEnums[nhlfe_set_policy_type]
            vl = nhlfe_set_policy_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Set_numPolicy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'policy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NhlfeHandle'
            nhlfehandle = self.NhlfeHandleEntry.get()
            vl = nhlfehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP', '407'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Type"
                if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_ILM')):
                    val  = self.LSP_TypeEnums['NPF_MPLS_LSP_ILM']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_MTU"
                val = self.LSP_MTUEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Model"
                val = self.LSP_ModelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_TTL_Decrement"
                val = self.LSP_TTL_DecrementEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Incoming_Label_Type"
                if(self.LSP_Incoming_Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                    val  = self.LSP_Incoming_Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Incoming_Label"
                val = self.LSP_Incoming_LabelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Ingress_Interface_handle"
                val = self.LSP_Ingress_Interface_handleEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Lable_Action"
                val = self.LSP_Lable_ActionEntry.get()
                if(self.LSP_Lable_ActionEnums.has_key(val)):
                    val  = self.LSP_Lable_ActionEnums[val]
                order.append((nm, str(val)))
                nm = "LSP_Modify_Type"
                val = self.LSP_Modify_TypeEntry.get()
                if(self.LSP_Modify_TypeEnums.has_key(val)):
                    val  = self.LSP_Modify_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Set_Id"
                val = self.NHLFE_Set_IdEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFE_Set_Policy_Type"
                val = self.NHLFE_Set_Policy_TypeEntry.get()
                if(self.NHLFE_Set_Policy_TypeEnums.has_key(val)):
                    val  = self.NHLFE_Set_Policy_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "NHLFE_Set_numPolicy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "policy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NhlfeHandle"
                val = self.NhlfeHandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP", "Error Occured while processing MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Handle_LSP Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.LSP_TypeEnums = {u'NPF_MPLS_LSP_FEC': u'1', u'NPF_MPLS_LSP_ILM': u'2', u'NPF_MPLS_LSP_TUN': u'3'}
        Label(master,text="LSP Type:", fg="blue").grid(row=row, column=14)
        self.LSP_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TypeEntry.grid(row=row, column=22)
        self.LSP_TypeEntry.insert(0, "NPF_MPLS_LSP_ILM")
        self.LSP_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_TypeEntry, self.LSP_TypeEntry, self.LSP_TypeEnums))
        row = row + 1
        Label(master,text="LSP MTU:", fg="blue").grid(row=row, column=14)
        self.LSP_MTUEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_MTUEntry.grid(row=row, column=22)
        self.LSP_MTUEntry.insert(0, "1500")
        row = row + 1
        Label(master,text="LSP Model:", fg="blue").grid(row=row, column=14)
        self.LSP_ModelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_ModelEntry.grid(row=row, column=22)
        self.LSP_ModelEntry.insert(0, "1")
        row = row + 1
        Label(master,text="LSP TTL Decrement:", fg="blue").grid(row=row, column=14)
        self.LSP_TTL_DecrementEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_TTL_DecrementEntry.grid(row=row, column=22)
        self.LSP_TTL_DecrementEntry.insert(0, "1")
        row = row + 1
        self.LSP_Incoming_Label_TypeEnums = {u'NPF_MPLS_LABEL_TYPE_FR': u'3', u'NPF_MPLS_LABEL_TYPE_GENERIC': u'1', u'NPF_MPLS_LABEL_TYPE_ATM': u'2'}
        Label(master,text="LSP Incoming Label Type:", fg="blue").grid(row=row, column=14)
        self.LSP_Incoming_Label_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Incoming_Label_TypeEntry.grid(row=row, column=22)
        self.LSP_Incoming_Label_TypeEntry.insert(0, "NPF_MPLS_LABEL_TYPE_GENERIC")
        self.LSP_Incoming_Label_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.LSP_Incoming_Label_TypeEntry, self.LSP_Incoming_Label_TypeEntry, self.LSP_Incoming_Label_TypeEnums))
        row = row + 1
        Label(master,text="LSP Incoming Label:", fg="blue").grid(row=row, column=14)
        self.LSP_Incoming_LabelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Incoming_LabelEntry.grid(row=row, column=22)
        self.LSP_Incoming_LabelEntry.insert(0, "100")
        row = row + 1
        Label(master,text="LSP Ingress Interface handle:", fg="blue").grid(row=row, column=14)
        self.LSP_Ingress_Interface_handleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Ingress_Interface_handleEntry.grid(row=row, column=22)
        self.LSP_Ingress_Interface_handleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.LSP_Lable_ActionEnums = {u'NPF_MPLS_DISCARD': u'4', u'NPF_MPLS_NO_POP_AND_FORWARD': u'3', u'NPF_MPLS_POP_AND_LOOKUP': u'1', u'NPF_MPLS_POP_AND_FORWARD': u'2'}
        Label(master,text="LSP Lable Action:", fg="blue").grid(row=row, column=14)
        self.LSP_Lable_ActionEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Lable_ActionEntry.grid(row=row, column=22)
        self.LSP_Lable_ActionEntry.insert(0, "NPF_MPLS_POP_AND_FORWARD")
        self.enums.append((self.LSP_Lable_ActionEntry, self.LSP_Lable_ActionEntry, self.LSP_Lable_ActionEnums))
        row = row + 1
        self.LSP_Modify_TypeEnums = {u'NPF_MPLS_COPY_PROCESS_OPCODE': u'2', u'NPF_MPLS_REDIRECT': u'1'}
        Label(master,text="LSP Modify Type:", fg="blue").grid(row=row, column=14)
        self.LSP_Modify_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_Modify_TypeEntry.grid(row=row, column=22)
        self.LSP_Modify_TypeEntry.insert(0, "NPF_MPLS_REDIRECT")
        self.enums.append((self.LSP_Modify_TypeEntry, self.LSP_Modify_TypeEntry, self.LSP_Modify_TypeEnums))
        row = row + 1
        self.NHLFESET_Param_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Param Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_Param_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_Param_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEntry, self.NHLFESET_Param_TypeEnums))
        row = row + 1
        Label(master,text="NHLFE Set Id:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Set_IdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Set_IdEntry.grid(row=row, column=22)
        self.NHLFE_Set_IdEntry.insert(0, "1")
        row = row + 1
        self.NHLFE_Set_Policy_TypeEnums = {u'NPF_MPLS_POLICYTYPE_DSCP': u'3', u'NPF_MPLS_POLICYTYPE_WEIGHT': u'1', u'NPF_MPLS_POLICYTYPE_EXP': u'2'}
        Label(master,text="NHLFE Set Policy Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Set_Policy_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Set_Policy_TypeEntry.grid(row=row, column=22)
        self.NHLFE_Set_Policy_TypeEntry.insert(0, "NPF_MPLS_POLICYTYPE_WEIGHT")
        self.enums.append((self.NHLFE_Set_Policy_TypeEntry, self.NHLFE_Set_Policy_TypeEntry, self.NHLFE_Set_Policy_TypeEnums))
        row = row + 1
        Label(master,text="NHLFE Set Policy No:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Set_Policy_NoEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Set_Policy_NoEntry.grid(row=row, column=22)
        self.NHLFE_Set_Policy_NoEntry.insert(0, "1")
        self.NHLFE_Set_Policy_NoEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="policy:", fg="blue").grid(row=row, column=14)
        self.policyEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.policyEntry.grid(row=row, column=22)
        self.policyEntry.insert(0, "1")
        self.policyEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFE_Parameter_TypeEnums = {u'NPF_MPLS_NHLFE_HANDLE': u'1', u'NPF_MPLS_NHLFE_PARAMS': u'2'}
        Label(master,text="NHLFE Parameter Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_Parameter_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_Parameter_TypeEntry.grid(row=row, column=22)
        self.NHLFE_Parameter_TypeEntry.insert(0, "NPF_MPLS_NHLFE_PARAMS")
        self.NHLFE_Parameter_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_Parameter_TypeEntry, self.NHLFE_Parameter_TypeEntry, self.NHLFE_Parameter_TypeEnums))
        row = row + 1
        Label(master,text="IfHandle:", fg="blue").grid(row=row, column=14)
        self.IfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IfHandleEntry.grid(row=row, column=22)
        self.IfHandleEntry.insert(0, "MPLS:0")
        row = row + 1
        self.NHLFE_IP_Addr_TypeEnums = {u'NPF_MPLS_IPV6': u'2', u'NPF_MPLS_IPV4': u'1'}
        Label(master,text="NHLFE IP Addr Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_IP_Addr_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_IP_Addr_TypeEntry.grid(row=row, column=22)
        self.NHLFE_IP_Addr_TypeEntry.insert(0, "NPF_MPLS_IPV4")
        self.NHLFE_IP_Addr_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEntry, self.NHLFE_IP_Addr_TypeEnums))
        row = row + 1
        Label(master,text="IPV4 Address:", fg="blue").grid(row=row, column=14)
        self.IPV4_AddressEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.IPV4_AddressEntry.grid(row=row, column=22)
        self.IPV4_AddressEntry.insert(0, "10.0.0.1")
        row = row + 1
        Label(master,text="numLabels:", fg="blue").grid(row=row, column=14)
        self.numLabelsEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numLabelsEntry.grid(row=row, column=22)
        self.numLabelsEntry.insert(0, "1")
        self.numLabelsEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="label:", fg="blue").grid(row=row, column=14)
        self.labelEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.labelEntry.grid(row=row, column=22)
        self.labelEntry.insert(0, "1")
        row = row + 1
        self.Label_TypeEnums = {u'NPF_MPLS_LABEL_TYPE_FR': u'3', u'NPF_MPLS_LABEL_TYPE_GENERIC': u'1', u'NPF_MPLS_LABEL_TYPE_ATM': u'2'}
        Label(master,text="Label Type:", fg="blue").grid(row=row, column=14)
        self.Label_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Label_TypeEntry.grid(row=row, column=22)
        self.Label_TypeEntry.insert(0, "NPF_MPLS_LABEL_TYPE_GENERIC")
        self.Label_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.Label_TypeEntry, self.Label_TypeEntry, self.Label_TypeEnums))
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "408"
            reqresp = ReqResp('MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Type'
            if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_ILM')):
                internalEnum   = self.LSP_TypeEnums['NPF_MPLS_LSP_ILM']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_MTU'
            lsp_mtu = self.LSP_MTUEntry.get()
            vl = lsp_mtu
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Model'
            lsp_model = self.LSP_ModelEntry.get()
            vl = lsp_model
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_TTL_Decrement'
            lsp_ttl_decrement = self.LSP_TTL_DecrementEntry.get()
            vl = lsp_ttl_decrement
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Incoming_Label_Type'
            if(self.LSP_Incoming_Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                internalEnum   = self.LSP_Incoming_Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Incoming_Label'
            lsp_incoming_label = self.LSP_Incoming_LabelEntry.get()
            vl = lsp_incoming_label
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Ingress_Interface_handle'
            lsp_ingress_interface_handle = self.LSP_Ingress_Interface_handleEntry.get()
            vl = lsp_ingress_interface_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Lable_Action'
            lsp_lable_action = self.LSP_Lable_ActionEntry.get()
            if(self.LSP_Lable_ActionEnums.has_key(lsp_lable_action)):
                lsp_lable_action = self.LSP_Lable_ActionEnums[lsp_lable_action]
            vl = lsp_lable_action
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Modify_Type'
            lsp_modify_type = self.LSP_Modify_TypeEntry.get()
            if(self.LSP_Modify_TypeEnums.has_key(lsp_modify_type)):
                lsp_modify_type = self.LSP_Modify_TypeEnums[lsp_modify_type]
            vl = lsp_modify_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Param_Type'
            if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Set_Id'
            nhlfe_set_id = self.NHLFE_Set_IdEntry.get()
            vl = nhlfe_set_id
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Set_Policy_Type'
            nhlfe_set_policy_type = self.NHLFE_Set_Policy_TypeEntry.get()
            if(self.NHLFE_Set_Policy_TypeEnums.has_key(nhlfe_set_policy_type)):
                nhlfe_set_policy_type = self.NHLFE_Set_Policy_TypeEnums[nhlfe_set_policy_type]
            vl = nhlfe_set_policy_type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Set_Policy_No'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'policy'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Parameter_Type'
            if(self.NHLFE_Parameter_TypeEnums.has_key('NPF_MPLS_NHLFE_PARAMS')):
                internalEnum   = self.NHLFE_Parameter_TypeEnums['NPF_MPLS_NHLFE_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IfHandle'
            ifhandle = self.IfHandleEntry.get()
            vl = ifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_IP_Addr_Type'
            if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                internalEnum   = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'IPV4_Address'
            ipv4_address = self.IPV4_AddressEntry.get()
            vl = ipv4_address
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'numLabels'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'label'
            label = self.labelEntry.get()
            vl = label
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Label_Type'
            if(self.Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                internalEnum   = self.Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Create_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP', '408'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Type"
                if(self.LSP_TypeEnums.has_key('NPF_MPLS_LSP_ILM')):
                    val  = self.LSP_TypeEnums['NPF_MPLS_LSP_ILM']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_MTU"
                val = self.LSP_MTUEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Model"
                val = self.LSP_ModelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_TTL_Decrement"
                val = self.LSP_TTL_DecrementEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Incoming_Label_Type"
                if(self.LSP_Incoming_Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                    val  = self.LSP_Incoming_Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Incoming_Label"
                val = self.LSP_Incoming_LabelEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Ingress_Interface_handle"
                val = self.LSP_Ingress_Interface_handleEntry.get()
                order.append((nm, str(val)))
                nm = "LSP_Lable_Action"
                val = self.LSP_Lable_ActionEntry.get()
                if(self.LSP_Lable_ActionEnums.has_key(val)):
                    val  = self.LSP_Lable_ActionEnums[val]
                order.append((nm, str(val)))
                nm = "LSP_Modify_Type"
                val = self.LSP_Modify_TypeEntry.get()
                if(self.LSP_Modify_TypeEnums.has_key(val)):
                    val  = self.LSP_Modify_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "NHLFESET_Param_Type"
                if(self.NHLFESET_Param_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_Param_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Set_Id"
                val = self.NHLFE_Set_IdEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFE_Set_Policy_Type"
                val = self.NHLFE_Set_Policy_TypeEntry.get()
                if(self.NHLFE_Set_Policy_TypeEnums.has_key(val)):
                    val  = self.NHLFE_Set_Policy_TypeEnums[val]
                order.append((nm, str(val)))
                nm = "NHLFE_Set_Policy_No"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "policy"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Parameter_Type"
                if(self.NHLFE_Parameter_TypeEnums.has_key('NPF_MPLS_NHLFE_PARAMS')):
                    val  = self.NHLFE_Parameter_TypeEnums['NPF_MPLS_NHLFE_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IfHandle"
                val = self.IfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NHLFE_IP_Addr_Type"
                if(self.NHLFE_IP_Addr_TypeEnums.has_key('NPF_MPLS_IPV4')):
                    val  = self.NHLFE_IP_Addr_TypeEnums['NPF_MPLS_IPV4']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "IPV4_Address"
                val = self.IPV4_AddressEntry.get()
                order.append((nm, str(val)))
                nm = "numLabels"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "label"
                val = self.labelEntry.get()
                order.append((nm, str(val)))
                nm = "Label_Type"
                if(self.Label_TypeEnums.has_key('NPF_MPLS_LABEL_TYPE_GENERIC')):
                    val  = self.Label_TypeEnums['NPF_MPLS_LABEL_TYPE_GENERIC']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP", "Error Occured while processing MPLSCreate_ILM_ShimLbl_NHLFESET_Params_NHLFE_Params_LSP Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSDelete_LSPDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="MPLSDelete_LSP")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="LSP Handle:", fg="blue").grid(row=row, column=14)
        self.LSP_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.LSP_HandleEntry.grid(row=row, column=22)
        self.LSP_HandleEntry.insert(0, "LSP:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "412"
            reqresp = ReqResp('MPLSDelete_LSP', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'LSP_Handle'
            lsp_handle = self.LSP_HandleEntry.get()
            vl = lsp_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSDelete_LSP ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Delete_LSP', '412'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "LSP_Handle"
                val = self.LSP_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSDelete_LSP", "Error Occured while processing MPLSDelete_LSP Dialog")
            pass
    
    def operation(self, event=None):
        pass

class MPLSDelete_NHLFESETDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="MPLSDelete_NHLFESET")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="NHLFESET Handle:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_HandleEntry.grid(row=row, column=22)
        self.NHLFESET_HandleEntry.insert(0, "NHLFESET:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "413"
            reqresp = ReqResp('MPLSDelete_NHLFESET', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Handle'
            nhlfeset_handle = self.NHLFESET_HandleEntry.get()
            vl = nhlfeset_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSDelete_NHLFESET ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Delete_NHLFESET', '413'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFESET_Handle"
                val = self.NHLFESET_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSDelete_NHLFESET", "Error Occured while processing MPLSDelete_NHLFESET Dialog")
            pass
    
    def operation(self, event=None):
        pass

class MPLSDelete_NHLFEDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="MPLSDelete_NHLFE")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="NHLFE Handle:", fg="blue").grid(row=row, column=14)
        self.NHLFE_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_HandleEntry.grid(row=row, column=22)
        self.NHLFE_HandleEntry.insert(0, "NHLFE:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "414"
            reqresp = ReqResp('MPLSDelete_NHLFE', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Handle'
            nhlfe_handle = self.NHLFE_HandleEntry.get()
            vl = nhlfe_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSDelete_NHLFE ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Delete_NHLFE', '414'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Handle"
                val = self.NHLFE_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSDelete_NHLFE", "Error Occured while processing MPLSDelete_NHLFE Dialog")
            pass
    
    def operation(self, event=None):
        pass

class MPLSQuery_NHLFE_based_on_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSQuery_NHLFE_based_on_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFE_TypeEnums = {u'NPF_MPLS_NHLFE_HANDLE': u'1', u'NPF_MPLS_NHLFE_PARAMS': u'2'}
        Label(master,text="NHLFE Type:", fg="blue").grid(row=row, column=14)
        self.NHLFE_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_TypeEntry.grid(row=row, column=22)
        self.NHLFE_TypeEntry.insert(0, "NPF_MPLS_NHLFE_HANDLE")
        self.NHLFE_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFE_TypeEntry, self.NHLFE_TypeEntry, self.NHLFE_TypeEnums))
        row = row + 1
        Label(master,text="NHLFE Handle:", fg="blue").grid(row=row, column=14)
        self.NHLFE_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFE_HandleEntry.grid(row=row, column=22)
        self.NHLFE_HandleEntry.insert(0, "NHLFE:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "415"
            reqresp = ReqResp('MPLSQuery_NHLFE_based_on_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Type'
            if(self.NHLFE_TypeEnums.has_key('NPF_MPLS_NHLFE_HANDLE')):
                internalEnum   = self.NHLFE_TypeEnums['NPF_MPLS_NHLFE_HANDLE']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFE_Handle'
            nhlfe_handle = self.NHLFE_HandleEntry.get()
            vl = nhlfe_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSQuery_NHLFE_based_on_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Query_NHLFE_based_on_Handle', '415'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Type"
                if(self.NHLFE_TypeEnums.has_key('NPF_MPLS_NHLFE_HANDLE')):
                    val  = self.NHLFE_TypeEnums['NPF_MPLS_NHLFE_HANDLE']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "NHLFE_Handle"
                val = self.NHLFE_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSQuery_NHLFE_based_on_Handle", "Error Occured while processing MPLSQuery_NHLFE_based_on_Handle Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSQuery_NHLFESET_based_on_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSQuery_NHLFESET_based_on_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFESET_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_HANDLE")
        self.NHLFESET_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_TypeEntry, self.NHLFESET_TypeEntry, self.NHLFESET_TypeEnums))
        row = row + 1
        Label(master,text="NHLFESET Handle:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_HandleEntry.grid(row=row, column=22)
        self.NHLFESET_HandleEntry.insert(0, "NHLFESET:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "416"
            reqresp = ReqResp('MPLSQuery_NHLFESET_based_on_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Type'
            if(self.NHLFESET_TypeEnums.has_key('NPF_MPLS_NHLFESET_HANDLE')):
                internalEnum   = self.NHLFESET_TypeEnums['NPF_MPLS_NHLFESET_HANDLE']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Handle'
            nhlfeset_handle = self.NHLFESET_HandleEntry.get()
            vl = nhlfeset_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSQuery_NHLFESET_based_on_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Query_NHLFESET_based_on_Handle', '416'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFESET_Type"
                if(self.NHLFESET_TypeEnums.has_key('NPF_MPLS_NHLFESET_HANDLE')):
                    val  = self.NHLFESET_TypeEnums['NPF_MPLS_NHLFESET_HANDLE']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "NHLFESET_Handle"
                val = self.NHLFESET_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSQuery_NHLFESET_based_on_Handle", "Error Occured while processing MPLSQuery_NHLFESET_based_on_Handle Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSQuery_NHLFESET_based_on_SetIdDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSQuery_NHLFESET_based_on_SetId")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.NHLFESET_TypeEnums = {u'NPF_MPLS_NHLFESET_HANDLE': u'1', u'NPF_MPLS_NHLFESET_PARAMS': u'2'}
        Label(master,text="NHLFESET Type:", fg="blue").grid(row=row, column=14)
        self.NHLFESET_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NHLFESET_TypeEntry.grid(row=row, column=22)
        self.NHLFESET_TypeEntry.insert(0, "NPF_MPLS_NHLFESET_PARAMS")
        self.NHLFESET_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.NHLFESET_TypeEntry, self.NHLFESET_TypeEntry, self.NHLFESET_TypeEnums))
        row = row + 1
        Label(master,text="nhSetId:", fg="blue").grid(row=row, column=14)
        self.nhSetIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.nhSetIdEntry.grid(row=row, column=22)
        self.nhSetIdEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "417"
            reqresp = ReqResp('MPLSQuery_NHLFESET_based_on_SetId', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NHLFESET_Type'
            if(self.NHLFESET_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                internalEnum   = self.NHLFESET_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'nhSetId'
            nhsetid = self.nhSetIdEntry.get()
            vl = nhsetid
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSQuery_NHLFESET_based_on_SetId ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Query_NHLFESET_based_on_SetId', '417'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "NHLFESET_Type"
                if(self.NHLFESET_TypeEnums.has_key('NPF_MPLS_NHLFESET_PARAMS')):
                    val  = self.NHLFESET_TypeEnums['NPF_MPLS_NHLFESET_PARAMS']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "nhSetId"
                val = self.nhSetIdEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSQuery_NHLFESET_based_on_SetId", "Error Occured while processing MPLSQuery_NHLFESET_based_on_SetId Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSQuery_LSP_based_on_HandleDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="MPLSQuery_LSP_based_on_Handle")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="numEntries:", fg="blue").grid(row=row, column=14)
        self.numEntriesEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.numEntriesEntry.grid(row=row, column=22)
        self.numEntriesEntry.insert(0, "1")
        self.numEntriesEntry.config(fg="red", state=DISABLED)
        row = row + 1
        self.Lsp_Param_TypeEnums = {u'NPF_MPLS_LSP_HANDLE': u'1', u'NPF_MPLS_LSP_PARAMS': u'2'}
        Label(master,text="Lsp Param Type:", fg="blue").grid(row=row, column=14)
        self.Lsp_Param_TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Lsp_Param_TypeEntry.grid(row=row, column=22)
        self.Lsp_Param_TypeEntry.insert(0, "NPF_MPLS_LSP_HANDLE")
        self.Lsp_Param_TypeEntry.config(fg="red", state=DISABLED)
        self.enums.append((self.Lsp_Param_TypeEntry, self.Lsp_Param_TypeEntry, self.Lsp_Param_TypeEnums))
        row = row + 1
        Label(master,text="Lsp Handle:", fg="blue").grid(row=row, column=14)
        self.Lsp_HandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.Lsp_HandleEntry.grid(row=row, column=22)
        self.Lsp_HandleEntry.insert(0, "LSP:0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "418"
            reqresp = ReqResp('MPLSQuery_LSP_based_on_Handle', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'numEntries'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Lsp_Param_Type'
            if(self.Lsp_Param_TypeEnums.has_key('NPF_MPLS_LSP_HANDLE')):
                internalEnum   = self.Lsp_Param_TypeEnums['NPF_MPLS_LSP_HANDLE']
            vl =  internalEnum
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'Lsp_Handle'
            lsp_handle = self.Lsp_HandleEntry.get()
            vl = lsp_handle
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSQuery_LSP_based_on_Handle ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Query_LSP_based_on_Handle', '418'))
                nm = "numEntries"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "Lsp_Param_Type"
                if(self.Lsp_Param_TypeEnums.has_key('NPF_MPLS_LSP_HANDLE')):
                    val  = self.Lsp_Param_TypeEnums['NPF_MPLS_LSP_HANDLE']
                    val = str(val)
                val = str(val)
                order.append((nm, val))
                nm = "Lsp_Handle"
                val = self.Lsp_HandleEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSQuery_LSP_based_on_Handle", "Error Occured while processing MPLSQuery_LSP_based_on_Handle Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class MPLSReset_MPLS_Handles_For_Test_RepeatDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="MPLSReset_MPLS_Handles_For_Test_Repeat")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "419"
            reqresp = ReqResp('MPLSReset_MPLS_Handles_For_Test_Repeat', cmd)
            order = []
            nm = ''
            vl = ''
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("MPLSReset_MPLS_Handles_For_Test_Repeat ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('MPLS_Reset_MPLS_Handles_For_Test_Repeat', '419'))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("MPLSReset_MPLS_Handles_For_Test_Repeat", "Error Occured while processing MPLSReset_MPLS_Handles_For_Test_Repeat Dialog")
            pass
    
    def operation(self, event=None):
        pass


class ATMAAL5_Vcc_SetDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, 1, title="ATMAAL5_Vcc_Set")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=28)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=36)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        Label(master,text="VPI:", fg="blue").grid(row=row, column=42)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=50)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        self.aal5TypeEnums = {u'NPF_IF_VCC_AAL5_VCMUX': u'5', u'NPF_IF_VCC_AALRAW': u'6', u'NPF_IF_VCC_AAL3_4': u'3', u'NPF_IF_VCC_AAL5_LLC': u'4', u'NPF_IF_VCC_AAL2': u'2', u'NPF_IF_VCC_AAL1': u'1', u'NPF_IF_VCC_AAL0': u'7'}
        Label(master,text="aal5Type:", fg="blue").grid(row=row, column=28)
        self.aal5TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.aal5TypeEntry.grid(row=row, column=36)
        self.aal5TypeEntry.insert(0, "NPF_IF_VCC_AAL5_VCMUX")
        self.enums.append((self.aal5TypeEntry, self.aal5TypeEntry, self.aal5TypeEnums))
        self.aalProfile_aal5TypeEnums = {u'NPF_IF_VCC_AAL5_VCMUX': u'5', u'NPF_IF_VCC_AALRAW': u'6', u'NPF_IF_VCC_AAL3_4': u'3', u'NPF_IF_VCC_AAL5_LLC': u'4', u'NPF_IF_VCC_AAL2': u'2', u'NPF_IF_VCC_AAL1': u'1', u'NPF_IF_VCC_AAL0': u'7'}
        Label(master,text="aalProfile aal5Type:", fg="blue").grid(row=row, column=42)
        self.aalProfile_aal5TypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.aalProfile_aal5TypeEntry.grid(row=row, column=50)
        self.aalProfile_aal5TypeEntry.insert(0, "NPF_IF_VCC_AAL5_VCMUX")
        self.enums.append((self.aalProfile_aal5TypeEntry, self.aalProfile_aal5TypeEntry, self.aalProfile_aal5TypeEnums))
        row = row + 1
        Label(master,text="aal5MaxCpcsSduSizeForward:", fg="blue").grid(row=row, column=14)
        self.aal5MaxCpcsSduSizeForwardEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.aal5MaxCpcsSduSizeForwardEntry.grid(row=row, column=22)
        self.aal5MaxCpcsSduSizeForwardEntry.insert(0, "50")
        Label(master,text="aal5MaxCpcsSduSizeBackward:", fg="blue").grid(row=row, column=28)
        self.aal5MaxCpcsSduSizeBackwardEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.aal5MaxCpcsSduSizeBackwardEntry.grid(row=row, column=36)
        self.aal5MaxCpcsSduSizeBackwardEntry.insert(0, "50")
        self.aal5AalModeEnums = {u'NPF_STREAMING_ASSURED': u'2', u'NPF_MESSAGE_ASSURED': u'0', u'NPF_STREAMING_UNASSURED': u'3', u'NPF_MESSAGE_UNASSURED': u'1'}
        Label(master,text="aal5AalMode:", fg="blue").grid(row=row, column=42)
        self.aal5AalModeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.aal5AalModeEntry.grid(row=row, column=50)
        self.aal5AalModeEntry.insert(0, "NPF_MESSAGE_ASSURED")
        self.enums.append((self.aal5AalModeEntry, self.aal5AalModeEntry, self.aal5AalModeEnums))
        row = row + 1
        self.aal5SscsTypeEnums = {u'NPF_DATA_SSURED': u'1', u'NPF_DATA_NON_ASSURED': u'2', u'NPF_SAR': u'16', u'NPF_SSCF_COTS': u'9', u'NPF_SSCF_CONS': u'8', u'NPF_SSCS_NULL': u'0', u'NPF_TRUNKING': u'17', u'NPF_FRAME_RELAY': u'4'}
        Label(master,text="aal5SscsType:", fg="blue").grid(row=row, column=14)
        self.aal5SscsTypeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.aal5SscsTypeEntry.grid(row=row, column=22)
        self.aal5SscsTypeEntry.insert(0, "NPF_SSCS_NULL")
        self.enums.append((self.aal5SscsTypeEntry, self.aal5SscsTypeEntry, self.aal5SscsTypeEnums))
        Label(master,text="parentIfHandle:", fg="blue").grid(row=row, column=28)
        self.parentIfHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.parentIfHandleEntry.grid(row=row, column=36)
        self.parentIfHandleEntry.insert(0, "1")
        self.QosServiceCategoryEnums = {u'NPF_UBR': u'5', u'NPF_CBR': u'1', u'NPF_GFR': u'6', u'NPF_nrtVBR': u'3', u'NPF_rtVBR': u'2', u'NPF_OTHER': u'0', u'NPF_ABR': u'4'}
        Label(master,text="QosServiceCategory:", fg="blue").grid(row=row, column=42)
        self.QosServiceCategoryEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosServiceCategoryEntry.grid(row=row, column=50)
        self.QosServiceCategoryEntry.insert(0, "NPF_CBR")
        self.enums.append((self.QosServiceCategoryEntry, self.QosServiceCategoryEntry, self.QosServiceCategoryEnums))
        row = row + 1
        Label(master,text="QosRxPCR1:", fg="blue").grid(row=row, column=14)
        self.QosRxPCR1Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxPCR1Entry.grid(row=row, column=22)
        self.QosRxPCR1Entry.insert(0, "15000")
        Label(master,text="QosRxPCR0:", fg="blue").grid(row=row, column=28)
        self.QosRxPCR0Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxPCR0Entry.grid(row=row, column=36)
        self.QosRxPCR0Entry.insert(0, "15000")
        Label(master,text="QosRxSCR1:", fg="blue").grid(row=row, column=42)
        self.QosRxSCR1Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxSCR1Entry.grid(row=row, column=50)
        self.QosRxSCR1Entry.insert(0, "8000")
        row = row + 1
        Label(master,text="QosRxSCR0:", fg="blue").grid(row=row, column=14)
        self.QosRxSCR0Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxSCR0Entry.grid(row=row, column=22)
        self.QosRxSCR0Entry.insert(0, "8000")
        Label(master,text="QosRxMBS1:", fg="blue").grid(row=row, column=28)
        self.QosRxMBS1Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxMBS1Entry.grid(row=row, column=36)
        self.QosRxMBS1Entry.insert(0, "15000")
        Label(master,text="QosRxMBS0:", fg="blue").grid(row=row, column=42)
        self.QosRxMBS0Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxMBS0Entry.grid(row=row, column=50)
        self.QosRxMBS0Entry.insert(0, "15000")
        row = row + 1
        Label(master,text="QosRxMCR:", fg="blue").grid(row=row, column=14)
        self.QosRxMCREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxMCREntry.grid(row=row, column=22)
        self.QosRxMCREntry.insert(0, "2000")
        Label(master,text="QosRxMaxFrmSize:", fg="blue").grid(row=row, column=28)
        self.QosRxMaxFrmSizeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxMaxFrmSizeEntry.grid(row=row, column=36)
        self.QosRxMaxFrmSizeEntry.insert(0, "1000")
        Label(master,text="QosRxCTD:", fg="blue").grid(row=row, column=42)
        self.QosRxCTDEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxCTDEntry.grid(row=row, column=50)
        self.QosRxCTDEntry.insert(0, "100")
        row = row + 1
        Label(master,text="QosRxCDV:", fg="blue").grid(row=row, column=14)
        self.QosRxCDVEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxCDVEntry.grid(row=row, column=22)
        self.QosRxCDVEntry.insert(0, "100")
        Label(master,text="QosRxCLR:", fg="blue").grid(row=row, column=28)
        self.QosRxCLREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxCLREntry.grid(row=row, column=36)
        self.QosRxCLREntry.insert(0, "100")
        Label(master,text="QosRxCDVT:", fg="blue").grid(row=row, column=42)
        self.QosRxCDVTEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxCDVTEntry.grid(row=row, column=50)
        self.QosRxCDVTEntry.insert(0, "100")
        row = row + 1
        Label(master,text="QosRxQosClass:", fg="blue").grid(row=row, column=14)
        self.QosRxQosClassEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxQosClassEntry.grid(row=row, column=22)
        self.QosRxQosClassEntry.insert(0, "1")
        Label(master,text="QosRxFrameDiscard:", fg="blue").grid(row=row, column=28)
        self.QosRxFrameDiscardEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxFrameDiscardEntry.grid(row=row, column=36)
        self.QosRxFrameDiscardEntry.insert(0, "1")
        Label(master,text="QosRxTagging:", fg="blue").grid(row=row, column=42)
        self.QosRxTaggingEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosRxTaggingEntry.grid(row=row, column=50)
        self.QosRxTaggingEntry.insert(0, "1")
        row = row + 1
        Label(master,text="QosTxPCR1:", fg="blue").grid(row=row, column=14)
        self.QosTxPCR1Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxPCR1Entry.grid(row=row, column=22)
        self.QosTxPCR1Entry.insert(0, "15000")
        Label(master,text="QosTxPCR0:", fg="blue").grid(row=row, column=28)
        self.QosTxPCR0Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxPCR0Entry.grid(row=row, column=36)
        self.QosTxPCR0Entry.insert(0, "15000")
        Label(master,text="QosTxSCR1:", fg="blue").grid(row=row, column=42)
        self.QosTxSCR1Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxSCR1Entry.grid(row=row, column=50)
        self.QosTxSCR1Entry.insert(0, "8000")
        row = row + 1
        Label(master,text="QosTxSCR0:", fg="blue").grid(row=row, column=14)
        self.QosTxSCR0Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxSCR0Entry.grid(row=row, column=22)
        self.QosTxSCR0Entry.insert(0, "8000")
        Label(master,text="QosTxMBS1:", fg="blue").grid(row=row, column=28)
        self.QosTxMBS1Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxMBS1Entry.grid(row=row, column=36)
        self.QosTxMBS1Entry.insert(0, "15000")
        Label(master,text="QosTxMBS0:", fg="blue").grid(row=row, column=42)
        self.QosTxMBS0Entry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxMBS0Entry.grid(row=row, column=50)
        self.QosTxMBS0Entry.insert(0, "15000")
        row = row + 1
        Label(master,text="QosTxMCR:", fg="blue").grid(row=row, column=14)
        self.QosTxMCREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxMCREntry.grid(row=row, column=22)
        self.QosTxMCREntry.insert(0, "2000")
        Label(master,text="QosTxMaxFrmSize:", fg="blue").grid(row=row, column=28)
        self.QosTxMaxFrmSizeEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxMaxFrmSizeEntry.grid(row=row, column=36)
        self.QosTxMaxFrmSizeEntry.insert(0, "1000")
        Label(master,text="QosTxCTD:", fg="blue").grid(row=row, column=42)
        self.QosTxCTDEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxCTDEntry.grid(row=row, column=50)
        self.QosTxCTDEntry.insert(0, "100")
        row = row + 1
        Label(master,text="QosTxCDV:", fg="blue").grid(row=row, column=14)
        self.QosTxCDVEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxCDVEntry.grid(row=row, column=22)
        self.QosTxCDVEntry.insert(0, "100")
        Label(master,text="QosTxCLR:", fg="blue").grid(row=row, column=28)
        self.QosTxCLREntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxCLREntry.grid(row=row, column=36)
        self.QosTxCLREntry.insert(0, "100")
        Label(master,text="QosTxCDVT:", fg="blue").grid(row=row, column=42)
        self.QosTxCDVTEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxCDVTEntry.grid(row=row, column=50)
        self.QosTxCDVTEntry.insert(0, "100")
        row = row + 1
        Label(master,text="QosTxQosClass:", fg="blue").grid(row=row, column=14)
        self.QosTxQosClassEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxQosClassEntry.grid(row=row, column=22)
        self.QosTxQosClassEntry.insert(0, "1")
        Label(master,text="QosTxFrameDiscard:", fg="blue").grid(row=row, column=28)
        self.QosTxFrameDiscardEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxFrameDiscardEntry.grid(row=row, column=36)
        self.QosTxFrameDiscardEntry.insert(0, "1")
        Label(master,text="QosTxTagging:", fg="blue").grid(row=row, column=42)
        self.QosTxTaggingEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosTxTaggingEntry.grid(row=row, column=50)
        self.QosTxTaggingEntry.insert(0, "1")
        row = row + 1
        Label(master,text="QosBestEffIndicator:", fg="blue").grid(row=row, column=14)
        self.QosBestEffIndicatorEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.QosBestEffIndicatorEntry.grid(row=row, column=22)
        self.QosBestEffIndicatorEntry.insert(0, "1")
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "503"
            reqresp = ReqResp('ATMAAL5_Vcc_Set', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'aal5Type'
            aal5type = self.aal5TypeEntry.get()
            if(self.aal5TypeEnums.has_key(aal5type)):
                aal5type = self.aal5TypeEnums[aal5type]
            vl = aal5type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'aalProfile_aal5Type'
            aalprofile_aal5type = self.aalProfile_aal5TypeEntry.get()
            if(self.aalProfile_aal5TypeEnums.has_key(aalprofile_aal5type)):
                aalprofile_aal5type = self.aalProfile_aal5TypeEnums[aalprofile_aal5type]
            vl = aalprofile_aal5type
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'aal5MaxCpcsSduSizeForward'
            aal5maxcpcssdusizeforward = self.aal5MaxCpcsSduSizeForwardEntry.get()
            vl = aal5maxcpcssdusizeforward
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'aal5MaxCpcsSduSizeBackward'
            aal5maxcpcssdusizebackward = self.aal5MaxCpcsSduSizeBackwardEntry.get()
            vl = aal5maxcpcssdusizebackward
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'aal5AalMode'
            aal5aalmode = self.aal5AalModeEntry.get()
            if(self.aal5AalModeEnums.has_key(aal5aalmode)):
                aal5aalmode = self.aal5AalModeEnums[aal5aalmode]
            vl = aal5aalmode
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'aal5SscsType'
            aal5sscstype = self.aal5SscsTypeEntry.get()
            if(self.aal5SscsTypeEnums.has_key(aal5sscstype)):
                aal5sscstype = self.aal5SscsTypeEnums[aal5sscstype]
            vl = aal5sscstype
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'parentIfHandle'
            parentifhandle = self.parentIfHandleEntry.get()
            vl = parentifhandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosServiceCategory'
            qosservicecategory = self.QosServiceCategoryEntry.get()
            if(self.QosServiceCategoryEnums.has_key(qosservicecategory)):
                qosservicecategory = self.QosServiceCategoryEnums[qosservicecategory]
            vl = qosservicecategory
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxPCR1'
            qosrxpcr1 = self.QosRxPCR1Entry.get()
            vl = qosrxpcr1
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxPCR0'
            qosrxpcr0 = self.QosRxPCR0Entry.get()
            vl = qosrxpcr0
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxSCR1'
            qosrxscr1 = self.QosRxSCR1Entry.get()
            vl = qosrxscr1
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxSCR0'
            qosrxscr0 = self.QosRxSCR0Entry.get()
            vl = qosrxscr0
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxMBS1'
            qosrxmbs1 = self.QosRxMBS1Entry.get()
            vl = qosrxmbs1
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxMBS0'
            qosrxmbs0 = self.QosRxMBS0Entry.get()
            vl = qosrxmbs0
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxMCR'
            qosrxmcr = self.QosRxMCREntry.get()
            vl = qosrxmcr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxMaxFrmSize'
            qosrxmaxfrmsize = self.QosRxMaxFrmSizeEntry.get()
            vl = qosrxmaxfrmsize
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxCTD'
            qosrxctd = self.QosRxCTDEntry.get()
            vl = qosrxctd
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxCDV'
            qosrxcdv = self.QosRxCDVEntry.get()
            vl = qosrxcdv
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxCLR'
            qosrxclr = self.QosRxCLREntry.get()
            vl = qosrxclr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxCDVT'
            qosrxcdvt = self.QosRxCDVTEntry.get()
            vl = qosrxcdvt
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxQosClass'
            qosrxqosclass = self.QosRxQosClassEntry.get()
            vl = qosrxqosclass
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxFrameDiscard'
            qosrxframediscard = self.QosRxFrameDiscardEntry.get()
            vl = qosrxframediscard
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosRxTagging'
            qosrxtagging = self.QosRxTaggingEntry.get()
            vl = qosrxtagging
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxPCR1'
            qostxpcr1 = self.QosTxPCR1Entry.get()
            vl = qostxpcr1
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxPCR0'
            qostxpcr0 = self.QosTxPCR0Entry.get()
            vl = qostxpcr0
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxSCR1'
            qostxscr1 = self.QosTxSCR1Entry.get()
            vl = qostxscr1
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxSCR0'
            qostxscr0 = self.QosTxSCR0Entry.get()
            vl = qostxscr0
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxMBS1'
            qostxmbs1 = self.QosTxMBS1Entry.get()
            vl = qostxmbs1
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxMBS0'
            qostxmbs0 = self.QosTxMBS0Entry.get()
            vl = qostxmbs0
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxMCR'
            qostxmcr = self.QosTxMCREntry.get()
            vl = qostxmcr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxMaxFrmSize'
            qostxmaxfrmsize = self.QosTxMaxFrmSizeEntry.get()
            vl = qostxmaxfrmsize
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxCTD'
            qostxctd = self.QosTxCTDEntry.get()
            vl = qostxctd
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxCDV'
            qostxcdv = self.QosTxCDVEntry.get()
            vl = qostxcdv
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxCLR'
            qostxclr = self.QosTxCLREntry.get()
            vl = qostxclr
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxCDVT'
            qostxcdvt = self.QosTxCDVTEntry.get()
            vl = qostxcdvt
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxQosClass'
            qostxqosclass = self.QosTxQosClassEntry.get()
            vl = qostxqosclass
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxFrameDiscard'
            qostxframediscard = self.QosTxFrameDiscardEntry.get()
            vl = qostxframediscard
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosTxTagging'
            qostxtagging = self.QosTxTaggingEntry.get()
            vl = qostxtagging
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'QosBestEffIndicator'
            qosbesteffindicator = self.QosBestEffIndicatorEntry.get()
            vl = qosbesteffindicator
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMAAL5_Vcc_Set ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_AAL5_Vcc_Set', '503'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                nm = "aal5Type"
                val = self.aal5TypeEntry.get()
                if(self.aal5TypeEnums.has_key(val)):
                    val  = self.aal5TypeEnums[val]
                order.append((nm, str(val)))
                nm = "aalProfile_aal5Type"
                val = self.aalProfile_aal5TypeEntry.get()
                if(self.aalProfile_aal5TypeEnums.has_key(val)):
                    val  = self.aalProfile_aal5TypeEnums[val]
                order.append((nm, str(val)))
                nm = "aal5MaxCpcsSduSizeForward"
                val = self.aal5MaxCpcsSduSizeForwardEntry.get()
                order.append((nm, str(val)))
                nm = "aal5MaxCpcsSduSizeBackward"
                val = self.aal5MaxCpcsSduSizeBackwardEntry.get()
                order.append((nm, str(val)))
                nm = "aal5AalMode"
                val = self.aal5AalModeEntry.get()
                if(self.aal5AalModeEnums.has_key(val)):
                    val  = self.aal5AalModeEnums[val]
                order.append((nm, str(val)))
                nm = "aal5SscsType"
                val = self.aal5SscsTypeEntry.get()
                if(self.aal5SscsTypeEnums.has_key(val)):
                    val  = self.aal5SscsTypeEnums[val]
                order.append((nm, str(val)))
                nm = "parentIfHandle"
                val = self.parentIfHandleEntry.get()
                order.append((nm, str(val)))
                nm = "QosServiceCategory"
                val = self.QosServiceCategoryEntry.get()
                if(self.QosServiceCategoryEnums.has_key(val)):
                    val  = self.QosServiceCategoryEnums[val]
                order.append((nm, str(val)))
                nm = "QosRxPCR1"
                val = self.QosRxPCR1Entry.get()
                order.append((nm, str(val)))
                nm = "QosRxPCR0"
                val = self.QosRxPCR0Entry.get()
                order.append((nm, str(val)))
                nm = "QosRxSCR1"
                val = self.QosRxSCR1Entry.get()
                order.append((nm, str(val)))
                nm = "QosRxSCR0"
                val = self.QosRxSCR0Entry.get()
                order.append((nm, str(val)))
                nm = "QosRxMBS1"
                val = self.QosRxMBS1Entry.get()
                order.append((nm, str(val)))
                nm = "QosRxMBS0"
                val = self.QosRxMBS0Entry.get()
                order.append((nm, str(val)))
                nm = "QosRxMCR"
                val = self.QosRxMCREntry.get()
                order.append((nm, str(val)))
                nm = "QosRxMaxFrmSize"
                val = self.QosRxMaxFrmSizeEntry.get()
                order.append((nm, str(val)))
                nm = "QosRxCTD"
                val = self.QosRxCTDEntry.get()
                order.append((nm, str(val)))
                nm = "QosRxCDV"
                val = self.QosRxCDVEntry.get()
                order.append((nm, str(val)))
                nm = "QosRxCLR"
                val = self.QosRxCLREntry.get()
                order.append((nm, str(val)))
                nm = "QosRxCDVT"
                val = self.QosRxCDVTEntry.get()
                order.append((nm, str(val)))
                nm = "QosRxQosClass"
                val = self.QosRxQosClassEntry.get()
                order.append((nm, str(val)))
                nm = "QosRxFrameDiscard"
                val = self.QosRxFrameDiscardEntry.get()
                order.append((nm, str(val)))
                nm = "QosRxTagging"
                val = self.QosRxTaggingEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxPCR1"
                val = self.QosTxPCR1Entry.get()
                order.append((nm, str(val)))
                nm = "QosTxPCR0"
                val = self.QosTxPCR0Entry.get()
                order.append((nm, str(val)))
                nm = "QosTxSCR1"
                val = self.QosTxSCR1Entry.get()
                order.append((nm, str(val)))
                nm = "QosTxSCR0"
                val = self.QosTxSCR0Entry.get()
                order.append((nm, str(val)))
                nm = "QosTxMBS1"
                val = self.QosTxMBS1Entry.get()
                order.append((nm, str(val)))
                nm = "QosTxMBS0"
                val = self.QosTxMBS0Entry.get()
                order.append((nm, str(val)))
                nm = "QosTxMCR"
                val = self.QosTxMCREntry.get()
                order.append((nm, str(val)))
                nm = "QosTxMaxFrmSize"
                val = self.QosTxMaxFrmSizeEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxCTD"
                val = self.QosTxCTDEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxCDV"
                val = self.QosTxCDVEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxCLR"
                val = self.QosTxCLREntry.get()
                order.append((nm, str(val)))
                nm = "QosTxCDVT"
                val = self.QosTxCDVTEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxQosClass"
                val = self.QosTxQosClassEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxFrameDiscard"
                val = self.QosTxFrameDiscardEntry.get()
                order.append((nm, str(val)))
                nm = "QosTxTagging"
                val = self.QosTxTaggingEntry.get()
                order.append((nm, str(val)))
                nm = "QosBestEffIndicator"
                val = self.QosBestEffIndicatorEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMAAL5_Vcc_Set", "Error Occured while processing ATMAAL5_Vcc_Set Dialog")
            pass
    
    def Select(self, event=None):
        if(len(self.enums) <= self.enumCount):
            self.listbox.delete(0, END)
            self.listbox.config(height=0)
            self.enumCount = 0
            self.prevSel.config(bg="gray")
            self.prevSel = None
            return
            if(self.curSel):
                self.curSel.config(bg="gray")
        if(not self.listbox):
            self.listbox = Listbox(self, bg="gray", fg="blue")
            self.listbox.bind("<Double-Button-1>", self.add)
            self.next = Button(self, text="v", width=1, command=self.next, default=ACTIVE)
            self.next.pack(side=RIGHT, padx=0, pady=0)
        else:
            self.listbox.delete(0, END)
        enum = self.enums[self.enumCount]
        entry = enum[0]
        self.curSel = enum[1]
        if(self.prevSel):
            self.prevSel.config(bg="gray")
        if(self.curSel):
            self.curSel.config(bg="black")
            self.prevSel = self.curSel
        sel = enum[2]
        for key in sel:
            self.listbox.insert(END, key)
        self.listbox.config(height = len(sel))
        self.listbox.pack(side=TOP, fill=BOTH)
        
    def add(self, event=None):
        item=self.listbox.curselection()
        try:
            selected = self.listbox.get(map(int, item)[0])
            self.enums[self.enumCount][0].delete(0, END)
            self.enums[self.enumCount][0].insert(0, selected)
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def next(self, event=None):
        item=self.listbox.curselection()
        try:
            self.enumCount = self.enumCount + 1
            self.Select()
        except:
            pass
    def operation(self, event=None):
        pass

class ATMATM_Vcc_BindDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_Vcc_Bind")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="ParentInterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.ParentInterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.ParentInterfaceHandleEntry.grid(row=row, column=22)
        self.ParentInterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "510"
            reqresp = ReqResp('ATMATM_Vcc_Bind', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'ParentInterfaceHandle'
            parentinterfacehandle = self.ParentInterfaceHandleEntry.get()
            vl = parentinterfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_Vcc_Bind ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_Vcc_Bind', '510'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "ParentInterfaceHandle"
                val = self.ParentInterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_Vcc_Bind", "Error Occured while processing ATMATM_Vcc_Bind Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_Vcc_DeleteDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_Vcc_Delete")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "511"
            reqresp = ReqResp('ATMATM_Vcc_Delete', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_Vcc_Delete ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_Vcc_Delete', '511'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_Vcc_Delete", "Error Occured while processing ATMATM_Vcc_Delete Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_Vcc_EnableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_Vcc_Enable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "512"
            reqresp = ReqResp('ATMATM_Vcc_Enable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_Vcc_Enable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_Vcc_Enable', '512'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_Vcc_Enable", "Error Occured while processing ATMATM_Vcc_Enable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_Vcc_DisableDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_Vcc_Disable")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "513"
            reqresp = ReqResp('ATMATM_Vcc_Disable', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_Vcc_Disable ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_Vcc_Disable', '513'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_Vcc_Disable", "Error Occured while processing ATMATM_Vcc_Disable Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_Vcc_Oper_Status_GetDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_Vcc_Oper_Status_Get")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "514"
            reqresp = ReqResp('ATMATM_Vcc_Oper_Status_Get', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_Vcc_Oper_Status_Get ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_Vcc_Oper_Status_Get', '514'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_Vcc_Oper_Status_Get", "Error Occured while processing ATMATM_Vcc_Oper_Status_Get Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_Vcc_Stats_GetDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_Vcc_Stats_Get")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "515"
            reqresp = ReqResp('ATMATM_Vcc_Stats_Get', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_Vcc_Stats_Get ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_Vcc_Stats_Get', '515'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_Vcc_Stats_Get", "Error Occured while processing ATMATM_Vcc_Stats_Get Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_AAL2_Chan_SetDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_AAL2_Chan_Set")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        Label(master,text="AAL2ChanId:", fg="blue").grid(row=row, column=14)
        self.AAL2ChanIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AAL2ChanIdEntry.grid(row=row, column=22)
        self.AAL2ChanIdEntry.insert(0, "1")
        row = row + 1
        Label(master,text="maxCpsSduDeliverLength:", fg="blue").grid(row=row, column=14)
        self.maxCpsSduDeliverLengthEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.maxCpsSduDeliverLengthEntry.grid(row=row, column=22)
        self.maxCpsSduDeliverLengthEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "516"
            reqresp = ReqResp('ATMATM_AAL2_Chan_Set', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'AAL2ChanId'
            aal2chanid = self.AAL2ChanIdEntry.get()
            vl = aal2chanid
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'maxCpsSduDeliverLength'
            maxcpssdudeliverlength = self.maxCpsSduDeliverLengthEntry.get()
            vl = maxcpssdudeliverlength
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_AAL2_Chan_Set ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_AAL2_Chan_Set', '516'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                nm = "AAL2ChanId"
                val = self.AAL2ChanIdEntry.get()
                order.append((nm, str(val)))
                nm = "maxCpsSduDeliverLength"
                val = self.maxCpsSduDeliverLengthEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_AAL2_Chan_Set", "Error Occured while processing ATMATM_AAL2_Chan_Set Dialog")
            pass
    
    def operation(self, event=None):
        pass

class ATMATM_AAL2_Chan_DelDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="ATMATM_AAL2_Chan_Del")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="InterfaceHandle:", fg="blue").grid(row=row, column=14)
        self.InterfaceHandleEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.InterfaceHandleEntry.grid(row=row, column=22)
        self.InterfaceHandleEntry.insert(0, "ATM:0")
        row = row + 1
        Label(master,text="NumVcc:", fg="blue").grid(row=row, column=14)
        self.NumVccEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.NumVccEntry.grid(row=row, column=22)
        self.NumVccEntry.insert(0, "1")
        self.NumVccEntry.config(fg="red", state=DISABLED)
        row = row + 1
        Label(master,text="VPI:", fg="blue").grid(row=row, column=14)
        self.VPIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VPIEntry.grid(row=row, column=22)
        self.VPIEntry.insert(0, "0")
        row = row + 1
        Label(master,text="VCI:", fg="blue").grid(row=row, column=14)
        self.VCIEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.VCIEntry.grid(row=row, column=22)
        self.VCIEntry.insert(0, "33")
        row = row + 1
        Label(master,text="AAL2ChanId:", fg="blue").grid(row=row, column=14)
        self.AAL2ChanIdEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.AAL2ChanIdEntry.grid(row=row, column=22)
        self.AAL2ChanIdEntry.insert(0, "1")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "517"
            reqresp = ReqResp('ATMATM_AAL2_Chan_Del', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'InterfaceHandle'
            interfacehandle = self.InterfaceHandleEntry.get()
            vl = interfacehandle
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'NumVcc'
            vl = '1'
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VPI'
            vpi = self.VPIEntry.get()
            vl = vpi
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'VCI'
            vci = self.VCIEntry.get()
            vl = vci
            nv = (nm, vl)
            reqresp.arg(nv)
            nm = 'AAL2ChanId'
            aal2chanid = self.AAL2ChanIdEntry.get()
            vl = aal2chanid
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("ATMATM_AAL2_Chan_Del ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('ATM_ATM_AAL2_Chan_Del', '517'))
                nm = "InterfaceHandle"
                val = self.InterfaceHandleEntry.get()
                order.append((nm, str(val)))
                nm = "NumVcc"
                val = "1"
                val = str(val)
                order.append((nm, val))
                nm = "VPI"
                val = self.VPIEntry.get()
                order.append((nm, str(val)))
                nm = "VCI"
                val = self.VCIEntry.get()
                order.append((nm, str(val)))
                nm = "AAL2ChanId"
                val = self.AAL2ChanIdEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("ATMATM_AAL2_Chan_Del", "Error Occured while processing ATMATM_AAL2_Chan_Del Dialog")
            pass
    
    def operation(self, event=None):
        pass


class RCMStart_RCMDialog(Dialog):
    def __init__(self, parent, cppdk):
        self.cppdk = cppdk
        self.helpShown = 0
        self.listbox = None
        self.enums = []
        self.enumCount = 0
        self.prevSel = None
        self.curSel = None
        if(not self.cppdk.printFile and self.cppdk.connect == 0):
            tkMessageBox.showerror("Not Connected","Not Connected \n\n Connect to CPPDK server and Try again")
            return
        Dialog.__init__(self, parent, title="RCMStart_RCM")
        self.cppdk = cppdk
    
    def body(self, master):
        row = 0
        Label(master,text="RouterName:", fg="blue").grid(row=row, column=14)
        self.RouterNameEntry  = Entry(master, bg="gray", fg="white", width=25, relief=SUNKEN)
        self.RouterNameEntry.grid(row=row, column=22)
        self.RouterNameEntry.insert(0, "/NPFSys/0")
        row = row + 1
        return 
    
    def ok(self):
        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return
        self.withdraw()
        self.update_idletasks()
        self.apply()
        self.cancel()
    def end(self):
        pass
    
    def apply(self):
        try:
            cmd = "199"
            reqresp = ReqResp('RCMStart_RCM', cmd)
            order = []
            nm = ''
            vl = ''
            nm = 'RouterName'
            routername = self.RouterNameEntry.get()
            vl = routername
            nv = (nm, vl)
            reqresp.arg(nv)
            if(not self.cppdk.printFile):
                self.cppdk.Send(reqresp)
            else:
                if(not tkMessageBox.askyesno("RCMStart_RCM ", "Write to File:" + self.cppdk.cmdFile)):
                    return
                order.append(('RCM_Start_RCM', '199'))
                nm = "RouterName"
                val = self.RouterNameEntry.get()
                order.append((nm, str(val)))
                self.cppdk.NewCommand(order)
        except:
            tkMessageBox.showerror("RCMStart_RCM", "Error Occured while processing RCMStart_RCM Dialog")
            pass
    
    def operation(self, event=None):
        pass










def usage(txt = ''):
    args = ''
    args = args + '-mode [a|g]'
    print ''
    print txt
    print 'ERROR: usage  ' + sys.argv[0] + ' ' + args
    print ''
    sys.exit(0)
 
def text_help():
    help = CppuiSeperator1 + CppuiSeperator1 + '\n'
    help = help + 'ts	- \t send test script\n'
    help = help + 'delay - \t Wait "delay" seconds before sending\n'
    help = help + 'ewait - \t Ask confirmation before sending\n'
    help = help + 'dwait - \t Don\'t confirmation before sending\n'
    help = help + 'elog	- \t Enable log file\n'
    help = help + 'dlog	- \t Disable log file\n'
    help = help + 'q    - \t\t Quit\n'
    help = help + 'count - \t set count(test script executed "count" times, ("-" execute in loop)\n'
    help = help + CppuiSeperator1 + CppuiSeperator1
    print help
 
def text_mode(host, port):
    ui = Cppui('ControlPlanePlatformUserInterface(CPPUI)', 0)
    ui.host = host
    ui.port = port
    print CppuiSeperator1 + CppuiSeperator1
    print '\tCPPUI Server (' + host + '@' + `port` + ')'
    print CppuiSeperator1 + CppuiSeperator1
    ui.Connect()
    reqresp = ReqResp("Connect", str(CPPDK_CONNECT_REQ))
    ui.Send(reqresp)
    text_help()
    while(1):
        sys.stdout.write('Test :')
        ts = sys.stdin.readline()
        ts = string.strip(ts)
        if(ts == 'q'):
            ans = askyesno('Quit?')
            if(ans == 1):
                reqresp = ReqResp("Disconnect", str(CPPDK_DISCONNECT_REQ))
                ui.Send(reqresp)
                sys.exit(0)
            else:
                continue
        elif(ts == 'delay'):
            sys.stdout.write('Seconds:')
            sec = sys.stdin.readline()
            sec = string.strip(sec)
            try:
                ui.waitTime = int(sec)
            except:
                showerror('Invalid time value "' + sec + '"')
                continue
        elif(ts == 'ewait'):
            ui.waitMode = 1
        elif(ts == 'dwait'):
            ui.waitMode = 0
        elif(ts == 'elog'):
            sys.stdout.write('Log File:')
            logf = sys.stdin.readline()
            logf = string.strip(logf)
            try:
                logf = ui.LOG_DIR + os.sep + logf
                logf = os.path.abspath(logf)
                ui.lf = logf
                ui.logf = open(logf, 'w')
                ui.log = 1
                continue
            except:
                showerror('Log Error')
                continue
        elif(ts == 'dlog'):
            ans = askyesno('Disable Log')
            if(ans == 1 and ui.log == 1 and ui.logf != None):
                ui.lf = ""
                ui.logf.flush()
                ui.logf.flush()
                ui.logf.close()
                ui.logf = None
                ui.log = 0
            continue
        elif(ts == 'count'):
            sys.stdout.write('Count:')
            cnt = sys.stdin.readline()
            cnt = string.strip(cnt)
            try:
                if(cnt != '-'):
                    ui.repeatCount = int(cnt)
                    continue
                else:
                    ui.repeatCount = 11111
                    continue
            except:
                showerror('Invalid count value "' + cnt + '"')
                continue
        elif(ts == 'ts'):
            sys.stdout.write('Test Script:')
            cf = sys.stdin.readline()
            cf = string.strip(cf)
            ui.LoadFile(cf)
            continue
        else:
            text_help()
 
def showerror(error):
    print('')
    print('ERROR::\t\t' + error)
    print('')
 
def askyesno(text, body = ''):
    ans = 'y'
    sys.stdout.write(text + '(y/n)[y]:')
    tmp = sys.stdin.readline()
    tmp = string.strip(tmp)
    if(len(tmp) > 0):
        ans = tmp
    if(ans == 'y'):
        return(1)
    return(0)
 
if(__name__ == '__main__'):
    mode = ''
    host = 'localhost'
    port = 7890
    wait = 0
    count = ''
    argc = 0
    if(len(sys.argv) < 2):
        cppui = Cppui('ControlPlanePlatformUserInterface(CPPUI)')
    else:
        sys.argv.append('last')
        try:
            for arg in sys.argv:
                argc = argc + 1
                arg = string.strip(arg)
                arg = string.replace(arg, ' ', '')
                if(arg == '-host'):
                    host = sys.argv[sys.argv.index(arg) + 1]
                elif(arg == '-port'):
                    try:
                        port = int(sys.argv[sys.argv.index(arg) + 1])
                    except:
                        usage('Invalid port <' + sys.argv[sys.argv.index(arg) + 1] + '>')
        except:
            usage()
        text_mode(host, port)
